--------------------------------------------------------------------------------
-- Bug 28702 – [WinStrom] zajistit správné fungování příloh na PostgreSQL >9.0 s povolenými přístupovými právy na LO
--------------------------------------------------------------------------------

-- pozor: tento skript je byt volan vicekrat (po kazdem upgradu), takze jeho chovani musi byt idempotentni!

-- trigger volany pri vytvoreni prilohy
create or replace function wPrilohaDataGrantLargeObject() returns trigger as $$
begin
  if (NEW.blobdata is not null) then 
    execute 'GRANT SELECT, UPDATE ON LARGE OBJECT ' || NEW.blobdata || ' TO %firmaRole%';
    execute 'ALTER LARGE OBJECT ' || NEW.blobdata || ' OWNER TO %firmaRole%';
  end if;
  return NEW; 
end;
$$ language plpgsql;
alter function public.wPrilohaDataGrantLargeObject() owner to %firmaRole%;

drop trigger if exists wPrilohaDataGrantLargeObject on wPrilohaData;

create trigger wPrilohaDataGrantLargeObject
  after insert or update on wPrilohaData 
  for each row execute procedure wPrilohaDataGrantLargeObject();

--------------------------------------------------------------------------------
-- Bug 32538: [WinStrom] Fixopie pri pokusu o filtraci na neobsahuje
--------------------------------------------------------------------------------

CREATE EXTENSION IF NOT EXISTS unaccent;


--------------------------------------------------------------------------------
-- Bug 39654 – [Bug] Nefunguje vyhledávání podle _
--------------------------------------------------------------------------------

-- Nastavíme stejné chování jako bylo u Pg 8.x (tj. vypneme standardní chování řetězců dle SQL normy).
ALTER DATABASE %firmaDbName% SET standard_conforming_strings TO 'off';
ALTER DATABASE %firmaDbName% SET escape_string_warning TO 'off';
