-- trigger mazajici obchodni vazby na dokladech
CREATE OR REPLACE FUNCTION ddokldeleteobchvazba()
  RETURNS trigger AS $$
declare
  _postfix varchar(20);
  _idDokl bigint;
begin
  select getDoklNamePostfixByModul(OLD.modul) into _postfix;
  if (_postfix = 'Fak') then
    _idDokl := OLD.idDoklFak;
  else
    if (_postfix = 'Obch') then
      _idDokl := OLD.idDoklObch;
    else
      if (_postfix = 'Sklad') then
        _idDokl := OLD.idDoklSklad;
      end if;
    end if;
  end if;
  
  delete from dVazebTab where (typvazbyk in ('typVazbyDokl.obchod_obchod_hla', 'typVazbyDokl.obchod_faktura_hla',
                                             'typVazbyDokl.obchod_zaloha_hla', 'typVazbyDokl.obchod_sklad_hla'))
                              and ((idTabA = _idDokl and modulA = OLD.modul) or
                                   (idTabB = _idDokl and modulB = OLD.modul));
  
  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION ddokldeleteobchvazba() OWNER TO %firmaRole%;

-- naveseni na tabulky dokladu
CREATE TRIGGER ddoklobchdeleteobchvazba BEFORE DELETE ON ddoklobch
  FOR EACH ROW EXECUTE PROCEDURE ddokldeleteobchvazba();
CREATE TRIGGER ddoklfakdeleteobchvazba BEFORE DELETE ON ddoklfak
  FOR EACH ROW EXECUTE PROCEDURE ddokldeleteobchvazba();
CREATE TRIGGER ddoklskladdeleteobchvazba BEFORE DELETE ON ddoklsklad
  FOR EACH ROW EXECUTE PROCEDURE ddokldeleteobchvazba();
