/*
 Promitnuti zmeny uctu na skladovem dokladu na navazane doklady

 Autor:        Jan Besta
*/
create or replace function dDoklSkladUpdateUcty() returns trigger as $$
declare idFak int;
begin
  -- test zda smi dojit ke zmene na dokladu
  if (OLD.zamek = true and NEW.zamek = true) then
    raise exception 'dDoklSkladUpdateUcty(): Dochz ke zmn na skladovm dokladu, kter je zamen.';
  end if;
 
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet);
    end loop;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dDoklSkladUpdateUcty on ddoklsklad;

create trigger dDoklSkladUpdateUcty after update on ddoklsklad
for each row execute procedure dDoklSkladUpdateUcty();