/*
 Přidání obratů do uObraty.

 Původní autor:             Josef Weinreb
 Autor verze pro PostgeSQL: Pavel Cvrcek
*/
create or replace function dPolDoklInsertUcto() returns trigger as $$
begin
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
        NEW.idMeny, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);
  
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,
        NEW.idMeny, NEW.idStred, NEW.sumDph, NEW.sumDphMen);

  return NEW;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dPolDoklInsertUcto on dpolfak;
drop trigger if exists dPolDoklInsertUcto on dpolint;
drop trigger if exists dPolDoklInsertUcto on dpolsklad;

create trigger dPolDoklInsertUcto before insert on dpolfak
for each row execute procedure dPolDoklInsertUcto();

create trigger dPolDoklInsertUcto before insert on dpolint
for each row execute procedure dPolDoklInsertUcto();

create trigger dPolDoklInsertUcto before insert on dpolsklad
for each row execute procedure dPolDoklInsertUcto();