-- návratový typ pro funkci hledající vazby
CREATE TYPE vazbadokladu AS
  (idvazebnidoklad integer,
  datucto timestamp without time zone,
  datvyst timestamp without time zone,
  iddokl integer,
  kod character varying(255),
  modul character varying(255),
  modulk character varying(255),
  popis character varying(255),
  poznam character varying(255),
  sumcelkem double precision,
  sumcelkemmen double precision,
  typvazbyk character varying(255),
  varsym character varying(255),
  idmeny integer,
  iduziv integer,
  idtypdokl integer,
  novy boolean,
  uroven integer,
  stavk character varying(255));

-- funkce pro nalezení všech dokladů, které jsou nějak navázané na doklad na vstupu
CREATE OR REPLACE FUNCTION findVazbyDokladu(_idDokl integer, _modul varchar(20))
  RETURNS setof vazbadokladu AS $$
declare
  zaznam Record;
  _uroven integer;
  _prechodVP boolean;    -- zda povolen prechod z PPV/OBV na PPP/OBP
begin
  _uroven = 1;
  _prechodVP = true;
  
  drop table if exists vazbydokladu;
  
  CREATE TEMPORARY TABLE vazbydokladu
   (idvazebnidoklad integer NOT NULL,
    datucto timestamp without time zone,
    datvyst timestamp without time zone,
    iddokl integer,
    kod character varying(255),
    modul character varying(255),
    modulk character varying(255),
    popis character varying(255),
    poznam character varying(255),
    sumcelkem double precision,
    sumcelkemmen double precision,
    typvazbyk character varying(255),
    varsym character varying(255),
    idmeny integer,
    iduziv integer,
    idtypdokl integer,
    novy boolean,
    uroven integer,
    stavk character varying(255),
    CONSTRAINT vazbydokladu_pkey PRIMARY KEY (idvazebnidoklad)
  ) WITH (OIDS=FALSE);
  
  perform findViceVazeb('vazbydokladu', _idDokl, _modul, 0, true);
  
  while (select count(*) from vazbydokladu where novy = true) > 0 LOOP
    if _prechodVP then
      select (count(*) = 0) into _prechodVP from vazbydokladu where modul in ('OBP', 'PPP') and novy = true;
    end if;
  
    for zaznam in (select * from vazbydokladu where novy = true)
    LOOP
      perform findViceVazeb('vazbydokladu', zaznam.idDokl, zaznam.modul, _uroven, _prechodVP);
  
      update vazbydokladu set novy = false where idvazebnidoklad = zaznam.idvazebnidoklad;
    end loop;

    _uroven = _uroven + 1;
  end loop;
  
  update vazbydokladu as V set modulK = modulK || 
    (case when (select typPohybuK from dDoklSklad where idDoklSklad = V.idDokl) = 'typPohybu.prijem' then 'PRI' else 'VYD' end) 
    where V.modul = 'SKL';

  return query SELECT * FROM vazbydokladu;
end; 
$$ LANGUAGE plpgsql;
