-- funkce vrati koncovou cast nazvu tabulky dokladu/polozky pro dany modul (Fak/Int/Sklad...)
CREATE OR REPLACE FUNCTION getDoklNamePostfixByModul(modul varchar(20))
  RETURNS varchar(20) AS $$
declare
  _postfix varchar(20);
begin
  if (modul in( 'FAV','FAP','PHL','ZAV')) then
    _postfix := 'Fak';
  else
    if (modul in( 'SKL')) then
      _postfix := 'Sklad';
    else
      if (modul in( 'BAN','POK','INT')) then
        _postfix := 'Int';
      else
        if (modul in ('PPP', 'NAV', 'OBP', 'PPV', 'NAP', 'OBV')) then
          _postfix := 'Obch';
        else
          raise exception 'getDoklNamePostfixByModul(): Neznámý modul: %', modul;
        end if;
      end if;
    end if;
  end if;
  
  return _postfix;
end; 
$$ LANGUAGE plpgsql;