CREATE OR REPLACE FUNCTION putglotxvariable(i_kod character varying, i_hodnota character varying)
  RETURNS void AS $$
DECLARE
  tmpGloTxVarTableExists boolean;
  pom integer;
BEGIN
  tmpGloTxVarTableExists := (SELECT istableexist('tmp_gloTxVar'));

  IF (tmpGloTxVarTableExists <> true) THEN
    CREATE TEMP TABLE tmp_gloTxVar (
      kod character varying(50),
      hodnota character varying(50)
    ) WITH (OIDS=FALSE) ON COMMIT DROP;
  END IF;

  SELECT count(1) INTO pom FROM tmp_gloTxVar WHERE kod=i_kod;
  if (pom > 0) then
    UPDATE tmp_gloTxVar SET hodnota=i_hodnota WHERE kod=i_kod;
  ELSE
    INSERT INTO tmp_gloTxVar VALUES(i_kod, i_hodnota);
  END IF;

END;
$$ LANGUAGE plpgsql SECURITY DEFINER;

ALTER FUNCTION putglotxvariable(i_kod character varying, i_hodnota character varying) OWNER TO %firmaRole%;


--------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION removeglotxvariable(i_kod character varying)
  RETURNS void AS $$
DECLARE
  tmpGloTxVarTableExists boolean;
BEGIN
  tmpGloTxVarTableExists := (SELECT istableexist('tmp_gloTxVar'));

  IF (tmpGloTxVarTableExists = true) THEN
    DELETE FROM tmp_gloTxVar WHERE kod=i_kod;
  END IF;

END;
$$ LANGUAGE plpgsql SECURITY DEFINER;

ALTER FUNCTION removeglotxvariable(i_kod character varying) OWNER TO %firmaRole%;


--------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION getglotxvariable(i_kod character varying)
  RETURNS character varying AS $$
DECLARE
  result varchar(50);
  tmpGloTxVarTableExists boolean;
BEGIN
  tmpGloTxVarTableExists := (SELECT istableexist('tmp_gloTxVar'));

  IF (tmpGloTxVarTableExists = true) THEN
    SELECT hodnota INTO result FROM tmp_gloTxVar WHERE kod=i_kod LIMIT 1;
  END IF;

  RETURN result;
END;
$$ LANGUAGE plpgsql SECURITY DEFINER;

ALTER FUNCTION getglotxvariable(i_kod character varying) OWNER TO %firmaRole%;
