-- Funkce aktualizujici rezervaci pro obchodni polozku
CREATE OR REPLACE FUNCTION rezervujPolObch(_idPolObch integer)
  RETURNS void AS $$
declare
  polObch record;
  doklObch record;
  mnoz numeric(19,6);
  _idUcetObd integer;
  _idRezer integer;
begin
  select * into polObch from dPolObch where idPolObch = _idPolObch;
  
  if (polObch.rezervovat = true and polObch.modul = 'OBP') then
    mnoz = polObch.mnozMj - polObch.mnozMjReal;
    
    if (mnoz > 0 and polObch.typPolozkyK = 'typPolozky.katalog' and polObch.idSkladu is not null) then            -- jestlize zbyva jeste neco realizovat a je to skladova pol
      select * into doklObch from dDoklObch where idDoklObch = polObch.idDoklObch;
      
      select idrezervace into _idRezer from srezervace where idPolObch = polObch.idPolObch;
      
      if _idRezer is null then    -- zaznam neexistuje, vytvorime ho
        insert into srezervace (idpolobch, iduziv, idfirmy, idcenik, idsklad, mnozstvi, datumod)
          values (polObch.idPolObch, doklObch.iduziv, doklObch.idfirmy, polObch.idCenik, polObch.idSkladu, mnoz, polObch.datVyst);
      else                        -- zaznam jiz existuje, upravime ho
        update srezervace set idfirmy = doklObch.idfirmy, idCenik = polObch.idCenik, idSklad = polObch.idSkladu,
          mnozstvi = mnoz, datumod = polObch.datVyst where idrezervace = _idRezer;
      end if;
    else                          -- pokud je polozka jiz realizovana
      delete from srezervace where idPolObch = polObch.idPolObch;
    end if;
  end if;
end; 
$$ LANGUAGE plpgsql;
