/*
 Provede prepocitani cen na vydejce urcene pomoci i_polskladid
 Autor verze pro PostgreSQL: Karel Bl
 Autor verze pro Sybase:     Karel Bl
*/

CREATE OR REPLACE FUNCTION szmencenynapolsklad(i_polskladid integer, i_skladkartaid integer, i_doklskladid integer)
  RETURNS void AS
$BODY$ 
declare 
  /* Deklarace promennych */ 
  _MnozMJ numeric(19,2);
  _CenaMJOld numeric(19,2); 
  _SumZkl numeric(19,2); 
  _SumZklMen numeric(19,2); 
  _PrumCenaTuz numeric(19,2); 
  _PrumCenaMen numeric(19,2);
  _PrumCena numeric(19,2); 
  _TypPohybuK varchar(50); 
  _DatVyst date;
  _CiziMena boolean;  
  zaznam record;
  
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */ 
  declare ThisDoklSklad cursor for select TypPohybuK, DatVyst from dDoklSklad where idDoklSklad = i_DoklSkladId;
  declare ThisPolSklad cursor for select MnozMJ, CenaMJ from dPolSklad  where idPolSklad = i_PolSkladId;
  declare ThisSkladKarta cursor for select PrumCenaTuz,PrumCenaMen from sKarty where idKarty = i_SkladKartaId;
  declare ThisPolSkladSum cursor for select SumZkl, SumZklMen from dPolSklad where idDoklSklad = i_DoklSkladId;   
begin
  /* Ahoj */
  
  /* Zjisteni typPohybuK */
  open ThisDoklSklad; 
  fetch ThisDoklSklad into _TypPohybuK, _DatVyst; 
  close ThisDoklSklad; 

  /* Zjisteni mnozstvi jednotek */
  open ThisPolSklad; 
  fetch ThisPolSklad into _MnozMJ, _CenaMJOld; 
  close ThisPolSklad; 

  /* Nacteni dat ze skladove karty */
  open ThisSkladKarta; 
  fetch ThisSkladKarta into _PrumCenaTuz,_PrumCenaMen; 
  close ThisSkladKarta;
  
  if _TypPohybuK = 'typPohybu.vydej' then
    _CiziMena := (select isDoklSkladMenaCizi(i_DoklSkladId, _DatVyst));
    if _CiziMena then
      _PrumCena := _PrumCenaMen;
    else
      _PrumCena := _PrumCenaTuz;
    end if;

    update dPolSklad set 
      cenaMJ = _PrumCena,
      sumZkl = _PrumCena * _MnozMJ
      where 
      idPolSklad = i_PolSkladId;

    /* Nacteni novych souctu na skladovem dokladu */
    _SumZkl := 0;
    _SumZklMen := 0; 
    for zaznam in select * from dPolSklad where idDoklSklad = i_DoklSkladId loop 
      _SumZkl := _SumZkl + zaznam.sumZkl;
      _SumZklMen := _SumZklMen + zaznam.sumZklMen;
    end loop;  

    update dDoklSklad set
      sumCelkem = _SumZkl,
      sumCelkemMen = _SumZklMen
      where
      idDoklSklad = i_DoklSkladId;

  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;