-------------------------------------------------------------------------
-- Bug 14197 – [WinStrom] Tabulka osob
-------------------------------------------------------------------------

-- Skupiny osob
CREATE SEQUENCE seq_pskuposob
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pskuposob OWNER TO %firmaRole%;

CREATE TABLE pskuposob
(
  idskuposob integer DEFAULT nextval('seq_pskuposob'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  tydenpracdobak character varying(50),
  workflow boolean NOT NULL DEFAULT false,
  idtdintnahrad integer,
  idtdinthruba integer,
  idtuozavsoczam integer,
  idtuozavzdrfir integer,
  idtuozavzdrzam integer,
  idtuozavsocfir integer,
  idtuozavdan integer,
  idtdintcestdolim integer,
  CONSTRAINT pskuposob_pkey PRIMARY KEY (idskuposob),
  CONSTRAINT pskuposob_idtuozavsocfir FOREIGN KEY (idtuozavsocfir)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_idtuozavsoczam FOREIGN KEY (idtuozavsoczam)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_idtuozavzdrfir FOREIGN KEY (idtuozavzdrfir)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_idtuozavzdrzam FOREIGN KEY (idtuozavzdrzam)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_idtuozavdan FOREIGN KEY (idtuozavdan)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7623d0dabb627e5c FOREIGN KEY (idtdintnahrad)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7623d0dae4ebd49e FOREIGN KEY (idtdinthruba)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_idtdintcestdolim FOREIGN KEY (idtdintcestdolim)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_kod_key UNIQUE (kod)
);
ALTER TABLE pskuposob OWNER TO %firmaRole%;


-- Tabulka hlaviček zaměstnanců
CREATE SEQUENCE seq_posobahlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_posobahlav OWNER TO %firmaRole%;

CREATE TABLE posobahlav
(
  idosobahlav integer DEFAULT nextval('seq_posobahlav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  osbcis character varying(20) NOT NULL,
  jmeno character varying(255),
  prijmeni character varying(255),
  titul character varying(255),
  password character varying(255),
  CONSTRAINT posobahlav_pkey PRIMARY KEY (idosobahlav)
);
ALTER TABLE posobahlav OWNER TO %firmaRole%;


-- Tabulka dětí
CREATE SEQUENCE seq_pdite
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pdite OWNER TO %firmaRole%;

CREATE TABLE pdite
(
  iddite integer DEFAULT nextval('seq_pdite'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  datnaroz date,
  jmeno character varying(255),
  pohlavik character varying(50),
  poznam text,
  prijmeni character varying(255),
  rodcis character varying(20),
  ztp_p boolean DEFAULT false,
  ztp_pdo date,
  ztp_pod date,
  idosoba integer NOT NULL,
  CONSTRAINT pdite_pkey PRIMARY KEY (iddite),
  CONSTRAINT fk64aca46483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pdite OWNER TO %firmaRole%;

-- Tabulka nastavení zaměstnanců
CREATE SEQUENCE seq_posoba
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_posoba OWNER TO %firmaRole%;

CREATE TABLE posoba
(
  idosoba integer DEFAULT nextval('seq_posoba'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  cisdomu character varying(20),
  cisdomukon character varying(20),
  cisdomukontuz character varying(20),
  cispojist character varying(20),
  cisprukaz character varying(20),
  cizpojcisdomu character varying(20),
  cizpojcislo character varying(255),
  cizpojmesto character varying(255),
  cizpojnazev character varying(255),
  cizpojpsc character varying(20),
  cizpojspec character varying(255),
  cizpojulice character varying(255),
  dannerezid boolean DEFAULT false,
  datnaroz date,
  email character varying(255),
  fax character varying(255),
  funkce character varying(255),
  ispvokres character varying(255),
  ispvvzdelani character varying(255),
  ispvzamest character varying(255),
  ispvpostaveni character varying(20),
  ispvvedouci boolean NOT NULL DEFAULT false,
  jmeno character varying(255),
  kvalifikace character varying(255),
  mesto character varying(255),
  mestokon character varying(255),
  mestokontuz character varying(255),
  minulesoc numeric(15,2) DEFAULT 0.0,
  minulezdrav numeric(15,2) DEFAULT 0.0,
  mistonaroz character varying(255),
  mobil character varying(255),
  nezdatnaroz date,
  nezdo date,
  nezjmeno character varying(255),
  nezod date,
  nezpartner boolean DEFAULT false,
  nezpohlavik character varying(50),
  nezprijmeni character varying(255),
  nezprijmenirod character varying(255),
  nezrodcis character varying(20),
  neztitul character varying(255),
  nezztp boolean DEFAULT false,
  nezztpdo date,
  nezztpod date,
  odpracdnupred integer DEFAULT 0,
  odpracrokupred integer DEFAULT 0,
  osbcis character varying(20) NOT NULL,
  osbcisalter character varying(20),
  platido date,
  platiod date,
  podpisprohl boolean DEFAULT false,
  pohlavik character varying(50),
  posta character varying(255),
  postakon character varying(255),
  postakontuz character varying(255),
  poznam text,
  prednempoj character varying(255),
  prijmeni character varying(255),
  prijmenipred character varying(255),
  prijmenirod character varying(255),
  psc character varying(20),
  psckon character varying(20),
  psckontuz character varying(20),
  rodcis character varying(20),
  rodstavk character varying(50),
  soucnempoj character varying(255),
  telefon character varying(255),
  titul character varying(255),
  typvztahuk character varying(50),
  ulice character varying(255),
  ulicekon character varying(255),
  ulicekontuz character varying(255),
  zdrpojdoplat boolean DEFAULT false,
  zdrpojdoplatrozdel boolean DEFAULT false,
  zpusplatbyk character varying(50),
  idcizpojstatu integer,
  idstatunaroz integer,
  idstatukontuz integer,
  idosobahlav integer NOT NULL,
  idnadzizeny integer,
  idstatukon integer,
  idstredisko integer,
  idzdravpoj integer,
  idstatu integer,
  prukazztp boolean DEFAULT false,
  idskuposob integer,
  idstatuobcan integer,
  invalcast boolean DEFAULT false,
  invalplna boolean DEFAULT false,
  invalod date,
  student boolean DEFAULT false,
  sirotciduch boolean DEFAULT false,
  starobniduch boolean DEFAULT false,
  starobnipredduch boolean DEFAULT false,
  vdovskyduch boolean DEFAULT false,
  zahranicniduch boolean DEFAULT false,
  duchodod date,
  slevapoplat boolean DEFAULT false,
  snizvymzaklzp boolean DEFAULT false,
  ucastnikDuchSpor boolean NOT NULL DEFAULT false,
  cisucastduchspor character varying(50),
  idtddobirka integer,
  idtdzaloha integer,
  idditeodpoc1 integer,
  idditeodpoc2 integer,
  pocetpriloh integer NOT NULL DEFAULT 0,
  password character varying(255),
  CONSTRAINT posoba_pkey PRIMARY KEY (idosoba),
  CONSTRAINT fkc3adf9fa3feff3a8 FOREIGN KEY (idstatunaroz)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa4248e313 FOREIGN KEY (idcizpojstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa43d3196a FOREIGN KEY (idstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa4ba9b668 FOREIGN KEY (idstatukon)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa73713339 FOREIGN KEY (idstatukontuz)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa3ffe457b FOREIGN KEY (idstatuobcan)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faa5048c67 FOREIGN KEY (idzdravpoj)
      REFERENCES aadresar (idfirmy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faf3bcf0d0 FOREIGN KEY (idosobahlav)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT posoba_idnadzizeny FOREIGN KEY (idnadzizeny)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faf8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa695cea0a FOREIGN KEY (idskuposob)
      REFERENCES pskuposob (idskuposob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa83f14203 FOREIGN KEY (idtddobirka)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa84178d26 FOREIGN KEY (idtdzaloha)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT posoba_idditeodpoc1 FOREIGN KEY (idditeodpoc1)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT posoba_idditeodpoc2 FOREIGN KEY (idditeodpoc2)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE posoba OWNER TO %firmaRole%;

-- Vazební tabulky pro výběrové klíče

CREATE SEQUENCE seq_wkli_zosoba
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_zosoba OWNER TO %firmaRole%;

CREATE TABLE wkli_zosoba
(
  idwkli_zosoba integer NOT NULL DEFAULT nextval('seq_wkli_zosoba'::regclass),
  idosoba integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_zosoba_pkey PRIMARY KEY (idwkli_zosoba),
  CONSTRAINT wkli_zosoba_idosoba_idvybklic_unique_key UNIQUE (idosoba, idvybklic),
  CONSTRAINT fke47f4fe4c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fke47f4fecd357b3e FOREIGN KEY (idosoba)
      REFERENCES posoba (idosoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_zosoba OWNER TO %firmaRole%;

CREATE SEQUENCE seq_wkli_zdite
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_zdite OWNER TO %firmaRole%;

CREATE TABLE wkli_zdite
(
  idwkli_zdite integer NOT NULL DEFAULT nextval('seq_wkli_zdite'::regclass),
  iddite integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_zdite_pkey PRIMARY KEY (idwkli_zdite),
  CONSTRAINT wkli_zdite_iddite_idvybklic_unique_key UNIQUE (iddite, idvybklic),
  CONSTRAINT fk8b2daa24c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk8b2daa25928fc02 FOREIGN KEY (iddite)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_zdite OWNER TO %firmaRole%;

CREATE TABLE pdite_posoba
(
  idosoba integer NOT NULL,
  iddite integer NOT NULL,
  CONSTRAINT pdite_posoba_pkey PRIMARY KEY (idosoba, iddite),
  CONSTRAINT fk71cdca735928fc02 FOREIGN KEY (iddite)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk71cdca73cd357b3e FOREIGN KEY (idosoba)
      REFERENCES posoba (idosoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pdite_posoba OWNER TO %firmaRole%;

-- Indexy

CREATE INDEX pDite_IdOsoba_index ON pDite USING btree (IdOsoba);
CREATE INDEX pOsoba_IdOsobaHlav_index ON pOsoba USING btree (IdOsobaHlav);
CREATE INDEX pOsoba_IdSkupOsob_index ON pOsoba USING btree (IdSkupOsob);
CREATE INDEX pOsoba_IdStatuNaroz_index ON pOsoba USING btree (IdStatuNaroz);
CREATE INDEX pOsoba_IdStredisko_index ON pOsoba USING btree (IdStredisko);
CREATE INDEX pOsoba_IdStatu_index ON pOsoba USING btree (IdStatu);
CREATE INDEX pOsoba_IdStatuKon_index ON pOsoba USING btree (IdStatuKon);
CREATE INDEX pOsoba_IdStatuKonTuz_index ON pOsoba USING btree (IdStatuKonTuz);
CREATE INDEX pOsoba_IdStatuObcan_index ON pOsoba USING btree (IdStatuObcan);
CREATE INDEX pOsoba_IdZdravPoj_index ON pOsoba USING btree (IdZdravPoj);
CREATE INDEX pOsoba_IdCizPojStatu_index ON pOsoba USING btree (IdCizPojStatu);
CREATE INDEX pOsoba_IdTdDobirka_index ON pOsoba USING btree (IdTdDobirka);
CREATE INDEX pOsoba_IdTdZaloha_index ON pOsoba USING btree (IdTdZaloha);
CREATE INDEX pOsoba_IdNadzizeny_index ON pOsoba USING btree (IdNadzizeny);
CREATE INDEX pOsoba_IdDiteOdpoc1_index ON pOsoba USING btree (IdDiteOdpoc1);
CREATE INDEX pOsoba_IdDiteOdpoc2_index ON pOsoba USING btree (IdDiteOdpoc2);
CREATE INDEX pSkupOsob_IdTdIntHruba_index ON pSkupOsob USING btree (IdTdIntHruba);
CREATE INDEX pSkupOsob_IdTdIntNahrad_index ON pSkupOsob USING btree (IdTdIntNahrad);
CREATE INDEX pSkupOsob_IdTdIntCestDoLim_index ON pSkupOsob USING btree (IdTdIntCestDoLim);
CREATE INDEX pSkupOsob_IdTuoZavSocZam_index ON pSkupOsob USING btree (IdTuoZavSocZam);
CREATE INDEX pSkupOsob_IdTuoZavSocFir_index ON pSkupOsob USING btree (IdTuoZavSocFir);
CREATE INDEX pSkupOsob_IdTuoZavZdrZam_index ON pSkupOsob USING btree (IdTuoZavZdrZam);
CREATE INDEX pSkupOsob_IdTuoZavZdrFir_index ON pSkupOsob USING btree (IdTuoZavZdrFir);
CREATE INDEX pSkupOsob_IdTuoZavDan_index ON pSkupOsob USING btree (IdTuoZavDan);


---------------------------------------------------------------
-- Bug 14356 – [WinStrom] Další tabulky a formuláře pro mzdy
---------------------------------------------------------------

-- Tabulka číselníku mzdových složek
CREATE SEQUENCE seq_pcismzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pcismzdsloz OWNER TO %firmaRole%;

CREATE TABLE pcismzdsloz
(
  idcismzdsloz integer DEFAULT nextval('seq_pcismzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  naosobu boolean DEFAULT false,
  vscastmzd boolean DEFAULT false,
  vscastnaden boolean DEFAULT false,
  vscastnahod boolean DEFAULT false,
  vscisdoklnem boolean DEFAULT false,
  vsdatdo boolean DEFAULT false,
  vsdatod boolean DEFAULT false,
  vsdnykal boolean DEFAULT false,
  vsdnyprac boolean DEFAULT false,
  vsdnysvatek boolean DEFAULT false,
  vshodiny boolean DEFAULT false,
  vshodinysvatek boolean DEFAULT false,
  vsdoplatzdrpoj boolean DEFAULT false,
  vspocetmes boolean DEFAULT false,
  vsprocmzd boolean DEFAULT false,
  vsprumnadennem boolean DEFAULT false,
  vsprumnahodnem boolean DEFAULT false,
  vszakljekracen boolean DEFAULT false,
  vszaklmzd boolean DEFAULT false,
  vszmenacastmzd boolean DEFAULT false,
  platido date,
  platiod date,
  cisrad integer,
  vyznamk character varying(50),
  castmzd numeric(15,2) DEFAULT 0.0,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  cisdoklnem integer,
  dnykal numeric(6,2) DEFAULT 0.0,
  dnyprac numeric(6,2) DEFAULT 0.0,
  dnysvatek numeric(6,2) DEFAULT 0.0,
  doplatzdravk character varying(50),
  hodiny numeric(6,2) DEFAULT 0.0,
  pocetmes integer,
  procmzd numeric(15,2) DEFAULT 0.0,
  prumnadennem numeric(15,2) DEFAULT 0.0,
  prumnahodnem numeric(15,2) DEFAULT 0.0,
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  zmenacastmzd boolean DEFAULT false,
  pracovni boolean DEFAULT false,
  ukladatnulove boolean DEFAULT false,
  paskamala boolean DEFAULT false,
  paskavelka boolean DEFAULT false,
  paskapole character varying(255),
  zapoctovylist boolean DEFAULT false,
  uuid character varying(50),
  CONSTRAINT pcismzdsloz_pkey PRIMARY KEY (idcismzdsloz),
  CONSTRAINT pcismzdsloz_kod_key UNIQUE (kod)
);
ALTER TABLE pcismzdsloz OWNER TO %firmaRole%;


-- Tabulka typů pracovních poměrů
CREATE SEQUENCE seq_ptyppracpom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ptyppracpom OWNER TO %firmaRole%;

CREATE TABLE ptyppracpom
(
  idtyppracpom integer DEFAULT nextval('seq_ptyppracpom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  CONSTRAINT ptyppracpom_pkey PRIMARY KEY (idtyppracpom)
);
ALTER TABLE ptyppracpom OWNER TO %firmaRole%;


-- Tabulka hlaviček pracovních poměrů
CREATE SEQUENCE seq_ppracpomhlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracpomhlav OWNER TO %firmaRole%;

CREATE TABLE ppracpomhlav
(
  idpracpomhlav integer NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  idosoba integer NOT NULL,
  aktivnido date,
  aktivniod date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  hlavni boolean DEFAULT false,
  zacatek date,
  konecpomeru date,
  CONSTRAINT ppracpomhlav_pkey PRIMARY KEY (idpracpomhlav),
  CONSTRAINT fk5365ced3483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracpomhlav OWNER TO %firmaRole%;


-- Tabulka pracovních poměrů
CREATE SEQUENCE seq_ppracpom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracpom OWNER TO %firmaRole%;

CREATE TABLE ppracpom
(
  idpracpom integer DEFAULT nextval('seq_ppracpom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  platido date,
  platiod date,
  idpracpomhlav integer NOT NULL,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  aktivnido date,
  aktivniod date,
  hlavni boolean DEFAULT false,
  hodinovamzda numeric(15,2) DEFAULT 0.0,
  kodeldp character varying(20),
  konecpomeru date,
  malyrozsah boolean DEFAULT false,
  mesicnimzda numeric(15,2) DEFAULT 0.0,
  nastup date,
  plneniodprdobyk character varying(50),
  pracrozvrhk character varying(50),
  predhrubprijem numeric(15,2) DEFAULT 0.0,
  procminmzd integer,
  tariftrida character varying(255),
  typmzdyk character varying(50),
  uvazhodtydne numeric(6,2) DEFAULT 0.0,
  uvazhoddenne numeric(6,2) DEFAULT 0.0,
  zacatek date,
  idtyppracpom integer NOT NULL,
  idosoba integer NOT NULL,
  zlistduvod character varying(255),
  zlistsdeleni text,
  zlistukonceni character varying(255),
  uvazdnutydne integer,
  uvazpo boolean NOT NULL DEFAULT false,
  uvazut boolean NOT NULL DEFAULT false,
  uvazst boolean NOT NULL DEFAULT false,
  uvazct boolean NOT NULL DEFAULT false,
  uvazpa boolean NOT NULL DEFAULT false,
  uvazso boolean NOT NULL DEFAULT false,
  uvazne boolean NOT NULL DEFAULT false,
  zacpracdoby numeric(6,2) DEFAULT 0.0,
  tydenpracdobak character varying(50),
  svatkyprumer boolean DEFAULT true,
  dovolenerocne numeric(6,2) NOT NULL DEFAULT 0.0,
  idtdinthruba integer,
  idtdintnahrad integer,
  idtdintcestdolim integer,
  idtuozavsoczam integer,
  idtuozavsocfir integer,
  idtuozavzdrzam integer,
  idtuozavzdrfir integer,
  idtuozavdan integer,
  CONSTRAINT ppracpom_pkey PRIMARY KEY (idpracpom),
  CONSTRAINT fkc283bf7a39186a54 FOREIGN KEY (idtyppracpom)
      REFERENCES ptyppracpom (idtyppracpom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7a483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7ab686f970 FOREIGN KEY (idpracpomhlav)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtuozavsoczam FOREIGN KEY (idtuozavsoczam)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtuozavsocfir FOREIGN KEY (idtuozavsocfir)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtuozavzdrzam FOREIGN KEY (idtuozavzdrzam)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtuozavzdrfir FOREIGN KEY (idtuozavzdrfir)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtuozavdan FOREIGN KEY (idtuozavdan)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7abb627e5c FOREIGN KEY (idtdintnahrad)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7ae4ebd49e FOREIGN KEY (idtdinthruba)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracpom_idtdintcestdolim FOREIGN KEY (idtdintcestdolim)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracpom OWNER TO %firmaRole%;


-- Tabulka nepřítomností
CREATE SEQUENCE seq_pnepritomnost
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pnepritomnost OWNER TO %firmaRole%;

CREATE TABLE pnepritomnost
(
  idnepritomnost integer DEFAULT nextval('seq_pnepritomnost'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  hodin1den numeric(6,2),
  hodinxden numeric(6,2),
  platido date,
  platiod date,
  poznam text,
  idosoba integer NOT NULL,
  idpracpom integer NOT NULL,
  idcismzdsloz integer,
  CONSTRAINT pnepritomnost_pkey PRIMARY KEY (idnepritomnost),
  CONSTRAINT fkad948d34483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkad948d3431a00b7 FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkad948d348c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pnepritomnost OWNER TO %firmaRole%;


-- Tabulka směn
CREATE SEQUENCE seq_psmeny
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_psmeny OWNER TO %firmaRole%;

CREATE TABLE psmeny
(
  idsmeny integer DEFAULT nextval('seq_psmeny'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  mesic integer DEFAULT 0,
  planovane text,
  rok integer,
  skutecne text,
  idpracpom integer,
  idskuposob integer,
  idosoba integer,
  CONSTRAINT psmeny_pkey PRIMARY KEY (idsmeny),
  CONSTRAINT fkc3e379c6483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3e379c6695cea0a FOREIGN KEY (idskuposob)
      REFERENCES pskuposob (idskuposob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3e379c6ba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE psmeny OWNER TO %firmaRole%;


-- Vazební tabulky pro výběrové klíče
CREATE SEQUENCE seq_wkli_pnepritomnost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pnepritomnost OWNER TO %firmaRole%;

CREATE TABLE wkli_pnepritomnost
(
  idwkli_pnepritomnost integer NOT NULL DEFAULT nextval('seq_wkli_pnepritomnost'::regclass),
  idnepritomnost integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pnepritomnost_pkey PRIMARY KEY (idwkli_pnepritomnost),
  CONSTRAINT wkli_pnepritomnost_idnepritomnost_idvybklic_unique_key UNIQUE (idnepritomnost, idvybklic),
  CONSTRAINT fk350c308644f0abde FOREIGN KEY (idnepritomnost)
      REFERENCES pnepritomnost (idnepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk350c30864c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pnepritomnost OWNER TO %firmaRole%;


-- indexy
CREATE INDEX pNepritomnost_IdOsoba_index ON pNepritomnost USING btree (IdOsoba);
CREATE INDEX pNepritomnost_IdCisMzdSloz_index ON pNepritomnost USING btree (IdCisMzdSloz);
CREATE INDEX pNepritomnost_IdPracPom_index ON pNepritomnost USING btree (IdPracPom);
CREATE INDEX pPracPom_IdPracPomHlav_index ON pPracPom USING btree (IdPracPomHlav);
CREATE INDEX pPracPom_IdOsoba_index ON pPracPom USING btree (IdOsoba);
CREATE INDEX pPracPom_IdTypPracPom_index ON pPracPom USING btree (IdTypPracPom);
CREATE INDEX pPracPom_IdTdIntHruba_index ON pPracPom USING btree (IdTdIntHruba);
CREATE INDEX pPracPom_IdTdIntNahrad_index ON pPracPom USING btree (IdTdIntNahrad);
CREATE INDEX pPracPom_IdTdIntCestDoLim_index ON pPracPom USING btree (IdTdIntCestDoLim);
CREATE INDEX pPracPom_IdTuoZavSocZam_index ON pPracPom USING btree (IdTuoZavSocZam);
CREATE INDEX pPracPom_IdTuoZavSocFir_index ON pPracPom USING btree (IdTuoZavSocFir);
CREATE INDEX pPracPom_IdTuoZavZdrZam_index ON pPracPom USING btree (IdTuoZavZdrZam);
CREATE INDEX pPracPom_IdTuoZavZdrFir_index ON pPracPom USING btree (IdTuoZavZdrFir);
CREATE INDEX pPracPom_IdTuoZavDan_index ON pPracPom USING btree (IdTuoZavDan);
CREATE INDEX pPracPomHlav_IdOsoba_index ON pPracPomHlav USING btree (IdOsoba);
CREATE INDEX pSmeny_IdOsoba_index ON pSmeny USING btree (IdOsoba);
CREATE INDEX pSmeny_IdPracPom_index ON pSmeny USING btree (IdPracPom);
CREATE INDEX pSmeny_IdSkupOsob_index ON pSmeny USING btree (IdSkupOsob);



-- Tabulka stálých mzdových složek
CREATE SEQUENCE seq_pstalamzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pstalamzdsloz OWNER TO %firmaRole%;

CREATE TABLE pstalamzdsloz
(
  idstalamzdsloz integer DEFAULT nextval('seq_pstalamzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  datumdo date,
  datumod date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  pocetmes integer,
  podil numeric(6,2) DEFAULT 0.0,
  poznam text,
  procmzd numeric(15,2) DEFAULT 0.0,
  skupslozkyk character varying(50),
  typpodilk character varying(50),
  typslozkyk character varying(50),
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  castmzd numeric(15,2) DEFAULT 0.0,
  dnykal numeric(15,2) DEFAULT 0.0,
  dnyprac numeric(15,2) DEFAULT 0.0,
  dnysvatek numeric(15,2) DEFAULT 0.0,
  hodiny numeric(15,2) DEFAULT 0.0,
  hodinysvatek numeric(15,2) DEFAULT 0.0,
  prumnadennem numeric(15,2) DEFAULT 0.0,
  prumnahodnem numeric(15,2) DEFAULT 0.0,
  idcismzdsloz integer NOT NULL,
  idpracpom integer NOT NULL,
  idstredisko integer,
  idzakazka integer,
  idosoba integer NOT NULL,
  CONSTRAINT pstalamzdsloz_pkey PRIMARY KEY (idstalamzdsloz),
  CONSTRAINT fk87a8c236483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c2368c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236ba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236f8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236fa994e17 FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pstalamzdsloz OWNER TO %firmaRole%;


-- Tabulka srážek
CREATE SEQUENCE seq_psrazka
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_psrazka OWNER TO %firmaRole%;

CREATE TABLE psrazka
(
  idsrazka integer DEFAULT nextval('seq_psrazka'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castka numeric(15,2) DEFAULT 0.0,
  celkem numeric(15,2) DEFAULT 0.0,
  deponovatdo date,
  kdatu date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  pocatek numeric(15,2) DEFAULT 0.0,
  poradi integer,
  poznam text,
  prednostni boolean DEFAULT false,
  procmzd numeric(10,6) DEFAULT 0.0,
  srazkado date,
  srazkaod date,
  zbyva numeric(15,2) DEFAULT 0.0,
  zpusobplatbyk character varying(50),
  splatnost integer,
  idbanspoj integer,
  idtypostzav integer,
  idosoba integer NOT NULL,
  idcismzdsloz integer NOT NULL,
  idtypintdokl integer,
  CONSTRAINT psrazka_pkey PRIMARY KEY (idsrazka),
  CONSTRAINT fkb8d08ebe144f8d03 FOREIGN KEY (idbanspoj)
      REFERENCES abanspoj (idbanspoj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe852963e7 FOREIGN KEY (idtypostzav)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebed3979543 FOREIGN KEY (idtypintdokl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE psrazka OWNER TO %firmaRole%;


-- Tabulka mzdových složek
CREATE SEQUENCE seq_pmzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdsloz OWNER TO %firmaRole%;

CREATE TABLE pmzdsloz
(
  idmzdsloz integer DEFAULT nextval('seq_pmzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castmzd numeric(15,2) DEFAULT 0.0,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  cisdoklnem integer,
  datumdo date,
  datumod date,
  dnykal numeric(6,2) DEFAULT 0.0,
  dnykalreal numeric(6,2) DEFAULT 0.0,
  dnyprac numeric(6,2) DEFAULT 0.0,
  dnysvatek numeric(6,2) DEFAULT 0.0,
  doplatzdravk character varying(50),
  hodiny numeric(6,2) DEFAULT 0.0,
  hodinysvatek numeric(6,2) DEFAULT 0.0,
  kod character varying(20) NOT NULL,
  mesic integer,
  nazev character varying(255),
  pocetmes integer,
  cisrad integer,
  poznam text,
  procmzd numeric(15,2) DEFAULT 0.0,
  prumnadennem numeric(15,2) DEFAULT 0.0,
  prumnahodnem numeric(15,2) DEFAULT 0.0,
  rok integer,
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  zmenacastmzd boolean DEFAULT false,
  zmenacasu boolean NOT NULL DEFAULT false,
  pracovni boolean DEFAULT false,
  datumdoklad date,
  mesicplatba integer,
  rokplatba integer,
  idpracpom integer,
  idosoba integer NOT NULL,
  idzakazka integer,
  idcismzdsloz integer NOT NULL,
  idstredisko integer,
  idsrazka integer,
  idstalamzdsloz integer,
  idnepritomnost integer,
  idOdmena integer,
  CONSTRAINT pmzdsloz_pkey PRIMARY KEY (idmzdsloz),
  CONSTRAINT fk319b3c6b483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6be6f87f72 FOREIGN KEY (idsrazka)
      REFERENCES psrazka (idsrazka) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b95ef09e2 FOREIGN KEY (idstalamzdsloz)
      REFERENCES pstalamzdsloz (idstalamzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b44f0abde FOREIGN KEY (idnepritomnost)
      REFERENCES pnepritomnost (idnepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bf8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bfa994e17 FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_pmzdsloz_odmena FOREIGN KEY (idodmena)
      REFERENCES pmzdsloz (idmzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdsloz OWNER TO %firmaRole%;



-- Vazební tabulky pro výběrové klíče
CREATE SEQUENCE seq_wkli_pmzdsloz
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pmzdsloz OWNER TO %firmaRole%;

CREATE TABLE wkli_pmzdsloz
(
  idwkli_pmzdsloz integer NOT NULL DEFAULT nextval('seq_wkli_pmzdsloz'::regclass),
  idmzdsloz integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pmzdsloz_pkey PRIMARY KEY (idwkli_pmzdsloz),
  CONSTRAINT wkli_pmzdsloz_idmzdsloz_idvybklic_unique_key UNIQUE (idmzdsloz, idvybklic),
  CONSTRAINT fk2ee54d994c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk2ee54d9998d9e180 FOREIGN KEY (idmzdsloz)
      REFERENCES pmzdsloz (idmzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pmzdsloz OWNER TO %firmaRole%;

CREATE SEQUENCE seq_wkli_pstalamzdsloz
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pstalamzdsloz OWNER TO %firmaRole%;

CREATE TABLE wkli_pstalamzdsloz
(
  idwkli_pstalamzdsloz integer NOT NULL DEFAULT nextval('seq_wkli_pstalamzdsloz'::regclass),
  idstalamzdsloz integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pstalamzdsloz_pkey PRIMARY KEY (idwkli_pstalamzdsloz),
  CONSTRAINT wkli_pstalamzdsloz_idstalamzdsloz_idvybklic_unique_key UNIQUE (idstalamzdsloz, idvybklic),
  CONSTRAINT fkabf659884c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkabf6598895ef09e2 FOREIGN KEY (idstalamzdsloz)
      REFERENCES pstalamzdsloz (idstalamzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pstalamzdsloz OWNER TO %firmaRole%;




CREATE INDEX pCisMzdSloz_VyznamK_index ON pCisMzdSloz USING btree (VyznamK);
CREATE INDEX pMzdSloz_IdOsoba_index ON pMzdSloz USING btree (IdOsoba);
CREATE INDEX pMzdSloz_IdPracPom_index ON pMzdSloz USING btree (IdPracPom);
CREATE INDEX pMzdSloz_IdCisMzdSloz_index ON pMzdSloz USING btree (IdCisMzdSloz);
CREATE INDEX pMzdSloz_IdStredisko_index ON pMzdSloz USING btree (IdStredisko);
CREATE INDEX pMzdSloz_IdZakazka_index ON pMzdSloz USING btree (IdZakazka);
CREATE INDEX pMzdSloz_IdStalaMzdSloz_index ON pMzdSloz USING btree (IdStalaMzdSloz);
CREATE INDEX pMzdSloz_IdSrazka_index ON pMzdSloz USING btree (IdSrazka);
CREATE INDEX pMzdSloz_IdNepritomnost_index ON pMzdSloz USING btree (IdNepritomnost);
CREATE INDEX pSrazka_IdOsoba_index ON pSrazka USING btree (IdOsoba);
CREATE INDEX pSrazka_IdCisMzdSloz_index ON pSrazka USING btree (IdCisMzdSloz);
CREATE INDEX pSrazka_IdBanSpoj_index ON pSrazka USING btree (IdBanSpoj);
CREATE INDEX pSrazka_IdTypOstZav_index ON pSrazka USING btree (IdTypOstZav);
CREATE INDEX pSrazka_IdTypIntDokl_index ON pSrazka USING btree (IdTypIntDokl);
CREATE INDEX pStalaMzdSloz_IdOsoba_index ON pStalaMzdSloz USING btree (IdOsoba);
CREATE INDEX pStalaMzdSloz_IdPracPom_index ON pStalaMzdSloz USING btree (IdPracPom);
CREATE INDEX pStalaMzdSloz_IdCisMzdSloz_index ON pStalaMzdSloz USING btree (IdCisMzdSloz);
CREATE INDEX pStalaMzdSloz_IdStredisko_index ON pStalaMzdSloz USING btree (IdStredisko);
CREATE INDEX pStalaMzdSloz_IdZakazka_index ON pStalaMzdSloz USING btree (IdZakazka);



-- Tabulka hlavicek kalkulatoru mezd
CREATE SEQUENCE seq_pmzdcalchlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalchlav OWNER TO %firmaRole%;

CREATE TABLE pmzdcalchlav
(
  idmzdcalchlav integer DEFAULT nextval('seq_pmzdcalchlav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  CONSTRAINT pmzdcalchlav_pkey PRIMARY KEY (idmzdcalchlav)
);
ALTER TABLE pmzdcalchlav OWNER TO %firmaRole%;


-- tabulky inicializacnich radek kalkulacky
CREATE SEQUENCE seq_pmzdcalcinit
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalcinit OWNER TO %firmaRole%;

CREATE TABLE pmzdcalcinit
(
  idmzdcalcinit integer DEFAULT nextval('seq_pmzdcalcinit'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  cisrad integer NOT NULL DEFAULT 0,
  polein character varying(255) NOT NULL,
  poleout character varying(255) NOT NULL,
  zdrojk character varying(50),
  platnostk character varying(50),
  zpracdatumk character varying(50),
  idtyppracpom integer,
  idmzdslozout integer NOT NULL,
  idmzdcalchlav integer NOT NULL,
  CONSTRAINT pmzdcalcinit_pkey PRIMARY KEY (idmzdcalcinit),
  CONSTRAINT fk7549e7ec39186a54 FOREIGN KEY (idtyppracpom)
      REFERENCES ptyppracpom (idtyppracpom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7549e7ec59ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7549e7ecffa59017 FOREIGN KEY (idmzdslozout)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdcalcinit OWNER TO %firmaRole%;


-- Tabulka radku kalkulatoru mezd
CREATE SEQUENCE seq_pmzdcalc
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalc OWNER TO %firmaRole%;

CREATE TABLE pmzdcalc
(
  idmzdcalc integer DEFAULT nextval('seq_pmzdcalc'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  cisrad integer NOT NULL DEFAULT 0,
  dohodnoty numeric(19,6) DEFAULT 0.0,
  koeficient numeric(19,6) NOT NULL DEFAULT 0.0,
  koeficient2 numeric(19,6) NOT NULL DEFAULT 1.0,
  koeficient3 numeric(19,6) NOT NULL DEFAULT 0.0,
  odhodnoty numeric(19,6) DEFAULT 0.0,
  polein character varying(255) NOT NULL,
  polein2 character varying(255),
  poleout character varying(255) NOT NULL,
  zaokrjakk character varying(50),
  zaokrnak character varying(50),
  operacek character varying(50),
  vyslodhodnoty numeric(19,6) DEFAULT 0.0,
  vysldohodnoty numeric(19,6) DEFAULT 0.0,
  idmzdcalchlav integer NOT NULL,
  idmzdslozout integer NOT NULL,
  idmzdslozin integer NOT NULL,
  idmzdslozin2 integer,
  vyhodnotrocne boolean DEFAULT false,
  sumtypk character varying(50),
  summesicu integer DEFAULT 0,
  ispv boolean NOT NULL DEFAULT false,
  vstupNapricPomery boolean not null default false,
  CONSTRAINT pmzdcalc_pkey PRIMARY KEY (idmzdcalc),
  CONSTRAINT fk3193ccbc59ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk3193ccbc81d0ccae FOREIGN KEY (idmzdslozin)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk3193ccbcffa57876 FOREIGN KEY (idmzdslozin2)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk3193ccbcffa59017 FOREIGN KEY (idmzdslozout)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdcalc OWNER TO %firmaRole%;


-- Tabulka parametrů typů pracovních poměrů
CREATE SEQUENCE seq_ptyppracpomparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ptyppracpomparam OWNER TO %firmaRole%;

CREATE TABLE ptyppracpomparam
(
  idtyppracpomparam integer DEFAULT nextval('seq_ptyppracpomparam'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  cisrad integer NOT NULL DEFAULT 0,
  dohodnoty numeric(19,6) DEFAULT 0.0,
  koeficient numeric(10,6) NOT NULL DEFAULT 0.0,
  odhodnoty numeric(19,6) DEFAULT 0.0,
  polenuluj character varying(255) NOT NULL,
  poletest character varying(255) NOT NULL,
  idtyppracpom integer,
  idmzdcalchlav integer NOT NULL,
  idcismzdsloz integer NOT NULL,
  actmaprohl boolean DEFAULT true,
  actmalyroz boolean DEFAULT true,
  actnemaprohl boolean DEFAULT true,
  actvelkyroz boolean DEFAULT true,
  actdannerez boolean DEFAULT true,
  actdanrez boolean DEFAULT true,
  actzdrdopl boolean DEFAULT true,
  actzdrnedopl boolean DEFAULT true,
  CONSTRAINT ptyppracpomparam_pkey PRIMARY KEY (idtyppracpomparam),
  CONSTRAINT fk764403e59ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk764403e39186a54 FOREIGN KEY (idtyppracpom)
      REFERENCES ptyppracpom (idtyppracpom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk764403e8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ptyppracpomparam OWNER TO %firmaRole%;


-- Tabulka radku kalkulatoru mezd pro hromadny vypocet
CREATE SEQUENCE seq_pmzdcalchrom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalchrom OWNER TO %firmaRole%;

CREATE TABLE pmzdcalchrom
(
  idmzdcalchrom integer DEFAULT nextval('seq_pmzdcalchrom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  cisrad integer NOT NULL DEFAULT 0,
  polein character varying(255) NOT NULL,
  poleout character varying(255) NOT NULL,
  zaokrjakk character varying(50),
  zaokrnak character varying(50),
  idmzdcalchlav integer NOT NULL,
  idmzdslozin integer NOT NULL,
  idmzdslozout integer NOT NULL,
  CONSTRAINT pmzdcalchrom_pkey PRIMARY KEY (idmzdcalchrom),
  CONSTRAINT fk7549834459ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7549834481d0ccae FOREIGN KEY (idmzdslozin)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk75498344ffa59017 FOREIGN KEY (idmzdslozout)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdcalchrom OWNER TO %firmaRole%;


ALTER TABLE pmzdcalchlav ADD COLUMN idradkahromadne integer;
ALTER TABLE pmzdcalchlav ADD CONSTRAINT fk75496b156b60de3 FOREIGN KEY (idradkahromadne)
  REFERENCES pmzdcalc (idmzdcalc) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX pMzdCalcHlav_IdRadkaHromadne_index ON pMzdCalcHlav USING btree (IdRadkaHromadne);
CREATE INDEX pMzdCalcInit_IdMzdCalcHlav_index ON pMzdCalcInit USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalcInit_IdTypPracPom_index ON pMzdCalcInit USING btree (IdTypPracPom);
CREATE INDEX pMzdCalcInit_IdMzdSlozOut_index ON pMzdCalcInit USING btree (IdMzdSlozOut);
CREATE INDEX pMzdCalc_IdMzdCalcHlav_index ON pMzdCalc USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalc_IdMzdSlozIn_index ON pMzdCalc USING btree (IdMzdSlozIn);
CREATE INDEX pMzdCalc_IdMzdSlozIn2_index ON pMzdCalc USING btree (IdMzdSlozIn2);
CREATE INDEX pMzdCalc_IdMzdSlozOut_index ON pMzdCalc USING btree (IdMzdSlozOut);
CREATE INDEX pTypPracPomParam_IdTypPracPom_index ON pTypPracPomParam USING btree (IdTypPracPom);
CREATE INDEX pTypPracPomParam_IdCisMzdSloz_index ON pTypPracPomParam USING btree (IdCisMzdSloz);
CREATE INDEX pTypPracPomParam_IdMzdCalcHlav_index ON pTypPracPomParam USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalcHrom_IdMzdCalcHlav_index ON pMzdCalcHrom USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalcHrom_IdMzdSlozIn_index ON pMzdCalcHrom USING btree (IdMzdSlozIn);
CREATE INDEX pMzdCalcHrom_IdMzdSlozOut_index ON pMzdCalcHrom USING btree (IdMzdSlozOut);


-- Vazebni tabulka mezd a zavazku
CREATE SEQUENCE seq_pmzdvazbazav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdvazbazav OWNER TO %firmaRole%;

CREATE TABLE pmzdvazbazav
(
  idmzdvazbazav integer DEFAULT nextval('seq_pmzdvazbazav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  mesic smallint DEFAULT 0,
  rok integer,
  vyznamk character varying(50),
  idpolfak integer,
  idosoba integer,
  iddoklfak integer,
  iddoklint integer,
  CONSTRAINT pmzdvazbazav_pkey PRIMARY KEY (idmzdvazbazav),
  CONSTRAINT fk42e09a88127b9d00 FOREIGN KEY (idpolfak)
      REFERENCES dpolfak (idpolfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a884759f20e FOREIGN KEY (iddoklfak)
      REFERENCES ddoklfak (iddoklfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a88475a0bcc FOREIGN KEY (iddoklint)
      REFERENCES ddoklint (iddoklint) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a88483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdvazbazav OWNER TO %firmaRole%;

CREATE INDEX pMzdVazbaZav_IdOsoba_index ON pMzdVazbaZav USING btree (IdOsoba);
CREATE INDEX pMzdVazbaZav_IdDoklFak_index ON pMzdVazbaZav USING btree (IdDoklFak);
CREATE INDEX pMzdVazbaZav_IdPolFak_index ON pMzdVazbaZav USING btree (IdPolFak);
CREATE INDEX pMzdVazbaZav_IdDoklInt_index ON pMzdVazbaZav USING btree (IdDoklInt);

-- tabulka pro parametry mezd
CREATE SEQUENCE seq_pmzdyparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdyparam OWNER TO %firmaRole%;

CREATE TABLE pmzdyparam
(
  idmzdyparam integer DEFAULT nextval('seq_pmzdyparam'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  klic character varying(50),
  hodnota character varying(255),
  CONSTRAINT pmzdyparam_pkey PRIMARY KEY (idmzdyparam)
);
ALTER TABLE pmzdyparam OWNER TO %firmaRole%;


-- Navazani bankovniho spojeni na osobu
ALTER TABLE abanspoj ADD COLUMN idosoba integer;
ALTER TABLE abanspoj ADD CONSTRAINT fkab68e206483ac817 FOREIGN KEY (idosoba)
  REFERENCES posobahlav (idosobahlav) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX aBanSpoj_IdOsoba_index ON aBanSpoj USING btree (IdOsoba);


-- Navazani prilohy na osobu
ALTER TABLE wpriloha ADD COLUMN idosoba integer;
ALTER TABLE wpriloha ADD CONSTRAINT fk9a21406c483ac817 FOREIGN KEY (idosoba)
  REFERENCES posobahlav (idosobahlav) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX wPriloha_IdOsoba_index ON wPriloha USING btree (IdOsoba) WHERE idosoba is not null;


CREATE SEQUENCE seq_ppracestred
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracestred OWNER TO %firmaRole%;

CREATE TABLE ppracestred
(
  idpracestred integer DEFAULT nextval('seq_ppracestred'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  datumdo date,
  datumod date,
  hodin numeric(6,2),
  mesic smallint DEFAULT 0,
  poznam text,
  procento numeric(6,2) DEFAULT 0.0,
  rok integer,
  idcinnost integer,
  idosoba integer NOT NULL,
  idpracpom integer NOT NULL,
  idstredisko integer,
  idzakazka integer,
  CONSTRAINT ppracestred_pkey PRIMARY KEY (idpracestred),
  CONSTRAINT ppracestred_idpracpom FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idosoba FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idcinnost FOREIGN KEY (idcinnost)
      REFERENCES ucinnost (idcinnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idstredisko FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT ppracestred_idzakazka FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracestred OWNER TO %firmaRole%;

CREATE INDEX pPraceStred_IdOsoba_index ON pPraceStred USING btree (IdOsoba);
CREATE INDEX pPraceStred_IdPracPom_index ON pPraceStred USING btree (IdPracPom);
CREATE INDEX pPraceStred_IdStredisko_index ON pPraceStred USING btree (IdStredisko);
CREATE INDEX pPraceStred_IdZakazka_index ON pPraceStred USING btree (IdZakazka);
CREATE INDEX pPraceStred_IdCinnost_index ON pPraceStred USING btree (IdCinnost);


-- externi ID

CREATE SEQUENCE seq_wextid
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wextid OWNER TO %firmaRole%;

CREATE TABLE wExtId
(
  idExtId integer NOT NULL DEFAULT nextval('seq_wextid'::regclass),
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  extId character varying(127) NOT NULL,
  tabulka character varying(63) NOT NULL,

  idcenik integer,
  idadresar integer,
  iddoklobch integer,
  iddoklfak integer,
  iddoklsklad integer,
  iddoklint integer,
  idpolobch integer,
  idpolfak integer,
  idpolsklad integer,
  idpolint integer,
  idskladkarty integer,
  idkurz integer,
  idOdberatel integer,
  idDodavatel integer,
  idSady integer,
  idPoplatek integer,
  idPodobne integer,
  idKusovnik integer,
  idPriloha integer,
  idCenHlad integer,
  idStredisko integer,
  idCinnost integer,
  idMerJed integer,
  idVybKlic integer,
  idTypUcOp integer,
  idText integer,
  idAdrUdalost integer,
  idBanSpoj integer,
  idMistUrc integer,
  idKontakt integer,
  idSkupFir integer,
  idSkupZboz integer,
  idTypDokl integer,
  idMapSklad integer,
  idZakazka integer,
  idUcet integer,
  idReport integer,
  idUzel integer,
  idVazUzel integer,
  idSazbaDph integer,
  idBsp integer,
  idDotaz integer,
  idDotazParam integer,
  idDotazProp integer,
  idSmlouvy integer,
  idPolSml integer,
  idTypSml integer,
  idStavSml integer,
  idUzivatel integer,
  idTypAkt integer,
  idTypNaklAkt integer,
  idTypZakazky integer,
  idVazbaTyp integer,
  idVazba integer,
  idSkupVybKlic integer,
  idzastupnost integer,
  idCustomButton integer,

  idBanSpojMzdy integer,
  idDite integer,
  idNepritomnost integer,
  idOsoba integer,
  idOsobaHlav integer,
  idPracPom integer,
  idPracPomHlav integer,
  idSkupOsob integer,
  idSmeny integer,
  idSrazka integer,
  idStalaMzdSloz integer,
  idPraceStred integer,
  idmzdsloz integer,

  idTypMaj integer,
  idMajetek integer,
  idTypLeas integer,
  idLeasing integer,
  idUmisteni integer,

  CONSTRAINT wextid_pkey PRIMARY KEY (idExtId),

  CONSTRAINT wextid_idcenik FOREIGN KEY (idcenik)
      REFERENCES ccenik(idcenik) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idadresar FOREIGN KEY (idadresar)
      REFERENCES aadresar(idfirmy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_iddoklobch FOREIGN KEY (iddoklobch)
      REFERENCES ddoklobch(iddoklobch) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_iddoklfak FOREIGN KEY (iddoklfak)
      REFERENCES ddoklfak(iddoklfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_iddoklsklad FOREIGN KEY (iddoklsklad)
      REFERENCES ddoklsklad(iddoklsklad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_iddoklint FOREIGN KEY (iddoklint)
      REFERENCES ddoklint(iddoklint) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idpolobch FOREIGN KEY (idpolobch)
      REFERENCES dpolobch(idpolobch) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idpolfak FOREIGN KEY (idpolfak)
      REFERENCES dpolfak(idpolfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idpolsklad FOREIGN KEY (idpolsklad)
      REFERENCES dpolsklad(idpolsklad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idpolint FOREIGN KEY (idpolint)
      REFERENCES dpolint(idpolint) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idskladkarty FOREIGN KEY (idskladkarty)
      REFERENCES skarty (idkarty) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idkurz FOREIGN KEY (idkurz)
      REFERENCES ukurzy (idkurzy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idOdberatel FOREIGN KEY (idOdberatel)
      REFERENCES codberatele (idodberatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idDodavatel FOREIGN KEY (idDodavatel)
      REFERENCES cdodavatele (iddodavatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idSady FOREIGN KEY (idSady)
      REFERENCES csady (idsady) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idPoplatek FOREIGN KEY (idPoplatek)
      REFERENCES cpoplatky (idPoplatek) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idPodobne FOREIGN KEY (idPodobne)
      REFERENCES cpodobne (idpodobne) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idKusovnik FOREIGN KEY (idKusovnik)
      REFERENCES ckusovnik (idkusovnik) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idPriloha FOREIGN KEY (idPriloha)
      REFERENCES wpriloha (idpriloha) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idCenHlad FOREIGN KEY (idCenHlad)
      REFERENCES ccenhlad (idcenhlad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idStredisko FOREIGN KEY (idStredisko)
      REFERENCES ustrediska (idStred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idCinnost FOREIGN KEY (idCinnost)
      REFERENCES ucinnost (idCinnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idMerJed FOREIGN KEY (idMerJed)
      REFERENCES cmerjed (idmj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idVybKlic FOREIGN KEY (idVybKlic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idTypUcOp FOREIGN KEY (idTypUcOp)
      REFERENCES utypucop (idtypucop) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idText FOREIGN KEY (idText)
      REFERENCES wtexty (idtext) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idAdrUdalost FOREIGN KEY (idAdrUdalost)
      REFERENCES audalosti (idudalost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idBanSpoj FOREIGN KEY (idBanSpoj)
      REFERENCES abanSpoj (idBanSpoj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idMistUrc FOREIGN KEY (idMistUrc)
      REFERENCES amisturc (idmur) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idKontakt FOREIGN KEY (idKontakt)
      REFERENCES aKontakty (idkontakt) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idSkupFir FOREIGN KEY (idSkupFir)
      REFERENCES askupfir (idskupfir) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idSkupZboz FOREIGN KEY (idSkupZboz)
      REFERENCES cskupzboz (idskupzboz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idTypDokl FOREIGN KEY (idTypDokl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idMapSklad FOREIGN KEY (idMapSklad)
      REFERENCES smapsklad (idmapSklad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idZakazka FOREIGN KEY (idZakazka)
      REFERENCES uzakazky (idZakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idUcet FOREIGN KEY (idUcet)
      REFERENCES uucty (iducet) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idreport FOREIGN KEY (idreport)
      REFERENCES wreport (idreport) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idUzel FOREIGN KEY (idUzel)
      REFERENCES wuzel (idUzel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idVazUzel FOREIGN KEY (idVazUzel)
      REFERENCES wvazuzel (idVazUzel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idSazbaDph FOREIGN KEY (idSazbaDph)
      REFERENCES uSazbyDph (idSazbyDph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idBsp FOREIGN KEY (idBsp)
      REFERENCES dBsp (idBsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idDotaz FOREIGN KEY (idDotaz)
      REFERENCES wDotazy (idDotaz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idDotazParam FOREIGN KEY (idDotazParam)
      REFERENCES wDotazyParam (idDotazParam) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idDotazProp FOREIGN KEY (idDotazProp)
      REFERENCES wDotazyProp (idDotazProp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idSmlouva FOREIGN KEY (idSmlouvy)
      REFERENCES dSmlouvy(idSmlouvy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idPolSmlouvy FOREIGN KEY (idPolSml)
      REFERENCES dPolSml(idPolSml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idTypSml FOREIGN KEY (idTypSml)
      REFERENCES dTypSml(idTypSml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idStavSml FOREIGN KEY (idStavSml)
      REFERENCES dStavSml(idStavSml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idUzivatel FOREIGN KEY (idUzivatel)
      REFERENCES wUzivatel (idUzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,      
  CONSTRAINT wextid_idTypAkt FOREIGN KEY (idTypAkt)
      REFERENCES aTypAkt (idTypAkt) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idTypNaklAkt FOREIGN KEY (idTypNaklAkt)
      REFERENCES aTypNaklAkt (idTypNaklAkt) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idTypZakazky FOREIGN KEY (idTypZakazky)
      REFERENCES uTypZakazky (idTypZakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idVazbaTyp FOREIGN KEY (idVazbaTyp)
      REFERENCES wvazbatyp(idvazbatyp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idVazba FOREIGN KEY (idVazba)
      REFERENCES wvazba(idvazba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idskupvybklic FOREIGN KEY (idskupvybklic)
      REFERENCES wskupvybklic(idskupvybklic) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idzastupnost FOREIGN KEY (idzastupnost)
      REFERENCES wzastupnosti (idzastupnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,
  CONSTRAINT wextid_idCustomButton FOREIGN KEY (idCustomButton)
      REFERENCES wcustbutton (idwcustbutton) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE,

  CONSTRAINT wextid_idBanSpojMzdy FOREIGN KEY (idBanSpojMzdy)
      REFERENCES aBanSpoj(idBanSpoj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idDite FOREIGN KEY (idDite)
      REFERENCES pDite(idDite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idNepritomnost FOREIGN KEY (idNepritomnost)
      REFERENCES pNepritomnost(idNepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idOsoba FOREIGN KEY (idOsoba)
      REFERENCES pOsoba(idOsoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idOsobaHlav FOREIGN KEY (idOsobaHlav)
      REFERENCES pOsobaHlav(idOsobaHlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idPracPom FOREIGN KEY (idPracPom)
      REFERENCES pPracPom(idPracPom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idPracPomHlav FOREIGN KEY (idPracPomHlav)
      REFERENCES pPracPomHlav(idPracPomHlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idSkupOsob FOREIGN KEY (idSkupOsob)
      REFERENCES pSkupOsob(idSkupOsob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idSmeny FOREIGN KEY (idSmeny)
      REFERENCES pSmeny(idSmeny) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idSrazka FOREIGN KEY (idSrazka)
      REFERENCES pSrazka(idSrazka) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idStalaMzdSloz FOREIGN KEY (idStalaMzdSloz)
      REFERENCES pStalaMzdSloz(idStalaMzdSloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idPraceStred FOREIGN KEY (idPraceStred)
      REFERENCES pPraceStred (idPraceStred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idmzdsloz FOREIGN KEY (idmzdsloz)
      REFERENCES  pmzdsloz(idmzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,

  CONSTRAINT wextid_idTypMaj FOREIGN KEY (idTypMaj)
      REFERENCES mTypMaj(idTypMaj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idMajetek FOREIGN KEY (idMajetek)
      REFERENCES mMajetek(idMajetku) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idTypLeas FOREIGN KEY (idTypLeas)
      REFERENCES mTypLeas(idTypLeas) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idLeasing FOREIGN KEY (idLeasing)
      REFERENCES mLeasing(idLeasing) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,
  CONSTRAINT wextid_idUmisteni FOREIGN KEY (idUmisteni)
      REFERENCES mUmisteni(idUmisteni) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade,

  CONSTRAINT cExtId_unique_key UNIQUE (extId,tabulka)
);
ALTER table wextid owner to %firmaRole%;

CREATE INDEX wExtId_IdAdresar_index ON wExtId USING btree (IdAdresar) WHERE IdAdresar is not null;
CREATE INDEX wExtId_IdCenik_index ON wExtId USING btree (IdCenik) WHERE IdCenik is not null;
CREATE INDEX wExtId_IdDoklFak_index ON wExtId USING btree (IdDoklFak) WHERE IdDoklFak is not null;
CREATE INDEX wExtId_IdDoklInt_index ON wExtId USING btree (IdDoklInt) WHERE IdDoklInt is not null;
CREATE INDEX wExtId_IdDoklObch_index ON wExtId USING btree (IdDoklObch) WHERE IdDoklObch is not null;
CREATE INDEX wExtId_IdDoklSklad_index ON wExtId USING btree (IdDoklSklad) WHERE IdDoklSklad is not null;
CREATE INDEX wExtId_IdKurz_index ON wExtId USING btree (IdKurz) WHERE IdKurz is not null;
CREATE INDEX wExtId_IdPolFak_index ON wExtId USING btree (IdPolFak) WHERE IdPolFak is not null;
CREATE INDEX wExtId_IdPolInt_index ON wExtId USING btree (IdPolInt) WHERE IdPolInt is not null;
CREATE INDEX wExtId_IdPolObch_index ON wExtId USING btree (IdPolObch) WHERE IdPolObch is not null;
CREATE INDEX wExtId_IdPolSklad_index ON wExtId USING btree (IdPolSklad) WHERE IdPolSklad is not null;
CREATE INDEX wExtId_IdSkladKarty_index ON wExtId USING btree (IdSkladKarty) WHERE IdSkladKarty is not null;
CREATE INDEX wExtId_IdOdberatel_index ON wExtId USING btree (IdOdberatel) WHERE IdOdberatel is not null;
CREATE INDEX wExtId_IdDodavatel_index ON wExtId USING btree (IdDodavatel) WHERE IdDodavatel is not null;
CREATE INDEX wExtId_IdSady_index ON wExtId USING btree (IdSady) WHERE IdSady is not null;
CREATE INDEX wExtId_IdPoplatek_index ON wExtId USING btree (IdPoplatek) WHERE IdPoplatek is not null;
CREATE INDEX wExtId_IdPodobne_index ON wExtId USING btree (IdPodobne) WHERE IdPodobne is not null;
CREATE INDEX wExtId_IdKusovnik_index ON wExtId USING btree (IdKusovnik) WHERE IdKusovnik is not null;
CREATE INDEX wExtId_IdPriloha_index ON wExtId USING btree (IdPriloha) WHERE IdPriloha is not null;
CREATE INDEX wExtId_IdCenHlad_index ON wExtId USING btree (IdCenHlad) WHERE IdCenHlad is not null;
CREATE INDEX wExtId_IdStredisko_index ON wExtId USING btree (IdStredisko) WHERE IdStredisko is not null;
CREATE INDEX wExtId_IdCinnost_index ON wExtId USING btree (IdCinnost) WHERE IdCinnost is not null;
CREATE INDEX wExtId_IdMerJed_index ON wExtId USING btree (IdMerJed) WHERE IdMerJed is not null;
CREATE INDEX wExtId_IdVybKlic_index ON wExtId USING btree (IdVybKlic) WHERE IdVybKlic is not null;
CREATE INDEX wExtId_IdTypUcOp_index ON wExtId USING btree (IdTypUcOp) WHERE IdTypUcOp is not null;
CREATE INDEX wExtId_IdText_index ON wExtId USING btree (IdText) WHERE IdText is not null;
CREATE INDEX wExtId_IdAdrUdalost_index ON wExtId USING btree (IdAdrUdalost) WHERE IdAdrUdalost is not null;
CREATE INDEX wExtId_IdBanSpoj_index ON wExtId USING btree (IdBanSpoj) WHERE IdBanSpoj is not null;
CREATE INDEX wExtId_IdMistUrc_index ON wExtId USING btree (IdMistUrc) WHERE IdMistUrc is not null;
CREATE INDEX wExtId_IdKontakt_index ON wExtId USING btree (IdKontakt) WHERE IdKontakt is not null;
CREATE INDEX wExtId_IdSkupFir_index ON wExtId USING btree (IdSkupFir) WHERE IdSkupFir is not null;
CREATE INDEX wExtId_IdSkupZboz_index ON wExtId USING btree (IdSkupZboz) WHERE IdSkupZboz is not null;
CREATE INDEX wExtId_IdTypDokl_index ON wExtId USING btree (IdTypDokl) WHERE IdTypDokl is not null;
CREATE INDEX wExtId_IdMapSklad_index ON wExtId USING btree (IdMapSklad) WHERE IdMapSklad is not null;
CREATE INDEX wExtId_IdZakazka_index ON wExtId USING btree (IdZakazka) WHERE IdZakazka is not null;
CREATE INDEX wExtId_IdUcet_index ON wExtId USING btree (IdUcet) WHERE IdUcet is not null;
CREATE INDEX wExtId_IdReport_index ON wExtId USING btree (IdReport) WHERE IdReport is not null;
CREATE INDEX wExtId_IdUzel_index ON wExtId USING btree (IdUzel) WHERE IdUzel is not null;
CREATE INDEX wExtId_IdVazUzel_index ON wExtId USING btree (IdVazUzel) WHERE IdVazUzel is not null;
CREATE INDEX wExtId_IdSazbyDph_index ON wExtId USING btree (idSazbaDph) WHERE idSazbaDph is not null;
CREATE INDEX wExtId_IdBsp_index ON wExtId USING btree (idBsp) WHERE idBsp is not null;
CREATE INDEX wExtId_IdDotaz_index ON wExtId USING btree (idDotaz) WHERE idDotaz is not null;
CREATE INDEX wExtId_IdDotazParam_index ON wExtId USING btree (idDotazParam) WHERE idDotazParam is not null;
CREATE INDEX wExtId_IdDotazProp_index ON wExtId USING btree (idDotazProp) WHERE idDotazProp is not null;
CREATE INDEX wExtId_IdSmlouvy_index ON wExtId USING btree (idSmlouvy) WHERE idSmlouvy is not null;
CREATE INDEX wExtId_IdPolSml_index ON wExtId USING btree (idPolSml) WHERE idPolSml is not null;
CREATE INDEX wExtId_IdTypSml_index ON wExtId USING btree (idTypSml) WHERE idTypSml is not null;
CREATE INDEX wExtId_IdStavSml_index ON wExtId USING btree (idStavSml) WHERE idStavSml is not null;
CREATE INDEX wExtId_IdUzivatel_index ON wExtId USING btree (idUzivatel) WHERE idUzivatel is not null;
CREATE INDEX wExtId_IdTypAkt_index ON wExtId USING btree (idTypAkt) WHERE idTypAkt is not null;
CREATE INDEX wExtId_IdTypNaklAkt_index ON wExtId USING btree (idTypNaklAkt) WHERE idTypNaklAkt is not null;
CREATE INDEX wExtId_IdTypZakazky_index ON wExtId USING btree (idTypZakazky) WHERE idTypZakazky is not null;
CREATE INDEX wExtId_IdVazbaTyp_index ON wExtId USING btree (IdVazbaTyp) WHERE IdVazbaTyp is not null;
CREATE INDEX wExtId_IdVazba_index ON wExtId USING btree (IdVazba) WHERE IdVazba is not null;
CREATE INDEX wExtId_IdSkupVybKlic_index ON wExtId USING btree (IdSkupVybKlic) WHERE IdSkupVybKlic is not null;
CREATE INDEX wextid_idzastupnost_index ON wextid USING btree (idzastupnost) WHERE idzastupnost is not null;
CREATE INDEX wExtId_IdCustomButton_index ON wExtId USING btree (IdCustomButton) WHERE IdCustomButton is not null;

CREATE INDEX wExtId_IdBanSpojMzdy_index ON wExtId USING btree (idBanSpojMzdy) WHERE idBanSpojMzdy is not null;
CREATE INDEX wExtId_IdDite_index ON wExtId USING btree (idDite) WHERE idDite is not null;
CREATE INDEX wExtId_IdNepritomnost_index ON wExtId USING btree (idNepritomnost) WHERE idNepritomnost is not null;
CREATE INDEX wExtId_IdOsoba_index ON wExtId USING btree (idOsoba) WHERE idOsoba is not null;
CREATE INDEX wExtId_IdOsobaHlav_index ON wExtId USING btree (idOsobaHlav) WHERE idOsobaHlav is not null;
CREATE INDEX wExtId_IdPracPom_index ON wExtId USING btree (idPracPom) WHERE idPracPom is not null;
CREATE INDEX wExtId_IdPracPomHlav_index ON wExtId USING btree (idPracPomHlav) WHERE idPracPomHlav is not null;
CREATE INDEX wExtId_IdSkupOsob_index ON wExtId USING btree (idSkupOsob) WHERE idSkupOsob is not null;
CREATE INDEX wExtId_IdSmeny_index ON wExtId USING btree (idSmeny) WHERE idSmeny is not null;
CREATE INDEX wExtId_IdSrazka_index ON wExtId USING btree (idSrazka) WHERE idSrazka is not null;
CREATE INDEX wExtId_IdStalaMzdSloz_index ON wExtId USING btree (idStalaMzdSloz) WHERE idStalaMzdSloz is not null;
CREATE INDEX wExtId_IdPraceStred_index ON wExtId USING btree (idPraceStred) WHERE idPraceStred is not null;
CREATE INDEX wExtId_IdMzdSloz_index ON wExtId USING btree (IdMzdSloz) WHERE IdMzdSloz is not null;

CREATE INDEX wExtId_IdTypMaj_index ON wExtId USING btree (idTypMaj) WHERE idTypMaj is not null;
CREATE INDEX wExtId_IdMajetek_index ON wExtId USING btree (idMajetek) WHERE idMajetek is not null;
CREATE INDEX wExtId_IdTypLeas_index ON wExtId USING btree (idTypLeas) WHERE idTypLeas is not null;
CREATE INDEX wExtId_IdLeasing_index ON wExtId USING btree (idLeasing) WHERE idLeasing is not null;
CREATE INDEX wExtId_IdUmisteni_index ON wExtId USING btree (idUmisteni) WHERE idUmisteni is not null;


CREATE INDEX wExtId_Tabulka_ExtId_index ON wExtId USING btree (Tabulka, upper(cast(ExtId AS text)));

--------------------------------------------------------------------------------
-- Bug 22323 – [winstrom] 8 - Mzdy - Náklady členit podle zakázek, zjemnění na více středisek
--------------------------------------------------------------------------------

-- funkce zjistujici zda jsou mzdy zamceny
CREATE OR REPLACE FUNCTION pismzdyzamek(rok integer, mesic integer)
  RETURNS boolean AS $$
declare
  zamku integer;
  calOd date;
  calDo date;
begin
  calOd = date (rok || '-' || mesic || '-01');
  calDo = calOd + interval '1 month' - interval '1 day';
  
  select count(*) into zamku from wzamky where modulmzd = true and zamekk in ('zamek.zamceno', 'zamek.polozamceno') and
    platiOdData <= calDo and platiDoData >= calOd;
  
  return (zamku > 0);
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pismzdyzamek(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pcantriggerchangeslozku(_rok integer, _mesic integer, _idosoba integer)
  RETURNS boolean AS $$
declare
  vypocet integer;
  zamku integer;
  calOd date;
  calDo date;
begin
  select count(*) into vypocet from pmzdsloz where idosoba = _idosoba and _rok = rok and _mesic = mesic and
    typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba' and datumod is not null;
  
  if (vypocet > 0) then    -- mzda je vypoctena nemuzeme ji menit
    return false;
  end if; 

  return not pismzdyzamek(_rok, _mesic);
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcantriggerchangeslozku(integer, integer, integer) OWNER TO %firmaRole%;



-- pro zadany pracovni pomer, mesic a rok vygeneruje smeny
CREATE OR REPLACE FUNCTION pgeneratesmenyforpracpom(_idpracpom integer, _rok integer, _mesic integer)
  RETURNS void AS $$
declare
  _pocatMes date;
  _pracpom record;
  _idsmeny integer;
  _den varchar;
  _mesicS varchar;
  _aktDatum date;
  _denTyden integer;
  _vysledek text;
  _smena integer;
  _smenaSvatek integer;
  _pocatSmeny integer;
  _konecSmeny integer;
  _svatku integer;
  _pracDni boolean[];
begin
  _pocatMes = date(_rok || '-' || _mesic || '-01');
  _mesicS = _mesic;
  if (length(_mesicS) < 2) then
    _mesicS = '0' || _mesicS;
  end if;
  
  select * into _pracpom from ppracpom where idpracpomhlav = _idpracpom and 
    (platiOd is null or platiOd <= _pocatMes) and (platiDo is null or platiDo >= _pocatMes) order by platiOd limit 1;
  
  if (_pracpom is null) then
    return;
  end if;
  
  select idsmeny, planovane into _idsmeny, _vysledek from psmeny where idpracpom = _idpracpom and rok = _rok and mesic = _mesic;
  
  if (_vysledek is null) then
    _vysledek = '';
  end if;
  
  if (_pracpom.pracrozvrhk = 'pracRozvrh.pravidelny') then
    _aktDatum = _pocatMes;
    _smena = 1;
    _smenaSvatek = 1;
    _vysledek = '';
    _pracDni = array[_pracpom.uvazpo, _pracpom.uvazut, _pracpom.uvazst, _pracpom.uvazct, _pracpom.uvazpa, _pracpom.uvazso, _pracpom.uvazne];
    while extract (month from _aktDatum) = _mesic loop
      _denTyden = extract (dow from _aktDatum);
      _den = extract (day from _aktDatum);
      if (length(_den) < 2) then
        _den = '0' || _den;
      end if;
      if _denTyden = 0 then _denTyden = 7; end if;       -- nedele je 7y den
      
      if (_pracDni[_denTyden] = true) then
        select count(*) into _svatku from pmzdyparam where klic = 'svatek' and 
            ((hodnota = _rok || '-' || _mesicS || '-' || _den) or (hodnota = 'XXXX-' || _mesicS || '-' || _den));
      
        if (length(_vysledek) > 0) then _vysledek = _vysledek || ';'; end if;  -- pripojime strednik mezi smeny
        
        _pocatSmeny = (extract (day from _aktDatum) - 1) * 1440 + cast((_pracpom.zacPracDoby * 60) as integer);
        _konecSmeny = _pocatSmeny + cast((60 * _pracpom.uvazHodDenne) as integer) - 1;
        
        if (_svatku = 0) then
          _vysledek = _vysledek || _smena;
          _smena = _smena + 1;
        else  
          _vysledek = _vysledek || 's' || _smenaSvatek;
          _smenaSvatek = _smenaSvatek + 1;
        end if;
        _vysledek = _vysledek || ':' || _pocatSmeny || ':' || _konecSmeny;
      end if;
      
      _aktDatum = _aktDatum + interval '1 day';
    end loop;
  
  end if;
  
  if (_idsmeny is null) then
    insert into psmeny (idosoba, idpracpom, rok, mesic, planovane)
      values (_pracpom.idosoba, _idpracpom, _rok, _mesic, _vysledek);
  else
    update psmeny set planovane = _vysledek where idpracpom = _idpracpom and rok = _rok and mesic = _mesic
      and not comparevarchar(planovane, _vysledek);
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratesmenyforpracpom(integer, integer, integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION pupdatemzdslozfromcis(_idMzdSloz integer, _idCis integer)
  RETURNS void AS $$
declare
  C record;
begin
  select * into C from pcismzdsloz where idcismzdsloz = _idCis;
  
  if (C.idcismzdsloz is not null) then
    update pmzdsloz set idcismzdsloz = _idCis, kod = C.kod, nazev = C.nazev, typslozkyk = C.typslozkyk, skupslozkyk = C.skupslozkyk, cisrad = C.cisrad, pracovni = C.pracovni,
      dnyPrac = C.dnyPrac, dnyKal = C.dnyKal, dnySvatek = C.dnySvatek, hodiny = C.hodiny, castkaHod = C.castkaHod, castkaDen = C.castkaDen, procMzd = C.procMzd, 
      zaklMzd = C.zaklMzd, zaklJeKracen = C.zaklJeKracen, castMzd = C.castMzd, zmenaCastMzd = C.zmenaCastMzd, pocetMes = C.pocetMes, cisDoklNem = C.cisDoklNem, 
      prumNaDenNem = C.prumNaDenNem, prumNaHodNem = C.prumNaHodNem, doplatZdravK = C.doplatZdravK where idmzdsloz = _idMzdSloz and (
           idcismzdsloz <> _idCis or kod <> C.kod or nazev <> C.nazev or typslozkyk <> C.typslozkyk or skupslozkyk <> C.skupslozkyk or
           not compareid(cisrad, C.cisrad) or pracovni <> C.pracovni or dnyPrac <> C.dnyPrac or dnyKal <> C.dnyKal or dnySvatek <> C.dnySvatek or
           hodiny <> C.hodiny or castkaHod <> C.castkaHod or castkaDen <> C.castkaDen or procMzd <> C.procMzd or zaklMzd <> C.zaklMzd or
           zaklJeKracen <> C.zaklJeKracen or castMzd <> C.castMzd or zmenaCastMzd <> C.zmenaCastMzd or not compareId(pocetMes, C.pocetMes) or
           not compareid(cisDoklNem, C.cisDoklNem) or prumNaDenNem <> C.prumNaDenNem or prumNaHodNem <> C.prumNaHodNem or
           not comparevarchar(doplatZdravK, C.doplatZdravK));
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromcis(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pupdatemzdslozfromsrazka(_idMzdSloz integer, _idSrazka integer)
  RETURNS void AS $$
declare
  S record;
begin
  select * into S from psrazka where idsrazka = _idSrazka;

  if (S.idsrazka is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, S.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> S.idcismzdsloz;
    -- preneseme data ze srazky
    update pmzdsloz set idsrazka = _idSrazka, kod = S.kod, nazev = S.nazev, poznam = S.poznam,
        procmzd = S.procmzd, skupslozkyk = S.skupslozkyk, typslozkyk = S.typslozkyk,
        castMzd = S.castka where idmzdsloz = _idMzdSloz and (
          not compareid(idsrazka, _idSrazka) or kod <> S.kod or nazev <> S.nazev or not comparevarchar(poznam, S.poznam) or
          procmzd <> S.procmzd or skupslozkyk <> S.skupslozkyk or typslozkyk <> S.typslozkyk or castMzd <> S.castka);
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromsrazka(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pupdatemzdslozfromstalasloz(_idMzdSloz integer, _idStalaSloz integer)
  RETURNS void AS $$
declare
  S record;
  Cis record;
  pomSl record;
  Cpom record;
  _idslozpom integer;
  slozS record;
begin
  select * into S from pstalamzdsloz where idstalamzdsloz = _idStalaSloz;
  select * into Cis from pcismzdsloz where idcismzdsloz = S.idcismzdsloz;

  if (S.idstalamzdsloz is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, S.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> S.idcismzdsloz;
    -- preneseme data ze stale mzdove slozky
    update pmzdsloz set idstalamzdsloz = _idStalaSloz,
        castkaden = S.castkaden, castkahod = S.castkahod, kod = S.kod, nazev = S.nazev, pocetmes = S.pocetmes, poznam = S.poznam,
        procmzd = S.procmzd, skupslozkyk = S.skupslozkyk, typslozkyk = S.typslozkyk, zakljekracen = S.zakljekracen, zaklmzd = S.zaklmzd,
        castmzd = S.castmzd, dnykal = S.dnykal, dnyprac = S.dnyprac, dnysvatek = S.dnysvatek, hodiny = S.hodiny, hodinysvatek = S.hodinysvatek,
        prumnadennem = S.prumnadennem, prumnahodnem = S.prumnahodnem,
        idstredisko = S.idstredisko, idzakazka = S.idzakazka
  -- NEW.podil, NEW.typpodilk,
      where idmzdsloz = _idMzdSloz and (not compareid(idstalamzdsloz, _idStalaSloz) or
        castkaHod <> S.castkaHod or castkaDen <> S.castkaDen or kod = S.kod or nazev = S.nazev or
        not compareId(pocetMes, S.pocetMes) or not comparevarchar(poznam, S.poznam) or procMzd <> S.procMzd or
        skupslozkyk <> S.skupslozkyk or typslozkyk <> S.typslozkyk or zaklMzd <> S.zaklMzd or zaklJeKracen <> S.zaklJeKracen or
        castMzd <> S.castMzd or dnykal <> S.dnykal or dnyprac <> S.dnyprac or dnysvatek <> S.dnysvatek or hodiny <> S.hodiny or
        hodinysvatek <> S.hodinysvatek or prumnadennem <> S.prumnadennem or prumnahodnem <> S.prumnahodnem or
        not compareid(idstredisko, S.idstredisko) or not compareid(idzakazka, S.idzakazka));
        
        -- nastavení částky pomocné složce pro odměny
        select * into pomSl from pmzdsloz where idodmena = _idMzdsloz;
        if Cis.uuid = 'MIMORADNA_ODM.VICE_M' or Cis.uuid = 'MIMORADNA ODMENA' then
          
          if (pomSl.idmzdsloz is not null) then
            update pmzdsloz set castMzd = S.castMzd, zaklMzd = S.castMzd where idOdmena = _idMzdSloz;
          else
            select * into slozS from pmzdsloz where idmzdsloz = _idMzdSloz;
            select * into Cpom from pcismzdsloz where uuid = 'POM.SLOZ.ODM-VM'; 
            select nextval('seq_pmzdsloz') into _idslozpom; 
            insert into pmzdsloz (idmzdsloz, idosoba, idpracpom, rok, mesic, idcismzdsloz, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni, dnyPrac, dnyKal, dnySvatek, hodiny, castkaHod, castkaDen, procMzd, zaklMzd, zaklJeKracen, castMzd, zmenaCastMzd, pocetMes, cisDoklNem, prumNaDenNem, prumNaHodNem, doplatZdravK, idOdmena) 
              values (_idslozpom, slozS.idosoba, slozS.idPracPom, slozS.rok, slozS.mesic, Cpom.idcismzdsloz, Cpom.kod, Cpom.nazev, Cpom.typslozkyk, Cpom.skupslozkyk, Cpom.cisrad, Cpom.pracovni, Cpom.dnyPrac, Cpom.dnyKal, Cpom.dnySvatek, Cpom.hodiny, Cpom.castkaHod, Cpom.castkaDen, Cpom.procMzd, S.zaklMzd, Cpom.zaklJeKracen, S.castMzd, true, 1, Cpom.cisDoklNem, Cpom.prumNaDenNem, Cpom.prumNaHodNem, Cpom.doplatZdravK, _idMzdSloz);
          end if;
          
        else 
           if (pomSl.idmzdsloz is not null) then
               delete from pmzdsloz where idmzdsloz = pomSl.idmzdsloz;
           end if;
        end if;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromstalasloz(integer, integer) OWNER TO %firmaRole%;


-- pro zadany pracovni pomer, mesic a rok vygeneruje mzdove slozky
CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpomandmesic(_idpracpom integer, _rok integer, _mesic integer)
  RETURNS void AS $$
declare
  _datum date;
  _datumpo date;
  _idosoba integer;
  _change boolean;
begin
  _datum = date (_rok || '-' || _mesic || '-01');
  _datumpo = _datum + interval '1 month';
  
  select idosoba, pcantriggerchangeslozku(_rok, _mesic, idosoba) into _idosoba, _change from ppracpomhlav where idpracpomhlav = _idpracpom;

  -- vystupni slozky
  -- jiz se negeneruji, vytvari se pri vypoctu
  
  if (_change) then  
    -- stale slozky
    perform pupdatemzdslozfromstalasloz(pcreatemzdslozfromcis(idcismzdsloz, _idpracpom, _idosoba, _rok, _mesic), idstalamzdsloz)
      from pstalamzdsloz as S where idpracpom = _idpracpom
        and (datumod is null or (datumod < _datumpo)) and (datumdo is null or (datumdo >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idstalamzdsloz = S.idstalamzdsloz) = 0;
  
    -- srazky
    perform pupdatemzdslozfromsrazka(pcreatemzdslozfromcis(idcismzdsloz, null, _idosoba, _rok, _mesic), idsrazka)
      from psrazka as S where idosoba = _idosoba
        and (srazkaod is null or (srazkaod < _datumpo)) and (srazkado is null or (srazkado >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idsrazka = S.idsrazka) = 0;
  end if;
  
  -- smeny
  perform pgeneratesmenyforpracpom(_idpracpom, _rok, _mesic);
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpomandmesic(integer, integer, integer) OWNER TO %firmaRole%;


-- vygeneruje mzdove slozky pro zadany pracovni pomer, pokud je id -1 generuje pro vsechny
CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpom(_idpracpom integer)
  RETURNS void AS $$
begin
  perform pgeneratemzdslozforpracpom(_idpracpom, -1);
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpom(_idpracpom integer, _iducetobd integer)
  RETURNS void AS $$
declare
  _od date;
  _do date;
  _odAkt date;
  rokod integer;
  rokdo integer;
  mesicod integer;
  mesicdo integer;
  rokOdAkt integer;
  mesicOdAkt integer;
  
  mesforod integer;
  mesfordo integer;
  aktrok integer;
  aktmesic integer;
  aktdatum date;
  _idOsoba integer;
begin
  select min(platioddata), max(platidodata) into _od, _do from nucetobdobi;
  rokod = date_part('year', _od);
  rokdo = date_part('year', _do);
  mesicod = date_part('month', _od);
  mesicdo = date_part('month', _do);
  
  if  (_idpracpom > -1) then        -- pokud delame jenom jeden pracovni pomer delame smeny i mimo obdobi
    select aktivniod, idosoba into _odAkt, _idOsoba from ppracpomhlav where idpracpomhlav = _idpracpom;
    rokOdAkt = date_part('year', _odAkt);
    mesicOdAkt = date_part('month', _odAkt);
    
    for aktrok in rokOdAkt..rokod loop
      mesforod = 1;
      mesfordo = 12;
      if (aktrok = rokOdAkt) then
        mesforod = mesicOdAkt;
      end if;  
      if (aktrok = rokod) then
        mesfordo = mesicod - 1;
      end if;
    
      -- a mesice
      for aktmesic in mesforod..mesfordo loop
        if (not pismzdyzamek(aktrok, aktmesic)) then
          -- smeny
          perform pgeneratesmenyforpracpom(_idpracpom, aktrok, aktmesic) where pcantriggerchangeslozku(aktrok, aktmesic, _idOsoba);
        end if;
      end loop;
    end loop;
  end if; 
  
  -- vymazeme nadbytecne
  delete from pmzdsloz where (rok < rokod or (rok = rokod and mesic < mesicod)) or (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  delete from psmeny where (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  
  -- pokud se meni ucetni obdobi generujeme jen v nem
  if (_iducetobd > -1) then
    select platioddata, platidodata into _od, _do from nucetobdobi where iducetobdobi = _iducetobd;
    if (_od is null) then   -- jsme zde protoze se obdobi smazalo, coz zatim sice neumime ale co kdyby nekdy
      return;               -- pak neni co generovat
    end if;
    
    rokod = date_part('year', _od);
    rokdo = date_part('year', _do);
    mesicod = date_part('month', _od);
    mesicdo = date_part('month', _do);
  end if;
  
  -- prochazime roky
  for aktrok in rokod..rokdo loop
    mesforod = 1;
    mesfordo = 12;
    if (aktrok = rokod) then
      mesforod = mesicod;
    end if;  
    if (aktrok = rokdo) then
      mesfordo = mesicdo;
    end if;
    
    -- a mesice
    for aktmesic in mesforod..mesfordo loop
      if (not pismzdyzamek(aktrok, aktmesic)) then
        aktdatum = date (aktrok || '-' || aktmesic || '-01');
      
        perform pgeneratemzdslozforpracpomandmesic(idpracpomhlav, aktrok, aktmesic) from ppracpomhlav where
          (_idpracpom = -1 or idpracpomhlav = _idpracpom) and (aktivnido is null or aktdatum <= aktivnido) and 
          (aktivniod is null or date_part('year', aktivniod) < aktrok or (date_part('year', aktivniod) = aktrok and date_part('month', aktivniod) <= aktmesic));
      end if;
    end loop;
  end loop;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer, integer) OWNER TO %firmaRole%;


-- nastavi slozky vznikle ze stalych mzdovych slozek a srazek do spravneho stavu
CREATE OR REPLACE FUNCTION popravslozkypromesic(_rok integer, _mesic integer, _idosoba integer)
  RETURNS void AS $$
declare aktdatum date;
        datumpo date;
begin
  aktdatum = date (_rok || '-' || _mesic || '-01');
  datumpo = aktdatum + interval '1 month';

  -- smazeme jiz nepotrebne
  delete from pmzdsloz as M using pstalamzdsloz as S where M.idstalamzdsloz = S.idstalamzdsloz
    and M.idstalamzdsloz is not null and M.rok = _rok and M.mesic = _mesic and (_idosoba = -1 or M.idosoba = _idosoba) and
      not ((S.datumod is null or (S.datumod < datumpo)) and (S.datumdo is null or (S.datumdo >= aktdatum)));

  delete from pmzdsloz as M using psrazka as S where M.idsrazka = S.idsrazka
    and M.idsrazka is not null and M.rok = _rok and M.mesic = _mesic and (_idosoba = -1 or M.idosoba = _idosoba) and
      not ((S.srazkaod is null or (S.srazkaod < datumpo)) and (S.srazkado is null or (S.srazkado >= aktdatum)));

  -- nastavime aktualni hodnoty
  perform pupdatemzdslozfromstalasloz(idmzdsloz, idstalamzdsloz) from pmzdsloz as S where
    rok = _rok and mesic = _mesic and idstalamzdsloz is not null and (_idosoba = -1 or idosoba = _idosoba)
    and zmenaCastMzd = false and zmenaCasu = false;                             -- TODO asi by chtelo do budoucna rozlisit ktera pole nastavit na vychozi hodnotu a ktera ne

  perform pupdatemzdslozfromsrazka(idmzdsloz, idsrazka) from pmzdsloz as S where 
    rok = _rok and mesic = _mesic and idsrazka is not null and (_idosoba = -1 or idosoba = _idosoba)
    and zmenaCastMzd = false and zmenaCasu = false;                             -- TODO asi by chtelo do budoucna rozlisit ktera pole nastavit na vychozi hodnotu a ktera ne
  
  -- vygenerujeme chybejici slozky
  perform pupdatemzdslozfromstalasloz(pcreatemzdslozfromcis(idcismzdsloz, idpracpom, S.idosoba, _rok, _mesic), idstalamzdsloz)
    from pstalamzdsloz as S inner join ppracpomhlav as P on P.idpracpomhlav = S.idpracpom
    where (_idosoba = -1 or S.idosoba = _idosoba)
      and (aktivniod is null or aktivniod < datumpo) and (aktivnido is null or aktdatum <= aktivnido)
      and (datumod is null or (datumod < datumpo)) and (datumdo is null or (datumdo >= aktdatum))
      and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idstalamzdsloz = S.idstalamzdsloz) = 0;

  perform pupdatemzdslozfromsrazka(pcreatemzdslozfromcis(idcismzdsloz, null, S.idosoba, _rok, _mesic), idsrazka)
    from psrazka as S inner join ppracpomhlav as P on P.idosoba = S.idosoba
    where (_idosoba = -1 or S.idosoba = _idosoba)
      and (aktivniod is null or aktivniod < datumpo) and (aktivnido is null or aktdatum <= aktivnido)
      and (srazkaod is null or (srazkaod < datumpo)) and (srazkado is null or (srazkado >= aktdatum))
      and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idsrazka = S.idsrazka) = 0
    limit 1;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.popravslozkypromesic(integer, integer, integer) OWNER TO %firmaRole%;


-- trigger prenasejici datumy aktivnosti pracovniho pomeru z jednoho nastaveni na ostatni a na hlavicku
CREATE OR REPLACE FUNCTION ppracpomupdateaktivni()
  RETURNS trigger AS $$
begin
  update ppracpomhlav set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  update ppracpom set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  if (NEW.platido is null) then
    update ppracpomhlav set kod = NEW.kod, nazev = NEW.nazev, hlavni = NEW.hlavni where idpracpomhlav = NEW.idpracpomhlav 
      and (kod <> NEW.kod or nazev <> NEW.nazev or hlavni <> NEW.hlavni);
  end if;
  
  -- pokud vkladame nove nastaveni nebo doslo ke zmene bez zmeny datumu aktivnosti zkontrolujeme smeny
  if (tg_op = 'INSERT') then
    perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  end if;
  if (tg_op = 'UPDATE') then
   if not (((OLD.aktivniod is null) <> (NEW.aktivniod is null)) or (OLD.aktivniod is not null and OLD.aktivniod <> NEW.aktivniod) or
       ((OLD.aktivnido is null) <> (NEW.aktivnido is null)) or (OLD.aktivnido is not null and OLD.aktivnido <> NEW.aktivnido)) then
      perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomupdateaktivni() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomupdateaktivni AFTER INSERT OR UPDATE ON ppracpom
  FOR EACH ROW EXECUTE PROCEDURE ppracpomupdateaktivni();


-- trigger generujici mzdove slozky pri uprave pracovnich pomeru
CREATE OR REPLACE FUNCTION ppracpomhlavupdatemzdsloz()
  RETURNS trigger AS $$
declare
  nullcount integer;
  _rok integer;
  _mesic integer;
  _idSmena integer;
  pregenSmenuRok integer;
  pregenSmenuMesic integer;
  pregenSmenuOd date;
  pregenSmenuDo date;
begin
  -- vymazeme nadbytecne slozky pro pracovni pomer
  if (NEW.aktivniod is not null) then
    _rok = date_part('year', NEW.aktivniod);
    _mesic = date_part('month', NEW.aktivniod);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.aktivnido is not null) then
    _rok = date_part('year', NEW.aktivnido);
    _mesic = date_part('month', NEW.aktivnido);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vymazeme nadbytecne spolecne slozky
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivniod is null;
  if nullcount = 0 then
    select date_part('year', min(aktivniod)), date_part('month', min(aktivniod)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivnido is null;
  if nullcount = 0 then
    select date_part('year', max(aktivnido)), date_part('month', max(aktivnido)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vygenerujeme chybejici
  perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  
  if (tg_op = 'UPDATE') then       -- pri zmene aktivni od/do zjistime jesteli neni potreba pregenerovat nejaky mesic, kvuli dobe kdy nepracuje
    -- zkontrolujeme zda se nezmenil zacatek pomeru a neni treba neco pregenerovat
    if (comparedate(NEW.zacatek, OLD.zacatek) = false) then
      pregenSmenuRok = 0;
      pregenSmenuMesic = 0;
      
      if (NEW.zacatek is null) then
        if extract(day from OLD.zacatek) > 1 then
          pregenSmenuRok = extract(year from OLD.zacatek);
          pregenSmenuMesic = extract(month from OLD.zacatek);
        end if;
      end if;
      if (OLD.zacatek is null) then
        if extract(day from NEW.zacatek) > 1 then
          pregenSmenuRok = extract(year from NEW.zacatek);
          pregenSmenuMesic = extract(month from NEW.zacatek);
        end if;
      end if;
      if NEW.zacatek is not null and OLD.zacatek is not null then
        if (extract(month from NEW.zacatek) = extract(month from OLD.zacatek) and extract(year from NEW.zacatek) = extract(year from OLD.zacatek)) then
          pregenSmenuRok = extract(year from NEW.zacatek);       -- zmenil se den pocatku ale mesic zustal
          pregenSmenuMesic = extract(month from NEW.zacatek);
        else
          if (extract(day from OLD.zacatek) > 1 and (extract(month from NEW.zacatek) < extract(month from OLD.zacatek) or extract(year from NEW.zacatek) < extract(year from OLD.zacatek))) then
            pregenSmenuRok = extract(year from NEW.zacatek);    -- stary den pocatku neni 1 a mesic se posunul v case dozadu - tj mesic existule ale uz je tam celej
            pregenSmenuMesic = extract(month from NEW.zacatek);
          end if;
          if (extract(day from NEW.zacatek) > 1 and (extract(month from NEW.zacatek) > extract(month from OLD.zacatek) or extract(year from NEW.zacatek) > extract(year from OLD.zacatek))) then
            pregenSmenuRok = extract(year from NEW.zacatek);    -- novy den pocatku neni 1 a mesic se posunul v case dopredu - tj mesic existuje ale meni se
            pregenSmenuMesic = extract(month from NEW.zacatek);
          end if;
        end if;
      end if;
      
      if pregenSmenuMesic > 0 then
        select idsmeny into _idSmena from psmeny where idpracpom = NEW.idpracpomhlav and rok = pregenSmenuRok and mesic = pregenSmenuMesic;
        if _idSmena is not null then
          perform pcreatemzdslozforsmeny(_idSmena);
        end if;
      end if;
    end if;
    
    -- zkontrolujeme zda se nezmenil konec pomeru a neni treba neco pregenerovat
    if (comparedate(NEW.konecpomeru, OLD.konecpomeru) = false) then
      pregenSmenuOd = null;
      pregenSmenuDo = null;
      if (NEW.aktivnido is not null and (OLD.aktivnido is null or NEW.aktivnido <= OLD.aktivnido)) then
        pregenSmenuDo = NEW.aktivnido;
      end if;
      if (OLD.aktivnido is not null and (NEW.aktivnido is null or OLD.aktivnido < NEW.aktivnido)) then
        pregenSmenuDo = OLD.aktivnido;
      end if;

      if (NEW.konecpomeru is null) then
        pregenSmenuOd = date_trunc('month', OLD.konecpomeru);
        if iskonecmesice(OLD.konecpomeru) = true then
          pregenSmenuOd = pregenSmenuOd + interval '1 month';
        end if;
      end if;
      if (OLD.konecpomeru is null) then
        pregenSmenuOd = date_trunc('month', NEW.konecpomeru);
        if iskonecmesice(NEW.konecpomeru) = true then
          pregenSmenuOd = pregenSmenuOd + interval '1 month';
        end if;
      end if;
      if NEW.konecpomeru is not null and OLD.konecpomeru is not null then
        if (extract(month from NEW.konecpomeru) = extract(month from OLD.konecpomeru) and extract(year from NEW.konecpomeru) = extract(year from OLD.konecpomeru)) then
          pregenSmenuOd = date_trunc('month', NEW.konecpomeru);                 -- zmenil se den konce ale mesic zustal
          pregenSmenuDo = pregenSmenuOd;
        else
          if (NEW.konecpomeru < OLD.konecpomeru) then
            pregenSmenuOd = NEW.konecpomeru;
            pregenSmenuDo = date_trunc('month', OLD.konecpomeru);
          else
            pregenSmenuOd = OLD.konecpomeru;
            pregenSmenuDo = date_trunc('month', NEW.konecpomeru);
          end if;
          
          if iskonecmesice(pregenSmenuOd) then
            pregenSmenuOd = pregenSmenuOd + interval '1 day';
          else
            pregenSmenuOd = date_trunc('month', pregenSmenuOd);
          end if;
        end if;
      end if;
      
      if pregenSmenuOd is not null then
        perform pcreatemzdslozforsmeny(idsmeny) from psmeny where idpracpom = NEW.idpracpomhlav and 
          pregenSmenuOd <= date('' || rok || '-' || mesic || '-01') and
          (pregenSmenuDo is null or pregenSmenuDo >= date('' || rok || '-' || mesic || '-01'));
      end if;
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomhlavupdatemzdsloz AFTER INSERT OR UPDATE ON ppracpomhlav -- TODO pri insertu by melo byt zbytecne spusti se az pri vlozeni do ppracpom
  FOR EACH ROW EXECUTE PROCEDURE ppracpomhlavupdatemzdsloz();


-- trigger generujici mzdove slozky pri uprave ucetniho obdobi
CREATE OR REPLACE FUNCTION nucetobdobiupdatemzdsloz() RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  if (tg_op = 'UPDATE') then
    if (NEW.platioddata <> OLD.platioddata or NEW.platidodata <> OLD.platidodata) then
      perform pgeneratemzdslozforpracpom(-1, NEW.iducetobdobi);
    end if;
  else
    perform pgeneratemzdslozforpracpom(-1, ZAZNAM.iducetobdobi);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.nucetobdobiupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER nucetobdobiupdatemzdsloz AFTER INSERT OR UPDATE OR DELETE ON nucetobdobi
  FOR EACH ROW EXECUTE PROCEDURE nucetobdobiupdatemzdsloz();


-- trigger generujici mzdove slozky pri vytvoreni nebo uprave stale mzdove slozky
CREATE OR REPLACE FUNCTION pstalamzdslozupdatemzdsloz()
  RETURNS trigger AS $$
declare
  _rok integer;
  _mesic integer;
begin
  -- vymazeme nadbytecne slozky pro stale slozky
  if (NEW.datumod is not null) then
    _rok = date_part('year', NEW.datumod);
    _mesic = date_part('month', NEW.datumod);
    -- smazání pomocných složek pro odměny
    delete from pmzdsloz where idodmena in (select idmzdsloz from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok < _rok or (rok = _rok and mesic < _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba)) and pcantriggerchangeslozku(rok, mesic, idosoba);
    delete from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok < _rok or (rok = _rok and mesic < _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba);
  end if;
  
  if (NEW.datumdo is not null) then
    _rok = date_part('year', NEW.datumdo);
    _mesic = date_part('month', NEW.datumdo);
    
    -- smazání pomocných složek pro odměny
    delete from pmzdsloz where idodmena in (select idmzdsloz from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok > _rok or (rok = _rok and mesic > _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba)) and pcantriggerchangeslozku(rok, mesic, idosoba);
    delete from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok > _rok or (rok = _rok and mesic > _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba);
  end if;

  -- vygenerujeme chybejici slozky
  perform pgeneratemzdslozforpracpom(NEW.idpracpom);
  
  -- nastavime aktualni parametry
  perform pupdatemzdslozfromstalasloz(idmzdsloz, NEW.idstalamzdsloz) from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and pcantriggerchangeslozku(rok, mesic, idosoba);
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pstalamzdslozupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pstalamzdslozupdatemzdsloz AFTER INSERT OR UPDATE ON pstalamzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pstalamzdslozupdatemzdsloz();


-- trigger mazajici mzdove slozky pri smazani stale mzdove slozky
CREATE OR REPLACE FUNCTION pstalamzdslozdeletemzdsloz()
  RETURNS trigger AS $$
begin
  -- smazání pomocných složek pro odměny
  delete from pmzdsloz where idOdmena in (select idmzdsloz from pmzdsloz where idstalamzdsloz = OLD.idstalamzdsloz and pcantriggerchangeslozku(rok, mesic, idosoba)) and pcantriggerchangeslozku(rok, mesic, idosoba); 
  delete from pmzdsloz where idstalamzdsloz = OLD.idstalamzdsloz and pcantriggerchangeslozku(rok, mesic, idosoba);
  
  -- ty co se nesmazali protoze jsou v zamcenym obdobi odvazeme od stale slozky
  update pmzdsloz set idstalamzdsloz = null where idstalamzdsloz = OLD.idstalamzdsloz;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pstalamzdslozdeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pstalamzdslozdeletemzdsloz BEFORE DELETE ON pstalamzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pstalamzdslozdeletemzdsloz();


-- trigger generujici mzdove slozky pri vytvoreni nebo uprave srazky
CREATE OR REPLACE FUNCTION psrazkaupdatemzdsloz()
  RETURNS trigger AS $$
declare
  _rok integer;
  _mesic integer;
  _idpracpom integer;
begin
  -- vymazeme nadbytecne slozky pro srazky
  if (NEW.srazkaod is not null) then
    _rok = date_part('year', NEW.srazkaod);
    _mesic = date_part('month', NEW.srazkaod);
    
    delete from pmzdsloz where idsrazka = NEW.idsrazka and (rok < _rok or (rok = _rok and mesic < _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba);
  end if;
  
  if (NEW.srazkado is not null) then
    _rok = date_part('year', NEW.srazkado);
    _mesic = date_part('month', NEW.srazkado);
    
    delete from pmzdsloz where idsrazka = NEW.idsrazka and (rok > _rok or (rok = _rok and mesic > _mesic)) and pcantriggerchangeslozku(rok, mesic, idosoba);
  end if;

  -- vygenerujeme chybejici slozky
  select idpracpomhlav into _idpracpom from ppracpomhlav where idosoba = NEW.idosoba limit 1;
  if (_idpracpom is not null) then 
    perform pgeneratemzdslozforpracpom(_idpracpom);
  end if;
  
  -- nastavime aktualni parametry
  perform pupdatemzdslozfromsrazka(idmzdsloz, NEW.idsrazka) from pmzdsloz where idsrazka = NEW.idsrazka and pcantriggerchangeslozku(rok, mesic, idosoba);
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psrazkaupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psrazkaupdatemzdsloz AFTER INSERT OR UPDATE ON psrazka
  FOR EACH ROW EXECUTE PROCEDURE psrazkaupdatemzdsloz();


-- trigger mazajici mzdove slozky pri smazani srazky
CREATE OR REPLACE FUNCTION psrazkadeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idsrazka = OLD.idsrazka and pcantriggerchangeslozku(rok, mesic, idosoba);
  
  -- ty co se nesmazali protoze jsou v zamcenym obdobi odvazeme od srazky
  update pmzdsloz set idsrazka = null where idsrazka = OLD.idsrazka;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psrazkadeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psrazkadeletemzdsloz BEFORE DELETE ON psrazka
  FOR EACH ROW EXECUTE PROCEDURE psrazkadeletemzdsloz();


-- trigger mazajici mzdove slozky pri smazani nepritomnosti
CREATE OR REPLACE FUNCTION pnepritomnostdeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idnepritomnost = OLD.idnepritomnost;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pnepritomnostdeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pnepritomnostdeletemzdsloz BEFORE DELETE ON pnepritomnost
  FOR EACH ROW EXECUTE PROCEDURE pnepritomnostdeletemzdsloz();


-- trigger posunujici cisla radky nasledujicich radek v mzdove kalkulacce pri smazani radky
CREATE OR REPLACE FUNCTION pmzdcalcdeletecisrad()
  RETURNS trigger AS $$
begin
  update pmzdcalc set cisrad = cisrad - 1 where idmzdcalchlav = OLD.idmzdcalchlav and cisrad > OLD.cisrad;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pmzdcalcdeletecisrad() OWNER TO %firmaRole%;

CREATE TRIGGER pmzdcalcdeletecisrad AFTER DELETE ON pmzdcalc
  FOR EACH ROW EXECUTE PROCEDURE pmzdcalcdeletecisrad();


-- trigger posunujici cisla radky nasledujicich radek v hromadne mzdove kalkulacce pri smazani radky
CREATE OR REPLACE FUNCTION pmzdcalchromdeletecisrad()
  RETURNS trigger AS $$
begin
  update pmzdcalchrom set cisrad = cisrad - 1 where idmzdcalchlav = OLD.idmzdcalchlav and cisrad > OLD.cisrad;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pmzdcalchromdeletecisrad() OWNER TO %firmaRole%;

CREATE TRIGGER pmzdcalchromdeletecisrad AFTER DELETE ON pmzdcalchrom
  FOR EACH ROW EXECUTE PROCEDURE pmzdcalchromdeletecisrad();


-- vygeneruje mzdovou slozku ze zadane ciselnikove slozky pro pracovni pomer a datum
CREATE OR REPLACE FUNCTION pcreatemzdslozfromcis(_idCis integer, _idPracPom integer, _idOsoba integer, _rok integer, _mesic integer)
  RETURNS integer AS $$
declare
  C record;
  Cpom record;
  _idosobaout integer;
  _idsloz integer;
  _idslozpom integer;
begin
  select * into C from pcismzdsloz where idcismzdsloz = _idCis;
  
  _idosobaout = _idOsoba;
  if (_idosobaout is null and _idPracPom is not null) then
    select idosoba into _idosobaout from ppracpomhlav where idpracpomhlav = _idPracPom;
  end if;
  
  if (C.idcismzdsloz is not null and _idosobaout is not null) then
    select nextval('seq_pmzdsloz') into _idsloz;
    insert into pmzdsloz (idmzdsloz, idosoba, idpracpom, rok, mesic, idcismzdsloz, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni, dnyPrac, dnyKal, dnySvatek, hodiny, castkaHod, castkaDen, procMzd, zaklMzd, zaklJeKracen, castMzd, zmenaCastMzd, pocetMes, cisDoklNem, prumNaDenNem, prumNaHodNem, doplatZdravK)
      values (_idsloz, _idosobaout, _idPracPom, _rok, _mesic, _idCis, C.kod, C.nazev, C.typslozkyk, C.skupslozkyk, C.cisrad, C.pracovni, C.dnyPrac, C.dnyKal, C.dnySvatek, C.hodiny, C.castkaHod, C.castkaDen, C.procMzd, C.zaklMzd, C.zaklJeKracen, C.castMzd, C.zmenaCastMzd, C.pocetMes, C.cisDoklNem, C.prumNaDenNem, C.prumNaHodNem, C.doplatZdravK);
    
    -- vytvoření pomocných složek pro odměny
    if (C.uuid = 'MIMORADNA ODMENA' or C.uuid = 'MIMORADNA_ODM.VICE_M') then
      select * into Cpom from pcismzdsloz where uuid = 'POM.SLOZ.ODM-VM'; 
      select nextval('seq_pmzdsloz') into _idslozpom; 
      insert into pmzdsloz (idmzdsloz, idosoba, idpracpom, rok, mesic, idcismzdsloz, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni, dnyPrac, dnyKal, dnySvatek, hodiny, castkaHod, castkaDen, procMzd, zaklMzd, zaklJeKracen, castMzd, zmenaCastMzd, pocetMes, cisDoklNem, prumNaDenNem, prumNaHodNem, doplatZdravK, idOdmena) 
      values (_idslozpom, _idosobaout, _idPracPom, _rok, _mesic, Cpom.idcismzdsloz, Cpom.kod, Cpom.nazev, Cpom.typslozkyk, Cpom.skupslozkyk, Cpom.cisrad, Cpom.pracovni, Cpom.dnyPrac, Cpom.dnyKal, Cpom.dnySvatek, Cpom.hodiny, Cpom.castkaHod, Cpom.castkaDen, Cpom.procMzd, Cpom.zaklMzd, Cpom.zaklJeKracen, Cpom.castMzd, true, 1, Cpom.cisDoklNem, Cpom.prumNaDenNem, Cpom.prumNaHodNem, Cpom.doplatZdravK, _idSloz); 


  end if;
    return _idsloz;
  end if;
  
  return -1;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcreatemzdslozfromcis(integer, integer, integer, integer, integer) OWNER TO %firmaRole%;

-- pro smeny se zadanym id vygeneruje mzdovou slozku pracovni doby
CREATE OR REPLACE FUNCTION pcreatemzdslozforsmeny(_idSmeny integer)
  RETURNS void AS $$
declare
  SM record;
  SMnext record;
  _hodin numeric;
  _dnuPrac numeric;
  _hodinPoc numeric;
  _dnuPracPoc numeric;
  _konecMes date;
  _okolMes date;
  _denOd integer;
  _denDo integer;
  _denOdPoc integer;
  _denDoPoc integer;
  _pocatek boolean;
  _jizNeprac boolean;
  _aktivOd date;
  _aktivDo date;
  i integer;
  smeny varchar[];
  smena varchar[];
  _aktSmena varchar;
  pocSmena integer;
  konSmena integer;
  denSmena integer;
  _idcisMzd integer;
  _idmzdsloz integer;
  _aktHodin numeric;
  _svatek boolean;
  _dnuSvat numeric;
  _hodinSvat numeric;
  _dnuSvatPoc numeric;
  _hodinSvatPoc numeric;
begin
  select * into SM from psmeny where idsmeny = _idsmeny;
  _hodin = 0;
  _dnuPrac = 0;
  _hodinPoc = 0;
  _dnuPracPoc = 0;
  _dnuSvat = 0;
  _hodinSvat = 0;
  _dnuSvatPoc = 0;
  _hodinSvatPoc = 0;
  _konecMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month' - interval '1 day';
  _denOd = 1;
  _denDo = extract (day from _konecMes);
  _denOdPoc = 1;
  _denDoPoc = _denDo;
  _jizNeprac = false;
  
  select zacatek, konecpomeru into _aktivOd, _aktivDo from ppracpomhlav where idpracpomhlav = SM.idpracpom;
  
  if (_aktivOd is not null) then
    if (SM.mesic = extract(month from _aktivOd) and SM.rok = extract(year from _aktivOd)) then
      _denOdPoc = extract (day from _aktivOd);
    end if;
  end if;
  if (_aktivDo is not null) then
    if (SM.mesic = extract(month from _aktivDo) and SM.rok = extract(year from _aktivDo)) then
      _denDoPoc = extract (day from _aktivDo);
    end if;
    if (date('' || SM.rok || '-' || SM.mesic || '-01') > _aktivDo) then
      _jizNeprac = true;
    end if;
  end if;
  _pocatek = (_denOd <> _denOdPoc or _denDo <> _denDoPoc);
  
  if (_jizNeprac = false and SM.planovane is not null and length(SM.planovane) > 0) then
    smeny = string_to_array(SM.planovane,';');
    _aktSmena = '';
    
    for i in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
      smena = string_to_array(smeny[i],':');
      if (smena[1] <> '0' and smena[1] <> 's0') then                     -- zbytek smeny z minuleho mesice nas nezajima
        pocSmena = smena[2];
        konSmena = smena[3];
        
        if (_aktSmena <> smena[1]) then
          denSmena = pocSmena / (24 * 60) + 1;    -- zjistime den
          _svatek = (strpos(smena[1], 's') > 0);    -- zjistime jestli jde o svatek
          
          if (_svatek) then
            _dnuSvat = _dnuSvat + 1;  -- pripocteme svatek kdy mel pracovat ale flakal se
            if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
              _dnuSvatPoc = _dnuSvatPoc + 1;
            end if;
          else
            _dnuPrac = _dnuPrac + 1;  -- pripocteme pracovni den
            if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
              _dnuPracPoc = _dnuPracPoc + 1;
            end if;
          end if;
          _aktSmena = smena[1];
        end if;
        
        _aktHodin = cast((konSmena - pocSmena + 1) as numeric) / 60;
        
        if (_svatek) then
          _hodinSvat = _hodinSvat + _aktHodin;  -- pripocteme svatecni hodiny
          if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
            _hodinSvatPoc = _hodinSvatPoc + _aktHodin;
          end if;
        else
          _hodin = _hodin + _aktHodin;    -- pripocteme pracovni hodiny
          if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
            _hodinPoc = _hodinPoc + _aktHodin;
          end if;
        end if;
      else
        _okolMes = date(SM.rok || '-' || SM.mesic || '-01') - interval '1 month';
        select pcreatemzdslozforsmeny(idsmeny)from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes);
      end if;
    end loop;
  end if;
  
  -- podivame se o mesic dal jestli tam nemame kousicek
  /*_okolMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month';
  select * into SMnext from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes) limit 1;
  if (SMnext.idsmeny is not null) then
    if (SMnext.planovane is not null and length(SMnext.planovane) > 0) then
      smeny = string_to_array(SMnext.planovane,';');
      
      for i in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
        smena = string_to_array(smeny[i],':');
        _aktSmena = smena[1];
      
        if (_aktSmena = '0' or _aktSmena = 's0') then
          pocSmena = smena[2];
          konSmena = smena[3];
          _aktHodin = (konSmena - pocSmena + 1) / 60;
          if (_aktSmena = '0') then
            _hodin = _hodin + _aktHodin;
          else
            _hodinSvat = _hodinSvat + _aktHodin;
          end if;
        end if;
      end loop;  
    end if;
  end if;*/
  
  select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba';
  select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic 
      and idcismzdsloz = _idcisMzd;
  
  if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
    select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
  end if;
  
  update pmzdsloz set dnyKal = (_denDo-_denOd+1), dnyPrac = _dnuPrac, hodiny = _hodin, dnySvatek = _dnuSvat, hodinySvatek = _hodinSvat where idmzdsloz = _idmzdsloz;

  
  select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.inicializace' and skupslozkyk = 'skupinaSlozky.doba';
  if (_idcisMzd is not null) then
    select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic
      and idcismzdsloz = _idcisMzd;

    if (_jizNeprac = false and _pocatek = true) then
      if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
        select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
      end if;

      update pmzdsloz set dnyKal = (_denDo-_denOd - _denDoPoc+_denOdPoc), dnyPrac = _dnuPracPoc, hodiny = _hodinPoc, dnySvatek = _dnuSvatPoc, hodinySvatek = _hodinSvatPoc where idmzdsloz = _idmzdsloz;
    else
      if (_idmzdsloz is not null) then      -- slozka neexistuje smazeme ji
        delete from pmzdsloz where idmzdsloz = _idmzdsloz;
      end if;
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcreatemzdslozforsmeny(integer) OWNER TO %firmaRole%;

-- trigger generujici ze smen mzdove slozky 
CREATE OR REPLACE FUNCTION psmenyupdatemzdsloz()
  RETURNS trigger AS $$
begin
  perform pcreatemzdslozforsmeny(NEW.idSmeny);

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psmenyupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psmenyupdatemzdsloz AFTER INSERT OR UPDATE ON psmeny
  FOR EACH ROW EXECUTE PROCEDURE psmenyupdatemzdsloz();

-- trigger mazajici mzdove slozky pri smazani pracovniho pomeru
CREATE OR REPLACE FUNCTION ppracpomhlavdeleteslozky()
  RETURNS trigger AS $$
declare
  pomeru integer;
  maxdo date;
begin
  delete from pmzdsloz where idpracpom = OLD.idpracpomhlav;
  delete from psmeny where idpracpom = OLD.idpracpomhlav;
  
  select count(*) into pomeru from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
  if (pomeru = 0) then
    delete from pmzdsloz where idosoba = OLD.idosoba;
  else
    select count(*) into pomeru from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba and aktivnido is null;
    if (pomeru = 0) then
      select max(aktivnido) into maxdo from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
      
      delete from pmzdsloz where idosoba = OLD.idosoba and ((rok > date_part('year', maxdo)) or (rok = date_part('year', maxdo) and mesic > date_part('month', maxdo)));
    end if;
    
    select min(aktivniod) into maxdo from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
    delete from pmzdsloz where idosoba = OLD.idosoba and ((rok < date_part('year', maxdo)) or (rok = date_part('year', maxdo) and mesic < date_part('month', maxdo)));
  end if;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavdeleteslozky() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomhlavdeleteslozky BEFORE DELETE ON ppracpomhlav
  FOR EACH ROW EXECUTE PROCEDURE ppracpomhlavdeleteslozky();

-- trigger mazajici vazbu do mezd pri smazani zavazku
CREATE OR REPLACE FUNCTION ddoklfakdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where iddoklfak = OLD.iddoklfak;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklfakdeletemzdvazba BEFORE DELETE ON ddoklfak
  FOR EACH ROW EXECUTE PROCEDURE ddoklfakdeletemzdvazba();

-- trigger mazajici vazbu do mezd pri smazani polozky zavazku
CREATE OR REPLACE FUNCTION dpolfakdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where idpolfak = OLD.idpolfak;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER dpolfakdeletemzdvazba BEFORE DELETE ON dpolfak
  FOR EACH ROW EXECUTE PROCEDURE dpolfakdeletemzdvazba();


-- trigger mazajici vazbu do mezd pri smazani interniho dokladu
CREATE OR REPLACE FUNCTION ddoklintdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where iddoklint = OLD.iddoklint;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklintdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklintdeletemzdvazba BEFORE DELETE ON ddoklint
  FOR EACH ROW EXECUTE PROCEDURE ddoklintdeletemzdvazba();


-- trigger prenasejici zmeny na ciselniku i na slozky
CREATE OR REPLACE FUNCTION pcismzdslozupdatemzdsloz()
  RETURNS trigger AS $$
begin
  -- neresi zmenu pole naOsobu, je treba osetrit ve scriptu protoze to je slozitejsi
  if (NEW.pracovni <> OLD.pracovni or NEW.typSlozkyK <> OLD.typSlozkyK or NEW.skupSlozkyK <> OLD.skupSlozkyK or NEW.cisRad <> OLD.cisRad) then
    UPDATE pmzdsloz SET pracovni = NEW.pracovni, typSlozkyK = NEW.typSlozkyK, skupSlozkyK = NEW.skupSlozkyK, cisRad = NEW.cisRad
      WHERE idCisMzdSloz = NEW.idCisMzdSloz and pcantriggerchangeslozku(rok, mesic, idosoba);
  end if;
  
  -- kod a nazev se prenasi vzdy - je treba v upgradu vypnout trigger hlidajici zmenu
  if (NEW.kod <> OLD.kod or NEW.nazev <> OLD.nazev) then
    UPDATE pmzdsloz SET kod = NEW.kod, nazev = NEW.nazev
      WHERE idCisMzdSloz = NEW.idCisMzdSloz;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcismzdslozupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pcismzdslozupdatemzdsloz AFTER UPDATE ON pcismzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pcismzdslozupdatemzdsloz();


-- pridani funkce na porovnani datumu pracujici spravne s null hodnotama
CREATE OR REPLACE FUNCTION comparedate(datea date, dateb date)
  RETURNS boolean AS $$   
begin   
  if (datea is null and dateb is null) or (datea is not null and dateb is not null and datea = dateb) then   
    return true;   
  end if;   
   
  return false;   
end;   
$$ LANGUAGE plpgsql;
ALTER FUNCTION comparedate(date, date) OWNER TO %firmaRole%;


-- pridani funkce ktera zjisti zda je datum posledni den v mesici
CREATE OR REPLACE FUNCTION iskonecmesice(datum date)
  RETURNS boolean AS $$   
declare poslden integer;
begin   
  if datum is not null then
    poslden = extract (day from (date_trunc('month', datum) + interval '1 month' - interval '1 day'));
    if poslden = extract (day from datum) then   
      return true;
    end if;
  end if;
  
  return false;
end;   
$$ LANGUAGE plpgsql;
ALTER FUNCTION iskonecmesice(date) OWNER TO %firmaRole%;


-- trigger odnastavujici datum vypoctu mzdy pri zmene a hlidajici ze se nezmeni slozka v zamcenem obdobi
CREATE OR REPLACE FUNCTION pmzdslozupdatedatumvypoctu()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
  _datumOd date;
  _datumDo date;
  _zamku integer;
  vypocet boolean;
  datDokl boolean;
  txName varchar;
begin
  if (tg_op = 'UPDATE') then
    if (OLD.idstalamzdsloz is not null and NEW.idstalamzdsloz is null) then     -- mazame stalou mzdovou slozku - to je ok
      return NEW;
    end if;
    if (OLD.idsrazka is not null and NEW.idsrazka is null) then     -- mazame srazku - to je ok
      return NEW;
    end if;
  end if;

  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  
  if (ZAZNAM.kod = 'POM.SLOŽ.ODM-VM') then -- rušení data výpočtu, je ošetřeno v Jave
     return ZAZNAM;
  end if;
  
  _datumOd = date (ZAZNAM.rok || '-' || ZAZNAM.mesic || '-01');
  _datumDo = _datumOd + interval '1 month';
  
  select count(*) into _zamku from wzamky where modulmzd = true and zamekk in ('zamek.polozamceno', 'zamek.zamceno') and
      platioddata < _datumDo and platidodata >= _datumOd;
  if (_zamku > 0) then
    raise exception 'Mzdy v období %/% jsou zamčené a není možno je měnit.', ZAZNAM.rok, ZAZNAM.mesic;
  end if;
  
  -- pokud se jedna o update resime cachry s datumava (vypocet, nastaveni datumu dokladu a jeho proplaceni)
  if (tg_op = 'UPDATE') then
    -- zjistime zda nastavujeme datum vypoctu
    vypocet = (NEW.typslozkyk = 'typSlozky.kopie' and NEW.skupslozkyk = 'skupinaSlozky.doba' and not comparedate(NEW.datumod, OLD.datumod));
    -- zjisitme zda se meni datum dokladu nebo obdobi platby
    datDokl = (NEW.idnepritomnost is not null and (not comparedate(NEW.datumdoklad, OLD.datumdoklad) or 
                  not compareid(NEW.rokplatba, OLD.rokplatba) or not compareid(NEW.mesicplatba, OLD.mesicplatba)));
  
    if (not vypocet and not datDokl) then
      SELECT getglotxvariable('zurnalTxName') INTO txName;
      if (txName is null or txName <> 'vypocetMezd') then       -- pokud pocitame mzdy tak neschazujeme - zbytecny zaznam v zurnalu
        update pmzdsloz set datumod = null where rok = ZAZNAM.rok and mesic = ZAZNAM.mesic and idosoba = ZAZNAM.idosoba and 
          typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba' and datumod is not null;
      end if;
    end if;
    
    if (datDokl) then
      update pmzdsloz set datumdoklad = NEW.datumdoklad, rokplatba = NEW.rokplatba, mesicplatba = NEW.mesicplatba 
        where idnepritomnost = NEW.idnepritomnost and rok = NEW.rok and mesic = NEW.mesic and idmzdsloz <> NEW.idmzdsloz;
    end if;
  else
    SELECT getglotxvariable('zurnalTxName') INTO txName;
    if (txName is null or txName <> 'vypocetMezd') then       -- pokud pocitame mzdy tak neschazujeme - zbytecny zaznam v zurnalu
      update pmzdsloz set datumod = null where rok = ZAZNAM.rok and mesic = ZAZNAM.mesic and idosoba = ZAZNAM.idosoba and 
        typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba' and datumod is not null;
    end if;
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pmzdslozupdatedatumvypoctu() OWNER TO %firmaRole%;

CREATE TRIGGER pmzdslozupdatedatumvypoctu AFTER INSERT OR UPDATE OR DELETE ON pmzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pmzdslozupdatedatumvypoctu();


-- trigger prenasejici jmeno apod na hlavicku
CREATE OR REPLACE FUNCTION posobaupdatehlavicka()
  RETURNS trigger AS $$
begin
  if (NEW.platido is null) then
    UPDATE posobahlav SET lastupdate = localtimestamp, osbcis = NEW.osbcis, jmeno = NEW.jmeno, prijmeni = NEW.prijmeni, titul = NEW.titul, password = NEW.password WHERE idosobahlav = NEW.idosobahlav 
       AND (osbcis <> NEW.osbcis or not comparevarchar(jmeno, NEW.jmeno) or not comparevarchar(prijmeni, NEW.prijmeni) or not comparevarchar(titul, NEW.titul) or not comparevarchar(password, NEW.password));  
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.posobaupdatehlavicka() OWNER TO %firmaRole%;

CREATE TRIGGER posobaupdatehlavicka AFTER INSERT OR UPDATE ON posoba
  FOR EACH ROW EXECUTE PROCEDURE posobaupdatehlavicka();

--------------------------------------------------------------------------------
-- Bug 37614 – [FlexiBee] Upravit report o změnách dokladu i o štítky (emeldi)
--------------------------------------------------------------------------------
CREATE INDEX wkli_pmzdsloz_idmzdsloz_index ON wkli_pmzdsloz USING btree (idmzdsloz);
CREATE INDEX wkli_pmzdsloz_idvybklic_index ON wkli_pmzdsloz USING btree (idvybklic);
CREATE INDEX wkli_pnepritomnost_idnepritomnost_index ON wkli_pnepritomnost USING btree (idnepritomnost);
CREATE INDEX wkli_pnepritomnost_idvybklic_index ON wkli_pnepritomnost USING btree (idvybklic);
CREATE INDEX wkli_pstalamzdsloz_idstalamzdsloz_index ON wkli_pstalamzdsloz USING btree (idstalamzdsloz);
CREATE INDEX wkli_pstalamzdsloz_idvybklic_index ON wkli_pstalamzdsloz USING btree (idvybklic);
CREATE INDEX wkli_zdite_iddite_index ON wkli_zdite USING btree (iddite);
CREATE INDEX wkli_zdite_idvybklic_index ON wkli_zdite USING btree (idvybklic);
CREATE INDEX wkli_zosoba_idosoba_index ON wkli_zosoba USING btree (idosoba);
CREATE INDEX wkli_zosoba_idvybklic_index ON wkli_zosoba USING btree (idvybklic);


-- funkce pro dočasné uložení externích indentifikátorů při výmazu
CREATE OR REPLACE FUNCTION saveextid() RETURNS trigger AS $$

    spi_exec "SELECT pg_attribute.attname AS pk
        FROM pg_index, pg_class, pg_attribute
        WHERE
          pg_class.oid = '[ quote $TG_table_name ]'::regclass AND
          indrelid = pg_class.oid AND
          pg_attribute.attrelid = pg_class.oid AND
          pg_attribute.attnum = any(pg_index.indkey) AND indisprimary"

    set fkall "false"
    set pkval [ quote $OLD([ quote $pk ]) ]
    
    spi_exec "SELECT attname AS fk
            FROM pg_attribute
            WHERE attrelid = 'wextid'::regclass
                AND attnum IN (
                    SELECT conkey\[1\]
                    FROM pg_constraint
                    WHERE conrelid = 'wextid'::regclass
                        AND confrelid = '[ quote $TG_table_name ]'::regclass)" {
        append fkall " or " $fk "=" $pkval
    }
    
    spi_exec "SELECT istableexist('changelog_delete_wextid') AS exists"
    if {!$exists} {
        spi_exec "CREATE TEMPORARY TABLE changelog_delete_wextid ( LIKE wextid ) ON COMMIT DROP"
    }
    spi_exec "INSERT INTO changelog_delete_wextid SELECT * FROM wextid WHERE $fkall"
    
    return [ array get OLD ]
    
$$ LANGUAGE pltcl VOLATILE SECURITY DEFINER;
ALTER FUNCTION saveextid() OWNER TO %admin%;


-- trigger zapisující změny do tabulky changelog
CREATE OR REPLACE FUNCTION logchanges() RETURNS trigger AS $$
    spi_exec "SELECT pg_attribute.attname AS pk
        FROM pg_index, pg_class, pg_attribute
        WHERE
          pg_class.oid = '[ quote $TG_table_name ]'::regclass AND
          indrelid = pg_class.oid AND
          pg_attribute.attrelid = pg_class.oid AND
          pg_attribute.attnum = any(pg_index.indkey)
          AND indisprimary"

    set modul null
    if {$TG_op == "INSERT" || $TG_op == "UPDATE"} {
        set pkval [ quote $NEW([ quote $pk ]) ]
        if {[info exists NEW(modul)]} {
            set modul '[ quote $NEW(modul) ]'
        }
    } else {
        set pkval [ quote $OLD([ quote $pk ]) ]
        if {[info exists OLD(modul)]} {
            set modul '[ quote $OLD(modul) ]'
        }
    }

    spi_exec "SELECT session_user AS user_name"
    set user_dollar_idx [string first \$ $user_name] 
    if {$user_dollar_idx != -1} {
        incr user_dollar_idx
        set user_name "[string range $user_name $user_dollar_idx end]" 
    }

    set operation "[string range $TG_op 0 0]"
    set extid null
    set extid_table "wextid"

    if {$TG_op == "DELETE" && $TG_when == "AFTER"} {
        set extid_table "changelog_delete_wextid"
        if {[spi_exec "SELECT 1 FROM pg_tables WHERE tablename = '$extid_table'"] == 0} {
            elog WARNING "Temporary table '$extid_table' was not found. External identifiers (extid) will be missed in Changes API for this DELETE." 
            set extid_table "wextid"
        }
    }

    if {[ info exists NEW(kod) ]} {
        append all_extids 'code:[ quote $NEW(kod) ]'
    } elseif {[ info exists OLD(kod) ]} {
        append all_extids 'code:[ quote $OLD(kod) ]'
    }

    spi_exec "select tablename from pg_tables where tablename = '${extid_table}'" {
        spi_exec "select attname AS fk from pg_attribute where attrelid = 'wextid'::regclass and attnum in (select conkey\[1\] from pg_constraint where conrelid = 'wextid'::regclass and confrelid = '[ quote $TG_table_name ]'::regclass)" {
            spi_exec "select extid from $extid_table where $fk = $pkval" {
                if {[info exists all_extids] && [string length $all_extids] > 0} {
                  append all_extids ","
                }
                append all_extids '[ quote $extid ]'
            }
        }
    }

    if {[info exists all_extids] && [string length $all_extids] > 0} {
        set extid "array\[$all_extids\]"
    }

    array set evidence_discriminators {
        dsmlouvy+null typpohybuk
        dtypsml+null typpohybuk
        
        ddoklint+BAN zapocet
        dtypdokl+BAN zapocet
        
        ddoklfak+FAV prodejka
        dtypdokl+FAV prodejka
        
        ukurzy+null typkurzuk
        
        sumisteni+null typumistenik
    }
    
    array set evidence_disc_mapping {
        dsmlouvy+null:typPohybu.prijem smlouva
        dsmlouvy+null:typPohybu.vydej dodavatelska-smlouva
        
        dtypsml+null:typPohybu.prijem typ-smlouvy
        dtypsml+null:typPohybu.vydej dodavatelsky-typ-smlouvy
        
        ddoklint+BAN:t vzajemny-zapocet
        ddoklint+BAN:f banka
        
        dtypdokl+BAN:t typ-vzajemnych-zapoctu
        dtypdokl+BAN:f typ-banka
        
        ddoklfak+FAV:t prodejka
        ddoklfak+FAV:f faktura-vydana
        
        dtypdokl+FAV:t typ-prodejky
        dtypdokl+FAV:f typ-faktury-vydane
        
        ukurzy+null:typKurzu.obecny kurz
        ukurzy+null:typKurzu.cenotvorba kurz-pro-cenotvorbu
        ukurzy+null:typKurzu.intrastat intrastat-kurz
        
        sumisteni+null:typUmisteniSklad.mistnost umisteni-ve-skladu-mistnost
        sumisteni+null:typUmisteniSklad.regal umisteni-ve-skladu-regal
        sumisteni+null:typUmisteniSklad.police umisteni-ve-skladu-police
    }
    
    array set evidence_easy_mapping {
        aadresar+null adresar
        abanspoj+null adresar-bankovni-ucet
        akontakty+null kontakt
        amisturc+null misto-urceni
        anaklakt+null naklad
        apsc+null psc
        askupfir+null skupina-firem
        asmerkod+null penezni-ustav
        astaty+null stat
        atypakt+null typ-aktivity
        atypnaklakt+null typ-nakladu
        catribut+null atribut
        ccenhlad+null cenova-uroven
        ccenik+null cenik
        cdodavatele+null dodavatel
        cenyview+null individualni-cenik
        ckusovnik+null kusovnik
        cmerjed+null merna-jednotka
        codberatele+null odberatel
        cpodobne+null podobne-zbozi
        cpoplatky+null poplatek
        cprislusenstvi+null prislustenstvi
        csady+null sady-a-komplety
        cskupcen+null cenikova-skupina
        cskupzboz+null skupina-zbozi
        ctypatribut+null typ-atributu
        ctypzbozi+null skupina-atributu
        danovaevidence+null danova-evidence
        dbsp+BAN bankovni-ucet
        dbsp+POK pokladna
        dbsp+SKL sklad
        dcislobal+null cislo-baliku
        ddoklfak+FAP faktura-prijata
        ddoklfak+PHL pohledavka
        ddoklfak+ZAV zavazek
        ddoklint+INT interni-doklad
        ddoklint+POK pokladni-pohyb
        ddoklobch+NAP nabidka-prijata
        ddoklobch+NAV nabidka-vydana
        ddoklobch+OBP objednavka-prijata
        ddoklobch+OBV objednavka-vydana
        ddoklobch+PPP poptavka-prijata
        ddoklobch+PPV poptavka-vydana
        ddoklsklad+SKL skladovy-pohyb
        delbanformat+null format-elektronickeho-bankovnictvi
        dformadopravy+null forma-dopravy
        dformauhradycis+null forma-uhrady
        dformauhrady+null prodejka-platba
        dformauhradyzauc+null forma-uhrady-zauctovani
        dkonsym+null konst-symbol
        dpolfak+FAP faktura-prijata-polozka
        dpolfak+FAV faktura-vydana-polozka
        dpolfak+PHL pohledavka-polozka
        dpolfak+ZAV zavazek-polozka
        dpolint+BAN banka-polozka
        dpolint+INT interni-doklad-polozka
        dpolint+POK pokladni-pohyb-polozka
        dpolobch+NAP nabidka-prijata-polozka
        dpolobch+NAV nabidka-vydana-polozka
        dpolobch+OBP objednavka-prijata-polozka
        dpolobch+OBV objednavka-vydana-polozka
        dpolobch+PPP poptavka-prijata-polozka
        dpolobch+PPV poptavka-vydana-polozka
        dpolsklad+SKL skladovy-pohyb-polozka
        dpolsml+null smlouva-polozka
        dprikazuhr+null prikaz-k-uhrade
        drady+ rada
        drady+BAN rada-banka
        drady+FAP rada-faktury-prijate
        drady+FAV rada-faktury-vydane
        drady+INT rada-interniho-dokladu
        drady+NAP rada-nabidky-prijate
        drady+NAV rada-nabidky-vydane
        drady+OBP rada-objednavky-prijate
        drady+OBV rada-objednavky-vydane
        drady+PHL rada-pohledavky
        drady+POK rada-pokladni-pohyb
        drady+PPP rada-poptavky-prijate
        drady+PPV rada-poptavky-vydane
        drady+SKL rada-skladovy-pohyb
        drady+ZAV rada-zavazku
        dradyrok+null rocni-rada
        dstavsml+null stav-smlouvy
        dtypdokl+FAP typ-faktury-prijate
        dtypdokl+INT typ-interniho-dokladu
        dtypdokl+NAP typ-nabidky-prijate
        dtypdokl+NAV typ-nabidky-vydane
        dtypdokl+OBP typ-objednavky-prijate
        dtypdokl+OBV typ-objednavky-vydane
        dtypdokl+PHL typ-pohledavky
        dtypdokl+POK typ-pokladni-pohyb
        dtypdokl+PPP typ-poptavky-prijate
        dtypdokl+PPV typ-poptavky-vydane
        dtypdokl+SKL typ-skladovy-pohyb
        dtypdokl+ZAV typ-zavazku
        dvazebtab+null vazba
        idodpodm+null intrastat-dodaci-podminky
        idruhdopr+null intrastat-druh-dopravy
        iintrmerjed+null intrastat-merna-jednotka
        ikrajurc+null intrastat-kraj-urceni
        inomen+null intrastat-kod-nomenklatury
        iobchtrans+null intrastat-obchodni-transakce
        izvlpoh+null intrastat-zvlastni-pohyb
        nnastav+null nastaveni
        nucetobdobi+null ucetni-obdobi
        podkladydph+null podklady-dph
        saldokdatu+ saldo-k-datu
        sinventura+null inventura
        skarty+null skladova-karta
        smapsklad+null mapovani-skladu
        spolinventura+null inventura-polozka
        srezervace+null rezervace
        stavskladu+null stav-skladu-k-datu
        svyrobnicislo+null vyrobni-cislo
        ucetnidenik+null ucetni-denik
        ucinnost+null cinnost
        uclendph+null cleneni-dph
        udphpren+null preneseni-dph
        umeny+null mena
        uobraty+null obrat
        usazbydph+null sazba-dph
        ustavzakazky+null stav-zakazky
        ustducty+null ucetni-osnova
        ustrediska+null stredisko
        utyporg+null typ-organizace
        utypucop+null predpis-zauctovani
        utypzakazky+null typ-zakazky
        uucty+null ucet
        uvyhzakazky+null hodnoceni-zakazky
        uzakazky+null zakazka
        wactclenstvi+null clenstvi-pro-workflow
        wactdefinice+null definice-workflow
        wactskupina+null skupina-pro-workflow
        wautcert+null certifikacni-autorita
        wdataprava+null pravo-viditelnosti
        wdotazy+null uzivatelsky-dotaz
        wdotazyparam+null uzivatelsky-dotaz-parametr
        wdotazyprop+null uzivatelsky-dotaz-vlastnost
        wfiltry+null filtr
        wparam+null parametr
        wpriloha+null priloha
        wreport+null report
        wrole+null role
        wskupvybklic+null skupina-stitku
        wstrom+null strom-koren
        wtexty+null text
        wuzel+null strom
        wuzivatel+null uzivatel
        wvazba+null uzivatelska-vazba
        wvazbatyp+null typ-uzivatelske-vazby
        wvazuzel+null strom-cenik
        wvybklice+null stitek
        wzastupnosti+null zastupnost
        wzurnal+null zurnal

        cstavcen+null stav-ceniku
        sumisteni+null umisteni-ve-skladu
        ukurzy+null kurz
    }
    
    set evidence null
    set evid_easy_key "${TG_table_name}+[string trim ${modul} \']"
    
    if {[ info exists evidence_discriminators($evid_easy_key) ]} {
        set discriminator $evidence_discriminators($evid_easy_key)
        
        if {[ info exists NEW($discriminator) ]} {
            set disc_value "$NEW($discriminator)"
        } elseif {[ info exists OLD($discriminator) ]} {
            set disc_value "$OLD($discriminator)"
        }
        
        if {[ info exists disc_value ]} {
            set evid_disc_key "$evid_easy_key:$disc_value"
            
            if {[ info exists evidence_disc_mapping($evid_disc_key) ]} {
                set evidence '[ quote $evidence_disc_mapping($evid_disc_key) ]'
            }
        }
    }
    if {$evidence == "null"} {
        if {[info exists evidence_easy_mapping($evid_easy_key)]} {
            set evidence '[ quote $evidence_easy_mapping($evid_easy_key) ]'
        }
    }
    
    spi_exec "INSERT INTO changelog(tabulka, modul, evidence, id, operace, uzivatel, extids)
        VALUES ('[ quote $TG_table_name ]',
            $modul,
            $evidence,
            '[ quote $pkval ]',
            '[ quote $operation ]',
            '[ quote $user_name ]',
            $extid)"

    if {$TG_op == "DELETE"} {
        return [array get OLD]
    } else {
        return [array get NEW]
    }
$$ LANGUAGE pltcl VOLATILE SECURITY DEFINER;
ALTER FUNCTION logchanges() OWNER TO %admin%;
