--------------------------------------------------------------------------------
-- Bug 20573 – [winstrom] - Podnikatel_Online - jemnější členění správy firem
--------------------------------------------------------------------------------

alter table csfirma alter column idcsfirma set DEFAULT nextval('seq_csfirma'::regclass);
alter table cspristup alter column idcspristup set DEFAULT nextval('seq_cspristup'::regclass);
alter table csuzivatel alter column idcsuzivatel set DEFAULT nextval('seq_csuzivatel'::regclass);
alter table dbversion alter column iddbversion set DEFAULT nextval('seq_dbversion'::regclass);

alter table csuzivatel
        add column create_company boolean DEFAULT false NOT NULL,
        add column manage_all boolean DEFAULT false NOT NULL,
        add column create_user boolean DEFAULT false NOT NULL,
        add column delete_company boolean DEFAULT false NOT NULL,
        add column grant_permission boolean DEFAULT false NOT NULL;

alter table cspristup
        add column isAdmin boolean DEFAULT false NOT NULL;

CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
declare
    _uziv record;
begin
    for _uziv in (select * from csuzivatel) loop
        if (_uziv.admin_firem) then
            update csuzivatel
                set create_company = true,
                manage_all = true,
                create_user = true,
                delete_company = true,
                grant_permission = true
            where idcsuzivatel = _uziv.idcsuzivatel;

            update cspristup
                set isadmin = true
            where idcsuzivatel = _uziv.idcsuzivatel;
        end if;
    end loop;
end;
$$ LANGUAGE plpgsql;

select runupgrade();
drop function runupgrade();

alter table csuzivatel
        drop column admin_firem;

insert into dbversion(iddbversion, dbversion, needreimport)
    values (nextval('seq_dbversion'), 6, 't');