-------------------------------------------------------------------------------
-- Bug 45673 - EET - změna schematu a aplikace do dokladu a typu dokladu  
-------------------------------------------------------------------------------

ALTER TABLE dtypdokl ADD COLUMN eetlimit numeric(6,2);
ALTER TABLE dtypdokl ADD COLUMN eetpokladnizarizeni character varying(20);
ALTER TABLE dtypdokl ADD COLUMN eetprovozovna integer;
ALTER TABLE dtypdokl ADD COLUMN eetdicpoverujiciho character varying(20);
ALTER TABLE dtypdokl ADD COLUMN eettypk character varying(50);

ALTER TABLE ddoklfak ADD COLUMN eetpokladnizarizeni character varying(20);
ALTER TABLE ddoklfak ADD COLUMN eetprovozovna integer;
ALTER TABLE ddoklfak ADD COLUMN eetdicpoverujiciho character varying(20);
ALTER TABLE ddoklfak ADD COLUMN eettypk character varying(50);
ALTER TABLE ddoklfak ADD COLUMN eetstavk character varying(50);
ALTER TABLE ddoklfak ADD COLUMN eetfik text;
ALTER TABLE ddoklfak ADD COLUMN eetpkp text;
ALTER TABLE ddoklfak ADD COLUMN eetdatcastrzby timestamp without time zone;

ALTER TABLE ddoklint ADD COLUMN eetpokladnizarizeni character varying(20);
ALTER TABLE ddoklint ADD COLUMN eetprovozovna integer;
ALTER TABLE ddoklint ADD COLUMN eetdicpoverujiciho character varying(20);
ALTER TABLE ddoklint ADD COLUMN eettypk character varying(50);
ALTER TABLE ddoklint ADD COLUMN eetstavk character varying(50);
ALTER TABLE ddoklint ADD COLUMN eetfik text;
ALTER TABLE ddoklint ADD COLUMN eetpkp text;
ALTER TABLE ddoklint ADD COLUMN eetdatcastrzby timestamp without time zone;

-------------------------------------------------------------------------------
-- Bug 45717 - EET - údaje z typu dokladu přidáme také do nastavení a na středisko   
-------------------------------------------------------------------------------
ALTER TABLE ustrediska ADD COLUMN eetprovozovna integer;
ALTER TABLE ustrediska ADD COLUMN eetlimit numeric(6,2);
ALTER TABLE ustrediska ADD COLUMN eettypk character varying(50);

ALTER TABLE nnastav ADD COLUMN eetprovozovna integer;
ALTER TABLE nnastav ADD COLUMN eetlimit numeric(6,2);
ALTER TABLE nnastav ADD COLUMN eettypk character varying(50);

-------------------------------------------------------------------------------
-- Bug 45731 - EET - možnost vypnutí odesílání do ostrého prostředí   
-------------------------------------------------------------------------------
 
ALTER TABLE nnastav ADD COLUMN eetmodk character varying(50);

-------------------------------------------------------------------------------
-- Bug 45711 - Správa osobních certifikátů pro EET   
-------------------------------------------------------------------------------

ALTER TABLE woscert ADD COLUMN ucelcertk character varying(50) NOT NULL DEFAULT 'ucelCertK.vseobecny';
ALTER TABLE woscert ADD COLUMN eetprovozovna integer;

-------------------------------------------------------------------------------
-- Bug 45806 - EET - lokalizovaný číselník pro typ platby na položku ceníku a fakturu    
-------------------------------------------------------------------------------
ALTER TABLE ccenik ADD COLUMN eettypplatbyk character varying(50);
ALTER TABLE dpolfak ADD COLUMN eettypplatbyk character varying(50);

-------------------------------------------------------------------------------
-- Bug 45729 - EET - Úpravy tiskových sestav 
-------------------------------------------------------------------------------
ALTER TABLE ddoklfak ADD COLUMN eettisknoutpkp boolean not null Default true;
ALTER TABLE ddoklint ADD COLUMN eettisknoutpkp boolean not null Default true;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1029, 't', %appVersion%, clock_timestamp());
