-----------------------------------------------------------------------
-- Bug 14303 - [WinStrom] Seznam "Kurzy pro cenotvorbu"
-----------------------------------------------------------------------

ALTER TABLE ukurzy
  ADD COLUMN cenotvorba boolean DEFAULT false NOT NULL;

ALTER TABLE ONLY ukurzy
    DROP CONSTRAINT ukurzy_idmeny_key;

ALTER TABLE ONLY ukurzy
    ADD CONSTRAINT ukurzy_idmeny_key UNIQUE (idmeny, platioddata, cenotvorba);

-----------------------------------------------------------------------

CREATE OR REPLACE FUNCTION getkurzfromsklad(i_skladid integer, i_datvyst date) RETURNS numeric
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenySklad integer;  
  _kurzMnozstvi integer;  
  _nbStred numeric(10,6);  
  _result numeric(19,6);  
    
begin   
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenySklad from dTypDokl where idTypDokl = i_skladId;  
  
  if(idMenySklad is null or idMenySklad = idMenyTuzemsko) then  
    return 1;  
  end if;   
    
  select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy 
  where idMeny = idMenySklad and i_DatVyst >= PlatiOdData and cenotvorba = false
  order by PlatiOdData desc limit 1;  
  if(_nbStred is null) then  
    select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy
    where idMeny = idMenySklad and PlatiOdData is null and cenotvorba = false
    limit 1;  
  end if;  
  if(_nbStred is null) then  
    raise exception '0001:getKurzFromSklad : neexistuje kurz!';  
    /*_nbStred := 0;  
    _kurzMnozstvi := 0;*/  
  end if;  
  
  if _kurzMnozstvi = 0 then  
    _result := 0;  
  else  
    _result := _nbStred / _kurzMnozstvi;  
  end if;  
    
  return _result;   
end;    
$$
    LANGUAGE plpgsql;

ALTER FUNCTION public.getkurzfromsklad(i_skladid integer, i_datvyst date) OWNER TO %firmaRole%;

-----------------------------------------------------------------------

insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 120, 't');