-- Oprava vypoctu procenta realizovatelnosti
  
CREATE FUNCTION maxValue(num1 numeric(15,2), num2 numeric(15,2)) RETURNS numeric(15,2) AS $$ 
begin 
  if (num1 > num2) then
    return num1;
  else
    return num2;
  end if;
end; 
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.maxValue(numeric, numeric) OWNER TO %firmaRole%;

CREATE FUNCTION obchodrealizovatelnost(idDokl integer) RETURNS numeric(6,2) AS $$ 
declare
  zbyvaNakl numeric(15,2);
  moznoSklad numeric(15,2);
  moznoNesklad numeric(15,2);
  vysledek numeric(6,2);
  _idUcetniObdobi integer;
begin 
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1;
  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl;

  select coalesce(sum(
    minValue(
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idTypDokl = P.idSkladu AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1), 0),
        (mnozMj-mnozMjReal))
    * cenaMj), 0) into moznoSklad
    from dPolObch as P where idDoklObch = idDokl and typPolozkyK = 'typPolozky.katalog';

  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad from dPolObch where idDoklObch = idDokl and typPolozkyK <> 'typPolozky.katalog';

  if (zbyvaNakl = 0) then
    vysledek := 100 ;
  else
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100;
  end if;
  
  return vysledek;
end; 
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.obchodrealizovatelnost(integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolobchrealizovatelnost()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  
  if (ZAZNAM.modul in ('PPP', 'NAV', 'OBP')) then
    update ddoklobch SET procReal=obchodrealizovatelnost(ZAZNAM.idDoklObch) WHERE iddoklobch=ZAZNAM.idDoklObch;
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;


CREATE OR REPLACE FUNCTION ddoklobchrealizovatelnost()
  RETURNS trigger AS $$
begin
  if (NEW.modul in ('PPP', 'NAV', 'OBP')) then
    NEW.procReal := obchodrealizovatelnost(NEW.idDoklObch);
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;

CREATE TRIGGER ddoklobchrealizovatelnost BEFORE UPDATE ON ddoklobch
  FOR EACH ROW EXECUTE PROCEDURE ddoklobchrealizovatelnost();
  
ALTER FUNCTION public.ddoklobchrealizovatelnost() OWNER TO %firmaRole%;

-- zvýšení verze DB
insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 14, 't')