------------------------------------------------------------------
-- Bug 17021 – [WinStrom] Při zamknutí období zamykat i majetek
------------------------------------------------------------------

CREATE OR REPLACE FUNCTION wzamkynastavzamky()
  RETURNS trigger AS $$
DECLARE
  _query character varying;
  _cond character varying;
  _condTmp character varying;
  _condOldZamek character varying;
  _condPlatiOd character varying;
  _condPlatiDo character varying;
  _modulyLen integer;
  _modulyDoklFak character varying;
  _modulyDoklInt character varying;
  _modulyDoklObch character varying;
  _condModulyDoklFak character varying;
  _condModulyDoklInt character varying;
  _condModulyDoklSklad character varying;
  _condModulyDoklObch character varying;
BEGIN
  IF (
--      ((NEW.zamekk = 'zamek.zamceno') AND
--       (OLD.zamekk = 'zamek.otevreno' OR OLD.zamekk = 'zamek.prohlednuto' OR OLD.zamekk = 'zamek.polozamceno'))
--        OR
--      ((NEW.zamekk = 'zamek.polozamceno') AND
--       (OLD.zamekk = 'zamek.otevreno' OR OLD.zamekk = 'zamek.prohlednuto' OR OLD.zamekk = 'zamek.zamceno'))
      NEW.zamekk = 'zamek.zamceno' OR NEW.zamekk = 'zamek.polozamceno'
      ) THEN

    -- Omezeni na zaznamy u nichz lze zamek zprisnit
    IF (NEW.zamekk = 'zamek.polozamceno') THEN
      _condOldZamek = '(zamekk IS NULL OR (zamekk <> ''' || NEW.zamekk || ''' AND zamekk <> ''zamek.zamceno''))';
    ELSE
      _condOldZamek = '(zamekk IS NULL OR zamekk <> ''' || NEW.zamekk || ''')';
    END IF;

    -- Omezeni casoveho obdobi pro zamykani
    IF (NEW.platioddata IS NOT NULL) THEN
      _condPlatiOd = '(datvyst > ''' || NEW.platioddata || ''' OR datvyst = ''' || NEW.platioddata || ''')';
      _cond = _condPlatiOd  || ' AND ' || _condOldZamek;
    ELSE
      _condPlatiOd = NULL;
    END IF;

    IF (NEW.platidodata IS NOT NULL) THEN
      _condPlatiDo = '(datvyst < ''' || NEW.platidodata || ''' OR datvyst = ''' || NEW.platidodata || ''')';
      _cond = _condPlatiDo  || ' AND ' || _condOldZamek;
    ELSE
      _condPlatiDo = NULL;
    END IF;

    IF (_condPlatiOd IS NOT NULL AND _condPlatiDo IS NOT NULL) THEN
      _cond = _condPlatiOd || ' AND ' || _condPlatiDo || ' AND ' || _condOldZamek;
    END IF;

    -- Omezeni na moduly
    -- 1) dDoklFak
    _modulyDoklFak = '';
    IF (NEW.modulfav = TRUE) THEN
      _modulyDoklFak = _modulyDoklFak || ',''FAV''';
    END IF;
    IF (NEW.modulfap = TRUE) THEN
      _modulyDoklFak = _modulyDoklFak || ',''FAP''';
    END IF;
    IF (NEW.modulphl = TRUE) THEN
      _modulyDoklFak = _modulyDoklFak || ',''PHL''';
    END IF;
    IF (NEW.modulzav = TRUE) THEN
      _modulyDoklFak = _modulyDoklFak || ',''ZAV''';
    END IF;

    _modulyLen = char_length(_modulyDoklFak);
    IF (_modulyLen > 0) THEN
      _modulyLen = _modulyLen - 1;
      _modulyDoklFak = substring(_modulyDoklFak from 2 for _modulyLen);
      _condModulyDoklFak = 'modul IN (' || _modulyDoklFak || ')';
    ELSE
      _condModulyDoklFak = NULL;
    END IF;

    -- 2) dDoklInt
    _modulyDoklInt = '';
    IF (NEW.modulpok = TRUE) THEN
      _modulyDoklInt = _modulyDoklInt || ',''POK''';
    END IF;
    IF (NEW.modulban = TRUE) THEN
      _modulyDoklInt = _modulyDoklInt || ',''BAN''';
    END IF;
    IF (NEW.modulint = TRUE) THEN
      _modulyDoklInt = _modulyDoklInt || ',''INT''';
    END IF;

    _modulyLen = char_length(_modulyDoklInt);
    IF (_modulyLen > 0) THEN
      _modulyLen = _modulyLen - 1;
      _modulyDoklInt = substring(_modulyDoklInt from 2 for _modulyLen);
      _condModulyDoklInt = 'modul IN (' || _modulyDoklInt || ')';
    ELSE
      _condModulyDoklInt = NULL;
    END IF;

    -- 3) dDoklSklad
    IF (NEW.modulskl = TRUE) THEN
      _condModulyDoklSklad = 'modul = ''SKL''';
    ELSE
      _condModulyDoklSklad = NULL;
    END IF;

    -- 4) dDoklObch
    _modulyDoklObch = '';
    IF (NEW.modulppp = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''PPP''';
    END IF;
    IF (NEW.modulppv = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''PPV''';
    END IF;
    IF (NEW.modulnap = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''NAP''';
    END IF;
    IF (NEW.modulnav = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''NAV''';
    END IF;
    IF (NEW.modulobp = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''OBP''';
    END IF;
    IF (NEW.modulobv = TRUE) THEN
      _modulyDoklObch = _modulyDoklObch || ',''OBV''';
    END IF;

    _modulyLen = char_length(_modulyDoklObch);
    IF (_modulyLen > 0) THEN
      _modulyLen = _modulyLen - 1;
      _modulyDoklObch = substring(_modulyDoklObch from 2 for _modulyLen);
      _condModulyDoklObch = 'modul IN (' || _modulyDoklObch || ')';
    ELSE
      _condModulyDoklObch = NULL;
    END IF;

    -- Provedeni dotazu
    -- 1) dDoklFak
    IF (_condModulyDoklFak IS NOT NULL) THEN
      _query = 'UPDATE ddoklfak SET zamekk = ''' || NEW.zamekk || ''', lastupdate = now() ' ||
         'WHERE ' || _condModulyDoklFak || ' AND ' || _cond || ';';
      --RAISE NOTICE 'Query is %', _query;
      EXECUTE _query;
    END IF;

    -- 2) dDoklInt
    IF (_condModulyDoklInt IS NOT NULL) THEN
      _query = 'UPDATE ddoklint SET zamekk = ''' || NEW.zamekk || ''', lastupdate = now() ' ||
         'WHERE ' || _condModulyDoklInt || ' AND ' || _cond || ';';
      --RAISE NOTICE 'Query is %', _query;
      EXECUTE _query;
    END IF;

    -- 3) dDoklSklad
    IF (_condModulyDoklSklad IS NOT NULL) THEN
      _query = 'UPDATE ddoklsklad SET zamekk = ''' || NEW.zamekk || ''', lastupdate = now() ' ||
         'WHERE ' || _condModulyDoklSklad || ' AND ' || _cond || ';';
      --RAISE NOTICE 'Query is %', _query;
      EXECUTE _query;
    END IF;

    -- 4) dDoklObch
    IF (_condModulyDoklObch IS NOT NULL) THEN
      _query = 'UPDATE ddoklobch SET zamekk = ''' || NEW.zamekk || ''', lastupdate = now() ' ||
         'WHERE ' || _condModulyDoklObch || ' AND ' || _cond || ';';
      --RAISE NOTICE 'Query is %', _query;
      EXECUTE _query;
    END IF;

    -- 5) mMajetek
    IF (NEW.modulmaj = TRUE) THEN
      _condTmp = _cond;
      IF (_condTmp  IS NOT NULL) THEN
        _condTmp = replace(_condTmp, 'datvyst', 'datzar');
      END IF;
      _query = 'UPDATE mmajetek SET zamekk = ''' || NEW.zamekk || ''', lastupdate = now() ' ||
         'WHERE ' || _condTmp || ';';
      --RAISE NOTICE 'Query is %', _query;
      EXECUTE _query;
    END IF;

  END IF;

  RETURN NEW;
END;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.wzamkynastavzamky() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 192, 't');
