-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$  
declare  
  _doklad record;  
  _polDokl record;  
  _doklSklad record;  
  _idDoklSklad integer;  
  _cisDoklad character varying;  
  _idrada integer;  
  _rada record;  
  _sklad record;  
  _idUcetObd integer;  
  _radaRok record;  
  _typPohybuSklad character varying;  
  _idTypUcOp integer;  
  _cisloDokladuCursor refCursor;  
  _typDoklFak record;  
  _idUcetSklad integer;  
  _idProtiUcet integer;  
  _typUcOp record;  
  _kurz numeric(19,6);  
  _idMenyTuzemsko integer;  
  _idMenySklad integer;  
  _kurzMnozstvi integer;  
  _typVazby character varying;  
begin  
  if(_modul like 'POK') then  
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
  elsif (_modul like 'FAV' or _modul like 'FAP') then  
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
  else  
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;  
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;  
  end if;  
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else  
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _sklad.idRadyPrijem; 
    _idTypUcOp = _sklad.idTypUcOpP; 
  else 
    _idrada = _sklad.idRadyVydej; 
    _idTypUcOp = _sklad.idTypUcOpV; 
  end if; 
   
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
   
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;    
  if (_idMenyTuzemsko is null) then    
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;     
  end if;    
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;    
    
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then    
    _kurz = 0.0; 
    _kurzMnozstvi = 1;    
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy   
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and cenotvorba = false  
      order by PlatiOdData desc limit 1;    
    if(_kurz is null) then    
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy  
        where idMeny = _sklad.idMeny and PlatiOdData is null and cenotvorba = false  
        limit 1;    
    end if;    
    if(_kurz is null) then    
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
   
  -- vytvoreni noveho skladoveho dokladu  
  insert into dDoklSklad (idDoklSklad, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, ucetni,   
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,  
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,   
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,  
         eanKod, idstatpuvod, idstatodesl,  
         idPrimUcet, idProtiUcet, idRady, idPolRady 
         )  
       values (_idDoklSklad, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _sklad.idTypDokl, _sklad.ucetni,   
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,  
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,   
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,   
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,  
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok  
         );  
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
   
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION szmencenynapolsklad(i_polskladid integer, i_skladkartaid integer, i_doklskladid integer)
  RETURNS void AS
$BODY$     
declare    
  /* Deklarace promennych */    
  _MnozMJ numeric(19,6);   
  _CenaMJOld numeric(19,6);    
  _SumZkl numeric(19,2);    
  _SumZklMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);   
  _PrumCena numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatVyst date;   
  _CiziMena boolean;     
  zaznam record;   
  _KurzSkladKarty numeric(19,6);    
  _KurzDokladu numeric(19,6); 
  tmp_polsklad_exists boolean; 
      
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK, DatVyst from dDoklSklad where idDoklSklad = i_DoklSkladId;  
  declare ThisPolSklad cursor for select MnozMJ, CenaMJ from dPolSklad  where idPolSklad = i_PolSkladId;  
  declare ThisSkladKarta cursor for select PrumCenaTuz,PrumCenaMen from sKarty where idKarty = i_SkladKartaId;  
  declare ThisPolSkladSum cursor for select SumZkl, SumZklMen from dPolSklad where idDoklSklad = i_DoklSkladId;     
begin  
  /* Zjisteni typPohybuK */  
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK, _DatVyst;   
  close ThisDoklSklad;   
  
  /* Zjisteni mnozstvi jednotek */  
  open ThisPolSklad;   
  fetch ThisPolSklad into _MnozMJ, _CenaMJOld;   
  close ThisPolSklad;   
  
  /* Nacteni dat ze skladove karty */  
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _PrumCenaTuz,_PrumCenaMen;   
  close ThisSkladKarta;  
    
  if _TypPohybuK = 'typPohybu.vydej' then  
    --_KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));   
    _KurzDokladu := (select getKurzFromDoklad(i_DoklSkladId, _DatVyst));   
    _PrumCena := _PrumCenaTuz / _KurzDokladu;
    --_CiziMena := (select isDoklSkladMenaCizi(i_DoklSkladId, _DatVyst));   
    --if _CiziMena then   
    --  _PrumCena := _PrumCenaMen;   
    --else   
    --  _PrumCena := _PrumCenaTuz;   
    --end if;   

    _SumZkl := _PrumCenaTuz * _MnozMJ;
    _SumZklMen := 0;
    if(_KurzDokladu <> 1.0) then
      _sumZklMen := _PrumCena * _MnozMJ;
    end if;
    tmp_polsklad_exists := (select istableexist('tmp_polsklad'));
    if(tmp_polsklad_exists) then
      insert into tmp_polsklad(idpolsklad) values (i_polskladid);
      update dPolSklad set    
        cenaMJ = _PrumCena,   
        sumZkl = _SumZkl, 
        sumZklMen = _SumZklMen 
        where    
        idPolSklad = i_PolSkladId;   
    end if;
    /* Nacteni novych souctu na skladovem dokladu */  
    execute sPrepoctiSumyDokladu(i_doklskladid);
  end if;  
end;  
$BODY$
    LANGUAGE plpgsql;
ALTER FUNCTION public.szmencenynapolsklad(i_polskladid integer, i_skladkartaid integer, i_doklskladid integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION createPolSklad(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;  
begin
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;
  
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad;
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad;
      
  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _prumCenaTuz;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;
  
  select nextval('seq_dpolsklad') into _idPolSklad;  
  insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,   
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,  
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, 
        idStred, idZakazky, idMeny)  
      values (_idPolSklad, _polDokl.idcenik, _polDokl.idskladu, _idkarty, _polDokl.datVyst, _polDokl.datUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,   
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, _polDokl.mnozBaleni,   
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true, 
        _polDokl.idStred, _polDokl.idZakazky, _idMeny);  
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION fillPolSklad(_idPolSklad integer, _idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;
  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _prumCenaTuz;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if; 
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;
  
  update dPolSklad set 
    cenaMj = _cenaMj, 
    mnozMj = _mnozMj, 
    sumZkl = _sumZkl, 
    sumZklMen = _sumZklMen, 
    nazev = _polDokl.nazev, 
    nazevA = _polDokl.nazevA, 
    nazevB = _polDokl.nazevB, 
    nazevC = _polDokl.nazevC, 
    datVyst = _polDokl.datVyst, 
    baleniId = _polDokl.baleniId, 
    mnozBaleni = _polDokl.mnozBaleni, 
    sarze = _polDokl.sarze, 
    expirace = _polDokl.expirace, 
    cisRad = _polDokl.cisRad, 
    eankod = _polDokl.eanKod, 
    idmj = _polDokl.idmj, 
    idStred = _polDokl.idStred, 
    idMeny = _polSklad.idMeny, 
    idZakazky = _polDokl.idZakazky, 
    idZklMdUcet = _idZklMdUcet, 
    idZklDalUcet = _idZklDalUcet,
    ucetni = true
    where idPolSklad = _idPolSklad;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: sprepoctisumydokladu(integer)
-- DROP FUNCTION sprepoctisumydokladu(integer);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2);  
 _sumZklMen numeric(15,2);   
begin 
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false; 
 if(_sumZkl is null) then _sumZkl = 0.0; end if;
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if;
 update dDoklSklad set sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen where idDoklSklad = i_idDoklSklad; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer) OWNER TO %firmaRole%;

-- Function: sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer)

-- DROP FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer);

CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$     
/* Prepocte stavy na skladove karte s id = iSkladKartaId */     
declare     
  /* Deklarace promennych */     
  _PomMnozMJ numeric(19,6);     
  _StavMJ numeric(19,6);     
  _StavTuz numeric(19,2);     
  _StavMen numeric(19,2);     
  _PrumCenaTuz numeric(19,6);     
  _PrumCenaMen numeric(19,6);     
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _TypPohybuK varchar(50);     
  _DatPosl date;     
  _kurzSkladKarty numeric(19,6);    
  _kurzDokladu numeric(19,6);    
  loc_MnozMJ numeric(19,6);    
  _sklzapor boolean;   
  _sklfifo boolean;     
    
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */    
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;    
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;      
begin    
  loc_MnozMJ:= i_MnozMJ;    
    
  /* Nacteni dat ze skladove karty */    
  open ThisSkladKarta;    
  fetch ThisSkladKarta into _StavMJ,    
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;    
  close ThisSkladKarta;    
      
  /* Zjisteni typPohybuK */    
  open ThisDoklSklad;    
  fetch ThisDoklSklad into _TypPohybuK;    
  close ThisDoklSklad;    
   
  /* zjisteni meny skladove karty */   
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));   
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));   
     
  /* pokud jde o vydej musim odecitat */    
  if _TypPohybuK = 'typPohybu.vydej' then    
    loc_MnozMJ:= 0-loc_MnozMJ;    
  end if;    
      
  /* Vypocet StavMJ */    
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;    
   
  if _StavMJ < 0 then   
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;   
	if (_sklzapor is null) then   
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;    
	end if;   
    if _sklzapor is null or _sklzapor = false then   
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/   
    end if;   
  end if;   
	   
      
  /* Vypocet StavTuz */    
  if loc_MnozMJ = 0 then    
    _PomMnozMJ:=1;    
  else    
    _PomMnozMJ:=loc_MnozMJ;    
  end if;    
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu); 
  /* Vypocet StavMen */    
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;    
   
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/   
  if _TypPohybuK = 'typPohybu.prijem' then 
    /* Vypocet PrumCenaTuz */    
    if _StavMJ > 0 then    
      _PrumCenaTuz:=_StavTuz/_StavMJ;    
    end if;    
    /* Vypocet PrumCenaMen */    
    if _StavMJ > 0 then    
      _PrumCenaMen:=_StavMen/_StavMJ;    
    end if;    
  end if;    
    
  /* Prepocteni stavu skladu pro FIFO */ 
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost   
  --_sklfifo := (select isfifosklad(i_DatVyst));   
  --if (_sklfifo) then   
    if(_StavMJ <> 0.0) then  
      _PrumCenaTuz := _StavTuz / _StavMJ;   
      _PrumCenaMen := _StavMen / _StavMJ;  
    end if;  
  --end if;   
    
  /* Nastaveni posledni ceny */    
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;   
  _PoslCenaMen:= i_CenaMJ;    
   
  /* Nastaveni data posledniho pohybu na karte */    
  if _DatPosl is null then    
    _DatPosl:= i_DatVyst;    
  end if;    
  if _DatPosl < i_DatVyst then    
    _DatPosl:=i_DatVyst;    
  end if;    
   
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl where    
      idKarty = i_SkladKartaId;    
  end if;
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


-- nastaveni verze vytvorene databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 207, 't');
