DROP FUNCTION if exists szapoctidominulosti(numeric, numeric, date, integer, integer, integer, integer);

CREATE OR REPLACE FUNCTION szapoctidominulosti(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer,i_skladid integer, i_nasobic integer, i_polSkladId integer)
  RETURNS void AS
$BODY$ 
begin 
  execute sNastavStavKartyDne(i_SkladKartaId,i_DatVyst, i_polSkladId); 
  execute sPrepoctiSkladKartu(i_MnozMJ,i_CenaMJ,i_DatVyst,i_SkladKartaId,i_DoklSkladId,i_skladid,i_Nasobic); 
  execute sZapoctiPolozkyOdData(i_SkladKartaId,i_DatVyst, i_polSkladId); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION public.szapoctidominulosti(numeric, numeric, date, integer, integer, integer, integer, integer) OWNER TO %firmaRole%;


DROP FUNCTION if exists snastavstavkartydne(integer, date);

CREATE OR REPLACE FUNCTION snastavstavkartydne(i_skladkartaid integer, i_datum date, i_polSkladId integer)
  RETURNS void AS
$BODY$ 
declare 
  zaznam Record; 
begin 
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > i_polSkladId)) 
  and idKarty = i_SkladKartaId order by DatVYst asc loop 
    execute sOdectiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idskladu,-1); 
  end loop; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION public.snastavstavkartydne(integer, date, integer) OWNER TO %firmaRole%;


DROP FUNCTION if exists szapoctipolozkyoddata(integer, date);

CREATE OR REPLACE FUNCTION szapoctipolozkyoddata(i_skladkartaid integer, i_datum date, i_polSkladId integer)
  RETURNS void AS
$BODY$ 
declare 
  zaznam Record; 
begin 
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > i_polSkladId))
  and idKarty = i_SkladKartaId order by DatVYst asc LOOP
    execute sZmenCenyNaPolSklad(zaznam.idPolSklad, i_SkladKartaId, zaznam.iddoklsklad); 
    execute sPrepoctiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idSkladu,1); 
  end loop; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION public.szapoctipolozkyoddata(integer, date, integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
begin 
  execute sZapoctiDoMinulosti(NEW.MnozMJ,NEW.CenaMJ,NEW.DatVyst,NEW.idKarty,NEW.idDoklSklad,NEW.idSkladu,1, NEW.idPolSklad); 
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;
  
drop trigger if exists dPolSkladInsert on dpolsklad;

create trigger dPolSkladInsert before insert on dpolsklad
for each row execute procedure dPolSkladInsert();


CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
begin 
  if OLD.storno = false then
    execute sZapoctiDoMinulosti(OLD.MnozMJ,OLD.CenaMJ,OLD.DatVyst,OLD.idKarty,OLD.idDoklSklad,OLD.idSkladu,-1, OLD.idPolSklad); 
  end if;
  if NEW.storno = false then
    execute sZapoctiDoMinulosti(NEW.MnozMJ,NEW.CenaMJ,NEW.DatVyst,NEW.idKarty,NEW.idDoklSklad,NEW.idSkladu,1, NEW.idPolSklad); 
  end if;
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

drop trigger if exists dPolSkladUpdate on dpolsklad;

create trigger dPolSkladUpdate before update on dpolsklad
for each row execute procedure dPolSkladUpdate();


CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$ 
declare 
begin 
  if OLD.storno = false then
    execute sZapoctiDoMinulosti(OLD.MnozMJ,OLD.CenaMJ,OLD.DatVyst,OLD.idKarty,OLD.idDoklSklad,OLD.idSkladu,-1, OLD.idPolSklad); 
  end if;
   
  return OLD; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

drop trigger if exists dPolSkladDelete on dpolsklad;

create trigger dPolSkladDelete before delete on dpolsklad
for each row execute procedure dPolSkladDelete();


-- zvyseni cisla verze db
insert into dbversion(iddbversion, dbversion, needreimport)
        values (nextval('seq_dbversion'), 21, 't');