--------------------------------------------------------------------------------
-- Bug 15642 – [WinStrom] Triggery pro automatickou generaci mzdových složek
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpomandmesic(_idpracpom integer, _rok integer, _mesic integer)
  RETURNS void AS $$
declare
  _datum date;
  _datumpo date;
  _idosoba integer;
begin
  _datum = date (_rok || '-' || _mesic || '-01');
  _datumpo = _datum + interval '1 month';
  
  select idosoba into _idosoba from ppracpomhlav where idpracpomhlav = _idpracpom;

  -- vystupni slozky
  -- jiz se negeneruji, vytvari se pri vypoctu
  
  -- stale slozky
  perform pupdatemzdslozfromstalasloz(pcreatemzdslozfromcis(idcismzdsloz, _idpracpom, _idosoba, _rok, _mesic), idstalamzdsloz)
      from pstalamzdsloz as S where idpracpom = _idpracpom
        and (datumod is null or (datumod < _datumpo)) and (datumdo is null or (datumdo >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idstalamzdsloz = S.idstalamzdsloz) = 0;
  
  -- srazky
  perform pupdatemzdslozfromsrazka(pcreatemzdslozfromcis(idcismzdsloz, null, _idosoba, _rok, _mesic), idsrazka)
      from psrazka as S where idosoba = _idosoba
        and (srazkaod is null or (srazkaod < _datumpo)) and (srazkado is null or (srazkado >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idsrazka = S.idsrazka) = 0;
  
  -- odecitatelne polozky
  perform pupdatemzdslozfromodecitpol(pcreatemzdslozfromcis(idcismzdsloz, null, _idosoba, _rok, _mesic), idodecitpol)
      from podecitpol as O where idosoba = _idosoba
        and (platiod is null or (platiod < _datumpo)) and (platido is null or (platido >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idodecitpol = O.idodecitpol) = 0;
  
  -- smeny
  perform pgeneratesmenyforpracpom(_idpracpom, _rok, _mesic);
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpomandmesic(integer, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 240, 't');
