---------------------------------------------------------------------
-- Bug 18875 – [WinStrom] Pri hromadne fakturaci se vygeneruje automaticka vydejka
---------------------------------------------------------------------

-- vypnuti skladovych triggeru
alter table dpolsklad disable trigger all;
alter table dpolfak disable trigger all;
alter table dpolint disable trigger all;

-- doplneni a spravne nastaveni pole zdrojProFak na hlavicky skladovych dokladu
alter table ddoklsklad add column zdrojProFak boolean NOT NULL DEFAULT true;

-- pridani pole pro lokalizovany ciselnik stav skladu
alter table ddoklsklad add column stavSkladK character varying(50);

--update ddoklsklad set zdrojProFak = false where iddoklsklad in (select idTabB from dvazebtab where typVazbyK = 'typVazbyDokl.hlavaSkl' and modulB = 'SKL' and (modulA = 'FAV' or modulA = 'FAP')
--      and idTabA in (select idDoklFak from dDoklFak where generovatSkl = true));
update ddoklsklad ds set zdrojProFak = false, stavSkladK = 'stavSklad.vygenFakt'
      from dVazebTab vd, dDoklFak df
      where ds.idDoklSklad = vd.idTabB and vd.modulB = 'SKL' and (vd.modulA = 'FAV' or vd.modulA = 'FAP') and vd.typVazbyK = 'typVazbyDokl.hlavaSkl' and vd.idTabA = df.idDoklFak and df.generovatSkl = true;
--update ddoklsklad set zdrojProFak = false where iddoklsklad in (select idTabB from dvazebtab where typVazbyK = 'typVazbyDokl.hlavaSkl' and modulB = 'SKL' and modulA = 'POK'
--      and idTabA in (select idDoklInt from dDoklInt where generovatSkl = true));
update ddoklsklad ds set zdrojProFak = false, stavSkladK = 'stavSklad.vygenPokl'
      from dVazebTab vd, dDoklInt di
      where ds.idDoklSklad = vd.idTabB and vd.modulB = 'SKL' and vd.modulA = 'POK' and vd.typVazbyK = 'typVazbyDokl.hlavaSkl' and vd.idTabA = di.idDoklInt and di.generovatSkl = true;

-- naplneni pole stav sklad
-- nastaveni prevodky
update ddoklsklad ds set zdrojProFak = false, stavSkladK = 'stavSklad.prevodka'
      from dVazebTab vd
      where (ds.idDoklSklad = vd.idTabA or ds.idDoklSklad = vd.idTabB) and vd.modulA = 'SKL' and vd.modulB = 'SKL' and vd.typVazbyK = 'typVazbyDokl.hlavaSklPrevod';
-- nastaveni vyroby
update ddoklsklad ds set zdrojProFak = false, stavSkladK = 'stavSklad.vyroba'
      from dVazebTab vd
      where (ds.idDoklSklad = vd.idTabA or ds.idDoklSklad = vd.idTabB) and vd.modulA = 'SKL' and vd.modulB = 'SKL' and vd.typVazbyK = 'typVazbyDokl.hlavaSklKus';
-- nastaveni uhrazeno fakturou ze skladu
update ddoklsklad ds set stavSkladK = 'stavSklad.vyfakt'
      from dVazebTab vd, dDoklFak df
      where ds.idDoklSklad = vd.idTabB and vd.modulB = 'SKL' and (vd.modulA = 'FAV' or vd.modulA = 'FAP') 
         and vd.typVazbyK = 'typVazbyDokl.hlavaSkl' and vd.idTabA = df.idDoklFak and df.generovatSkl = false and ds.hromFakt = false;
-- nastaveni uhrazeno hromadnou fakturou ze skladu
update ddoklsklad ds set stavSkladK = 'stavSklad.vyfaktHrom'
      from dVazebTab vd, dDoklFak df
      where ds.idDoklSklad = vd.idTabB and vd.modulB = 'SKL' and (vd.modulA = 'FAV' or vd.modulA = 'FAP') 
         and vd.typVazbyK = 'typVazbyDokl.hlavaSkl' and vd.idTabA = df.idDoklFak and df.generovatSkl = false and ds.hromFakt = true;
-- nastaveni uhrazeno pokladnou ze skladu
update ddoklsklad ds set zdrojProFak = false, stavSkladK = 'stavSklad.uhrazen'
      from dVazebTab vd, dDoklInt di
      where ds.idDoklSklad = vd.idTabB and vd.modulB = 'SKL' and vd.modulA = 'POK' and vd.typVazbyK = 'typVazbyDokl.hlavaSkl' and vd.idTabA = di.idDoklInt and di.generovatSkl = false;

-- prejmenovani chybne pojmenovaneho pole generovatSkl na zdrojProSkl aby se nepletlo s generovatSkl na typu dokladu
alter table ddoklfak rename column generovatSkl to zdrojProSkl;
alter table ddoklint rename column generovatSkl to zdrojProSkl;

-- doplneni pole generovatSkl na fakturu a pokladu tak ze se naplni z typu dokladu
alter table ddoklfak add column generovatSkl boolean NOT NULL DEFAULT true;
alter table ddoklint add column generovatSkl boolean NOT NULL DEFAULT true;
--update ddoklfak set generovatSkl = false where idTypDokl in (select idTypDokl from dTypDokl where generovatSkl = false);
update ddoklfak df set generovatSkl = false
      from dTypDokl td
      where td.generovatSkl = false and td.idTypDokl = df.idTypDokl;
--update ddoklint set generovatSkl = false where idTypDokl in (select idTypDokl from dTypDokl where generovatSkl = false);
update ddoklint df set generovatSkl = false
      from dTypDokl td
      where td.generovatSkl = false and td.idTypDokl = df.idTypDokl;

-- pridani potrebnych policek na polozky faktury a pokladny a jejich sp[ravne naplneni hodnotou z hlavicky
alter table dpolfak add column zdrojProSkl boolean NOT NULL DEFAULT true;
alter table dpolint add column zdrojProSkl boolean NOT NULL DEFAULT true;
alter table dpolsklad add column zdrojProFak boolean NOT NULL DEFAULT true;
--update dpolfak set zdrojProSkl = false where iddoklfak in (select idDoklFak from dDoklFak where zdrojProSkl = false);
update dpolfak pf set zdrojProSkl = false
      from ddoklfak df
      where pf.idDoklFak = df.idDoklFak and df.zdrojProSkl = false;
--update dpolint set zdrojProSkl = false where iddoklint in (select idDoklInt from dDoklInt where zdrojProSkl = false);
update dpolint pi set zdrojProSkl = false
      from ddoklint di
      where pi.idDoklInt = di.idDoklInt and di.zdrojProSkl = false;
--update dpolsklad set zdrojProFak = false where iddoklsklad in (select idDoklSklad from dDoklSklad where zdrojProFak = false);
update dpolsklad ps set zdrojProFak = false
      from ddoklsklad ds
      where ps.idDoklSklad = ds.idDoklSklad and ds.zdrojProFak = false;

-- povoleni skladovych triggeru
alter table dpolint enable trigger all;
alter table dpolfak enable trigger all;
alter table dpolsklad enable trigger all;

-- opravy triggeru a ulozenych procedur

-- Function: dpoldoklinsertsklad()
-- DROP FUNCTION dpoldoklinsertsklad();
CREATE OR REPLACE FUNCTION dpoldoklinsertsklad()
  RETURNS trigger AS
$BODY$ 
declare 
  pocetNavazanychDokladu integer; 
  _idPolFak integer; 
  _idDoklFak integer; 
  _idPolSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _sadaItemCount integer;  
begin 
 
  if(NEW.typPolozkyK like 'typPolozky.katalog') then 
    if(NEW.modul like 'POK') then 
      _idPolFak = NEW.idPolInt; 
      _idDoklFak = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt); 
    else 
      _idPolFak = NEW.idPolFak; 
      _idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    end if; 
 
    select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
    if ((_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek')  
      and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then 
      select count(*) into pocetNavazanychDokladu from dvazebtab where 
        typVazbyK like 'typVazbyDokl.hlavaSkl' 
        and ( 
        (idTabA = _idDoklFak and modulA like NEW.modul) 
        or 
        (idTabB = _idDoklFak and modulB like NEW.modul)); 
 
      if(pocetNavazanychDokladu > 2) then 
        --neco jeste nevim co 
      else 
        if(_sadaItemCount > 0) then 
          execute createPolSkladSada(_idPolFak, NEW.modul); 
        else 
          select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad;  
        end if; 
      end if; 
    end if; 
  end if; 
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;







-- Function: dpoldoklupdatesklad()
-- DROP FUNCTION dpoldoklupdatesklad();
CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer; 
begin 
  if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
    return NEW; 
  end if; 
 
  if(NEW.modul like 'POK') then 
    _idPolDokl = NEW.idPolInt; 
    _idDoklad = NEW.idDoklInt; 
    select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
    select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
    select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
  elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
    _idPolDokl = NEW.idPolFak; 
    _idDoklad = NEW.idDoklFak; 
    select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
    select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
    select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
  else  
    return NEW;   
  end if; 
 
  -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
  -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
  if((NEW.idSkladu <> OLD.idSkladu or NEW.idCenik <> OLD.idCenik  
     or NEW.typPolozkyK <> OLD.typPolozkyK or NEW.mnozMj <> OLD.mnozMj 
     or NEW.sarze <> OLD.sarze or NEW.expirace <> OLD.expirace) 
     and _dokladGenerovatSkl and NEW.zdrojProSkl) then  
    --raise exception 'mazu polSklad'; 
    execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
  end if; 
 
  if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then  
    select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
    if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
      if(_idPolSklad is null) then 
        --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
        if(_sadaItemCount > 0) then 
          execute createPolSkladSada(_idPolDokl, NEW.modul); 
        else 
          select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
        end if; 
      else 
        if(_sadaItemCount > 0) then 
          execute fillPolSkladSada(_idPolDokl, NEW.modul); 
        else 
          select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
        end if; 
      end if; 
      -- provedeni upgradu vyrobnich cisel 
      if(NEW.modul like 'FAV') then 
        for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak loop 
          update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
        end loop; 
      end if; 
      if(NEW.modul like 'FAP') then 
        for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak loop 
          update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
        end loop; 
      end if; 
      if(NEW.modul like 'POK') then 
        select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
        if(_typPohybuK like 'typPohybu.prijem') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        else 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
      end if; 
 
    end if; 
    -- prepocteni sum na dokladu 
    select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
    execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst); 
  end if; 
 
  return NEW; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;



-- Function: createpolskladsada(integer, character varying)
-- DROP FUNCTION createpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean; 
  _nasobic integer; 
  _idSkladu integer;  
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if; 
 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;  
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.typZasobyK like 'typZasoby.skladem' or _cenik.typZasobyK like 'typZasoby.vyrobek') then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
 
      _idSkladu = _polDokl.idSkladu; 
 
      select * into _skladKarta from skarty  
        where idTypDokl = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;  
 
      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
      if(_skladKarta is null) then 
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu; 
        select * into _skladKarta from skarty 
          where idTypDokl = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi; 
        if(_skladKarta is null) then 
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
        end if; 
      end if; 
        
      _nasobic = 1; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        _nasobic = -1; 
      end if; 
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
      select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;  
      if(_idZklMdUcet is null) then  
        select idProtiUcetV into _idZklMdUcet from uTypUcOp where idTypUcOp = (select idTypUcOpV from dTypDokl where idTypDokl = _polDokl.idSkladu);  
      end if;  
   
      _idZklDalUcet = _sklad.idPrimUcet; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,     
          mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,    
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,   
          idStred, idZakazky, idMeny, zdrojProFak)    
        values (_idPolSklad, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, 0.0, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,   
          _polDokl.idStred, _polDokl.idZakazky, _idMeny, false); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)   
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');   
    end if;  
  END LOOP;  
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying) OWNER TO %firmaRole%;



-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
begin 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _prumCenaTuz; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,    
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,   
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
        idStred, idZakazky, idMeny, zdrojProFak)   
      values (_idPolSklad, _polDokl.idcenik, _polDokl.idskladu, _idkarty, _polDokl.datVyst, _polDokl.datUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, _polDokl.mnozBaleni,    
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,  
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false);   
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;


-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$  
declare  
  _doklad record;  
  _polDokl record;  
  _doklSklad record;  
  _idDoklSklad integer;  
  _cisDoklad character varying;  
  _idrada integer;  
  _rada record;  
  _sklad record;  
  _idUcetObd integer;  
  _radaRok record;  
  _typPohybuSklad character varying;  
  _idTypUcOp integer;  
  _cisloDokladuCursor refCursor;  
  _typDoklFak record;  
  _idUcetSklad integer;  
  _idProtiUcet integer;  
  _typUcOp record;  
  _kurz numeric(19,6);  
  _idMenyTuzemsko integer;  
  _idMenySklad integer;  
  _kurzMnozstvi integer;  
  _typVazby character varying;  
  _stavSklad character varying;
begin  
  if(_modul like 'POK') then  
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _stavSklad = 'stavSklad.vygenPokl';
  elsif (_modul like 'FAV' or _modul like 'FAP') then  
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _stavSklad = 'stavSklad.vygenFakt';
  else  
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;  
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;  
    _stavSklad = 'stavSklad.vyroba';
  end if;  
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else  
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _sklad.idRadyPrijem; 
    _idTypUcOp = _sklad.idTypUcOpP; 
  else 
    _idrada = _sklad.idRadyVydej; 
    _idTypUcOp = _sklad.idTypUcOpV; 
  end if; 
   
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
   
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;    
  if (_idMenyTuzemsko is null) then    
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;     
  end if;    
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;    
    
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then    
    _kurz = 0.0; 
    _kurzMnozstvi = 1;    
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy   
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and cenotvorba = false  
      order by PlatiOdData desc limit 1;    
    if(_kurz is null) then    
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy  
        where idMeny = _sklad.idMeny and PlatiOdData is null and cenotvorba = false  
        limit 1;    
    end if;    
    if(_kurz is null) then    
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
   
  -- vytvoreni noveho skladoveho dokladu  
  insert into dDoklSklad (idDoklSklad, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, ucetni,   
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,  
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,   
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,  
         eanKod, idstatpuvod, idstatodesl,  
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK 
         )  
       values (_idDoklSklad, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _sklad.idTypDokl, _sklad.ucetni,   
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,  
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,   
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,   
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,  
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad
         );  
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
   
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 286, 't');
