--------------------------------------------------------------------------------
-- Bug 19192 – [WinStrom] DE - zálohové doklady - nepřenáší se členění DE + nepřístupný předpis zaúčtování.
--------------------------------------------------------------------------------

-- Uložená procedura aktualizující tabulku daňové evidence pro interní doklad se zadaným id
create or replace function uUpdateDanEvid (in _idDoklInt integer) returns void as $$
declare
  doklInt record;
  tempRec record;
  podvoj boolean;
  navazaneDotaz varchar;
  vazeb integer;
  _danEvidK character varying(50);
  _idTypUcOp integer;
  _idStred integer;
  _idZakazky integer;
  nespadaDph character varying(50);
  _idDanEvid integer;
  _idDoklFak integer;
  castka numeric(15,2);
  castkaMen numeric(15,2);
  castkaZbyva numeric(15,2);
  castkaZbyvaMen numeric(15,2);
  castkaOdpocet numeric(15,2);
  castkaOdpocetMen numeric(15,2);
  zapocteno numeric(15,2);
  zapoctenoMen numeric(15,2);
  domaciMena integer;
  ciziMena boolean;
begin
  nespadaDph := 'danEvid.NeDanEvid';

  select * into doklInt from ddoklint where iddoklint = _idDoklInt;
  select podvojucto, idmeny into podvoj, domaciMena from nnastav where (platioddata is null or platioddata <= doklInt.datUcto) 
    order by coalesce(platioddata, '0001-01-01') desc limit 1;
  
  ciziMena := (doklInt.idMeny is not null and domaciMena <> doklInt.idMeny);
  
  if (doklInt.modul not in ('BAN', 'POK')) then
    return;
  end if;

  if (podvoj = false and doklInt.ucetni = true) then
    -- dotaz ktery nalezne veschny navazane faktury a navazane castky
    navazaneDotaz := '(select V.idDoklFak, sum(V.castka) as castka from
         (select idTabA as idDoklFak, castka from dvazebtab where typvazbyk in (''typVazbyDokl.uhrada'', ''typVazbyDokl.vazbaZDD'') and idtabb = ' || doklInt.idDoklInt || '
          union
          select idTabA as idDoklFak, (castka +
            (select coalesce(sum(P.sumzkl + P.sumdph), 0) from dpolfak as P inner join dVazebTab as V2 on P.idPolFak = V2.idtaba and V2.typVazbyK = ''typVazbyDokl.odpocetZALOHY'' where V2.idtabb = V.idtaba))
              as castka 
            from dvazebtab as V where typvazbyk = ''typVazbyDokl.uhradaZALOHY'' and idtabb = ' || doklInt.idDoklInt || '
              and (select count(*) from dvazebtab where typvazbyk = ''typVazbyDokl.vazbaZDD'' and idtabb = V.idtabb) = 0
          union
          select P.idDoklFak, coalesce(sum(-P.sumzkl - P.sumdph), 0) as castka from dpolfak as P inner join dVazebTab as VOdp on VOdp.idtaba = P.idpolfak and VOdp.typVazbyK = ''typVazbyDokl.odpocetZALOHY''
             inner join dVazebTab as VUhr on VUhr.idtaba = VOdp.idtabb and VUhr.typvazbyk = ''typVazbyDokl.uhradaZALOHY'' where VUhr.idtabb = ' || doklInt.idDoklInt || ' group by P.idDoklFak
          ) as V group by V.idDoklFak having sum(V.castka) <> 0)';
    
    execute 'select count(*) from ' || navazaneDotaz || ' as D' into vazeb;
  
    if (vazeb = 0) then			-- pro interni doklad neni vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is not null;           -- vymazeme ty co byli vytvorene pres vazbu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
             
      -- DPH
      select idDanEvid into _idDanEvid from uDanEvid where danEvidK = nespadaDph and idDoklInt = doklInt.idDoklInt;  -- zjistime zda uz zaznam existuje
      select coalesce(sum(sumDph),0),coalesce(sum(sumDphMen),0) into castka,castkaMen from dPolInt 
        where idDoklInt = doklInt.idDoklInt and storno = false;      -- secteme dane
      
      if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
        INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
          VALUES (nespadaDph, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
      else                                     -- zaznam jiz byl vytvoren, vynulujeme i zaklad pokud by jiz nebyl pouzit
        UPDATE uDanEvid SET sumDph = castka, sumDphMen = castkaMen, sumZkl = 0, sumZklMen = 0, kurz = doklInt.kurz, 
          kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
      end if;
    
      -- Zaklad
      for _danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen in select danEvidK, idTypUcOp, idStred, idZakazky, sum(sumZkl), sum(sumZklMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false group by danEvidK, idTypUcOp, idStred, idZakazky loop 
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = _danEvidK and idDoklInt = doklInt.idDoklInt
          and compareid(_idTypUcOp, idTypUcOp) and compareid(_idStred, idStred) and compareid(_idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        else                                     -- zaznam jiz byl vytvoren
          UPDATE uDanEvid SET sumZkl = castka, sumZklMen = castkaMen, kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi,
            idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop; 
    else				            -- pro interni doklad je vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is null;           -- smazeme polozky co nemaji vazbu na fakturu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
      
      drop table if exists tempDanEvid;
      
      CREATE TEMPORARY TABLE tempDanEvid
        (idDoklFak integer NOT NULL,
         danEvidK character varying(50),
         idTypUcOp integer,
         idStred integer,
         idZakazky integer,
         dan boolean DEFAULT false,
         kUhrade numeric(15,2) DEFAULT 0.0 NOT NULL,
         kUhradeMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazeno numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazenoMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         vazbaFak numeric(15,2) DEFAULT 0.0 NOT NULL
        );

      for tempRec in execute 'select * from ' || navazaneDotaz || ' as D' loop
        _idDoklFak = tempRec.idDoklFak;
        castka = tempRec.castka;
      
        select * into tempRec from dDoklFak where idDoklFak = _idDoklFak;
        if ((ciziMena = true and (tempRec.idMeny is null or tempRec.idMeny <> doklInt.idMeny)) 
         or (ciziMena = false and tempRec.idMeny is not null and tempRec.idMeny <> domaciMena)) then
          raise exception 'uUpdateDanEvid: Nesouhlasi meny dokladu';
        end if;
      
        -- zjistime kolik je treba na fakture uhradit a kolik je uhrazeno
        insert into tempDanEvid (idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) 
          select _idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, castka, sum(sumZkl), sum(sumZklMen), 
               (select coalesce(sum(sumZkl),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and 
                 compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),
               (select coalesce(sum(sumZklMen),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and
                 compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
           from dPolFak as P where idDoklFak = _idDoklFak and storno = false
             and typPolozkyK not in ('typPolozky.odpocetZalohy') group by danEvidK, idTypUcOp, idStred, idZakazky;
           
        -- dan
        insert into tempDanEvid (idDoklFak, danEvidK, dan, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) values (_idDoklFak, null, true, castka,   -- dan si oznacime jako null
           (select coalesce(sum(sumDph),0) from dPolFak where idDoklFak = _idDoklFak and storno = false 
              and typPolozkyK not in ('typPolozky.odpocetZalohy')),     -- castka dane dokladu
           (select coalesce(sum(sumDphMen),0) from dPolFak where idDoklFak = _idDoklFak and storno = false
              and typPolozkyK not in ('typPolozky.odpocetZalohy')),  -- castka dane dokladu v mene
           (select coalesce(sum(sumDph),0) from uDanEvid where idDoklFak = _idDoklFak),                             -- uhrazena dan dokladu
           (select coalesce(sum(sumDphMen),0) from uDanEvid where idDoklFak = _idDoklFak)                           -- uhrazena dan dokladu v mene
          );
      end loop;
      
      zapocteno := 0;
      zapoctenoMen := 0;
      
      for _idDoklFak,castka in select idDoklFak,vazbaFak from tempDanEvid group by idDoklFak,vazbaFak loop           -- prochazime navazene faktury
        castkaMen := castka;

        for tempRec in select * from tempDanEvid where idDoklFak = _idDoklFak order by (case when (kUhrade-uhrazeno) < 0 then -1 else 1 end), -- napred zaporny 
                                                                                              dan desc, danEvidK desc loop    -- sestupne aby null (dan) bylo prvni
        
          if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then                -- pokud jeste mame nejakou castku
            castkaZbyva := tempRec.kUhrade - tempRec.uhrazeno;
            castkaZbyvaMen := tempRec.kUhradeMen - tempRec.uhrazenoMen;
            
            if ((ciziMena = false and castkaZbyva <> 0) or (ciziMena = true and castkaZbyvaMen <> 0)) then    -- pokud na aktualnim zaznamu zbyva neco uhradit
              if ((ciziMena = false and castka > 0 and castkaZbyva > 0) or (ciziMena = true and castkaMen > 0 and castkaZbyvaMen > 0)) then
                castkaOdpocet := minValue(castka, castkaZbyva);      -- spocteme kolik budeme "odpocitavat"
                castkaOdpocetMen := minValue(castkaMen, castkaZbyvaMen);
              else
                if ((ciziMena = false and castka < 0 and castkaZbyva < 0) or (ciziMena = true and castkaMen < 0 and castkaZbyvaMen < 0)) then
                  castkaOdpocet := maxValue(castka, castkaZbyva);
                  castkaOdpocetMen := maxValue(castkaMen, castkaZbyvaMen);
                else
                  castkaOdpocet := castkaZbyva;
                  castkaOdpocetMen := castkaZbyvaMen;
                end if;
              end if;
              
              castka := castka - castkaOdpocet;                    -- odebereme to z odpocitatelne castky
              castkaMen := castkaMen - castkaOdpocetMen;
              zapocteno := zapocteno + castkaOdpocet;
              zapoctenoMen := zapoctenoMen + castkaOdpocetMen;
              
              if (ciziMena = true) then
                castkaOdpocet := castkaOdpocetMen * doklInt.kurz / doklInt.kurzmnozstvi;
              else
                castkaOdpocetMen := 0;
              end if;
              
              if (tempRec.dan) then        -- pokud se jedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and danEvidK = nespadaDph;  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (nespadaDph, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumDph = castkaOdpocet, sumDphMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              else                                      -- pokud se nejedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak 
                  and ((tempRec.danEvidK is null and danEvidK is null) or (danEvidK = tempRec.danEvidK))
                  and compareid(tempRec.idTypUcOp, idTypUcOp) and compareid(tempRec.idStred, idStred) and compareid(tempRec.idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (tempRec.danEvidK, tempRec.idTypUcOp, tempRec.idStred, tempRec.idZakazky, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumZkl = castkaOdpocet, sumZklMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              end if;
            
              --select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and
              --   ((tempRec.danEvidK is not null and danEvidK = tempRec.danEvidK) or (tempRec.danEvidK is null and danEvidK = nespadaDph));  -- zjistime zda uz zaznam existuje
            end if;
          end if;
        
        end loop;
        
        if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then
          if (ciziMena = true) then
            castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
          else
            castkaMen := 0;
          end if;
        
          -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
          select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
            where idDoklFak = _idDoklFak order by sumZkl desc limit 1;
          if _danEvidK is not null then
            INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
              VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
            zapocteno = zapocteno + castka;
            zapoctenoMen = zapoctenoMen + castkaMen;
          end if;
        end if;
      end loop;
      
      if ((ciziMena = false and zapocteno < doklInt.sumCelkem) or (ciziMena = true and zapoctenoMen < doklInt.sumCelkemMen)) then     -- pokud neni komplet sparovan
        castka = doklInt.sumCelkem - zapocteno;
        castkaMen = doklInt.sumCelkemMen - zapoctenoMen;
        if (ciziMena = true) then
          castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
        else
          castkaMen := 0;
        end if;
        
        -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
        select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
          where idDoklInt = doklInt.idDoklInt order by sumZkl desc limit 1;
        if _danEvidK is not null then
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        end if;
        
      end if;
      
    end if;
  end if;
  
  DELETE from uDanEvid WHERE idDoklInt = doklInt.idDoklInt and sumZkl = 0 and sumZklMen = 0 and sumDph = 0 and sumDphMen = 0;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.uUpdateDanEvid(integer) OWNER TO %firmaRole%;

-- trigger volaný při změně položky faktury - aktualizuje položky v daňové evidenci
CREATE OR REPLACE FUNCTION dpolfakupdatedanevid()
  RETURNS trigger AS $$
declare
  idDoklInt integer;
begin
  for idDoklInt in (
    select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD')
    union
    select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in
      (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabA in
        (select idPolFak from dPolFak where idDoklFak = NEW.idDoklFak))
  ) loop
    perform uUpdateDanEvid(idDoklInt);
  end loop;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdatedanevid() OWNER TO %firmaRole%;

-- trigger volaný při vytváření a mazání vazby mezi doklady - aktualizuje položky v daňové evidenci pokud se jedná o úhradu
CREATE OR REPLACE FUNCTION dvazebtabinsertdeletedanevid()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
  _idDoklInt integer;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  _idDoklInt := null;
  
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD')) then
    _idDoklInt := ZAZNAM.idTabB;
  end if;
  if (ZAZNAM.typvazbyk = 'typVazbyDokl.odpocetZALOHY') then
    select idTabB into _idDoklInt from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA = ZAZNAM.idTabB;
  end if;
  
  if (_idDoklInt is not null) then
    perform uUpdateDanEvid(_idDoklInt);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabinsertdeletedanevid() OWNER TO %firmaRole%;


-- prepocteme DE
create or replace function runupgrade()
    returns void as $$
declare
    _podvojUcto boolean;
begin
  select podvojucto into _podvojUcto from nnastav
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- prepocet danove evidence provedeme jen pro DE
  if (_podvojUcto = false) then
    perform uUpdateDanEvid(idDoklInt) from dDoklInt;
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 299, 't');
