-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _zaznam record; 
  _vyrobniCislo record; 
  _pocatek_ucetobd date; 
  _konec_ucetobd date; 
  _evidVyrCis boolean; 
  _mazatTmpTable boolean; 
  _citac integer;
  _pocetPred integer;
  _pocetPo integer;
begin 

  execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
  execute putglotxvariable('probihaPrepocetSkladu', 'true');
   
  -- nacteni datumu zacatku ucetniho obdobi 
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- smazani tabulky fifo vazeb 
  delete from sfifovazby where idpolskladvydej in  
    (select idpolsklad from dpolsklad where  
            datVyst >= _pocatek_ucetobd); 
 
  delete from sfifovazby f 
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); 
 
  -- nagenerovani pomocnych tabulek 
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable; 
 
  select count(*) into _pocetPred from tmp_RozsirenePolozky;
  
  -- provedu fifovani rozsirenych polozek
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej') then 
      select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;   
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik;  
      if (not _evidVyrCis) then  
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idSkladu, _zaznam.idKarty, _zaznam.mnozmj);  
      else  
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop  
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;  
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;  
        end loop;  
      end if;  
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);   
    end if;
  end loop; 

  --select count(*) into _pocetPo from tmp_RozsirenePolozky;
 
  -- vynulovani skladovych karet 
  execute skladVynulujSkladoveKarty(); 

  -- zafifovane veci zapoctu na skladove karty
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
  end loop;

  if(_mazatTmpTable) then 
    drop table tmp_RozsirenePolozky; 
    drop table tmp_SkladoveKarty; 
    execute removeglotxvariable('zurnalTxName');
    execute removeglotxvariable('probihaPrepocetSkladu'); 
  end if; 
 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;


-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$  
declare  
  _rozsirenaPolozka record;  
  _typPohybuk character varying;  
  _mazatTmpTable boolean;  
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
begin
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky  
    select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;  
  
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');   
  
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then  
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
      end if;  
    end loop;  
    
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
    end loop;  
    
    if(_mazatTmpTable) then  
      drop table tmp_RozsirenePolozky;  
      drop table tmp_SkladoveKarty;  
      execute removeglotxvariable('zurnalTxName');  
    end if;  
  end if;
  
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;    
  --pokud výdej, tak fifuju vazby    
  if (_typPohybuk = 'typPohybu.vydej') then    
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idSkladu, NEW.idKarty, NEW.mnozmj);    
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad);    
  end if; 

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- Bug 17557 – [WinStrom] Aktualizace kalkulačky na rok 2010
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
-- update inicializacnich radek kalkulacky
-- update radek kalkulacky
UPDATE pmzdcalc SET polein = 'zaklMzd;zaklMzd;zaklMzd', poleout = 'zaklMzd;procMzd;castkaDen' WHERE IdMzdCalc = 123;

-- pracovni pomery
-- parametry pro typ prac pom
UPDATE ptyppracpomparam SET poletest = 'castkaDen' WHERE IdTypPracPomParam = 9;

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 305, 't');
