--------------------------------------------------------------------------------
-- Bug 19541 – [winstrom] vydaná nabídka
--------------------------------------------------------------------------------

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklfifo boolean; 
  _mazatTmpTable boolean; 
  _idkarty integer; 
  _rozsirenaPolozka record; 
  _iducetobdobi integer; 
  _result numeric(19,6); 
  _pomocDPolSkladF record; 
  _mnozstvi numeric(19,6); 
  _potrebnyPocet numeric(19,6); 
  _sadaItemCount integer; 
  _polozkaSady record; 
  _pomoc numeric(19,6); 
begin 
  _result = 0.0; 
  _mnozstvi = 0.0; 
 
  if(i_mnozMj > 0) then 
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik;  
    if(_sadaItemCount > 0) then 
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP  
        -- TODO doresit sarze expirace a vyrobni cisla 
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null) into _pomoc; 
        _result = _result + _pomoc; 
      end loop; 
    else 
      select iducetobdobi into _iducetobdobi from nucetobdobi; 
      _sklfifo := (select isfifosklad(i_datum)); 
      if (_sklfifo) then 
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then 
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu 
          select cenaMj into _result from dpolskladf where idcenik = i_idcenik and idskladu = i_idskladu and idvyrobnicislo = i_idvyrobnihocisla; 
        elsif(i_sarze is not null and i_expirace is not null) then 
          -- pokud je zadana sarze i expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi; 
          else
            _result = 0.0;
          end if;
        elsif(i_sarze is not null and i_expirace is null) then 
          -- pokud je zadana jen sarze 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi; 
          else
            _result = 0.0;
          end if;
        elsif(i_sarze is null and i_expirace is not null) then 
          -- pokud je zadana jen expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi; 
          else
            _result = 0.0;
          end if;
        else 
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datVyst,idpolsklad) loop 
            if(i_mnozMj >= _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi; 
          else
            _result = 0.0;
          end if;
        end if; 
      else 
        -- generuji rozsirene polozky 
        select idkarty into _idkarty from skarty where idcenik = i_idcenik and idtypdokl = i_idskladu and iducetobdobi = _iducetobdobi; 
       
        -- bez pricteni +1 to pak vraci cenu na zacatku dne a my potrebujeme na konci dne (zacatku pristiho) 
        select skladGenerujRozsirenePolozky(i_datum + 1, -1, _idkarty) into _mazatTmpTable; 
 
        for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end loop; 
 
        select prumCenaTuz into _result from skarty where idKarty = _idKarty; 
     
        for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end loop; 
 
        if(_mazatTmpTable) then 
          drop table tmp_RozsirenePolozky; 
          drop table tmp_SkladoveKarty; 
        end if;  
      end if; 
    end if; 
  end if; 
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer) OWNER TO %firmaRole%;

----------------------------------------------------------
-- bug none - pridani indexu kvuli saldu
----------------------------------------------------------
create index idx_dvazebtab_idtaba on dvazebtab(idtaba);
create index idx_dvazebtab_idtabb on dvazebtab(idtabb);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 319, 't');