--------------------------------------------------------------------------------
-- Bug 19931 – [winstrom] - Upomínky
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wsablona
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wsablona OWNER TO %firmaRole%;

CREATE TABLE wsablona
(
  idSablony integer NOT NULL DEFAULT nextval('seq_wsablona'::regclass),
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  datum character varying(255),
  datuma character varying(255),
  datumb character varying(255),
  datumc character varying(255),
  hlavicka text,
  hlavickaa text,
  hlavickab text,
  hlavickac text,
  odberatel character varying(255),
  odberatela character varying(255),
  odberatelb character varying(255),
  odberatelc character varying(255),
  uvod text,
  uvoda text,
  uvodb text,
  uvodc text,
  textNad text,
  textNada text,
  textNadb text,
  textNadc text,
  textPod text,
  textPoda text,
  textPodb text,
  textPodc text,
  zapati text,
  zapatia text,
  zapatib text,
  zapatic text,
  typSablonyK character varying(50) not null,
  CONSTRAINT wsablona_pkey PRIMARY KEY (idSablony)
);
ALTER TABLE wsablona OWNER TO %firmaRole%;

create or replace function upgrade() returns void as
$BODY$
begin
    -- idstatuleg je konstantni po celou dobu trvani firmy
    -- ceske upominky
    if ((select max(idstatuleg) from nnastav) = (select idstatu from astaty where uuid = 'CZ_CZ')) then
        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Ze dne', 'Věc: Upomínka č. 1', 'Adresa odběratele',
            'Vážený odběrateli,', 'dovolujeme si připomenout, že jste dosud neuhradil následující fakturu(y)',
            'Věříme, že se tak stalo nedopatřením a dlužná částka bude uhrazena do 10 dnů od doručení této upomínky.', 'S pozdravem', 'typSablony.prvniUpominka');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Ze dne', 'Věc: Upomínka č. 2', 'Adresa odběratele',
            'Vážený odběrateli,', 'již jsme Vás jednou upomínali a nyní musíme konstatovat, že jste dosud neuhradil následující fakturu(y).',
            'Věříme, že naši pohledávku uhradíte obratem a to nejpozději do 5 dnů od doručení této upomínky.', 'S pozdravem', 'typSablony.druhaUpominka');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Ze dne', 'Věc: Upomínka č. 3 - pokus o smír', 'Adresa odběratele',
            'Vážený odběrateli,', 'již jsme Vás dvakrát upomínali o zaplacení následující faktur(y).',
            'Věříme, že naši pohledávku uhradíte obratem a to nejpozději do 5 dnů od doručení této upomínky. Pokud ani v tomto termínu fakturu neuhradíte, budeme nuceni částku vymáhat soudně a následně prostřednictvím exekutorského úřadu!', 'S pozdravem', 'typSablony.pokusOSmir');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Ze dne', 'Věc: Inventarizace pohledávek', 'Adresa odběratele',
            'Vážený odběrateli,', 'dovolujeme si Vám připomenout, že jste dosud neuhradil následující fakturu(y)',
            'Věříme, že se tak stalo nedopatřením a dlužná částka bude v brzké době uhrazena.', 'S pozdravem', 'typSablony.inventarizace');
    end if;

    -- slovenske upomienky
    if ((select max(idstatuleg) from nnastav) = (select idstatu from astaty where uuid = 'SK_SK')) then
        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Zo dňa', 'Prvá upomienka', 'Adresa odberateľe',
            'Vážený odběrateľ,', 'dovoľujeme si Vás upozorniť, že ste dosud neuhradil nasledujúcí faktúru(y)',
            'Verime, že se tak stalo nedopatrenim a dlžnú sumu uhradíte obratom a to najneskôr do 10 dní od doručení tejto upomienky.', 'S pozdravom', 'typSablony.prvniUpominka');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Zo dňa', 'Druhá upomienka', 'Adresa odberateľe',
            'Vážený odběrateľ,',  'už raz sme Vás upomienali a žiaľ s poľutovaním musíme konštatovať, že ste dosud neuhradil nasledujúcí faktúru(y)',
            'Verime, že dlžnú sumu uhradíte obratom a to najneskôr do 5 dní od doručení tejto upomienky.', 'S pozdravom', 'typSablony.druhaUpominka');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Zo dňa', 'Pokus o zmier',  'Adresa odberateľe',
            'Vážený odběrateľ,',  'už sme Vás dvakrát upomienali a sme sklamaní, že ste napriek dvěma predchádzajúcím upomienkam dosud neuhradil nasledujúcí faktúru(y)',
            'Upozorňujeme Vás, že ak svoj záväzok neuhradíte do 5 dní od doručení tejto upomienky, celú záležitosť budeme musieť riešiť súdnou cestou.', 'S pozdravom', 'typSablony.pokusOSmir');

        insert into wsablona(datum, hlavicka, odberatel, uvod, textNad, textPod, zapati, typSablonyK)
            values ('Zo dňa', 'Inventarizácia', 'Adresa odberateľe',
            'Vážený odběrateľ,', 'dovoľujeme si Vás upozorniť, že ste dosud neuhradil nasledujúcí faktúru(y)',
            'Verime, že se tak stalo nedopatrenim a dlžnú sumu uhradíte čo nejskôr', 'S pozdravom', 'typSablony.inventarizace');
    end if;
end;
$BODY$
LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION upgrade() OWNER TO %firmaRole%;
select upgrade();
drop function upgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 346, 't');

