--------------------------------------------------------------------------------
-- Bug 20468 – [WinStrom] Pridat pole datum udalosti vyrazeni na majetek
--------------------------------------------------------------------------------

ALTER TABLE mmajetek
    ADD COLUMN datudalvyr date;

create or replace function vyplnDatVyr() returns void as $$
declare
    _idmajetku integer;
    _datudalvyr date;
begin
    for _idmajetku in (select idmajetku from mmajetek) loop
        select datvyst into _datudalvyr
            from mudalosti ud
            where ud.idmajetku = _idmajetku
            and ud.typUdalostik = 'typUdal.uplVyr';

        if (_datudalvyr is not null) then
            update mmajetek 
                set datudalvyr = _datudalvyr
                where idmajetku = _idmajetku;
        end if;
    end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION vyplnDatVyr() OWNER TO %firmaRole%;

select vyplnDatVyr();

drop function vyplnDatVyr();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 375, 't');
