---------------------------------------------------------------------------------------
-- Bug 21155 – [winstrom] Majetek -Zrychlené odpisy - zařazení staršího - chybná generace odpisů
---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, cinnost integer, castka numeric, castkamen numeric)
  RETURNS void AS
$$
declare
  nRok integer;
  nObdobi integer;
  idUcetniObdobi integer;
  idMenyTuzemsko integer;
  id integer;
  puvodniMD numeric(15,2);
  puvodniDal numeric(15,2);
begin
  if ucetni = false or storno = true or datumucto is null or stredisko is null or castkamducet is null or castkadalucet is null then
    return;
  end if;

  select idMeny into idMenyTuzemsko from nNastav where (platiOdData is null or platiOdData <= datumucto)
    order by coalesce(platioddata, '0001-01-01') desc limit 1;

  nRok:= date_part('year', datumUcto);
  nObdobi:= date_part('month', datumUcto);

  select idUcetObdobi into idUcetniObdobi from nUcetObdobi where (datumUcto >= PlatiOdData and datumUcto <= PlatiDoData) limit 1;

  if(nRok is not null) and (nRok <> 0) and (nObdobi is not null) and (nObdobi <> 0) and (idMenyTuzemsko is not null) then

    /*dph tuzemsko*/
    if (castkaMdUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko and compareid(cinnost, idCinnost) for update; -- zamek !!!

      if (id is null) then
        insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
	         values(castkaMdUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, cinnost, 0.0, castka, idUcetniObdobi, now());
      else
        puvodniMD := puvodniMD + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrMD = obrMD + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    if (castkaDalUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko and compareid(cinnost, idCinnost) for update;

      if (id is null) then
        insert into uObraty (idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
           values(castkaDalUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, cinnost, castka, 0.0, idUcetniObdobi, now());
      else
        puvodniDal := puvodniDal + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrDal = obrDal + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    -- cizi mena, v pripade, ze se mena nema zapocitavat tak ma hodnotu -1
    if (mena <> -1) and mena <> idMenyTuzemsko then
          if(castkaMdUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena and compareid(cinnost, idCinnost) for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
                 values(castkaMdUcet, nRok, nObdobi, stredisko, mena, cinnost, 0.0, castkaMen, idUcetniObdobi, now());
            else
              puvodniMD := puvodniMD + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrMD = obrMD + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;

          if(castkaDalUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena and compareid(cinnost, idCinnost) for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
                 values(castkaDalUcet, nRok, nObdobi, stredisko, mena, cinnost, castkaMen, 0.0, idUcetniObdobi, now());
            else
              puvodniDal := puvodniDal + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrDal = obrDal + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;
    end if;

  else
    -- v pripade, ze dany objekt nema vyplneno datumUcto, nejsou hodnoty nastaveny a nezapocitavaji se do obratu
    if (datumUcto is not null) then
        raise exception 'aktualizace zaznamu tabulky uObraty: Neplatné vstupní hodnoty. % % %',idMenyTuzemsko,nRok,nObdobi;
    end if;
  end if;
end;
$$
  LANGUAGE plpgsql;
ALTER FUNCTION public.createorupdateobraty(boolean, boolean, date, integer, integer, integer, integer, integer, numeric, numeric) OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- Bug 21164 – [WinStrom] Mozne prepsani castek obratu
--------------------------------------------------------------------------------

create or replace function navazobratynaucetobdobi(_platioddata date, _platidodata date, _iducetobdobi integer)
  returns void as $$
declare
  _obdobiod integer;
  _obdobido integer;
  _rokod integer;
  _rokdo integer;
begin
  select extract(month from _platioddata) into _obdobiod;
  select extract(year from _platioddata) into _rokod;
  select extract(month from _platidodata) into _obdobido;
  select extract(year from _platidodata) into _rokdo;

  update uobraty set
    lastupdate = now(),
    iducetobdobi = _iducetobdobi
  where (rok > _rokod or (rok = _rokod and obdobi >= _obdobiod))
    and (rok < _rokdo or (rok = _rokdo and obdobi <= _obdobido));
end;
$$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION navazobratynaucetobdobi(date, date, integer) OWNER TO %firmaRole%;


create or replace function nucetniobdobiinsert()
  returns trigger as $$
begin
  execute navazobratynaucetobdobi(NEW.platioddata, NEW.platidodata, NEW.iducetobdobi);
  return NEW;
end;
$$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION nucetniobdobiinsert() OWNER TO %firmaRole%;

CREATE TRIGGER nucetniobdobiinsert
    AFTER INSERT ON nucetobdobi
    FOR EACH ROW
    EXECUTE PROCEDURE nucetniobdobiinsert();

create or replace function nucetniobdobiupdate()
  returns trigger as $$
declare
  minod date;
  maxod date;
  mindo date;
  maxdo date;
  iduo integer;
begin
  if (OLD.platioddata < NEW.platioddata) then
    minod = OLD.platioddata;
    maxod = NEW.platioddata;
    -- u obratu prvniho mesice zmeneneho obdobi nechceme nastavit iduo na null
    maxod = maxod - interval '1 month';
    iduo = null;
  else
    maxod = OLD.platioddata;
    minod = NEW.platioddata;
    iduo = NEW.iducetobdobi;
  end if;

  execute navazobratynaucetobdobi(minod, maxod, iduo);

  if (OLD.platidodata < NEW.platidodata) then
    mindo = OLD.platidodata;
    maxdo = NEW.platidodata;
    iduo = NEW.iducetobdobi;
  else
    maxdo = OLD.platidodata;
    mindo = NEW.platidodata;
    -- u obratu posledniho mesice zmeneneho obdobi nechceme nastavit iduo na null
    mindo = mindo + interval '1 month';
    iduo = null;
  end if;

  execute navazobratynaucetobdobi(mindo, maxdo, iduo);

  return NEW;
end;
$$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION nucetniobdobiupdate() OWNER TO %firmaRole%;

CREATE TRIGGER nucetniobdobiupdate
    AFTER UPDATE ON nucetobdobi
    FOR EACH ROW
    EXECUTE PROCEDURE nucetniobdobiupdate();

create or replace function nucetniobdobidelete()
  returns trigger as $$
begin
  execute navazobratynaucetobdobi(OLD.platioddata, OLD.platidodata, null);
  return OLD;
end;
$$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION nucetniobdobidelete() OWNER TO %firmaRole%;

CREATE TRIGGER nucetniobdobidelete
    BEFORE DELETE ON nucetobdobi
    FOR EACH ROW
    EXECUTE PROCEDURE nucetniobdobidelete();

insert into dbversion(iddbversion, dbversion, needreimport)
    values (nextval('seq_dbversion'), 398, 't');
