--------------------------------------------------------------------------------
-- Bug 21522 – [WinStrom] Přepočet stavů účtů - zaúčtování DPH událostí majetku
--------------------------------------------------------------------------------

-- uprava funkce na prepocet obratu aby umela opravit nenavazane obraty
CREATE OR REPLACE FUNCTION prepoctiobraty(iducetobd integer) RETURNS void AS $$ 
declare 
  platiOd date; 
  platiDo date; 
begin 
  select platioddata, platidodata into platiOd, platiDo from nucetobdobi where iducetobdobi = idUcetObd; 
 
  if (platiOd is not null and platiDo is not null) then 
    delete from uobraty where obdobi > 0 and (iducetobdobi = idUcetObd or 
      (obdobi < 99 and date(rok || '-' || obdobi || '-02') between platiOd and platiDo)); 
     
    -- zauctovani polozek faktur 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
        
     -- zauctovani polozek internich dokladu 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
                                 
     -- zauctovani polozek skladovych dokladu                      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between platiOd and platiDo; 
     
     -- danove naklady 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from mdannakl as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
           
     -- danove odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mdanodpisy as P 
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
      
     -- splatkovy kalendar 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
           
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, L.idMeny, P.idStred,  
          P.sumDph, P.sumDphMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
      
     -- ucetni odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mucetodpisy as P 
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
      
     -- udalosti 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between platiOd and platiDo; 
     
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, -1, P.idStred,  
          P.sumDph, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between platiOd and platiDo;
  end if; 
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.prepoctiobraty(iducetobd integer) OWNER TO %firmaRole%;

create or replace function runupgrade() returns void as $$
declare
  _idUoPrep integer[];
  udalCount integer;
begin
  select count(*) into udalCount from mudalosti where sumdph <> 0;
  
  if udalCount > 0 then
    perform prepoctiobraty(iducetobdobi) from nucetobdobi where zmenazaver = true;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 419, 't', %appVersion%, clock_timestamp());
