--------------------------------------------------------------------------------
-- Bug 22795 – [WinStrom] 3 - Adresář - Místo určení - Doplnit Kontaktní osoba
--------------------------------------------------------------------------------

alter table ddoklfak add column idkontaktosoba integer;
alter table ddoklint add column idkontaktosoba integer;
alter table ddoklobch add column idkontaktosoba integer;
alter table ddoklsklad add column idkontaktosoba integer;
alter table uzakazky add column idkontaktosoba integer;
alter table amisturc add column idkontaktosoba integer;

alter table ddoklfak 
  add constraint doklfak_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;
alter table ddoklint 
  add constraint doklint_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;
alter table ddoklobch 
  add constraint doklobch_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;
alter table ddoklsklad 
  add constraint doklfak_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;
alter table uzakazky 
  add constraint zakazky_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;
alter table amisturc 
  add constraint misturc_kontakt_osoba foreign key (idkontaktosoba)
  references akontakty (idkontakt) match simple
  on update no action on delete set null;

CREATE INDEX dDoklFak_IdKontaktOsoba_index ON dDoklFak USING btree (IdKontaktOsoba);
CREATE INDEX dDoklInt_IdKontaktOsoba_index ON dDoklInt USING btree (IdKontaktOsoba);
CREATE INDEX dDoklObch_IdKontaktOsoba_index ON dDoklObch USING btree (IdKontaktOsoba);
CREATE INDEX dDoklSklad_IdKontaktOsoba_index ON dDoklSklad USING btree (IdKontaktOsoba);
CREATE INDEX aMistUrc_IdKontaktOsoba_index ON aMistUrc USING btree (IdKontaktOsoba);
CREATE INDEX uZakazky_IdKontaktOsoba_index ON uZakazky USING btree (IdKontaktOsoba);

update amisturc 
  set poznam = poznam || E'\nvyřizuje: ' || prijmeni
  where poznam is not null and prijmeni is not null;

update amisturc
  set poznam = 'vyřizuje: ' || prijmeni
  where poznam is null and prijmeni is not null;

alter table amisturc drop column prijmeni;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 448, 't', %appVersion%, clock_timestamp());
