--------------------------------------------------------------------------------
-- Bug 22796 – [WinStrom] 4 - Zakázky - Rozšířit zakázky o přílohy a splatnost
--------------------------------------------------------------------------------

ALTER TABLE uzakazky
  ADD COLUMN splatdny integer,
  ADD COLUMN pocetPriloh integer not null default 0;


ALTER TABLE wpriloha
  ADD COLUMN idzakazky integer,
  ADD CONSTRAINT wpriloha_idzakazky FOREIGN KEY (idzakazky)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX wpriloha_idzakazky_index ON wpriloha USING btree (idzakazky);


create or replace function updatePocetPriloh(prilohaid integer, addon integer) returns void as
$BODY$
declare
    priloha record;
begin
    select * into priloha from wpriloha p where p.idpriloha = prilohaid;

    if (priloha.idreport is not null) then
        update wreport
        set pocetPriloh =   (select count(1)+addon
                            from wpriloha p
                            where p.idreport = priloha.idreport)
        where idreport = priloha.idreport;
    end if;


    if (priloha.idadresar is not null) then
        update aadresar
        set pocetPriloh =   (select count(1)+addon
                            from wpriloha p
                            where p.idadresar = priloha.idadresar)
        where idfirmy = priloha.idadresar;
    end if;

    if (priloha.idkontakt is not null) then
        update akontakty set pocetPriloh =  (select count(1)+addon
                                            from wpriloha p
                                            where p.idkontakt = priloha.idkontakt)
        where idkontakt = priloha.idkontakt;
    end if;

    if (priloha.idcenik is not null) then
        update ccenik set pocetPriloh = (select count(1)+addon
                                        from wpriloha p
                                        where p.idcenik = priloha.idcenik)
        where idcenik = priloha.idcenik;
    end if;

    if (priloha.iddoklfak is not null) then
        update ddoklfak set pocetPriloh =   (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklfak = priloha.iddoklfak)
        where iddoklfak = priloha.iddoklfak;
    end if;

    if (priloha.iddoklint is not null) then
        update ddoklint set pocetPriloh =   (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklint = priloha.iddoklint)
        where iddoklint = priloha.iddoklint;
    end if;

    if (priloha.iddoklobch is not null) then
        update ddoklobch set pocetPriloh =  (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklobch = priloha.iddoklobch)
        where iddoklobch = priloha.iddoklobch;
    end if;

    if (priloha.iddoklsklad is not null) then
        update ddoklsklad set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklsklad = priloha.iddoklsklad)
        where iddoklsklad = priloha.iddoklsklad;
    end if;

    if (priloha.idosoba is not null) then
        update posoba set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idosoba = priloha.idosoba)
        where idosobahlav = priloha.idosoba;
    end if;

    if (priloha.idadrudalost is not null) then
        update audalosti set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idadrudalost = priloha.idadrudalost)
        where idudalost = priloha.idadrudalost;
    end if;

    if (priloha.idzakazky is not null) then
        update uzakazky set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idzakazky = priloha.idzakazky)
        where idzakazky = priloha.idzakazky;
    end if;

    if (priloha.idkonektor is not null) then
        update wkonektor set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idkonektor = priloha.idkonektor)
        where idkonektor = priloha.idkonektor;
    end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION updatePocetPriloh(integer, integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 454, 't', %appVersion%, clock_timestamp());
