--------------------------------------------------------------------------------
-- Bug 24525 – [WinStrom] Přenos účtu z pokladny na sklad
--------------------------------------------------------------------------------

-- prenos uctu z dokladu
CREATE OR REPLACE FUNCTION ddoklintupdateucty() RETURNS trigger
    AS $$
declare idPoloz int;
        idDokl int;
        kopirovat boolean;
        ucPrij int;
        ucVyd int;
begin
  --pokud dojde ke zmene protiuctu
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    if (NEW.modul = 'POK' and NEW.typPohybuK = 'typPohybu.vydej') then             -- pokladni vydej
      -- vazba na sklad   
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklInt and    
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)   
      loop   
        execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);   
      end loop;   
    end if;   

    -- uprava faktur vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni
    for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and idDoklFak in
        (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))
    loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
    end loop;

    -- odpocet zalohy - polozka dokladu
    for idPoloz in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK = 'typVazbyDokl.uhradaZALOHY')) loop
      if (NEW.typPohybuK = 'typPohybu.prijem') then
        update dPolFak set idZklDalUcet = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklDalUcet, NEW.idProtiUcet) = false and compareId(idZklDalUcet, OLD.idProtiUcet) = true;
      else
        update dPolFak set idZklMdUcet  = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklMdUcet,  NEW.idProtiUcet) = false and compareId(idZklMdUcet,  OLD.idProtiUcet) = true;
      end if;
    end loop;

    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and compareId(idPrimUcet, OLD.idProtiUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
      end loop;
    end if;
  end if;

  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then
    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idPrimUcet) = false and compareId(idPrimUcet, OLD.idPrimUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idPrimUcet);
      end loop;
    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklintupdateucty() OWNER TO %firmaRole%;


-- prenos uctu z polozky
CREATE OR REPLACE FUNCTION dpolintupdateucty() RETURNS trigger AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
begin  
  if (NEW.modul = 'POK' and NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklInt where idDoklInt = NEW.idDoklInt;  
  
      -- vydej penez
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolInt and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolInt and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          raise exception '0008:dPolIntUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
        end if;  
      end if;  
  end if;  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolintupdateucty() OWNER TO %firmaRole%;

CREATE TRIGGER dpolintupdateucty AFTER UPDATE ON dpolint
  FOR EACH ROW EXECUTE PROCEDURE dpolintupdateucty();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 507, 't', %appVersion%, clock_timestamp());
