--------------------------------------------------------------------------------
-- Bug 24855 – [WinStrom] Zálohové faktury - upravit filtr
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolfakdeletevazba() RETURNS trigger AS $$
declare _dokl record;
        _idzal integer;
        uhrad integer;
        _stavUhrK varchar;
begin  
  if (OLD.typPolozkyK in ('typPolozky.odpocetZalohy', 'typPolozky.odpocetZdd')) then
    select idtabb into _idzal from dvazebtab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    delete from dVazebTab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    select * into _dokl from dDoklFak where idDoklFak = OLD.idDoklFak;
    
    if (_dokl.stavUhrK = 'stavUhr.uhrazeno' and OLD.sumZkl < 0) then
      select count(*) into uhrad from dVazebTab where idTabA = _dokl.idDoklFak and modulA = _dokl.modul and typVazbyK = 'typVazbyDokl.uhrada';
      
      _stavUhrK = null;
      if (uhrad > 0) then
        _stavUhrK = 'stavUhr.castUhr';
      end if;
      
      update dDoklFak set stavUhrK = _stavUhrK where idDoklFak = _dokl.idDoklFak;
    end if;
    
    _stavUhrK = null;
    select count(*) into uhrad from dVazebTab where idtabb = _idzal and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    if (uhrad > 0) then
      _stavUhrK = 'stavOdp.cast';
    end if;
    
    update ddoklfak set StavOdpocetK = _stavUhrK where iddoklfak = _idzal and not comparevarchar(StavOdpocetK, _stavUhrK);
  end if;  
  
  return OLD;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakdeletevazba() OWNER TO %firmaRole%;

-- nastaveni stavu u existujicich dokladu
alter table ddoklfak disable trigger all;

update ddoklfak set stavodpocetk = null where stavodpocetk = 'stavOdp.ne';

alter table ddoklfak enable trigger all;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 527, 't', %appVersion%, clock_timestamp());