--------------------------------------------------------------------------------------------------------
-- Bug 25308 – [winstrom] - Migrace - Skladové pohyby - umožnit migrovat data přesně jak jsou ve zdroji
--------------------------------------------------------------------------------------------------------

ALTER TABLE dpolsklad 
    ADD COLUMN cenyrucne boolean DEFAULT false NOT NULL;

-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying; 
  _mazatTmpTable boolean; 
  _idPolSklad integer; 
  _probihaPrepocetSkladu character varying; 
  _polSklad record; 
  _pocetMenenychVydejek integer;
begin
  if(NEW.storno = true) then
    return NEW;
  end if; 
  
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu; 
  if(_probihaPrepocetSkladu = 'true') then 
  else 
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds 
      on ps.datsklad >= NEW.datVyst and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej';
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datSklad, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
      return NEW;
    end if;

    -- v pripade ze neprobiha prepocet skladu 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
          if(_rozsirenaPolozka.storno = false) then 
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
          end if;
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if;
      end if; 
    end loop; 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.cenyRucne = true) then
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
        if(_rozsirenaPolozka.storno = false) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        end if;
      else
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if;
    end loop; 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if; 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad; 
  --pokud výdej, tak fifuju vazby 
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then 
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj, NEW.cenyRucne); 
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad); 
  end if; 
 
  if(_probihaPrepocetSkladu = 'true') then 
    if(NEW.idPolSklad < 0) then 
      _idPolSklad = -NEW.idPolSklad; 
    else 
      _idPolSklad = NEW.idPolSklad; 
    end if; 
 
    execute skladinsertrozsirenoupolozku(_idPolSklad); 
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;



-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$  
declare  
  tmp_rozsirenepolozky_exists boolean;  
  _updatuj boolean;  
  _pocetPolozek integer;  
  _rozsirenaPolozka record;  
  _sklFifo boolean;  
  _vypnutySklad character varying; 
  _mazatTmpTable boolean;  
  _polSklad record;
begin  

  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik and comparedate(NEW.datSklad, OLD.datSklad) 
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK) 
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace) 
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen 
    and NEW.storno = OLD.storno  
  ) then 
    return NEW; 
  end if; 
 
  /*  
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky  
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat  
  */  
  select getglotxvariable('vypniSklad') into _vypnutySklad;  
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then  
    _updatuj = true;  
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));  
    if(tmp_rozsirenepolozky_exists = true) then  
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad;  
      if(_pocetPolozek > 0) then  
        _updatuj = false;  
      end if;  
    end if;  
  
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then  
      _updatuj = false;  
    end if;  
    
    _sklfifo := (select isfifosklad(NEW.datSklad));    
    if (_sklfifo) then    
      --fifo    
      if (OLD.storno=false and NEW.storno=true) then    
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);    
      end if;      
      if (OLD.cenamj <> NEW.cenamj) then    
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);    
      end if;      
      --fifo konec    
    end if;    
  
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby 
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then 
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne); 
    end if; 
     
    if(_updatuj) then  
  
      -- generuji rozsirene polozky  
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;  
      
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu');  
   
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
            end if;
          else 
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
          end if;
        end if;  
      end loop;  
 
      if(OLD.storno = false) then 
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datSklad, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
      end if; 
 
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          if(_rozsirenaPolozka.cenyRucne = true) then 
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
            end if;
          else
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
          end if;
        else 
          if(NEW.storno = false) then 
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datSklad, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
          end if; 
        end if; 
      end loop;  
  
      if(_mazatTmpTable) then  
        drop table tmp_RozsirenePolozky;  
        drop table tmp_SkladoveKarty;  
        execute removeglotxvariable('zurnalTxName');  
      end if;  
         
    end if;  
  end if; 
  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;


-- Function: dpolskladdelete()
-- DROP FUNCTION dpolskladdelete();
CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _mazatTmpTable boolean;  
  _polSklad record;   
begin 
  
  if(not OLD.storno) then 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(OLD.datSklad, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
        if(_rozsirenaPolozka.cenyRucne = true) then
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      else  
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
 
    -- musim jeste odpocist mazanou polozku 
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad); 
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datSklad, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
   
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        else
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if;
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
     
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad); 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if;  
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;


-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _zaznam record; 
  _vyrobniCislo record; 
  _pocatek_ucetobd date; 
  _konec_ucetobd date; 
  _evidVyrCis boolean; 
  _mazatTmpTable boolean; 
  _citac integer; 
  _pocetPred integer; 
  _pocetPo integer; 
  _polSklad record;
begin 
 
  execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  execute putglotxvariable('probihaPrepocetSkladu', 'true'); 
 
  -- nacteni datumu zacatku ucetniho obdobi 
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- smazani tabulky fifo vazeb 
  delete from sfifovazby where idpolskladvydej in 
    (select idpolsklad from dpolsklad where 
            datSklad >= _pocatek_ucetobd); 
 
  delete from sfifovazby f 
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); 
 
  -- nagenerovani pomocnych tabulek 
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable; 
 
  select count(*) into _pocetPred from tmp_RozsirenePolozky; 
 
  -- provedu fifovani rozsirenych polozek 
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _zaznam.mnozMj < 0.0)) then 
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik; 
      if (not _evidVyrCis) then 
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idBspSkl, _zaznam.idKarty, _zaznam.mnozmj, _zaznam.cenyRucne); 
      else 
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop 
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
        end loop; 
      end if; 
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad); 
    end if; 
  end loop; 
 
  --select count(*) into _pocetPo from tmp_RozsirenePolozky; 
 
  -- vynulovani skladovych karet 
  execute skladVynulujSkladoveKarty(); 
 
  -- zafifovane veci zapoctu na skladove karty 
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    if(_rozsirenaPolozka.cenyRucne = true) then
      select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
      execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datSklad, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
    else
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
    end if;
  end loop; 
 
  if(_mazatTmpTable) then 
    drop table tmp_RozsirenePolozky; 
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName'); 
    execute removeglotxvariable('probihaPrepocetSkladu'); 
  end if; 
 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

create or replace function skladGenerujRozsirenePolozky( i_datum date, i_idpolsklad integer, i_idSkladKarty integer ) returns boolean as
$BODY$
declare
  tmp_skladovekarty_exists boolean;
  tmp_rozsirenepolozky_exists boolean;
  _polSklad record;
  _skladKarta record;
  _pocetSkladKarty integer;
  _result boolean;
  _idUcetObd integer;
begin
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true
  _result = false;

  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty'));
  if(tmp_skladovekarty_exists <> true) then
    --raise exception 'tmp_skladoveKarty se vytvari';
    CREATE TEMPORARY TABLE tmp_SkladoveKarty (
      idskladkarty integer
    ) WITH (OIDS=TRUE) ON COMMIT DROP;
  end if;

  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));
  if(tmp_rozsirenepolozky_exists <> true) then
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky (
      idpolsklad integer,
      iddoklskladMaster integer,
      iddoklskladpolozky integer,
      datum date,
      skupina integer,
      typPohybuK character varying,
      idskladkarty integer,
      storno boolean,
      cenyRucne boolean 
      --mnozMj numeric(19,6),
      --cenaMj numeric(19,6),
      --sumZkl numeric(19,6)
    ) WITH (OIDS=TRUE) ON COMMIT DROP;

    -- tabulky zde byli vytvoreny tim padem se musi vracet true
    _result = true;
  end if;
  
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou
    select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty;
    if(_pocetSkladKarty = 0) then
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty);
      for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = i_idSkladKarty) loop
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad);
      end loop;
    else
      -- do something stupid - kdyz je skladkarta v seznamu
    end if;
  else
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum;
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty);
      --for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = _skladKarta.idKarty) loop
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad);
      end loop;
    end loop;
  end if;

  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladGenerujRozsirenePolozky(date, integer, integer ) OWNER TO %firmaRole%;

create or replace function skladInsertRozsirenouPolozku(i_idPolSklad integer) returns void as
$BODY$
declare
  _polSklad record;
  _navazanaPolSklad record;
  _pocetRozsirenePolSklad integer;
  _typPohybuK character varying;
  _pocetProSkupinu integer;
  _skupina integer;
  _idDoklSkladMaster integer;
  _idDoklSkladMasterPom integer;
  _mazatTmpTable boolean;
begin
  select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad;
  select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = _polSklad.idPolSklad;
  if(_pocetRozsirenePolSklad = 0) then
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    -- urceni skupiny do ktere dana polozka patri
    _skupina = 2;
    select count(*) into _pocetProSkupinu from dvazebtab 
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'));
    if(_pocetProSkupinu = 0) then
      if(_typPohybuK = 'typPohybu.prijem') then
        _skupina = 1;
      else
        _skupina = 3;
      end if;
    end if;

    -- urceni id skladoveho doklad ktery je master
    _idDoklSkladMaster = _polSklad.idDoklSklad;
    if(_skupina = 2) then
      -- _idDoklSkladMasterPom
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and 
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus');
      if(_idDoklSkladMasterPom is not null) then
        _idDoklSkladMaster = _idDoklSkladMasterPom;
      end if;
    end if;

    -- rekurzi spoustim pro prevodku a kusovnik
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then
      select * into _navazanaPolSklad from dPolSklad 
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');

      -- pokud neni soucasti prevodky tak se jedna o kusovnik
      if(_navazanaPolSklad is null) then
        select * into _navazanaPolSklad from dPolSklad
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      end if;
      
      if(_navazanaPolSklad is null) then
        --raise notice 'navazana je null';
      else
        --raise notice 'volam rekurzi';
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable;
      end if;
    end if;

    -- vlozeni zaznamu o polozce do tmp tabulky
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, skupina, typPohybuK, idskladkarty, /*mnozMj, cenaMj, sumZkl,*/ iddoklskladpolozky, storno, cenyRucne)
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datSklad, _skupina, _typPohybuK, _polSklad.idkarty, /*_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno, _polSklad.cenyRucne);
  else
    -- do something stupid - kdyz je polozka v seznamu
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;

DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);

CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric, _cenyRucne boolean)
  RETURNS void AS
$BODY$      
declare       
  _zaznam Record;       
  _vybrano numeric(19,6);     
  _i integer;     
  _novevydcelkem numeric(19,6);     
  _pocet numeric(19,6);     
  _cenamjP numeric(19,6);  
  _sumZklP numeric(19,2); 
  _cenaMjPMen numeric(19,6);  
  _kurzDokladuP numeric(19,6);   
  _kurzDokladuV numeric(19,6);   
  _idDoklSkladP integer;    
  _idDoklSkladV integer;   
  _datVystV date;   
  _idrozlozeni integer;     
  _vydexpir boolean;     
  _vyrcis character varying(255);     
  _sklfifo boolean;  
  _sarze character varying(255);  
  _expirace date;       
  _evidVyrCis boolean;    
begin       
  _vybrano := 0;     
  _i := 1;     
  _novevydcelkem := vyd;     
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;  
  if (not _evidVyrCis) then  
    if (idvydej>0) then  
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;  
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;     
      if (not _vydexpir) then     
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datSklad,idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                end if;     
                --     
                if (_i = 1) then  
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo and not _cenyRucne) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then  
                      _cenamjP := _cenamjP * _kurzDokladuP;     
	                end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    if(_zaznam.pocet = _pocet) then 
                      select pp.sumZkl - coalesce((select sum(pv.sumZkl / (case when pv.mnozMj = 0.0 then 1.0 else pv.mnozMj end) * v.kusu) from dpolsklad pv join sfifovazby v on pv.idpolsklad = v.idpolskladvydej and v.idpolskladprijem = pp.idPolSklad), 0.0) into _sumZklP from dpolsklad pp where idpolsklad = _zaznam.idPolSklad; 
                    else 
                      _sumZklP = _pocet*_cenamjP*_kurzDokladuV; 
                    end if; 
                    insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;   
                    update dpolsklad set mnozmj = _pocet, mnozMjPlan = _pocet,cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _sumZklP, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace  
                          where idpolsklad = idvydej;  
                  else  
                    insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;   
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if; 
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo and not _cenyRucne) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    if(_zaznam.pocet = _pocet) then 
                      select pp.sumZkl - coalesce((select sum(pv.sumZkl / (case when pv.mnozMj = 0.0 then 1.0 else pv.mnozMj end) * v.kusu) from dpolsklad pv join sfifovazby v on pv.idpolsklad = v.idpolskladvydej and v.idpolskladprijem = pp.idPolSklad), 0.0) into _sumZklP from dpolsklad pp where idpolsklad = _zaznam.idPolSklad; 
                    else 
                      _sumZklP = _pocet*_cenaMjP*_kurzDokladuV; 
                    end if;   
                    insert into dpolsklad(idpolsklad,mnozmj,idtypucop,koptypucop,autozaokr,autogen,baleniid,cenjednotka,cenamj,  cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,        kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,        slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,                sumzklmen,         szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
                         (select (-1*_idrozlozeni),  _pocet,idtypucop,koptypucop,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,   cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_sumZklP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej); 
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);     
                  end if;     
                end if;     
                --     
                _i:=_i+1;     
              else 
                if (_vybrano>_novevydcelkem) then 
                  _pocet := -_zaznam.pocet; 
                  if(( _vybrano+_pocet) < _novevydcelkem) then 
                    _pocet := _novevydcelkem-_vybrano; 
                  end if; 
                  _vybrano := _vybrano+_pocet; 
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ; 
                end if; 
              end if;  
            end if; 
          end if; 
        end loop;    
      else     
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                    select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                end if;     
                --     
                if (_i = 1) then     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo and not _cenyRucne) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    if(_zaznam.pocet = _pocet) then 
                      select pp.sumZkl - coalesce((select sum(pv.sumZkl / (case when pv.mnozMj = 0.0 then 1.0 else pv.mnozMj end) * v.kusu) from dpolsklad pv join sfifovazby v on pv.idpolsklad = v.idpolskladvydej and v.idpolskladprijem = pp.idPolSklad), 0.0) into _sumZklP from dpolsklad pp where idpolsklad = _zaznam.idPolSklad; 
                    else 
                      _sumZklP = _pocet*_cenamjP*_kurzDokladuV; 
                    end if; 
                    insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;      
                    update dpolsklad set mnozmj = _pocet, mnozMjPlan = _pocet, cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _sumZklP, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace   
                          where idpolsklad = idvydej;  
                  else  
                    insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;     
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if;     
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo and not _cenyRucne) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    if(_zaznam.pocet = _pocet) then 
                      select pp.sumZkl - coalesce((select sum(pv.sumZkl / (case when pv.mnozMj = 0.0 then 1.0 else pv.mnozMj end) * v.kusu) from dpolsklad pv join sfifovazby v on pv.idpolsklad = v.idpolskladvydej and v.idpolskladprijem = pp.idPolSklad), 0.0) into _sumZklP from dpolsklad pp where idpolsklad = _zaznam.idPolSklad; 
                      _sumZklP = _sumZklP / _kurzDokladuV; 
                    else 
                      _sumZklP = _pocet*_cenaMjP; 
                    end if;  
                    insert into dpolsklad(idpolsklad,mnozmj,idtypucop,koptypucop,autozaokr,autogen,baleniid,cenjednotka,cenamj,  cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,        kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,        slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,                sumzklmen,         szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
                         (select (-1*_idrozlozeni),  _pocet,idtypucop,koptypucop,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,   cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_sumZklP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej); 
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else      
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);      
                  end if;      
                end if;      
                --      
                _i:=_i+1;      
              else 
                if (_vybrano>_novevydcelkem) then 
                  _pocet := -_zaznam.pocet; 
                  if(( _vybrano+_pocet) < _novevydcelkem) then 
                    _pocet := _novevydcelkem-_vybrano; 
                  end if; 
                  _vybrano := _vybrano+_pocet; 
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ; 
                end if; 
              end if;   
            end if; 
          end if;     
        end loop;      
      end if;      
    else      
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný      
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;               
    end if;  
  end if;     
end;       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric, boolean) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION sfifocenamj(idpohyb integer, iddokl integer, cenamjprijem numeric(19,6))
  RETURNS void AS
$BODY$  
--J.Svik - pokud stornuju nebo mau pohled, tak ruím fifo vazby
declare  
	_typPohybuk character varying(255);
         _pouzitaPrijemka integer;
        _idPolSklad integer;
        _polSklad record;
        _cenaMj numeric(19,6);
        _kurzPrijem numeric(19,6);
        _kurzVydej numeric(19,6);
        _sumZkl numeric(19,6);
        _sumZklMen numeric(19,6);
        _vydejCiziMena boolean;
        _prijemCiziMena boolean;
        _datVystPrijem date;
begin  
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = iddokl;	
	if (_typPohybuk = 'typPohybu.prijem') then
	        select datVyst into _datVystPrijem from ddoklsklad where iddoklsklad = iddokl;
                select getkurzfromdoklad(iddokl, _datVystPrijem) into _kurzPrijem;
                _cenaMj = cenamjprijem * _kurzPrijem;
                --pokud změna ceny na příjemce, tak změním dle vazeb na výdejkách 
         	for _idpolsklad in select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb loop
                  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
                  if(not _polSklad.cenyRucne) then

                    select getkurzfromdoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzVydej;
                    select isdoklskladmenacizi(_polSklad.idDoklSklad, _polSklad.datVyst) into _vydejCiziMena;
                    _sumZkl = _cenaMj * _polSklad.mnozMj;
                    if(_vydejCiziMena = true) then
                      _sumZklMen = (_cenaMj * polSklad.mnozMj) / _kurzVydej ;
                    else
                      _sumZklMen = 0.0;
                    end if;
                  
                    update dpolsklad set 
                      cenamj = (_cenaMj / _kurzVydej),
                      cenaMjPoriz = (_cenaMj / _kurzVydej), 
                      sumZkl = _sumZkl,
                      sumZklMen = _sumZklMen 
                      where idpolsklad = _idPolSklad;
                    execute sprepoctisumydokladu(_polSklad.idDoklSklad);
                  end if;
         	end loop;
		--update dpolsklad set cenamj = cenamjprijem where idpolsklad = (select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb); 
         end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifocenamj(integer, integer, numeric(19,6)) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 529, 't', %appVersion%, clock_timestamp());
