--------------------------------------------------------------------------------
-- Bug 25105 – [WinStrom] Dost hrůzostrašný problém se skladem Sincolor
--------------------------------------------------------------------------------

-- Function: jevydano(integer)
-- DROP FUNCTION jevydano(integer);
CREATE OR REPLACE FUNCTION jevydano(idprijemka integer)
  RETURNS numeric AS
$BODY$
declare
    jeVydano numeric(19,6);
begin
  
  select sum(fv.kusu) into jeVydano 
    from sfifovazby fv join dpolsklad ps 
      on fv.idpolskladprijem = idprijemka and fv.idpolskladvydej = ps.idpolsklad
  where ps.storno = false;

  if (jeVydano is null) then
    jeVydano:=0;
  end if;
  return jeVydano;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION jevydano(integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 533, 't', %appVersion%, clock_timestamp());
