---------------------------------------------------------------------------------------
-- Bug 19594 – [WinStrom] Stav skladu na položce dokladu
---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dGetStavNaSkladeAktualni(i_skladkartaid integer)
  RETURNS numeric AS
$BODY$       
declare      
  _idcenik integer;    
  _idskladu integer;    
  _iducetniobdobi integer;  
  _stavMj numeric(19,6);      
  _idSkladKarty integer;  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _stavSkladuSady numeric(19,6);  
begin      
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;  
  
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik;  
  -- pokud se nejedna o sadu tak funguju normalne  
  if(_sadaItemCount = 0) then  
      -- zkusime vypocitat stav na vrcholu  
      select stavMj into _stavMj from skarty where idkarty = i_skladkartaid;  
  else  
    for _polozkaSady in  
      select * from cSady where idCenikSada = _idCenik  
    loop  
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi;  
      if(_idSkladKarty is not null) then   
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;  
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;  
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dGetStavNaSkladeAktualni(integer) OWNER TO %firmaRole%;

-- Function: dgetstavnaskladeaktualni(integer)

-- DROP FUNCTION dgetstavnaskladeaktualni(integer);

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(i_idcenik integer, i_idsklad integer, i_datum date)
  RETURNS numeric AS
$BODY$       
declare      
  _iducetniobdobi integer;  
  _stavMj numeric(19,6);      
  _idSkladKarty integer;  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _stavSkladuSady numeric(19,6);  
begin      
  --select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;  
  select idUcetObdobi into _iducetniobdobi from nUcetObdobi where platiOdData <= i_datum and platiDoData >= i_datum;
  
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = i_idCenik;  
  -- pokud se nejedna o sadu tak funguju normalne  
  if(_sadaItemCount = 0) then  
      -- zkusime vypocitat stav na vrcholu  
      select idKarty into _idSkladKarty from sKarty where idCenik = i_idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;  
      select stavMj into _stavMj from skarty where idkarty = _idSkladKarty;  
  else  
    for _polozkaSady in  
      select * from cSady where idCenikSada = i_idCenik  
    loop  
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;  
      if(_idSkladKarty is not null) then   
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;  
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;  
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 549, 't', %appVersion%, clock_timestamp());
