--------------------------------------------------------------------------------
-- Bug 27355 – [WinStrom] Nová snížená sazba DPH 14% od 1.1.2012
--------------------------------------------------------------------------------

UPDATE usazbydph
SET platidodata='2011-12-31'
WHERE uuid='CZ_10_2010';

CREATE OR REPLACE FUNCTION doUpgrade()
  RETURNS void AS
$BODY$    
declare
  pom integer;
  _idstatu integer;
  stat character varying;
begin    
    select idstatu into _idstatu from astaty where uuid like '%_CZ';

    -- Sazba DPH 14%
    pom = 0;
    select count(1) into pom from usazbydph
    where typSzbDphK = 'typSzbDph.dphSniz' and szbdph = 14.00 and idstatu = _idstatu
      and (platioddata is null or platioddata >= '2012-01-01');

    if (pom = 0) then
        INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
            VALUES ('2011-12-19 15:30:00.000', NULL, '2012-01-01', NULL, NULL, 14.00, 'typSzbDph.dphSniz',
            _idstatu, 'CZ_14_2012');
    end if;

    -- Kod prenesene danove povinnosti §92
    select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
        where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
    
    if (stat = 'CZ_CZ') then
        update udphpren set platido='2011' where uuid is not null;

        pom = 0;
        select count(1) into pom from udphpren where kod = '1';
        if (pom = 0) then
            insert into udphpren (kod, nazev, platiod, platido, uuid)
            values ('1', '§ 92b – zlato', 2012, 9999, 'CZ_§92_1_2012');
        end if;

        pom = 0;
        select count(1) into pom from udphpren where kod = '2';
        if (pom = 0) then
            insert into udphpren (kod, nazev, platiod, platido, uuid)
            values ('2', '§ 92d – povolenky', 2012, 9999,'CZ_§92_2_2012');
        end if;

        pom = 0;
        select count(1) into pom from udphpren where kod = '4';
        if (pom = 0) then
            insert into udphpren (kod, nazev, platiod, platido, uuid)
            values ('4', '§ 92e – stavební a montážní práce', 2012, 9999,'CZ_§92_4_2012');
        end if;

        pom = 0;
        select count(1) into pom from udphpren where kod = '5';
        if (pom = 0) then
            insert into udphpren (kod, nazev, platiod, platido, uuid)
            values ('5', '§ 92c – zboží uvedené v příloze č. 5', 2012, 9999,'CZ_§92_5_2012');
        end if;
    end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION doUpgrade() OWNER TO %firmaRole%;

select doUpgrade();
drop function doUpgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 567, 't', %appVersion%, clock_timestamp());
