--------------------------------------------------------------------------------
-- Bug 27026 – [WinStrom] Smlouvy - Žurnál generace smluv
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_dzurnalsml
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_dzurnalsml OWNER TO %firmaRole%;

CREATE TABLE dzurnalsml (
    idzurnalsml integer DEFAULT nextval('seq_dzurnalsml'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    datcas timestamp without time zone DEFAULT now()::timestamp without time zone NOT NULL,
    transakcek character varying(50),
    pocetok integer not null default 0,
    poceterr integer not null default 0,
    chyby text,

    iduziv integer,

    CONSTRAINT dzurnalsml_pkey PRIMARY KEY (idzurnalsml),
    CONSTRAINT dzurnalsml_iduziv FOREIGN KEY (iduziv)
      REFERENCES wuzivatel (iduzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

ALTER TABLE public.dzurnalsml OWNER TO %firmaRole%;

CREATE INDEX dzurnalsml_iduziv_index ON dzurnalsml USING btree (iduziv);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 569, 't', %appVersion%, clock_timestamp());
