--------------------------------------------------------------------------------
-- Bug 27228 – [WinStrom] Slovenská legislativa
-- ostraneni radku 'SK_005-008, 020-021+§25 2012', 'SK_009-010, 020-021+§25 2012', 'SK 011-012, 020-021+§25 2010'
-- ktere maji byt nahrazeny pro FAV 'SK_026-027 2012' nebo pro FAP 'SK_028 2012'
--------------------------------------------------------------------------------

UPDATE dpolfak AS pf 
  SET idclendph = (select idclendph from uclendph where uuid = (case when modul = 'FAV' or modul = 'PHL' then 'SK_026-027 2012' else 'SK_028 2012' end))
  FROM uclendph AS cd
  WHERE pf.idclendph = cd.idclendph and cd.uuid in ('SK_005-008, 020-021+§25 2012', 'SK_009-010, 020-021+§25 2012', 'SK 011-012, 020-021+§25 2010');
UPDATE ddoklfak AS df 
  SET idclendph = (select idclendph from uclendph where uuid = (case when modul = 'FAV' or modul = 'PHL' then 'SK_026-027 2012' else 'SK_028 2012' end))
  FROM uclendph AS cd
  WHERE df.idclendph = cd.idclendph and cd.uuid in ('SK_005-008, 020-021+§25 2012', 'SK_009-010, 020-021+§25 2012', 'SK 011-012, 020-021+§25 2010');

UPDATE dpolint AS pf 
  SET idclendph = (select idclendph from uclendph where uuid = 
    (case when (select typPohybuK from ddoklint where iddoklint = pf.iddoklint) = 'typPohybu.prijem' 
      then 'SK_026-027 2012' else 'SK_028 2012' end))
  FROM uclendph AS cd
  WHERE pf.idclendph = cd.idclendph and cd.uuid in ('SK_005-008, 020-021+§25 2012', 'SK_009-010, 020-021+§25 2012', 'SK 011-012, 020-021+§25 2010');
UPDATE ddoklint AS df 
  SET idclendph = (select idclendph from uclendph where uuid = (case when typPohybuK = 'typPohybu.prijem' then 'SK_026-027 2012' else 'SK_028 2012' end))
  FROM uclendph AS cd
  WHERE df.idclendph = cd.idclendph and cd.uuid in ('SK_005-008, 020-021+§25 2012', 'SK_009-010, 020-021+§25 2012', 'SK 011-012, 020-021+§25 2010');

DELETE FROM uclendph WHERE uuid = 'SK_005-008, 020-021+§25 2012';
DELETE FROM uclendph WHERE uuid = 'SK_009-010, 020-021+§25 2012';
DELETE FROM uclendph WHERE uuid = 'SK 011-012, 020-021+§25 2010';

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 581, 't', %appVersion%, clock_timestamp());
