--------------------------------------------------------------------------------
-- Bug 28065 – [winstrom] - Intrastat - Slovensko
--------------------------------------------------------------------------------

-- pridani uuid
ALTER TABLE idodpodm ADD COLUMN uuid character varying(50);
ALTER TABLE idruhdopr ADD COLUMN uuid character varying(50);
ALTER TABLE iintrmerjed ADD COLUMN uuid character varying(50);
ALTER TABLE ikrajurc ADD COLUMN uuid character varying(50);
ALTER TABLE inomen ADD COLUMN uuid character varying(50);
ALTER TABLE iobchtrans ADD COLUMN uuid character varying(50);
ALTER TABLE izvlpoh ADD COLUMN uuid character varying(50);

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    userbankid integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);

  -- slovensky intrastat
  if (stat = 'SK_SK') then

DELETE from inomen as N where idnomen <= 9548 and
  NOT EXISTS (select 1 from ccenik as C where C.idnomen = N.idnomen);

DELETE from iintrmerjed as M where idintrmerjed <= 44 and
  NOT EXISTS (select 1 from inomen as N where M.idintrmerjed = N.idintrmerjed);

DELETE from idodpodm as I where iddodpodm <= 18 and
  NOT EXISTS (select 1 from ddoklfak as D where I.iddodpodm = D.iddodpodm) and
  NOT EXISTS (select 1 from ddoklint as D where I.iddodpodm = D.iddodpodm) and
  NOT EXISTS (select 1 from ddoklobch as D where I.iddodpodm = D.iddodpodm) and
  NOT EXISTS (select 1 from ddoklsklad as D where I.iddodpodm = D.iddodpodm) and
  NOT EXISTS (select 1 from dtypdokl as D where I.iddodpodm = D.iddodpodm);

DELETE from idruhdopr as I where iddruhdopr <= 8 and
  NOT EXISTS (select 1 from ddoklfak as D where I.iddruhdopr = D.iddruhdopr) and
  NOT EXISTS (select 1 from ddoklint as D where I.iddruhdopr = D.iddruhdopr) and
  NOT EXISTS (select 1 from ddoklobch as D where I.iddruhdopr = D.iddruhdopr) and
  NOT EXISTS (select 1 from ddoklsklad as D where I.iddruhdopr = D.iddruhdopr) and
  NOT EXISTS (select 1 from dtypdokl as D where I.iddruhdopr = D.iddruhdopr);

DELETE from ikrajurc as I where idkrajurc <= 20 and
  NOT EXISTS (select 1 from ddoklfak as D where I.idkrajurc = D.idkrajurc) and
  NOT EXISTS (select 1 from ddoklint as D where I.idkrajurc = D.idkrajurc) and
  NOT EXISTS (select 1 from ddoklobch as D where I.idkrajurc = D.idkrajurc) and
  NOT EXISTS (select 1 from ddoklsklad as D where I.idkrajurc = D.idkrajurc) and
  NOT EXISTS (select 1 from dtypdokl as D where I.idkrajurc = D.idkrajurc);

DELETE from iobchtrans as I where idobchtrans <= 37 and
  NOT EXISTS (select 1 from ddoklfak as D where I.idobchtrans = D.idobchtrans) and
  NOT EXISTS (select 1 from ddoklint as D where I.idobchtrans = D.idobchtrans) and
  NOT EXISTS (select 1 from ddoklobch as D where I.idobchtrans = D.idobchtrans) and
  NOT EXISTS (select 1 from ddoklsklad as D where I.idobchtrans = D.idobchtrans) and
  NOT EXISTS (select 1 from dtypdokl as D where I.idobchtrans = D.idobchtrans);

DELETE from izvlpoh as I where idzvlpoh <= 12 and
  NOT EXISTS (select 1 from ddoklfak as D where I.idzvlpoh = D.idzvlpoh) and
  NOT EXISTS (select 1 from ddoklint as D where I.idzvlpoh = D.idzvlpoh) and
  NOT EXISTS (select 1 from ddoklobch as D where I.idzvlpoh = D.idzvlpoh) and
  NOT EXISTS (select 1 from ddoklsklad as D where I.idzvlpoh = D.idzvlpoh) and
  NOT EXISTS (select 1 from dtypdokl as D where I.idzvlpoh = D.idzvlpoh);

-- druh dopravy
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '2', 'Železničná doprava', true, 0, 9999, 'SK_2');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '3', 'Cestná doprava', true, 0, 9999, 'SK_3');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '4', 'Letecká doprava', true, 0, 9999, 'SK_4');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '5', 'Poštová zásielka', true, 0, 9999, 'SK_5');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '7', 'Vedením a potrubím', true, 0, 9999, 'SK_7');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '8', 'Vnútrozemská vodná doprava', true, 0, 9999, 'SK_8');
INSERT INTO idruhdopr (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '9', 'Vlastný pohon', true, 0, 9999, 'SK_9');

-- dodaci podminky
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'EXW', 'Zo závodu', 'Ex works', true, 0, 9999, 'SK_EXW');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'FCA', 'Vyplatené dopravcovi', 'Free carrier', true, 0, 9999, 'SK_FCA');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'FAS', 'Vyplatené k boku lode', 'Free alongside ship', true, 0, 9999, 'SK_FAS');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'FOB', 'Vyplatené na palubu', 'Free on board', true, 0, 9999, 'SK_FOB');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'CFR', 'Náklady a prepravné', 'Cost and freight', true, 0, 9999, 'SK_CFR');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'CIF', 'Náklady, poistné a prepravné', 'Cost, insurance and freight', true, 0, 9999, 'SK_CIF');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'CPT', 'Preprava platená do', 'Carriage paid to', true, 0, 9999, 'SK_CPT');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'CIP', 'Preprava, poistné platené do', 'Carriage and insurance paid to', true, 0, 9999, 'SK_CIP');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'DAF', 'S dodaním na hranicu', 'Delivered at frontier', true, 0, 9999, 'SK_DAF');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'DES', 'S dodaním z lode', 'Delivered ex–ship', true, 0, 9999, 'SK_DES');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'DEQ', 'S dodaním z nábrežia', 'Delivered ex–quay', true, 0, 9999, 'SK_DEQ');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'DDU', 'S dodaním clo neplatené', 'Delivered duty unpaid', true, 0, 9999, 'SK_DDU');
INSERT INTO idodpodm (lastupdate, kod, nazev, nazeva, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'DDP', 'S dodaním clo platené', 'Delivered duty paid', true, 0, 9999, 'SK_DDP');
INSERT INTO idodpodm (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', 'XXX', 'Ak sú podmienky dodania iné než vyššie uvedené', true, 0, 9999, 'SK_XXX');

-- kraj urceni
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '1', 'Bratislavský kraj', true, 0, 9999, 'SK_1');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '2', 'Trnavský kraj', true, 0, 9999, 'SK_2');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '3', 'Trenčiansky kraj', true, 0, 9999, 'SK_3');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '4', 'Nitriansky kraj', true, 0, 9999, 'SK_4');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '5', 'Žilinský kraj', true, 0, 9999, 'SK_5');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '6', 'Banskobystrický kraj', true, 0, 9999, 'SK_6');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '7', 'Prešovský kraj', true, 0, 9999, 'SK_7');
INSERT INTO ikrajurc (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '8', 'Košický kraj', true, 0, 9999, 'SK_8');

-- obchodni transakce
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '11', 'Transakcie so skutočným alebo plánovaným prevodom vlastníctva z rezidentov na nerezidentov za finančnú alebo inú náhradu (okrem transakcií uvedených v bodoch 2, 7, 8) - Priama kúpa/predaj', true, 0, 9999, 'SK_11');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '12', 'Transakcie so skutočným alebo plánovaným prevodom vlastníctva z rezidentov na nerezidentov za finančnú alebo inú náhradu (okrem transakcií uvedených v bodoch 2, 7, 8) - Dodávka tovaru na skúšku, na ukážka, na komisionálny predaj alebo na akýkoľvek predaj', true, 0, 9999, 'SK_12');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '13', 'Transakcie so skutočným alebo plánovaným prevodom vlastníctva z rezidentov na nerezidentov za finančnú alebo inú náhradu (okrem transakcií uvedených v bodoch 2, 7, 8) - Barterový obchod (náhrada v naturáliách)', true, 0, 9999, 'SK_13');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '14', 'Transakcie so skutočným alebo plánovaným prevodom vlastníctva z rezidentov na nerezidentov za finančnú alebo inú náhradu (okrem transakcií uvedených v bodoch 2, 7, 8) - Finančný lízing (splátkový obchod)', true, 0, 9999, 'SK_14');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '19', 'Transakcie so skutočným alebo plánovaným prevodom vlastníctva z rezidentov na nerezidentov za finančnú alebo inú náhradu (okrem transakcií uvedených v bodoch 2, 7, 8) - Iné', true, 0, 9999, 'SK_19');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '21', 'Bezplatné vrátenie a náhrada tovaru po registrácii pôvodnej transakcie - Vrátenie tovaru', true, 0, 9999, 'SK_21');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '22', 'Bezplatné vrátenie a náhrada tovaru po registrácii pôvodnej transakcie - Náhrada za vrátený tovar', true, 0, 9999, 'SK_22');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '23', 'Bezplatné vrátenie a náhrada tovaru po registrácii pôvodnej transakcie - Náhrada (napríklad v záručnej lehote) za tovar, ktorý nebol vrátený', true, 0, 9999, 'SK_23');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '29', 'Bezplatné vrátenie a náhrada tovaru po registrácii pôvodnej transakcie - Iné', true, 0, 9999, 'SK_29');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '3', 'Transakcie zahŕňajúce prevod vlastníctva bez finančnej alebo vecnej náhrady (napr. dodávky pomoci)', true, 0, 9999, 'SK_3');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '41', 'Operácie s cieľom spracovania na základe zmluvy (bez prevodu vlastníctva na spracovateľa) - Tovar, ktorý sa má vrátiť do pôvodného členského štátu odoslania', true, 0, 9999, 'SK_41');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '42', 'Operácie s cieľom spracovania na základe zmluvy (bez prevodu vlastníctva na spracovateľa) - Tovar, ktorý sa nemá vrátiť do pôvodného členského štátu odoslania', true, 0, 9999, 'SK_42');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '51', 'Operácie po spracovaní na základe zmluvy (bez prevodu vlastníctva na spracovateľa) - Tovar, ktorý sa vracia do pôvodného členského štátu odoslania', true, 0, 9999, 'SK_51');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '52', 'Operácie po spracovaní na základe zmluvy (bez prevodu vlastníctva na spracovateľa) - Tovar, ktorý sa nevracia do pôvodného členského štátu odoslania', true, 0, 9999, 'SK_52');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '61', 'Určité transakcie zaznamenávané na vnútroštátne účely - Tovar prijatý na dočasné použitie na obdobie nie dlhšie ako 24 mesiacov a tovar odoslaný na užívanie na obdobie nie dlhšie ako 24 mesiacov', true, 0, 9999, 'SK_61');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '62', 'Určité transakcie zaznamenávané na vnútroštátne účely - Oprava a údržba za úhradu', true, 0, 9999, 'SK_62');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '7', 'Operácie v rámci projektov spoločnej obrany alebo iných spoločných medzivládnych výrobných programov', true, 0, 9999, 'SK_7');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '8', 'Transakcie zahŕňajúce dodávku stavebného materiálu a technického vybavenia pre stavebné a inžinierske práce v rámci všeobecnej zmluvy, v prípade ktorých sa nevystavujú faktúry za jednotlivý tovar, ale jedna faktúra za celú hodnotu tovaru', true, 0, 9999, 'SK_8');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '91', 'Iné transakcie, ktoré sa nedajú zaradiť pod iné kódy - Prenájom, pôžička, prevádzkový lízing dlhšie ako na 24 mesiacov', true, 0, 9999, 'SK_91');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '92', 'Iné transakcie, ktoré sa nedajú zaradiť pod iné kódy - Nepriamy dovoz a nepriamy vývoz', true, 0, 9999, 'SK_92');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '93', 'Iné transakcie, ktoré sa nedajú zaradiť pod iné kódy - Premiestnenie tovaru', true, 0, 9999, 'SK_93');
INSERT INTO iobchtrans (lastupdate, kod, nazev, show, platiod, platido, uuid)
 VALUES ('2012-02-02 00:00:00.000', '99', 'Iné transakcie, ktoré sa nedajú zaradiť pod iné kódy - Transakcie inde nešpecifikované', true, 0, 9999, 'SK_99');

-- merne jednotky
INSERT INTO iintrmerjed(kod, nazev, nazeva, platiod, platido, uuid) 
 VALUES 
('CCT', 'nosnosť v tonách', 'Carrying capacity in tonnes', 0, 9999, 'SK_CCT'),
('CEN', '100 kusov', 'Hundred items', 0, 9999, 'SK_CEN'),
('CTM', 'karáty', 'Carats (1 metric carat = 2 x 10-4 kg)', 0, 9999, 'SK_CTM'),
('DHS', 'kilogram dihydrostreptomycínu', 'Kilogram of dihydrostreptomycin', 0, 9999, 'SK_DHS'),
('DTN', 'ektokilogram', 'Hectokilogram', 0, 9999, 'SK_DTN'),
('GFI', 'gram štiepnych izotopov', 'Gram of fissile isotopes', 0, 9999, 'SK_GFI'),
('GRM', 'gram', 'Gram', 0, 9999, 'SK_GRM'),
('GRT', 'hrubá nosnosť', 'Gross tonnage', 0, 9999, 'SK_GRT'),
('HLT', 'hektoliter', 'Hectolitre', 0, 9999, 'SK_HLT'),
('HMT', 'hektometer', 'Hectometer', 0, 9999, 'SK_HMT'),
('KCC', 'kilogram cholínchloridu', 'Kilogram of choline chloride', 0, 9999, 'SK_KCC'),
('KCL', 'tona chloridu draselného', 'Ton of potassium chloride', 0, 9999, 'SK_KCL'),
('KGM', 'kilogram', 'Kilogram', 0, 9999, 'SK_KGM'),
--('KGM', 'kilogram, hmotnosť pevnej zložky', 'Kilogram drained net weight', 0, 9999, 'SK_KGM'),
('KLT', '1000 litrov', 'Thousand litres', 0, 9999, 'SK_KLT'),
('KMA', 'kilogram metylamínu', 'Kilogram of methylamines', 0, 9999, 'SK_KMA'),
('KNI', 'kilogram dusíku', 'Kilogram of nitrogen', 0, 9999, 'SK_KNI'),
('KNS', 'kilogram peroxidu vodíka', 'Kilogram of hydrogen peroxide', 0, 9999, 'SK_KNS'),
('KPH', 'kilogram hydroxidu draselného (žieravého draslíka)', 'Kilogram of potassium hydroxide (caustic potash)', 0, 9999, 'SK_KPH'),
('KPO', 'kilogram oxidu draselného', 'Kilogram of potassium oxide', 0, 9999, 'SK_KPO'),
('KPP', 'kilogram oxidu fosforečného', 'Kilogram of diphosphorus pentaoxide', 0, 9999, 'SK_KPP'),
('KSD', 'kilogram prepočítaný na 90% sušiny', 'Kilogram of substance 90 % dry', 0, 9999, 'SK_KSD'),
('KSH', 'kilogram hydroxidu sodného (žieravého nátronu)', 'Kilogram of sodium hydroxide (caustic soda)', 0, 9999, 'SK_KSH'),
('KUR', 'kilogram uránu', 'Kilogram of uranium', 0, 9999, 'SK_KUR'),
('LPA', 'liter čistého (100%) alkoholu', 'Litre pure (100 %) alcohol', 0, 9999, 'SK_LPA'),
('LTR', 'liter', 'Litre', 0, 9999, 'SK_LTR'),
('MIL', '1000 kusov', 'Thousand items', 0, 9999, 'SK_MIL'),
('MPR', '1000 párov', 'Thousand pairs', 0, 9999, 'SK_MPR'),
('MQM', '1000 metrov kubických', 'Thousand cubic metres', 0, 9999, 'SK_MQM'),
('MTK', 'meter štvorcový', 'Square metre', 0, 9999, 'SK_MTK'),
('MTQ', 'meter kubický', 'Cubic metre', 0, 9999, 'SK_MTQ'),
('MTR', 'meter', 'Metre', 0, 9999, 'SK_MTR'),
('MWH', '1000 kilowatthodín', 'Thousand kilowatt hours', 0, 9999, 'SK_MWH'),
('NAR', 'počet kusov', 'Number of items', 0, 9999, 'SK_NAR'),
('NCL', 'počet článkov', 'Number of cells', 0, 9999, 'SK_NCL'),
('NPR', 'počet párov', 'Number of pairs', 0, 9999, 'SK_NPR'),
('TJO', 'terajoule (hrubé spalné teplo)', 'Terajoule (gross calorific value)', 0, 9999, 'SK_TJO'),
('TNE', 'tona', 'Ton', 0, 9999, 'SK_TNE'),
('ZZZ', 'nešpecifikované', 'No additional unit', 0, 9999, 'SK_ZZZ');

-- kody nomenklatury
-- vklada upgrade 586

-- konec slovenskeho bloku
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 585, 't', %appVersion%, clock_timestamp());
