--------------------------------------------------------------------------------
-- Bug 29021 – [winstrom] - Cenové úrovně - doplnit vazbu na položku ceníku
--------------------------------------------------------------------------------

-- vazebni tabulka cenova hladina - cenik
CREATE TABLE cchl_cen
(
  idcenhlad integer NOT NULL,
  idcenik integer NOT NULL,
  CONSTRAINT cchl_cen_pkey PRIMARY KEY (idcenik, idcenhlad),
  CONSTRAINT cchl_cen_idcenhlad FOREIGN KEY (idcenhlad)
      REFERENCES ccenhlad (idcenhlad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT cchl_cen_idcenik FOREIGN KEY (idcenik)
      REFERENCES ccenik (idcenik) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE cchl_cen OWNER TO %firmaRole%;

CREATE INDEX cchl_cen_idcenhlad_index ON cchl_cen USING btree (idcenhlad);
CREATE INDEX cchl_cen_idcenik_index ON cchl_cen USING btree (idcenik);

-- nejprve musime odebrat protoze posgres hlasi: cannot change number of columns in view
DROP VIEW ccenhladview;

-- rozsireni pohledu na cenove hladiny
CREATE OR REPLACE VIEW ccenhladview AS

select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H
where H.vsechnyskupzboz = true

union

select SZ.idskupzboz as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H, cchl_skz SZ
where H.vsechnyskupzboz = false and H.idcenhlad = SZ.idcenhlad
union

select cast(null as integer) as idskupzboz, C.idcenik as idcenik, H.*
from ccenhladusers H, cchl_cen C
where H.vsechnyskupzboz = false and H.idcenhlad = C.idcenhlad

union

-- hladina co neni nikde pouzita
select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H left outer join cchl_skz SZ on H.idcenhlad = SZ.idcenhlad 
left outer join cchl_cen C on H.idcenhlad = C.idcenhlad
where H.vsechnyskupzboz = false and SZ.idskupzboz is null and C.idcenik is null;

ALTER TABLE ccenhladview OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 614, 't', %appVersion%, clock_timestamp());
