--------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
--------------------------------------------------------------------------------

-- Function: deletenavazanepolsklad(integer, character varying)
-- DROP FUNCTION deletenavazanepolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION deletenavazanepolsklad(_idpoldokl integer, _modul character varying, _generujSklDoklad boolean)
  RETURNS void AS
$BODY$
declare
  _idPolSklad integer;
  _idVazbyPolSklad integer;
  _idPolSkladRozpad integer;
  _zdrojProSklPolDokl boolean;
  _pocetFifoVazeb integer;
begin
  for _idPolSklad in select idTabB from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSkl'
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    loop
    if (_modul like 'FAV' or _modul like 'FAP') then
      select zdrojProSkl into _zdrojProSklPolDokl from dPolFak where idPolFak = _idPolDokl;
    elsif (_modul like 'POK') then
      select zdrojProSkl into _zdrojProSklPolDokl from dPolInt where idPolInt = _idPolDokl;
    end if;

    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
      end loop;
    end if;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
      if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
        raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
      end if;
      delete from dPolSklad where idPolSklad = _idPolSklad;
    end if;
  end loop;

  for _idPolSklad in select idTabA from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSkl'
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'
    loop
    if (_modul like 'FAV' or _modul like 'FAP') then
      select zdrojProSkl into _zdrojProSklPolDokl from dPolFak where idPolFak = _idPolDokl;
    elsif (_modul like 'POK') then
      select zdrojProSkl into _zdrojProSklPolDokl from dPolInt where idPolInt = _idPolDokl;
    end if;

    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
      end loop;
    end if;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
      if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
        raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
      end if;
      delete from dPolSklad where idPolSklad = _idPolSklad;
    end if;
  end loop;

  -- mazani polozek prevodky
  -- polozky prevodky by meli jit mazat z obou stran
  for _idPolSklad in select idTabB from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    loop

    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
    end loop;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';

    select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
    if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
      raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
    end if;

    delete from dPolSklad where idPolSklad = _idPolSklad;
  end loop;

  for _idPolSklad in select idTabA from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'
    loop

    -- pokud mazeme vygenerovanou prijemku musime smazat jen vazby a nikoliv zdrojovy doklad
    --for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
      --select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      --delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      --delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
    --end loop;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';
    -- pokud mazeme vygenerovanou prijemku musime smazat jen vazby a nikoliv zdrojovy doklad
    --delete from dPolSklad where idPolSklad = _idPolSklad;
  end loop;

  -- mazani polozek sady
  for _idPolSklad in select idTabB from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSklSada'
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    loop

    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
    end loop;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';

    select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
    if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
      raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
    end if;

    delete from dPolSklad where idPolSklad = _idPolSklad;
  end loop;

  for _idPolSklad in select idTabA from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSklSada'
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'
    loop

    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
    end loop;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';

    select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
    if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
      raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
    end if;
 
    delete from dPolSklad where idPolSklad = _idPolSklad;
  end loop;

  -- pokud mazu polozku vydejky, ktera byla vytvorena k polozce prijemky podle kusovniku
  -- vyhodim vyjimku, polozek vydejky se muselo vytvorit vice a musel bych je smazat vsechny
  -- navic mi prijemka ridi existenci vydejky a tak bych celou vazbu mel ovladat z ni
  if (exists (select 1 from dvazebtab where idTabB = _idPolDokl and modulB = _modul
    and typVazbyK = 'typVazbyDokl.polozkaSklKus')) then
        raise exception 'polozku dokladu vydejky nelze smazat, smazte zavislou polozku na prijemce';
  end if;

  for _idPolSklad in select idTabB from dvazebtab where
    typVazbyK like 'typVazbyDokl.polozkaSklKus'
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    loop

    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;
    end loop;

    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus';
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus';

    select count(*) into _pocetFifoVazeb from sfifovazby where idpolskladprijem = _idPolSklad;
    if(_pocetFifoVazeb is not null and _pocetFifoVazeb > 0) then
      raise exception '0009:deleteNavazanePolSklad:jizVyskladneno';
    end if;
 
    delete from dPolSklad where idPolSklad = _idPolSklad;
  end loop;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying, boolean) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 642, 't', %appVersion%, clock_timestamp());
