------------------------------------------------------------------------------------------
-- Bug 30475 – [WinStrom] Sincolor - Pri prepoctu skladu nedochazi k nulovani ceny v mene
------------------------------------------------------------------------------------------

create or replace function skladVynulujSkladoveKarty() returns void as
$BODY$
declare
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _skladKarta record;
begin
  for _skladKarta in (select * from skarty where idkarty in (select idskladkarty from tmp_SkladoveKarty)) loop
    _prumCenaTuz = 0.0;
    _prumCenaMen = 0.0;
    if(_skladKarta.pocatMj <> 0.0) then
      _prumCenaTuz = _skladKarta.pocatTuz / _skladKarta.pocatMj;
      _prumCenaMen = _skladKarta.pocatMen / _skladKarta.pocatMj;
    end if;
    update skarty set 
      stavmj = _skladKarta.pocatMj,
      stavtuz = _skladKarta.pocatTuz,
      stavMen = _skladKarta.pocatMen,
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaMen,
      lastUpdate = LOCALTIMESTAMP
      where idkarty = _skladKarta.idKarty;
  end loop;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladVynulujSkladoveKarty() OWNER TO %firmaRole%;

----------------------------------------------------------------------------------------
-- Bug 30549 – [WinStrom] Fixopie při otevření přesunutého reportu se seznamem dokladů
----------------------------------------------------------------------------------------

update dautotisk set report = '_globalreports/prehledDokladu:Doklady' where report = 'favAkt:Doklady';
update dautotisk set report = '_globalreports/prehledDokladu:Doklady:SUM' where report = 'favAkt:Doklady:SUM';
update dautotisk set report = '_globalreports/prehledDokladu:Doklady' where report = 'phlAkt:Doklady';
update dautotisk set report = '_globalreports/prehledDokladu:Doklady:SUM' where report = 'phlAkt:Doklady:SUM';
update dautotisk set report = '_globalreports/prehledDokladu:Doklady' where report = 'zavAkt:Doklady';
update dautotisk set report = '_globalreports/prehledDokladu:Doklady:SUM' where report = 'zavAkt:Doklady:SUM';

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 645, 't', %appVersion%, clock_timestamp());
