--------------------------------------------------------------------------------
-- Bug 30614 – [WinStrom] Rozšířit datový model pro internetové obchody
--------------------------------------------------------------------------------

-- doklfak
alter table ddoklfak add column kontaktJmeno character varying(255);
alter table ddoklfak add column kontaktTel character varying(255);
alter table ddoklfak add column kontaktEmail character varying(255);
-- doklint
alter table ddoklint add column kontaktJmeno character varying(255);
alter table ddoklint add column kontaktTel character varying(255);
alter table ddoklint add column kontaktEmail character varying(255);
-- doklobch
alter table ddoklobch add column kontaktJmeno character varying(255);
alter table ddoklobch add column kontaktTel character varying(255);
alter table ddoklobch add column kontaktEmail character varying(255);
-- doklsklad
alter table ddoklsklad add column kontaktJmeno character varying(255);
alter table ddoklsklad add column kontaktTel character varying(255);
alter table ddoklsklad add column kontaktEmail character varying(255);

-- cenik
alter table ccenik add column kratkyPopis text;
alter table ccenik add column klicSlova character varying(255);
alter table ccenik add column techParam text;
alter table ccenik add column dodaciLhuta numeric(19,6);
alter table ccenik add column idMjDodaciLhuta integer;
alter table ccenik add constraint ccenik_idmjdodacilhuta FOREIGN KEY (idMjDodaciLhuta)
      REFERENCES cmerjed (idmj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX cCenik_IdMjDodaciLhuta_index ON cCenik USING btree (IdMjDodaciLhuta);

-- dodavatele
alter table cdodavatele add column dodaciLhuta numeric(19,6);
alter table cdodavatele add column idMjDodaciLhuta integer;
alter table cdodavatele add constraint cdodavatele_idmjdodacilhuta FOREIGN KEY (idMjDodaciLhuta)
      REFERENCES cmerjed (idmj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX cDodavatele_IdMjDodaciLhuta_index ON cDodavatele USING btree (IdMjDodaciLhuta);

-- uzel
alter table wuzel add column kratkyPopis text;
alter table wuzel add column klicSlova character varying(255);
alter table wuzel add column popis text;
alter table wuzel add column txtNad text;
alter table wuzel add column txtPod text;

-- tabulka stav ceniku
create sequence seq_cstavcen
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_cstavcen owner to %firmaRole%;

create table cStavCen(
    idStavCen integer default nextval('seq_cstavcen'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    neprodejne boolean not null default false,

    CONSTRAINT cstavcen_pkey PRIMARY KEY (idstavcen)
);
alter table cstavcen owner to %firmaRole%;

CREATE TABLE wkli_stavcen (
    idstavcen integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_stavcen_pkey PRIMARY KEY (idstavcen, idvybklic),
    CONSTRAINT wkli_stavcen_idstavcen FOREIGN KEY (idstavcen)
      REFERENCES cstavcen (idstavcen) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_stavcen_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_stavcen OWNER TO %firmaRole%;

CREATE INDEX wkli_stavcen_idstavcen_index ON wkli_stavcen USING btree (idstavcen);
CREATE INDEX wkli_stavcen_idvybklic_index ON wkli_stavcen USING btree (idvybklic);

CREATE TABLE stavcen_cenik (
    idstavcen integer NOT NULL,
    idcenik integer NOT NULL,

    CONSTRAINT stavcen_cenik_pkey PRIMARY KEY (idstavcen, idcenik),
    CONSTRAINT stavcen_cenik_idstavcen FOREIGN KEY (idstavcen)
      REFERENCES cstavcen (idstavcen) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT stavcen_cenik_idcenik FOREIGN KEY (idcenik)
        REFERENCES ccenik(idcenik) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.stavcen_cenik OWNER TO %firmaRole%;

CREATE INDEX stavcen_cenik_idstavcen_index ON stavcen_cenik USING btree (idstavcen);
CREATE INDEX stavcen_cenik_idcenik_index ON stavcen_cenik USING btree (idcenik);

-- tabulka prislusenstvi
create sequence seq_cprislusenstvi
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_cprislusenstvi owner to %firmaRole%;

create table cprislusenstvi (
    idprislusenstvi integer default nextval('seq_cprislusenstvi'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    poznam text,
    idcenikotec integer NOT NULL,
    idcenik integer NOT NULL,

    CONSTRAINT cprislusenstvi_pkey PRIMARY KEY (idprislusenstvi),
    CONSTRAINT cprislusenstvi_idcenikotec FOREIGN KEY (idcenikotec)
        REFERENCES ccenik (idcenik)
        ON UPDATE NO ACTION ON DELETE CASCADE,
    CONSTRAINT cprislusenstvi_idcenik FOREIGN KEY (idcenik)
        REFERENCES ccenik (idcenik)
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
alter table cprislusenstvi owner to %firmaRole%;

CREATE INDEX cprislusenstvi_idcenikotec_index ON cprislusenstvi USING btree (idcenikotec);
CREATE INDEX cprislusenstvi_idcenik_index ON cprislusenstvi USING btree (idcenik);

-- tabulka typ atributu
create sequence seq_ctypatribut
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_ctypatribut owner to %firmaRole%;

create table cTypAtribut(
    idTypAtribut integer default nextval('seq_ctypatribut'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    typatributk character varying(50),
    idmj integer,

    CONSTRAINT ctypatribut_pkey PRIMARY KEY (idtypatribut),
    CONSTRAINT ctypatribut_idmj FOREIGN KEY (idmj)
        REFERENCES cmerjed (idmj) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
alter table ctypatribut owner to %firmaRole%;

CREATE INDEX cTypAtribut_IdMj_index ON cTypAtribut USING btree (IdMj);

-- tabulka typ zbozi
create sequence seq_ctypzbozi
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_ctypzbozi owner to %firmaRole%;

create table cTypZbozi(
    idTypZbozi integer default nextval('seq_ctypzbozi'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,

    CONSTRAINT ctypzbozi_pkey PRIMARY KEY (idtypzbozi)
);
alter table ctypzbozi owner to %firmaRole%;

CREATE TABLE wkli_typzbozi (
    idtypzbozi integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_typzbozi_pkey PRIMARY KEY (idtypzbozi, idvybklic),
    CONSTRAINT wkli_typzbozi_idtypzbozi FOREIGN KEY (idtypzbozi)
      REFERENCES ctypzbozi (idtypzbozi) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_typzbozi_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_typzbozi OWNER TO %firmaRole%;

CREATE INDEX wkli_typzbozi_idtypzbozi_index ON wkli_typzbozi USING btree (idtypzbozi);
CREATE INDEX wkli_typzbozi_idvybklic_index ON wkli_typzbozi USING btree (idvybklic);

CREATE TABLE ctypatribut_typzbozi (
    idtypzbozi integer NOT NULL,
    idtypatribut integer NOT NULL,

    CONSTRAINT ctypatribut_typzbozi_pkey PRIMARY KEY (idtypzbozi, idtypatribut),
    CONSTRAINT ctypatribut_typzbozi_idtypzbozi FOREIGN KEY (idtypzbozi)
      REFERENCES ctypzbozi (idtypzbozi) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT ctypatribut_typzbozi_idtypatribut FOREIGN KEY (idtypatribut)
        REFERENCES ctypatribut(idtypatribut) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.ctypatribut_typzbozi OWNER TO %firmaRole%;

CREATE INDEX ctypatribut_typzbozi_idtypzbozi_index ON ctypatribut_typzbozi USING btree (idtypzbozi);
CREATE INDEX ctypatribut_typzbozi_idtypatribut_index ON ctypatribut_typzbozi USING btree (idtypatribut);


-- tabulka atribut
create sequence seq_catribut
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_catribut owner to %firmaRole%;

create table catribut (
    idatribut integer default nextval('seq_catribut'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    idcenik integer NOT NULL,
    idtypatribut integer NOT NULL,
    valBoolean boolean,
    valInteger integer,
    valNumeric numeric(19,6),
    valString text,
    valDatCas timestamp without time zone,
    hodnota text,

    CONSTRAINT catribut_pkey PRIMARY KEY (idatribut),
    CONSTRAINT catribut_idcenik FOREIGN KEY (idcenik)
        REFERENCES ccenik (idcenik)
        ON UPDATE NO ACTION ON DELETE CASCADE,
    CONSTRAINT catribut_idtypatribut FOREIGN KEY (idtypatribut)
        REFERENCES ctypatribut (idtypatribut)
        ON UPDATE NO ACTION ON DELETE CASCADE
);
alter table catribut owner to %firmaRole%;

CREATE INDEX catribut_idcenik_index ON catribut USING btree (idcenik);
CREATE INDEX catribut_idtypatribut_index ON catribut USING btree (idtypatribut);

alter table dformadopravy add column exportEshop boolean DEFAULT true NOT NULL;
alter table dformadopravy add column idDopravne integer;
alter table dformadopravy add constraint dformadopravy_iddopravne FOREIGN KEY (iddopravne)
        REFERENCES ccenik (idcenik)
        ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dFormaDopravy_IdDopravne_index ON dFormaDopravy USING btree (IdDopravne);

-- vlozeni dat do tabulky cstavcen stavy ceniku
INSERT INTO cstavcen(idstavcen, kod, nazev, neprodejne) 
VALUES (1, 'NOVINKA', 'Novinka', false);
INSERT INTO cstavcen(idstavcen, kod, nazev, neprodejne) 
VALUES (2, 'AKCE', 'Akce', false);
INSERT INTO cstavcen(idstavcen, kod, nazev, neprodejne) 
VALUES (3, 'BĚŽNÝ PRODEJ', 'Běžný prodej', false);
INSERT INTO cstavcen(idstavcen, kod, nazev, neprodejne) 
VALUES (4, 'VÝPRODEJ', 'Výprodej', false);
INSERT INTO cstavcen(idstavcen, kod, nazev, neprodejne) 
VALUES (5, 'JIŽ NEPRODEJNÉ', 'Již neprodejné', true);
select setval('seq_cstavcen', (select max(idstavcen)+1 from cstavcen));

CREATE FUNCTION to_ascii(bytea, name) 
RETURNS text AS 'to_ascii_encname' LANGUAGE internal IMMUTABLE STRICT;

ALTER FUNCTION public.to_ascii(bytea, name) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 661, 't', %appVersion%, clock_timestamp());
