--------------------------------------------------------------------------------
-- Bug 32364 – [WinStrom] České sazby DPH na rok 2013
--------------------------------------------------------------------------------

UPDATE usazbydph
SET platidodata='2012-12-31'
WHERE uuid='CZ_14_2012';
UPDATE usazbydph
SET platidodata='2012-12-31'
WHERE uuid='CZ_20_2010';

CREATE OR REPLACE FUNCTION doUpgrade()
  RETURNS void AS
$BODY$    
declare
  pom integer;
  _idstatu integer;
begin    
    select idstatu into _idstatu from astaty where uuid like '%_CZ';

    -- Sazba DPH 15%
    pom = 0;
    select count(1) into pom from usazbydph
    where typSzbDphK = 'typSzbDph.dphSniz' and szbdph = 15.00 and idstatu = _idstatu
      and (platioddata is null or platioddata >= '2013-01-01');

    if (pom = 0) then
        INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
            VALUES ('2012-12-21 15:30:00.000', NULL, '2013-01-01', NULL, NULL, 15.00, 'typSzbDph.dphSniz',
            _idstatu, 'CZ_15_2013');
    end if;

    -- Sazba DPH 21%
    pom = 0;
    select count(1) into pom from usazbydph
    where typSzbDphK = 'typSzbDph.dphZakl' and szbdph = 21.00 and idstatu = _idstatu
      and (platioddata is null or platioddata >= '2013-01-01');

    if (pom = 0) then
        INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
            VALUES ('2012-12-21 15:30:00.000', NULL, '2013-01-01', NULL, NULL, 21.00, 'typSzbDph.dphZakl',
            _idstatu, 'CZ_21_2013');
    end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION doUpgrade() OWNER TO %firmaRole%;

select doUpgrade();
drop function doUpgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 688, 't', %appVersion%, clock_timestamp());
