--------------------------------------------------------------------------------
-- Bug 32956 – [FlexiBee] Přidat Partikulární Podporu Pro Pokročilou Parametrizaci
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wparam OWNER TO %firmaRole%;

CREATE TABLE wparam (
    idparam integer DEFAULT nextval('seq_wparam'::regclass) NOT NULL,
    lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
    paramk character varying(50), 
    hodnota text,
    kodreportu character varying(255),

    iduzivatel integer,
    idrole integer,
    idstred integer,
    idbsp integer,
    idtypdokl integer,
    idfirmy integer,
    idskupfir integer,
    idzakazky integer,

    CONSTRAINT wparam_pkey PRIMARY KEY (idparam),
    CONSTRAINT wparam_iduzivatel FOREIGN KEY (iduzivatel)
        REFERENCES wuzivatel(iduzivatel) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idrole FOREIGN KEY (idrole)
        REFERENCES wrole(idrole) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idstred FOREIGN KEY (idstred)
        REFERENCES ustrediska(idstred) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idbsp FOREIGN KEY (idbsp)
        REFERENCES dbsp(idbsp) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idtypdokl FOREIGN KEY (idtypdokl)
        REFERENCES dtypdokl(idtypdokl) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idfirmy FOREIGN KEY (idfirmy)
        REFERENCES aadresar(idfirmy) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idskupfir FOREIGN KEY (idskupfir)
        REFERENCES askupfir(idskupfir) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wparam_idzakazky FOREIGN KEY (idzakazky)
        REFERENCES uzakazky(idzakazky) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wparam OWNER TO %firmaRole%;

CREATE INDEX wparam_iduzivatel_index ON wparam USING btree (iduzivatel);
CREATE INDEX wparam_idrole_index ON wparam USING btree (idrole);
CREATE INDEX wparam_idstred_index ON wparam USING btree (idstred);
CREATE INDEX wparam_idbsp_index ON wparam USING btree (idbsp);
CREATE INDEX wparam_idtypdokl_index ON wparam USING btree (idtypdokl);
CREATE INDEX wparam_idfirmy_index ON wparam USING btree (idfirmy);
CREATE INDEX wparam_idskupfir_index ON wparam USING btree (idskupfir);
CREATE INDEX wparam_idzakazky_index ON wparam USING btree (idzakazky);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 707, 't', %appVersion%, clock_timestamp());
