-- Bug 13581 – [WinStrom] Nová tabulka typů účetních operací
-- Bug 13582 – [WinStrom] Vyčlenění typu účetní operace z tabulky typů dokladů

--------------------------------------------------------------------------------
-- Bug 13581 – [WinStrom] Nová tabulka typů účetních operací
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_utypucop
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_utypucop OWNER TO %firmaRole%;


-- Table: utypucop

-- DROP TABLE utypucop;

CREATE TABLE utypucop
(
  idtypucop integer DEFAULT nextval('seq_utypucop'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  "show" boolean NOT NULL DEFAULT true,

  modulfav boolean DEFAULT false,
  modulfap boolean DEFAULT false,
  modulphl boolean DEFAULT false,
  modulzav boolean DEFAULT false,
  modulbanp boolean DEFAULT false,
  modulbanv boolean DEFAULT false,
  modulpokp boolean DEFAULT false,
  modulpokv boolean DEFAULT false,
  modulsklp boolean DEFAULT false,
  modulsklv boolean DEFAULT false,
  modulint boolean DEFAULT false,

  danevidk character varying(50),
  kodplnenik character varying(50),

  idprotiucetp integer,
  idprotiucetv integer,
  iddphsnizucet integer,
  iddphzaklucet integer,
  iducetobdobiod integer,
  iducetobdobido integer,
  uuid character varying(50),

  CONSTRAINT utypucop_pkey PRIMARY KEY (idtypucop),

  CONSTRAINT fkaa41c0051f1e399d FOREIGN KEY (idprotiucetp)
      REFERENCES uucty (iducet),
  CONSTRAINT fkaa41c0051f1e39a3 FOREIGN KEY (idprotiucetv)
      REFERENCES uucty (iducet),
  CONSTRAINT fkaa41c00564253e7b FOREIGN KEY (iddphsnizucet)
      REFERENCES uucty (iducet),
  CONSTRAINT fkaa41c0058e40de77 FOREIGN KEY (iddphzaklucet)
      REFERENCES uucty (iducet),
  CONSTRAINT fkaa41c00527753f8 FOREIGN KEY (iducetobdobiod)
      REFERENCES nucetobdobi (iducetobdobi),
  CONSTRAINT fkaa41c00527752ae FOREIGN KEY (iducetobdobido)
      REFERENCES nucetobdobi (iducetobdobi)
);

ALTER TABLE utypucop OWNER TO %firmaRole%;


CREATE INDEX utypucop_idprotiucetp_index ON utypucop USING btree (idprotiucetp);
CREATE INDEX utypucop_idprotiucetv_index ON utypucop USING btree (idprotiucetv);
CREATE INDEX utypucop_iddphsnizucet_index ON utypucop USING btree (iddphsnizucet);
CREATE INDEX utypucop_iddphzaklucet_index ON utypucop USING btree (iddphzaklucet);
CREATE INDEX utypucop_iducetobdobiod_index ON utypucop USING btree (iducetobdobiod);
CREATE INDEX utypucop_iducetobdobido_index ON utypucop USING btree (iducetobdobido);


--------------------------------------------------------------------------------
-- Bug 13582 – [WinStrom] Vyčlenění typu účetní operace z tabulky typů dokladů
--------------------------------------------------------------------------------

ALTER TABLE dtypdokl ADD COLUMN idtypucopp integer;
ALTER TABLE dtypdokl ADD COLUMN idtypucopv integer;

ALTER TABLE dtypdokl
    ADD CONSTRAINT dtypdokl_idtypucopp FOREIGN KEY (idtypucopp)
                                       REFERENCES utypucop(idtypucop);
ALTER TABLE dtypdokl
    ADD CONSTRAINT dtypdokl_idtypucopv FOREIGN KEY (idtypucopv)
                                       REFERENCES utypucop(idtypucop);

CREATE INDEX dTypDokl_IdTypUcOpP_index ON dTypDokl USING btree (IdTypUcOpP);
CREATE INDEX dTypDokl_IdTypUcOpV_index ON dTypDokl USING btree (IdTypUcOpV);


--------------------------------------------------------------------------------

ALTER TABLE ddoklfak ADD COLUMN idtypucop integer;
ALTER TABLE dpolfak ADD COLUMN idtypucop integer;

ALTER TABLE ddoklint ADD COLUMN idtypucop integer;
ALTER TABLE dpolint ADD COLUMN idtypucop integer;

ALTER TABLE ddoklsklad ADD COLUMN idtypucop integer;
ALTER TABLE dpolsklad ADD COLUMN idtypucop integer;

ALTER TABLE ddoklobch ADD COLUMN idtypucop integer;
ALTER TABLE dpolobch ADD COLUMN idtypucop integer;


ALTER TABLE ddoklfak
    ADD CONSTRAINT ddoklfak_idtypucop FOREIGN KEY (idtypucop)
                                      REFERENCES utypucop(idtypucop);
ALTER TABLE dpolfak
    ADD CONSTRAINT dpolfak_idtypucop FOREIGN KEY (idtypucop)
                                     REFERENCES utypucop(idtypucop);

ALTER TABLE ddoklint
    ADD CONSTRAINT ddoklint_idtypucop FOREIGN KEY (idtypucop)
                                      REFERENCES utypucop(idtypucop);
ALTER TABLE dpolint
    ADD CONSTRAINT dpolint_idtypucop FOREIGN KEY (idtypucop)
                                     REFERENCES utypucop(idtypucop);

ALTER TABLE ddoklsklad
    ADD CONSTRAINT ddoklsklad_idtypucop FOREIGN KEY (idtypucop)
                                        REFERENCES utypucop(idtypucop);
ALTER TABLE dpolsklad
    ADD CONSTRAINT dpolsklad_idtypucop FOREIGN KEY (idtypucop)
                                       REFERENCES utypucop(idtypucop);

ALTER TABLE ddoklobch
    ADD CONSTRAINT ddoklobch_idtypucop FOREIGN KEY (idtypucop)
                                       REFERENCES utypucop(idtypucop);
ALTER TABLE dpolobch
    ADD CONSTRAINT dpolobch_idtypucop FOREIGN KEY (idtypucop)
                                      REFERENCES utypucop(idtypucop);

CREATE INDEX dDoklFak_IdTypUcOp_index ON dDoklFak USING btree (IdTypUcOp);
CREATE INDEX dPolFak_IdTypUcOp_index ON dPolFak USING btree (IdTypUcOp);

CREATE INDEX dDoklInt_IdTypUcOp_index ON dDoklInt USING btree (IdTypUcOp);
CREATE INDEX dPolInt_IdTypUcOp_index ON dPolInt USING btree (IdTypUcOp);

CREATE INDEX dDoklObch_IdTypUcOp_index ON dDoklObch USING btree (IdTypUcOp);
CREATE INDEX dPolObch_IdTypUcOp_index ON dPolObch USING btree (IdTypUcOp);

CREATE INDEX dDoklSklad_IdTypUcOp_index ON dDoklSklad USING btree (IdTypUcOp);
CREATE INDEX dPolSklad_IdTypUcOp_index ON dPolSklad USING btree (IdTypUcOp);


--------------------------------------------------------------------------------

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 84, 't');