--------------------------------------------------------------------------------
-- Bug 39470 – [Bug] Chybné vyhledávání podle uzlu ve stromu ceníku
--------------------------------------------------------------------------------

create or replace function opravStrom(i_idUzlu integer)
RETURNS void AS
$BODY$
declare
  _otec record;
  _potomek record;
  _poradi int;
begin
  if(i_idUzlu is null) then
     select * into _otec from wuzel where idOtec is null;
   else
     select * into _otec from wuzel where idUzel = i_idUzlu;
   end if;

   _poradi = 0;
   for _potomek in (select * from wuzel where idOtec = _otec.idUzel order by idOtec, poradi, idUzel) loop
     _poradi = _poradi + 1;
     update wuzel set
       poradi = _poradi,
       cesta = _otec.cesta || _poradi || '/',
       hladina = _otec.hladina + 1
       where iduzel = _potomek.iduzel;

     perform opravStrom(_potomek.iduzel);
   end loop;
end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION opravStrom(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 860, 't', %appVersion%, clock_timestamp());
