-- Bug 13640 – [WinStrom] Upravit data tabulky členění DPH dle nových kódů plnění
-- Bug 13582 - [WinStrom] Vyčlenění typu účetní operace z tabulky typů dokladů

--------------------------------------------------------------------------------
-- Bug 13640 – [WinStrom] Upravit data tabulky členění DPH dle nových kódů plnění
--------------------------------------------------------------------------------

UPDATE uclendph SET kodplnenik = 'kodPlneni.sluzby' WHERE uuid = 'CZ 05-06';
UPDATE uclendph SET kodplnenik = 'kodPlneni.sluzby' WHERE uuid = 'CZ 05-06, 44-45';
UPDATE uclendph SET kodplnenik = 'kodPlneni.sluzby' WHERE uuid = 'CZ 05-06, 44-45 KR';

UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 09';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 09, 44';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 09, 44 KR';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 09, 44, 48';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 09, 44, 48 KR';

UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 11-12';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 11-12, 44-45';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 11-12, 44-45 KR';

UPDATE uclendph SET kodplnenik = 'kodPlneni.sluzby' WHERE uuid = 'CZ 21';
UPDATE uclendph SET kodplnenik = 'kodPlneni.sluzby' WHERE uuid = 'CZ 21, 51 SN';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 23';
UPDATE uclendph SET kodplnenik = 'kodPlneni.doprProstr' WHERE uuid = 'CZ 23, 51 SN';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 25';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 25, 51 SN';

UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 44-45';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 44-45 KR';
UPDATE uclendph SET kodplnenik = 'kodPlneni.ostatni' WHERE uuid = 'CZ 46';
UPDATE uclendph SET kodplnenik = 'kodPlneni.osv' WHERE uuid = 'CZ 50';
UPDATE uclendph SET kodplnenik = 'kodPlneni.osv' WHERE uuid = 'CZ 50, 51 BN';


-- u puvodnich kodu plneni DPH pouzijeme smysluplnejsi kody
UPDATE uclendph SET kodplnenik = 'kodPlneni.zbozi' WHERE kodplnenik = 'kodPlneni.0';
UPDATE uclendph SET kodplnenik = 'kodPlneni.majetek' WHERE kodplnenik = 'kodPlneni.1';
UPDATE uclendph SET kodplnenik = 'kodPlneni.tristran' WHERE kodplnenik = 'kodPlneni.2';


--------------------------------------------------------------------------------
-- Bug 13582 - [WinStrom] Vyčlenění typu účetní operace z tabulky typů dokladů
--------------------------------------------------------------------------------

-----------------------------------------------
-- [0] TEMPORARY TABLE tmp_utypucop

DROP TABLE IF EXISTS tmp_utypucop;
  
CREATE TEMPORARY TABLE tmp_utypucop (
  idtypucop integer PRIMARY KEY DEFAULT nextval('seq_utypucop'::regclass) NOT NULL,
  idtypdokl integer,
  idtypdoklp integer,
  idtypdoklv integer,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,

  modul character varying(3) NOT NULL,
  modulfav boolean DEFAULT false,
  modulfap boolean DEFAULT false,
  modulphl boolean DEFAULT false,
  modulzav boolean DEFAULT false,
  modulbanp boolean DEFAULT false,
  modulbanv boolean DEFAULT false,
  modulpokp boolean DEFAULT false,
  modulpokv boolean DEFAULT false,
  modulsklp boolean DEFAULT false,
  modulsklv boolean DEFAULT false,
  modulint boolean DEFAULT false,

  danevidk character varying(50),
  kodplnenik character varying(50),

  idprotiucetp integer,
  idprotiucetv integer,
  iddphsnizucet integer,
  iddphzaklucet integer,
  iducetobdobiod integer,
  iducetobdobido integer,
  uuid character varying(50)
) WITH (OIDS=FALSE);


-----------------------------------------------
-- [1] Prijem: FAV || PHL || SKL || BAN || POK

INSERT INTO tmp_utypucop (
  idtypdokl, idtypdoklp, idtypdoklv, kod, nazev, danevidk, idprotiucetp, idprotiucetv, iddphsnizucet, iddphzaklucet, kodplnenik,
  modul, modulfav, modulfap, modulphl, modulzav, modulbanp, modulbanv, modulpokp, modulpokv, modulsklp, modulsklv, modulint,
  iducetobdobiod, iducetobdobido, uuid )
SELECT td.idtypdokl AS idtypdokl, td.idtypdokl AS idtypdoklp, null AS idtypdoklv,
  case when modul='BAN' or modul='POK' or modul='SKL' then substring(td.kod || ' - PŘÍJEM' from 1 for 20) else td.kod end AS kod,
  case when modul='BAN' or modul='POK' or modul='SKL' then substring(td.nazev || ' - příjem' from 1 for 255) else td.nazev end AS nazev,
  td.danevidk, td.idprotiucetp, null AS idprotiucetv, td.iddphsnizucet, td.iddphzaklucet,
  --td.idclendphp,
  cd.kodplnenik,
  td.modul,
  case when modul='FAV' then true else false end AS modulfav,
  false AS modulfap,
  case when modul='PHL' then true else false end AS modulphl,
  false AS modulzav,
  case when modul='BAN' then true else false end AS modulbanp,
  false AS modulbanv,
  case when modul='POK' then true else false end AS modulpokp,
  false AS modulpokv,
  case when modul='SKL' then true else false end AS modulsklp,
  false AS modulsklv,
  false AS modulint,
  --td.modul,
  td.iducetobdobiod, td.iducetobdobido,
  td.uuid || '_TUOMIG' || case when modul='BAN' or modul='POK' or modul='SKL' then 'P' else '' end AS uuid
FROM dtypdokl td LEFT OUTER JOIN uclendph cd ON td.idclendphp = cd.idclendph
WHERE td.modul IN ('FAV','PHL','SKL','BAN','POK') AND
  td.ucetni = true AND
  (td.danevidk IS NOT NULL OR td.idprotiucetp IS NOT NULL OR
   td.iddphsnizucet IS NOT NULL OR td.iddphzaklucet IS NOT NULL OR td.idclendphp IS NOT NULL)
ORDER BY modul;


-----------------------------------------------
-- [2] Vydej: FAP || ZAV || SKL || BAN || POK

INSERT INTO tmp_utypucop (
  idtypdokl, idtypdoklp, idtypdoklv, kod, nazev, danevidk, idprotiucetp, idprotiucetv, iddphsnizucet, iddphzaklucet, kodplnenik,
  modul, modulfav, modulfap, modulphl, modulzav, modulbanp, modulbanv, modulpokp, modulpokv, modulsklp, modulsklv, modulint,
  iducetobdobiod, iducetobdobido, uuid )
SELECT td.idtypdokl AS idtypdokl, null AS idtypdoklp, td.idtypdokl AS idtypdoklv,
  case when modul='BAN' or modul='POK' or modul='SKL' then substring(td.kod || ' - VÝDEJ' from 1 for 20) else td.kod end AS kod,
  case when modul='BAN' or modul='POK' or modul='SKL' then substring(td.nazev || ' - výdej' from 1 for 255) else td.nazev end AS nazev,
  td.danevidk, null AS idprotiucetp, td.idprotiucetv, td.iddphsnizucet, td.iddphzaklucet,
  --td.idclendphv,
  cd.kodplnenik,
  td.modul,
  false AS modulfav,
  case when modul='FAP' then true else false end AS modulfap,
  false AS modulphl,
  case when modul='ZAV' then true else false end AS modulzav,
  false AS modulbanp,
  case when modul='BAN' then true else false end AS modulbanv,
  false AS modulpokp,
  case when modul='POK' then true else false end AS modulpokv,
  false AS modulsklp,
  case when modul='SKL' then true else false end AS modulsklv,
  false AS modulint,
  --td.modul,
  td.iducetobdobiod, td.iducetobdobido,
  td.uuid || '_TUOMIG' || case when modul='BAN' or modul='POK' or modul='SKL' then 'V' else '' end AS uuid
FROM dtypdokl td LEFT OUTER JOIN uclendph cd ON td.idclendphv = cd.idclendph
WHERE td.modul IN ('FAP','ZAV','SKL','BAN','POK') AND
  td.ucetni = true AND
  (td.danevidk IS NOT NULL OR td.idprotiucetv IS NOT NULL OR
   td.iddphsnizucet IS NOT NULL OR td.iddphzaklucet IS NOT NULL OR td.idclendphv IS NOT NULL)
ORDER BY modul;


-----------------------------------------------
-- [3] Prijem: INT

INSERT INTO tmp_utypucop (
  idtypdokl, idtypdoklp, idtypdoklv, kod, nazev, danevidk, idprotiucetp, idprotiucetv, iddphsnizucet, iddphzaklucet, kodplnenik,
  modul, modulfav, modulfap, modulphl, modulzav, modulbanp, modulbanv, modulpokp, modulpokv, modulsklp, modulsklv, modulint,
  iducetobdobiod, iducetobdobido, uuid )
SELECT td.idtypdokl AS idtypdokl, td.idtypdokl AS idtypdoklp, null AS idtypdoklv,
  td.kod,
  td.nazev,
  td.danevidk, td.idprotiucetp AS idprotiucetp, td.idprimucet AS idprotiucetv, td.iddphsnizucet, td.iddphzaklucet,
  --td.idclendphp,
  cd.kodplnenik,
  td.modul,
  false AS modulfav,
  false AS modulfap,
  false AS modulphl,
  false AS modulzav,
  false AS modulbanp,
  false AS modulbanv,
  false AS modulpokp,
  false AS modulpokv,
  false AS modulsklp,
  false AS modulsklv,
  true AS modulint,
  --td.modul,
  td.iducetobdobiod, td.iducetobdobido,
  td.uuid || '_TUOMIG' AS uuid
FROM dtypdokl td LEFT OUTER JOIN uclendph cd ON td.idclendphp = cd.idclendph
WHERE td.modul IN ('INT') AND
  td.ucetni = true AND
  (td.danevidk IS NOT NULL OR td.idprimucet IS NOT NULL OR td.idprotiucetp IS NOT NULL OR
   td.iddphsnizucet IS NOT NULL OR td.iddphzaklucet IS NOT NULL OR td.idclendphp IS NOT NULL)
ORDER BY modul;


-----------------------------------------------
-- [4] Kontrolní výpis

--SELECT * FROM tmp_utypucop ORDER BY modul, idtypdokl, idtypucop;


-----------------------------------------------
-- [5] Inserty typů účetních případů

INSERT INTO utypucop (
  idtypucop, kod, nazev, danevidk, idprotiucetp, idprotiucetv, iddphsnizucet, iddphzaklucet, kodplnenik,
  modulfav, modulfap, modulphl, modulzav, modulbanp, modulbanv, modulpokp, modulpokv, modulsklp, modulsklv, modulint,
  iducetobdobiod, iducetobdobido, uuid )
SELECT idtypucop, kod, nazev, danevidk, idprotiucetp, idprotiucetv, iddphsnizucet, iddphzaklucet, kodplnenik,
  modulfav, modulfap, modulphl, modulzav, modulbanp, modulbanv, modulpokp, modulpokv, modulsklp, modulsklv, modulint,
  iducetobdobiod, iducetobdobido, uuid
FROM tmp_utypucop ORDER BY modul;


-----------------------------------------------
-- [6] Navázání typů účetních případů na typy dokladů

UPDATE dtypdokl td
SET idtypucopp = ( SELECT tuo.idtypucop
                   FROM tmp_utypucop tuo
                   WHERE tuo.idtypdoklp = td.idtypdokl );

UPDATE dtypdokl td
SET idtypucopv = ( SELECT tuo.idtypucop
                   FROM tmp_utypucop tuo
                   WHERE tuo.idtypdoklv = td.idtypdokl );


-----------------------------------------------

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 92, 't');
