--------------------------------------------------------------------------------
-- Bug 42773 - Automatická tvorba rezervací s kombinací kopie dokladu vytváří chybné rezervace
--------------------------------------------------------------------------------

-- Function: dgetstavnaskladeaktualni(integer, integer, date, integer, integer)

-- DROP FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer, integer);

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(
    i_idcenik integer,
    i_idsklad integer,
    i_datum date,
    i_idfirma integer,
    i_iddoklobch integer,
    i_novyDoklad boolean)
  RETURNS numeric AS
$BODY$  
declare  
  _stavMj numeric(19,6);   
  _firmaRezerMj numeric(19,6);   
  _celkemRezerMj numeric(19,6);   
begin  
  SELECT dgetstavnaskladeaktualni(i_idcenik, i_idsklad, i_datum) INTO _stavMj;   
    
  -- zjistime kolik je celkem rezervovano - od/do ignorujeme (bug 25844, 25789), muselo by se zohlednovat uz pri plneni pole skladmj a nebo toto pole idealne vyhodit  
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace where idcenik = i_idcenik and idsklad = i_idsklad;  
     
  IF (i_idfirma > 0) THEN   
    IF (i_iddoklobch > 0) THEN 
        -- zjistime kolik ma firma rezervovano   
        select coalesce(sum(r.skladmj), 0) into _firmaRezerMj from srezervace r  
            left join dpolobch po on r.idpolobch = po.idpolobch 
            where r.idfirmy = i_idfirma and r.idcenik = i_idcenik and r.idsklad = i_idsklad and (po.iddoklobch is null or po.iddoklobch = i_iddoklobch);  
    ELSIF (i_novyDoklad) THEN
            -- zjistime kolik ma firma rezervovano   
        select coalesce(sum(r.skladmj), 0) into _firmaRezerMj from srezervace r  
            left join dpolobch po on r.idpolobch = po.idpolobch 
            where r.idfirmy = i_idfirma and r.idcenik = i_idcenik and r.idsklad = i_idsklad and po.iddoklobch is null;  
    ELSE 
        select coalesce(sum(skladmj), 0) into _firmaRezerMj from srezervace where idfirmy = i_idfirma and idcenik = i_idcenik and idsklad = i_idsklad;  
    END IF; 
  
  ELSE   
    _firmaRezerMj := 0;   
  END IF;   
     
  -- spocteme kolik mu muzeme dat   
  _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj);   
     
  RETURN _stavMj;   
end;   
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer, integer,boolean)
  OWNER TO %firmaRole%;

-- Function: dgetstavnaskladeaktualni(integer, integer, date, integer)

-- DROP FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer);

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(
    i_idcenik integer,
    i_idsklad integer,
    i_datum date,
    i_idfirma integer)
  RETURNS numeric AS
$BODY$  
declare  
  _stavMj numeric(19,6);  
begin    
  select dgetstavnaskladeaktualni(i_idcenik, i_idsklad, i_datum, i_idfirma, -1, false) into _stavMj; 
  return _stavMj;   
end;   
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date, integer)
  OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer)
  RETURNS numeric AS
$BODY$   
declare  
  zbyvaNakl numeric(15,2);  
  moznoSklad numeric(15,2);  
  moznoNesklad numeric(15,2);  
  vysledek numeric(20,2);  
  _idadresar integer; 
begin   
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl and mnozmj > 0 and cenamj > 0;  
   
  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl; 
   
  select coalesce(sum(a.procpol), 0) into moznoSklad from  
   (select minValue(  
        maxValue(dgetstavnaskladeaktualni(P.idCenik, P.idBspSkl, DATE(NOW()), _idadresar, idDokl, false), 0), 
        sum(mnozMj-mnozMjReal))  
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol 
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  
      where idDoklObch = idDokl and C.skladove = true and mnozMj-mnozMjReal > 0 
    group by P.idcenik, idbspskl) as a; 
  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad  
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  where idDoklObch = idDokl and cenaMj > 0 and mnozmj > 0 and  (C.skladove is null or C.skladove = false);  
  
  if (zbyvaNakl = 0) then  
    vysledek := 100 ;  
  else  
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100;  
  end if;   
  if (vysledek < 0.0) then  
     vysledek := -1.0; 
  end if;	 
  if (vysledek > 999) then  
     vysledek := 999; 
  end if;  
    
  return vysledek;  
end;   
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION obchodrealizovatelnost(integer)
  OWNER TO %firmaRole%;
  
-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 933, 't', %appVersion%, clock_timestamp());
