-------------------------------------------------------------------------
-- Bug 44108 - Změna datového modelu pro ukládání rozpadu úhrad pro potřeby osobitné úpravy 
-------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare

    _pocet_sk integer;
    stat character varying(10);
 
 
begin

	-- ucet
    select count(*) into _pocet_sk from uucty where kod = '343999';
    
    select a.uuid into stat from nnastav n left join utyporg u on u.idtyporg = n.idtyporg
           left join astaty a on a.idstatu = u.idstatu order by coalesce(n.platioddata, '1900-01-01') desc limit 1;
 
     if (stat = 'SK_SK') then
        if(_pocet_sk = 0) then
            INSERT INTO uucty (lastupdate, kod, nazev, show, danovy, saldo, typuctuk, druhuctuk, prijemfav, vydejfap, prijemskl, vydejskl, prijemban, vydejban, prijempok, vydejpok, idstducet, idtyporg, uuid)
                VALUES ('2015-12-10 00:00:00.000', '343999', 'Daň z pridanej hodnoty - pomocný účet', true, false, false, 'typUctu.rozvahovy', 'druhUctu.aktpasvy', false, false, false, false, false, false, false, false, (select IdStdUcet from uStdUcty where uuid = 'SK_POD_343'), 3, 'SK_POD_343999');
        end if;
     end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- aktualizace funkce pro hledání vazeb
CREATE OR REPLACE FUNCTION findvicevazeb(
    _inserttab character varying,
    _iddokl integer,
    _modul character varying,
    _uroven integer,
    _prechodvp boolean)
  RETURNS void AS
$BODY$  
declare  
  tabulka varchar(20);  
  poleStav varchar(20);  
  dotaz varchar;  
  prechodPom varchar;    
begin  
  tabulka = getdoklnamepostfixbymodul(_modul);  
  prechodPom = '';  
  
  if (_uroven = 0) then  
    if (tabulka = 'Fak') then  
      poleStav = 'stavUhrK';  
    else  
      poleStav = 'stavUzivK'; 
      prechodPom = 'cast(null as numeric) as ';   
    end if;  
      
    dotaz =   
      'select 0 as idVazby, null as typVazbyK, false as storno, D.idDokl' || tabulka || ' as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.' || poleStav || ' as stavK, 
        D.nazFirmy, D.mesto, ' || prechodPom || 'juhsum, ' || prechodPom || 'juhsummen 
        from dDokl' || tabulka || ' as D where D.idDokl' || tabulka || ' = ' || _idDokl || ' and D.modul = ''' || _modul || '''';  
  else  
  
  if (tabulka = 'Fak') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'',  
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'', ''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.nakladVynos'')   
          and V.modulB in (''BAN'', ''POK'', ''INT'')   
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.PP'')   
          and V.modulA in (''BAN'', ''POK'', ''INT'')   
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazovanaFaktura'')   
          and V.modulA in (''INT'')  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocitavanaFaktura'')   
          and V.modulA in (''INT'')  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.hlavaSkl''  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.uhradaPP'', ''typVazbyDokl.hlavaDobropis'') 
          and V.modulB in (''PHL'', ''ZAV'', ''FAP'', ''FAV'') 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.uhradaPP'', ''typVazbyDokl.hlavaDobropis'')  
          and V.modulA in (''PHL'', ''ZAV'', ''FAP'', ''FAV'') 
      union   
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul  
        where V.idTabA in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and  
          V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'')   
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavuhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen  
      union   
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on D.idDoklFak=  
                (select idDoklFak from dPolFak where idPolFak = V.idTabA) and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'')  
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen  
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'') 
      union 
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dPolFak as P on P.idPolFak = V.idTabA left outer join dDoklFak as D on D.idDoklFak = P.idDoklFak 
        where V.idTabB in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and V.modulB=''' || _modul || ''' and 
          V.typVazbyK = ''typVazbyDokl.odpocetPolZALOHY''   
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
      union 
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dPolFak as P on P.idPolFak = V.idTabB left outer join dDoklFak as D on D.idDoklFak = P.idDoklFak 
        where V.idTabA in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and V.modulB=''' || _modul || ''' and 
          V.typVazbyK = ''typVazbyDokl.odpocetPolZALOHY''   
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen';  
  else if (tabulka = 'Int') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'',  
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'', ''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.nakladVynos'')   
          and V.modulA in (''PHL'', ''ZAV'', ''FAP'', ''FAV'') 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.PP'')   
          and V.modulB in (''PHL'', ''ZAV'', ''FAP'', ''FAV'') 
           
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.hlavaSkl'')   
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')   
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazujiciDoklad'')   
          and V.modulA in (''INT'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazovanaFaktura'')   
          and V.modulB in (''FAP'', ''FAV'', ''ZAV'', ''PHL'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocitavanaFaktura'')   
          and V.modulB in (''FAP'', ''FAV'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazujiciDoklad'')   
          and V.modulB in (''POK'', ''BAN'')';    
  else if (tabulka = 'Sklad') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and   
          V.modulA in (''FAV'',''FAP'',''PHL'',''ZAV'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl''   
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and   
          V.modulA in (''BAN'',''POK'',''INT'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl''  
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and 
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus'' 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and 
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus'' 
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and  
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod''  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and  
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod''  
      union    
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla''';  
  else if (tabulka = 'Obch') then  
    if (_prechodVP = false and _modul in ('PPV', 'OBV')) then  
      prechodPom = ' and D.modul in (''PPV'', ''NAP'', ''OBV'')';  
    end if;  
    
    dotaz =   
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || '  
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklObch as D on V.idTabB=D.idDoklObch and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || '  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK, 
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'')  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla''';  
  else  
    raise exception 'findVazbyDokladu(): Neznámá tabulka % pro modul %', tabulka, _modul;   
  end if;  
  end if;  
  end if;  
  end if;  
    
  end if;  
    
  execute 'insert into ' || _insertTab || ' (idvazebnidoklad, typVazbyK, storno, idDokl, modul, modulk, kod, varsym, datvyst, datucto, sumcelkem,  
  sumcelkemmen, popis, poznam, idtypdokl,idmeny, iduziv, stavk, nazFirmy, mesto, juhsum, juhsummen, uroven, novy) select *, ' || _uroven || ', true from ('   
     || dotaz || ') as UN where (select count(*) from ' || _insertTab || ' as TV where   
     (TV.idDokl = UN.idDokl and TV.modul = UN.modul) or UN.idVazby = TV.idvazebnidoklad) = 0';  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION findvicevazeb(character varying, integer, character varying, integer, boolean)
  OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 958, 't', %appVersion%, clock_timestamp());