--------------------------------------------------------------------------------
-- Bug 13582 – [WinStrom] Vyčlenění typu účetní operace z tabulky typů dokladů
--  - odstranění rušených sloupců
--
--  Pozn. 
--  Vytvořené indexy a contrainty na vazební sloupce se zruší automaticky
--  odstraněním příslušných vazebních sloupců.
--
--  Seznam rušených indexů a contraintů:
--  INDEX dtypdokl_idprotiucetp_index ON dtypdokl USING btree (idprotiucetp);
--  INDEX dtypdokl_idprotiucetv_index ON dtypdokl USING btree (idprotiucetv);
--  INDEX dtypdokl_iddphsnizucet_index ON dtypdokl USING btree (iddphsnizucet);
--  INDEX dtypdokl_iddphzaklucet_index ON dtypdokl USING btree (iddphzaklucet);
--  INDEX dtypdokl_idclendphp_index ON dtypdokl USING btree (idclendphp);
--  INDEX dtypdokl_idclendphv_index ON dtypdokl USING btree (idclendphv);
--  
--  CONSTRAINT fkc4463b531f1e399d FOREIGN KEY (idprotiucetp) REFERENCES uucty(iducet);
--  CONSTRAINT fkc4463b531f1e39a3 FOREIGN KEY (idprotiucetv) REFERENCES uucty(iducet);
--  CONSTRAINT fkc4463b5364253e7b FOREIGN KEY (iddphsnizucet) REFERENCES uucty(iducet);
--  CONSTRAINT fkc4463b538e40de77 FOREIGN KEY (iddphzaklucet) REFERENCES uucty(iducet);
--  CONSTRAINT fkc4463b5353af8c57 FOREIGN KEY (idclendphp) REFERENCES uclendph(idclendph);
--  CONSTRAINT fkc4463b5353af8c5d FOREIGN KEY (idclendphv) REFERENCES uclendph(idclendph);
--
--------------------------------------------------------------------------------

ALTER TABLE dtypdokl DROP COLUMN danevidk;
ALTER TABLE dtypdokl DROP COLUMN idprotiucetp;
ALTER TABLE dtypdokl DROP COLUMN idprotiucetv;
ALTER TABLE dtypdokl DROP COLUMN idclendphp;
ALTER TABLE dtypdokl DROP COLUMN idclendphv;
ALTER TABLE dtypdokl DROP COLUMN iddphzaklucet;
ALTER TABLE dtypdokl DROP COLUMN iddphsnizucet;


--------------------------------------------------------------------------------

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 97, 't');

