-----------------------------------------------------------------------
-- Bug 44870 - Odpočet ZDD, faktura zahr. - stejný kurz
------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION dpolfakdeletevazba() RETURNS trigger
    AS $$
declare _dokl record;
        _idzal integer;
        _idKorekce integer;
        uhrad integer;
        _stavUhrK varchar;
        _idPomInt integer; 
        _idVazbaOdpocFak integer;
        _idVazbaUhrFak integer;
begin  
  if (OLD.typPolozkyK in ('typPolozky.odpocetZalohy', 'typPolozky.odpocetZdd')) then
    select idtabb into _idzal from dvazebtab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    -- v případě odpočtu zálohové položky je ve vazební tabulce odkazována položka faktury, my ale chceme hlavičku faktury
    if (_idzal is null) then
        select pf.iddoklfak into _idzal from dvazebtab vt inner join dpolfak pf on vt.idtabb = pf.idpolfak where vt.idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY';
    end if;
    
    
        -- SK - pomocný interní doklad
    select d.iddoklint, vtz.idvazby, vtf.idvazby into _idPomInt, _idVazbaOdpocFak, _idVazbaUhrFak from ddoklint d 
        inner join dvazebtab vtz on vtz.idtaba = d.iddoklint
        inner join dvazebtab vtf on vtf.idtaba = d.iddoklint 
        where 
        vtz.idtabb = _idzal and vtz.typvazbyk = 'typVazbyDokl.odpocitavanaFaktura' and 
            vtf.idtabb =  OLD.idDoklFak and vtf.typvazbyk = 'typVazbyDokl.uhrazovanaFaktura';

    if (_idVazbaOdpocFak is not null and _idVazbaUhrFak is not null) then
        delete from dvazebtab where idvazby in (_idVazbaOdpocFak, _idVazbaUhrFak);
        delete from dpolint  where iddoklint = _idPomInt;
        delete from ddoklint where iddoklint = _idPomInt;
    end if;
    -- /SK - pomocný interní doklad
    
    delete from dVazebTab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD' or typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
    
    select * into _dokl from dDoklFak where idDoklFak = OLD.idDoklFak;
    
    if (_dokl.stavUhrK = 'stavUhr.uhrazeno' and OLD.sumZkl < 0) then
      select count(*) into uhrad from dVazebTab where idTabA = _dokl.idDoklFak and modulA = _dokl.modul and typVazbyK = 'typVazbyDokl.uhrada';
      
      _stavUhrK = null;
      if (uhrad > 0) then
        _stavUhrK = 'stavUhr.castUhr';
      end if;
      
      update dDoklFak set stavUhrK = _stavUhrK where idDoklFak = _dokl.idDoklFak;
    end if;
    
    if _idzal is not null then
      _stavUhrK = null;
      select count(*) into uhrad from dVazebTab where idtabb = _idzal and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
      if (uhrad > 0) then
        _stavUhrK = 'stavOdp.cast';
      end if;
    end if;
    
    update ddoklfak set StavOdpocetK = _stavUhrK where iddoklfak = _idzal and not comparevarchar(StavOdpocetK, _stavUhrK);
    
    -- smazání vazeb a položek korekce KR odpočtu
    select idtabb into _idKorekce from dvazebtab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';

    if (_idKorekce is not null) then 
        delete from dVazebTab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';
        delete from dpolfak where idpolfak = _idKorekce;
    end if;
  end if;  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakdeletevazba() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger
    AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
        pol record;
        df record;
        ds record;
        ucetFak varchar;
        ucetSkl varchar;
        osUpravaDoklad boolean;
begin  
  -- nacteni typu pohybu  
  select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy 
  if (typPohyb = 'typPohybu.prijem') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphMdUcet = NEW.idDphDalUcet where compareId(idDphMdUcet, NEW.idDphDalUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy
  if (typPohyb = 'typPohybu.vydej') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphDalUcet = NEW.idDphMdUcet where compareId(idDphDalUcet, NEW.idDphMdUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          select * into pol from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl') limit 1;
          select * into df from ddoklfak where iddoklfak = NEW.iddoklfak;
          select * into ds from ddoklsklad where iddoklsklad = pol.iddoklsklad;
          
          select kod into ucetFak from uucty where iducet = NEW.idZklMdUcet;
          select kod into ucetSkl from uucty where iducet = pol.idZklDalUcet;
        
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. FAK: zdroj-% hrom-% pol: kop-% % zdroj-% SKL: zdroj-% hrom-% pol: kop-% % zdroj-%', 
            df.zdrojProSkl, df.hromFakt, NEW.kopZklMdUcet, ucetFak, NEW.zdrojProSkl, ds.zdrojProFak, ds.hromFakt, true, ucetSkl, pol.ZdrojProFak;  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Zkl.';
            end if;
          end if;
          
          if (NEW.ucetni) then
              -- korekce kr (změna účtu na odpočtové položce vyvolá změnu účtu na položkce korekce)
              update dPolFak set idZklMdUcet = NEW.idZklDalUcet where idPolFak 
                in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB 
                    where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
                    and compareId(pf.idZklMdUcet, NEW.idZklDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZisk');

              update dPolFak set idZklDalUcet = NEW.idZklDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idZklDalUcet, NEW.idZklDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZtrata');

          end if;
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphDalUcet where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
          
          if (NEW.ucetni) then
              -- korekce kr (změna účtu na odpočtové položce vyvolá změnu účtu na položkce korekce)
            update dPolFak set idDphMdUcet = NEW.idDphDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idDphMdUcet, NEW.idDphDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZisk');

            update dPolFak set idDphDalUcet = NEW.idDphDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idDphDalUcet, NEW.idDphDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZtrata');
              
          end if; 
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Md Zkl.';
            end if;
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphMdUcet where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  

  if (NEW.zaloha = true) then
    -- nacteni typu pohybu
    select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;

    if (typPohyb = 'typPohybu.prijem') then
      if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false or compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true) or
          (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false and compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet, idDphDalUcet = NEW.idDphDalUcet 
            where (compareId(idZklDalUcet, NEW.idZklDalUcet) = false or compareId(idDphDalUcet, NEW.idDphDalUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
    if (typPohyb = 'typPohybu.vydej') then
      if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false or compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true) or
          (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false and compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet, idDphMdUcet = NEW.idDphMdUcet 
            where (compareId(idZklMdUcet, NEW.idZklMdUcet) = false or compareId(idDphMdUcet, NEW.idDphMdUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
  end if;
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;

-- aby šly smazat doklady, i když existuje vazba korekce KR mezi idčky položek shodnými s idčky dokladů
CREATE OR REPLACE FUNCTION dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) RETURNS boolean
    AS $$ 
declare 
  _pocetVazeb integer; 
begin 
   
  /* Jedná se o položku dokladu */ 
  if (i_isDoklad = false) then 
    /* idtaba i idtabb jsou položky */ 
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk in ('typVazbyDokl.polozkaSkl', 
                                                             'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod',
                                                             'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol', 
                                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol',
                                                             'typVazbyDokl.odpocetPolZALOHY', 'typVazbyDokl.polozkaDobropis')) 
                                                      and ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb = i_modul)); 
    if (_PocetVazeb <> 0) then 
      return false; 
    end if; 
     
    /* kontrola, kde je pro položku dokladu jen u idtaba, jedná se o "typVazbyDokl.odpocetZALOHY" a "typVazbyDokl.odpocetZDD" */ 
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk = 'typVazbyDokl.odpocetZALOHY' or typvazbyk = 'typVazbyDokl.odpocetZDD') 
                                                      and ((idtaba = i_idDokl and modula = i_modul and modulb = i_modul)); 
    if (_pocetVazeb <> 0) then 
      return false; 
    end if; 
     
    return true; 
  else 
   
   /* Jedná se o doklad, kde je hlavička */ 
   select count(*) into _pocetVazeb from dVazebTab where (typvazbyk not in ('typVazbyDokl.polozkaSkl', 
                            'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod', 
                            'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol', 
                            'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol',
                            'typVazbyDokl.odpocetPolZALOHY', 'typVazbyDokl.polozkaDobropis', 'typVazbyDokl.KROdpoctu') 
                        ) and (not ( 
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZALOHY') or 
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZDD') or 
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZALOHY') or 
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZDD'))) and 
                        ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb=i_modul)); 
   if (_pocetVazeb <> 0) then 
     return false; 
   end if; 
      
   return true; 
  end if; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) OWNER TO %firmaRole%;

-- přidání účtů pro KR do nastavení

ALTER TABLE nnastav ADD COLUMN idUcetKrOdpoctuVynos INTEGER;
ALTER TABLE nnastav ADD COLUMN idUcetKrOdpoctuNaklad INTEGER;

ALTER TABLE nnastav ADD CONSTRAINT nastav_ucet_kr_odpoctu_vynos FOREIGN KEY (idUcetKrOdpoctuVynos)
    REFERENCES uucty (iducet) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nastav_ucet_kr_odpoctu_naklad FOREIGN KEY (idUcetKrOdpoctuNaklad)
    REFERENCES uucty (iducet) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 993, 't', %appVersion%, clock_timestamp());
