--------------------------------------------------------------------------------------
-- Bug 44867 - PSQLException: ERROR: operator does not exist: boolean <> date — Nelze nastavit ukončení PP 
---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ppracpomupdateaktivni()
  RETURNS trigger AS $$
begin
  update ppracpomhlav set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  update ppracpom set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  if (NEW.platido is null) then
    update ppracpomhlav set kod = NEW.kod, nazev = NEW.nazev, hlavni = NEW.hlavni where idpracpomhlav = NEW.idpracpomhlav 
      and (kod <> NEW.kod or nazev <> NEW.nazev or hlavni <> NEW.hlavni);
  end if;
  
  -- pokud vkladame nove nastaveni nebo doslo ke zmene bez zmeny datumu aktivnosti zkontrolujeme smeny
  if (tg_op = 'INSERT') then
    perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  end if;
  if (tg_op = 'UPDATE') then
   if not (((OLD.aktivniod is null) <> (NEW.aktivniod is null)) or (OLD.aktivniod is not null and OLD.aktivniod <> NEW.aktivniod) or
       ((OLD.aktivnido is null) <> (NEW.aktivnido is null)) or (OLD.aktivnido is not null and OLD.aktivnido <> NEW.aktivnido)) then
      perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomupdateaktivni() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 998, 't', %appVersion%, clock_timestamp());
