<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:variable name="poznamka" select="java:flexibee.Tool.generateUniqueString()"/>

    <xsl:template match="winstrom">
        <winstrom version="1.0" source="epos">
<!--            <xsl:apply-templates select="*[local-name() = 'Příjemky' and position() &lt; 100]"/> -->
            <cinnost>
                <id>code:HLAVNÍ ČINNOST</id>
                <id>ext:EPOS-CINNOST-1</id>
                <kod>HLAVNÍ ČINNOST</kod>
                <nazev>Hlavní činnost</nazev>
            </cinnost>
            <cinnost>
                <id>code:DOPLŇKOVÁ ČINNOST</id>
                <id>ext:EPOS-CINNOST-2</id>
                <kod>DOPLŇKOVÁ ČINNOST</kod>
                <nazev>Doplňková činnost</nazev>
            </cinnost>
            <cinnost>
                <id>code:SPOLEČNÁ ČINNOST</id>
                <id>ext:EPOS-CINNOST-3</id>
                <kod>SPOLEČNÁ ČINNOST</kod>
                <nazev>Společná činnost</nazev>
            </cinnost>
            <cinnost>
                <id>code:NEUVEDENÁ ČINNOST</id>
                <id>ext:EPOS-CINNOST-4</id>
                <kod>NEUVEDENÁ ČINNOST</kod>
                <nazev>Neuvedená činnost</nazev>
            </cinnost>

            <xsl:apply-templates select="*"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t prijemky-in.xslt -x prijemky.xml -o prijemky-vystup.xml
-->

    <xsl:template match="//winstrom/*">
        <!--
        Vytvářet účty by nemělo být potřeba
        <ucet update="ignore">
            <id>code:<xsl:value-of select="c5"/></id>
            <kod><xsl:value-of select="c5"/></kod>
            <stdUcet>code:<xsl:value-of select="java:flexibee.Tool.substring(c5, 0, 3)"/></stdUcet>
        </ucet>
        -->
        <!--
        Vytvářet střediska by nemělo být potřeba
        <stredisko update="ignore">
            <id>code:<xsl:value-of select="c7"/></id>
            <kod><xsl:value-of select="c7"/></kod>
            <nazev>Středisko - <xsl:value-of select="c7"/></nazev>
        </stredisko>
        -->

        <xsl:choose>
            <xsl:when test="c4 = c5">
                <!-- nema dopad do ucetnictvi takze nedelame nic -->
            </xsl:when>
            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '211'">
                <!-- 211 = pokladna -->
                <pokladni-pohyb>
                    <id>ext:EPOS-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/></id>
                    <!--typDokl>code:<xsl:value-of select="c8"/></typDokl-->
                    <typDokl>code:STANDARD</typDokl>
                    <typPohybuK>typPohybu.prijem</typPohybuK>
                    <pokladna>code:PK-<xsl:value-of select="c4"/></pokladna>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c8"/> - <xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <!--primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet-->
                    <!--sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem-->
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>false</bezPolozek>
                    <polozkyIntDokladu>
                        <pokladni-pohyb-polozka>
                            <xsl:choose>
                                <xsl:when test="c5 = '343020' or c5 = '343014'">
                                    <nazev>DPH</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-DPH</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl>0.0</sumZkl>
                                    <sumDph><xsl:value-of select="c6"/></sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet if-not-found="null">code:<xsl:value-of select="c4"/></dphMdUcet>
                                    <dphDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></dphDalUcet>
                                    <zklMdUcet></zklMdUcet>
                                    <zklDalUcet></zklDalUcet>
                                </xsl:when>
                                <xsl:otherwise>
                                    <nazev>ZKL</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-ZKL</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl><xsl:value-of select="c6"/></sumZkl>
                                    <sumDph>0.0</sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet></dphMdUcet>
                                    <dphDalUcet></dphDalUcet>
                                    <zklMdUcet if-not-found ="null">code:<xsl:value-of select="c4"/></zklMdUcet>
                                    <zklDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></zklDalUcet>
                                </xsl:otherwise>
                            </xsl:choose>
                            <xsl:choose>
                                <xsl:when test="c9 = 1">
                                    <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 2">
                                    <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 4">
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:50</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:otherwise>
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:000U</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:otherwise>
                            </xsl:choose>
                            <kopDphDalUcet>false</kopDphDalUcet>
                            <kopZklDalUcet>false</kopZklDalUcet>
                            <kopZklMdUcet>false</kopZklMdUcet>
                            <kopDphMdUcet>false</kopDphMdUcet>
                            <cinnost>ext:EPOS-CINNOST-<xsl:value-of select="c10"/></cinnost>
                            <kopCinnost>false</kopCinnost>
                            <poznam><xsl:value-of select="$poznamka"/></poznam>
                        </pokladni-pohyb-polozka>
                    </polozkyIntDokladu>
                </pokladni-pohyb>
            </xsl:when>



            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '378'">
                <!-- 378 = pohledavky -->
                <pohledavka>
                    <id>ext:EPOS-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/></id>
                    <typDokl>code:PK-<xsl:value-of select="c4"/></typDokl>
                    <typPohybuK>typPohybu.prijem</typPohybuK>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c8"/> - <xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>false</bezPolozek>
                    <polozkyFaktury>
                        <pohledavka-polozka>
                            <xsl:choose>
                                <xsl:when test="c5 = '343020' or c5 = '343014'">
                                    <nazev>DPH</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-DPH</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl>0.0</sumZkl>
                                    <sumDph><xsl:value-of select="c6"/></sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet if-not-found="null">code:<xsl:value-of select="c4"/></dphMdUcet>
                                    <dphDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></dphDalUcet>
                                    <zklMdUcet></zklMdUcet>
                                    <zklDalUcet></zklDalUcet>
                                </xsl:when>
                                <xsl:otherwise>
                                    <nazev>ZKL</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-ZKL</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl><xsl:value-of select="c6"/></sumZkl>
                                    <sumDph>0.0</sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet></dphMdUcet>
                                    <dphDalUcet></dphDalUcet>
                                    <zklMdUcet if-not-found ="null">code:<xsl:value-of select="c4"/></zklMdUcet>
                                    <zklDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></zklDalUcet>
                                </xsl:otherwise>
                            </xsl:choose>
                            <xsl:choose>
                                <xsl:when test="c9 = 1">
                                    <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 2">
                                    <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 4">
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:50</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:otherwise>
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:000U</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:otherwise>
                            </xsl:choose>
                            <kopDphDalUcet>false</kopDphDalUcet>
                            <kopZklDalUcet>false</kopZklDalUcet>
                            <kopZklMdUcet>false</kopZklMdUcet>
                            <kopDphMdUcet>false</kopDphMdUcet>
                            <cinnost>ext:EPOS-CINNOST-<xsl:value-of select="c10"/></cinnost>
                            <kopCinnost>false</kopCinnost>
                            <poznam><xsl:value-of select="$poznamka"/></poznam>
                        </pohledavka-polozka>
                    </polozkyFaktury>
                </pohledavka>
            </xsl:when>




            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '384' or java:flexibee.Tool.substring(c4, 0, 3) = '132' or java:flexibee.Tool.substring(c4, 0, 3) = '131' or java:flexibee.Tool.substring(c4, 0, 3) = '504'">
                <!-- 384 = interni doklady 
                     132 = sklad (interni doklady)
                     131 = sklad (interni doklady)
                     504 = sklad (interni doklady) - typ dokladu se vybira podle uctu dal c5
                -->
                <interni-doklad>
                    <id>ext:EPOS-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/></id>
                    <xsl:choose>
                        <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '504'">
	                    <typDokl>code:ID-<xsl:value-of select="c5"/></typDokl>
                        </xsl:when>
                        <xsl:otherwise>
                            <typDokl>code:ID-<xsl:value-of select="c4"/></typDokl>
                        </xsl:otherwise>
                    </xsl:choose>
                    <typPohybuK>typPohybu.prijem</typPohybuK>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c8"/> - <xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>false</bezPolozek>
                    <polozkyIntDokladu>
                        <interni-doklad-polozka>
                            <xsl:choose>
                                <xsl:when test="c5 = '343020' or c5 = '343014'">
                                    <nazev>DPH</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-DPH</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl>0.0</sumZkl>
                                    <sumDph><xsl:value-of select="c6"/></sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet if-not-found="null">code:<xsl:value-of select="c4"/></dphMdUcet>
                                    <dphDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></dphDalUcet>
                                    <zklMdUcet></zklMdUcet>
                                    <zklDalUcet></zklDalUcet>
                                </xsl:when>
                                <xsl:otherwise>
                                    <nazev>ZKL</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-ZKL</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl><xsl:value-of select="c6"/></sumZkl>
                                    <sumDph>0.0</sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet></dphMdUcet>
                                    <dphDalUcet></dphDalUcet>
                                    <zklMdUcet if-not-found ="null">code:<xsl:value-of select="c4"/></zklMdUcet>
                                    <zklDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></zklDalUcet>
                                </xsl:otherwise>
                            </xsl:choose>
                            <xsl:choose>
                                <xsl:when test="c9 = 1">
                                    <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 2">
                                    <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 4">
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:50</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:otherwise>
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:000U</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:otherwise>
                            </xsl:choose>
                            <kopDphDalUcet>false</kopDphDalUcet>
                            <kopZklDalUcet>false</kopZklDalUcet>
                            <kopZklMdUcet>false</kopZklMdUcet>
                            <kopDphMdUcet>false</kopDphMdUcet>
                            <cinnost>ext:EPOS-CINNOST-<xsl:value-of select="c10"/></cinnost>
                            <kopCinnost>false</kopCinnost>
                            <poznam><xsl:value-of select="$poznamka"/></poznam>
                        </interni-doklad-polozka>
                    </polozkyIntDokladu>
                </interni-doklad>
            </xsl:when>

            <xsl:otherwise>
                <!-- neidentifikovane doklady mozno doprogramovat -->
                <interni-doklad>
                    <id>ext:EPOS-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/></id>
                    <typDokl>code:ID-395100</typDokl>
                    <typPohybuK>typPohybu.prijem</typPohybuK>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c8"/> - <xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>false</bezPolozek>
                    <polozkyIntDokladu>
                        <interni-doklad-polozka>
                            <xsl:choose>
                                <xsl:when test="c5 = '343020' or c5 = '343014'">
                                    <nazev>DPH</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-DPH</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl>0.0</sumZkl>
                                    <sumDph><xsl:value-of select="c6"/></sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet if-not-found="null">code:<xsl:value-of select="c4"/></dphMdUcet>
                                    <dphDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></dphDalUcet>
                                    <zklMdUcet></zklMdUcet>
                                    <zklDalUcet></zklDalUcet>
                                </xsl:when>
                                <xsl:otherwise>
                                    <nazev>ZKL</nazev>
                                    <id>ext:EPOS-P-<xsl:value-of select="concat(c2, '-', c1, '-20', c0 )"/>-<xsl:value-of select="c7"/>-<xsl:value-of select="c4"/>-<xsl:value-of select="c5"/>-<xsl:value-of select="c9"/>-<xsl:value-of select="c10"/>-<xsl:value-of select="c8"/>-ZKL</id>
                                    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    <sumZkl><xsl:value-of select="c6"/></sumZkl>
                                    <sumDph>0.0</sumDph>
                                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                                    <dphMdUcet></dphMdUcet>
                                    <dphDalUcet></dphDalUcet>
                                    <zklMdUcet if-not-found ="null">code:<xsl:value-of select="c4"/></zklMdUcet>
                                    <zklDalUcet if-not-found="null">code:<xsl:value-of select="c5"/></zklDalUcet>
                                </xsl:otherwise>
                            </xsl:choose>
                            <xsl:choose>
                                <xsl:when test="c9 = 1">
                                    <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 2">
                                    <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                                    <clenDph>code:01-02</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:when test="c9 = 4">
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:50</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:when>
                                <xsl:otherwise>
                                    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    <clenDph>code:000U</clenDph>
                                    <kopClenDph>false</kopClenDph>
                                </xsl:otherwise>
                            </xsl:choose>
                            <kopDphDalUcet>false</kopDphDalUcet>
                            <kopZklDalUcet>false</kopZklDalUcet>
                            <kopZklMdUcet>false</kopZklMdUcet>
                            <kopDphMdUcet>false</kopDphMdUcet>
                            <cinnost>ext:EPOS-CINNOST-<xsl:value-of select="c10"/></cinnost>
                            <kopCinnost>false</kopCinnost>
                            <poznam><xsl:value-of select="$poznamka"/></poznam>
                        </interni-doklad-polozka>
                    </polozkyIntDokladu>
                </interni-doklad>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
<!--xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '378'">
                < 378 = pohledavky >
                <pohledavka>
                    <typDokl>code:PK-<xsl:value-of select="c4"/></typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </pohledavka>
            </xsl:when>
            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '384'">
                < 384 = interni doklady >
                <interni-doklad>
                    <typDokl>code:ID-<xsl:value-of select="c4"/></typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </interni-doklad>
            </xsl:when>
            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '132'">
                < 132 = sklad >
                <interni-doklad>
                    <typDokl>code:SKL-<xsl:value-of select="c4"/></typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </interni-doklad>
            </xsl:when>
            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '131'">
                < 131 = sklad >
                <interni-doklad>
                    <typDokl>code:SKL-<xsl:value-of select="c4"/></typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </interni-doklad>
            </xsl:when>
            <xsl:when test="java:flexibee.Tool.substring(c4, 0, 3) = '395'">
                < 395 = interni doklady >
                <interni-doklad>
                    <typDokl>code:ID-<xsl:value-of select="c4"/></typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </interni-doklad>
            </xsl:when>
            <xsl:otherwise>
                <interni-doklad>
                    <typDokl>code:ID-395100</typDokl>
                    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(concat(c2, '-', c1, '-20', c0 ), 'd-M-y')"/></datVyst>
                    <popis><xsl:value-of select="c3"/></popis>
                    <poznam><xsl:value-of select="$poznamka"/></poznam>
                    <primUcet if-not-found="null">code:<xsl:value-of select="c4"/></primUcet>
                    <protiUcet if-not-found="null">code:<xsl:value-of select="c5"/></protiUcet>
                    <sumOsv><xsl:value-of select="c6"/></sumOsv>
                    <sumCelkem><xsl:value-of select="c6"/></sumCelkem>
                    <stredisko if-not-found="null">code:<xsl:value-of select="c7"/></stredisko>
                    <bezPolozek>true</bezPolozek>
                </interni-doklad>
            </xsl:otherwise-->
</xsl:stylesheet>
