<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="STOCK_DOCUMENTS">
    
	<winstrom>
		<xsl:apply-templates select="STOCK_DOCUMENT"/>
	</winstrom>
    </xsl:template>
<!--
flexibee2xml -t sklad-doklad-in.xslt -x SKLDOKL.xml -o sklad-doklad.xml
-->

    <xsl:template match="STOCK_DOCUMENT">
        
        <xsl:choose>
            <xsl:when test="HEAD/STMH_SIGN = '-1'">
                <xsl:variable name="sklad" select="HEAD/CMPL_CODE"/>
            
			<xsl:for-each select="ITEMS/ITEM">
<!--				<cenik update="ignore">
					<id>plu:<xsl:value-of select="PLU_CODE"/></id>
					<id>ean:<xsl:value-of select="PLU_CODE"/></id>
					<nazev><xsl:value-of select="CTLG_DESC"/></nazev>
					<mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(UNIT_CODE)"/></mj1>
                    <eanKod><xsl:value-of select="PLU_CODE"/></eanKod>
                    <kodPlu><xsl:value-of select="PLU_CODE"/></kodPlu>
                    <skladove>true</skladove>
                    <typZasobyK>typZasoby.zbozi</typZasobyK>
				</cenik> -->
				<skladova-karta update="ignore">
					<ucetObdobi>code:<xsl:value-of select="java:flexibee.Tool.formatDate(java:flexibee.Tool.currentDate(), 'yyyy')"/></ucetObdobi>
					<cenik>[<xsl:value-of select="CTLG_EXT_CODE"/>]</cenik>
                    <!-- <cenik>[plu:<xsl:value-of select="PLU_CODE"/>][ean:<xsl:value-of select="PLU_CODE"/>]</cenik> -->
 					<sklad>code:<xsl:value-of select="$sklad"/></sklad>
				</skladova-karta>
			</xsl:for-each>

                <skladovy-pohyb>
                    <xsl:if test="GLOB_OFFER != '0' or STATUT = '7' or STATUT = '9'">
                        <xsl:attribute name="action">storno</xsl:attribute>
                    </xsl:if>
                    <id>ext:GS-SKL-D:<xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></id>
                    <id>code:<xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></id>
                    <kod><xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></kod>
                    <typDokl>code:PRODEJ-<xsl:value-of select="HEAD/FILIALKA_CODE"/></typDokl>
			  <typPohybuK>typPohybu.vydej</typPohybuK>
                    <!--DOCSERIES_CODE>D900</DOCSERIES_CODE-->
                    <!--DOCSERIES_DESC>Prodej zboží přes pokladny</DOCSERIES_DESC-->
                    <!--DOCSERIES_DOCTYP>114</DOCSERIES_DOCTYP-->
            
                    <datVyst><xsl:value-of select="HEAD/STMH_MOVEDATE"/></datVyst>
                    <cisDodak><xsl:value-of select="HEAD/STMH_NUMDOC"/></cisDodak>
                    <cisObj><xsl:value-of select="HEAD/STMH_BUSCASE"/></cisObj>
                    <!--STMH_RECEIPT /-->
                    
                    <!--VOL_NAK>518.750</VOL_NAK-->
                    <!--VOL_PROD>796.000</VOL_PROD-->
                    <!--VOL_POM>0.000</VOL_POM-->
                    <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(HEAD/STMH_RATE)"/></kurz>
                    <mena>code:<xsl:value-of select="HEAD/CURR_CODE"/></mena>
                    
                    <sklad>code:<xsl:value-of select="$sklad"/></sklad>
                    <!--CMPE_CODE /-->
                    <!--CMPL_NAME>OC Metropole Zličín - prodejna</CMPL_NAME-->
                    <!--FILIALKA_CODE>F101</FILIALKA_CODE-->
                    
                    <!--CONT_ICP>000001</CONT_ICP-->
                    <!--CONT_CODE>TEST</CONT_CODE-->
                    <!--CONT_NAME>Test s. r. o.</CONT_NAME-->
                    <!--CONT_SPECID>56789889</CONT_SPECID-->

                    <!--ADDR_ICA>003</ADDR_ICA-->
                    <!--ADDR_STREET>Řevnická 2</ADDR_STREET-->
                    <!--ADDR_TOWN>Praha 5 - Zličín</ADDR_TOWN-->
                    <!--ADDR_POSTALCODE>15700</ADDR_POSTALCODE-->
                    
                    <xsl:if test="HEAD/IOCONT_CODE != ''">
                        <firma>code:<xsl:value-of select="HEAD/IOCONT_CODE"/></firma>
                    </xsl:if>
                    <xsl:if test="HEAD/IOCONT_NAME != ''">
                        <nazFirmy><xsl:value-of select="HEAD/IOCONT_NAME"/></nazFirmy>
                    </xsl:if>
                    <xsl:if test="HEAD/IOCONT_SPECID != ''">
                        <ic><xsl:value-of select="HEAD/IOCONT_SPECID"/></ic>
                    </xsl:if>
                    <xsl:if test="HEAD/IOADDR_STREET != ''">
                        <ulice><xsl:value-of select="HEAD/IOADDR_STREET"/></ulice>
                    </xsl:if>
                    <xsl:if test="HEAD/IOADDR_TOWN != ''">
                        <mesto><xsl:value-of select="HEAD/IOADDR_TOWN"/></mesto>
                    </xsl:if>
                    <xsl:if test="HEAD/IOADDR_POSTALCODE != ''">
                        <psc><xsl:value-of select="HEAD/IOADDR_POSTALCODE"/></psc>
                    </xsl:if>
                    
                                      <!--STMH_PAID>0</STMH_PAID-->
                    <!--STCLS_DATE /-->
                    <!--CANCEL_ORDER /-->
                    <!--CANCEL_MOVEDATE /-->
                    
                    <skladovePolozky removeAll="true">
                        <xsl:for-each select="ITEMS/ITEM">
                            <skladovy-pohyb-polozka>
                                <typPolozkyK>typPolozky.katalog</typPolozkyK>
                                <cisRad><xsl:value-of select="STMI_ORDER"/></cisRad>
                                
                                <!--CTLG_CODE>225674</CTLG_CODE-->
                                <cenik>[<xsl:value-of select="CTLG_EXT_CODE"/>]</cenik>
                                <!-- <cenik>[plu:<xsl:value-of select="PLU_CODE"/>][ean:<xsl:value-of select="PLU_CODE"/>]</cenik> -->
                                <nazev><xsl:value-of select="CTLG_DESC"/></nazev>
                                
                                <!--ORDER_NR /-->
                                <!--CTLG_PACKING>1.000000</CTLG_PACKING-->
                                <!--PLU_CODE>2000000000022</PLU_CODE-->
                                
                                <!--VAT_TARIFF>20.000</VAT_TARIFF-->
                                <!--VAT_CLASS>2</VAT_CLASS-->
                                <mj>code:<xsl:value-of select="java:flexibee.Tool.toUpper(UNIT_CODE)"/></mj>
                                <sklad>code:<xsl:value-of select="$sklad"/></sklad>
                                
                                <xsl:choose>
                                    <xsl:when test="STATUT = '8'">
                                        <mnozMj><xsl:value-of select="CTLG_PACKING * ST_NUM * -1"/></mnozMj>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <mnozMj><xsl:value-of select="CTLG_PACKING * ST_NUM"/></mnozMj>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <cenaMj><xsl:value-of select="VOL_NAK div (ST_NUM * CTLG_PACKING)"/></cenaMj>
                                
                                <!-- <sumZkl><xsl:value-of select="VOL_NAK"/></sumZkl> -->
                                <!-- <sumCelkem><xsl:value-of select="VOL_NAK"/></sumCelkem> -->
                                <!--VOL_PROD>485.000</VOL_PROD-->
                                <!--VOL_POM>0.000</VOL_POM-->
                                
                                <!--CTLG_TYPE>10</CTLG_TYPE-->
                                <!--CTLG_CATEGORY>0</CTLG_CATEGORY-->
                                <!--CTLG_WEIGHTED>0</CTLG_WEIGHTED-->
                                <!--CTLG_WEIGHT /-->
                                
                                <!--SUBG_CODE>999101</SUBG_CODE-->
                                <!--SUBG_DESC /-->
                                <!--SGRP_CODE>9991</SGRP_CODE-->
                                <!--SGRP_DESC>Poukázky</SGRP_DESC-->

                                <!--SORT_CODE>999</SORT_CODE-->
                                <!--SORT_DESC>Poukázky, šeky</SORT_DESC-->

                                <poznam><xsl:value-of select="CTLG_MEMO"/></poznam>

                            </skladovy-pohyb-polozka>
                        </xsl:for-each>
                    </skladovePolozky>
                    
                </skladovy-pohyb>
            </xsl:when>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>