<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <!-- zalozime ucet, ktery bude slouzit jako druha strana u "jednostraneho uctovani" -->
      <ucet update="ignore">
          <id>code:395999</id>
          <kod>395999</kod>
          <stdUcet>code:395</stdUcet>
          <nazev>Vnitřní jednostranné účtování</nazev>
      </ucet>
      <xsl:apply-templates select="*"/>
    </winstrom>
  </xsl:template>

    <!--
KOD,C,6
POPIS,C,46 
TYP,C,1
AKTIVNI,C,1
NEWKOD,C,6
VYRKOD,C,6
    -->

  <xsl:template match="*">
      <xsl:choose>
          <xsl:when test="KOD != '' and string-length(KOD) = 6">
              <ucet update="ignore">
                <id>code:<xsl:value-of select="KOD"/></id>
                <kod><xsl:value-of select="KOD"/></kod>
                <stdUcet>code:<xsl:value-of select="java:flexibee.Tool.substring(KOD, 0, 3)"/></stdUcet>
                <xsl:choose>
                    <xsl:when test="POPIS != ''">
                        <nazev><xsl:value-of select="POPIS"/></nazev>
                    </xsl:when>
                    <xsl:otherwise>
                        <nazev><xsl:value-of select="KOD"/></nazev>
                    </xsl:otherwise>
                </xsl:choose>
              </ucet>
          </xsl:when>
      </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
