<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="adresar"/>
    </winstrom>
  </xsl:template>

    <!--

CISLO,N,11,0
GUID,C,38
SKUPINA,N,11,0
NAZEV,C,50
ULICE,C,30
MISTO,C,40
PSC,C,10
STAT,C,20
OBCHNAZEV,C,50
OBCHULICE,C,30
OBCHMISTO,C,40
OBCHPSC,C,10
OBCHSTAT,C,20
FAKTNAZEV,C,50
FAKTULICE,C,30
FAKTMISTO,C,40
FAKTPSC,C,10
FAKTSTAT,C,20
TELPRED,C,10
TELCISLO,C,20
TELKLAP,C,5
FAXPRED,C,10
FAXCISLO,C,20
FAXKLAP,C,5
MOBILPRED,C,10
MOBILCISLO,C,20
EMAIL,C,50
WWW,C,50
SPOJENI,C,255
ICO,C,10
DIC,C,20
PLATCEDPH,L
FYZOSOBA,L
KODDANUR,C,4
BANKA,C,50
UCET,C,34
KODBANKY,C,11
SPECSYM,C,10
CINNOSTI,C,254
ADRKLICE,C,254
CENY,C,254
CENIKY,C,254
KREDIT,L
KREDITVAL,N,15,4
SPLATPOH,L
SPLATZAV,L
SPLPOHDNI,N,6,0
SPLZAVDNI,N,6,0
POSLPD,D
POSLPCD,C,10
SLEVA,N,15,4
FLAGSLEVA,L
MAILDATUM,D
MAIL,L
ZPRAVA,C,255
POZNAMKA,M
KODPARTN,C,20
HLAVKOSOBA,N,11,0
OSJAKOFIR,L
FLAGSLAVE,N,5,0
SLAVEEXP,N,5,0
TYPOP,N,3,0
IN_EXPORT,N,3,0
IN_CHANGED,L
IN_NEW,L
IN_ID,N,11,0
IN_VID,C,25
IN_JMENO,C,25
IN_HESLO,C,10
IN_DEALER,L
IN_DSKUP,C,1
IN_INDSLEV,N,6,0
IN_SOUKROM,L
MO_ZMENAUC,L
MO_FROMWWW,L
MO_SETIDES,L
MO_SETDEAL,L
DATPOR,D
TIMPOR,C,5
OBKODSTATU,C,2
KODSTATU,C,2
FAKODSTATU,C,2
DOKUMENTY,M
DS_JMENO,C,255
DS_ID,C,7

    -->

  <xsl:template match="adresar">
  
  <adresar >
    <id>ext:moneyS3:<xsl:value-of select="CISLO"/></id>
    <xsl:if test="ICO != ''">
      <id>in:<xsl:value-of select="ICO"/></id>
    </xsl:if>
    
    <kod>M<xsl:value-of select="java:flexibee.Tool.toUpper(CISLO)"/></kod>
    
    <ic><xsl:value-of select="ICO"/></ic>
    <dic><xsl:value-of select="DIC"/></dic>
    <nazev><xsl:value-of select="NAZEV"/></nazev>
    <ulice><xsl:value-of select="ULICE"/></ulice>
    <mesto><xsl:value-of select="MISTO"/></mesto>
    <psc><xsl:value-of select="PSC"/></psc>
    <xsl:if test="KODSTATU!=''">
      <stat>code:<xsl:value-of select="KODSTATU"/></stat>
    </xsl:if>
    <faJmenoFirmy><xsl:value-of select="FAKTNAZEV"/></faJmenoFirmy>
    <faulice><xsl:value-of select="FAKTULICE"/></faulice>
    <famesto><xsl:value-of select="FAKTMISTO"/></famesto>
    <fapsc><xsl:value-of select="FAKTPSC"/></fapsc>
    
    <tel><xsl:value-of select="TELPRED"/><xsl:value-of select="TELCISLO"/></tel>
    <fax><xsl:value-of select="FAXPRED"/><xsl:value-of select="FAXCISLO"/></fax>
    <mobil><xsl:value-of select="MOBILPRED"/><xsl:value-of select="MOBILCISLO"/></mobil>
    <email><xsl:value-of select="EMAIL"/></email>
    <www><xsl:value-of select="WWW"/></www>
    <poznam><xsl:value-of select="POZNAMKA"/></poznam>
    <typVztahuK>typVztahu.odberDodav</typVztahuK>
      
  </adresar>
  
  <!--<xsl:if test="BANKA != ''">
    <penezni-ustav update="ignore">
    <id>code:<xsl:value-of select="KODBANKY"/></id>
    <kod><xsl:value-of select="KODBANKY"/></kod>
    <nazev><xsl:value-of select="KODBANKY"/></nazev>
    </penezni-ustav>
    <adresar-bankovni-ucet>
      <id>ext:moneyS3:<xsl:value-of select="INTER"/></id>
      <firma>ext:moneyS3:<xsl:value-of select="INTER"/></firma>
      <xsl:if test="java:flexibee.Tool.isNumber(KOD_BANKY)">
        <buc><xsl:value-of select="UCET"/></buc>
        <smerKod><xsl:value-of select="KODBANKY"/></smerKod>
      </xsl:if>
      <xsl:if test="not(java:flexibee.Tool.isNumber(KODBANKY))">
        
        <bic><xsl:value-of select="KODBANKY"/></bic>
      </xsl:if>
    </adresar-bankovni-ucet>
  </xsl:if>-->
  
  </xsl:template>
</xsl:stylesheet>