<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom version="1.0">
	<xsl:apply-templates select="pokladni-pohyb"/>
	</winstrom>
    </xsl:template>

<!--
cislo	datum	cas	operator	druh	kod	nazev	počet	
cena-mj	castka	vs
-->

    <cenik>
	<id>ext:PRIMSYS:PRIP.INT</id>
	<kod>PRIP.INTERNET</kod>
	<nazev>Služba připojení k internetu - 1 měsíc</nazev>
	<cenaZakl>399.0</cenaZakl>
	<typCenyDphK showAs="bez DPH">typCeny.bezDph</typCenyDphK>
	<zaokrJakK showAs="matematicky">zaokrJak.matem</zaokrJakK>
	<zaokrNaK showAs="setiny">zaokrNa.setiny</zaokrNaK>
	<typSzbDphK showAs="osvobozeno">typSzbDph.dphOsv</typSzbDphK>
	<typZasobyK showAs="Služba">typZasoby.sluzba</typZasobyK>
	<skupZboz showAs="SLUŽBY: Služby">code:SLUŽBY</skupZboz>
    </cenik>


    <xsl:template match="pokladni-pohyb">
	<pokladni-pohyb>
	    <id>ext:PRIMSYS:<xsl:value-of select="cislo"/></id>
	    <kod><xsl:value-of select="cislo"/></kod>
	    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(datum, 'd.M.y')"/></datVyst>
	    <typPohybuK>typPohybu.prijem</typPohybuK>
	    <typDokl>code:POKLADNA KČ</typDokl>
	    <varSym><xsl:value-of select="vs"/></varSym>
	    <poznam>Operátor: <xsl:value-of select="operator"/></poznam>
	    <polozkyIntDokladu removeAll="true">
		<pokladni-pohyb-polozka>
		    <cenik>code:PRIP.INTERNET</cenik>
		    <typPolozkyK>typPolozky.katalog</typPolozkyK>
		    <typCenyDphK>typCeny.bezDph</typCenyDphK>
		    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
		    <cenaMj><xsl:value-of select="cena-mj"/></cenaMj>
		    <sumZkl><xsl:value-of select="castka"/></sumZkl>
		    <mnozMj><xsl:value-of select="pocet"/></mnozMj>
		</pokladni-pohyb-polozka>
	    </polozkyIntDokladu>
	</pokladni-pohyb>
    </xsl:template>

</xsl:stylesheet>