<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<SHOP>
		<xsl:apply-templates select="cenik"/>
	</SHOP>
    </xsl:template>

    <xsl:template match="cenik">
	<SHOPITEM>
	    <xsl:attribute name="id">
		<xsl:value-of select="id"/>
	    </xsl:attribute>
	    <xsl:attribute name="external_id">0</xsl:attribute>
	    <xsl:attribute name="plu">
		<xsl:value-of select="kodPlu"/>
	    </xsl:attribute>


	    <xsl:attribute name="name">
		<xsl:value-of select="nazev"/>
	    </xsl:attribute>
	    <xsl:attribute name="measure">
		<xsl:value-of select="java:flexibee.Tool.toLower(java:flexibee.Tool.substring(mj1, 5))"/>
	    </xsl:attribute>

	    <xsl:attribute name="ean">
		<xsl:value-of select="eanKod"/>
	    </xsl:attribute>

	    <xsl:attribute name="price">
		<xsl:value-of select="cenaZakl"/>
	    </xsl:attribute>

	    <xsl:attribute name="groupId">
		<xsl:value-of select="skupZboz/skupina-zbozi/id"/>
	    </xsl:attribute>

	    <xsl:attribute name="groupName">
		<xsl:value-of select="skupZboz/skupina-zbozi/nazev"/>
	    </xsl:attribute>

	    <xsl:attribute name="type">
		<xsl:choose>
		    <xsl:when test="typZasobyK = 'typZasoby.sluzba'">Service</xsl:when>
		    <xsl:otherwise>Goods</xsl:otherwise>
		</xsl:choose>
	    </xsl:attribute>

	</SHOPITEM>
    </xsl:template>

</xsl:stylesheet>