<?xml version="1.0" encoding="utf-8"?>

<!-- soubor pro transformaci výpisů z formátu camt.053.001.02 do XML, které umí FlexiBee naimportovat -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:java="http://xml.apache.org/xalan/java" 
exclude-result-prefixes="java">

  <xsl:template match="/">
    <xsl:apply-templates select="tpExport"/>
  </xsl:template>

  <xsl:template match="tpExport">
    <winstrom version="1.0" source="importVypisu">  
      <xsl:apply-templates select="payments_export"/>
    </winstrom>
  </xsl:template>
  
  <xsl:template match="payments_export">
    <xsl:apply-templates select="payments"/>    
  </xsl:template>
  
  <xsl:template match="payments">
    <!--xsl:param name="cisloUctu" select="merchant_header/bank_account"></xsl:param--> 
    <xsl:apply-templates select="payment"/>
  </xsl:template>
  
  <xsl:template match="payment">
    <banka>
      <banka>bankovniUcet.urlParam</banka>
      <typDokl>typDokl.zNastaveni</typDokl>
      <!--banka>iban:CZ71<xsl:value-of select="../../../merchant_header/bank_code" />0000000<xsl:value-of select="../../../merchant_header/bank_account" /></banka-->
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(created_on, 'yyyy-MM-dd')" /></datVyst>
      <varSym><xsl:value-of select="merchant_data" /></varSym>
      <xsl:choose>
        <xsl:when test="currency = 'CZK'">
          <mena>code:<xsl:value-of select="currency" /></mena>
          <sumCelkem><xsl:value-of select="value" /></sumCelkem>
          <sumOsv><xsl:value-of select="value" /></sumOsv>  
        </xsl:when>
        <xsl:otherwise>
          <mena>code:<xsl:value-of select="currency" /></mena>
          <!--sumCelkemMen><xsl:value-of select="value" /></sumCelkemMen>
          <sumOsvMen><xsl:value-of select="value" /></sumOsvMen-->
          <sumCelkem><xsl:value-of select="value" /></sumCelkem>
          <sumOsv><xsl:value-of select="value" /></sumOsv>  
        </xsl:otherwise>
      </xsl:choose>
      <bezPolozek>true</bezPolozek>
      <xsl:choose>
        <xsl:when test="brutto_CRDB = 'CR'">
          <typPohybuK>typPohybu.prijem</typPohybuK>
        </xsl:when>
        <xsl:when test="brutto_CRDB = 'DB'">
          <typPohybuK>typPohybu.vydej</typPohybuK>
        </xsl:when>
        <xsl:otherwise>
          <typPohybuK>typPohybu.prijem</typPohybuK>
        </xsl:otherwise>
      </xsl:choose>
    </banka>
    <!--xsl:if test="fee != 0.00">
      <banka>
        <banka>bankovniUcet.urlParam</banka>
        <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(date, 'yyyyMMdd')" /></datVyst>
        <varSym><xsl:value-of select="variable_symbol" /></varSym>
        <poznam><xsl:value-of select="invoice_number" /></poznam>
        <sumCelkem><xsl:value-of select="fee" /></sumCelkem>
        <sumOsv><xsl:value-of select="fee" /></sumOsv>
        <bezPolozek>true</bezPolozek>
        <typPohybuK>typPohybu.vydej</typPohybuK>
      </banka>
    </xsl:if-->    
    
  </xsl:template>
  
  
  
</xsl:stylesheet>
