<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />


    <xsl:variable name="radkyDoc" select="document('prijemky-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_příjemek" use="Číslo_příjemky"/>

    <xsl:template match="/Příjemky">
        <winstrom version="1.0" atomic="false"> 
<!--            <xsl:apply-templates select="*[local-name() = 'Příjemky' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="Příjemky"/> 
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t prijemky-skladova-karta-in.xslt -x prijemky.xml -o ppp-karta.xml
kod, nazev
-->

    <xsl:template match="Příjemky">
	    <xsl:variable name="cislo" select="Číslo_příjemky"/>
	    <xsl:variable name="datum" select="java:flexibee.Tool.formatDate(java:flexibee.Tool.parseDate(Datum, 'd.M.y'), 'yyyy')"/>

	<xsl:for-each select="$radkyDoc">
	    <xsl:for-each select="key('cisloKey',$cislo)">
		    <skladova-karta update="ignore">
			<id>ext:4DD-SKL-<xsl:value-of select="$datum"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_skladu)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
        		<ucetObdobi>code:<xsl:value-of select="$datum"/></ucetObdobi>
			<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
				<xsl:if test="Číslo_skladu = ''">
				<sklad>code:XXX_HISTORIE</sklad>
				</xsl:if>
				<xsl:if test="Číslo_skladu != ''">
				<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_skladu)"/>_HISTORIE</sklad>
				</xsl:if>
		    </skladova-karta>
	    </xsl:for-each>
	</xsl:for-each>
    </xsl:template>

</xsl:stylesheet>
