<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />
<!--

SQL dotaz:

select iducetobdobi from nucetobdobi where kod = extract(year from now())::text;

copy (select ccenik.kod as cenik, dbsp.kod as sklad, stavmj, stavmen from skarty inner join ccenik on ccenik.idcenik = skarty.idcenik inner join dbsp on dbsp.idbsp = skarty.idskladu where idskladu in (select idbsp from dbsp where modul = 'SKL' and kod like '%_HISTORIE') and (stavmj > 0 or stavmen > 0) and iducetobdobi in (select iducetobdobi from nucetobdobi where kod = extract(year from now())::text)) TO '/tmp/sklady.csv' WITH CSV HEADER;

flexibee2xml -c sklady.csv -m radek -t sklad-vynulovani.xslt -o sklady-vystup.xml


<sklad>
  <cenik>8901</cenik>
  <sklad>18_HISTORIE</sklad>
  <stavmj>240.000000</stavmj>
  <stavmen>10604.830000</stavmen>
</sklad>

-->
    <xsl:key name="skladKey" match="radek" use="sklad"/>
    
    <xsl:template match="/winstrom">
        <winstrom version="1.0">

            <xsl:apply-templates select="radek"/>

        </winstrom>
    </xsl:template>


    <xsl:template match="radek">
      <xsl:if test="generate-id(.) = generate-id(key('skladKey', sklad)[1])">
          <skladovy-pohyb>
            <id>ext:4DD:VYNULOVANI-<xsl:value-of select="java:flexibee.Tool.toUpper(sklad)"/></id>
            <kod>1-<xsl:value-of select="java:flexibee.Tool.toUpper(sklad)"/></kod>
            <typDokl>code:HISTORICKÁ</typDokl>
     	   <typPohybuK>typPohybu.vydej</typPohybuK>
            <datVyst>2011-08-31</datVyst>
		   <sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(sklad)"/></sklad>

            <poznam>Vynulovací příjemka pro historické pohyby</poznam>
     	   <skladovePolozky removeAll="true">

            <xsl:for-each select="key('skladKey', sklad)">
    
			<skladovy-pohyb-polozka>
				<id>ext:4DD:RESET-<xsl:value-of select="java:flexibee.Tool.toUpper(cenik)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(sklad)"/></id>
				<typPolozkyK>typPolozky.katalog</typPolozkyK>
				<cenik>code:<xsl:value-of select="java:flexibee.Tool.toUpper(cenik)"/></cenik>
				<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(stavmj)"/></mnozMj>
				<xsl:choose>
      				<xsl:when test="stavmj != 0">
				<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(stavmen) div java:flexibee.Tool.parseMoney(stavmj)"/></cenaMj>
      				</xsl:when>
      				<xsl:otherwise>
          				<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(stavmen)"/></cenaMj>
      				</xsl:otherwise>
      			</xsl:choose>
				<cenyRucne>true</cenyRucne>
				<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(sklad)"/></sklad>
			</skladovy-pohyb-polozka>
 		</xsl:for-each>	
		
     	   </skladovePolozky>
        </skladovy-pohyb>
            
      </xsl:if>
			
    </xsl:template>

</xsl:stylesheet>
