<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0" ignore-errors="true">
            <xsl:apply-templates select="Stavy"/>
            <nastaveni>
                <id>1</id>
                <postMigrace>true</postMigrace>
            </nastaveni>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Stavy">
        <winstrom version="1.0" ignore-errors="true">
            <xsl:apply-templates select="Stavy"/>
            <nastaveni>
                <id>1</id>
                <postMigrace>true</postMigrace>
            </nastaveni>
        </winstrom>
    </xsl:template>

<!--
.\flexibee2xml.exe -t adresar.in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->

    <xsl:template match="Stavy">
        <xsl:if test="java:flexibee.Tool.trim(Kód_EAN) != '' and java:flexibee.Tool.trim(Sklad) != ''">
            <cenik create="ignore">
                <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
                <id>ext:4DD-CEN:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
                <skladove>true</skladove>
                <skladKarty>
                    <skladKarta>
                        <id>ext:4DD-SKL_KAR:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/>                    </id>
                        <sklad if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/></sklad>
                        <cenik if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
                        <ucetObdobi if-not-found="null">code:2011</ucetObdobi>
                        <stavMJ><xsl:value-of select="java:flexibee.Tool.parseMoney(Úč.množství)"/></stavMJ>
                        <xsl:choose>
                            <xsl:when test="java:flexibee.Tool.parseMoney(Úč.množství) != '0'">
                                <prumCenaTuz><xsl:value-of select="java:flexibee.Tool.parseMoney(Úč.hodnota) div java:flexibee.Tool.parseMoney(Úč.množství)"/></prumCenaTuz>
                            </xsl:when>
                            <xsl:otherwise>
                                <prumCenaTuz><xsl:value-of select="java:flexibee.Tool.parseMoney(Úč.hodnota)"/></prumCenaTuz>
                            </xsl:otherwise>
                        </xsl:choose>
                        <minMJ><xsl:value-of select="java:flexibee.Tool.parseMoney(Minimum)"/></minMJ>
                        <maxMJ><xsl:value-of select="java:flexibee.Tool.parseMoney(Maximum)"/></maxMJ>
                    </skladKarta>
                </skladKarty>
            </cenik>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>
