<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />


    <xsl:variable name="radkyDoc" select="document('vydejky-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_výdejek" use="Číslo_výdejky"/>

    <xsl:template match="/Výdejky">
        <winstrom version="1.0">
<!--		<xsl:apply-templates select="*[local-name() = 'Výdejky' and position() &lt; 100]"/>  -->
        	<xsl:apply-templates select="Výdejky"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t vydejky-in.xslt -x vydejky.xml -o 4-vydejky.xml
-->

    <xsl:template match="Výdejky">
	    <xsl:variable name="cislo" select="Číslo_výdejky"/>
            <xsl:variable name="slevaDokl" select="Proc.sleva"/>

	<xsl:if test="Úč.období != '201109'">

        <skladovy-pohyb>
            <id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></id>
            <typDokl>code:HISTORICKÁ</typDokl>
            <kod>V-<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_výdejky)"/></kod>
	    <typPohybuK>typPohybu.vydej</typPohybuK>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum, 'd.M.y')"/></datVyst>

	    <xsl:if test="Odběratel != '' and Odběratel != 'False' and Odběratel != '0'">
        	<firma>ext:4DD-ADR:<xsl:value-of select="Odběratel"/></firma>
	    </xsl:if>

	    <stredisko if-not-found="null">ext:4DD-STRED:<xsl:value-of select="Středisko"/></stredisko>
	    <xsl:if test="Zakázka != ''">
	    	<zakazka>ext:4DD-ZAK:<xsl:value-of select="Zakázka"/></zakazka>
	    </xsl:if>

		<xsl:for-each select="$radkyDoc">
			<xsl:choose>
                    	    <xsl:when test="key('cisloKey',$cislo)[1]/Sklad_výdeje != ''">
                        	<bsp>code:<xsl:value-of select="java:flexibee.Tool.toUpper(key('cisloKey',$cislo)[1]/Sklad_výdeje)"/>_HISTORIE</bsp>
                    	    </xsl:when>
                    	    <xsl:otherwise>
                        	<bsp>code:XXX_HISTORIE</bsp>
			    </xsl:otherwise>
                        </xsl:choose>
		</xsl:for-each>


            <uvodTxt><xsl:value-of select="Obsahuje"/></uvodTxt>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
	    <popis>Hodnota: <xsl:value-of select="Hodnota"/>
		   <xsl:if test="Úč.doklad != '0'">, Úč. doklad: <xsl:value-of select="Úč.doklad"/></xsl:if>
		   <xsl:if test="Č.vyd.faktury != '0'">, číslo vydané faktury: <xsl:value-of select="Č.vyd.faktury"/></xsl:if>
		   <xsl:if test="Č.přij.faktury != '0'">, číslo přijaté faktury: <xsl:value-of select="Č.přij.faktury"/></xsl:if>
		   <xsl:if test="Číslo_příjemky != '0'">, číslo příjemky: <xsl:value-of select="Číslo_příjemky"/></xsl:if>
		   <xsl:if test="Číslo_prodejky != '0'">, číslo prodejky: <xsl:value-of select="Číslo_prodejky"/></xsl:if>
		   <xsl:if test="Č.převodky != '0'">, číslo převodky: <xsl:value-of select="Č.převodky"/></xsl:if>
		</popis>

	    <skladovePolozky>

		<xsl:for-each select="$radkyDoc">
		    <xsl:for-each select="key('cisloKey',$cislo)">
			<xsl:if test="Množství != 0 or J.cena_nák. != 0 or Kód_položky != ''">
			    <skladovy-pohyb-polozka>
				<id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_výdejky)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
				<typPolozkyK>typPolozky.katalog</typPolozkyK>
				<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
				<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Množství)"/></mnozMj>

				<xsl:choose>
				    <xsl:when test="(Proc.sleva != '' and Proc.sleva != '0') or ($slevaDokl != '' and $slevaDokl != '0')">
					<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_nák.) * ((100.0 -  java:flexibee.Tool.parseMoney(Proc.sleva) - java:flexibee.Tool.parseMoney($slevaDokl)) div 100.0)"/></cenaMj>
				    </xsl:when>
				    <xsl:otherwise>
					<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_nák.)"/></cenaMj>
				    </xsl:otherwise>
				</xsl:choose>


				<cenyRucne>true</cenyRucne>
				<xsl:if test="Sklad_výdeje = ''">
				<sklad>code:XXX_HISTORIE</sklad>
				</xsl:if>
				<xsl:if test="Sklad_výdeje != ''">
				<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad_výdeje)"/>_HISTORIE</sklad>
				</xsl:if>
				<poznam><xsl:value-of select="Poznámka"/>
				    <xsl:if test="(Proc.sleva != '' and Proc.sleva != '0') or ($slevaDokl != '' and $slevaDokl != '0')">
					<xsl:if test="Poznámka != ''">, </xsl:if>
					Cena před slevou (<xsl:value-of select="java:flexibee.Tool.parseMoney(Proc.sleva) + java:flexibee.Tool.parseMoney($slevaDokl)"/>%): <xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_nák)"/>
				    </xsl:if>
				   <xsl:if test="J.cena_prod. != '0'">, Jednotková cena prodejní: <xsl:value-of select="J.cena_prod."/></xsl:if>

				</poznam>
			    </skladovy-pohyb-polozka>
			</xsl:if>
		    </xsl:for-each>
		</xsl:for-each>
	    </skladovePolozky>
        </skladovy-pohyb>

	</xsl:if>

    </xsl:template>

</xsl:stylesheet>
