-- funkce pro posun kalendarniho data, tak aby akceptoval aktualni datum importu, takze je to posun o rok z datum importu - datum vytvoreni skriptu
-- data jsou z roku 2008
-- napr. datumy                                 2007 2008 2009 2010
-- se pri importu v roce 2008 predelaji na      2007 2008 2009 2010
--                v roce 2009                   2008 2009 2010 2011
--                v roce 2010                   2009 2010 2011 2012
-- zaroven se prida ucetni obdobi o rok starsi nez je datum importu ZAKOMENTOVANO
-- POZOR jako datum vytvoreni skriptu se bere lastupdate z nnastav!@!@!@!@
create or replace function posunDatum(in proDatum date) returns date as $$
declare
	_datumVytvoreni date;
begin
	-- nactu si datum vytvoreni dat
	select lastupdate into _datumVytvoreni from nnastav where idnastav = 1;
	return proDatum + (extract(year from now()) - extract(year from _datumVytvoreni)) * interval '1 year';
end;
$$ LANGUAGE plpgsql;

-- funkce pro posun integeru
create or replace function posunInt(in proInteger integer) returns integer as $$
declare
	_datumVytvoreni date;
begin
	-- nactu si datum vytvoreni dat
	select lastupdate into _datumVytvoreni from nnastav where idnastav = 1;
	return proInteger + (extract(year from now()) - extract(year from _datumVytvoreni));
end;
$$ LANGUAGE plpgsql;

-- vytvori kod z datum platny podle ISO-8601 yyyymmdd
create or replace function vytvorKod(in proDatum date) returns character varying(20) as $$
begin
	return cast(extract(year from proDatum)as varchar) || cast(extract(month from proDatum)as varchar) || cast(extract(day from proDatum)as varchar);
end;
$$ LANGUAGE plpgsql;

-- vytvori aktualni kod z byvaleho kodu pro doklad PF0001/2008 a demo firma vytvarena v roce 2010 vrati PF0001/2009 
create or replace function posunDoklKod(in doklKod varchar) returns character varying(20) as $$
declare
	_first varchar;
	_second varchar;
begin
	select split_part(doklKod, '/', 1) into _first;
	select split_part(doklKod, '/', 2) into _second;
	return _first || '/' || posunInt(cast(_second as integer));
end;
$$LANGUAGE plpgsql;

-- vrati cleneniDph prislusne pro dany rok
create or replace function vratCleneniDph(in idClenDph integer) returns integer as $$
begin
    if (cast(extract(year from now()) as integer) = 2008) then
            return idClenDph;
    else
            if (idClenDph = 18 or idClenDph = 19) then
                    return idClenDph;
            end if;
            if (idClenDph = 1) then
                    return 80;
            end if;
            if (idClenDph = 2) then
                    return 108;
            else 
                    return idClenDph;
            end if;
    end if;
end;
$$ LANGUAGE plpgsql;

-- vrati typDokladu podle prvniho UUID pokud vytvarime firmu v roce 2008 jinak podle druheho UUID
create or replace function vratTypDokl(in uuid2008 varchar, in uuidYounger varchar) returns integer as $$
declare
	rvidtypdokl integer;
begin
    if (cast(extract(year from now()) as integer) = 2008) then
	select idtypdokl into rvidtypdokl from dtypdokl where uuid = uuid2008;
    else 
        select idtypdokl into rvidtypdokl from dtypdokl where uuid = uuidYounger;
    end if;
    return rvidtypdokl;
end;
$$ LANGUAGE plpgsql;

-- vrati typDokladu podle daneho UUID
create or replace function vratTypDokl(in i_uuid varchar) returns integer as $$
declare
	rvidtypdokl integer;
begin
	select idtypdokl into rvidtypdokl from dtypdokl where uuid = i_uuid;
    return rvidtypdokl;
end;
$$ LANGUAGE plpgsql;

-- metoda nedela nic je tu pouze pro oznaceni typuDokladu, kdybychom je v budoucnu chteli zmenit,
-- tak abychom je nemuseli zase dohledavat ve sloupcich
create or replace function vratTypDokl(in idTypDokl integer) returns integer as $$
begin
    return idTypDokl;
end;
$$ LANGUAGE plpgsql;

-- metoda vracejici id skupiny zbozi podle uuid skupiny zbozi
create or replace function vratSkupZboz(in i_uuid varchar) returns integer as $$
begin
        return (select idskupzboz from cskupzboz where uuid = i_uuid);
end;
$$ LANGUAGE plpgsql;

-- vytvorime nastaveni
INSERT INTO nnastav (idnastav, lastupdate,                autozakazka, avsmerkod, avtrankod, cinnost,          dic,          elpokexport, elpokimport, elpokini, email, famesto, fapsc, faulice, fax,        idfinurad, fyzosoba, ic,         intrastat, mesto,      mobil, nazfirmy,           oprjmeno, oprpostav, oprprijmeni, platcedph, platioddata, podpisprik, podvojucto, psc,      sklfifo, sklucto, sklgenerovatpozadavky, spisznac,                                   splatdny, tel,        ulice,          cispop, www,  zobrlogok,             idtdzbytekvynos,                        idstatu,                                           idfastatu, idtdfapzdd, idtdfavzdd, idstatuleg,                                        idtdkurzrozvynos,                      idtdzbyteknaklad,                        idtdeppok, idtyporg, idtdobfav, idmeny, idtdkurzroznaklad,                       idtdepskl, pravformapodnik,                 idtdobfavzal, idtdobfap, idtdobsklpri, idtdobsklvyd, idtdobnav, idtdobobp, idtdobppv, idtdobnap, idtdobobv, jazyk1K,    jazyk2K,    jazyk3K,    jazyk4K,    jakytypfavk,            jakytypphlk,            jakytypfapk,            jakytypzavk,            jakytypintk,            jakytyppppk,            jakytypnavk,            jakytypobpk,            jakytypppvk,            jakytypnapk,            jakytypobvk,          rezimRezervaciK, idFuKraj, idfuuzemprac, eetprovozovna, eetlimit, eetmodk) 
             VALUES (1,        '2008-11-05 17:52:00.434', false,       NULL,      NULL,      'Nákup a prodej', 'CZ1212121218', NULL,        NULL,        NULL,     '',    NULL,    NULL,  NULL,    '25845634', NULL,      false,    '21212121', false,     'Praha 10', NULL,  'Demovačka s.r.o.', NULL,     NULL,      NULL,        true,      NULL,        false,      true,       '100 00', false,   false,   true,                  'zapsano u KS v Praze, odd B vložka 89512', 0,        '25896544', 'Holandská',    '31',   NULL, 'zobrLogo.prizFormat', vratTypDokl('CZ_POD_INT_ZBYTEK_VYNOS'), (select idstatu from astaty where uuid = 'CZ_CZ'), NULL,      NULL,       NULL,       (select idstatu from astaty where uuid = 'CZ_CZ'), vratTypDokl('CZ_POD_INT_KURROZ_ZISK'), vratTypDokl('CZ_POD_INT_ZBYTEK_NAKLAD'), NULL,      1,        NULL,      31,     vratTypDokl('CZ_POD_INT_KURROZ_ZTRATA'), NULL,      'Společnost s ručením omezeným', NULL,         NULL,      NULL,         NULL,         NULL,      NULL,      NULL,      NULL,      NULL,      'jazyk.cs', 'jazyk.en', 'jazyk.de', 'jazyk.fr', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'jakyTypDokl.posledni', 'rezimRezervaci.rucni', (select idFirmy from aAdresar where kod = 'FÚ - PRAHA'), (select idFirmy from aAdresar where kod = 'ÚP - PRAHA 10'), 123, 2, 'eetMod.ostryTest');

SELECT pg_catalog.setval('seq_nnastav', 1, true);

-- vytvorime ucetni obdobi o rok mladsi nez je aktualni datum
/*INSERT INTO nucetobdobi (iducetobdobi, lastupdate, chybapreceneni, kod, platidodata, platioddata, popis, poznam, rokproradu, zmenazaver) VALUES 
                        (nextval('seq_nucetobdobi'), '2008-08-27 11:49:08.71', true, posunInt(2008), posunDatum(date(extract (year from now()-1) || '-12-31')), posunDatum(date(extract (year from now()-1) || '-1-1')), NULL, NULL, posunInt(2008), true);*/


-- adresar
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (1, '2008-08-27 17:08:17.645', 'ABCSYSTEME', 'ABC-Systeme GesmbH', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Wien', NULL, '1200', NULL, 'Brigittenauer Lände 20', NULL, 0, 'AT845121', NULL, NULL, NULL, NULL, NULL, NULL, '84564545', 0.00, true, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, 171, NULL);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (3, '2008-08-27 17:13:53.101', 'DEMOFIRMA', 'DEMOFIRMA', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 10', NULL, '100 00', NULL, 'Holandská 31', NULL, 0, 'CZ21212121', NULL, NULL, NULL, NULL, NULL, NULL, '0000000000', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, NULL);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (4, '2008-08-27 17:15:21.712', 'DIETER AG', 'Dieter AG', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Berlin', NULL, '101 19', NULL, 'Schönhauser Allee 5', NULL, 0, 'DE1234567', NULL, NULL, NULL, NULL, NULL, NULL, '1234567', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, 147, NULL);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (5, '2008-08-27 17:16:14.589', 'KOLBÁSCZ', 'Kolbáscz', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Budapest', NULL, '1031', NULL, 'Nárony u. 6', NULL, 0, 'HU5151214', NULL, NULL, NULL, NULL, NULL, NULL, '9999553', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, 124, NULL);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (6, '2008-08-27 17:18:02.569', 'MCPAPER', 'Papírnictví McPaper', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 10', NULL, '101 00', NULL, 'Na kopřivkách 14', 'www.mcpaper.com', 0, 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, '12358454', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (2, '2008-08-27 17:18:20.456', 'CONSUL', 'Consul s.r.o.', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 13', NULL, '153 24', NULL, 'U strojovny 45', NULL, 0, 'CZ12345678', NULL, NULL, NULL, NULL, NULL, NULL, '123456', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 2);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (7, '2008-08-27 17:21:51.741', 'OD KOTVA', 'Obchodní dům Kotva', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 'honcova@odkotva.cz', '22457895', 'Praha 1', NULL, '110 00', '22114568', 'Revoluční 29', NULL, 0, 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, '74123654', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (8, '2008-08-27 17:25:15.537', 'OD KOTVA1', 'Sklady O.D. Kotva', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 5 - Stodůlky', NULL, '150 23', NULL, 'Skladovací 45', NULL, 0, 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, '74123654', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (9, '2008-08-27 17:33:32.196', 'PBENDA', 'Papírnictví Benda', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 5', NULL, '150 00', NULL, 'Plzeňská 65', 'www.benda.cz', 0, 'CZ7002051235', NULL, NULL, NULL, NULL, NULL, NULL, '12345678', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (10, '2008-08-27 17:35:48.349', 'PSTROS', 'Papírnictví u Pštrosa', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 10 - Vršovice', NULL, '101 00', NULL, 'Moskevská 23', NULL, 0, 'CZ777777', NULL, NULL, NULL, NULL, NULL, NULL, '777777', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (11, '2008-08-27 17:37:05.105', 'SUPER', 'Psací stroje SUPER a.s.', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Dobříš', NULL, '263 01', NULL, 'Za poštou 1036', NULL, 0, 'CZ985214461', NULL, NULL, NULL, NULL, NULL, NULL, '985214461', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 2);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) VALUES (12, '2008-08-27 17:38:32.236', 'VSE', 'Vysoká škola ekonomická', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Praha 3', NULL, '130 00', NULL, 'Nám. Winstona Churchila', NULL, 0, 'CZ45454544', NULL, NULL, NULL, NULL, NULL, NULL, '45454544', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 1);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) 
VALUES (13, '2008-08-27 17:40:12.344', 'VYRKANC', 'Výroba kancelářských potřeb', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, 'Mělník', NULL, '277 15', NULL, 'Za svorkami 763', NULL, 0, 'CZ9889693', NULL, NULL, NULL, NULL, NULL, NULL, '9889693', 0.00, false, NULL, 0, 'typVztahu.odberDodav', NULL, NULL, NULL, 2);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) 
VALUES (14, '2008-11-05 17:30:17.415', 'SOFTEU', 'SoftEU s.r.o.', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 'info@softeu.com', NULL, 'Plzeň', NULL, '301 00', NULL, 'Lochotínská 18', 'www.softeu.cz', 0, 'CZ26380676', NULL, NULL, NULL, NULL, NULL, NULL, '26380676', 0.00, true, NULL, 0, 'typVztahu.odberDodav', NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL);
INSERT INTO aadresar (idfirmy, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, email, fax, mesto, mobil, psc, tel, ulice, www, bonita, dic, eankod, faeankod, famesto, fapsc, faulice, formexportk, ic, limitfak, platcedph, specsym, splatdny, typvztahuk, idfastatu, idstred, idstatu, idskupfir) 
VALUES (15, '2008-11-05 17:29:26.165', 'FLEXIBEE', 'FlexiBee Systems s.r.o.', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 'info@flexibee.eu', NULL, 'Plzeň', NULL, '301 00', NULL, 'Lochotínská 18', 'www.flexibee.eu', 0, 'CZ28019920', NULL, NULL, NULL, NULL, NULL, NULL, '28019920', 0.00, true, NULL, 0, 'typVztahu.odberDodav', NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL);



-- abanspoj
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (1, '2008-08-27 17:09:57.251', NULL, NULL, NULL, NULL, '147258369', NULL, NULL, NULL, NULL, true, NULL, 6, 2, 7, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (2, '2008-08-27 17:21:51.737', NULL, NULL, NULL, NULL, '456123', NULL, NULL, NULL, NULL, true, NULL, 11, 7, NULL, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (3, '2008-08-27 17:24:48.502', NULL, NULL, NULL, NULL, '65893232', NULL, NULL, NULL, NULL, true, NULL, 52, 8, NULL, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (4, '2008-08-27 17:35:26.61', NULL, NULL, NULL, NULL, '456456', NULL, NULL, NULL, NULL, true, NULL, 5, 10, 7, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (5, '2008-08-27 17:37:05.101', NULL, NULL, NULL, NULL, '789987987', NULL, NULL, NULL, NULL, true, NULL, 1, 11, 1, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (6, '2008-08-27 17:38:32.232', NULL, NULL, NULL, NULL, '45789999', NULL, NULL, NULL, NULL, true, NULL, 10, 12, NULL, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (7, '2008-08-27 17:40:12.339', NULL, NULL, NULL, NULL, '7895458', NULL, NULL, NULL, NULL, true, NULL, 24, 13, NULL, NULL);
INSERT INTO abanspoj (idbanspoj, lastupdate, mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, idsmerkod, idfirmy, idkonsym, idstatu) VALUES (8, '2008-11-05 17:30:17.395', NULL, NULL, NULL, 'RZBCCZPP', '102019028', 'CZ255500 0000 0001 0201 9028', NULL, NULL, NULL, true, NULL, 31, 14, NULL, NULL);

SELECT pg_catalog.setval('seq_abanspoj', 8, true);

-- akontakty
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (1, '2008-08-27 17:11:12.503', NULL, NULL, NULL, 'tomasmarny', NULL, '777 666 666', '377 215 895', NULL, 'Ředitel', 'Tomáš', NULL, NULL, 'Marný', true, 'Doc. RnDr.', 2, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (2, '2008-08-27 17:11:38.413', NULL, NULL, NULL, NULL, NULL, '777 777 777', '377 215 895', NULL, 'dělník s r', 'Emanuel', NULL, NULL, 'Bacigala', false, NULL, 2, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (3, '2008-08-27 17:13:40.67', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Karel', NULL, NULL, 'Bednář', true, NULL, 3, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (4, '2008-08-27 17:13:53.094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Jiří', NULL, NULL, 'Kalousek', false, NULL, 3, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (5, '2008-08-27 17:18:02.566', NULL, NULL, NULL, NULL, NULL, '737 555 888', '377 123 456', NULL, 'Obchodní z', 'Antonín', NULL, NULL, 'Klapejron', true, NULL, 6, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (6, '2008-08-27 17:25:15.533', NULL, NULL, NULL, NULL, '375557796', NULL, '37555668', NULL, NULL, 'Tomáš', NULL, NULL, 'Odráška', true, NULL, 8, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (7, '2008-08-27 17:33:51.202', NULL, NULL, NULL, 'benda@benda.cz', NULL, NULL, '777897123', NULL, NULL, 'Josef', NULL, NULL, 'Benda', true, 'Ing.', 9, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (8, '2008-08-27 17:35:48.345', NULL, NULL, NULL, NULL, '478956', NULL, '451415', NULL, NULL, 'Jakub', NULL, NULL, 'Pštros', true, NULL, 10, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (9, '2008-08-27 17:36:49.373', NULL, NULL, NULL, 'a.novak@super.cz', '30645795', NULL, '30645789', NULL, NULL, 'Antonín', NULL, NULL, 'Novák', true, NULL, 11, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (10, '2008-08-27 17:38:13.385', NULL, NULL, NULL, 'svoboda@vse.cz', '777741853', NULL, '777741852', NULL, NULL, 'Eliáš', NULL, NULL, 'Svoboda', true, 'Doc.', 12, NULL);
INSERT INTO akontakty (idkontakt, lastupdate, mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, popis, poznam, prijmeni, primarni, titul, idfirmy, idstatu) VALUES (11, '2008-08-27 17:39:55.107', NULL, NULL, NULL, NULL, '206485618', NULL, '315 445632', NULL, NULL, 'Jan', NULL, NULL, 'Připínáček', true, NULL, 13, NULL);
SELECT pg_catalog.setval('seq_akontakty', 11, true);

-- merne jednotky
INSERT INTO cmerjed (idmj, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, typmjk) VALUES (100, '2008-08-28 11:58:37.222', 'KM', 'kilometr', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 'typMj.delka');
SELECT pg_catalog.setval('seq_cmerjed', 100, true);

-- zbozi
INSERT INTO cskupzboz (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, limmnoz2, limmnoz3, limmnoz4, limmnoz5, proczakl, procento2, procento3, procento4, procento5, typcenydphk, typcenyvychozi25k, typcenyvychozik, typvypceny25k, typvypcenyk, zaokrjakk, zaokrnak, idprotiucetvfa, idprotiucetpfa, idprotiucetsklv, idprotiucetsklp, uuid) VALUES ('2008-08-28 11:38:35.556', 'KANCELAR', 'kancelářské zboží', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 0.000000, 0.000000, 0.000000, 0.000000, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', 'typVypCeny.marze', 'typVypCeny.marze', 'zaokrJak.matem', 'zaokrNa.setiny', NULL, NULL, NULL, NULL, 'CZ_KANCELAR');
INSERT INTO cskupzboz (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, limmnoz2, limmnoz3, limmnoz4, limmnoz5, proczakl, procento2, procento3, procento4, procento5, typcenydphk, typcenyvychozi25k, typcenyvychozik, typvypceny25k, typvypcenyk, zaokrjakk, zaokrnak, idprotiucetvfa, idprotiucetpfa, idprotiucetsklv, idprotiucetsklp, uuid) VALUES ('2008-08-28 11:38:47.14', 'MANUALY', 'Manuály a návody', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 0.000000, 0.000000, 0.000000, 0.000000, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', 'typVypCeny.marze', 'typVypCeny.marze', 'zaokrJak.matem', 'zaokrNa.setiny', NULL, NULL, NULL, NULL,'CZ_MANUALY');
INSERT INTO cskupzboz (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, limmnoz2, limmnoz3, limmnoz4, limmnoz5, proczakl, procento2, procento3, procento4, procento5, typcenydphk, typcenyvychozi25k, typcenyvychozik, typvypceny25k, typvypcenyk, zaokrjakk, zaokrnak, idprotiucetvfa, idprotiucetpfa, idprotiucetsklv, idprotiucetsklp, uuid) VALUES ('2008-08-28 11:39:10.53', 'STROJE', 'Psací stroje', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 0.000000, 0.000000, 0.000000, 0.000000, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', 'typVypCeny.marze', 'typVypCeny.marze', 'zaokrJak.matem', 'zaokrNa.setiny', NULL, NULL, NULL, NULL, 'CZ_STROJE');

-- cenik
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (1, '2008-08-28 11:55:37.636', 'DEROVACKA2', 'Děrovačka se dvěma otvory', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 57.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 38.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (2, '2008-08-28 11:57:37.231', 'DEROVACKA3', 'Děrovačka se třemi otvory', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 70.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 40.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (3, '2008-08-28 11:59:30.553', 'DO', 'Náklady na dopravu', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 9.000000, 6, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 0.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.sluzba', false, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 100, vratSkupZboz('CZ_MANUALY'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (4, '2008-08-28 12:02:16.235', 'DRTICPAP025', 'Skartovačka papíru 5list.', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 2500.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 1230.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (5, '2008-08-28 13:32:03.774', 'KUFR', 'Kufr na psací stroj', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 1500.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 1000.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_STROJE'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (6, '2008-08-28 13:33:01.223', 'MANUAL', 'Náhradní manuál', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 300.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 250.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphSniz', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_MANUALY'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (7, '2008-08-28 13:53:39.266', 'POST', 'Poštovné a balné', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 200.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 0.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.poplatek', false, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, NULL, vratSkupZboz('CZ_SLUZBY'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (8, '2008-08-28 14:03:47.576', 'SESIVACKA', 'Sešívačka', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 45.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 23.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (10, '2008-08-28 14:09:35.989', 'STROJ E C', 'Psací stroj Consul elektrický', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 4500.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 3256.300000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_STROJE'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (11, '2008-08-28 14:11:53.709', 'STROJ M C', 'Psací stroj Consul mechanický', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 1800.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 1000.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_STROJE'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (12, '2008-08-28 14:22:25.364', 'STROJ S', 'Psací stroj Super elektrický s pamětí', NULL, NULL, NULL, 'Obsahuje předdefinované vzory dopisů', NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 9000.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 7300.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_STROJE'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (13, '2008-08-28 14:25:56.843', 'STROJ SD', 'Psací stroj Super elektrický s pamětí a displayem', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 15200.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 14600.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_STROJE'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (14, '2008-08-28 14:28:52.893', 'VAZAC M', 'Vazač listů mechanický', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 1500.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 820.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (15, '2008-08-28 14:29:49.04', 'VAZAC T', 'Vazač listů tepelný', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 2000.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 1200.000000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO ccenik (idcenik, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, baleniean1, baleniean2, baleniean3, baleniean4, baleniean5, balenimj1, balenimj2, balenimj3, balenimj4, balenimj5, baleninazev1, baleninazev2, baleninazev3, baleninazev4, baleninazev5, cenjednotka, cena2, cena3, cena4, cena5, cenazakl, desetinmj, dokcesta, dokprogram, eankod, evidvyrcis, hmotmj, hmotobal, inevid, inkoefmj, inkoefstat, kodplu, limmnoz2, limmnoz3, limmnoz4, limmnoz5, mjkoef2, mjkoef3, mjzarukyk, nakupcena, objem, popisa, popisb, popisc, proczakl, procento2, procento3, procento4, procento5, prodejmj, typcenydphk, typcenyvychozi25k, typcenyvychozik, typprodejk, typszbdphk, typvypceny25k, typvypcenyk, typzasobyk, skladove, wkatalog, wnahrat, wneni, wnovinka, wobrmini, wobrnormal, wpriprav, wskladem, wsleva, wslevado, wslevaod, wtopcena, wvyprodej, www, wzmena, zaokrjakk, zaokrnak, zaruka, zatrid, idmj1, idskupzboz, idstatu, idnomen, idmjobj, idmj2, idmj3, idmjhmot) VALUES (9, '2008-08-29 15:31:27.676', 'SPONKY', 'Kancelářské sponky', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 13.000000, 0, NULL, NULL, NULL, false, 0.000000, 0.000000, false, 0.000000, 0.000000, NULL, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, NULL, 12.300000, 0.000000, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, 0.00, 0, 'typCeny.bezDph', 'typCenyVychozi.nakCena', 'typCenyVychozi.nakCena', NULL, 'typSzbDph.dphZakl', 'typVypCeny.marze', 'typVypCeny.marze', 'typZasoby.zbozi', true, NULL, false, false, false, NULL, NULL, false, false, 0.00, NULL, NULL, false, false, NULL, false, 'zaokrJak.matem', 'zaokrNa.setiny', 0, NULL, 3, vratSkupZboz('CZ_KANCELAR'), NULL, NULL, NULL, NULL, NULL, NULL);
SELECT pg_catalog.setval('seq_ccenik', 15, true);

-- uzakazky
INSERT INTO uzakazky (idzakazky, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, datkonec, datzahaj, idstavzakazky, idtypzakazky, iduzivatel, idstred, idfirmy) VALUES (1, '2008-08-29 11:04:49.985', 'ZAK', 'Obchodní případ', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, (select idtypzakazky from utypzakazky where druhzakk = 'typZak.nevyrob'), NULL, NULL, NULL);
INSERT INTO uzakazky (idzakazky, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, datkonec, datzahaj, idstavzakazky, idtypzakazky, iduzivatel, idstred, idfirmy) VALUES (2, '2008-08-29 14:54:05.721', '111888', 'Vybavení školy', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, NULL, NULL, NULL, (select idtypzakazky from utypzakazky where druhzakk = 'typZak.nevyrob'), NULL, NULL, NULL);
SELECT pg_catalog.setval('seq_uzakazky', 2, true);

-- typy dokladu
INSERT INTO dbsp (lastupdate, kod, nazev, show, modul, platiod, platido, buc, bucprimarni, privypis, sloprikaz, priprikaz, prikpopklient, prikpoppopis, vypisduplicitak, automatickysklad, idradyprijem, idradyvydej, idstred, idmeny, idmenabanky, idprimucet, idtyporg, uuid)
 VALUES ('2012-08-01 00:00:00.000', 'BANKOVNÍ ÚČET 2', 'Druhý bankovní účet', true, 'BAN', 0, 9999, '37050301', true, 'gpc', 'c:'||E'\\', 'kpc', true, true, 'elVypisDuplicita.vypis', true, (select IdRady from dRady where uuid = 'CZ_BAN_PLUS'), (select IdRady from dRady where uuid = 'CZ_BAN_MINUS'), (select IdStred from uStrediska where uuid = 'CZ_CENTRALA'), (select IdMeny from uMeny where uuid = 'CZ_CZK'), (select IdMeny from uMeny where uuid = 'CZ_CZK'), (select IdUcet from uUcty where uuid = 'CZ_POD_221001'), 1, 'CZ_POD_BAN_STD2');
INSERT INTO dtypdokl (lastupdate, kod, nazev, show, modul, ucetni, typdoklk, primarni, slevadokl, splatdny, generovatskl, tiskautomat, prodejka, zapocet, platiod, platido, idstatdph, idtyporg, idbsp, uuid)
 VALUES ('2010-12-06 00:00:00.000', 'BANKOVNÍ ÚČET 2', 'Pohyb na druhém bankovním účtu', true, 'BAN', true, 'typBanUctu.kc', false, 0.0, 0, true, false, false, false, 0, 9999, (select IdStatu from aStaty where uuid like '%_CZ'), 1, (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 'CZ_POD_BAN_STD2');
INSERT INTO public.dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, doprava, popisdoklad, uvodtxt, zavtxt, formauhrk, modul, slevadokl, splatdny, typdoklk, ucetni, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, workflow, idradyprijem, idstatpuvod, idstatodesl, idobchtrans, idradyvydej, iducetobdobiod, idstatdph, idkonsym, iddruhdopr, idprimucet, idzvlpoh, idstred, idcinnost, idmeny, idkrajurc, iducetobdobido, iddodpodm, idstaturc, idtyporg, idtypucopp, idtypucopv, platido, platiod, razeniprotiskk, tiskautomat, primarni, prodejka, cashregister, zapocet, faktsouhrn, faktauto, uhrauto, zapauto, automail, umoznitrefun, idtypdoklpok, idbspskl, typpohybuk, typpohybuskladk, eanakcenahrat, eanakcepopis, idbsp, idbspban, idtypprotidokladuprijem, idtypprotidokladuvydej, idtypdoklfak, idformauhradycis, idformadopravy, uuid, emailtxt, ekokomk, vscisobj, odpocauto, idclenkonvykdph, jednaplusjedna, eetpokladnizarizeni, eettypk, generovatskl) VALUES
 ('2016-08-18 16:33:28.185000', 'FAKTURA-EET', 'Faktura - daňový doklad, EET', null, null, null, 'Typ dokladu pro standardní fakturu', null, true, null, null, null, null, 'formaUhr.prevod', 'FAV', 0.00, 14, 'typDokladu.faktura', true, 'zaokrJak.matem', 'zaokrJak.matem', 'zaokrNa.setiny', 'zaokrNa.jednotky', false, 1, null, null, null, null, null, 39, 1, null, 17, null, 1, null, 31, null, null, null, null, 1, null, null, 9999, 0, null, false, false, false, false, false, false, false, false, false, false, true, null, null, null, null, false, null, null, 1, null, 1, null, 3, null, null, null, null, false, false, null, false, 'pokladna-1', 'eetTyp.anoBezny', true),
 ('2016-08-18 16:43:53.865000', 'KASA-EET', ' Kasa EET', null, null, null, null, null, true, null, null, null, null, null, 'FAV', 0.00, null, 'typDokladu.prodejka', true, null, null, null, null, false, 24, null, null, null, null, null, 39, null, null, null, null, null, null, 31, null, null, null, null, 1, null, null, 9999, 0, null, false, false, true, false, false, false, false, false, false, false, true, 5, 4, null, null, false, null, null, null, null, 1, null, null, null, null, null, null, false, false, null, false, 'pokladna-1', 'eetTyp.anoBezny', true),
 ('2016-08-18 16:45:12.928000', 'STANDARD-EET', 'Standardní pokladní pohyb, EET', null, null, null, null, null, true, null, null, null, null, 'formaUhr.hotove', 'POK', 0.00, null, null, true, null, null, null, null, false, null, null, null, null, null, null, 39, null, null, null, null, null, null, null, null, null, null, null, 1, null, null, 9999, 0, null, false, false, false, false, false, false, false, false, false, false, true, null, null, null, null, false, null, null, null, 1, 1, null, 1, null, null, null, null, false, false, null, false, 'pokladna-1', 'eetTyp.anoBezny', true);  


-- skladove karty
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (1, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'DEROVACKA2'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (2, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'DEROVACKA3'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (3, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'DRTICPAP025'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (4, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'KUFR'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (5, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-03', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'MANUAL'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (6, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-03', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'SESIVACKA'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (7, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-01-09', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'SPONKY'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (8, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'STROJ E C'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (9, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'STROJ M C'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (10, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'STROJ S'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (11, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-05', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'STROJ SD'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (12, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-03-03', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'VAZAC M'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));
INSERT INTO skarty (idkarty, lastupdate, prumcenatuz, prumcenamen, stavmj, stavtuz, stavmen, datposl, pocatmj, pocattuz, pocatmen, minmj, maxmj, rezervmj, datstavmj, datstavtuz, datstavmen, poslcenatuz, poslcenamen, vydexpir, iducetobdobi, idcenik, idskladu)
 VALUES (13, '2008-08-28 00:00:00.000', 0.0, 0.0, 0.0, 0.0, 0.0, '2010-01-01', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, (select max(iducetobdobi) from nucetobdobi), (select IdCenik from cCenik where kod = 'VAZAC T'), (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'));

SELECT pg_catalog.setval('seq_skarty', 13, true);

-- doklady
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (2, '2008-08-29 11:05:53.378', true, NULL, '7895458', NULL, '99632', NULL, NULL, NULL, NULL, posunDatum('2008-01-06'), NULL, posunDatum('2008-01-06'), NULL, posunDatum('2008-01-06'), 'CZ9889693', NULL, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0002/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'doprava', NULL, '277 15', 0.00, NULL, NULL, false, 1000.00, 0.00, 0.00, 0.00, 159.71, 0.00, 0.00, 0.00, 0.00, 0.00, 840.29, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '99632', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, 1, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.3.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_518001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (13, '2008-08-29 11:22:13.004', true, NULL, '789987987', NULL, '15800', NULL, NULL, NULL, NULL, posunDatum('2008-03-30'), NULL, posunDatum('2008-03-13'), NULL, posunDatum('2008-03-13'), 'CZ985214461', NULL, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('PF0013/2008'), 0.000000, 0, 'Dobříš', 'FAP', 'Psací stroje SUPER a.s.', 'papíry do tiskáren', 'Proč bez DPH: od neplátce', '263 01', 0.00, NULL, NULL, false, 1250.00, 0.00, 0.00, 0.00, 0.00, 0.00, 1250.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '15800', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 11, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (12, '2008-08-29 11:22:28.181', true, NULL, '789987987', NULL, '15800', NULL, NULL, NULL, NULL, posunDatum('2008-03-29'), NULL, posunDatum('2008-03-10'), NULL, posunDatum('2008-03-10'), 'CZ985214461', NULL, posunDatum('2008-03-10'), posunDatum('2008-03-10'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('PF0012/2008'), 0.000000, 0, 'Dobříš', 'FAP', 'Psací stroje SUPER a.s.', 'náplň do sešívaček', 'Proč bez DPH: od neplátce', '263 01', 0.00, NULL, NULL, false, 390.00, 0.00, 0.00, 0.00, 0.00, 0.00, 390.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '15800', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 11, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (1, '2008-09-01 17:29:25.953', true, NULL, '147258369', NULL, '88889', NULL, NULL, NULL, NULL, posunDatum('2008-01-15'), NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ12345678', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('PF0001/2008'), 0.000000, 0, 'Praha 13', 'FAP', 'Consul s.r.o.', 'zboží', NULL, '153 24', 0.00, NULL, NULL, false, 5000.00, 0.00, 0.00, 0.00, 798.50, 0.00, 0.00, 0.00, 0.00, 0.00, 4201.50, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '88889', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 4000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.castUhr', 0.00, 0.00, 2, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 7, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021') , (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.3.'), NULL, NULL, 6, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_119001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (5, '2008-09-02 09:52:34.704', true, NULL, '7895458', NULL, '89756', NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ9889693', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0005/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'kancelářské doplňky', 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 980.00, 0.00, 0.00, 0.00, 0.00, 0.00, 980.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '89756', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, NULL, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (4, '2008-09-02 10:17:09.945', true, NULL, '789987987', NULL, '89755', NULL, NULL, NULL, NULL, posunDatum('2008-03-27'), NULL, posunDatum('2008-03-05'), posunDatum('2008-03-01'), posunDatum('2008-03-05'), 'CZ985214461', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('PF0004/2008'), 0.000000, 0, 'Dobříš', 'FAP', 'Psací stroje SUPER a.s.', 'server', NULL, '263 01', 0.00, NULL, NULL, false, 230000.00, 0.00, 0.00, 0.00, 36731.00, 0.00, 0.00, 0.00, 0.00, 0.00, 193269.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '89755', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 230000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 11, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.2.'), NULL, NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (7, '2008-09-02 10:25:01.664', true, NULL, '789987987', NULL, '47851', NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), 'CZ985214461', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('PF0007/2008'), 0.000000, 0, 'Dobříš', 'FAP', 'Psací stroje SUPER a.s.', NULL, 'Proč bez DPH: od neplátce', '263 01', 0.00, NULL, NULL, false, 785.00, 0.00, 0.00, 0.00, 0.00, 0.00, 785.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '47851', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 11, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (6, '2008-09-02 10:25:09.654', true, NULL, '147258369', NULL, '47850', NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), posunDatum('2008-03-01'), posunDatum('2008-03-07'), 'CZ12345678', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('PF0006/2008'), 0.000000, 0, 'Praha 13', 'FAP', 'Consul s.r.o.', 'stolní počítač', 'Proč bez DPH: od neplátce', '153 24', 0.00, NULL, NULL, false, 24000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 24000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '47850', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 24000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 2, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), NULL, NULL, 6, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (15, '2008-08-29 11:25:15.08', true, NULL, '789987987', NULL, '15800', NULL, NULL, NULL, NULL, posunDatum('2008-03-13'), NULL, posunDatum('2008-03-13'), NULL, posunDatum('2008-03-13'), 'CZ985214461', NULL, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('PF0015/2008'), 0.000000, 0, 'Dobříš', 'FAP', 'Psací stroje SUPER a.s.', 'odkladný stolek', 'Proč bez DPH: od neplátce', '263 01', 0.00, NULL, NULL, false, 3000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 3000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '15800', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 11, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 1, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (18, '2008-08-29 11:27:59.425', true, NULL, '147258369', NULL, '45133', NULL, NULL, NULL, NULL, posunDatum('2008-03-15'), NULL, posunDatum('2008-03-15'), NULL, posunDatum('2008-03-15'), 'CZ12345678', NULL, posunDatum('2008-03-15'), posunDatum('2008-03-15'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('PF0018/2008'), 0.000000, 0, 'Praha 13', 'FAP', 'Consul s.r.o.', 'nákup přídavných šuplíků', 'Proč bez DPH: od neplátce', '153 24', 0.00, NULL, NULL, false, 4500.00, 0.00, 0.00, 0.00, 0.00, 0.00, 4500.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '45133', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 2, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 7, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 6, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (19, '2008-09-01 17:18:14.075', false, NULL, NULL, 'S-0001/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-17'), NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), posunDatum('2008-01-03'), 'CZ7002051235', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('VF1-0001/2008'), 0.000000, 0, 'Praha 5', 'FAV', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 36283.10, 0.00, 0.00, 0.00, 5793.20, 0.00, 0.00, 0.00, 0.00, 0.00, 30489.90, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080001', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 36283.10, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 9, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (16, '2008-09-02 10:34:51.748', true, NULL, '7895458', NULL, '36450', NULL, NULL, NULL, NULL, posunDatum('2008-03-30'), NULL, posunDatum('2008-03-13'), NULL, posunDatum('2008-03-13'), 'CZ9889693', NULL, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0016/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', NULL, 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 6540.00, 0.00, 0.00, 0.00, 0.00, 0.00, 6540.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '36450', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (17, '2008-09-02 10:34:59.412', true, NULL, '7895458', NULL, '36451', NULL, NULL, NULL, NULL, posunDatum('2008-03-15'), NULL, posunDatum('2008-03-15'), NULL, posunDatum('2008-03-15'), 'CZ9889693', NULL, posunDatum('2008-03-15'), posunDatum('2008-03-15'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0017/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'nákup příručních počítačů', 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 250000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 250000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '36451', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 150000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.castUhr', 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (21, '2008-09-02 09:24:11.08', false, NULL, NULL, 'S-0003/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-17'), NULL, posunDatum('2008-01-03'), posunDatum('2008-01-04'), posunDatum('2008-01-03'), 'CZ7002051235', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('VF1-0003/2008'), 0.000000, 0, 'Praha 5', 'FAV', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 3415300.00, 0.00, 0.00, 0.00, 545300.00, 0.00, 0.00, 0.00, 0.00, 0.00, 2870000.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080003', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 3415300.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 9, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (23, '2008-08-29 15:35:13.202', false, NULL, NULL, 'S-0005/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-23'), NULL, posunDatum('2008-01-09'), NULL, posunDatum('2008-01-09'), 'CZ777777', NULL, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, NULL, NULL, NULL, NULL, '777777', posunDoklKod('VF1-0005/2008'), 0.000000, 0, 'Praha 10 - Vršovice', 'FAV', 'Papírnictví u Pštrosa', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 3647.40, 0.00, 0.00, 0.00, 582.40, 0.00, 0.00, 0.00, 0.00, 0.00, 3065.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Moskevská 23', NULL, '20080005', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 10, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (24, '2008-08-29 15:37:09.016', false, NULL, NULL, 'S-0006/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-15'), NULL, posunDatum('2008-01-01'), NULL, posunDatum('2008-01-01'), 'CZ74123654', NULL, posunDatum('2008-01-01'), posunDatum('2008-01-01'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('VF1-0006/2008'), 0.000000, 0, 'Praha 1', 'FAV', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 5087.00, 0.00, 27.00, 0.00, 760.00, 0.00, 0.00, 0.00, 300.00, 0.00, 4000.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, '20080006', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (26, '2008-08-29 16:47:36.64', false, NULL, NULL, 'S-0008/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ45454544', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '45454544', posunDoklKod('VF1-0008/2008'), 0.000000, 0, 'Praha 3', 'FAV', 'Vysoká škola ekonomická', NULL, NULL, '130 00', 0.00, NULL, NULL, false, 1635.00, 0.00, 135.00, 0.00, 0.00, 0.00, 0.00, 0.00, 1500.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Nám. Winstona Churchila', NULL, '20080008', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 12, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (30, '2008-08-29 16:50:13.623', false, NULL, NULL, 'S-0012/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ7002051235', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('VF1-0012/2008'), 0.000000, 0, 'Praha 5', 'FAV', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 203.50, 0.00, 0.00, 0.00, 32.50, 0.00, 0.00, 0.00, 0.00, 0.00, 171.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080012', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 9, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (20, '2008-09-02 09:40:14.536', false, NULL, NULL, 'S-0002/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-17'), NULL, posunDatum('2008-01-03'), posunDatum('2008-03-01'), posunDatum('2008-01-03'), 'CZ12358454', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', 'VF1-0002/2008', 0.000000, 0, 'Praha 10', 'FAV', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 2975.00, 0.00, 0.00, 0.00, 475.00, 0.00, 0.00, 0.00, 0.00, 0.00, 2500.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080002', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 2975.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, 2, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (22, '2008-09-02 09:40:46.547', false, NULL, NULL, 'S-0004/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-23'), NULL, posunDatum('2008-01-09'), posunDatum('2008-03-01'), posunDatum('2008-01-09'), 'CZ12358454', NULL, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('VF1-0004/2008'), 0.000000, 0, 'Praha 10', 'FAV', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 6259.40, 0.00, 0.00, 0.00, 999.40, 0.00, 0.00, 0.00, 0.00, 0.00, 5260.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080004', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 6259.40, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (25, '2008-09-02 09:41:38.556', false, NULL, NULL, 'S-0007/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), posunDatum('2008-03-01'), posunDatum('2008-03-03'), 'CZ7002051235', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('VF1-0007/2008'), 0.000000, 0, 'Praha 5', 'FAV', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 5950.00, 0.00, 0.00, 0.00, 950.00, 0.00, 0.00, 0.00, 0.00, 0.00, 5000.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080007', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 5950.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 9, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (29, '2008-09-02 09:43:28.581', false, NULL, NULL, 'S-0011/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ74123654', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('VF1-0011/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'FAV', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 7140.00, 0.00, 0.00, 0.00, 1140.00, 0.00, 0.00, 0.00, 0.00, 0.00, 6000.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Skladovací 45', NULL, '20080011', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 3000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.castUhr', 0.00, 0.00, 8, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (27, '2008-09-02 10:40:55.846', false, NULL, NULL, 'S-0009/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), posunDatum('2008-03-06'), posunDatum('2008-03-03'), 'CZ45454544', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '45454544', posunDoklKod('VF1-0009/2008'), 0.000000, 0, 'Praha 3', 'FAV', 'Vysoká škola ekonomická', NULL, NULL, '130 00', 0.00, NULL, NULL, false, 746.10, 0.00, 0.00, 0.00, 119.20, 0.00, 0.00, 0.00, 0.00, 0.00, 626.90, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Nám. Winstona Churchila', NULL, '20080009', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 746.10, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 12, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (31, '2008-09-02 10:41:48.801', false, NULL, NULL, 'S-0013/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-18'), NULL, posunDatum('2008-03-04'), posunDatum('2008-03-06'), posunDatum('2008-03-04'), 'CZ74123654', NULL, posunDatum('2008-03-04'), posunDatum('2008-03-04'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('VF1-0013/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'FAV', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 4284.00, 0.00, 0.00, 0.00, 684.00, 0.00, 0.00, 0.00, 0.00, 0.00, 3600.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Skladovací 45', NULL, '20080013', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 4284.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 8, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (32, '2008-08-29 16:51:33.78', false, NULL, NULL, 'S-0014/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ12358454', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('VF1-0014/2008'), 0.000000, 0, 'Praha 10', 'FAV', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 18088.00, 0.00, 0.00, 0.00, 2888.00, 0.00, 0.00, 0.00, 0.00, 0.00, 15200.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080014', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (34, '2008-09-02 10:42:40.568', false, NULL, NULL, 'S-0016/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), posunDatum('2008-03-06'), posunDatum('2008-03-05'), 'CZ74123654', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('VF1-0016/2008'), 0.000000, 0, 'Praha 1', 'FAV', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 9650.90, 0.00, 0.00, 0.00, 1540.90, 0.00, 0.00, 0.00, 0.00, 0.00, 8110.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, '20080016', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 9650.90, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (33, '2008-08-29 17:02:20.159', false, NULL, NULL, 'S-0015/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ12358454', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('VF1-0015/2008'), 0.000000, 0, 'Praha 10', 'FAV', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 1176434.00, 0.00, 0.00, 0.00, 187834.00, 0.00, 0.00, 0.00, 0.00, 0.00, 988600.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080015', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (3, '2008-09-02 10:47:08.309', true, NULL, '147258369', NULL, '8548', NULL, NULL, NULL, NULL, posunDatum('2008-03-13'), NULL, posunDatum('2008-03-03'), posunDatum('2008-03-07'), posunDatum('2008-03-03'), 'CZ12345678', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('PF0003/2008'), 0.000000, 0, 'Praha 13', 'FAP', 'Consul s.r.o.', 'zboží na sklad', NULL, '153 24', 0.00, NULL, NULL, false, 236.00, 0.00, 0.00, 0.00, 37.69, 0.00, 0.00, 0.00, 0.00, 0.00, 198.31, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '8548', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 236.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 2, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 7, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), NULL, NULL, 6, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (35, '2008-08-29 17:17:19.315', false, NULL, NULL, 'S-0017/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'AT845121', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '84564545', posunDoklKod('VF1-0017/2008'), 26.200000, 1, 'Wien', 'FAV', 'ABC-Systeme GesmbH', NULL, NULL, '1200', 0.00, NULL, NULL, false, 7545.60, 288.00, 0.00, 0.00, 0.00, 0.00, 7545.60, 288.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Brigittenauer Lände 20', NULL, '20080017', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, 171, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 11, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (8, '2008-09-02 10:47:21.465', true, NULL, '7895458', NULL, '61542', NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), posunDatum('2008-03-07'), 'CZ9889693', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0008/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'nová křesla', 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 10200.00, 0.00, 0.00, 0.00, 0.00, 0.00, 10200.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '61542', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 10200.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (36, '2008-08-29 17:18:53.614', false, NULL, NULL, 'S-0018/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'HU5151214', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '9999553', posunDoklKod('VF1-0018/2008'), 26.200000, 1, 'Budapest', 'FAV', 'Kolbáscz', NULL, NULL, '1031', 0.00, NULL, NULL, false, 7663.50, 292.50, 0.00, 0.00, 0.00, 0.00, 7663.50, 292.50, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Nárony u. 6', NULL, '20080018', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021') , (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, 124, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 11, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (10, '2008-09-02 10:47:30.298', true, NULL, '7895458', NULL, '48522', NULL, NULL, NULL, NULL, posunDatum('2008-03-09'), NULL, posunDatum('2008-03-09'), posunDatum('2008-03-07'), posunDatum('2008-03-09'), 'CZ9889693', NULL, posunDatum('2008-03-09'), posunDatum('2008-03-09'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0010/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'promítačka', 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 40000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 40000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '48522', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 40000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (38, '2008-08-29 17:21:48.773', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, NULL, NULL, posunDatum('2008-03-05'), 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('VF2-0001/2008'), 0.000000, 0, 'Praha 10', 'FAV', 'Papírnictví McPaper', 'Záloha k objednávce', NULL, '101 00', 0.00, NULL, NULL, false, 20218.10, 0.00, 0.00, 0.00, 0.00, 0.00, 20218.10, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', false, 'Na kopřivkách 14', NULL, '20085000', NULL, false, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 6, NULL, NULL, 5, NULL, 1, vratTypDokl('CZ_POD_FAV_ZAL'), NULL, NULL, NULL, 1, 1, 6, 4, NULL, (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 4, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(19), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, NULL);
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (9, '2008-09-02 10:27:19.529', true, NULL, '7895458', NULL, '48521', NULL, NULL, NULL, NULL, posunDatum('2008-03-09'), NULL, posunDatum('2008-03-09'), NULL, posunDatum('2008-03-09'), 'CZ9889693', NULL, posunDatum('2008-03-09'), posunDatum('2008-03-09'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('PF0009/2008'), 0.000000, 0, 'Mělník', 'FAP', 'Výroba kancelářských potřeb', 'server', 'Proč bez DPH: od neplátce', '277 15', 0.00, NULL, NULL, false, 68000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 68000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '48521', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, NULL, NULL, 0.00, 0.00, 13, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 1, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 24, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (11, '2008-09-02 10:32:04', true, NULL, '147258369', NULL, '48523', NULL, NULL, NULL, NULL, posunDatum('2008-03-29'), NULL, posunDatum('2008-03-10'), posunDatum('2008-03-01'), posunDatum('2008-03-10'), 'CZ12345678', NULL, posunDatum('2008-03-10'), posunDatum('2008-03-10'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('PF0011/2008'), 0.000000, 0, 'Praha 13', 'FAP', 'Consul s.r.o.', 'kancelářské lampy', 'Proč bez DPH: od neplátce', '153 24', 0.00, NULL, NULL, false, 10000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 10000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '48523', NULL, true, NULL, NULL, NULL, NULL, NULL, 0.00, 0.00, 10000.00, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 2, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, vratTypDokl('CZ_POD_FAP_STD'), NULL, NULL, 7, 1, 1, 6, 5, (select iducet from uucty where uuid = 'CZ_POD_343021') , (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 5, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 6, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idclenkonvykdph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (28, '2008-09-02 10:43:07.965', false, NULL, NULL, 'S-0010/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-17'), NULL, posunDatum('2008-03-03'), posunDatum('2008-03-06'), posunDatum('2008-03-03'), 'CZ74123654', NULL, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('VF1-0010/2008'), 0.000000, 0, 'Praha 1', 'FAV', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 642.60, 0.00, 0.00, 0.00, 102.60, 0.00, 0.00, 0.00, 0.00, 0.00, 540.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, '20080010', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 642.60, 0.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, NULL, NULL, vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 31, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, formauhrk, idformauhradycis, juhdat, juhdatmen, juhsum, juhsummen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idrady, iddphzaklucet, idbspban, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet) VALUES (37, '2008-09-02 10:44:20.063', false, NULL, NULL, 'S-0019/08', NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-19'), NULL, posunDatum('2008-03-05'), posunDatum('2008-03-06'), posunDatum('2008-03-05'), 'DE1234567', NULL, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, NULL, NULL, NULL, '1234567', posunDoklKod('VF1-0019/2008'), 26.200000, 1, 'Berlin', 'FAV', 'Dieter AG', NULL, NULL, '101 19', 0.00, NULL, NULL, false, 1048.00, 40.00, 0.00, 0.00, 0.00, 0.00, 1048.00, 40.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Schönhauser Allee 5', NULL, '20080019', NULL, true, NULL, NULL, NULL, NULL, 'formaUhr.prevod', (select IdFormaUhradyCis from dFormaUhradyCis where uuid = 'PREVOD'), 0.00, 0.00, 1048.00, 40.00, false, 0.00, 0.00, NULL, 'stavUhr.uhrazeno', 0.00, 0.00, 4, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'), 5, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, vratTypDokl('CZ_POD_FAV_STD'), NULL, NULL, 1, 1, 1, 6, 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, NULL, NULL, NULL, 147, NULL, vratCleneniDph(1), NULL, NULL, NULL, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, 11, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'));
INSERT INTO ddoklfak (iddoklfak, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, postovnishodna, fanazev, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, pocetpriloh, popis, poznam, psc, slevadokl, source, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphsniz2, sumdphsniz2men, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklsniz2, sumzklsniz2men, sumzklzakl, sumzklzaklmen, sumnaklady, szbdphsniz, szbdphsniz2, szbdphzakl, typpohybuk, ucetni, ulice, uuid, uvodtxt, uzptuzemsko, varsym, zamekk, zavtxt, zuctovano, danevidk, datsmir, datup1, datup2, datpenale, formauhrk, juhdat, juhdatmen, juhsum, juhsummen, juhsumpp, juhsumppmen, sumprepl, sumpreplmen, podpisprik, prikazsum, prikazsummen, stavodpocetk, stavuhrk, sumzalohy, sumzalohymen, idfirmy, idfastatu, iddphsnizucet, iddphsniz2ucet, idsazbydphzakl, idprimucet, iduziv, idtypdokl, idstaturc, iddodpodm, idkonsym, idstred, idsazbydphosv, idsazbydphsniz, idsazbydphsniz2, idrady, iddphzaklucet, idpolrady, idstatpuvod, idzakazky, idzvlpoh, idstatu, idobchtrans, idclendph, idstatodesl, idmur, idsmerkod, idstatdph, iddruhdopr, idmeny, idbanspojdod, idkrajurc, idprotiucet, idtypucop, vatid, generovatskl, zdrojproskl, hromfakt, zaokrjaksumk, zaokrnasumk, zaokrjakdphk, zaokrnadphk, dphsnizkoef, dphsniz2koef, dphzaklkoef, prodejka, stavmailk, vyloucitsaldo, zakazplatba, idbsp, idbspban, idcinnost, idsmlouvy, idtypdoklskl, idzodposoba, idkontaktosoba, idformauhradycis, idformauhradyciskasa, idformadopravy, kontaktjmeno, kontakttel, kontaktemail, ekokomk, balikpocet, balikvytvxml, balikzacislovan, dobropisovano, iddodatna, idclenkonvykdph, osobupravadph, osobupravadphdodavatel, eetpokladnizarizeni, eetprovozovna, eetdicpoverujiciho, eettypk, eetstavk, eetfik, eetpkp, eetdatcastrzby) VALUES (40, '2016-08-18 16:37:04.808000', true, null, null, null, null, null, null, null, null, '2016-09-01', null, '2016-08-18', null, '2016-08-18', null, null, '2016-08-18', '2016-08-18', null, true, null, null, null, null, null, null, null, 'VF1-0021/2016', 0.000000, 0.000000, null, 'FAV', null, 0, null, null, null, 0.00, null, null, null, false, 114.90, 0.00, 4.50, 0.00, 2.00, 0.00, 8.40, 0.00, 10.00, 0.00, 30.00, 0.00, 20.00, 0.00, 40.00, 0.00, 0.00, 15.00, 10.00, 21.00, 'typPohybu.prijem', true, null, '667ab2dbc0d295fff3cf222eb08364f3a44d68c7', null, false, '100212016', 'zamek.otevreno', null, false, null, null, null, null, null, 'formaUhr.prevod', 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, false, 0.00, 0.00, null, null, 0.00, 0.00, null, null, null, null, 23, 17, 1, 38, null, null, 1, 1, 1, 22, 24, 1, null, 1, null, null, null, null, null, 80, null, null, null, 39, null, 31, null, null, null, null, null, true, true, false, 'zaokrJak.matem', 'zaokrNa.desetiny', 'zaokrJak.nahoru', 'zaokrNa.setiny', false, false, false, false, null, false, false, null, 1, null, null, 1, 1, null, 3, null, null, null, null, null, null, 0, false, false, false, null, null, false, false, 'pokladna-1', 123, null, 'eetTyp.anoBezny', null, null, null, '2016-08-18 16:37:04.708000');
SELECT pg_catalog.setval('seq_ddoklfak', 40, true);

INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (1, '2008-09-02 09:23:02.183', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ7002051235', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('B+0001/2008'), 0.000000, 0, 'Praha 5', 'BAN', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 36283.10, 0.00, 0.00, 0.00, 0.00, 0.00, 36283.10, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '105', NULL, true, NULL, true, vratCleneniDph(1), 1, NULL, NULL, NULL, NULL, 9, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (2, '2008-09-02 09:23:14.047', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ12345678', NULL, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('B-0001/2008'), 0.000000, 0, 'Praha 13', 'BAN', 'Consul s.r.o.', NULL, NULL, '153 24', 0.00, NULL, NULL, false, 4000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 4000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '88889', NULL, true, NULL, true, vratCleneniDph(1), 1, NULL, NULL, NULL, NULL, 2, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (3, '2008-09-02 09:24:11.08', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-04'), NULL, posunDatum('2008-01-04'), 'CZ7002051235', NULL, posunDatum('2008-01-04'), posunDatum('2008-01-04'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('B+0002/2008'), 0.000000, 0, 'Praha 5', 'BAN', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 3415300.00, 0.00, 0.00, 0.00, 0.00, 0.00, 3415300.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080003', NULL, true, NULL, true, vratCleneniDph(1), 1, NULL, NULL, NULL, NULL, 9, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (4, '2008-09-02 09:40:14.536', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ12358454', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('B+0003/2008'), 0.000000, 0, 'Praha 10', 'BAN', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 2975.00, 0.00, 0.00, 0.00, 0.00, 0.00, 2975.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080002', NULL, true, NULL, true, vratCleneniDph(1), 1, NULL, NULL, NULL, NULL, 6, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (6, '2008-09-02 09:41:38.556', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ7002051235', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('B+0005/2008'), 0.000000, 0, 'Praha 5', 'BAN', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 5950.00, 0.00, 0.00, 0.00, 0.00, 0.00, 5950.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Plzeňská 65', NULL, '20080007', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 9, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (11, '2008-09-02 10:34:59.411', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ9889693', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('B-0005/2008'), 0.000000, 0, 'Mělník', 'BAN', 'Výroba kancelářských potřeb', NULL, NULL, '277 15', 0.00, NULL, NULL, false, 150000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 150000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '36451', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 13, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (12, '2008-09-02 10:40:55.846', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), 'CZ45454544', NULL, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, '45454544', posunDoklKod('B+0007/2008'), 0.000000, 0, 'Praha 3', 'BAN', 'Vysoká škola ekonomická', NULL, NULL, '130 00', 0.00, NULL, NULL, false, 746.10, 0.00, 0.00, 0.00, 0.00, 0.00, 746.10, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Nám. Winstona Churchila', NULL, '20080009', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 12, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (13, '2008-09-02 10:41:48.801', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), 'CZ74123654', NULL, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('B+0008/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'BAN', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 4284.00, 0.00, 0.00, 0.00, 0.00, 0.00, 4284.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Skladovací 45', NULL, '20080013', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 8, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (16, '2008-09-02 10:44:20.063', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), 'DE1234567', NULL, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, '1234567', posunDoklKod('B+0011/2008'), 26.050000, 1, 'Berlin', 'BAN', 'Dieter AG', NULL, NULL, '101 19', 0.00, NULL, NULL, false, 1042.00, 40.00, 0.00, 0.00, 0.00, 0.00, 1042.00, 40.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Schönhauser Allee 5', NULL, '20080019', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 4, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 11, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 147, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (5, '2008-09-02 09:40:46.547', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ12358454', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('B+0004/2008'), 0.000000, 0, 'Praha 10', 'BAN', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 6259.40, 0.00, 0.00, 0.00, 0.00, 0.00, 6259.40, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Na kopřivkách 14', NULL, '20080004', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 6, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (7, '2008-09-02 09:43:28.58', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ74123654', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('B+0006/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'BAN', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 3000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 3000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Skladovací 45', NULL, '20080011', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 8, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (8, '2008-09-02 10:17:09.945', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ985214461', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '985214461', posunDoklKod('B-0002/2008'), 0.000000, 0, 'Dobříš', 'BAN', 'Psací stroje SUPER a.s.', NULL, NULL, '263 01', 0.00, NULL, NULL, false, 230000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 230000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za poštou 1036', NULL, '89755', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 11, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (9, '2008-09-02 10:25:09.651', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ12345678', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('B-0003/2008'), 0.000000, 0, 'Praha 13', 'BAN', 'Consul s.r.o.', NULL, NULL, '153 24', 0.00, NULL, NULL, false, 24000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 24000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '47850', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 2, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (10, '2008-09-02 10:32:04', true, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-01'), NULL, posunDatum('2008-03-01'), 'CZ12345678', NULL, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('B-0004/2008'), 0.000000, 0, 'Praha 13', 'BAN', 'Consul s.r.o.', NULL, NULL, '153 24', 0.00, NULL, NULL, false, 10000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 10000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '48523', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 2, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (14, '2008-09-02 10:42:40.568', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), 'CZ74123654', NULL, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('B+0009/2008'), 0.000000, 0, 'Praha 1', 'BAN', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 9650.90, 0.00, 0.00, 0.00, 0.00, 0.00, 9650.90, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, '20080016', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 7, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (15, '2008-09-02 10:43:07.965', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), 'CZ74123654', NULL, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('B+0010/2008'), 0.000000, 0, 'Praha 1', 'BAN', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 642.60, 0.00, 0.00, 0.00, 0.00, 0.00, 642.60, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, '20080010', NULL, true, NULL, true, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 7, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 2, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 2, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (17, '2008-09-02 10:44:20.275', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-06'), NULL, posunDatum('2008-03-06'), NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDoklKod('IN0001/2008'), 0.000000, 0, NULL, 'INT', NULL, 'Kurzová ztráta (B+001108)', NULL, NULL, 0.00, NULL, NULL, false, 6.00, 0.00, 0.00, 0.00, 0.00, 0.00, 6.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.prijem', true, NULL, NULL, '20080019', NULL, true, NULL, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 11, NULL, vratTypDokl('CZ_POD_INT_KURROZ_ZTRATA'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_563001'), NULL, 11, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (18, '2008-09-02 10:47:08.309', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), 'CZ12345678', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '123456', posunDoklKod('B-0006/2008'), 0.000000, 0, 'Praha 13', 'BAN', 'Consul s.r.o.', NULL, NULL, '153 24', 0.00, NULL, NULL, false, 236.00, 0.00, 0.00, 0.00, 0.00, 0.00, 236.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'U strojovny 45', NULL, '8548', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 2, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (19, '2008-09-02 10:47:21.465', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), 'CZ9889693', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('B-0007/2008'), 0.000000, 0, 'Mělník', 'BAN', 'Výroba kancelářských potřeb', NULL, NULL, '277 15', 0.00, NULL, NULL, false, 10200.00, 0.00, 0.00, 0.00, 0.00, 0.00, 10200.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '61542', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 13, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (20, '2008-09-02 10:47:30.297', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-07'), NULL, posunDatum('2008-03-07'), 'CZ9889693', NULL, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, NULL, NULL, NULL, '9889693', posunDoklKod('B-0008/2008'), 0.000000, 0, 'Mělník', 'BAN', 'Výroba kancelářských potřeb', NULL, NULL, '277 15', 0.00, NULL, NULL, false, 40000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 40000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, 'Za svorkami 763', NULL, '48522', NULL, true, NULL, true, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, 13, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 3, NULL, vratTypDokl('CZ_POD_BAN_STD2'), (select IdBsp from dBsp where uuid = 'CZ_POD_BAN_STD2'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), NULL, 3, NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_321001'), NULL);
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (21, '2008-09-02 11:00:21.057', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-05'), NULL, posunDatum('2008-01-05'), 'CZ74123654', NULL, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('P+0001/2008'), 0.000000, 0, 'Praha 1', 'POK', 'Obchodní dům Kotva', 'zboží', NULL, '110 00', 0.00, NULL, NULL, false, 100.00, 0.00, 0.00, 0.00, 15.97, 0.00, 0.00, 0.00, 0.00, 0.00, 84.03, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, 'Revoluční 29', NULL, NULL, NULL, true, NULL, false, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, 7, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 6, NULL, vratTypDokl('CZ_POD_POK_STD'), (select IdBsp from dBsp where uuid = 'CZ_POD_POK_KC'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_604001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (22, '2008-09-02 11:09:15.739', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-05'), NULL, posunDatum('2008-01-05'), NULL, NULL, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDoklKod('P+0002/2008'), 0.000000, 0, NULL, 'POK', NULL, 'přijatá záloha', NULL, NULL, 0.00, NULL, NULL, false, 5000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 5000.00, 0.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, NULL, NULL, NULL, NULL, true, NULL, false, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 6, NULL, vratTypDokl('CZ_POD_POK_STD'), (select IdBsp from dBsp where uuid = 'CZ_POD_POK_KC'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_324001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (24, '2008-09-02 11:11:24.485', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-06'), NULL, posunDatum('2008-01-06'), NULL, NULL, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDoklKod('P-0001/2008'), 0.000000, 0, NULL, 'POK', NULL, 'Služby', NULL, NULL, 0.00, NULL, NULL, false, 450.00, 0.00, 0.00, 0.00, 71.87, 0.00, 0.00, 0.00, 0.00, 0.00, 378.13, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, NULL, NULL, '', NULL, false, NULL, false, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 7, NULL, vratTypDokl('CZ_POD_POK_STD'), (select IdBsp from dBsp where uuid = 'CZ_POD_POK_KC'), 1, 31, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, 7, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) VALUES (25, '2008-09-02 11:15:02.818', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-05'), NULL, posunDatum('2008-01-05'), NULL, NULL, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDoklKod('P+0004/2008'), 32.000000, 1, NULL, 'POK', NULL, 'dotace pokladny', NULL, NULL, 0.00, NULL, NULL, false, 1600.00, 50.00, 0.00, 0.00, 0.00, 0.00, 1600.00, 50.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.prijem', true, NULL, NULL, '', NULL, true, NULL, false, vratCleneniDph(19), 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 6, NULL, vratTypDokl('CZ_POD_POK_STD'), (select IdBsp from dBsp where uuid = 'CZ_POD_POK_EUR'), 1, 11, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, 6, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_261001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
INSERT INTO ddoklint (iddoklint, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, danevidk, sparovano, idclendph, idsazbydphosv, idzakazky, idobchtrans, idmur, idstatodesl, idfirmy, iddodpodm, idkonsym, idsazbydphzakl, idstatdph, iddruhdopr, idzvlpoh, idpolrady, idstatpuvod, idtypdokl, idbsp, iduziv, idmeny, idfastatu, idsmerkod, idbanspojdod, idstaturc, idstred, idkrajurc, idprimucet, idstatu, idrady, iddphzaklucet, idsazbydphsniz, idprotiucet, iddphsnizucet) 
VALUES (26, '2008-09-02 11:15:08.164', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-05'), NULL, posunDatum('2008-01-05'), NULL, NULL, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDoklKod('P-0002/2008'), 32.000000, 1, NULL, 'POK', NULL, 'záloha', NULL, NULL, 0.00, NULL, NULL, false, 640.00, 20.00, 0.00, 0.00, 0.00, 0.00, 640.00, 20.00, 0.00, 0.00, 0.00, 0.00, 9.00, 19.00, 'typPohybu.vydej', true, NULL, NULL, '', NULL, true, NULL, false, vratCleneniDph(18), 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, (select idstatu from astaty where uuid = 'CZ_CZ'), NULL, NULL, 7, NULL, vratTypDokl('CZ_POD_POK_STD'), (select IdBsp from dBsp where uuid = 'CZ_POD_POK_EUR'), 1, 11, NULL, NULL, NULL, NULL, 1, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, 7, (select iducet from uucty where uuid = 'CZ_POD_343021'), 6, (select iducet from uucty where uuid = 'CZ_POD_314001'), (select iducet from uucty where uuid = 'CZ_POD_343015'));
SELECT pg_catalog.setval('seq_ddoklint', 26, true);

--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (1, '2008-08-29 14:39:42.578', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ7002051235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('S-0001/2008'), 0.000000, 0, 'Praha 5', 'SKL', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Plzeňská 65', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 9, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (2, '2008-08-29 14:55:04.597', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('S-0002/2008'), 0.000000, 0, 'Praha 10', 'SKL', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Na kopřivkách 14', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, 2, NULL, NULL, 111, 6, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (3, '2008-08-29 14:57:22.18', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-03'), NULL, posunDatum('2008-01-03'), 'CZ7002051235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('S-0003/2008'), 0.000000, 0, 'Praha 5', 'SKL', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Plzeňská 65', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 9, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (4, '2008-08-29 15:32:05.874', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-09'), NULL, posunDatum('2008-01-09'), 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('S-0004/2008'), 0.000000, 0, 'Praha 10', 'SKL', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Na kopřivkách 14', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 6, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (5, '2008-08-29 15:35:13.204', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-09'), NULL, posunDatum('2008-01-09'), 'CZ777777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '777777', posunDoklKod('S-0005/2008'), 0.000000, 0, 'Praha 10 - Vršovice', 'SKL', 'Papírnictví u Pštrosa', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Moskevská 23', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 10, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (6, '2008-08-29 15:37:09.016', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-01-01'), NULL, posunDatum('2008-01-01'), 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('S-0006/2008'), 0.000000, 0, 'Praha 1', 'SKL', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Revoluční 29', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 7, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (7, '2008-08-29 16:46:47.858', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ7002051235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('S-0007/2008'), 0.000000, 0, 'Praha 5', 'SKL', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Plzeňská 65', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 9, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (8, '2008-08-29 16:47:36.603', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ45454544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '45454544', posunDoklKod('S-0008/2008'), 0.000000, 0, 'Praha 3', 'SKL', 'Vysoká škola ekonomická', NULL, NULL, '130 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Nám. Winstona Churchila', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 12, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (9, '2008-08-29 16:48:23.986', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ45454544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '45454544', posunDoklKod('S-0009/2008'), 0.000000, 0, 'Praha 3', 'SKL', 'Vysoká škola ekonomická', NULL, NULL, '130 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Nám. Winstona Churchila', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 12, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (10, '2008-08-29 16:49:01.286', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('S-0010/2008'), 0.000000, 0, 'Praha 1', 'SKL', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Revoluční 29', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 7, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (11, '2008-08-29 16:49:35.249', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('S-0011/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'SKL', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Skladovací 45', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 8, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (12, '2008-08-29 16:50:13.61', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-03'), NULL, posunDatum('2008-03-03'), 'CZ7002051235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12345678', posunDoklKod('S-0012/2008'), 0.000000, 0, 'Praha 5', 'SKL', 'Papírnictví Benda', NULL, NULL, '150 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Plzeňská 65', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 9, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (13, '2008-08-29 16:51:05.237', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-04'), NULL, posunDatum('2008-03-04'), 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('S-0013/2008'), 0.000000, 0, 'Praha 5 - Stodůlky', 'SKL', 'Sklady O.D. Kotva', NULL, NULL, '150 23', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Skladovací 45', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 8, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (14, '2008-08-29 16:51:33.766', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('S-0014/2008'), 0.000000, 0, 'Praha 10', 'SKL', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Na kopřivkách 14', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 6, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (15, '2008-08-29 17:02:20.159', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ12358454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '12358454', posunDoklKod('S-0015/2008'), 0.000000, 0, 'Praha 10', 'SKL', 'Papírnictví McPaper', NULL, NULL, '101 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Na kopřivkách 14', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 6, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (16, '2008-08-29 17:04:11.704', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'CZ74123654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '74123654', posunDoklKod('S-0016/2008'), 0.000000, 0, 'Praha 1', 'SKL', 'Obchodní dům Kotva', NULL, NULL, '110 00', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Revoluční 29', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, NULL, 111, 7, 31, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (17, '2008-08-29 17:06:54.183', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'AT845121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '84564545', posunDoklKod('S-0017/2008'), 26.200000, 1, 'Wien', 'SKL', 'ABC-Systeme GesmbH', NULL, NULL, '1200', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Brigittenauer Lände 20', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, 171, 111, 1, 11, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (18, '2008-08-29 17:18:25.615', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'HU5151214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '9999553', posunDoklKod('S-0018/2008'), 26.200000, 1, 'Budapest', 'SKL', 'Kolbáscz', NULL, NULL, '1031', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Nárony u. 6', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, 124, 111, 5, 11, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--INSERT INTO ddoklsklad (iddoklsklad, lastupdate, bezpolozek, bic, buc, cisdodak, cisdosle, cisobj, cissml, datobj, datreal, datsplat, dattermin, datucto, datuhr, datvyst, dic, doprava, duzppuv, duzpucto, eankod, faeankod, famesto, fapsc, faulice, iban, ic, kod, kurz, kurzmnozstvi, mesto, modul, nazfirmy, popis, poznam, psc, slevadokl, specsym, stavuzivk, storno, sumcelkem, sumcelkemmen, sumdphsniz, sumdphsnizmen, sumdphzakl, sumdphzaklmen, sumosv, sumosvmen, sumzklsniz, sumzklsnizmen, sumzklzakl, sumzklzaklmen, szbdphsniz, szbdphzakl, typpohybuk, ucetni, ulice, uvodtxt, varsym, zavtxt, zuctovano, idstatdph, idstatpuvod, idprotiucet, idtypdokl, idstaturc, iddodpodm, idkrajurc, idsazbydphsniz, idstred, iddphsnizucet, idbanspojdod, idstatodesl, iddphzaklucet, idmur, idpolrady, idobchtrans, idrady, idzvlpoh, idsazbydphosv, idzakazky, idsazbydphzakl, idstatu, idprimucet, idfirmy, idmeny, idfastatu, idsmerkod, idtypdoklban, iduziv, idclendph, idkonsym, iddruhdopr) VALUES (19, '2008-08-29 17:20:05.389', false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, posunDatum('2008-03-05'), NULL, posunDatum('2008-03-05'), 'DE1234567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1234567', posunDoklKod('S-0019/2008'), 26.200000, 1, 'Berlin', 'SKL', 'Dieter AG', NULL, NULL, '101 19', 0.00, NULL, NULL, false, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 'typPohybu.vydej', true, 'Schönhauser Allee 5', NULL, NULL, NULL, true, NULL, NULL, 134, vratTypDokl('CZ_POD_SKL_STD'), NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 9, NULL, 9, NULL, NULL, NULL, NULL, 147, 111, 4, 11, NULL, NULL, NULL, 1, NULL, NULL, NULL);
--SELECT pg_catalog.setval('seq_ddoklsklad', 19, true);

-- polozky dokladu
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (21, '2008-08-29 17:01:56.61', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 4, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ M C', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Consul mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 9, 11, 134, NULL, 5, NULL, NULL, 3, 15, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (2, '2008-08-29 14:39:42.572', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 4, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ SD', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 11, 13, 134, NULL, 5, NULL, NULL, 3, 1, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (1, '2008-08-29 14:40:41.592', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 3, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'SESIVACKA', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Sešívačka', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 6, 8, 134, NULL, 5, NULL, NULL, 3, 1, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (3, '2008-08-29 14:55:04.599', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 3, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 1.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 3, 4, 134, NULL, 5, NULL, 2, 3, 2, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (4, '2008-08-29 14:57:04.517', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ SD', true, false, false, true, false, false, false, false, 0, 100.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 11, 13, 134, NULL, 5, NULL, NULL, 3, 3, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (5, '2008-08-29 14:57:22.174', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ E C', true, false, false, true, false, false, false, false, 0, 300.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Consul elektrický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 8, 10, 134, NULL, 5, NULL, NULL, 3, 3, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (6, '2008-08-29 15:29:56.715', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 3, 4, 134, NULL, 5, NULL, NULL, 3, 4, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (7, '2008-08-29 15:32:05.864', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'SPONKY', true, false, false, true, false, false, false, false, 0, 20.000000, 0.000000, 0.000000, 'SKL', 'Kancelářské sponky', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 7, 9, 134, NULL, 5, NULL, NULL, 3, 4, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (8, '2008-08-29 15:34:56.875', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'VAZAC M', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Vazač listů mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 12, 14, 134, NULL, 5, NULL, NULL, 3, 5, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (9, '2008-08-29 15:35:13.197', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'SPONKY', true, false, false, true, false, false, false, false, 0, 5.000000, 0.000000, 0.000000, 'SKL', 'Kancelářské sponky', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 7, 9, 134, NULL, 5, NULL, NULL, 3, 5, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (10, '2008-08-29 15:36:56.175', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-01'), posunDatum('2008-01-01'), NULL, NULL, 'VAZAC T', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Vazač listů tepelný', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 13, 15, 134, NULL, 5, NULL, NULL, 3, 6, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (11, '2008-08-29 15:37:09.01', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-01'), posunDatum('2008-01-01'), NULL, NULL, 'MANUAL', true, false, false, true, false, false, false, false, 0, 1.000000, 0.000000, 0.000000, 'SKL', 'Náhradní manuál', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphSniz', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 5, 6, 134, NULL, 6, NULL, NULL, 3, 6, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (12, '2008-08-29 16:46:47.861', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 3, 4, 134, NULL, 5, NULL, NULL, 3, 7, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (13, '2008-08-29 16:47:36.611', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'MANUAL', true, false, false, true, false, false, false, false, 0, 5.000000, 0.000000, 0.000000, 'SKL', 'Náhradní manuál', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphSniz', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 5, 6, 134, NULL, 6, NULL, NULL, 3, 8, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (14, '2008-08-29 16:48:23.987', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DEROVACKA2', true, false, false, true, false, false, false, false, 0, 11.000000, 0.000000, 0.000000, 'SKL', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 1, 1, 134, NULL, 5, NULL, NULL, 3, 9, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (15, '2008-08-29 16:49:01.288', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'SESIVACKA', true, false, false, true, false, false, false, false, 0, 12.000000, 0.000000, 0.000000, 'SKL', 'Sešívačka', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 6, 8, 134, NULL, 5, NULL, NULL, 3, 10, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (16, '2008-08-29 16:49:35.25', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'VAZAC M', true, false, false, true, false, false, false, false, 0, 4.000000, 0.000000, 0.000000, 'SKL', 'Vazač listů mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 12, 14, 134, NULL, 5, NULL, NULL, 3, 11, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (17, '2008-08-29 16:50:13.611', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DEROVACKA2', true, false, false, true, false, false, false, false, 0, 3.000000, 0.000000, 0.000000, 'SKL', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 1, 1, 134, NULL, 5, NULL, NULL, 3, 12, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (18, '2008-08-29 16:51:05.237', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-04'), posunDatum('2008-03-04'), NULL, NULL, 'STROJ M C', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Consul mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 9, 11, 134, NULL, 5, NULL, NULL, 3, 13, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (19, '2008-08-29 16:51:33.769', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ SD', true, false, false, true, false, false, false, false, 0, 1.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 11, 13, 134, NULL, 5, NULL, NULL, 3, 14, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (20, '2008-08-29 17:01:42.947', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 3, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ E C', true, false, false, true, false, false, false, false, 0, 50.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Consul elektrický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 8, 10, 134, NULL, 5, NULL, NULL, 3, 15, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (22, '2008-08-29 17:02:20.15', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 5, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ SD', true, false, false, true, false, false, false, false, 0, 50.000000, 0.000000, 0.000000, 'SKL', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 11, 13, 134, NULL, 5, NULL, NULL, 3, 15, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (23, '2008-08-29 17:03:32.677', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 3, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DEROVACKA2', true, false, false, true, false, false, false, false, 0, 30.000000, 0.000000, 0.000000, 'SKL', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 1, 1, 134, NULL, 5, NULL, NULL, 3, 16, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (24, '2008-08-29 17:03:57.686', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 4, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DEROVACKA3', true, false, false, true, false, false, false, false, 0, 20.000000, 0.000000, 0.000000, 'SKL', 'Děrovačka se třemi otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 2, 2, 134, NULL, 5, NULL, NULL, 3, 16, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (25, '2008-08-29 17:04:11.693', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 5, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 3, 4, 134, NULL, 5, NULL, NULL, 3, 16, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (26, '2008-08-29 17:17:00.638', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 3.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 31, 1, 3, 4, 134, NULL, 1, NULL, NULL, 3, 17, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (27, '2008-08-29 17:18:53.614', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 3.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 11, 1, 3, 4, 134, NULL, 1, NULL, NULL, 3, 18, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--INSERT INTO dpolsklad (idpolsklad, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, vyrcis, zaokrjakk, zaokrnak, idzkldalucet, iddphdalucet, idmjobjem, idmeny, idstred, idkarty, idcenik, idzklmducet, iddphmducet, idsazbydph, idclendph, idzakazky, idmj, iddoklsklad, idskladu, idfirmy) VALUES (28, '2008-08-29 17:20:35.169', false, false, 0, 1.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, false, false, true, false, false, false, false, 0, 2.000000, 0.000000, 0.000000, 'SKL', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, NULL, 111, NULL, NULL, 11, 1, 3, 4, 134, NULL, 1, NULL, NULL, 3, 19, vratTypDokl('CZ_POD_SKL_STD'), NULL);
--SELECT pg_catalog.setval('seq_dpolsklad', 28, true);

INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (1, '2008-08-29 11:01:08.354', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 798.50, 0.00, 4201.50, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.3.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 1, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_119001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (2, '2008-08-29 11:05:53.381', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 159.71, 0.00, 840.29, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.3.'), 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), 2, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_518001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (3, '2008-08-29 11:08:14.935', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 37.69, 0.00, 198.31, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(2), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 3, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (4, '2008-08-29 11:09:23.93', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 36731.00, 0.00, 193269.00, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(2), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ B.2.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 4, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (5, '2008-08-29 11:13:03.345', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 980.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 5, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (6, '2008-08-29 11:14:47.354', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 24000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), NULL, NULL, 6, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (7, '2008-08-29 11:16:22.39', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 785.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 7, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (8, '2008-08-29 11:17:19.125', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 10200.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 8, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (9, '2008-08-29 11:18:35.286', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-09'), posunDatum('2008-03-09'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 68000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 9, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (10, '2008-08-29 11:19:24.699', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-09'), posunDatum('2008-03-09'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 40000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 10, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (11, '2008-08-29 11:20:30.395', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-10'), posunDatum('2008-03-10'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 10000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 11, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (12, '2008-08-29 11:21:19.771', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-10'), posunDatum('2008-03-10'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 390.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 12, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (13, '2008-08-29 11:22:13.007', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 1250.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 13, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (15, '2008-08-29 11:25:15.085', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 3000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 15, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (16, '2008-08-29 11:26:09.53', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-13'), posunDatum('2008-03-13'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 6540.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 16, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (17, '2008-08-29 11:27:14.972', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-15'), posunDatum('2008-03-15'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 250000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 17, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (18, '2008-08-29 11:27:59.427', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-15'), posunDatum('2008-03-15'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAP', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 4500.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_321001'), vratCleneniDph(18), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 18, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_501001'), NULL, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (24, '2008-08-29 13:52:19.811', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Text:    ', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 19, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (19, '2008-08-29 13:52:34.376', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Objednávka: 896663 ze dne 31.12.2005, zakázka: ZAK', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 19, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (27, '2008-08-29 14:39:42.567', false, false, 0, 1.000000, 15200.000000, 14600.000000, 0.000000, 4, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ SD', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 5776.00, 0.00, 30400.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 19, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 13, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (26, '2008-08-29 14:40:41.591', true, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9992, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAV', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.09, 0.00, -0.10, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 19, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (25, '2008-08-29 14:40:41.592', false, false, 0, 1.000000, 45.000000, 23.000000, 0.000000, 3, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'SESIVACKA', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Sešívačka', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 17.11, 0.00, 90.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 19, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 8, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (28, '2008-08-29 14:52:57.732', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Objednávka: 12345 ze dne 02.01.2005, zakázka: 111888', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (29, '2008-08-29 14:53:22.289', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Text:   ', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (30, '2008-08-29 14:55:04.602', false, false, 0, 1.000000, 2500.000000, 1230.000000, 0.000000, 3, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 1.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 475.00, 0.00, 2500.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), 2, (select iducet from uucty where uuid = 'CZ_POD_311001'), 20, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (31, '2008-08-29 14:57:04.519', false, false, 0, 1.000000, 15200.000000, 14600.000000, 0.000000, 1, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ SD', true, true, true, true, true, true, true, true, 0, 100.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 288800.00, 0.00, 1520000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 21, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 13, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (32, '2008-08-29 14:57:22.172', false, false, 0, 1.000000, 4500.000000, 3256.300000, 0.000000, 2, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, 'STROJ E C', true, true, true, true, true, true, true, true, 0, 300.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Consul elektrický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 256500.00, 0.00, 1350000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 21, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 10, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (33, '2008-08-29 15:29:56.718', false, false, 0, 1.000000, 2500.000000, 1230.000000, 0.000000, 1, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 950.00, 0.00, 5000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 22, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (34, '2008-08-29 15:32:05.861', false, false, 0, 1.000000, 13.000000, 12.300000, 0.000000, 2, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'SPONKY', true, true, true, true, true, true, true, true, 0, 20.000000, 0.000000, 0.000000, 'FAV', 'Kancelářské sponky', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 49.40, 0.00, 260.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 22, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 9, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (35, '2008-08-29 15:34:56.878', false, false, 0, 1.000000, 1500.000000, 820.000000, 0.000000, 1, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'VAZAC M', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Vazač listů mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 570.00, 0.00, 3000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 23, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 14, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (36, '2008-08-29 15:35:13.192', false, false, 0, 1.000000, 13.000000, 12.300000, 0.000000, 2, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, 'SPONKY', true, true, true, true, true, true, true, true, 0, 5.000000, 0.000000, 0.000000, 'FAV', 'Kancelářské sponky', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 12.35, 0.00, 65.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 23, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 9, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (37, '2008-08-29 15:35:13.196', true, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9992, posunDatum('2008-01-09'), posunDatum('2008-01-09'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAV', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.05, 0.00, 0.00, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 23, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (38, '2008-08-29 15:36:56.178', false, false, 0, 1.000000, 2000.000000, 1200.000000, 0.000000, 1, posunDatum('2008-01-01'), posunDatum('2008-01-01'), NULL, NULL, 'VAZAC T', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Vazač listů tepelný', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 760.00, 0.00, 4000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 24, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 15, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (39, '2008-08-29 15:37:09.007', false, false, 0, 1.000000, 300.000000, 250.000000, 0.000000, 2, posunDatum('2008-01-01'), posunDatum('2008-01-01'), NULL, NULL, 'MANUAL', true, true, true, true, true, true, true, true, 0, 1.000000, 0.000000, 0.000000, 'FAV', 'Náhradní manuál', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 27.00, 0.00, 300.00, 0.00, 9.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphSniz', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 24, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 6, (select iducet from uucty where uuid = 'CZ_POD_343015'), 6, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (40, '2008-08-29 16:46:47.864', false, false, 0, 1.000000, 2500.000000, 1230.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 950.00, 0.00, 5000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 25, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (41, '2008-08-29 16:47:36.617', false, false, 0, 1.000000, 300.000000, 250.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'MANUAL', true, true, true, true, true, true, true, true, 0, 5.000000, 0.000000, 0.000000, 'FAV', 'Náhradní manuál', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 135.00, 0.00, 1500.00, 0.00, 9.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphSniz', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31,(select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 26, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 6, (select iducet from uucty where uuid = 'CZ_POD_343015'), 6, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (42, '2008-08-29 16:48:23.994', false, false, 0, 1.000000, 57.000000, 38.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DEROVACKA2', true, true, true, true, true, true, true, true, 0, 11.000000, 0.000000, 0.000000, 'FAV', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 119.13, 0.00, 627.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 27, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (43, '2008-08-29 16:48:23.996', true, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9992, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAV', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.07, 0.00, -0.10, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 27, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (44, '2008-08-29 16:49:01.29', false, false, 0, 1.000000, 45.000000, 23.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'SESIVACKA', true, true, true, true, true, true, true, true, 0, 12.000000, 0.000000, 0.000000, 'FAV', 'Sešívačka', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 102.60, 0.00, 540.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 28, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 8, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (45, '2008-08-29 16:49:35.253', false, false, 0, 1.000000, 1500.000000, 820.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'VAZAC M', true, true, true, true, true, true, true, true, 0, 4.000000, 0.000000, 0.000000, 'FAV', 'Vazač listů mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 1140.00, 0.00, 6000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 29, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 14, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (46, '2008-08-29 16:50:13.613', false, false, 0, 1.000000, 57.000000, 38.000000, 0.000000, 1, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, 'DEROVACKA2', true, true, true, true, true, true, true, true, 0, 3.000000, 0.000000, 0.000000, 'FAV', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 32.49, 0.00, 171.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 30, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (47, '2008-08-29 16:50:13.616', true, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9992, posunDatum('2008-03-03'), posunDatum('2008-03-03'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAV', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.01, 0.00, 0.00, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 30, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (48, '2008-08-29 16:51:05.237', false, false, 0, 1.000000, 1800.000000, 1000.000000, 0.000000, 1, posunDatum('2008-03-04'), posunDatum('2008-03-04'), NULL, NULL, 'STROJ M C', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Consul mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 684.00, 0.00, 3600.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 31, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 11, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (49, '2008-08-29 16:51:33.771', false, false, 0, 1.000000, 15200.000000, 14600.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ SD', true, true, true, true, true, true, true, true, 0, 1.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 2888.00, 0.00, 15200.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 32, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 13, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (50, '2008-08-29 16:52:41.541', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Objednávka: ze dne , Zakázka:', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 33, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (53, '2008-08-29 17:01:56.608', false, false, 0, 1.000000, 1800.000000, 1000.000000, 0.000000, 4, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ M C', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Consul mechanický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 684.00, 0.00, 3600.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 33, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 11, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (51, '2008-08-29 17:01:24.084', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Text:     ', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 33, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (52, '2008-08-29 17:01:42.95', false, false, 0, 1.000000, 4500.000000, 3256.300000, 0.000000, 3, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ E C', true, true, true, true, true, true, true, true, 0, 50.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Consul elektrický', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 42750.00, 0.00, 225000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 33, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 10, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (54, '2008-08-29 17:02:20.147', false, false, 0, 1.000000, 15200.000000, 14600.000000, 0.000000, 5, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'STROJ SD', true, true, true, true, true, true, true, true, 0, 50.000000, 0.000000, 0.000000, 'FAV', 'Psací stroj Super elektrický s pamětí a displayem', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 144400.00, 0.00, 760000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.4.0'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 33, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 13, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (55, '2008-08-29 17:03:01.485', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Objednávka: ze dne , Zakázka:', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 34, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (56, '2008-08-29 17:03:12.868', false, false, 0, 0.000000, 0.000000, 0.000000, 0.000000, 2, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, NULL, false, false, false, false, false, false, false, false, 0, 0.000000, 0.000000, 0.000000, 'FAV', 'Text:    ', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 0.00, 0.00, 0.00, NULL, 'typPolozky.text', NULL, NULL, false, false, NULL, NULL, NULL, 31, NULL, NULL, NULL, NULL, 34, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (57, '2008-08-29 17:03:32.681', false, false, 0, 1.000000, 57.000000, 38.000000, 0.000000, 3, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DEROVACKA2', true, true, true, true, true, true, true, true, 0, 30.000000, 0.000000, 0.000000, 'FAV', 'Děrovačka se dvěma otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 324.90, 0.00, 1710.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 34, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (58, '2008-08-29 17:03:57.684', false, false, 0, 1.000000, 70.000000, 40.000000, 0.000000, 4, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DEROVACKA3', true, true, true, true, true, true, true, true, 0, 20.000000, 0.000000, 0.000000, 'FAV', 'Děrovačka se třemi otvory', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 266.00, 0.00, 1400.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 34, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 2, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (59, '2008-08-29 17:04:11.69', false, false, 0, 1.000000, 2500.000000, 1230.000000, 0.000000, 5, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 950.00, 0.00, 5000.00, 0.00, 19.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphZakl', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 31, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 34, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, (select iducet from uucty where uuid = 'CZ_POD_343021'), 5, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (60, '2008-08-29 17:17:19.315', false, false, 0, 1.000000, 96.000000, 1230.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 3.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 7545.60, 288.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 11, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 35, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (61, '2008-08-29 17:18:53.614', false, false, 0, 1.000000, 97.500000, 1230.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 3.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 7663.50, 292.50, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 11, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ A.5.'), NULL, NULL, 36, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (63, '2008-08-29 17:20:35.169', false, false, 0, 1.000000, 20.000000, 1230.000000, 0.000000, 1, posunDatum('2008-03-05'), posunDatum('2008-03-05'), NULL, NULL, 'DRTICPAP025', true, true, true, true, true, true, true, true, 0, 2.000000, 0.000000, 0.000000, 'FAV', 'Skartovačka papíru 5list.', NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 1048.00, 40.00, 0.00, 'typCeny.bezDph', 'typPolozky.katalog', 'typSzbDph.dphOsv', 'typVypCeny.marze', true, true, 'zaokrJak.matem', 'zaokrNa.setiny', 1, 11, (select iducet from uucty where uuid = 'CZ_POD_604001'), vratCleneniDph(1), NULL, NULL, 37, 3, (select IdBsp from dBsp where uuid = 'CZ_POD_SKL_STD'), NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, NULL, 1, NULL);
INSERT INTO dpolfak (idpolfak, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idstred, idmeny, idzkldalucet, idclendph, idclenkonvykdph, idzakazky, iddphmducet, iddoklfak, idmj, idbspskl, idfirmy, idzklmducet, idcenik, iddphdalucet, idsazbydph, idmjobjem) VALUES (64, '2008-08-29 17:21:48.762', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, NULL, posunDatum('2008-03-05'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'FAV', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 20218.10, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, false, false, NULL, NULL, 1, 31, NULL, vratCleneniDph(19), (select idclenkonvykdph from uclenkonvykdph where uuid = 'CZ 0.0.'), NULL, NULL, 38, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL);
SELECT pg_catalog.setval('seq_dpolfak', 96, true);

INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (1, '2008-09-01 17:06:51.535', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 36283.10, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 1, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (2, '2008-09-01 17:27:49.536', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-03'), posunDatum('2008-01-03'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 4000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 2, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (3, '2008-09-02 09:22:46.126', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-04'), posunDatum('2008-01-04'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 3415300.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 3, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (4, '2008-09-02 09:39:15.726', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 2975.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 4, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (5, '2008-09-02 09:39:21.836', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 6259.40, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 5, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (6, '2008-09-02 09:39:29.748', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 5950.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 6, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (7, '2008-09-02 09:39:34.933', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 3000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL,(select iducet from uucty where uuid = 'CZ_POD_311001'), 7, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (8, '2008-09-02 09:39:41.475', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 230000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 8, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (9, '2008-09-02 09:39:49.166', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 24000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 9, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (10, '2008-09-02 09:39:54.282', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 10000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 10, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (11, '2008-09-02 09:39:58.413', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-01'), posunDatum('2008-03-01'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 150000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 11, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (13, '2008-09-02 10:37:36.618', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 4284.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 13, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (14, '2008-09-02 10:38:00.364', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 9650.90, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 14, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (15, '2008-09-02 10:38:25.809', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 642.60, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 15, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (16, '2008-09-02 10:39:35.671', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 1042.00, 40.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 16, NULL, NULL, vratCleneniDph(19), 11, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (12, '2008-09-02 10:40:37.922', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 746.10, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 12, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (17, '2008-09-02 10:44:20.277', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-06'), posunDatum('2008-03-06'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'INT', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 6.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_563001'), NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_311001'), 17, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (20, '2008-09-02 10:46:30.437', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 40000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 20, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (19, '2008-09-02 10:46:37.266', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 10200.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 19, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (18, '2008-09-02 10:46:39.933', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-03-07'), posunDatum('2008-03-07'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'BAN', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 236.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_321001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_221001'), 18, NULL, NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (21, '2008-09-02 11:00:21.061', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'POK', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 15.97, 0.00, 84.03, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), 5, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, (select iducet from uucty where uuid = 'CZ_POD_604001'), 21, (select iducet from uucty where uuid = 'CZ_POD_343021'), NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (22, '2008-09-02 11:09:15.742', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'POK', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 5000.00, 0.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_324001'), 22, NULL, NULL, vratCleneniDph(19), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (24, '2008-09-02 11:11:24.487', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9993, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, NULL, NULL, true, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'POK', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 71.87, 0.00, 378.13, 0.00, 19.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphZakl', NULL, true, false, NULL, NULL, NULL, 5, (select iducet from uucty where uuid = 'CZ_POD_343021'), NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), 24, (select iducet from uucty where uuid = 'CZ_POD_211001'), NULL, vratCleneniDph(18), 31, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (25, '2008-09-02 11:12:15.475', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'POK', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 1600.00, 50.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_261001'), 25, NULL, NULL, vratCleneniDph(19), 11, NULL, NULL, NULL, 1, NULL);
INSERT INTO dpolint (idpolint, lastupdate, autozaokr, autogen, baleniid, cenjednotka, cenamj, cenamjnakup, cenamjprodej, cisrad, datucto, datvyst, eankod, expirace, kod, kopclendph, kopdphdalucet, kopdphmducet, kopklice, kopstred, kopzakazku, kopzkldalucet, kopzklmducet, mnozbaleni, mnozmj, mnozmjplan, mnozmjreal, modul, nazev, objednatk, objem, poznam, proczakl, rezervovat, sarze, slevadokl, slevamnoz, slevapol, stavuzivk, storno, stornopol, sumdph, sumdphmen, sumzkl, sumzklmen, szbdph, typcenydphk, typpolozkyk, typszbdphk, typvypcenyk, ucetni, uplslevadokl, zaokrjakk, zaokrnak, idzklmducet, idsazbydph, iddphmducet, idmj, idzkldalucet, iddoklint, iddphdalucet, idbspskl, idclendph, idmeny, idzakazky, idmjobjem, idfirmy, idstred, idcenik) VALUES (26, '2008-09-02 11:12:51.993', false, true, 0, 0.000000, 0.000000, 0.000000, 0.000000, 9991, posunDatum('2008-01-05'), posunDatum('2008-01-05'), NULL, NULL, NULL, false, true, true, true, true, true, true, true, 0, 0.000000, 0.000000, 0.000000, 'POK', NULL, NULL, 0.000000, NULL, 0.000000, false, NULL, 0.00, 0.00, 0.00, NULL, false, false, 0.00, 0.00, 640.00, 20.00, 0.00, NULL, 'typPolozky.ucetni', 'typSzbDph.dphOsv', NULL, true, false, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_314001'), 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_211001'), 26, NULL, NULL, vratCleneniDph(18), 11, NULL, NULL, NULL, 1, NULL);
SELECT pg_catalog.setval('seq_dpolint', 26, true);




-- aktualizace ciselnych rad
UPDATE dradyrok SET cisakt = 20 WHERE idradyrok = 1;
UPDATE dradyrok SET cisakt = 18 WHERE idradyrok = 5;
UPDATE dradyrok SET cisakt = 4  WHERE idradyrok = 6;
UPDATE dradyrok SET cisakt = 2  WHERE idradyrok = 7;
UPDATE dradyrok SET cisakt = 11 WHERE idradyrok = 2;
UPDATE dradyrok SET cisakt = 8  WHERE idradyrok = 3;
UPDATE dradyrok SET cisakt = 19 WHERE idradyrok = 9;

--INSERT INTO dradydiry (idradydiry, lastupdate, cisdira, idradyrok) VALUES (87, '2008-09-02 10:48:53.443', 'PF0014/08', 5);
--SELECT pg_catalog.setval('seq_dradydiry', 97, true);
INSERT INTO dradydiry (lastupdate, cisdira, idradyrok) VALUES ('2008-09-02 10:48:53.443', posunDoklKod('PF0014/2008'), 5);

-- vazby mezi doklady

--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 19, 1, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 25, 1, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 27, 2, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 20, 2, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 30, 3, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 21, 3, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 31, 4, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 32, 5, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 22, 4, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 33, 6, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 34, 7, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 23, 5, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 35, 8, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 36, 9, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 24, 6, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 38, 10, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 39, 11, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 25, 7, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 40, 12, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 26, 8, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 41, 13, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 27, 9, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 42, 14, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 28, 10, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 44, 15, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 29, 11, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 45, 16, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 30, 12, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 46, 17, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 31, 13, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 48, 18, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 32, 14, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 49, 19, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 33, 15, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 52, 20, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 53, 21, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 54, 22, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 34, 16, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 57, 23, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 58, 24, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 59, 25, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 35, 17, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 60, 26, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 36, 18, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 61, 27, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 37, 19, 'FAV', 'SKL', false, 'typVazbyDokl.hlavaSkl');
--INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 63, 28, 'FAV', 'SKL', false, 'typVazbyDokl.polozkaSkl');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (36283.10, 19, 1, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (4000.00, 1, 2, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (3415300.00, 21, 3, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (2975.00, 20, 4, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (6259.40, 22, 5, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (5950.00, 25, 6, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (3000.00, 29, 7, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (230000.00, 4, 8, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (24000.00, 6, 9, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (10000.00, 11, 10, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (150000.00, 17, 11, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (746.10, 27, 12, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (4284.00, 31, 13, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (9650.90, 34, 14, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (642.60, 28, 15, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (40.00, 37, 16, 'FAV', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 37, 17, 'FAV', 'INT', false, 'typVazbyDokl.uhradaKR');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (0.00, 16, 17, 'BAN', 'INT', false, 'typVazbyDokl.KR');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (236.00, 3, 18, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (10200.00, 8, 19, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
INSERT INTO dvazebtab (castka, idtaba, idtabb, modula, modulb, storno, typvazbyk) VALUES (40000.00, 10, 20, 'FAP', 'BAN', false, 'typVazbyDokl.uhrada');
--SELECT pg_catalog.setval('seq_dvazebtab', 68, true);

-- MAJETEK

INSERT INTO mtypmaj (idtypmaj, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, druhk, jeodpis, idodpucet, idopravucet, idprotiucetzar, iducetobdobido, idstred, iducetobdobiod, idzakazky, idprimucet) VALUES (100, '2008-09-01 16:22:07.986', 'AUTA', 'Auta', NULL, NULL, NULL, NULL, NULL, true, 'druhMaj.hmDl', true, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_042001'), NULL, 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
INSERT INTO mtypmaj (idtypmaj, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, druhk, jeodpis, idodpucet, idopravucet, idprotiucetzar, iducetobdobido, idstred, iducetobdobiod, idzakazky, idprimucet) VALUES (101, '2008-09-01 16:32:15.432', 'PC', 'Počítače', NULL, NULL, NULL, NULL, NULL, true, 'druhMaj.hmDl', true, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_042001'), NULL, 1, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
SELECT pg_catalog.setval('seq_mtypmaj', 101, true);

INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (1, '2008-09-01 14:49:15.877', 'STŮL1', 'Stůl psací', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 5357.00, NULL, posunDatum('2008-01-30'), NULL, NULL, NULL, NULL, posunDatum('2008-01-30'), 'druhMaj.neodepis', NULL, 1, NULL, NULL, 0.00, 0, 0, false, NULL, false, 0, 'zpusobOdp.zar100', NULL, 5357.00, 5357.00, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (2, '2008-09-01 15:12:33.164', 'ŽIDLE1', 'Židle kancelářská otočná', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 2750.00, NULL, posunDatum('2008-01-30'), NULL, NULL, NULL, NULL, posunDatum('2008-01-30'), 'druhMaj.neodepis', NULL, 1, NULL, NULL, 0.00, 0, 0, false, NULL, false, 0, NULL, NULL, 2750.00, 2750.00, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (3, '2008-09-01 16:22:25.525', 'AUTA1', 'Škoda OCTAVIA', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 600000.00, '1/08', posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, posunDatum('2008-02-01'), posunDatum('2008-02-01'), posunDatum('2008-01-06'), 'druhMaj.hmDl', NULL, 1, NULL, 'nahrUcet.aPocMes', 36.00, 0, 0, false, NULL, false, 0, 'typOdp.rovn', NULL, 600000.00, 600000.00, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 100, (select iducet from uucty where uuid = 'CZ_POD_022001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), NULL, NULL, 3, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (4, '2008-09-01 16:27:22.155', 'AUTA2', 'Škoda FABIA', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 350000.00, NULL, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, posunDatum('2008-02-01'), posunDatum('2008-02-01'), posunDatum('2008-01-06'), 'druhMaj.hmDl', NULL, 1, NULL, 'nahrUcet.aPocMes', 36.00, 0, 0, false, NULL, false, 0, 'typOdp.rovn', NULL, 350000.00, 350000.00, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 100, (select iducet from uucty where uuid = 'CZ_POD_022001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), NULL, NULL, 3, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (5, '2008-09-01 16:36:37.268', 'PC1', 'Notebook ACER', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 120000.00, NULL, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, posunDatum('2008-02-01'), posunDatum('2008-02-01'), posunDatum('2008-01-06'), 'druhMaj.hmDl', NULL, 1, NULL, 'nahrUcet.aPocMes', 36.00, 0, 0, false, NULL, false, 0, 'typOdp.rovn', NULL, 120000.00, 120000.00, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 101, (select iducet from uucty where uuid = 'CZ_POD_022001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), NULL, NULL, 3, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (6, '2008-09-01 16:39:16.662', 'PC2', 'Server IBM', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 80000.00, NULL, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, posunDatum('2008-02-01'), posunDatum('2008-02-01'), posunDatum('2008-01-06'), 'druhMaj.hmDl', NULL, 1, NULL, 'nahrUcet.aPocMes', 36.00, 0, 0, false, NULL, false, 0, 'typOdp.rovn', NULL, 80000.00, 80000.00, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 101, (select iducet from uucty where uuid = 'CZ_POD_022001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), NULL, NULL, 3, NULL);
INSERT INTO mmajetek (idmajetku, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cena, cidporiz, datkoupe, datudalzar, datvyroby, datzacdan, datzacucet, datzar, druhk, eankod, kusysoubor, mjzarukyk, nahrucetodpk, predpisucetodp, staripor, staritechzhod, techzhod, vyrcis, zamek, zaruka, zpusodpk, zpuspor, zustdan, zustucet, zvyszrychk, idfirmydod, idfirmyvyr, idodpucet, idzakazky, iddoklfak, idprotiucetzar, idstred, idtypmaj, idprimucet, idopravucet, idumismist, idumissekce, idsazby, idumisobj) VALUES (7, '2008-09-01 16:40:41.955', 'PC3', 'Laserová tiskárna HP', NULL, NULL, NULL, NULL, NULL, true, 9999, 0, 55000.00, NULL, posunDatum('2008-01-06'), posunDatum('2008-01-06'), NULL, posunDatum('2008-02-01'), posunDatum('2008-02-01'), posunDatum('2008-01-06'), 'druhMaj.hmDl', NULL, 1, NULL, 'nahrUcet.aPocMes', 36.00, 0, 0, false, NULL, false, 0, 'typOdp.rovn', NULL, 55000.00, 55000.00, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 101, (select iducet from uucty where uuid = 'CZ_POD_022001'), (select iducet from uucty where uuid = 'CZ_POD_082001'), NULL, NULL, 3, NULL);
SELECT pg_catalog.setval('seq_mmajetek', 7, true);

INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (4, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1, 120000.00, false, false, false, 480000.00, 1, 3, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (5, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2, 240000.00, false, false, false, 240000.00, 1, 3, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (6, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3, 240000.00, false, false, false, 0.00, 1, 3, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (7, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1, 70000.00, false, false, false, 280000.00, 1, 4, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (8, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2, 140000.00, false, false, false, 140000.00, 1, 4, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (9, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3, 140000.00, false, false, false, 0.00, 1, 4, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (10, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1, 24000.00, false, false, false, 96000.00, 1, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (11, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2, 48000.00, false, false, false, 48000.00, 1, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (12, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3, 48000.00, false, false, false, 0.00, 1, 5, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (13, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1, 16000.00, false, false, false, 64000.00, 1, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (14, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2, 32000.00, false, false, false, 32000.00, 1, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (15, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3, 32000.00, false, false, false, 0.00, 1, 6, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (16, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1, 11000.00, false, false, false, 44000.00, 1, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (17, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2, 22000.00, false, false, false, 22000.00, 1, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
INSERT INTO mdanodpisy (iddanodpisu, datucto, datvyst, kod, modul, poznam, starimaj, sumzkl, ucetni, zamek, zmena, zustpoodp, idstred, idmajetku, idzakazky, idzklmducet, idzkldalucet) VALUES (18, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3, 22000.00, false, false, false, 0.00, 1, 7, NULL, (select iducet from uucty where uuid = 'CZ_POD_551001'), (select iducet from uucty where uuid = 'CZ_POD_082001'));
SELECT pg_catalog.setval('seq_mdanodpisy', 18, true);

INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (37, posunDatum('2008-01-31'), posunDatum('2008-01-31'), vytvorKod(posunDatum('20080131')), 'MAJ', NULL, 16667.00, true, false, false, 583333.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (38, posunDatum('2008-02-29'), posunDatum('2008-02-29'), vytvorKod(posunDatum('20080229')), 'MAJ', NULL, 16667.00, true, false, false, 566666.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (39, posunDatum('2008-03-31'), posunDatum('2008-03-31'), vytvorKod(posunDatum('20080331')), 'MAJ', NULL, 16667.00, true, false, false, 549999.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (40, posunDatum('2008-04-30'), posunDatum('2008-04-30'), vytvorKod(posunDatum('20080430')), 'MAJ', NULL, 16667.00, true, false, false, 533332.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (41, posunDatum('2008-05-31'), posunDatum('2008-05-31'), vytvorKod(posunDatum('20080531')), 'MAJ', NULL, 16667.00, true, false, false, 516665.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (42, posunDatum('2008-06-30'), posunDatum('2008-06-30'), vytvorKod(posunDatum('20080630')), 'MAJ', NULL, 16667.00, true, false, false, 499998.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (43, posunDatum('2008-07-31'), posunDatum('2008-07-31'), vytvorKod(posunDatum('20080731')), 'MAJ', NULL, 16667.00, true, false, false, 483331.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (44, posunDatum('2008-08-31'), posunDatum('2008-08-31'), vytvorKod(posunDatum('20080831')), 'MAJ', NULL, 16667.00, true, false, false, 466664.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (45, posunDatum('2008-09-30'), posunDatum('2008-09-30'), vytvorKod(posunDatum('20080930')), 'MAJ', NULL, 16667.00, true, false, false, 449997.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (46, posunDatum('2008-10-31'), posunDatum('2008-10-31'), vytvorKod(posunDatum('20081031')), 'MAJ', NULL, 16667.00, true, false, false, 433330.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (47, posunDatum('2008-11-30'), posunDatum('2008-11-30'), vytvorKod(posunDatum('20081130')), 'MAJ', NULL, 16667.00, true, false, false, 416663.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (48, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 16667.00, true, false, false, 399996.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (49, NULL, posunDatum('2009-01-31'), vytvorKod(posunDatum('20090131')), 'MAJ', NULL, 16667.00, true, false, false, 383329.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (50, NULL, posunDatum('2009-02-28'), vytvorKod(posunDatum('20090228')), 'MAJ', NULL, 16667.00, true, false, false, 366662.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (51, NULL, posunDatum('2009-03-31'), vytvorKod(posunDatum('20090331')), 'MAJ', NULL, 16667.00, true, false, false, 349995.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (52, NULL, posunDatum('2009-04-30'), vytvorKod(posunDatum('20090430')), 'MAJ', NULL, 16667.00, true, false, false, 333328.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (53, NULL, posunDatum('2009-05-31'), vytvorKod(posunDatum('20090531')), 'MAJ', NULL, 16667.00, true, false, false, 316661.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (54, NULL, posunDatum('2009-06-30'), vytvorKod(posunDatum('20090630')), 'MAJ', NULL, 16667.00, true, false, false, 299994.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (55, NULL, posunDatum('2009-07-31'), vytvorKod(posunDatum('20090731')), 'MAJ', NULL, 16667.00, true, false, false, 283327.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (56, NULL, posunDatum('2009-08-31'), vytvorKod(posunDatum('20090831')), 'MAJ', NULL, 16667.00, true, false, false, 266660.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (57, NULL, posunDatum('2009-09-30'), vytvorKod(posunDatum('20090930')), 'MAJ', NULL, 16667.00, true, false, false, 249993.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (58, NULL, posunDatum('2009-10-31'), vytvorKod(posunDatum('20091031')), 'MAJ', NULL, 16667.00, true, false, false, 233326.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (59, NULL, posunDatum('2009-11-30'), vytvorKod(posunDatum('20091130')), 'MAJ', NULL, 16667.00, true, false, false, 216659.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (60, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 16667.00, true, false, false, 199992.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (61, NULL, posunDatum('2010-01-31'), vytvorKod(posunDatum('20100131')), 'MAJ', NULL, 16667.00, true, false, false, 183325.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (62, NULL, posunDatum('2010-02-28'), vytvorKod(posunDatum('20100228')), 'MAJ', NULL, 16667.00, true, false, false, 166658.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (63, NULL, posunDatum('2010-03-31'), vytvorKod(posunDatum('20100331')), 'MAJ', NULL, 16667.00, true, false, false, 149991.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (64, NULL, posunDatum('2010-04-30'), vytvorKod(posunDatum('20100430')), 'MAJ', NULL, 16667.00, true, false, false, 133324.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (65, NULL, posunDatum('2010-05-31'), vytvorKod(posunDatum('20100531')), 'MAJ', NULL, 16667.00, true, false, false, 116657.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (66, NULL, posunDatum('2010-06-30'), vytvorKod(posunDatum('20100630')), 'MAJ', NULL, 16667.00, true, false, false, 99990.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (67, NULL, posunDatum('2010-07-31'), vytvorKod(posunDatum('20100731')), 'MAJ', NULL, 16667.00, true, false, false, 83323.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (68, NULL, posunDatum('2010-08-31'), vytvorKod(posunDatum('20100831')), 'MAJ', NULL, 16667.00, true, false, false, 66656.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (69, NULL, posunDatum('2010-09-30'), vytvorKod(posunDatum('20100930')), 'MAJ', NULL, 16667.00, true, false, false, 49989.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (70, NULL, posunDatum('2010-10-31'), vytvorKod(posunDatum('20101031')), 'MAJ', NULL, 16667.00, true, false, false, 33322.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (71, NULL, posunDatum('2010-11-30'), vytvorKod(posunDatum('20101130')), 'MAJ', NULL, 16667.00, true, false, false, 16655.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (72, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 16655.00, true, false, false, 0.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 3, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (73, posunDatum('2008-01-31'), posunDatum('2008-01-31'), vytvorKod(posunDatum('20080131')), 'MAJ', NULL, 9723.00, true, false, false, 340277.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (74, posunDatum('2008-02-29'), posunDatum('2008-02-29'), vytvorKod(posunDatum('20080229')), 'MAJ', NULL, 9723.00, true, false, false, 330554.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (75, posunDatum('2008-03-31'), posunDatum('2008-03-31'), vytvorKod(posunDatum('20080331')), 'MAJ', NULL, 9723.00, true, false, false, 320831.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (76, posunDatum('2008-04-30'), posunDatum('2008-04-30'), vytvorKod(posunDatum('20080430')), 'MAJ', NULL, 9723.00, true, false, false, 311108.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (77, posunDatum('2008-05-31'), posunDatum('2008-05-31'), vytvorKod(posunDatum('20080531')), 'MAJ', NULL, 9723.00, true, false, false, 301385.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (78, posunDatum('2008-06-30'), posunDatum('2008-06-30'), vytvorKod(posunDatum('20080630')), 'MAJ', NULL, 9723.00, true, false, false, 291662.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (79, posunDatum('2008-07-31'), posunDatum('2008-07-31'), vytvorKod(posunDatum('20080731')), 'MAJ', NULL, 9723.00, true, false, false, 281939.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (80, posunDatum('2008-08-31'), posunDatum('2008-08-31'), vytvorKod(posunDatum('20080831')), 'MAJ', NULL, 9723.00, true, false, false, 272216.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (81, posunDatum('2008-09-30'), posunDatum('2008-09-30'), vytvorKod(posunDatum('20080930')), 'MAJ', NULL, 9723.00, true, false, false, 262493.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (82, posunDatum('2008-10-31'), posunDatum('2008-10-31'), vytvorKod(posunDatum('20081031')), 'MAJ', NULL, 9723.00, true, false, false, 252770.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (83, posunDatum('2008-11-30'), posunDatum('2008-11-30'), vytvorKod(posunDatum('20081130')), 'MAJ', NULL, 9723.00, true, false, false, 243047.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (84, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 9723.00, true, false, false, 233324.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (85, NULL, posunDatum('2009-01-31'), vytvorKod(posunDatum('20090131')), 'MAJ', NULL, 9723.00, true, false, false, 223601.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (86, NULL, posunDatum('2009-02-28'), vytvorKod(posunDatum('20090228')), 'MAJ', NULL, 9723.00, true, false, false, 213878.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (87, NULL, posunDatum('2009-03-31'), vytvorKod(posunDatum('20090331')), 'MAJ', NULL, 9723.00, true, false, false, 204155.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (88, NULL, posunDatum('2009-04-30'), vytvorKod(posunDatum('20090430')), 'MAJ', NULL, 9723.00, true, false, false, 194432.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (89, NULL, posunDatum('2009-05-31'), vytvorKod(posunDatum('20090531')), 'MAJ', NULL, 9723.00, true, false, false, 184709.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (90, NULL, posunDatum('2009-06-30'), vytvorKod(posunDatum('20090630')), 'MAJ', NULL, 9723.00, true, false, false, 174986.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (91, NULL, posunDatum('2009-07-31'), vytvorKod(posunDatum('20090731')), 'MAJ', NULL, 9723.00, true, false, false, 165263.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (92, NULL, posunDatum('2009-08-31'), vytvorKod(posunDatum('20090831')), 'MAJ', NULL, 9723.00, true, false, false, 155540.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (93, NULL, posunDatum('2009-09-30'), vytvorKod(posunDatum('20090930')), 'MAJ', NULL, 9723.00, true, false, false, 145817.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (94, NULL, posunDatum('2009-10-31'), vytvorKod(posunDatum('20091031')), 'MAJ', NULL, 9723.00, true, false, false, 136094.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (95, NULL, posunDatum('2009-11-30'), vytvorKod(posunDatum('20091130')), 'MAJ', NULL, 9723.00, true, false, false, 126371.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (96, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 9723.00, true, false, false, 116648.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (97, NULL, posunDatum('2010-01-31'), vytvorKod(posunDatum('20100131')), 'MAJ', NULL, 9723.00, true, false, false, 106925.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (98, NULL, posunDatum('2010-02-28'), vytvorKod(posunDatum('20100228')), 'MAJ', NULL, 9723.00, true, false, false, 97202.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (99, NULL, posunDatum('2010-03-31'), vytvorKod(posunDatum('20100331')), 'MAJ', NULL, 9723.00, true, false, false, 87479.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (100, NULL, posunDatum('2010-04-30'), vytvorKod(posunDatum('20100430')), 'MAJ', NULL, 9723.00, true, false, false, 77756.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (101, NULL, posunDatum('2010-05-31'), vytvorKod(posunDatum('20100531')), 'MAJ', NULL, 9723.00, true, false, false, 68033.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (102, NULL, posunDatum('2010-06-30'), vytvorKod(posunDatum('20100630')), 'MAJ', NULL, 9723.00, true, false, false, 58310.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (103, NULL, posunDatum('2010-07-31'), vytvorKod(posunDatum('20100731')), 'MAJ', NULL, 9723.00, true, false, false, 48587.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (104, NULL, posunDatum('2010-08-31'), vytvorKod(posunDatum('20100831')), 'MAJ', NULL, 9723.00, true, false, false, 38864.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (105, NULL, posunDatum('2010-09-30'), vytvorKod(posunDatum('20100930')), 'MAJ', NULL, 9723.00, true, false, false, 29141.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (106, NULL, posunDatum('2010-10-31'), vytvorKod(posunDatum('20101031')), 'MAJ', NULL, 9723.00, true, false, false, 19418.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (107, NULL, posunDatum('2010-11-30'), vytvorKod(posunDatum('20101130')), 'MAJ', NULL, 9723.00, true, false, false, 9695.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (108, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 9695.00, true, false, false, 0.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 4, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (109, posunDatum('2008-01-31'), posunDatum('2008-01-31'), vytvorKod(posunDatum('20080131')), 'MAJ', NULL, 3334.00, true, false, false, 116666.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (110, posunDatum('2008-02-29'), posunDatum('2008-02-29'), vytvorKod(posunDatum('20080229')), 'MAJ', NULL, 3334.00, true, false, false, 113332.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (111, posunDatum('2008-03-31'), posunDatum('2008-03-31'), vytvorKod(posunDatum('20080331')), 'MAJ', NULL, 3334.00, true, false, false, 109998.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (112, posunDatum('2008-04-30'), posunDatum('2008-04-30'), vytvorKod(posunDatum('20080430')), 'MAJ', NULL, 3334.00, true, false, false, 106664.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (113, posunDatum('2008-05-31'), posunDatum('2008-05-31'), vytvorKod(posunDatum('20080531')), 'MAJ', NULL, 3334.00, true, false, false, 103330.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (114, posunDatum('2008-06-30'), posunDatum('2008-06-30'), vytvorKod(posunDatum('20080630')), 'MAJ', NULL, 3334.00, true, false, false, 99996.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (115, posunDatum('2008-07-31'), posunDatum('2008-07-31'), vytvorKod(posunDatum('20080731')), 'MAJ', NULL, 3334.00, true, false, false, 96662.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (116, posunDatum('2008-08-31'), posunDatum('2008-08-31'), vytvorKod(posunDatum('20080831')), 'MAJ', NULL, 3334.00, true, false, false, 93328.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (117, posunDatum('2008-09-30'), posunDatum('2008-09-30'), vytvorKod(posunDatum('20080930')), 'MAJ', NULL, 3334.00, true, false, false, 89994.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (118, posunDatum('2008-10-31'), posunDatum('2008-10-31'), vytvorKod(posunDatum('20081031')), 'MAJ', NULL, 3334.00, true, false, false, 86660.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (119, posunDatum('2008-11-30'), posunDatum('2008-11-30'), vytvorKod(posunDatum('20081130')), 'MAJ', NULL, 3334.00, true, false, false, 83326.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (120, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 3334.00, true, false, false, 79992.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (121, NULL, posunDatum('2009-01-31'), vytvorKod(posunDatum('20090131')), 'MAJ', NULL, 3334.00, true, false, false, 76658.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (122, NULL, posunDatum('2009-02-28'), vytvorKod(posunDatum('20090228')), 'MAJ', NULL, 3334.00, true, false, false, 73324.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (123, NULL, posunDatum('2009-03-31'), vytvorKod(posunDatum('20090331')), 'MAJ', NULL, 3334.00, true, false, false, 69990.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (124, NULL, posunDatum('2009-04-30'), vytvorKod(posunDatum('20090430')), 'MAJ', NULL, 3334.00, true, false, false, 66656.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (125, NULL, posunDatum('2009-05-31'), vytvorKod(posunDatum('20090531')), 'MAJ', NULL, 3334.00, true, false, false, 63322.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (126, NULL, posunDatum('2009-06-30'), vytvorKod(posunDatum('20090630')), 'MAJ', NULL, 3334.00, true, false, false, 59988.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (127, NULL, posunDatum('2009-07-31'), vytvorKod(posunDatum('20090731')), 'MAJ', NULL, 3334.00, true, false, false, 56654.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (128, NULL, posunDatum('2009-08-31'), vytvorKod(posunDatum('20090831')), 'MAJ', NULL, 3334.00, true, false, false, 53320.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (129, NULL, posunDatum('2009-09-30'), vytvorKod(posunDatum('20090930')), 'MAJ', NULL, 3334.00, true, false, false, 49986.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (130, NULL, posunDatum('2009-10-31'), vytvorKod(posunDatum('20091031')), 'MAJ', NULL, 3334.00, true, false, false, 46652.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (131, NULL, posunDatum('2009-11-30'), vytvorKod(posunDatum('20091130')), 'MAJ', NULL, 3334.00, true, false, false, 43318.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (132, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 3334.00, true, false, false, 39984.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (133, NULL, posunDatum('2010-01-31'), vytvorKod(posunDatum('20100131')), 'MAJ', NULL, 3334.00, true, false, false, 36650.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (134, NULL, posunDatum('2010-02-28'), vytvorKod(posunDatum('20100228')), 'MAJ', NULL, 3334.00, true, false, false, 33316.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (135, NULL, posunDatum('2010-03-31'), vytvorKod(posunDatum('20100331')), 'MAJ', NULL, 3334.00, true, false, false, 29982.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (136, NULL, posunDatum('2010-04-30'), vytvorKod(posunDatum('20100430')), 'MAJ', NULL, 3334.00, true, false, false, 26648.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (137, NULL, posunDatum('2010-05-31'), vytvorKod(posunDatum('20100531')), 'MAJ', NULL, 3334.00, true, false, false, 23314.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (138, NULL, posunDatum('2010-06-30'), vytvorKod(posunDatum('20100630')), 'MAJ', NULL, 3334.00, true, false, false, 19980.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (139, NULL, posunDatum('2010-07-31'), vytvorKod(posunDatum('20100731')), 'MAJ', NULL, 3334.00, true, false, false, 16646.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (140, NULL, posunDatum('2010-08-31'), vytvorKod(posunDatum('20100831')), 'MAJ', NULL, 3334.00, true, false, false, 13312.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (141, NULL, posunDatum('2010-09-30'), vytvorKod(posunDatum('20100930')), 'MAJ', NULL, 3334.00, true, false, false, 9978.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (142, NULL, posunDatum('2010-10-31'), vytvorKod(posunDatum('20101031')), 'MAJ', NULL, 3334.00, true, false, false, 6644.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (143, NULL, posunDatum('2010-11-30'), vytvorKod(posunDatum('20101130')), 'MAJ', NULL, 3334.00, true, false, false, 3310.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (144, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 3310.00, true, false, false, 0.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 5, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (145, posunDatum('2008-01-31'), posunDatum('2008-01-31'), vytvorKod(posunDatum('20080131')), 'MAJ', NULL, 2223.00, true, false, false, 77777.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (146, posunDatum('2008-02-29'), posunDatum('2008-02-29'), vytvorKod(posunDatum('20080229')), 'MAJ', NULL, 2223.00, true, false, false, 75554.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (147, posunDatum('2008-03-31'), posunDatum('2008-03-31'), vytvorKod(posunDatum('20080331')), 'MAJ', NULL, 2223.00, true, false, false, 73331.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (148, posunDatum('2008-04-30'), posunDatum('2008-04-30'), vytvorKod(posunDatum('20080430')), 'MAJ', NULL, 2223.00, true, false, false, 71108.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (149, posunDatum('2008-05-31'), posunDatum('2008-05-31'), vytvorKod(posunDatum('20080531')), 'MAJ', NULL, 2223.00, true, false, false, 68885.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (150, posunDatum('2008-06-30'), posunDatum('2008-06-30'), vytvorKod(posunDatum('20080630')), 'MAJ', NULL, 2223.00, true, false, false, 66662.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (151, posunDatum('2008-07-31'), posunDatum('2008-07-31'), vytvorKod(posunDatum('20080731')), 'MAJ', NULL, 2223.00, true, false, false, 64439.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (152, posunDatum('2008-08-31'), posunDatum('2008-08-31'), vytvorKod(posunDatum('20080831')), 'MAJ', NULL, 2223.00, true, false, false, 62216.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (153, posunDatum('2008-09-30'), posunDatum('2008-09-30'), vytvorKod(posunDatum('20080930')), 'MAJ', NULL, 2223.00, true, false, false, 59993.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (154, posunDatum('2008-10-31'), posunDatum('2008-10-31'), vytvorKod(posunDatum('20081031')), 'MAJ', NULL, 2223.00, true, false, false, 57770.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (155, posunDatum('2008-11-30'), posunDatum('2008-11-30'), vytvorKod(posunDatum('20081130')), 'MAJ', NULL, 2223.00, true, false, false, 55547.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (156, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 2223.00, true, false, false, 53324.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (157, NULL, posunDatum('2009-01-31'), vytvorKod(posunDatum('20090131')), 'MAJ', NULL, 2223.00, true, false, false, 51101.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (158, NULL, posunDatum('2009-02-28'), vytvorKod(posunDatum('20090228')), 'MAJ', NULL, 2223.00, true, false, false, 48878.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (159, NULL, posunDatum('2009-03-31'), vytvorKod(posunDatum('20090331')), 'MAJ', NULL, 2223.00, true, false, false, 46655.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (160, NULL, posunDatum('2009-04-30'), vytvorKod(posunDatum('20090430')), 'MAJ', NULL, 2223.00, true, false, false, 44432.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (161, NULL, posunDatum('2009-05-31'), vytvorKod(posunDatum('20090531')), 'MAJ', NULL, 2223.00, true, false, false, 42209.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (162, NULL, posunDatum('2009-06-30'), vytvorKod(posunDatum('20090630')), 'MAJ', NULL, 2223.00, true, false, false, 39986.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (163, NULL, posunDatum('2009-07-31'), vytvorKod(posunDatum('20090731')), 'MAJ', NULL, 2223.00, true, false, false, 37763.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (164, NULL, posunDatum('2009-08-31'), vytvorKod(posunDatum('20090831')), 'MAJ', NULL, 2223.00, true, false, false, 35540.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (165, NULL, posunDatum('2009-09-30'), vytvorKod(posunDatum('20090930')), 'MAJ', NULL, 2223.00, true, false, false, 33317.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (166, NULL, posunDatum('2009-10-31'), vytvorKod(posunDatum('20091031')), 'MAJ', NULL, 2223.00, true, false, false, 31094.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (167, NULL, posunDatum('2009-11-30'), vytvorKod(posunDatum('20091130')), 'MAJ', NULL, 2223.00, true, false, false, 28871.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (168, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 2223.00, true, false, false, 26648.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (169, NULL, posunDatum('2010-01-31'), vytvorKod(posunDatum('20100131')), 'MAJ', NULL, 2223.00, true, false, false, 24425.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (170, NULL, posunDatum('2010-02-28'), vytvorKod(posunDatum('20100228')), 'MAJ', NULL, 2223.00, true, false, false, 22202.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (171, NULL, posunDatum('2010-03-31'), vytvorKod(posunDatum('20100331')), 'MAJ', NULL, 2223.00, true, false, false, 19979.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (172, NULL, posunDatum('2010-04-30'), vytvorKod(posunDatum('20100430')), 'MAJ', NULL, 2223.00, true, false, false, 17756.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (173, NULL, posunDatum('2010-05-31'), vytvorKod(posunDatum('20100531')), 'MAJ', NULL, 2223.00, true, false, false, 15533.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (174, NULL, posunDatum('2010-06-30'), vytvorKod(posunDatum('20100630')), 'MAJ', NULL, 2223.00, true, false, false, 13310.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (175, NULL, posunDatum('2010-07-31'), vytvorKod(posunDatum('20100731')), 'MAJ', NULL, 2223.00, true, false, false, 11087.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (176, NULL, posunDatum('2010-08-31'), vytvorKod(posunDatum('20100831')), 'MAJ', NULL, 2223.00, true, false, false, 8864.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (177, NULL, posunDatum('2010-09-30'), vytvorKod(posunDatum('20100930')), 'MAJ', NULL, 2223.00, true, false, false, 6641.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (178, NULL, posunDatum('2010-10-31'), vytvorKod(posunDatum('20101031')), 'MAJ', NULL, 2223.00, true, false, false, 4418.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (179, NULL, posunDatum('2010-11-30'), vytvorKod(posunDatum('20101130')), 'MAJ', NULL, 2223.00, true, false, false, 2195.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (180, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 2195.00, true, false, false, 0.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 6, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (181, posunDatum('2008-01-31'), posunDatum('2008-01-31'), vytvorKod(posunDatum('20080131')), 'MAJ', NULL, 1528.00, true, false, false, 53472.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (182, posunDatum('2008-02-29'), posunDatum('2008-02-29'), vytvorKod(posunDatum('20080229')), 'MAJ', NULL, 1528.00, true, false, false, 51944.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (183, posunDatum('2008-03-31'), posunDatum('2008-03-31'), vytvorKod(posunDatum('20080331')), 'MAJ', NULL, 1528.00, true, false, false, 50416.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (184, posunDatum('2008-04-30'), posunDatum('2008-04-30'), vytvorKod(posunDatum('20080430')), 'MAJ', NULL, 1528.00, true, false, false, 48888.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (185, posunDatum('2008-05-31'), posunDatum('2008-05-31'), vytvorKod(posunDatum('20080531')), 'MAJ', NULL, 1528.00, true, false, false, 47360.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (186, posunDatum('2008-06-30'), posunDatum('2008-06-30'), vytvorKod(posunDatum('20080630')), 'MAJ', NULL, 1528.00, true, false, false, 45832.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (187, posunDatum('2008-07-31'), posunDatum('2008-07-31'), vytvorKod(posunDatum('20080731')), 'MAJ', NULL, 1528.00, true, false, false, 44304.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (188, posunDatum('2008-08-31'), posunDatum('2008-08-31'), vytvorKod(posunDatum('20080831')), 'MAJ', NULL, 1528.00, true, false, false, 42776.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (189, posunDatum('2008-09-30'), posunDatum('2008-09-30'), vytvorKod(posunDatum('20080930')), 'MAJ', NULL, 1528.00, true, false, false, 41248.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (190, posunDatum('2008-10-31'), posunDatum('2008-10-31'), vytvorKod(posunDatum('20081031')), 'MAJ', NULL, 1528.00, true, false, false, 39720.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (191, posunDatum('2008-11-30'), posunDatum('2008-11-30'), vytvorKod(posunDatum('20081130')), 'MAJ', NULL, 1528.00, true, false, false, 38192.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (192, posunDatum('2008-12-31'), posunDatum('2008-12-31'), vytvorKod(posunDatum('20081231')), 'MAJ', NULL, 1528.00, true, false, false, 36664.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (193, NULL, posunDatum('2009-01-31'), vytvorKod(posunDatum('20090131')), 'MAJ', NULL, 1528.00, true, false, false, 35136.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (194, NULL, posunDatum('2009-02-28'), vytvorKod(posunDatum('20090228')), 'MAJ', NULL, 1528.00, true, false, false, 33608.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (195, NULL, posunDatum('2009-03-31'), vytvorKod(posunDatum('20090331')), 'MAJ', NULL, 1528.00, true, false, false, 32080.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (196, NULL, posunDatum('2009-04-30'), vytvorKod(posunDatum('20090430')), 'MAJ', NULL, 1528.00, true, false, false, 30552.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (197, NULL, posunDatum('2009-05-31'), vytvorKod(posunDatum('20090531')), 'MAJ', NULL, 1528.00, true, false, false, 29024.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (198, NULL, posunDatum('2009-06-30'), vytvorKod(posunDatum('20090630')), 'MAJ', NULL, 1528.00, true, false, false, 27496.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (199, NULL, posunDatum('2009-07-31'), vytvorKod(posunDatum('20090731')), 'MAJ', NULL, 1528.00, true, false, false, 25968.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (200, NULL, posunDatum('2009-08-31'), vytvorKod(posunDatum('20090831')), 'MAJ', NULL, 1528.00, true, false, false, 24440.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (201, NULL, posunDatum('2009-09-30'), vytvorKod(posunDatum('20090930')), 'MAJ', NULL, 1528.00, true, false, false, 22912.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (202, NULL, posunDatum('2009-10-31'), vytvorKod(posunDatum('20091031')), 'MAJ', NULL, 1528.00, true, false, false, 21384.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (203, NULL, posunDatum('2009-11-30'), vytvorKod(posunDatum('20091130')), 'MAJ', NULL, 1528.00, true, false, false, 19856.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (204, NULL, posunDatum('2009-12-31'), vytvorKod(posunDatum('20091231')), 'MAJ', NULL, 1528.00, true, false, false, 18328.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (205, NULL, posunDatum('2010-01-31'), vytvorKod(posunDatum('20100131')), 'MAJ', NULL, 1528.00, true, false, false, 16800.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (206, NULL, posunDatum('2010-02-28'), vytvorKod(posunDatum('20100228')), 'MAJ', NULL, 1528.00, true, false, false, 15272.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (207, NULL, posunDatum('2010-03-31'), vytvorKod(posunDatum('20100331')), 'MAJ', NULL, 1528.00, true, false, false, 13744.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (208, NULL, posunDatum('2010-04-30'), vytvorKod(posunDatum('20100430')), 'MAJ', NULL, 1528.00, true, false, false, 12216.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (209, NULL, posunDatum('2010-05-31'), vytvorKod(posunDatum('20100531')), 'MAJ', NULL, 1528.00, true, false, false, 10688.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (210, NULL, posunDatum('2010-06-30'), vytvorKod(posunDatum('20100630')), 'MAJ', NULL, 1528.00, true, false, false, 9160.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (211, NULL, posunDatum('2010-07-31'), vytvorKod(posunDatum('20100731')), 'MAJ', NULL, 1528.00, true, false, false, 7632.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (212, NULL, posunDatum('2010-08-31'), vytvorKod(posunDatum('20100831')), 'MAJ', NULL, 1528.00, true, false, false, 6104.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (213, NULL, posunDatum('2010-09-30'), vytvorKod(posunDatum('20100930')), 'MAJ', NULL, 1528.00, true, false, false, 4576.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (214, NULL, posunDatum('2010-10-31'), vytvorKod(posunDatum('20101031')), 'MAJ', NULL, 1528.00, true, false, false, 3048.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (215, NULL, posunDatum('2010-11-30'), vytvorKod(posunDatum('20101130')), 'MAJ', NULL, 1528.00, true, false, false, 1520.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
INSERT INTO mucetodpisy (iducetodpisu, datucto, datvyst, kod, modul, poznam, sumzkl, ucetni, zamek, zmena, zustpoodp, idzkldalucet, idzklmducet, idzakazky, idmajetku, idstred) VALUES (216, NULL, posunDatum('2010-12-31'), vytvorKod(posunDatum('20101231')), 'MAJ', NULL, 1520.00, true, false, false, 0.00, (select iducet from uucty where uuid = 'CZ_POD_082001'), (select iducet from uucty where uuid = 'CZ_POD_551001'), NULL, 7, 1);
SELECT pg_catalog.setval('seq_mucetodpisy', 216, true);

INSERT INTO mudalosti (idudalosti, lastupdate, datucto, datvyst, kod, modul, poznam, sumdph, sumdphmen, sumzkl, sumzklmen, typudalostik, ucetni, zamek, zmenadobyodpis, idzkldalucet, idstred, idmajetku, idzakazky, iddphmducet, iddphdalucet, idzklmducet) VALUES (1, '2008-09-01 15:41:47.20', posunDatum('2008-01-06'), posunDatum('2008-01-06'), vytvorKod(posunDatum('20080106')), 'MAJ', NULL, 0.00, 0.00, 600000.00, 0.00, 'typUdal.zarazeni', true, false, 0, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 3, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
INSERT INTO mudalosti (idudalosti, lastupdate, datucto, datvyst, kod, modul, poznam, sumdph, sumdphmen, sumzkl, sumzklmen, typudalostik, ucetni, zamek, zmenadobyodpis, idzkldalucet, idstred, idmajetku, idzakazky, iddphmducet, iddphdalucet, idzklmducet) VALUES (2, '2008-09-01 16:27:22.189', posunDatum('2008-01-06'), posunDatum('2008-01-06'), vytvorKod(posunDatum('20080106')), 'MAJ', NULL, 0.00, 0.00, 350000.00, 0.00, 'typUdal.zarazeni', true, false, 0, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 4, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
INSERT INTO mudalosti (idudalosti, lastupdate, datucto, datvyst, kod, modul, poznam, sumdph, sumdphmen, sumzkl, sumzklmen, typudalostik, ucetni, zamek, zmenadobyodpis, idzkldalucet, idstred, idmajetku, idzakazky, iddphmducet, iddphdalucet, idzklmducet) VALUES (3, '2008-09-01 16:33:03.464', posunDatum('2008-01-06'), posunDatum('2008-01-06'), vytvorKod(posunDatum('20080106')), 'MAJ', NULL, 0.00, 0.00, 120000.00, 0.00, 'typUdal.zarazeni', true, false, 0, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 5, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
INSERT INTO mudalosti (idudalosti, lastupdate, datucto, datvyst, kod, modul, poznam, sumdph, sumdphmen, sumzkl, sumzklmen, typudalostik, ucetni, zamek, zmenadobyodpis, idzkldalucet, idstred, idmajetku, idzakazky, iddphmducet, iddphdalucet, idzklmducet) VALUES (4, '2008-09-01 16:39:16.697', posunDatum('2008-01-06'), posunDatum('2008-01-06'), vytvorKod(posunDatum('20080106')), 'MAJ', NULL, 0.00, 0.00, 80000.00, 0.00, 'typUdal.zarazeni', true, false, 0, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 6, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
INSERT INTO mudalosti (idudalosti, lastupdate, datucto, datvyst, kod, modul, poznam, sumdph, sumdphmen, sumzkl, sumzklmen, typudalostik, ucetni, zamek, zmenadobyodpis, idzkldalucet, idstred, idmajetku, idzakazky, iddphmducet, iddphdalucet, idzklmducet) VALUES (5, '2008-09-01 16:40:41.983', posunDatum('2008-01-06'), posunDatum('2008-01-06'), vytvorKod(posunDatum('20080106')), 'MAJ', NULL, 0.00, 0.00, 55000.00, 0.00, 'typUdal.zarazeni', true, false, 0, (select iducet from uucty where uuid = 'CZ_POD_042001'), 1, 7, NULL, NULL, NULL, (select iducet from uucty where uuid = 'CZ_POD_022001'));
SELECT pg_catalog.setval('seq_mudalosti', 5, true);

drop function posunDatum(in proDatum date);
drop function posunInt(in proInteger integer);
drop function vytvorKod(in proDatum date);
drop function posunDoklKod(in doklKod varchar);


--------------------------------------------------------------------------------
-- Bug 13586 – [WinStrom] Nastavení zaokrouhlení přímo na dokladu
-- TODO zahrnout přímo do dokladů v demo datech a odstranit updaty níže

-- Přenesení nastavení zaokrouhlení dat do tabulky ddoklfak
UPDATE ddoklfak d
SET zaokrjaksumk = ( SELECT td.zaokrjaksumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklfak d
SET zaokrnasumk  = ( SELECT td.zaokrnasumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklfak d
SET zaokrjakdphk = ( SELECT td.zaokrjakdphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklfak d
SET zaokrnadphk  = ( SELECT td.zaokrnadphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );

-- Přenesení nastavení zaokrouhlení dat do tabulky ddoklint
UPDATE ddoklint d
SET zaokrjaksumk = ( SELECT td.zaokrjaksumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklint d
SET zaokrnasumk  = ( SELECT td.zaokrnasumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklint d
SET zaokrjakdphk = ( SELECT td.zaokrjakdphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklint d
SET zaokrnadphk  = ( SELECT td.zaokrnadphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );

-- Přenesení nastavení zaokrouhlení dat do tabulky ddoklsklad
UPDATE ddoklsklad d
SET zaokrjaksumk = ( SELECT td.zaokrjaksumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklsklad d
SET zaokrnasumk  = ( SELECT td.zaokrnasumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklsklad d
SET zaokrjakdphk = ( SELECT td.zaokrjakdphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklsklad d
SET zaokrnadphk  = ( SELECT td.zaokrnadphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );

-- Přenesení nastavení zaokrouhlení dat do tabulky ddoklobch
UPDATE ddoklobch d
SET zaokrjaksumk = ( SELECT td.zaokrjaksumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklobch d
SET zaokrnasumk  = ( SELECT td.zaokrnasumk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklobch d
SET zaokrjakdphk = ( SELECT td.zaokrjakdphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );
UPDATE ddoklobch d
SET zaokrnadphk  = ( SELECT td.zaokrnadphk 
                     FROM dtypdokl td 
                     WHERE td.idtypdokl = d.idtypdokl );

--------------------------------------------------------------------------------

--certifikát pro EET
INSERT INTO woscert (idoscert, lastupdate, typcertk, ucelcertk, platido, platiod, uzivnazev, certnazev, certorgan, cesta, iduzivatel, eetprovozovna) VALUES (1, '2017-01-06 22:52:50.190000', 'typCert.server', 'ucelCertK.eet', '2019-09-30 11:02:44.000000', '2016-09-30 11:02:44.000000', null, 'CZ1212121218', '<není součástí certifikátu>', null, 1, 123);
INSERT INTO woscertcipher (idoscertcipher, certifikat, idoscert) VALUES (1, 'h\\335\\244\\276\\2674\\265F\\253\\223X#\\273-_A-\\371\\340\\262\\231\\322W\\317\\316\\350h\\360s0\\031:\\220\\3702~BA\\347(o\\314\\236\\343N\\275\\212\\037\\356D\\334\\032%N\\005\\325\\302\\343.\\366L\\223\\362a}\\361\\027\\261/\\333)\\0160(\\\\s?>\\003\\034s\\357\\211|?0j\\276\\345\\331b]j\\362i;>\\207\\024\\315\\027Ek\\255\\237\\033\\026T\\333\\000(\\223B2\\246\\003\\345\\205\\025Az\\005\\365\\377x\\350T\\242\\343D\\221SV%\\205\\276\\217\\016\\012\\276\\322\\303\\336+\\007\\365\\214\\367b7z\\202N\\373z\\276A\\354\\245\\203\\017\\234\\226\\006l\\031"\\030\\223\\226\\307\\032\\275\\211\\342c\\277\\320Y3s^?\\335h\\311\\204\\203\\262\\3031\\244\\320\\030\\240I\\341\\025`\\214\\355\\346\\200&WHH\\271\\273\\325\\332\\351[\\206\\015gAcY\\235\\034\\023\\353.g\\336\\037I\\374\\250\\252\\336\\263\\350\\317/\\351\\244\\317\\004\\251Kp\\371\\204\\275[\\355~G;\\262{(\\366\\3555q\\247\\004\\340\\047\\003\\313{\\226\\331\\273\\321\\374\\243\\022\\311\\331a\\026\\231n\\202\\202\\373\\252\\212[\\335\\221\\302\\317LqX\\270\\274\\301^l\\375k`u\\200cp?8\\223\\036\\277~\\206<&F\\374\\257\\027-\\310\\210\\252\\342\\335Wy:6l*>\\277x\\232\\032\\343\\375\\236\\267\\243\\360G\\000D<\\341\\013J\\233\\003\\024&7\\227\\302\\243\\021\\\\v&4\\006-U"\\316y\\350\\313w\\311\\2059\\273\\027\\327\\2152F\\014\\313\\221\\336\\377\\343\\246*\\332\\317\\212 \\\\\\262\\272\\275\\016\\214j\\257x49\\241\\027\\313\\031\\213n\\201\\014\\323-\\364\\337wN\\245\\346tq\\213E\\024z\\234\\277\\242\\372\\330\\246\\001\\335\\016\\353\\026\\342\\307h\\014L0\\314\\325\\035S\\262Xpq~\\025\\266\\2436##Y\\267Z\\344\\336t\\014\\010\\215\\374v\\315\\254\\345\\036\\026\\226\\313kkBe8\\354\\232\\276\\364P\\250\\200\\357:\\357\\047WI\\241\\345\\361\\313\\0008\\251K\\346\\034\\2359\\345\\017\\272AjV\\236\\270\\033d\\215~\\2751\\033\\316\\313\\036\\311\\047\\030\\232\\312\\372\\364\\254)\\347\\222\\015\\204w=\\316HY-|}F*oQD$\\005Fo\\261\\225\\326\\006\\300\\331\\257\\204\\327EEd\\302\\374t\\260\\260\\365\\030\\021\\335\\047wN\\240P\\207/\\343l\\324b\\346\\275\\306\\367H \\003%\\314\\264\\267\\264\\320\\023(.\\252c\\222\\217=\\345\\375T\\274\\357\\372\\216*\\344\\262x&ui\\221t[\\352\\024\\\\CN\\006\\216\\246n\\236q(\\201\\3230\\013(\\370i\\363\\035\\361M\\034\\201\\011\\237\\373\\340\\204\\352\\211\\332\\365\\360\\000U\\240\\346\\243\\333\\370\\321\\266\\204\\023*\\202Tt\\271/u\\306tm\\031E\\327(\\244\\326\\004\\240\\325\\356\\277\\220\\231U\\004K\\021\\047P\\222\\027b\\361\\351\\357\\014\\374\\357\\326\\261\\334\\213lS]\\036\\332\\226>\\317t\\337W\\316\\275\\024&\\014\\300\\030\\306\\364zK\\354\\047v/b\\274\\000\\255\\307\\177\\220\\345JWE#\\253\\210"\\311\\271\\266*&\\221\\344|\\264\\342t\\026[\\312^\\210\\362\\341\\201\\362\\024D$\\373\\0246\\271\\326`\\355?Y\\330c\\016\\016\\304\\224\\\\\\373r\\377#\\340CYo\\310o\\331\\362\\252\\242\\225\\375$\\3149\\265\\335\\223\\271W\\312\\246/\\210ZE\\356u\\003v\\250\\013\\315/\\011\\004J7\\342\\341\\032:N\\005}|\\360f\\247\\015\\244~8A<\\346\\312\\314G\\373\\337\\252\\270\\000\\315\\313:E\\231\\357\\205\\030\\243\\357\\022\\273R\\371\\024\\330\\325\\204\\355\\342gX+\\352\\355\\322\\347~\\363]\\270bTa\\275W`I4<>o\\321Qg\\271\\370\\336S\\355;M\\315O\\010]\\306\\010\\216\\007\\337]\\346\\351B\\325\\237\\310\\224\\327S\\370\\320\\374NU\\362\\030\\357\\217\\363dK5\\255\\000\\326[\\202\\234\\251q\\361\\251\\363\\004\\215\\230\\226\\227Ib\\223Ts)b!&7"\\200\\013\\313\\263\\254s\\302T\\242+\\007\\207\\364\\323\\215\\352\\2235F\\257\\211\\235w\\361.R\\022\\351\\220\\047hQ#\\272\\217\\366\\245\\343%\\021\\264\\014\\321J\\200\\006\\334\\257\\212\\242\\356N\\330k\\373\\033\\211\\261\\266\\017m\\021\\232ia1R\\320\\276\\357\\266Eb\\273?5\\366\\215\\330\\274\\013?\\316C\\017\\272~R\\240h\\336V\\013\\211\\201\\340\\031;\\313P\\015\\344\\020p\\036\\306\\252K%*\\233\\313Y\\322Pi\\002+^\\347\\265\\315t\\321\\001\\375i\\204\\374&\\2647\\223Y+\\204\\310\\345\\370Z|/&a`\\356\\323\\206?\\275/s\\036\\307_\\006\\335O~j\\373\\336\\210>\\370\\245\\316\\000)\\217\\013\\361}\\304[\\337\\316Q\\210\\316\\321\\317Mh\\243$\\366t\\3739\\363K\\363\\325\\256\\015\\253\\261L\\0173\\362\\237\\330\\2207\\227\\237\\302t[\\200umua\\332b\\325G\\3378U\\227\\346t\\261\\272\\362F\\026\\330\\245\\000\\024I\\307p\\355\\270\\203)\\266\\031\\035\\024\\252\\013,\\030m\\005h?C z|=n\\332\\3337URJ\\324\\256\\345>\\007\\277\\207\\326\\370\\213\\353\\366\\017\\374\\254\\005BI\\037\\312\\207\\262JC\\252\\241\\300\\035b\\036\\375%\\214\\330y\\344\\370\\220\\330\\\\\\232~WdP\\357\\025\\344\\003\\023Z\\360\\317\\340dW_\\212X\\323\\031\\213\\213\\350\\027H\\347}P`\\341\\373\\032d\\047\\317\\310t\\2705(l3>\\014^\\343I\\312|b\\022\\235\\352D\\335Bq\\332g\\301\\261\\231\\207e`kpl,\\364\\374E\\007\\272\\2164\\363\\021\\360\\004\\252\\301\\027<\\351d\\260o\\027\\232\\333%\\251\\362mZ3\\324\\351\\036\\314>C\\353u"\\325\\320\\345W\\356@\\002\\003\\000\\332\\277.w:\\026\\373\\177a0(\\177\\021\\374\\243\\303\\005\\357c\\272/\\274Uw\\373\\\\\\205,\\303\\264n\\001\\222&\\004_X\\0368\\327\\365\\010\\005qC\\323\\371\\214\\272w&\\003\\370h\\223\\244\\213s\\037\\374g%\\301\\227\\001\\332\\032Yu\\033*\\221w2Z\\235\\323\\242\\237gw\\330\\201\\243\\030\\274hnhY\\327\\267\\265n\\206z{\\371\\241\\346\\257\\246>(\\016\\014\\015\\300\\357\\206\\022\\215\\012X\\2356\\267v-O\\002~\\277\\257P\\261EM\\007i\\375WN=\\262\\252O$\\003\\353I\\256Uj\\317\\3471\\227\\263\\351\\223\\273G\\210!%.\\220p\\351f\\265KEMH5\\256\\224A\\331\\047\\026w\\2061D,\\300KzG\\351\\270\\326>]\\241=\\260PH)\\327\\024n\\206\\375~\\363Qb\\270\\332\\372Z\\011vLP\\322\\235\\006\\306\\206\\002\\233\\222\\027\\010\\264\\012\\210\\006\\335yq\\030\\370/k\\232\\256\\027\\305\\333\\217\\305(\\346\\351\\035W\\264\\273\\214\\011\\312\\320\\364>\\226>\\210\\334V\\023\\024Z.\\217\\226\\321;\\016\\346\\245\\323>Wv\\266M\\345G\\0212\\203,\\334\\360eE\\251R\\002\\212\\037\\261\\304=\\242\\216-D>\\213\\310Qy\\246\\367&\\366\\373\\202\\202\\357;\\\\\\036d\\032\\014[\\273\\367\\270\\252\\331\\356U\\215\\015\\006\\250\\367\\015a\\251~h\\015\\207\\212\\200\\016\\330Qe\\021\\266\\247\\315\\272_\\177\\3366\\244V<\\365\\241\\312T\\275o?\\241eL;\\317\\224}^\\337\\231\\347\\312\\235\\345\\245t4\\237\\355\\347\\020\\276\\220q\\347|\\343\\335T\\227\\007J\\034Fp&v\\372\\235\\360\\3646\\252\\320{\\344y\\271\\016m\\002Q\\364G\\361\\371a-\\255\\374\\010\\035\\216\\315\\031\\315\\235\\264\\033\\347R\\365\\216\\3625C]\\250Y:|]R\\377gd\\312q\\337\\364\\334\\376I\\354p\\365\\001\\236\\221jm\\376e\\231\\202\\246\\303\\305\\003r\\303f\\345\\270q\\277\\277\\337\\012\\047\\007,A\\016\\246Lp\\256|\\302o\\255\\200"3;v\\354\\303\\372\\031\\0213\\226\\377=\\270\\255\\023GY7k\\037\\306\\224j\\027\\033\\314\\273\\263Ec\\274\\2326\\016Mg\\177\\2779\\217}\\204\\244\\003 \\3722\\363\\241\\233\\245X\\020\\206\\357\\312\\373w\\375hK\\034Ob!k\\221D\\272\\3006<#\\002.\\241~S\\255e\\274}/wI\\034,\\241\\256\\267\\310\\330%=\\005\\345\\317\\242\\3502(\\207r\\252q\\277Y\\260\\340\\275\\311\\362\\215b=-l\\351\\302\\375\\177\\335\\371\\310\\276\\242^\\005I\\235\\264\\304\\227\\233UE2\\306nA\\257Z\\343\\225V\\327\\361\\313\\007\\263\\216\\247P\\354\\250\\047\\351)\\326I5\\347\\3107\\000\\303D\\203)\\011\\356z\\0164]1BXI\\016\\316~\\236i\\015wo\\351I\\236\\261\\336\\206\\240/\\177\\036\\231\\364\\214\\320\\020\\213\\237\\2673\\306E\\353\\255\\372\\257CU\\213\\030:\\032\\241\\266-:<\\023\\0229\\037\\311u5\\327\\214\\245\\235I\\210\\015\\210\\232@\\317\\302\\264=\\236 B\\276\\012\\024\\006\\235\\233\\256Mi\\374gh\\367q*2V\\241j\\205!\\026o\\215G\\360\\306_)7\\266\\036\\232\\366\\344\\020\\232\\326\\260o:)\\374\\001wD\\002"L\\260\\244\\305\\247\\211\\323c\\006\\350\\021\\361\\262\\000\\326{\\304\\307b\\264z!v\\312\\\\\\372\\215\\047\\326\\360\\321\\007\\011\\012\\233\\375/\\247I\\253z\\263M\\020\\254\\314\\275\\322]\\367\\032\\244\\014\\336\\177\\376\\010r\\001\\005\\377b_\\334\\3778\\023f?-\\245\\333\\216A?\\362H\\300\\234\\277 \\002\\354\\273Ai5\\321~\\321\\355=\\265\\020\\342\\013\\307+\\032&\\371k\\240P\\011\\373K\\334]\\213\\306\\004o\\261\\376\\030\\024\\275\\372\\005\\254H\\324hW\\364\\0245\\232Z]\\027^\\230\\367\\227\\243\\220\\372\\272\\2459\\247F\\002\\022M\\237M\\213\\000\\226\\004\\360\\340\\047\\035\\343\\212\\047\\317\\305gQ1\\304\\346\\376\\341;:R1\\333R\\336\\364\\032M\\3773;\\237_\\204\\372\\330#\\337\\200\\356i\\242\\025\\177\\245\\256~\\327\\304\\216\\015\\032\\362\\030\\253\\300\\315\\233a\\315\\221\\226\\307\\253\\371\\274\\255\\324\\367A\\177\\012\\047\\022\\305W\\362\\212c\\006*n\\2354\\324\\360\\047\\335\\224\\252\\032\\\\F\\373\\207\\322\\212n4\\362\\353\\236\\026\\217(\\263t\\245\\346\\016\\341\\325=\\030M\\266\\011\\212\\304\\317\\177\\3124ZQG\\321\\022\\351\\314\\212\\377\\322\\270;K\\346\\352b\\026\\325\\022\\200@\\372\\224z\\215N\\265\\031\\012$\\026\\373|\\254\\010\\343\\357[M\\343\\235\\2567\\324\\226L9\\314\\325V\\334<\\275\\277\\307\\375\\013\\037\\004\\344\\265\\323mU\\276,\\265\\\\\\376\\024\\227m/\\314\\344\\035\\3473\\004\\225\\30346\\271j\\364So\\306\\213\\241e\\264\\047\\304\\020\\257\\006\\022\\216,Wm\\020\\222\\035c\\026\\322=%\\232\\335\\367\\324Z\\260E\\004a\\224x\\373Hv7\\220!d\\002$J\\034\\006\\331\\333#\\306\\253\\360\\346X\\217i\\2223l\\000UI\\003iZ\\261\\370=\\362\\213\\200:jI\\177=U5\\346\\010\\212\\026O\\215\\024\\2771\\011\\211\\327F\\216\\205R\\226\\3428\\375\\353\\003\\204\\236\\257w\\317\\350L\\337\\037^[\\014LAMn\\321\\031\\202\\202eqT\\337\\323\\254{sTkm\\347\\027\\0060\\006Q\\247\\246\\365SZ\\265:\\311@t\\221\\047j0\\001\\000\\253\\352\\012E\\364\\244A\\227Gg\\236]e\\333]y\\375\\033\\271\\224\\312^\\320f\\327\\177\\3371!\\271\\352Z\\254\\011\\275\\347)6\\332\\233\\353\\313\\033#\\340\\202\\242R\\231\\355PD\\273\\010\\344\\261\\001\\012\\212\\0277Y\\331;\\003\\306ex\\266"\\033\\301\\003\\032\\224~\\010\\331\\276\\177\\376\\370B\\222\\300Tg]\\254\\272H\\372\\313\\271\\240+\\002\\364\\3046\\013\\3712\\017\\330\\220E\\2022cbo\\347\\001$\\240$\\332\\367\\350\\227\\030\\233\\013\\022D\\333\\240\\032\\023LobkL*\\246\\313\\202\\002Y\\342\\240\\252\\354\\260\\216\\2307\\323\\211`\\334\\220\\247\\316\\204\\015\\275\\226\\364\\264\\364\\047\\263KE\\273az\\016@\\224\\210\\047m\\246W\\023:1\\200\\323p\\371!l\\250\\305\\325ZKRe.\\354\\212\\367!\\273\\324.\\033\\344\\212\\261\\226\\015c@\\035$\\316\\314\\320\\217\\010|z\\034\\2047\\341TT\\232G\\312P\\257\\047\\371#\\226\\351h\\361\\201\\372\\363\\337\\001h\\367u\\017\\004\\363\\335\\370\\312\\013\\3225\\357\\325\\237\\037\\370\\307\\203hB\\337\\3718m\\202&D\\220s\\363\\035\\267\\206\\244\\273}\\307\\022\\230\\257\\305m\\2272A\\177\\314`\\205/\\2349E\\336\\274$4*\\326\\351\\270R\\011U\\344\\240\\255Y\\0101\\222\\312\\356y\\344\\236\\3657\\357j\\325z\\003\\047\\354\\235\\226\\2774\\370\\225M\\270\\367\\375g\\177H\\047\\206\\356\\217ca\\312\\261\\273Kv\\303H\\027Y\\010KgB\\260t>\\361A\\317\\221\\031~4\\007\\215b\\261\\361\\034\\231"TPg)\\350\\276\\277T#Z\\305$\\212\\231Bv\\230\\232f\\340\\034\\247\\250\\007T`\\211\\251.k\\010\\177\\0267=\\334\\323v\\326`;e\\355\\273\\340\\213\\047\\204Z\\221\\017\\263l\\351,\\230JH\\223g`\\241H\\370\\261\\236LFn,\\266WA\\027\\007$\\376U\\020\\334N\\276X\\271\\245z\\335Q\\255\\032\\360>\\250\\316\\376=\\004AI\\000\\356\\\\k\\241\\241sQ\\371h\\221\\307\\025\\333\\201\\020\\236\\2441\\261\\022?\\203#6\\364\\204\\341,\\240\\211Z\\303\\317\\310\\273\\374\\240\\332v\\003\\313\\332\\365|\\22179\\270\\311\\360O\\005\\016\\223 \\222L/\\273e\\205@\\241+\\024~\\313\\3538\\024.)|6JV\\207\\007\\241p\\237Z\\367\\333_\\221\\010\\013\\244\\234\\222%A\\226\\347\\205\\031\\247\\371\\001\\217\\301\\276\\262gl2lPz\\021w$\\216\\2560\\343\\355UA\\202\\027}7\\271\\023\\001\\230\\\\\\234V\\2633\\352O\\316\\260N`\\354M\\336\\221\\266MD\\255{p\\047\\227&\\034\\031\\201\\310u\\344\\253\\361\\235S\\010\\330\\303\\005', 1);
