--
-- PostgreSQL database dump
--

-- Started on 2009-01-19 10:34:15

SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

--
-- TOC entry 1845 (class 1259 OID 237544)
-- Dependencies: 3
-- Name: seq_aadresar; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_aadresar
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_aadresar OWNER TO %firmaRole%;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1846 (class 1259 OID 237549)
-- Dependencies: 2272 2273 2274 2275 2276 2277 2278 2279 2280 3
-- Name: aadresar; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE aadresar (
    idfirmy integer DEFAULT nextval('seq_aadresar'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    nazev2 character varying(255),
    nazev2a character varying(255),
    nazev2b character varying(255),
    nazev2c character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    email character varying(255),
    fax character varying(255),
    mesto character varying(255),
    mobil character varying(255),
    psc character varying(255),
    tel character varying(255),
    ulice character varying(255),
    www character varying(255),
    bonita integer DEFAULT 0,
    dic character varying(20),
    eankod character varying(20),
    faeankod character varying(20),
    fajmenofirmy character varying(255),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    formexportk character varying(50),
    ic character varying(20),
    limitfak numeric(15,2) DEFAULT 0.0 NOT NULL,
    pocetPriloh integer not null default 0,
    platcedph boolean DEFAULT false NOT NULL,
    specsym character varying(255),
    splatdny integer,
    limitPoSplatDny integer,
    limitPoSplatZakaz boolean DEFAULT false NOT NULL,
    typvztahuk character varying(50),
    idfastatu integer,
    idstred integer,
    idstatu integer,
    idskupfir integer,
    idskupcen integer,
    idzodposoba integer,
    idformauhradycis integer,
    vatid character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    kodpojistovny character varying(20),
    nazevpojistovny character varying(255),
    osloveni character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    obpautomhotovo boolean NOT NULL DEFAULT false,
    insolvence boolean NOT NULL DEFAULT false,
    nespolehlivyplatce boolean NOT NULL DEFAULT false,
    revize integer NOT NULL DEFAULT 0,
    katastruzemi character varying(255),
    parcela character varying(255),
    datnaroz date,
    datzaloz date,
    rodcis character varying(20),
    skrytNeuhrFaktNaTisku boolean NOT NULL DEFAULT false,
    creditcheckk character varying(50),
    canceled boolean DEFAULT false NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.aadresar OWNER TO %firmaRole%;

--
-- TOC entry 1847 (class 1259 OID 237564)
-- Dependencies: 3
-- Name: seq_abanspoj; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_abanspoj
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_abanspoj OWNER TO %firmaRole%;

--
-- TOC entry 1848 (class 1259 OID 237566)
-- Dependencies: 2281 2282 2283 3
-- Name: abanspoj; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE abanspoj (
    idbanspoj integer DEFAULT nextval('seq_abanspoj'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    mesto character varying(255),
    psc character varying(255),
    ulice character varying(255),
    bic character varying(255),
    buc character varying(255),
    iban character varying(255),
    nazbanky character varying(255),
    popis text,
    poznam text,
    primarni boolean DEFAULT false NOT NULL,
    specsym character varying(255),
    varsym character varying(30),
    idsmerkod integer,
    idfirmy integer,
    idkonsym integer,
    idstatu integer,
    registered boolean DEFAULT false NOT NULL
);


ALTER TABLE public.abanspoj OWNER TO %firmaRole%;

--
-- TOC entry 1849 (class 1259 OID 237575)
-- Dependencies: 3
-- Name: seq_akontakty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_akontakty
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_akontakty OWNER TO %firmaRole%;

--
-- TOC entry 1850 (class 1259 OID 237577)
-- Dependencies: 2284 2285 2286 3
-- Name: akontakty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE akontakty (
    idkontakt integer DEFAULT nextval('seq_akontakty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    mesto character varying(255),
    psc character varying(255),
    ulice character varying(255),
    email character varying(255),
    fax character varying(255),
    mobil character varying(255),
    tel character varying(255),
    www character varying(255),
    funkce character varying(255),
    jmeno character varying(255),
	oddeleni character varying(255),
    osloveni character varying(255),
    pocetPriloh integer not null default 0,
    popis text,
    poznam text,
    prijmeni character varying(255),
    primarni boolean DEFAULT false NOT NULL,
    titul character varying(255),
    titulza character varying(255),
    idfirmy integer,
    idstatu integer,
    odesilatFak boolean NOT NULL DEFAULT false,
    odesilatObj boolean NOT NULL DEFAULT false,
    odesilatPpt boolean NOT NULL DEFAULT false,
    odesilatNab boolean NOT NULL DEFAULT false,
    odesilatPok boolean NOT NULL DEFAULT false,
    odesilatSkl boolean NOT NULL DEFAULT false,
    datnaroz date,
    rodcis character varying(20),
    username varchar(255) UNIQUE,
    password varchar(255),
    blocked boolean NOT NULL DEFAULT false,
    blockedText varchar(255)
);


ALTER TABLE public.akontakty OWNER TO %firmaRole%;

--
-- TOC entry 1851 (class 1259 OID 237586)
-- Dependencies: 3
-- Name: seq_amisturc; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_amisturc
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_amisturc OWNER TO %firmaRole%;

--
-- TOC entry 1852 (class 1259 OID 237588)
-- Dependencies: 2287 2288 2289 3
-- Name: amisturc; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE amisturc (
    idmur integer DEFAULT nextval('seq_amisturc'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    mesto character varying(255),
    psc character varying(255),
    ulice character varying(255),
    email character varying(255),
    fax character varying(255),
    mobil character varying(255),
    tel character varying(255),
    www character varying(255),
    eankod character varying(20),
    nazev character varying(255),
    popis text,
    poznam text,
    primarni boolean DEFAULT false NOT NULL,
    nazev2 character varying(255),
    idstatu integer,
    idfirmy integer NOT NULL,
    idkontaktosoba integer
);


ALTER TABLE public.amisturc OWNER TO %firmaRole%;

--
-- TOC entry 1853 (class 1259 OID 237597)
-- Dependencies: 3
-- Name: seq_askupfir; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_askupfir
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_askupfir OWNER TO %firmaRole%;

--
-- TOC entry 1854 (class 1259 OID 237599)
-- Dependencies: 2290 2291 2292 2293 2294 2295 3
-- Name: askupfir; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE askupfir (
    idskupfir integer DEFAULT nextval('seq_askupfir'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    workflow boolean NOT NULL DEFAULT false,
    idprimucetpfa integer,
    idprimucetvfa integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.askupfir OWNER TO %firmaRole%;

--
-- TOC entry 1855 (class 1259 OID 237610)
-- Dependencies: 3
-- Name: seq_asmerkod; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_asmerkod
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_asmerkod OWNER TO %firmaRole%;

--
-- TOC entry 1856 (class 1259 OID 237612)
-- Dependencies: 2296 2297 2298 2299 2300 3
-- Name: asmerkod; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE asmerkod (
    idsmerkod integer DEFAULT nextval('seq_asmerkod'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.asmerkod OWNER TO %firmaRole%;

--
-- TOC entry 1857 (class 1259 OID 237623)
-- Dependencies: 3
-- Name: seq_astaty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_astaty
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_astaty OWNER TO %firmaRole%;

--
-- TOC entry 1858 (class 1259 OID 237625)
-- Dependencies: 2301 2302 2303 2304 2305 2306 3
-- Name: astaty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE astaty (
    idstatu integer DEFAULT nextval('seq_astaty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    kodDph character varying(20) NOT NULL,
    kodNum character varying(20),
    kodAlpha3 character varying(20),
    nazZemeC25 character varying(30),
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    idmeny integer,
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    cleneu boolean DEFAULT false NOT NULL,
    vatid character varying(20),
    vatIdMoss character varying(20),
    idfukraj integer,
    idfuuzprac integer,
    telPredvolba character varying(20),
    uuid character varying(50)
);


ALTER TABLE public.astaty OWNER TO %firmaRole%;

--
-- TOC entry 1859 (class 1259 OID 237637)
-- Dependencies: 3
-- Name: seq_audalosti; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_audalosti
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_audalosti OWNER TO %firmaRole%;

--
-- TOC entry 1860 (class 1259 OID 237639)
-- Dependencies: 2307 2308 3
-- Name: audalosti; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE audalosti (
    idudalost integer DEFAULT nextval('seq_audalosti'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    celodenni boolean DEFAULT true,
    dokonceni timestamp without time zone,
    druhudalk character varying(50),
    pocetpriloh integer NOT NULL DEFAULT 0,
    predmet character varying(255),
    prioritak character varying(50),
    stavudalk character varying(50),
    termin timestamp without time zone,
    umisteni character varying(255),
    volno boolean DEFAULT true,
    zahajeni timestamp without time zone,
    popis text,
    poznam text,
    idfirmy integer,
    idtypakt integer,
    iduzivatel integer,
    idzakazky integer
);


ALTER TABLE public.audalosti OWNER TO %firmaRole%;

CREATE INDEX audalosti_idtypakt_index ON audalosti USING btree (idtypakt);
CREATE INDEX audalosti_iduzivatel_index ON audalosti USING btree (iduzivatel);
CREATE INDEX audalosti_idzakazky_index ON audalosti USING btree (idzakazky);

--
-- TOC entry 1861 (class 1259 OID 237647)
-- Dependencies: 3
-- Name: seq_ccenik; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ccenik
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ccenik OWNER TO %firmaRole%;

--
-- TOC entry 1862 (class 1259 OID 237649)
-- Dependencies: 2309 2310 2311 2312 2313 2314 2315 2316 2317 2318 2319 2320 2321 2322 2323 2324 2325 2326 2327 2328 2329 2330 2331 2332 2333 2334 2335 2336 2337 2338 2339 2340 2341 2342 2343 2344 2345 2346 2347 2348 2349 2350 2351 2352 2353 2354 2355 3
-- Name: ccenik; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ccenik (
    idcenik integer DEFAULT nextval('seq_ccenik'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    individCena boolean DEFAULT false NOT NULL,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    baleniean1 character varying(20),
    baleniean2 character varying(20),
    baleniean3 character varying(20),
    baleniean4 character varying(20),
    baleniean5 character varying(20),
    balenimj1 numeric(19,6) DEFAULT 0.0 NOT NULL,
    balenimj2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    balenimj3 numeric(19,6) DEFAULT 0.0 NOT NULL,
    balenimj4 numeric(19,6) DEFAULT 0.0 NOT NULL,
    balenimj5 numeric(19,6) DEFAULT 0.0 NOT NULL,
    baleninazev1 character varying(255),
    baleninazev2 character varying(255),
    baleninazev3 character varying(255),
    baleninazev4 character varying(255),
    baleninazev5 character varying(255),
    cenjednotka numeric(19,6) DEFAULT 0.0 NOT NULL,
    cena2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    cena3 numeric(19,6) DEFAULT 0.0 NOT NULL,
    cena4 numeric(19,6) DEFAULT 0.0 NOT NULL,
    cena5 numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenazakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    desetinmj integer DEFAULT 0 NOT NULL,
    dokcesta character varying(255),
    dokprogram character varying(255),
    eankod character varying(20),
    evidvyrcis boolean DEFAULT false NOT NULL,
    unikvyrcis boolean DEFAULT false NOT NULL,
    vyloucitZJednaPlusJedna boolean DEFAULT false NOT NULL,
    exportnaeshop boolean DEFAULT true NOT NULL,
    hmotmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    hmotobal numeric(19,6) DEFAULT 0.0 NOT NULL,
    inevid boolean DEFAULT false NOT NULL,
    inkodsled character varying(50),
    inkoefmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    inkoefstat numeric(19,6) DEFAULT 0.0 NOT NULL,
    kodplu character varying(20),
    limmnoz2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz3 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz4 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz5 numeric(19,6) DEFAULT 0.0 NOT NULL,
    mjkoef2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    mjkoef3 numeric(19,6) DEFAULT 0.0,
    mjzarukyk character varying(50),
    minmarzecenik boolean DEFAULT false NOT NULL,
    minmarze numeric(6,2) DEFAULT 0.0 NOT NULL,
    nakupcena numeric(19,6) DEFAULT 0.0 NOT NULL,
    objem numeric(19,6) DEFAULT 0.0 NOT NULL,
    pocetPriloh integer not null default 0,
    popisa text,
    popisb text,
    popisc text,
    proczakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento3 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento4 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento5 numeric(6,2) DEFAULT 0.0 NOT NULL,
    prodejmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    skladove boolean DEFAULT FALSE NOT NULL,
    typcenydphk character varying(50),
    typcenyvychozi25k character varying(50),
    typcenyvychozik character varying(50),
    typprodejk character varying(50),
    typszbdphk character varying(50),
    typvypceny25k character varying(50),
    typvypcenyk character varying(50),
    typzasobyk character varying(50) NOT NULL,
    wkatalog character varying(20),
    wnahrat boolean DEFAULT false NOT NULL,
    wneni boolean DEFAULT false NOT NULL,
    wnovinka boolean DEFAULT false NOT NULL,
    wobrmini character varying(255),
    wobrnormal character varying(255),
    wpriprav boolean DEFAULT false NOT NULL,
    wskladem boolean DEFAULT false NOT NULL,
    wsleva numeric(6,2) DEFAULT 0.0 NOT NULL,
    wslevado date,
    wslevaod date,
    wtopcena boolean DEFAULT false NOT NULL,
    wvyprodej boolean DEFAULT false NOT NULL,
    www character varying(255),
    wzmena boolean DEFAULT false NOT NULL,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    zaruka integer DEFAULT 0 NOT NULL,
    zatrid character varying(255),
    cenabezna numeric(19,6) NOT NULL DEFAULT 0.0,
    evidsarze boolean DEFAULT false NOT NULL,
    evidexpir boolean DEFAULT false NOT NULL,
    dnyTrvanPoExpir integer DEFAULT 0 NOT NULL,
    neseskupovatobj boolean DEFAULT false NOT NULL,
    kratkyPopis text,
    klicSlova character varying(255),
    techParam text,
    prodejkasa boolean DEFAULT true NOT NULL,
    idmj1 integer,
    idskupzboz integer,
    idstatu integer,
    idnomen integer,
    idmjobj integer,
    idmj2 integer,
    idmj3 integer,
    idmjhmot integer,
    iddodavatel integer,
    idvyrobce integer,
    dodaciLhuta numeric(19,6),
    idMjDodaciLhuta integer,
    ciselnyKodZbozi character varying(255),
    druhZbozi character varying(255),
    eettypplatbyk character varying(50)
);


ALTER TABLE public.ccenik OWNER TO %firmaRole%;

--
-- TOC entry 1863 (class 1259 OID 237702)
-- Dependencies: 3
-- Name: seq_cmerjed; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_cmerjed
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_cmerjed OWNER TO %firmaRole%;

--
-- TOC entry 1864 (class 1259 OID 237704)
-- Dependencies: 2356 2357 2358 2359 2360 3
-- Name: cmerjed; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE cmerjed (
    idmj integer DEFAULT nextval('seq_cmerjed'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    kodtisk  character varying(20),
    kodtiska character varying(20),
    kodtiskb character varying(20),
    kodtiskc character varying(20),
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    typmjk character varying(50),
    normalMjK character varying(50),
    uuid character varying(50)
);


ALTER TABLE public.cmerjed OWNER TO %firmaRole%;

--
-- TOC entry 1997 (class 1259 OID 238837)
-- Dependencies: 3
-- Name: seq_cskupzboz; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_cskupzboz
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_cskupzboz OWNER TO %firmaRole%;

--
-- TOC entry 1865 (class 1259 OID 237715)
-- Dependencies: 2361 2362 2363 2364 2365 2366 2367 2368 2369 2370 2371 2372 2373 2374 3
-- Name: cskupzboz; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE cskupzboz (
    idskupzboz integer DEFAULT nextval('seq_cskupzboz'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    limmnoz2 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz3 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz4 numeric(19,6) DEFAULT 0.0 NOT NULL,
    limmnoz5 numeric(19,6) DEFAULT 0.0 NOT NULL,
    hlidatminmarzi boolean DEFAULT false NOT NULL,
    minmarze numeric(6,2) DEFAULT 0.0 NOT NULL,
    proczakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento3 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento4 numeric(6,2) DEFAULT 0.0 NOT NULL,
    procento5 numeric(6,2) DEFAULT 0.0 NOT NULL,
    typcenydphk character varying(50),
    typcenyvychozi25k character varying(50),
    typcenyvychozik character varying(50),
    typvypceny25k character varying(50),
    typvypcenyk character varying(50),
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    workflow boolean NOT NULL DEFAULT false,
    danevidk character varying(50),
    idprotiucetvfa integer,
    idprotiucetpfa integer,
    idprotiucetsklv integer,
    idprotiucetsklp integer,
    idprotiucetsklholyv integer,
    idprotiucetsklprevv integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.cskupzboz OWNER TO %firmaRole%;


-----------------------------------------------------------------------
--
-- TOC entry 1866 (class 1259 OID 237734)
-- Dependencies: 3
-- Name: seq_dbversion; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dbversion
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dbversion OWNER TO %firmaRole%;

--
-- TOC entry 1867 (class 1259 OID 237736)
-- Dependencies: 2375 2376 2377 3
-- Name: dbversion; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dbversion (
    iddbversion integer DEFAULT nextval('seq_dbversion'::regclass) NOT NULL,
    dbversion integer DEFAULT 0 NOT NULL,
    needreimport boolean DEFAULT false,
    appversion character varying(512) NOT NULL DEFAULT 'UNKNOWN',
    upgradetime timestamp without time zone DEFAULT NULL
);


ALTER TABLE public.dbversion OWNER TO %firmaRole%;

--
-- TOC entry 1868 (class 1259 OID 237742)
-- Dependencies: 3
-- Name: seq_ddoklfak; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ddoklfak
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ddoklfak OWNER TO %firmaRole%;

--
-- TOC entry 1869 (class 1259 OID 237744)
-- Dependencies: 2378 2379 2380 2381 2382 2383 2384 2385 2386 2387 2388 2389 2390 2391 2392 2393 2394 2395 2396 2397 2398 2399 2400 2401 2402 2403 2404 2405 2406 2407 2408 2409 2410 3
-- Name: ddoklfak; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ddoklfak (
    iddoklfak integer DEFAULT nextval('seq_ddoklfak'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    bezpolozek boolean DEFAULT false NOT NULL,
    bic character varying(255),
    buc character varying(255),
    cisdodak character varying(30),
    cisdosle character varying(30),
    cisobj text,
    cissml character varying(30),
    datobj date,
    datreal date,
    datsplat date,
    dattermin date,
    datucto date,
    datuhr date,
    datvyst date NOT NULL,
    dic character varying(20),
    doprava character varying(255),
    duzppuv date,
    duzpucto date,
    eankod character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    fanazev character varying(255),
    faeankod character varying(20),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    iban character varying(255),
    ic character varying(20),
    kod character varying(20) NOT NULL,
    kurz numeric(19,6) DEFAULT 0.0 NOT NULL,
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    mesto character varying(255),
    modul character varying(3) NOT NULL,
    nazfirmy character varying(255),
    pocetPriloh integer not null default 0,
    popis text,
    poznam text,
    psc character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    specsym character varying(255),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    sumcelkem numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumcelkemmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosv numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosvmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumNaklady numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphzakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    typpohybuk character varying(50) NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    ulice character varying(255),
    uuid character varying(50),
    uvodtxt text,
    uzpTuzemsko boolean DEFAULT false NOT NULL,
    varsym character varying(30),
    zamekk character varying(50) DEFAULT 'zamek.otevreno',
    zavtxt text,
    zuctovano boolean DEFAULT false NOT NULL,
    danevidk character varying(50),
    datsmir date,
    datup1 date,
    datup2 date,
    datPenale date,
    formauhrk character varying(50),
    juhdat numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhdatmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhsum numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhsummen numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhsumpp numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhsumppmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumprepl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumpreplmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    podpisprik boolean DEFAULT false NOT NULL,
    prikazsum numeric(15,2) DEFAULT 0.0,
    prikazsummen numeric(15,2) DEFAULT 0.0 NOT NULL,
    stavodpocetk character varying(50),
    stavuhrk character varying(50),
    sumzalohy numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzalohymen numeric(15,2) DEFAULT 0.0 NOT NULL,
    idfirmy integer,
    idfastatu integer,
    iddphsnizucet integer,
    iddphsniz2ucet integer,
    idsazbydphzakl integer,
    idprimucet integer,
    iduziv integer,
    idtypdokl integer NOT NULL,
    idstaturc integer,
    iddodpodm integer,
    idkonsym integer,
    idstred integer,
    idsazbydphosv integer,
    idsazbydphsniz integer,
    idsazbydphsniz2 integer,
    idrady integer,
    iddphzaklucet integer,
    idpolrady integer,
    idstatpuvod integer,
    idzakazky integer,
    idzvlpoh integer,
    idstatu integer,
    idobchtrans integer,
    idclendph integer,
    idstatodesl integer,
    idmur integer,
    idsmerkod integer,
    idstatdph integer,
    iddruhdopr integer,
    idmeny integer,
    idbanspojdod integer,
    idkrajurc integer,
    idprotiucet integer,
    idtypucop integer,
    vatid character varying(20),
    generovatSkl boolean DEFAULT true NOT NULL,
    zdrojProSkl boolean NOT NULL DEFAULT true,
    hromfakt boolean DEFAULT false NOT NULL,
    zaokrjaksumk character varying(50),
    zaokrnasumk character varying(50),
    zaokrjakdphk character varying(50),
    zaokrnadphk character varying(50),
    dphsnizkoef boolean DEFAULT false NOT NULL,
    dphsniz2koef boolean DEFAULT false NOT NULL,
    dphzaklkoef boolean DEFAULT false NOT NULL,
    prodejka boolean NOT NULL DEFAULT false,
    stavmailk character varying(50),
    vyloucitsaldo boolean NOT NULL DEFAULT false,
    zakazplatba boolean NOT NULL DEFAULT false,
    idbsp integer,
    idbspban integer,
    idcinnost integer,
    idsmlouvy integer,
    idtypdoklskl integer,
    idzodposoba integer,
    idkontaktosoba integer,
    idformauhradycis integer,
    idformauhradyciskasa integer,
    idformadopravy integer,
    kontaktJmeno character varying(255),
    kontaktTel character varying(255),
    kontaktEmail character varying(255),
    ekokomK character varying(50),
    balikpocet integer DEFAULT 0,
    balikvytvxml boolean NOT NULL DEFAULT false,
    balikzacislovan boolean NOT NULL DEFAULT false,
    dobropisovano boolean NOT NULL DEFAULT false,
    iddodatna integer,
    idclenkonvykdph integer,
    osobUpravaDph boolean NOT NULL DEFAULT false,
    osobUpravaDphDodavatel boolean NOT NULL DEFAULT false,
    eetpokladnizarizeni character varying(20),
    eetprovozovna integer,
    eetdicpoverujiciho character varying(20),
    eettypk character varying(50),
    eetstavk character varying(50),
    eetfik text,
    eetpkp text,
    eetdatcastrzby timestamp without time zone,
    eettisknoutpkp boolean not null Default true,
    eetbkp text,
    odpocAuto boolean NOT NULL DEFAULT false
);


ALTER TABLE public.ddoklfak OWNER TO %firmaRole%;

--
-- TOC entry 1870 (class 1259 OID 237783)
-- Dependencies: 3
-- Name: seq_ddoklint; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ddoklint
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ddoklint OWNER TO %firmaRole%;

--
-- TOC entry 1871 (class 1259 OID 237785)
-- Dependencies: 2411 2412 2413 2414 2415 2416 2417 2418 2419 2420 2421 2422 2423 2424 2425 2426 2427 2428 2429 2430 2431 2432 2433 2434 2435 3
-- Name: ddoklint; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ddoklint (
    iddoklint integer DEFAULT nextval('seq_ddoklint'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    bezpolozek boolean DEFAULT false NOT NULL,
    bic character varying(255),
    buc character varying(255),
    cisdodak character varying(30),
    cisdosle character varying(30),
    cisobj text,
    cissml character varying(30),
    datobj date,
    datreal date,
    datsplat date,
    dattermin date,
    datucto date,
    datuhr date,
    datvyst date NOT NULL,
    dic character varying(20),
    doprava character varying(255),
    duzppuv date,
    duzpucto date,
    eankod character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    fanazev character varying(255),
    faeankod character varying(20),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    formauhrk character varying(50),
    iban character varying(255),
    ic character varying(20),
    kod character varying(20) NOT NULL,
    kurz numeric(19,6) DEFAULT 0.0 NOT NULL,
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    mesto character varying(255),
    modul character varying(3) NOT NULL,
    nazfirmy character varying(255),
    pocetPriloh integer not null default 0,
    popis text,
    poznam text,
    psc character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    specsym character varying(255),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    sumcelkem numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumcelkemmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosv numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosvmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumNaklady numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphzakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    typpohybuk character varying(50) NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    ulice character varying(255),
    uuid character varying(50),
    uvodtxt text,
    uzpTuzemsko boolean DEFAULT false NOT NULL,
    varsym character varying(30),
    zamekk character varying(50) DEFAULT 'zamek.otevreno',
    zavtxt text,
    zuctovano boolean DEFAULT false NOT NULL,
    danevidk character varying(50),
    jakuhrk character varying(50),
    sparovano boolean DEFAULT false NOT NULL,
    idclendph integer,
    idsazbydphosv integer,
    idzakazky integer,
    idobchtrans integer,
    idmur integer,
    idstatodesl integer,
    idfirmy integer,
    iddodpodm integer,
    idkonsym integer,
    idsazbydphzakl integer,
    idstatdph integer,
    iddruhdopr integer,
    idzvlpoh integer,
    idpolrady integer,
    idstatpuvod integer,
    idtypdokl integer NOT NULL,
    iduziv integer,
    idmeny integer,
    idfastatu integer,
    idsmerkod integer,
    idbanspojdod integer,
    idstaturc integer,
    idstred integer,
    idkrajurc integer,
    idprimucet integer,
    idstatu integer,
    idrady integer,
    iddphzaklucet integer,
    idsazbydphsniz integer,
    idsazbydphsniz2 integer,
    idprotiucet integer,
    iddphsnizucet integer,
    iddphsniz2ucet integer,
    idtypucop integer,
    vatid character varying(20),
    generovatSkl boolean DEFAULT true NOT NULL,
    zdrojProSkl boolean NOT NULL DEFAULT true,
    generacemzdy boolean DEFAULT false NOT NULL,
    zaokrjaksumk character varying(50),
    zaokrnasumk character varying(50),
    zaokrjakdphk character varying(50),
    zaokrnadphk character varying(50),
    dphsnizkoef boolean DEFAULT false NOT NULL,
    dphsniz2koef boolean DEFAULT false NOT NULL,
    dphzaklkoef boolean DEFAULT false NOT NULL,
    vyloucitsaldo boolean NOT NULL DEFAULT false,
    vypishash character varying(255),
    vypiscisdokl character varying(50),
    idbsp integer,
    idbspban integer,
    idcinnost integer,
    idsmlouvy integer,
    zapocet boolean DEFAULT false NOT null,
    idtypdoklskl integer,
    idzodposoba integer,
    idkontaktosoba integer,
    idformauhradycis integer,
    idformadopravy integer,
    kontaktJmeno character varying(255),
    kontaktTel character varying(255),
    kontaktEmail character varying(255),
    ekokomK character varying(50),
    balikpocet integer DEFAULT 0,
    balikvytvxml boolean NOT NULL DEFAULT false,
    balikzacislovan boolean NOT NULL DEFAULT false,
    iddodatna integer,
    idclenkonvykdph integer,
    osobUpravaDph boolean NOT NULL DEFAULT false,
    cissouhrnne character varying(30),
    eetpokladnizarizeni character varying(20),
    eetprovozovna integer,
    eetdicpoverujiciho character varying(20),
    eettypk character varying(50),
    eetstavk character varying(50),
    eetfik text,
    eetpkp text,
    eetdatcastrzby timestamp without time zone,
    eettisknoutpkp boolean not null Default true,
    eetbkp text
);


ALTER TABLE public.ddoklint OWNER TO %firmaRole%;

--
-- TOC entry 1998 (class 1259 OID 241512)
-- Dependencies: 3
-- Name: seq_ddoklobch; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ddoklobch
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ddoklobch OWNER TO %firmaRole%;

--
-- TOC entry 2000 (class 1259 OID 241516)
-- Dependencies: 2951 2952 2953 2954 2955 2956 2957 2958 2959 2960 2961 2962 2963 2964 2965 2966 2967 2968 2969 2970 2971 2972 2973 2974 2975 2976 2977 2978 3
-- Name: ddoklobch; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ddoklobch (
    iddoklobch integer DEFAULT nextval('seq_ddoklobch'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    bezpolozek boolean DEFAULT false NOT NULL,
    bic character varying(255),
    buc character varying(255),
    cisdodak character varying(30),
    cisdosle character varying(30),
    cisobj text,
    cissml character varying(30),
    datobj date,
    datreal date,
    datsplat date,
    dattermin date,
    datucto date,
    datuhr date,
    datvyst date NOT NULL,
    dic character varying(20),
    doprava character varying(255),
    duzppuv date,
    duzpucto date,
    eankod character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    fanazev character varying(255),
    faeankod character varying(20),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    iban character varying(255),
    ic character varying(20),
    kod character varying(20) NOT NULL,
    kurz numeric(19,6) DEFAULT 0.0 NOT NULL,
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    mesto character varying(255),
    modul character varying(3) NOT NULL,
    nazfirmy character varying(255),
    pocetPriloh integer not null default 0,
    popis text,
    poznam text,
    psc character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    specsym character varying(255),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    sumcelkem numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumcelkemmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosv numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosvmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphzakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    typpohybuk character varying(50) NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    ulice character varying(255),
    uuid character varying(50),
    uvodtxt text,
    uzpTuzemsko boolean DEFAULT false NOT NULL,
    varsym character varying(30),
    zamekk character varying(50) DEFAULT 'zamek.otevreno',
    zavtxt text,
    zuctovano boolean DEFAULT false NOT NULL,
    formauhrk character varying(50),
    juhsum numeric(15,2) DEFAULT 0.0 NOT NULL,
    juhsummen numeric(15,2) DEFAULT 0.0 NOT NULL,
    procreal numeric(6,2) DEFAULT 0.0 NOT NULL,
    sumnaklady numeric(15,2) DEFAULT 0.0 NOT NULL,
    faktsouhrn boolean DEFAULT false NOT NULL,
    fakttxt text,
    idzvlpoh integer,
    idstred integer,
    iduziv integer,
    idsmerkod integer,
    idstatodesl integer,
    idkrajurc integer,
    idmur integer,
    idsazbydphsniz integer,
    idsazbydphsniz2 integer,
    idsazbydphzakl integer,
    idprotiucet integer,
    idbanspojdod integer,
    idfirmy integer,
    idclendph integer,
    idmeny integer,
    iddphzaklucet integer,
    idprimucet integer,
    idtypdokl integer NOT NULL,
    idobchtrans integer,
    idkonsym integer,
    iddruhdopr integer,
    idfastatu integer,
    iddodpodm integer,
    idtypdoklnabfak integer,
    idzakazky integer,
    idstatu integer,
    idstatpuvod integer,
    idstaturc integer,
    idstatdph integer,
    idpolrady integer,
    idrady integer,
    iddphsnizucet integer,
    iddphsniz2ucet integer,
    idsazbydphosv integer,
    idtypucop integer,
    vatid character varying(20),
    zaokrjaksumk character varying(50),
    zaokrnasumk character varying(50),
    zaokrjakdphk character varying(50),
    zaokrnadphk character varying(50),
    dphsnizkoef boolean DEFAULT false NOT NULL,
    dphsniz2koef boolean DEFAULT false NOT NULL,
    dphzaklkoef boolean DEFAULT false NOT NULL,
    vyloucitsaldo boolean NOT NULL DEFAULT false,
    idbsp integer,
    idbspban integer,
    idcinnost integer,
    idsmlouvy integer,
    idtypdoklskl integer,
    idzodposoba integer,
    idkontaktosoba integer,
    idformauhradycis integer,
    idformadopravy integer,
    kontaktJmeno character varying(255),
    kontaktTel character varying(255),
    kontaktEmail character varying(255),
    ekokomK character varying(50),
    idskladcil integer,
    balikpocet integer DEFAULT 0,
    balikvytvxml boolean NOT NULL DEFAULT false,
    balikzacislovan boolean NOT NULL DEFAULT false,
    iddodatna integer,
    idclenkonvykdph integer
);


ALTER TABLE public.ddoklobch OWNER TO %firmaRole%;

--
-- TOC entry 1872 (class 1259 OID 237816)
-- Dependencies: 3
-- Name: seq_ddoklsklad; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ddoklsklad
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ddoklsklad OWNER TO %firmaRole%;

--
-- TOC entry 1873 (class 1259 OID 237818)
-- Dependencies: 2436 2437 2438 2439 2440 2441 2442 2443 2444 2445 2446 2447 2448 2449 2450 2451 2452 2453 2454 2455 2456 2457 2458 2459 3
-- Name: ddoklsklad; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ddoklsklad (
    iddoklsklad integer DEFAULT nextval('seq_ddoklsklad'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    bezpolozek boolean DEFAULT false NOT NULL,
    bic character varying(255),
    buc character varying(255),
    cisdodak character varying(30),
    cisdosle character varying(30),
    cisobj text,
    cissml character varying(30),
    datobj date,
    datreal date,
    datsplat date,
    dattermin date,
    datucto date,
    datuhr date,
    datvyst date NOT NULL,
    dic character varying(20),
    doprava character varying(255),
    duzppuv date,
    duzpucto date,
    eankod character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    fanazev character varying(255),
    faeankod character varying(20),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    iban character varying(255),
    ic character varying(20),
    kod character varying(20) NOT NULL,
    kurz numeric(19,6) DEFAULT 0.0 NOT NULL,
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    mesto character varying(255),
    modul character varying(3) NOT NULL,
    nazfirmy character varying(255),
    pocetPriloh integer not null default 0,
    popis text,
    poznam text,
    psc character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    specsym character varying(255),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    sumcelkem numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumcelkemmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosv numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumosvmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsnizmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzaklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    szbdphzakl numeric(6,2) DEFAULT 0.0 NOT NULL,
    sumNaklady numeric(15,2) DEFAULT 0.0 NOT NULL,
    typpohybuk character varying(50) NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    ulice character varying(255),
    uuid character varying(50),
    uvodtxt text,
    uzpTuzemsko boolean DEFAULT false NOT NULL,
    varsym character varying(30),
    zamekk character varying(50) DEFAULT 'zamek.otevreno',
    zavtxt text,
    zuctovano boolean DEFAULT false NOT NULL,
    idstatdph integer,
    idstatpuvod integer,
    idprotiucet integer,
    idtypdokl integer NOT NULL,
    idstaturc integer,
    iddodpodm integer,
    idkrajurc integer,
    idsazbydphsniz integer,
    idsazbydphsniz2 integer,
    idstred integer,
    iddphsnizucet integer,
    iddphsniz2ucet integer,
    idbanspojdod integer,
    idstatodesl integer,
    iddphzaklucet integer,
    idmur integer,
    idpolrady integer,
    idobchtrans integer,
    idrady integer,
    idzvlpoh integer,
    idsazbydphosv integer,
    idzakazky integer,
    idsazbydphzakl integer,
    idstatu integer,
    idprimucet integer,
    idfirmy integer,
    idmeny integer,
    idfastatu integer,
    idsmerkod integer,
    iduziv integer,
    idclendph integer,
    idkonsym integer,
    iddruhdopr integer,
    idtypucop integer,
    vatid character varying(20),
    zaokrjaksumk character varying(50),
    zaokrnasumk character varying(50),
    zaokrjakdphk character varying(50),
    zaokrnadphk character varying(50),
    hromfakt boolean DEFAULT false NOT NULL,
    dphsnizkoef boolean DEFAULT false NOT NULL,
    dphsniz2koef boolean DEFAULT false NOT NULL,
    dphzaklkoef boolean DEFAULT false NOT NULL,
    zdrojProFak boolean NOT NULL DEFAULT true,
    stavSkladK character varying(50),
    typPohybuSkladK character varying(50),
    vyloucitsaldo boolean NOT NULL DEFAULT false,
    idbsp integer,
    idbspban integer,
    idcinnost integer,
    idsmlouvy integer,
    idtypdoklskl integer,
    idzodposoba integer,
    idkontaktosoba integer,
    idformadopravy integer,
    kontaktJmeno character varying(255),
    kontaktTel character varying(255),
    kontaktEmail character varying(255),
    ekokomK character varying(50),
    idskladcil integer,
    balikpocet integer DEFAULT 0,
    balikvytvxml boolean NOT NULL DEFAULT false,
    balikzacislovan boolean NOT NULL DEFAULT false,
    idinventura integer,
    iddodatna integer,
    idclenkonvykdph integer
);


ALTER TABLE public.ddoklsklad OWNER TO %firmaRole%;

--
-- TOC entry 1874 (class 1259 OID 237848)
-- Dependencies: 3
-- Name: seq_delbanformat; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_delbanformat
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_delbanformat OWNER TO %firmaRole%;

--
-- TOC entry 1875 (class 1259 OID 237850)
-- Dependencies: 2460 2461 2462 2463 2464 3
-- Name: delbanformat; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE delbanformat (
    idelbanformat integer DEFAULT nextval('seq_delbanformat'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    formatprikaz character varying(255),
    formatprikazzahr character varying(255),
    formatvypis character varying(255),
    priprikaz character varying(50),
    priprikazzahr character varying(50),
    privypis character varying(50),
    kodovanivypis character varying(50)
);


ALTER TABLE public.delbanformat OWNER TO %firmaRole%;

--
-- TOC entry 1876 (class 1259 OID 237861)
-- Dependencies: 3
-- Name: seq_dkonsym; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dkonsym
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dkonsym OWNER TO %firmaRole%;

--
-- TOC entry 1877 (class 1259 OID 237863)
-- Dependencies: 2465 2466 2467 2468 2469 3
-- Name: dkonsym; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dkonsym (
    idkonsym integer DEFAULT nextval('seq_dkonsym'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.dkonsym OWNER TO %firmaRole%;

--
-- TOC entry 1878 (class 1259 OID 237874)
-- Dependencies: 3
-- Name: seq_dpolfak; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dpolfak
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dpolfak OWNER TO %firmaRole%;

--
-- TOC entry 1879 (class 1259 OID 237876)
-- Dependencies: 2470 2471 2472 2473 2474 2475 2476 2477 2478 2479 2480 2481 2482 2483 2484 2485 2486 2487 2488 2489 2490 2491 2492 2493 2494 2495 2496 2497 2498 2499 2500 2501 2502 2503 2504 2505 2506 2507 3
-- Name: dpolfak; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dpolfak (
    idpolfak integer DEFAULT nextval('seq_dpolfak'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    autozaokr boolean DEFAULT false NOT NULL,
    autogen boolean DEFAULT false NOT NULL,
    baleniid integer DEFAULT 0 NOT NULL,
    cenjednotka numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamj numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjceniktuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    cisrad integer DEFAULT 0 NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    eankod character varying(20),
    expirace date,
    dattrvan date,
    datvyroby date,
    kod character varying(20),
    kopclendph boolean DEFAULT true NOT NULL,
    kopdphdalucet boolean DEFAULT true NOT NULL,
    kopdphmducet boolean DEFAULT true NOT NULL,
    kopklice boolean DEFAULT true NOT NULL,
    kopstred boolean DEFAULT true NOT NULL,
    kopzakazku boolean DEFAULT true NOT NULL,
    kopzkldalucet boolean DEFAULT true NOT NULL,
    kopzklmducet boolean DEFAULT true NOT NULL,
    koptypucop boolean DEFAULT true NOT NULL,
    kopdanevid boolean DEFAULT true NOT NULL,
    kopcinnost boolean DEFAULT true NOT NULL,
    kopdatucto boolean DEFAULT true NOT NULL,
    mnozbaleni numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjplan numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjreal numeric(19,6) DEFAULT 0.0 NOT NULL,
    modul character varying(3) NOT NULL,
    nazev character varying(255),
    nazevA character varying(255),
    nazevB character varying(255),
    nazevC character varying(255),
    objednatk character varying(50),
    objem numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznam text,
    proczakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    rezervovat boolean DEFAULT false NOT NULL,
    sarze character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevamnoz numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevapol numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    stornopol boolean DEFAULT false NOT NULL,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdph numeric(6,2) DEFAULT 0.0 NOT NULL,
    typcenydphk character varying(50),
    typpolozkyk character varying(50) NOT NULL,
    typszbdphk character varying(50),
    typvypcenyk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    uplslevadokl boolean DEFAULT false NOT NULL,
    vyrobnicislaok boolean not null default false,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    zaloha boolean DEFAULT false NOT NULL,
    idstred integer,
    idmeny integer,
    idzkldalucet integer,
    idclendph integer,
    idzakazky integer,
    iddphmducet integer,
    iddoklfak integer NOT NULL,
    idmj integer,
    idbspskl integer,
    idfirmy integer,
    idzklmducet integer,
    idcenik integer,
    idcenhlad integer,
    iddphdalucet integer,
    idsazbydph integer,
    idsazbydphpuv integer,
    idmjobjem integer,
    idtypucop integer,
    danevidk character varying(50),
    idcinnost integer,
    idpolfakpoplatek integer,
    zdrojProSkl boolean NOT NULL DEFAULT true,
    prodejka boolean NOT NULL DEFAULT false,
    idpoldobropis integer,
    ekokomK character varying(50),
    kopEkokom boolean NOT NULL DEFAULT true,
    idclenkonvykdph integer,
    kopclenkonvykdph boolean NOT NULL DEFAULT true,
    ciselnyKodZbozi character varying(255),
    druhZbozi character varying(255),
    sumVedlNaklIntrMen numeric(19,6) DEFAULT 0.0 NOT NULL,
    eettypplatbyk character varying(50)
);


ALTER TABLE public.dpolfak OWNER TO %firmaRole%;

--
-- TOC entry 1880 (class 1259 OID 237919)
-- Dependencies: 3
-- Name: seq_dpolint; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dpolint
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dpolint OWNER TO %firmaRole%;

--
-- TOC entry 1881 (class 1259 OID 237921)
-- Dependencies: 2508 2509 2510 2511 2512 2513 2514 2515 2516 2517 2518 2519 2520 2521 2522 2523 2524 2525 2526 2527 2528 2529 2530 2531 2532 2533 2534 2535 2536 2537 2538 2539 2540 2541 2542 2543 2544 2545 3
-- Name: dpolint; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dpolint (
    idpolint integer DEFAULT nextval('seq_dpolint'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    autozaokr boolean DEFAULT false NOT NULL,
    autogen boolean DEFAULT false NOT NULL,
    baleniid integer DEFAULT 0 NOT NULL,
    cenjednotka numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamj numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjceniktuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    cisrad integer DEFAULT 0 NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    eankod character varying(20),
    expirace date,
    dattrvan date,
    datvyroby date,
    kod character varying(20),
    kopclendph boolean DEFAULT true NOT NULL,
    kopdphdalucet boolean DEFAULT true NOT NULL,
    kopdphmducet boolean DEFAULT true NOT NULL,
    kopklice boolean DEFAULT true NOT NULL,
    kopstred boolean DEFAULT true NOT NULL,
    kopzakazku boolean DEFAULT true NOT NULL,
    kopzkldalucet boolean DEFAULT true NOT NULL,
    kopzklmducet boolean DEFAULT true NOT NULL,
    koptypucop boolean DEFAULT true NOT NULL,
    kopdanevid boolean DEFAULT true NOT NULL,
    kopcinnost boolean DEFAULT true NOT NULL,
    kopdatucto boolean DEFAULT true NOT NULL,
    mnozbaleni numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjplan numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjreal numeric(19,6) DEFAULT 0.0 NOT NULL,
    modul character varying(3) NOT NULL,
    nazev character varying(255),
    nazevA character varying(255),
    nazevB character varying(255),
    nazevC character varying(255),
    objednatk character varying(50),
    objem numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznam text,
    proczakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    rezervovat boolean DEFAULT false NOT NULL,
    sarze character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevamnoz numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevapol numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    stornopol boolean DEFAULT false NOT NULL,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdph numeric(6,2) DEFAULT 0.0 NOT NULL,
    typcenydphk character varying(50),
    typpolozkyk character varying(50) NOT NULL,
    typszbdphk character varying(50),
    typvypcenyk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    uplslevadokl boolean DEFAULT false NOT NULL,
    vyrobnicislaok boolean not null default false,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    idzklmducet integer,
    idsazbydph integer,
    idsazbydphpuv integer,
    iddphmducet integer,
    idmj integer,
    idzkldalucet integer,
    iddoklint integer NOT NULL,
    iddphdalucet integer,
    idbspskl integer,
    idclendph integer,
    idmeny integer,
    idzakazky integer,
    idmjobjem integer,
    idfirmy integer,
    idstred integer,
    idcenik integer,
    idcenhlad integer,
    idtypucop integer,
    danevidk character varying(50),
    idcinnost integer,
    generacemzdy boolean DEFAULT false NOT NULL,
    idpolintpoplatek integer,
    idpoldobropis integer,
    zdrojProSkl boolean NOT NULL DEFAULT true,
    ekokomK character varying(50),
    kopEkokom boolean NOT NULL DEFAULT true,
    idclenkonvykdph integer,
    kopclenkonvykdph boolean NOT NULL DEFAULT true,
    ciselnyKodZbozi character varying(255),
    druhZbozi character varying(255),
    zapocet boolean NOT NULL DEFAULT false,
    eettypplatbyk character varying(50)
);


ALTER TABLE public.dpolint OWNER TO %firmaRole%;

--
-- TOC entry 1999 (class 1259 OID 241514)
-- Dependencies: 3
-- Name: seq_dpolobch; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dpolobch
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dpolobch OWNER TO %firmaRole%;

--
-- TOC entry 2001 (class 1259 OID 241550)
-- Dependencies: 2979 2980 2981 2982 2983 2984 2985 2986 2987 2988 2989 2990 2991 2992 2993 2994 2995 2996 2997 2998 2999 3000 3001 3002 3003 3004 3005 3006 3007 3008 3009 3010 3011 3012 3013 3014 3015 3
-- Name: dpolobch; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dpolobch (
    idpolobch integer DEFAULT nextval('seq_dpolobch'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    autozaokr boolean DEFAULT false NOT NULL,
    autogen boolean DEFAULT false NOT NULL,
    baleniid integer DEFAULT 0 NOT NULL,
    cenjednotka numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamj numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjceniktuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    cisrad integer DEFAULT 0 NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    eankod character varying(20),
    expirace date,
    dattrvan date,
    datvyroby date,
    kod character varying(20),
    kopclendph boolean DEFAULT true NOT NULL,
    kopdphdalucet boolean DEFAULT true NOT NULL,
    kopdphmducet boolean DEFAULT true NOT NULL,
    kopklice boolean DEFAULT true NOT NULL,
    kopstred boolean DEFAULT true NOT NULL,
    kopzakazku boolean DEFAULT true NOT NULL,
    kopzkldalucet boolean DEFAULT true NOT NULL,
    kopzklmducet boolean DEFAULT true NOT NULL,
    koptypucop boolean DEFAULT true NOT NULL,
    kopcinnost boolean DEFAULT true NOT NULL,
    kopdatucto boolean DEFAULT true NOT NULL,
    mnozbaleni numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjplan numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjreal numeric(19,6) DEFAULT 0.0 NOT NULL,
    modul character varying(3) NOT NULL,
    nazev character varying(255),
    nazevA character varying(255),
    nazevB character varying(255),
    nazevC character varying(255),
    objednatk character varying(50),
    objednanomj numeric(19,6) NOT NULL DEFAULT 0.0,
    objem numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznam text,
    proczakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    rezervovat boolean DEFAULT false NOT NULL,
    sarze character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevamnoz numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevapol numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    stornopol boolean DEFAULT false NOT NULL,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdph numeric(6,2) DEFAULT 0.0 NOT NULL,
    typcenydphk character varying(50),
    typpolozkyk character varying(50) NOT NULL,
    typszbdphk character varying(50),
    typvypcenyk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    uplslevadokl boolean DEFAULT false NOT NULL,
    vyrobnicislaok boolean not null default false,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    neseskupovatobj boolean DEFAULT false NOT NULL,
    idstred integer,
    idzkldalucet integer,
    idsazbydph integer,
    idsazbydphpuv integer,
    iddphmducet integer,
    idbspskl integer,
    idfirmy integer,
    iddphdalucet integer,
    idmjobjem integer,
    idmj integer,
    idcenik integer,
    idcenhlad integer,
    idzklmducet integer,
    idclendph integer,
    idzakazky integer,
    idmeny integer,
    iddoklobch integer NOT NULL,
    idtypucop integer,
    idcinnost integer,
    idpolobchpoplatek integer,
    rezervovatmj numeric(19,6) NOT NULL DEFAULT 0.0,
    idpoldobropis integer,
    ekokomK character varying(50),
    kopEkokom boolean NOT NULL DEFAULT true,
    idclenkonvykdph integer,
    kopclenkonvykdph boolean NOT NULL DEFAULT true,
    ciselnyKodZbozi character varying(255),
    druhZbozi character varying(255)
);


ALTER TABLE public.dpolobch OWNER TO %firmaRole%;

--
-- TOC entry 1882 (class 1259 OID 237964)
-- Dependencies: 3
-- Name: seq_dpolprikazuhr; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dpolprikazuhr
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dpolprikazuhr OWNER TO %firmaRole%;

--
-- TOC entry 1883 (class 1259 OID 237966)
-- Dependencies: 2546 2547 2548 3
-- Name: dpolprikazuhr; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dpolprikazuhr (
    idpolprikazuhr integer DEFAULT nextval('seq_dpolprikazuhr'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    bic character varying(255),
    buc character varying(255),
    castka numeric(15,2) DEFAULT 0.0 NOT NULL,
    datsplat date,
    iban character varying(255),
    kod character varying(255),
    konsym character varying(20),
    kontakt character varying(255),
    mestobanky character varying(255),
    mestoprijem character varying(255),
    nazbanky character varying(255),
    nazprijem character varying(255),
    popis text,
    poplatekk character varying(50),
    poznam text,
    pscbanky character varying(255),
    pscprijem character varying(255),
    specsymprijem character varying(255),
    specsymprikaz character varying(255),
    ulicebanky character varying(255),
    uliceprijem character varying(255),
    varsymprijem character varying(30),
    varsymprikaz character varying(30),
    idstatubanky integer,
    idstatuprijem integer,
    idmeny integer,
    idprikazuhr integer NOT NULL,
    idprimdokl integer,
    idsmerkod integer
);


ALTER TABLE public.dpolprikazuhr OWNER TO %firmaRole%;

--
-- TOC entry 1884 (class 1259 OID 237975)
-- Dependencies: 3
-- Name: seq_dpolsklad; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dpolsklad
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dpolsklad OWNER TO %firmaRole%;

--
-- TOC entry 1885 (class 1259 OID 237977)
-- Dependencies: 2549 2550 2551 2552 2553 2554 2555 2556 2557 2558 2559 2560 2561 2562 2563 2564 2565 2566 2567 2568 2569 2570 2571 2572 2573 2574 2575 2576 2577 2578 2579 2580 2581 2582 2583 2584 2585 3
-- Name: dpolsklad; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dpolsklad (
    idpolsklad integer DEFAULT nextval('seq_dpolsklad'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    autozaokr boolean DEFAULT false NOT NULL,
    autogen boolean DEFAULT false NOT NULL,
    baleniid integer DEFAULT 0 NOT NULL,
    cenjednotka numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamj numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjskl numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjneskl numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjporiz numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjnakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenamjceniktuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    cenyrucne boolean DEFAULT false NOT NULL,
    cisrad integer DEFAULT 0 NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    datsklad timestamp DEFAULT clock_timestamp() NOT NULL,
    eankod character varying(20),
    expirace date,
    dattrvan date,
    datvyroby date,
    kod character varying(20),
    kopclendph boolean DEFAULT true NOT NULL,
    kopdphdalucet boolean DEFAULT true NOT NULL,
    kopdphmducet boolean DEFAULT true NOT NULL,
    kopklice boolean DEFAULT true NOT NULL,
    kopstred boolean DEFAULT true NOT NULL,
    kopzakazku boolean DEFAULT true NOT NULL,
    kopzkldalucet boolean DEFAULT true NOT NULL,
    kopzklmducet boolean DEFAULT true NOT NULL,
    koptypucop boolean DEFAULT true NOT NULL,
    kopcinnost boolean DEFAULT true NOT NULL,
    kopdatucto boolean DEFAULT true NOT NULL,
    mnozbaleni numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjplan numeric(19,6) DEFAULT 0.0 NOT NULL,
    mnozmjreal numeric(19,6) DEFAULT 0.0 NOT NULL,
    modul character varying(3) NOT NULL,
    nazev character varying(255),
    nazevA character varying(255),
    nazevB character varying(255),
    nazevC character varying(255),
    objednatk character varying(50),
    objem numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznam text,
    prevodka boolean DEFAULT false NOT NULL,
    proczakl numeric(19,6) DEFAULT 0.0 NOT NULL,
    rezervovat boolean DEFAULT false NOT NULL,
    sarze character varying(255),
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevamnoz numeric(6,2) DEFAULT 0.0 NOT NULL,
    slevapol numeric(6,2) DEFAULT 0.0 NOT NULL,
    source character varying(50),
    stavuzivk character varying(50),
    storno boolean DEFAULT false NOT NULL,
    stornopol boolean DEFAULT false NOT NULL,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdph numeric(6,2) DEFAULT 0.0 NOT NULL,
    typcenydphk character varying(50),
    typpolozkyk character varying(50) NOT NULL,
    typszbdphk character varying(50),
    typvypcenyk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    uplslevadokl boolean DEFAULT false NOT NULL,
    vyrobnicislaok boolean not null default false,
    zaokrjakk character varying(50),
    zaokrnak character varying(50),
    idzkldalucet integer,
    iddphdalucet integer,
    idmjobjem integer,
    idmeny integer,
    idstred integer,
    idkarty integer NOT NULL,
    idcenik integer,
    idcenhlad integer,
    idzklmducet integer,
    iddphmducet integer,
    idsazbydph integer,
    idsazbydphpuv integer,
    idclendph integer,
    idzakazky integer,
    idmj integer,
    iddoklsklad integer NOT NULL,
    idbspskl integer,
    idfirmy integer,
    idtypucop integer,
    idcinnost integer,
    zdrojProFak boolean NOT NULL DEFAULT true,
    idpoldobropis integer,
    ekokomK character varying(50),
    kopEkokom boolean NOT NULL DEFAULT true,
    idclenkonvykdph integer,
    kopclenkonvykdph boolean NOT NULL DEFAULT true,
    ciselnyKodZbozi character varying(255),
    druhZbozi character varying(255)
);


ALTER TABLE public.dpolsklad OWNER TO %firmaRole%;

--
-- TOC entry 1886 (class 1259 OID 238020)
-- Dependencies: 3
-- Name: seq_dprikazuhr; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dprikazuhr
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dprikazuhr OWNER TO %firmaRole%;

--
-- TOC entry 1887 (class 1259 OID 238022)
-- Dependencies: 2586 2587 2588 2589 2590 3
-- Name: dprikazuhr; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dprikazuhr (
    idprikazuhr integer DEFAULT nextval('seq_dprikazuhr'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    celcastka numeric(15,2) DEFAULT 0.0,
    datsplat date,
    datvytvor date,
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    jmenosoub character varying(255),
    konsym character varying(20),
    nazfirmy character varying(255),
    poradiprikaz integer DEFAULT 0 NOT NULL,
    stavprikazk character varying(50),
    zahranicni boolean DEFAULT false,
    typprikazk character varying(50),
    bezpopisu boolean DEFAULT false,
    idbanka integer NOT NULL,
    idmeny integer NOT NULL,
    idfastatu integer
);


ALTER TABLE public.dprikazuhr OWNER TO %firmaRole%;

--
-- TOC entry 1888 (class 1259 OID 238033)
-- Dependencies: 3
-- Name: seq_drady; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_drady
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_drady OWNER TO %firmaRole%;

--
-- TOC entry 1889 (class 1259 OID 238035)
-- Dependencies: 2591 2592 2593 2594 2595 3
-- Name: drady; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE drady (
    idrady integer DEFAULT nextval('seq_drady'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    modul character varying(3) NOT NULL,
    typpohybuk character varying(50),
    uuid character varying(50)
);


ALTER TABLE public.drady OWNER TO %firmaRole%;

--
-- TOC entry 1890 (class 1259 OID 238046)
-- Dependencies: 3
-- Name: seq_dradydiry; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dradydiry
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dradydiry OWNER TO %firmaRole%;

--
-- TOC entry 1891 (class 1259 OID 238048)
-- Dependencies: 2596 2597 3
-- Name: dradydiry; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dradydiry (
    idradydiry integer DEFAULT nextval('seq_dradydiry'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    cisdira character varying(20) NOT NULL,
    idradyrok integer NOT NULL
);


ALTER TABLE public.dradydiry OWNER TO %firmaRole%;

--
-- TOC entry 1892 (class 1259 OID 238053)
-- Dependencies: 3
-- Name: seq_dradyrok; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dradyrok
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dradyrok OWNER TO %firmaRole%;

--
-- TOC entry 1893 (class 1259 OID 238055)
-- Dependencies: 2598 2599 2600 2601 2602 2603 3
-- Name: dradyrok; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dradyrok (
    idradyrok integer DEFAULT nextval('seq_dradyrok'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    cisakt integer DEFAULT 0 NOT NULL,
    cisdelka integer DEFAULT 0 NOT NULL,
    cispoc integer DEFAULT 0 NOT NULL,
    postfix character varying(50),
    prefix character varying(50),
    zobraznuly boolean DEFAULT true NOT NULL,
    iducetobdobi integer NOT NULL,
    idrady integer NOT NULL
);


ALTER TABLE public.dradyrok OWNER TO %firmaRole%;

--
-- TOC entry 1894 (class 1259 OID 238064)
-- Dependencies: 3
-- Name: seq_dtypdokl; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dtypdokl
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dtypdokl OWNER TO %firmaRole%;

--
-- TOC entry 1895 (class 1259 OID 238066)
-- Dependencies: 2604 2605 2606 2607 2608 2609 2610 2611 2612 2613 2614 3
-- Name: dtypdokl; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dtypdokl (
    idtypdokl integer DEFAULT nextval('seq_dtypdokl'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    doprava character varying(255),
    popisdoklad text,
    uvodtxt text,
    zavtxt text,
    formauhrk character varying(50),
    modul character varying(3) NOT NULL,
    slevadokl numeric(6,2) DEFAULT 0.0 NOT NULL,
    splatdny integer,
    typdoklk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    zaokrjakdphk character varying(50),
    zaokrjaksumk character varying(50),
    zaokrnadphk character varying(50),
    zaokrnasumk character varying(50),
    workflow boolean NOT NULL DEFAULT false,
    idradyprijem integer,
    idstatpuvod integer,
    idstatodesl integer,
    idobchtrans integer,
    idradyvydej integer,
    iducetobdobiod integer,
    idstatdph integer,
    idkonsym integer,
    iddruhdopr integer,
    idprimucet integer,
    idzvlpoh integer,
    idstred integer,
    idcinnost integer,
    idmeny integer,
    idkrajurc integer,
    iducetobdobido integer,
    iddodpodm integer,
    idstaturc integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    idtypucopp integer,
    idtypucopv integer,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    razeniProTiskK character varying(50),
    tiskautomat boolean NOT NULL DEFAULT false,
    primarni boolean NOT NULL DEFAULT false,
    prodejka boolean NOT NULL DEFAULT false,
    cashRegister boolean NOT NULL DEFAULT false,
    zapocet boolean NOT NULL DEFAULT false,
    faktsouhrn boolean NOT NULL DEFAULT false,
    faktauto boolean NOT NULL DEFAULT false,
    uhrauto boolean NOT NULL DEFAULT false,
    zapauto boolean NOT NULL DEFAULT false,
    automail boolean NOT NULL DEFAULT false,
    umoznitrefun boolean NOT NULL DEFAULT true,
    idtypdoklpok integer,
    idbspskl integer,
    typpohybuk character varying(50),
    typpohybuskladk character varying(50),
    eanakcenahrat boolean NOT NULL DEFAULT false,
    eanakcepopis text,
    idbsp integer,
    idbspban integer,
    idtypprotidokladuprijem integer,
    idtypprotidokladuvydej integer,
    idtypdoklfak integer,
    idformauhradycis integer,
    idformadopravy integer,
    uuid character varying(50),
    emailtxt text,
    ekokomK character varying(50),
    vsCisObj boolean NOT NULL DEFAULT false,
    odpocAuto boolean NOT NULL DEFAULT false,
    idclenkonvykdph integer,
    jednaPlusJedna boolean NOT NULL DEFAULT false,
    eetlimit numeric(6,2),
    eetpokladnizarizeni character varying(20),
    eetprovozovna integer,
    eetdicpoverujiciho character varying(20),
    eettypk character varying(50)
);


ALTER TABLE public.dtypdokl OWNER TO %firmaRole%;

--
-- TOC entry 1896 (class 1259 OID 238080)
-- Dependencies: 3
-- Name: seq_dvazebtab; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_dvazebtab
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dvazebtab OWNER TO %firmaRole%;

--
-- TOC entry 1897 (class 1259 OID 238082)
-- Dependencies: 2615 2616 2617 2618 2619 3
-- Name: dvazebtab; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE dvazebtab (
    idvazby integer DEFAULT nextval('seq_dvazebtab'::regclass) NOT NULL,
    castka numeric(15,2) DEFAULT 0.0 NOT NULL,
    idtaba integer DEFAULT 0,
    idtabb integer DEFAULT 0,
    modula character varying(3) NOT NULL,
    modulb character varying(3) NOT NULL,
    storno boolean DEFAULT false,
    typvazbyk character varying(50)
);


ALTER TABLE public.dvazebtab OWNER TO %firmaRole%;

--
-- TOC entry 1898 (class 1259 OID 238090)
-- Dependencies: 3
-- Name: seq_idodpodm; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_idodpodm
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_idodpodm OWNER TO %firmaRole%;

--
-- TOC entry 1899 (class 1259 OID 238092)
-- Dependencies: 2620 2621 2622 2623 2624 3
-- Name: idodpodm; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE idodpodm (
    iddodpodm integer DEFAULT nextval('seq_idodpodm'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.idodpodm OWNER TO %firmaRole%;

--
-- TOC entry 1900 (class 1259 OID 238103)
-- Dependencies: 3
-- Name: seq_idruhdopr; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_idruhdopr
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_idruhdopr OWNER TO %firmaRole%;

--
-- TOC entry 1901 (class 1259 OID 238105)
-- Dependencies: 2625 2626 2627 2628 2629 3
-- Name: idruhdopr; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE idruhdopr (
    iddruhdopr integer DEFAULT nextval('seq_idruhdopr'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.idruhdopr OWNER TO %firmaRole%;

--
-- TOC entry 1902 (class 1259 OID 238116)
-- Dependencies: 3
-- Name: seq_iintrmerjed; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_iintrmerjed
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_iintrmerjed OWNER TO %firmaRole%;

--
-- TOC entry 1903 (class 1259 OID 238118)
-- Dependencies: 2630 2631 2632 2633 2634 3
-- Name: iintrmerjed; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE iintrmerjed (
    idintrmerjed integer DEFAULT nextval('seq_iintrmerjed'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.iintrmerjed OWNER TO %firmaRole%;

--
-- TOC entry 1904 (class 1259 OID 238129)
-- Dependencies: 3
-- Name: seq_ikrajurc; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ikrajurc
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ikrajurc OWNER TO %firmaRole%;

--
-- TOC entry 1905 (class 1259 OID 238131)
-- Dependencies: 2635 2636 2637 2638 2639 3
-- Name: ikrajurc; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ikrajurc (
    idkrajurc integer DEFAULT nextval('seq_ikrajurc'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.ikrajurc OWNER TO %firmaRole%;

--
-- TOC entry 1906 (class 1259 OID 238142)
-- Dependencies: 3
-- Name: seq_inomen; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_inomen
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_inomen OWNER TO %firmaRole%;

--
-- TOC entry 1907 (class 1259 OID 238144)
-- Dependencies: 2640 2641 2642 2643 2644 3
-- Name: inomen; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE inomen (
    idnomen integer DEFAULT nextval('seq_inomen'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50),
    idintrmerjed integer NOT NULL
);


ALTER TABLE public.inomen OWNER TO %firmaRole%;

--
-- TOC entry 1908 (class 1259 OID 238155)
-- Dependencies: 3
-- Name: seq_iobchtrans; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_iobchtrans
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_iobchtrans OWNER TO %firmaRole%;

--
-- TOC entry 1909 (class 1259 OID 238157)
-- Dependencies: 2645 2646 2647 2648 2649 3
-- Name: iobchtrans; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE iobchtrans (
    idobchtrans integer DEFAULT nextval('seq_iobchtrans'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.iobchtrans OWNER TO %firmaRole%;

--
-- TOC entry 1910 (class 1259 OID 238168)
-- Dependencies: 3
-- Name: seq_izvlpoh; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_izvlpoh
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_izvlpoh OWNER TO %firmaRole%;

--
-- TOC entry 1911 (class 1259 OID 238170)
-- Dependencies: 2650 2651 2652 2653 2654 3
-- Name: izvlpoh; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE izvlpoh (
    idzvlpoh integer DEFAULT nextval('seq_izvlpoh'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.izvlpoh OWNER TO %firmaRole%;

--
-- TOC entry 1912 (class 1259 OID 238181)
-- Dependencies: 3
-- Name: seq_mdannakl; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mdannakl
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mdannakl OWNER TO %firmaRole%;

--
-- TOC entry 1913 (class 1259 OID 238183)
-- Dependencies: 2655 2656 2657 2658 2659 3
-- Name: mdannakl; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mdannakl (
    iddannakl integer DEFAULT nextval('seq_mdannakl'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    kod character varying(20) NOT NULL,
    modul character varying(3) NOT NULL,
    poznam text,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    idzakazky integer,
    idstred integer NOT NULL,
    idzklmducet integer,
    idzkldalucet integer,
    idleasing integer NOT NULL
);


ALTER TABLE public.mdannakl OWNER TO %firmaRole%;

--
-- TOC entry 1914 (class 1259 OID 238194)
-- Dependencies: 3
-- Name: seq_mdanodpisy; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mdanodpisy
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mdanodpisy OWNER TO %firmaRole%;

--
-- TOC entry 1915 (class 1259 OID 238196)
-- Dependencies: 2660 2661 2662 2663 2664 2665 2666 3
-- Name: mdanodpisy; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mdanodpisy (
    iddanodpisu integer DEFAULT nextval('seq_mdanodpisy'::regclass) NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    kod character varying(20) NOT NULL,
    modul character varying(3) NOT NULL,
    poznam text,
    starimaj integer DEFAULT 0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    zamek boolean DEFAULT false NOT NULL,
    zmena boolean DEFAULT false NOT NULL,
    zustpoodp numeric(15,2) DEFAULT 0.0 NOT NULL,
    idstred integer NOT NULL,
    idmajetku integer NOT NULL,
    idzakazky integer,
    idzklmducet integer,
    idzkldalucet integer
);


ALTER TABLE public.mdanodpisy OWNER TO %firmaRole%;

--
-- TOC entry 1916 (class 1259 OID 238209)
-- Dependencies: 3
-- Name: seq_mleasing; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mleasing
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mleasing OWNER TO %firmaRole%;

--
-- TOC entry 1917 (class 1259 OID 238211)
-- Dependencies: 2667 2668 2669 2670 2671 2672 2673 2674 2675 2676 2677 2678 2679 3
-- Name: mleasing; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mleasing (
    idleasing integer DEFAULT nextval('seq_mleasing'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    cena numeric(15,2) DEFAULT 0.0 NOT NULL,
    cidporiz character varying(20) DEFAULT 0 NOT NULL,
    datkoupe date NOT NULL,
    datvyroby date,
    druhk character varying(50) NOT NULL,
    eankod character varying(20),
    frekdannaklk character varying(50),
    mjzarukyk character varying(50),
    pocetdannakl integer DEFAULT 0 NOT NULL,
    pocetsplatek integer DEFAULT 0 NOT NULL,
    sumsplaceno numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzbyva numeric(15,2) DEFAULT 0.0 NOT NULL,
    vyrcis character varying(20),
    zamek boolean DEFAULT false NOT NULL,
    zaruka integer DEFAULT 0 NOT NULL,
    pocetPriloh integer not null default 0,
    vozcislo character varying(255),
    vozspz character varying(255),
    vozznacka character varying(255),
    vozmodel character varying(255),
    voztyp character varying(255),
    vozobjem numeric(15,2) NOT NULL DEFAULT 0.0,
    vozhavar character varying(255),
    vozhavarvyse numeric(15,2) NOT NULL DEFAULT 0.0,
    vozvybava text,
    idzakazky integer,
    idfirmyvyr integer,
    idcasucet integer,
    idstred integer NOT NULL,
    idzavazucet integer,
    idmeny integer,
    iddphzaklucet integer,
    iddphsnizucet integer,
    idtypleas integer NOT NULL,
    idnaklucet integer,
    idfirmydod integer,
    iduziv integer
);


ALTER TABLE public.mleasing OWNER TO %firmaRole%;

--
-- TOC entry 1918 (class 1259 OID 238229)
-- Dependencies: 3
-- Name: seq_mmajetek; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mmajetek
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mmajetek OWNER TO %firmaRole%;

--
-- TOC entry 1919 (class 1259 OID 238231)
-- Dependencies: 2680 2681 2682 2683 2684 2685 2686 2687 2688 2689 2690 2691 2692 2693 2694 3
-- Name: mmajetek; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mmajetek (
    idmajetku integer DEFAULT nextval('seq_mmajetek'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    cena numeric(15,2) DEFAULT 0.0 NOT NULL,
    cidporiz character varying(20),
    datkoupe date NOT NULL,
    datudalvyr date,
    datudalzar date,
    datvyroby date,
    datzacdan date,
    datzacucet date,
    datzar date,
    druhk character varying(50) NOT NULL,
    eankod character varying(20),
    kusysoubor integer DEFAULT 0 NOT NULL,
    mjzarukyk character varying(50),
    nahrucetodpk character varying(50),
    predpisucetodp numeric(15,2) DEFAULT 0.0 NOT NULL,
    staripor integer DEFAULT 0 NOT NULL,
    staritechzhod integer DEFAULT 0 NOT NULL,
    techzhod boolean DEFAULT false NOT NULL,
    vyrcis character varying(20),
    zamek boolean DEFAULT false NOT NULL,
    zamekk character varying(50) DEFAULT 'zamek.otevreno',
    zaruka integer DEFAULT 0 NOT NULL,
    zpusodpk character varying(50),
    zpuspor character varying(255),
    zustdan numeric(15,2) DEFAULT 0.0 NOT NULL,
    zustucet numeric(15,2) DEFAULT 0.0 NOT NULL,
    zvyszrychk character varying(50),
    pocetPriloh integer not null default 0,
    skp character varying(50),
    katastruzemi character varying(255),
    parcela character varying(255),
    vozcislo character varying(255),
    vozspz character varying(255),
    vozznacka character varying(255),
    vozmodel character varying(255),
    voztyp character varying(255),
    vozobjem numeric(15,2) NOT NULL DEFAULT 0.0,
    vozhavar character varying(255),
    vozhavarvyse numeric(15,2) NOT NULL DEFAULT 0.0,
    vozvybava text,
    idfirmydod integer,
    idfirmyvyr integer,
    idodpucet integer,
    idzakazky integer,
    iddoklfak integer,
    idprotiucetzar integer,
    idstred integer NOT NULL,
    idtypmaj integer NOT NULL,
    idprimucet integer,
    idopravucet integer,
    idzustvyrazucet integer,
    idumismist integer,
    idumissekce integer,
    idsazby integer,
    idumisobj integer,
    iduziv integer
);


ALTER TABLE public.mmajetek OWNER TO %firmaRole%;

--
-- TOC entry 1920 (class 1259 OID 238252)
-- Dependencies: 3
-- Name: seq_msazby; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_msazby
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_msazby OWNER TO %firmaRole%;

--
-- TOC entry 1921 (class 1259 OID 238254)
-- Dependencies: 2695 2696 2697 2698 2699 2700 2701 2702 2703 2704 2705 2706 2707 2708 2709 3
-- Name: msazby; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE msazby (
    idsazby integer DEFAULT nextval('seq_msazby'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    dobaodp integer DEFAULT 0 NOT NULL,
    koefzrodp1 integer DEFAULT 0 NOT NULL,
    koefzrodpdalsi integer DEFAULT 0 NOT NULL,
    koefzrodpzvceny integer DEFAULT 0 NOT NULL,
    mindobaodp integer DEFAULT 0 NOT NULL,
    prcroodp1 numeric(6,2) DEFAULT 0.0 NOT NULL,
    prcroodpdalsi numeric(6,2) DEFAULT 0.0 NOT NULL,
    prcroodpzvceny numeric(6,2) DEFAULT 0.0 NOT NULL,
    typodpk character varying(50),
    zamek boolean DEFAULT false NOT NULL,
    zmena boolean DEFAULT true NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.msazby OWNER TO %firmaRole%;

--
-- TOC entry 1922 (class 1259 OID 238275)
-- Dependencies: 3
-- Name: seq_msplatkal; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_msplatkal
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_msplatkal OWNER TO %firmaRole%;

--
-- TOC entry 1923 (class 1259 OID 238277)
-- Dependencies: 2710 2711 2712 2713 2714 2715 2716 2717 2718 3
-- Name: msplatkal; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE msplatkal (
    idsplatkal integer DEFAULT nextval('seq_msplatkal'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    clensplk character varying(50),
    datucto date,
    datvyst date NOT NULL,
    kod character varying(20) NOT NULL,
    modul character varying(3) NOT NULL,
    poznam text,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    szbdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    typsplk character varying(50),
    typszbdphk character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    iddphdalucet integer,
    idzakazky integer,
    idzklmducet integer,
    idleasing integer NOT NULL,
    idzkldalucet integer,
    idstatdph integer NOT NULL,
    idstred integer NOT NULL,
    iddphmducet integer,
    idclendph integer NOT NULL,
    iddoklfak integer,
    cisrad integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.msplatkal OWNER TO %firmaRole%;

--
-- TOC entry 1924 (class 1259 OID 238291)
-- Dependencies: 3
-- Name: seq_mtypleas; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mtypleas
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mtypleas OWNER TO %firmaRole%;

--
-- TOC entry 1925 (class 1259 OID 238293)
-- Dependencies: 2719 2720 2721 2722 3
-- Name: mtypleas; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mtypleas (
    idtypleas integer DEFAULT nextval('seq_mtypleas'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    druhk character varying(50),
    workflow boolean NOT NULL DEFAULT false,
    iddphsnizucet integer,
    idzakazky integer,
    iducetobdobiod integer,
    idcasucet integer,
    idnaklucet integer,
    iddphzaklucet integer,
    iducetobdobido integer,
    idstred integer,
    idzavazucet integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.mtypleas OWNER TO %firmaRole%;

--
-- TOC entry 1926 (class 1259 OID 238302)
-- Dependencies: 3
-- Name: seq_mtypmaj; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mtypmaj
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mtypmaj OWNER TO %firmaRole%;

--
-- TOC entry 1927 (class 1259 OID 238304)
-- Dependencies: 2723 2724 2725 2726 2727 3
-- Name: mtypmaj; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mtypmaj (
    idtypmaj integer DEFAULT nextval('seq_mtypmaj'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    druhk character varying(50),
    jeodpis boolean DEFAULT true NOT NULL,
    workflow boolean NOT NULL DEFAULT false,
    idodpucet integer,
    idopravucet integer,
    idprotiucetzar integer,
    iducetobdobido integer,
    idstred integer,
    iducetobdobiod integer,
    idzakazky integer,
    idprimucet integer,
    idzustvyrazucet integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.mtypmaj OWNER TO %firmaRole%;

--
-- TOC entry 1928 (class 1259 OID 238314)
-- Dependencies: 3
-- Name: seq_mucetodpisy; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mucetodpisy
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mucetodpisy OWNER TO %firmaRole%;

--
-- TOC entry 1929 (class 1259 OID 238316)
-- Dependencies: 2728 2729 2730 2731 2732 2733 3
-- Name: mucetodpisy; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mucetodpisy (
    iducetodpisu integer DEFAULT nextval('seq_mucetodpisy'::regclass) NOT NULL,
    datucto date,
    datvyst date NOT NULL,
    kod character varying(20) NOT NULL,
    modul character varying(3) NOT NULL,
    poznam text,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    zamek boolean DEFAULT false NOT NULL,
    zmena boolean DEFAULT false NOT NULL,
    zustpoodp numeric(15,2) DEFAULT 0.0 NOT NULL,
    idzkldalucet integer,
    idzklmducet integer,
    idzakazky integer,
    idmajetku integer NOT NULL,
    idstred integer NOT NULL
);


ALTER TABLE public.mucetodpisy OWNER TO %firmaRole%;

--
-- TOC entry 1930 (class 1259 OID 238328)
-- Dependencies: 3
-- Name: seq_mudalosti; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mudalosti
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mudalosti OWNER TO %firmaRole%;

--
-- TOC entry 1931 (class 1259 OID 238330)
-- Dependencies: 2734 2735 2736 2737 2738 2739 2740 2741 2742 3
-- Name: mudalosti; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mudalosti (
    idudalosti integer DEFAULT nextval('seq_mudalosti'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    datucto date NOT NULL,
    datvyst date NOT NULL,
    kod character varying(20) NOT NULL,
    modul character varying(3) NOT NULL,
    poznam text,
    sumdph numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzkl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklmen numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphdanove numeric(15,2) DEFAULT 0.0 NOT NULL,
    typudalostik character varying(50),
    ucetni boolean DEFAULT false NOT NULL,
    zamek boolean DEFAULT false NOT NULL,
    zmenadobyodpis integer DEFAULT 0 NOT NULL,
    zmena boolean not null Default false,
    idzkldalucet integer,
    idstred integer,
    idmajetku integer NOT NULL,
    idzakazky integer,
    iddphmducet integer,
    iddphdalucet integer,
    idzklmducet integer
);


ALTER TABLE public.mudalosti OWNER TO %firmaRole%;

--
-- TOC entry 1932 (class 1259 OID 238345)
-- Dependencies: 3
-- Name: seq_mumisteni; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mumisteni
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mumisteni OWNER TO %firmaRole%;

--
-- TOC entry 1933 (class 1259 OID 238347)
-- Dependencies: 2743 2744 2745 2746 2747 3
-- Name: mumisteni; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mumisteni (
    idumisteni integer DEFAULT nextval('seq_mumisteni'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.mumisteni OWNER TO %firmaRole%;

--
-- TOC entry 1934 (class 1259 OID 238358)
-- Dependencies: 3
-- Name: seq_mzapujcky; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_mzapujcky
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_mzapujcky OWNER TO %firmaRole%;

--
-- TOC entry 1935 (class 1259 OID 238360)
-- Dependencies: 2748 2749 3
-- Name: mzapujcky; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE mzapujcky (
    idzapujcky integer DEFAULT nextval('seq_mzapujcky'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    datkonec date,
    datzahaj date,
    email character varying(255),
    fax character varying(255),
    jmeno character varying(255),
    mesto character varying(255),
    mobil character varying(255),
    poznam text,
    prijmeni character varying(255),
    psc character varying(255),
    tel character varying(255),
    ulice character varying(255),
    www character varying(255),
    idleasing integer,
    idstatu integer,
    idmajetku integer,
    idosoby integer
);


ALTER TABLE public.mzapujcky OWNER TO %firmaRole%;

--
-- TOC entry 1938 (class 1259 OID 238374)
-- Dependencies: 3
-- Name: seq_nnastav; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_nnastav
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_nnastav OWNER TO %firmaRole%;

--
-- TOC entry 1939 (class 1259 OID 238376)
-- Dependencies: 2751 2752 2753 2754 2755 2756 2757 2758 2759 2760 2761 2762 2763 3
-- Name: nnastav; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE nnastav (
    idnastav integer DEFAULT nextval('seq_nnastav'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    autozakazka boolean DEFAULT false NOT NULL,
    avsmerkod character varying(255),
    avtrankod character varying(255),
    cinnost character varying(255),
    dic character varying(20),
    eankod character varying(20),
    elpokexport character varying(255),
    elpokimport character varying(255),
    elpokini character varying(255),
    email character varying(255),
    datovaSchranka character varying(10),
    famesto character varying(255),
    fapsc character varying(255),
    faulice character varying(255),
    facispop character varying(255),
    facisor character varying(255),
    fakturacniShodna boolean DEFAULT true NOT NULL,
    postUlice character varying(255),
    postCisPop character varying(50),
    postCisOr character varying(50),
    postMesto character varying(255),
    postPsc character varying(255),
    fax character varying(255),
    fyzosoba boolean DEFAULT false NOT NULL,
    fyzOsJmeno character varying(255),
    fyzOsPrijmeni character varying(255),
    fyzOsTitul character varying(50),
    fyzOsTitulZa character varying(50),
    ic character varying(20),
    intrastat boolean DEFAULT false NOT NULL,
    mesto character varying(255),
    mobil character varying(255),
    nazfirmy character varying(255),
    oprjmeno character varying(255),
    oprpostav character varying(255),
    oprprijmeni character varying(255),
    platcedph boolean DEFAULT false NOT NULL,
    moss boolean DEFAULT false NOT NULL,
    omezovatVyberStatu boolean DEFAULT true NOT NULL,
    platioddata date,
    podpisprik boolean DEFAULT false NOT NULL,
    podvojucto boolean DEFAULT true NOT NULL,
    typUcJednotkyK character varying(50),
    psc character varying(255),
    sklfifo boolean DEFAULT false NOT NULL,
    sklucto boolean DEFAULT false NOT NULL,
    sklGenerovatPozadavky boolean DEFAULT false NOT NULL,
    adrKontrolovatFirmy boolean DEFAULT true NOT NULL,
    sklAktualNakupCena boolean DEFAULT false NOT NULL,
    spisznac character varying(255),
    spisznaca character varying(255),
    spisznacb character varying(255),
    spisznacc character varying(255),
    splatdny integer DEFAULT 0 NOT NULL,
    splatdnynakup integer,
    tel character varying(255),
    ulice character varying(255),
    cispop character varying(50),
    cisor character varying(50),
    www character varying(255),
    zobrlogok character varying(50),
    idtdzbytekvynos integer,
    idstatu integer,
    idfastatu integer,
    idPostStatu integer,
    idtdfapzdd integer,
    idtdfavzdd integer,
    idstatuleg integer NOT NULL,
    idtdkurzrozvynos integer,
    idtdzbyteknaklad integer,
    idtdeppok integer,
    idtyporg integer NOT NULL,
    idtdobfav integer,
    idmeny integer NOT NULL,
    idtdkurzroznaklad integer,
    idtdepskl integer,
    pravformapodnik character varying(255),
    idtdobfavzal integer,
    idtdobfap integer,
    idtdobsklpri integer,
    idtdobsklvyd integer,
    idtdobnav integer,
    idtdobobp integer,
    idtdobobpEdi integer,
    idtdobppv integer,
    idtdobnap integer,
    idtdobobv integer,
    kurzdualmena numeric(19,6) DEFAULT 0.0 NOT NULL,
    idmenydual integer,
    doplnText text,
    idUcetZaokrNaklad integer,
    idUcetZaokrVynos integer,
    idUcetKrOdpoctuNaklad integer,
    idUcetKrOdpoctuVynos integer,
    idtdpreplphl integer,
    idtdpreplzav integer,
    vatid character varying(20),
    postovniShodna boolean DEFAULT true NOT NULL,
    jazyk1K character varying(50),
    jazyk2K character varying(50),
    jazyk3K character varying(50),
    jazyk4K character varying(50),
    logoPoziceK character varying(50),
    postMigrace boolean NOT NULL DEFAULT false,
    firmaUUID character varying(50),
    mzddnudovolabs numeric(10,6) DEFAULT 0.0,
    mzdpenzprip boolean NOT NULL DEFAULT false,
    mzdpenzpripproc numeric(10,6) DEFAULT 0.0,
    idmzdtdzavdansra integer,
    idmzdtdintnahrad integer,
    idmzdadrsocpoj integer,
    idmzdtdzavzdrav integer,
    idmzdtuozavsoczam integer,
    idmzdtdzavdanzal integer,
    idmzdtdzavdanrez integer,
    idmzdtuozavzdrfir integer,
    idmzdtdinthruba integer,
    idmzdtdzavsrazka integer,
    idmzdtdzavsoc integer,
    idmzdtdzavzaloha integer,
    idmzdtuozavzdrzam integer,
    idmzdtdzavdobirka integer,
    idmzdtuozavsocfir integer,
    idmzdadrdan integer,
    idmzdbandanzal integer,
    idmzdbandansra integer,
    idmzdbandanrez integer,
    idmzdtdintcestdolim integer,
    mzdsmenydnutydne integer,
    mzdsmenyhodindenne numeric(6,2) DEFAULT 0.0,
    mzdsmenypocpracdoby numeric(6,2) DEFAULT 0.0,
    mzdsmenysvatkyprum boolean DEFAULT true,
    mzdnemocproplatauto boolean DEFAULT true,
    mzdnemocproplatvarov boolean DEFAULT false,
    mzdrefundnahrnemoc boolean DEFAULT false,
    mzdpromilepovpojisteni numeric(6,2) DEFAULT 0.0,
    mzdispvokres character varying(20),
    mzdsplatdanrez integer,
    mzdsplatdansra integer,
    mzdsplatdanzal integer,
    mzdsplatdobirka integer,
    mzdsplatsocpoj integer,
    mzdsplatzdravpoj integer,
    mzdtydenpracdobak character varying(50),
    rezervovatzapor boolean NOT NULL DEFAULT false,
    rezimRezervaciK character varying(50) NOT NULL DEFAULT 'rezimRezervaci.rucni',
    idfinurad integer,
    idfukraj integer,
    idfuuzemprac integer,
    zastupceTypK character varying(50),
    zastupceKod character varying(255),
    zastupceNazev character varying(255),
    zastupceIc character varying(255),
    zastupcePrijmeni character varying(255),
    zastupceJmeno character varying(255),
    zastupceDatNar date,
    zastupceEvCislo character varying(255),
    rocniKurzK character varying(50),
    denniKurzK character varying(50),
    jakytypfavk character varying(50),
    jakytypphlk character varying(50),
    jakytypfapk character varying(50),
    jakytypzavk character varying(50),
    jakytypintk character varying(50),
    jakytyppppk character varying(50),
    jakytypnavk character varying(50),
    jakytypobpk character varying(50),
    jakytypppvk character varying(50),
    jakytypnapk character varying(50),
    jakytypobvk character varying(50),
    jakytypbank character varying(50),
    jakytyppokk character varying(50),
    jakytypsklk character varying(50),
    prepocetcenk character varying(50),
    manualCisDokl boolean NOT NULL DEFAULT false,
    prenfirstred boolean NOT NULL DEFAULT false,
    odpocneuhrzalfav boolean NOT NULL DEFAULT false,
    odpocneuhrzalfap boolean NOT NULL DEFAULT false,
    zaokrNulovaSazba boolean NOT NULL DEFAULT false,
    eanrealizaceobj boolean NOT NULL DEFAULT false,
    eantvorbafak boolean NOT NULL DEFAULT false,
    eantvorbaskl boolean NOT NULL DEFAULT false,
    osobUpravaDph boolean NOT NULL DEFAULT false,
    idtdbanprijem integer,
    idtdbanvydej integer,
    nace character varying(255),
    idTypDoklOsUpravaPrijem integer,
    idTypDoklOsUpravaVydej integer,
    idUcetOsUpravaDphSniz integer,
    idUcetOsUpravaDphZakl integer,
    idUcetOsUpravaZaklad integer,
    fapDatProDuzpUctoK character varying(50) NOT NULL DEFAULT 'fapDatProDuzpUctoK.duzpPuv',
    eetprovozovna integer,
    eetlimit numeric(6,2),
    eettypk character varying(50),
    eetmodk character varying(50),
    autoSendMailModK character varying(50),
    autoSendMailBccEmail character varying(255),
    idTdFapEdi integer,
    idTdSklEdi integer,
    sifrovaniPdf boolean not null default false,
    versionForCaching integer not null default 0,
    zobrazWebModK character varying(50) NOT NULL DEFAULT 'zobrazWebKompMod.auto'
);


ALTER TABLE public.nnastav OWNER TO %firmaRole%;

CREATE INDEX nNastav_IdUcetZaokrNaklad_index ON nNastav USING btree (idUcetZaokrNaklad);
CREATE INDEX nNastav_IdUcetZaokrVynos_index ON nNastav USING btree (idUcetZaokrVynos);

--
-- TOC entry 1940 (class 1259 OID 238394)
-- Dependencies: 3
-- Name: seq_nucetobdobi; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_nucetobdobi
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_nucetobdobi OWNER TO %firmaRole%;

--
-- TOC entry 1941 (class 1259 OID 238396)
-- Dependencies: 2764 2765 2766 2767 2768 3
-- Name: nucetobdobi; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE nucetobdobi (
    iducetobdobi integer DEFAULT nextval('seq_nucetobdobi'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    chybapreceneni boolean DEFAULT false NOT NULL,
    kod character varying(20) NOT NULL,
    platidodata date NOT NULL,
    platioddata date NOT NULL,
    popis text,
    poznam text,
    rokproradu integer DEFAULT 0 NOT NULL,
    zmenazaver boolean DEFAULT false NOT NULL
);


ALTER TABLE public.nucetobdobi OWNER TO %firmaRole%;

--
-- TOC entry 1942 (class 1259 OID 238410)
-- Dependencies: 3
-- Name: seq_skarty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_skarty
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_skarty OWNER TO %firmaRole%;

--
-- TOC entry 1943 (class 1259 OID 238412)
-- Dependencies: 2769 2770 2771 2772 2773 2774 2775 2776 2777 2778 2779 2780 2781 2782 2783 2784 2785 2786 2787 3
-- Name: skarty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE skarty (
    idkarty integer DEFAULT nextval('seq_skarty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    nazev character varying(255),
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    cenpopis text,
    cenpopisa text,
    cenpopisb text,
    cenpopisc text,
    cenpoznam text,
    datposl date,
    datstavmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    datstavmen numeric(19,6) DEFAULT 0.0 NOT NULL,
    datstavtuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    maxmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    minmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    pocatmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    pocatmen numeric(19,6) DEFAULT 0.0 NOT NULL,
    pocattuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    popis text,
    popisa text,
    popisb text,
    popisc text,
    poslcenamen numeric(19,6) DEFAULT 0.0 NOT NULL,
    poslcenatuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznamvelka text,
    prumcenamen numeric(19,6) DEFAULT 0.0 NOT NULL,
    prumcenatuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    rezervmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    stavmj numeric(19,6) DEFAULT 0.0 NOT NULL,
    stavMjSPozadavky numeric(19,6) DEFAULT 0.0 NOT NULL,
    pozadavkyMj numeric(19,6) DEFAULT 0.0 NOT NULL,
    stavmen numeric(19,6) DEFAULT 0.0 NOT NULL,
    stavtuz numeric(19,6) DEFAULT 0.0 NOT NULL,
    vydexpir boolean DEFAULT false NOT NULL,
    idskladu integer NOT NULL,
    idcenik integer NOT NULL,
    idmistnost integer,
    idregal integer,
    idpolice integer,
    iducetobdobi integer NOT NULL
);


ALTER TABLE public.skarty OWNER TO %firmaRole%;

--
-- TOC entry 1944 (class 1259 OID 238437)
-- Dependencies: 3
-- Name: seq_uclendph; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_uclendph
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_uclendph OWNER TO %firmaRole%;

--
-- TOC entry 1945 (class 1259 OID 238439)
-- Dependencies: 2788 2789 2790 2791 2792 2793 3
-- Name: uclendph; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE uclendph (
    idclendph integer DEFAULT nextval('seq_uclendph'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    jedph boolean DEFAULT false NOT NULL,
    kodplnenik character varying(50),
    typobchoduk character varying(50),
    typplnenik character varying(50),
    idstatu integer NOT NULL,
    poradi integer default 0,
    kodPlneniSH character varying(20),
    typplnenieetk character varying(50),
    uuid character varying(50)
);


ALTER TABLE public.uclendph OWNER TO %firmaRole%;

--
-- TOC entry 1946 (class 1259 OID 238451)
-- Dependencies: 3
-- Name: seq_ukurzy; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ukurzy
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ukurzy OWNER TO %firmaRole%;

--
-- TOC entry 1947 (class 1259 OID 238453)
-- Dependencies: 2794 2795 2796 2797 2798 2799 2800 2801 3
-- Name: ukurzy; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ukurzy (
    idkurzy integer DEFAULT nextval('seq_ukurzy'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    devnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    devprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    nbstred numeric(19,6) DEFAULT 0.0 NOT NULL,
    platioddata date,
    valnakup numeric(19,6) DEFAULT 0.0 NOT NULL,
    valprodej numeric(19,6) DEFAULT 0.0 NOT NULL,
    typkurzuk character varying(50) NOT NULL,
    idmeny integer NOT NULL
);


ALTER TABLE public.ukurzy OWNER TO %firmaRole%;

--
-- TOC entry 1948 (class 1259 OID 238464)
-- Dependencies: 3
-- Name: seq_umeny; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_umeny
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_umeny OWNER TO %firmaRole%;

--
-- TOC entry 1949 (class 1259 OID 238466)
-- Dependencies: 2802 2803 2804 2805 2806 2807 3
-- Name: umeny; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE umeny (
    idmeny integer DEFAULT nextval('seq_umeny'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    symbol character varying(20), 
    kurzmnozstvi numeric(19,6) DEFAULT 0.0 NOT NULL,
    zpusobStahKurzK character varying(50),
    uuid character varying(50)
);


ALTER TABLE public.umeny OWNER TO %firmaRole%;

--
-- TOC entry 1950 (class 1259 OID 238478)
-- Dependencies: 3
-- Name: seq_uobraty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_uobraty
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_uobraty OWNER TO %firmaRole%;

--
-- TOC entry 1951 (class 1259 OID 238480)
-- Dependencies: 2808 2809 2810 2811 2812 2813 3
-- Name: uobraty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE uobraty (
    idobrat integer DEFAULT nextval('seq_uobraty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    obdobi smallint DEFAULT 0,
    obrdal numeric(15,2) DEFAULT 0.0 NOT NULL,
    obrmd numeric(15,2) DEFAULT 0.0 NOT NULL,
    obrdalbck numeric(15,2),
    obrmdbck numeric(15,2),
    uzivnastav boolean DEFAULT false NOT NULL,
    rok smallint DEFAULT 0,
    idmeny integer NOT NULL,
    iducet integer NOT NULL,
    idstred integer NOT NULL,
    idcinnost integer,
    iducetobdobi integer,
    CONSTRAINT uobraty_unique_key UNIQUE (obdobi, rok, idmeny, iducet, idstred, idcinnost, iducetobdobi)
);


ALTER TABLE public.uobraty OWNER TO %firmaRole%;

--
-- TOC entry 1952 (class 1259 OID 238489)
-- Dependencies: 3
-- Name: seq_usazbydph; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usazbydph
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usazbydph OWNER TO %firmaRole%;

--
-- TOC entry 1953 (class 1259 OID 238491)
-- Dependencies: 2814 2815 2816 3
-- Name: usazbydph; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usazbydph (
    idsazbydph integer DEFAULT nextval('seq_usazbydph'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platidodata date,
    platioddata date NOT NULL,
    popis text,
    poznam text,
    szbdph numeric(6,2) DEFAULT 0.0 NOT NULL,
    typszbdphk character varying(50),
    idstatu integer NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.usazbydph OWNER TO %firmaRole%;

--
-- TOC entry 1954 (class 1259 OID 238500)
-- Dependencies: 3
-- Name: seq_usesradky; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usesradky
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usesradky OWNER TO %firmaRole%;

--
-- TOC entry 1955 (class 1259 OID 238502)
-- Dependencies: 2817 2818 2819 2820 2821 2822 2823 2824 2825 3
-- Name: usesradky; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usesradky (
    idsesradky integer DEFAULT nextval('seq_usesradky'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    cisrad integer DEFAULT 0 NOT NULL,
    hod1 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod3 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod4 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod5 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod6 numeric(15,2) DEFAULT 0.0 NOT NULL,
    kodrad character varying(20),
    cisradxml integer,
    nazev character varying(255),
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    oznaceni character varying(255),
    popis text,
    poznam text,
    idsestavy integer NOT NULL,
    zjednodusena boolean default false,
    zakladni boolean not null Default false
);


ALTER TABLE public.usesradky OWNER TO %firmaRole%;

--
-- TOC entry 1956 (class 1259 OID 238517)
-- Dependencies: 3
-- Name: seq_usesrozpaduce; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usesrozpaduce
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usesrozpaduce OWNER TO %firmaRole%;

--
-- TOC entry 1957 (class 1259 OID 238519)
-- Dependencies: 2826 2827 2828 2829 2830 2831 2832 2833 3
-- Name: usesrozpaduce; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usesrozpaduce (
    idsesrozpaduce integer DEFAULT nextval('seq_usesrozpaduce'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    hod1 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod3 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod4 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod5 numeric(15,2) DEFAULT 0.0 NOT NULL,
    hod6 numeric(15,2) DEFAULT 0.0 NOT NULL,
    idsesradky integer NOT NULL,
    iducet integer NOT NULL
);


ALTER TABLE public.usesrozpaduce OWNER TO %firmaRole%;

--
-- TOC entry 1958 (class 1259 OID 238530)
-- Dependencies: 3
-- Name: seq_usesstdpred; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usesstdpred
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usesstdpred OWNER TO %firmaRole%;

--
-- TOC entry 1959 (class 1259 OID 238532)
-- Dependencies: 2834 2835 2836 2837 2838 3
-- Name: usesstdpred; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usesstdpred (
    idsesstdpred integer DEFAULT nextval('seq_usesstdpred'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    cissloup integer DEFAULT 0 NOT NULL,
    druhuctuk character varying(50),
    jenkladne boolean DEFAULT false NOT NULL,
    prevratznam boolean DEFAULT false NOT NULL,
    zpusobvypk character varying(50),
    idstducet integer NOT NULL,
    idsesradky integer NOT NULL
);


ALTER TABLE public.usesstdpred OWNER TO %firmaRole%;

--
-- TOC entry 1960 (class 1259 OID 238540)
-- Dependencies: 3
-- Name: seq_usessumace; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usessumace
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usessumace OWNER TO %firmaRole%;

--
-- TOC entry 1961 (class 1259 OID 238542)
-- Dependencies: 2839 2840 2841 3
-- Name: usessumace; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usessumace (
    idsessumace integer DEFAULT nextval('seq_usessumace'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    prevratznam boolean DEFAULT false NOT NULL,
    idsesradkysum integer NOT NULL,
    idsesradky integer NOT NULL
);


ALTER TABLE public.usessumace OWNER TO %firmaRole%;

--
-- TOC entry 1962 (class 1259 OID 238548)
-- Dependencies: 3
-- Name: seq_usestavy; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usestavy
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usestavy OWNER TO %firmaRole%;

--
-- TOC entry 1963 (class 1259 OID 238550)
-- Dependencies: 2842 2843 2844 2845 2846 2847 2848 2849 2850 2851 2852 2853 2854 2855 2856 2857 2858 2859 2860 3
-- Name: usestavy; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usestavy (
    idsestavy integer DEFAULT nextval('seq_usestavy'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    nazevsloup1 character varying(255),
    nazevsloup2 character varying(255),
    nazevsloup3 character varying(255),
    nazevsloup4 character varying(255),
    nazevsloup5 character varying(255),
    nazevsloup6 character varying(255),
    nazevsloupa1 character varying(255),
    nazevsloupa2 character varying(255),
    nazevsloupa3 character varying(255),
    nazevsloupa4 character varying(255),
    nazevsloupa5 character varying(255),
    nazevsloupa6 character varying(255),
    nazevsloupb1 character varying(255),
    nazevsloupb2 character varying(255),
    nazevsloupb3 character varying(255),
    nazevsloupb4 character varying(255),
    nazevsloupb5 character varying(255),
    nazevsloupb6 character varying(255),
    nazevsloupc1 character varying(255),
    nazevsloupc2 character varying(255),
    nazevsloupc3 character varying(255),
    nazevsloupc4 character varying(255),
    nazevsloupc5 character varying(255),
    nazevsloupc6 character varying(255),
    sloupec3sum12 boolean DEFAULT false NOT NULL,
    sloupec6sum45 boolean DEFAULT false NOT NULL,
    standard boolean DEFAULT false NOT NULL,
    typsesk character varying(50),
    typvypsestavyk character varying(50),
    vypminobd boolean DEFAULT false NOT NULL,
    zobrazit1 boolean DEFAULT false NOT NULL,
    zobrazit2 boolean DEFAULT false NOT NULL,
    zobrazit3 boolean DEFAULT false NOT NULL,
    zobrazit4 boolean DEFAULT false NOT NULL,
    zobrazit5 boolean DEFAULT false NOT NULL,
    zobrazit6 boolean DEFAULT false NOT NULL,
    idtyporg integer NOT NULL,
    rokod integer DEFAULT 0,
    rokdo integer DEFAULT 0,
    mesicod integer DEFAULT 0,
    mesicdo integer DEFAULT 0,
    predrokod integer DEFAULT 0,
    predrokdo integer DEFAULT 0,
    predmesicod integer DEFAULT 0,
    predmesicdo integer DEFAULT 0,
    datvypocet date,
    idradcil integer,
    idseszdroj integer,
    idradzdroj integer,
    uuid character varying(50),
    idradrozdil1 integer,
    idradrozdil2 integer,
    idradzaokr2 integer,
    idradzaokr1 integer,
    strediska text,
    typJednotkyMikro boolean DEFAULT false NOT NULL
);


ALTER TABLE public.usestavy OWNER TO %firmaRole%;

--
-- TOC entry 1964 (class 1259 OID 238575)
-- Dependencies: 3
-- Name: seq_usesuzivpred; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_usesuzivpred
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_usesuzivpred OWNER TO %firmaRole%;

--
-- TOC entry 1965 (class 1259 OID 238577)
-- Dependencies: 2861 2862 2863 2864 2865 3
-- Name: usesuzivpred; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE usesuzivpred (
    idsesuzivpred integer DEFAULT nextval('seq_usesuzivpred'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    cissloup integer DEFAULT 0 NOT NULL,
    jenkladne boolean DEFAULT false NOT NULL,
    prevratznam boolean DEFAULT false NOT NULL,
    zpusobvypk character varying(50),
    idsesradky integer NOT NULL,
    iducet integer NOT NULL
);


ALTER TABLE public.usesuzivpred OWNER TO %firmaRole%;

--
-- TOC entry 1966 (class 1259 OID 238585)
-- Dependencies: 3
-- Name: seq_ustducty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ustducty
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ustducty OWNER TO %firmaRole%;

--
-- TOC entry 1967 (class 1259 OID 238587)
-- Dependencies: 2866 2867 2868 2869 2870 2871 3
-- Name: ustducty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ustducty (
    idstducet integer DEFAULT nextval('seq_ustducty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    druhuctuk character varying(50),
    saldo boolean DEFAULT false NOT NULL,
    typuctuk character varying(50),
    idtyporg integer NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.ustducty OWNER TO %firmaRole%;

--
-- TOC entry 1968 (class 1259 OID 238599)
-- Dependencies: 3
-- Name: seq_ustrediska; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_ustrediska
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ustrediska OWNER TO %firmaRole%;

--
-- TOC entry 1969 (class 1259 OID 238601)
-- Dependencies: 2872 2873 2874 2875 2876 3
-- Name: ustrediska; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE ustrediska (
    idstred integer DEFAULT nextval('seq_ustrediska'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    ulice character varying(255),
    mesto character varying(255),
    psc character varying(255),
    tel character varying(255),
    mobil character varying(255),
    fax character varying(255),
    email character varying(255),
    www character varying(255),
    idstatu integer,
    tisknout boolean DEFAULT false NOT NULL,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    nazev2 character varying(255),
    nazev2a character varying(255),
    nazev2b character varying(255),
    nazev2c character varying(255),
    uuid character varying(50),
    eetprovozovna integer,
    eetlimit numeric(6,2),
    eettypk character varying(50),
    ic character varying(20),
    dic character varying(20),
    vatid character varying(20)
);


ALTER TABLE public.ustrediska OWNER TO %firmaRole%;

--
-- TOC entry 1970 (class 1259 OID 238612)
-- Dependencies: 3
-- Name: seq_utyporg; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_utyporg
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_utyporg OWNER TO %firmaRole%;

--
-- TOC entry 1971 (class 1259 OID 238614)
-- Dependencies: 2877 2878 2879 2880 2881 3
-- Name: utyporg; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE utyporg (
    idtyporg integer DEFAULT nextval('seq_utyporg'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    idstatu integer NOT NULL
);


ALTER TABLE public.utyporg OWNER TO %firmaRole%;

--
-- TOC entry 1972 (class 1259 OID 238625)
-- Dependencies: 3
-- Name: seq_uucty; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_uucty
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_uucty OWNER TO %firmaRole%;

--
-- TOC entry 1973 (class 1259 OID 238627)
-- Dependencies: 2882 2883 2884 2885 2886 2887 2888 2889 2890 2891 2892 2893 2894 2895 3
-- Name: uucty; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE uucty (
    iducet integer DEFAULT nextval('seq_uucty'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    danovy boolean DEFAULT false NOT NULL,
    druhuctuk character varying(50),
    prijemban boolean DEFAULT false NOT NULL,
    prijemfav boolean DEFAULT false NOT NULL,
    prijempok boolean DEFAULT false NOT NULL,
    prijemskl boolean DEFAULT false NOT NULL,
    saldo boolean DEFAULT false NOT NULL,
    typuctuk character varying(50),
    vydejban boolean DEFAULT false NOT NULL,
    vydejfap boolean DEFAULT false NOT NULL,
    vydejpok boolean DEFAULT false NOT NULL,
    vydejskl boolean DEFAULT false NOT NULL,
    idstducet integer,
    iducetobdobido integer,
    idmeny integer,
    iducetobdobiod integer,
    idtyporg integer DEFAULT 1 NOT NULL,
    uuid character varying(50)
);


ALTER TABLE public.uucty OWNER TO %firmaRole%;

--
-- TOC entry 1974 (class 1259 OID 238646)
-- Dependencies: 3
-- Name: seq_uzakazky; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_uzakazky
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_uzakazky OWNER TO %firmaRole%;

--
-- TOC entry 1975 (class 1259 OID 238648)
-- Dependencies: 2896 2897 2898 2899 2900 3
-- Name: uzakazky; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE uzakazky (
    idzakazky integer DEFAULT nextval('seq_uzakazky'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    procVyh numeric(18,6) NOT NULL DEFAULT 0.0,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    datkonec date,
    datzahaj date,
    termin timestamp without time zone,
    splatdny integer,
    pocetPriloh integer not null default 0,
    varsym character varying(30),
    idstred integer,
    idfirmy integer,
    idmur integer,
    idstavzakazky integer,
    idtypzakazky integer,
    iduzivatel integer,
    idvyhzakazky integer,
    idkontaktosoba integer,
    rozsah numeric (19,6) not null default 0.0,
    nakladyPredpoklad numeric (19,6) not null default 0.0,
    ziskPredpoklad numeric (19,6) not null default 0.0,
    idmena integer,
-- podmíněné pokročilým parametrem
    cisObj character varying(30), 
    cisSml character varying(30),
    datZahajPlan timestamp without time zone, 
    datPredaniPlan timestamp without time zone,
    datPredani timestamp without time zone, 
    zaruka boolean not null default false,
    datZaruky timestamp without time zone
);


ALTER TABLE public.uzakazky OWNER TO %firmaRole%;

--
-- TOC entry 669 (class 1247 OID 242123)
-- Dependencies: 3 2005
-- Name: vazbadokladu; Type: TYPE; Schema: public; Owner: %firmaRole%
--

CREATE TYPE vazbadokladu AS (
	idvazebnidoklad integer,
	datucto timestamp without time zone,
	datvyst timestamp without time zone,
	iddokl integer,
	kod character varying(255),
	modul character varying(255),
	modulk character varying(255),
	popis text,
	poznam text,
	sumcelkem double precision,
	sumcelkemmen double precision,
	typvazbyk character varying(255),
	storno boolean,
	varsym character varying(255),
	idmeny integer,
	iduziv integer,
	idtypdokl integer,
	novy boolean,
	uroven integer,
	stavk character varying(255),
	nazfirmy character varying(255),
	mesto character varying(255),
	juhsum double precision,
	juhsummen double precision
);


ALTER TYPE public.vazbadokladu OWNER TO %firmaRole%;

--
-- TOC entry 1976 (class 1259 OID 238665)
-- Dependencies: 3
-- Name: seq_wcolumn; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wcolumn
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wcolumn OWNER TO %firmaRole%;

--
-- TOC entry 1977 (class 1259 OID 238667)
-- Dependencies: 2901 2902 2903 2904 2905 2906 2907 3
-- Name: wcolumn; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wcolumn (
    idcolumn integer DEFAULT nextval('seq_wcolumn'::regclass) NOT NULL,
    beankey character varying(100) NOT NULL,
    orderdesc boolean DEFAULT false NOT NULL,
    orderindex integer DEFAULT (-1) NOT NULL,
    poradi integer DEFAULT 0 NOT NULL,
    propname character varying(50) NOT NULL,
    sirka integer DEFAULT 0 NOT NULL,
    iduzivatel integer DEFAULT 0 NOT NULL,
    visible boolean DEFAULT false NOT NULL
);


ALTER TABLE public.wcolumn OWNER TO %firmaRole%;

CREATE SEQUENCE seq_wcustbutton
INCREMENT BY 1
NO MAXVALUE
NO MINVALUE
CACHE 1;
ALTER TABLE public.seq_wcustbutton OWNER TO %firmaRole%;


CREATE TABLE wcustbutton (
idwcustbutton integer DEFAULT nextval('seq_wcustbutton'::regclass) NOT NULL,
lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
kod character varying(20) NOT NULL,
url text not null,
title character varying(255) NOT NULL,
description text not null,
evidence character varying(255) NOT NULL,
location character varying(255) NOT NULL,
browser character varying(255) NOT NULL DEFAULT 'automatic',
CONSTRAINT wcustbutton_pkey PRIMARY KEY (idwcustbutton)
);
ALTER TABLE public.wcustbutton OWNER TO %firmaRole%;


CREATE SEQUENCE seq_deetkom
INCREMENT BY 1
NO MAXVALUE
NO MINVALUE
CACHE 1;
ALTER TABLE public.seq_deetkom OWNER TO %firmaRole%;


CREATE TABLE deetkom (
    ideetkom integer DEFAULT nextval('seq_deetkom'::regclass) NOT NULL,
    iddokl integer NOT NULL,
    formid integer NOT NULL,
    verze integer NOT NULL,
    modul character varying(3) NOT NULL,
    storno boolean DEFAULT false,
    cas timestamp with time zone DEFAULT NULL,
    casPosl timestamp with time zone DEFAULT NULL,
    eetmodk character varying(50),
    eettypk character varying(50),
    chyba character varying(255),
    varovani character varying(255),
    celktrzba numeric(15,2),
    sumosv numeric(15,2),
    sumzklzakl numeric(15,2),
    sumdphzakl numeric(15,2),
    sumzklsniz numeric(15,2),
    sumdphsniz numeric(15,2),
    sumzklsniz2 numeric(15,2),
    sumdphsniz2 numeric(15,2),
    cestsluz numeric(15,2),
    pouzitzboz1 numeric(15,2),
    pouzitzboz2 numeric(15,2),
    pouzitzboz3 numeric(15,2),
    urcenocerpzuct numeric(15,2),
    cerpzuct numeric(15,2),
    zprava text,
    odpoved text,
    zpravaPosl text,
    odpovedPosl text,
    CONSTRAINT deetkom_pkey PRIMARY KEY (ideetkom)
);
ALTER TABLE public.deetkom OWNER TO %firmaRole%;


--
-- TOC entry 1978 (class 1259 OID 238677)
-- Dependencies: 3
-- Name: wkli_aadresar; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_aadresar
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_aadresar OWNER TO %firmaRole%;

CREATE TABLE wkli_aadresar (
    idwkli_aadresar integer NOT NULL DEFAULT nextval('seq_wkli_aadresar'::regclass),
    idfirmy integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_aadresar OWNER TO %firmaRole%;

--
-- TOC entry 1979 (class 1259 OID 238680)
-- Dependencies: 3
-- Name: wkli_akontakt; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_akontakt
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_akontakt OWNER TO %firmaRole%;

CREATE TABLE wkli_akontakt (
    idwkli_akontakt integer NOT NULL DEFAULT nextval('seq_wkli_akontakt'::regclass),
    idkontakt integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_akontakt OWNER TO %firmaRole%;

--
-- TOC entry 1980 (class 1259 OID 238683)
-- Dependencies: 3
-- Name: wkli_audalost; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_audalost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_audalost OWNER TO %firmaRole%;

CREATE TABLE wkli_audalost (
    idwkli_audalost integer NOT NULL DEFAULT nextval('seq_wkli_audalost'::regclass),
    idudalost integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_audalost OWNER TO %firmaRole%;

--
-- TOC entry 1981 (class 1259 OID 238686)
-- Dependencies: 3
-- Name: wkli_cenik; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_cenik
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_cenik OWNER TO %firmaRole%;

CREATE TABLE wkli_cenik (
    idwkli_cenik integer NOT NULL DEFAULT nextval('seq_wkli_cenik'::regclass),
    idcenik integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_cenik OWNER TO %firmaRole%;

--
-- TOC entry 1982 (class 1259 OID 238689)
-- Dependencies: 3
-- Name: wkli_doklfak; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_doklfak
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklfak OWNER TO %firmaRole%;

CREATE TABLE wkli_doklfak (
    idwkli_doklfak integer NOT NULL DEFAULT nextval('seq_wkli_doklfak'::regclass),
    iddoklfak integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_doklfak OWNER TO %firmaRole%;

--
-- TOC entry 1983 (class 1259 OID 238692)
-- Dependencies: 3
-- Name: wkli_doklint; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_doklint
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklint OWNER TO %firmaRole%;

CREATE TABLE wkli_doklint (
    idwkli_doklint integer NOT NULL DEFAULT nextval('seq_wkli_doklint'::regclass),
    iddoklint integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_doklint OWNER TO %firmaRole%;

--
-- TOC entry 2002 (class 1259 OID 241593)
-- Dependencies: 3
-- Name: wkli_doklobch; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_doklobch
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklobch OWNER TO %firmaRole%;

CREATE TABLE wkli_doklobch (
    idwkli_doklobch integer NOT NULL DEFAULT nextval('seq_wkli_doklobch'::regclass),
    iddoklobch integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_doklobch OWNER TO %firmaRole%;

--
-- TOC entry 1984 (class 1259 OID 238695)
-- Dependencies: 3
-- Name: wkli_doklsklad; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_doklsklad
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklsklad OWNER TO %firmaRole%;

CREATE TABLE wkli_doklsklad (
    idwkli_doklsklad integer NOT NULL DEFAULT nextval('seq_wkli_doklsklad'::regclass),
    iddoklsklad integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_doklsklad OWNER TO %firmaRole%;

--
-- TOC entry 1985 (class 1259 OID 238698)
-- Dependencies: 3
-- Name: wkli_mleasing; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_mleasing
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_mleasing OWNER TO %firmaRole%;

CREATE TABLE wkli_mleasing (
    idwkli_mleasing integer NOT NULL DEFAULT nextval('seq_wkli_mleasing'::regclass),
    idleasing integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_mleasing OWNER TO %firmaRole%;

--
-- TOC entry 1986 (class 1259 OID 238701)
-- Dependencies: 3
-- Name: wkli_mmajetek; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--
CREATE SEQUENCE seq_wkli_mmajetek
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_mmajetek OWNER TO %firmaRole%;

CREATE TABLE wkli_mmajetek (
    idwkli_mmajetek integer NOT NULL DEFAULT nextval('seq_wkli_mmajetek'::regclass),
    idmajetku integer NOT NULL,
    idvybklic integer NOT NULL
);


ALTER TABLE public.wkli_mmajetek OWNER TO %firmaRole%;

--
-- TOC entry 1987 (class 1259 OID 238704)
-- Dependencies: 3
-- Name: seq_wlokcis; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wlokcis
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wlokcis OWNER TO %firmaRole%;

--
-- TOC entry 1988 (class 1259 OID 238706)
-- Dependencies: 2908 2909 2910 2911 2912 2913 3
-- Name: wlokcis; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wlokcis (
    idlokcis integer DEFAULT nextval('seq_wlokcis'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    ciselnik character varying(50) NOT NULL,
    kod character varying(50) NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    poradi integer DEFAULT 0,
    show boolean DEFAULT true NOT NULL
);


ALTER TABLE public.wlokcis OWNER TO %firmaRole%;

--
-- TOC entry 1989 (class 1259 OID 238715)
-- Dependencies: 3
-- Name: seq_wokna; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wokna
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wokna OWNER TO %firmaRole%;

--
-- TOC entry 1990 (class 1259 OID 238717)
-- Dependencies: 2914 2915 2916 2917 2918 2919 3
-- Name: wokna; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wokna (
    idokna integer DEFAULT nextval('seq_wokna'::regclass) NOT NULL,
    kodform character varying(255),
    sirka integer DEFAULT (-1) NOT NULL,
    iduzivatel integer DEFAULT 0 NOT NULL,
    vyska integer DEFAULT (-1) NOT NULL,
    x numeric(10,6) DEFAULT 0.0 NOT NULL,
    y numeric(10,6) DEFAULT 0.0 NOT NULL
);


ALTER TABLE public.wokna OWNER TO %firmaRole%;

--
-- TOC entry 2003 (class 1259 OID 241945)
-- Dependencies: 3
-- Name: seq_wsetting; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wsetting
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wsetting OWNER TO %firmaRole%;

--
-- TOC entry 2004 (class 1259 OID 241947)
-- Dependencies: 3016 3017 3
-- Name: wsetting; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wsetting (
    idsetting integer DEFAULT nextval('seq_wsetting'::regclass) NOT NULL,
    klic character varying(50) NOT NULL,
    hodnota text,
    iduzivatel integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.wsetting OWNER TO %firmaRole%;

--
-- TOC entry 1993 (class 1259 OID 238739)
-- Dependencies: 3
-- Name: seq_wuzivatel; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wuzivatel
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wuzivatel OWNER TO %firmaRole%;

--
-- TOC entry 1994 (class 1259 OID 238741)
-- Dependencies: 2925 2926 2927 2928 3
-- Name: wuzivatel; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wuzivatel (
    iduzivatel integer DEFAULT nextval('seq_wuzivatel'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    adduser boolean DEFAULT false NOT NULL,
    mesto character varying(255),
    psc character varying(255),
    ulice character varying(255),
    email character varying(255),
    fax character varying(255),
    funkce character varying(255),
    jazykk character varying(50),
    jmeno character varying(255),
    kod character varying(255) NOT NULL,
    mobil character varying(255),
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    popis text,
    poznam text,
    prijmeni character varying(255),
    idrole integer NOT NULL,
    ucetni boolean DEFAULT false NOT NULL,
    tel character varying(255),
    titul character varying(255),
    titulza character varying(255),
    www character varying(255),
    idstatu integer,
    dbusername character varying(63),
    deleted boolean DEFAULT false NOT NULL,
    systemuser boolean DEFAULT false NOT NULL
);


ALTER TABLE public.wuzivatel OWNER TO %firmaRole%;

--
-- TOC entry 1995 (class 1259 OID 238751)
-- Dependencies: 3
-- Name: seq_wvybklice; Type: SEQUENCE; Schema: public; Owner: %firmaRole%
--

CREATE SEQUENCE seq_wvybklice
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_wvybklice OWNER TO %firmaRole%;

--
-- TOC entry 1996 (class 1259 OID 238753)
-- Dependencies: 2929 2930 2931 2932 2933 2934 2935 2936 2937 2938 2939 2940 2941 2942 2943 2944 2945 2946 2947 2948 2949 2950 3
-- Name: wvybklice; Type: TABLE; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE TABLE wvybklice (
    idvybklice integer DEFAULT nextval('seq_wvybklice'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    vsbadr boolean DEFAULT false,
    vsbban boolean DEFAULT false,
    vsbfap boolean DEFAULT false,
    vsbfav boolean DEFAULT false,
    vsbint boolean DEFAULT false,
    vsbkatalog boolean DEFAULT false,
    vsbmaj boolean DEFAULT false,
    vsbnap boolean DEFAULT false,
    vsbnav boolean DEFAULT false,
    vsbobp boolean DEFAULT false,
    vsbobv boolean DEFAULT false,
    vsbphl boolean DEFAULT false,
    vsbpok boolean DEFAULT false,
    vsbppp boolean DEFAULT false,
    vsbppv boolean DEFAULT false,
    vsbskl boolean DEFAULT false,
    vsbzav boolean DEFAULT false,
    vsbmzd boolean DEFAULT false,
    vsbcis boolean DEFAULT false,
    idskupvybklic integer,
    uuid character varying(50)
);


ALTER TABLE public.wvybklice OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
--Bug 13565 – [WinStrom] Sprava osobních certifikátu
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_woscert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_woscert OWNER TO %firmaRole%;

CREATE TABLE woscert (
    idoscert integer DEFAULT nextval('seq_woscert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    typcertk character varying(50) NOT NULL,
    ucelcertk character varying(50) NOT NULL DEFAULT 'ucelCertK.vseobecny',
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    cesta character varying(255),
    iduzivatel integer DEFAULT NULL,
    eetprovozovna integer
);


ALTER TABLE public.woscert OWNER TO %firmaRole%;

CREATE SEQUENCE seq_woscertcipher
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_woscertcipher OWNER TO %firmaRole%;

CREATE TABLE woscertcipher (
        idoscertcipher integer NOT NULL DEFAULT nextval('seq_woscertcipher'::regclass),
        certifikat bytea NOT NULL,
        idoscert integer NOT NULL DEFAULT 0
);

ALTER TABLE public.woscertcipher OWNER TO %firmaRole%;

-- certifikat firem v adresari

CREATE SEQUENCE seq_wadrcert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wadrcert OWNER TO %firmaRole%;

CREATE TABLE wadrcert (
    idadrcert integer DEFAULT nextval('seq_wadrcert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    duveryhodnostk character varying(50) NOT NULL,
    idadresar integer DEFAULT NULL
);

ALTER TABLE public.wadrcert OWNER TO %firmaRole%;

CREATE SEQUENCE seq_wadrcertcipher
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wadrcertcipher OWNER TO %firmaRole%;

CREATE TABLE wadrcertcipher (
    idadrcertcipher integer DEFAULT nextval('seq_wadrcertcipher'::regclass) NOT NULL,
    certifikat bytea NOT NULL,
    idadrcert integer NOT NULL DEFAULT 0,
    otisk character varying(255) NOT NULL
);

ALTER TABLE public.wadrcertcipher OWNER TO %firmaRole%;

--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Bug 13567 – [WinStrom] Zmena hesla u certifikatu a pridani cert. autorit
--------------------------------------------------------------------------------
-- pridani tabulky pro certifikacni autority a pro ulozeni keystore,
-- ktery je bude obsahovat

CREATE SEQUENCE seq_wautcert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_wautcert OWNER TO %firmaRole%;

CREATE TABLE wautcert (
    idAutCert integer DEFAULT nextval('seq_wautcert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL
);

ALTER TABLE public.wautcert OWNER TO %firmaRole%;

CREATE SEQUENCE seq_wautcertcipher
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_wautcertcipher OWNER TO %firmaRole%;

CREATE TABLE wautcertcipher (
    idautcertcipher integer DEFAULT nextval('seq_wautcertcipher'::regclass) NOT NULL,
    certifikat bytea NOT NULL,
    idautcert integer NOT NULL DEFAULT 0
);

ALTER TABLE public.wautcertcipher OWNER TO %firmaRole%;

--------------------------------------------------------------------------------

--
-- TOC entry 86 (class 1255 OID 241958)
-- Dependencies: 673 3
-- Name: add_column_if_not_exists(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION add_column_if_not_exists(table_name character varying, column_name character varying, column_def character varying) RETURNS void
    AS $_$   
declare   
  _pocetColumnu integer; 
begin 
 select count(*) into _pocetColumnu from pg_attribute as a where 
  a.attname = column_name and  
  a.attrelid = ( 
        SELECT c.oid 
        FROM pg_catalog.pg_class c 
            LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace 
        WHERE c.relname ~ ('^('||table_name||')$') 
            AND pg_catalog.pg_table_is_visible(c.oid) 
    ); 
 if(_pocetColumnu = 0) then 
   execute 'Alter table '||table_name||' add '||column_name||' '||column_def||';'; 
 end if; 
end;   
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.add_column_if_not_exists(table_name character varying, column_name character varying, column_def character varying) OWNER TO %firmaRole%;

--
-- TOC entry 85 (class 1255 OID 241957)
-- Dependencies: 3 673
-- Name: add_constraint_if_not_exists(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION add_constraint_if_not_exists(table_name character varying, constraint_name character varying, constraint_value character varying) RETURNS void
    AS $$   
declare   
  _pocetConstraintu integer; 
begin 
 select count(*) into _pocetConstraintu from pg_constraint where conname = constraint_name; 
 if(_pocetConstraintu = 0) then 
   execute 'Alter table '||table_name||' add constraint '||constraint_name||' '||constraint_value||';'; 
 end if; 
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.add_constraint_if_not_exists(table_name character varying, constraint_name character varying, constraint_value character varying) OWNER TO %firmaRole%;

--
-- TOC entry 20 (class 1255 OID 238781)
-- Dependencies: 3 673
-- Name: bigid(bigint, bigint); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION bigid(id bigint, mod bigint) RETURNS bigint
    AS $$  
declare  
  bigId bigint;  
begin  
  bigId:= mod*2147483647+id;	  
  return bigId;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.bigid(id bigint, mod bigint) OWNER TO %firmaRole%;

--
-- TOC entry 21 (class 1255 OID 238782)
-- Dependencies: 673 3
-- Name: compareid(integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION compareid(ida integer, idb integer) RETURNS boolean
    AS $$  
begin  
  if (idA is null and idB is null) or (idA is not null and idB is not null and idA = idB) then  
    return true;  
  end if;  
  
  return false;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.compareid(ida integer, idb integer) OWNER TO %firmaRole%;

--
-- TOC entry 81 (class 1255 OID 238783)
-- Dependencies: 673 3
-- Name: createorupdateobraty(boolean, boolean, date, integer, integer, integer, integer, numeric, numeric); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, cinnost integer, castka numeric, castkamen numeric)
  RETURNS void AS
$$
declare
  nRok integer;
  nObdobi integer;
  idUcetniObdobi integer;
  idMenyTuzemsko integer;
  id integer;
  puvodniMD numeric(15,2);
  puvodniDal numeric(15,2);
begin
  if ucetni = false or storno = true or datumucto is null or stredisko is null or castkamducet is null or castkadalucet is null then
    return;
  end if;

  select idMeny into idMenyTuzemsko from nNastav where (platiOdData is null or platiOdData <= datumucto)
    order by coalesce(platioddata, '0001-01-01') desc limit 1;

  nRok:= date_part('year', datumUcto);
  nObdobi:= date_part('month', datumUcto);

  select idUcetObdobi into idUcetniObdobi from nUcetObdobi where (datumUcto >= PlatiOdData and datumUcto <= PlatiDoData) limit 1;

  if(nRok is not null) and (nRok <> 0) and (nObdobi is not null) and (nObdobi <> 0) and (idMenyTuzemsko is not null) then

    /*dph tuzemsko*/
    if (castkaMdUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko and compareid(cinnost, idCinnost) for update; -- zamek !!!

      if (id is null) then
        insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
	         values(castkaMdUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, cinnost, 0.0, castka, idUcetniObdobi, now());
      else
        puvodniMD := puvodniMD + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrMD = obrMD + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    if (castkaDalUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko and compareid(cinnost, idCinnost) for update;

      if (id is null) then
        insert into uObraty (idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
           values(castkaDalUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, cinnost, castka, 0.0, idUcetniObdobi, now());
      else
        puvodniDal := puvodniDal + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrDal = obrDal + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    -- cizi mena, v pripade, ze se mena nema zapocitavat tak ma hodnotu -1
    if (mena <> -1) and mena <> idMenyTuzemsko then
          if(castkaMdUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena and compareid(cinnost, idCinnost) for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
                 values(castkaMdUcet, nRok, nObdobi, stredisko, mena, cinnost, 0.0, castkaMen, idUcetniObdobi, now());
            else
              puvodniMD := puvodniMD + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrMD = obrMD + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;

          if(castkaDalUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena and compareid(cinnost, idCinnost) for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, idCinnost, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
                 values(castkaDalUcet, nRok, nObdobi, stredisko, mena, cinnost, castkaMen, 0.0, idUcetniObdobi, now());
            else
              puvodniDal := puvodniDal + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrDal = obrDal + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;
    end if;

  else
    -- v pripade, ze dany objekt nema vyplneno datumUcto, nejsou hodnoty nastaveny a nezapocitavaji se do obratu
    if (datumUcto is not null) then
        raise exception 'aktualizace zaznamu tabulky uObraty: Neplatné vstupní hodnoty. % % %',idMenyTuzemsko,nRok,nObdobi;
    end if;
  end if;
end;
$$
  LANGUAGE plpgsql;
ALTER FUNCTION public.createorupdateobraty(boolean, boolean, date, integer, integer, integer, integer, integer, numeric, numeric) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, castka numeric, castkamen numeric)
  RETURNS void AS $$
begin
  PERFORM createorupdateobraty(ucetni, storno, datumucto, castkamducet, castkadalucet, mena, stredisko, null, castka, castkamen);
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, castka numeric, castkamen numeric) OWNER TO %firmaRole%;

--
-- TOC entry 24 (class 1255 OID 238784)
-- Dependencies: 673 3
-- Name: ddokldelete(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddokldelete() RETURNS trigger
    AS $$ 
declare 
  _idUcetObdobi integer; 
  _navratHodnota boolean; 
begin 
  /* !!! Důležité !!! Podmínka na následující řádce nutná kvůli importu z W6 na W10. */ 
  if (OLD.idRady is not null and OLD.idPolRady is not null) then
    /* Podle idPolRady na dokladu vyhledej příslušné účetní období */ 
    select idUcetobdobi into _idUcetObdobi from dRadyRok where idRadyRok = OLD.idPolRady limit 1; 
    if (_idUcetObdobi is not null) then 
      _navratHodnota:= (select dVratCisDokl (OLD.idRady, _idUcetObdobi, OLD.kod)); 
    else 
      raise exception 'dDoklDelete(): Nebylo nalezeno platné účetní období pro datum zaúčtování.'; 
    end if; 
  end if; 
 
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddokldelete() OWNER TO %firmaRole%;

--
-- TOC entry 82 (class 1255 OID 241937)
-- Dependencies: 3 673
-- Name: ddokldeleteobchvazba(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddokldeleteobchvazba() RETURNS trigger
    AS $$ 
declare 
  _postfix varchar(20); 
  _idDokl bigint; 
begin 
  select getDoklNamePostfixByModul(OLD.modul) into _postfix; 
  if (_postfix = 'Fak') then 
    _idDokl := OLD.idDoklFak; 
  else 
    if (_postfix = 'Obch') then 
      _idDokl := OLD.idDoklObch; 
    else 
      if (_postfix = 'Sklad') then 
        _idDokl := OLD.idDoklSklad; 
      end if; 
    end if; 
  end if; 
   
  delete from dVazebTab where (typvazbyk in ('typVazbyDokl.obchod_obchod_hla', 'typVazbyDokl.obchod_faktura_hla', 
                                             'typVazbyDokl.obchod_zaloha_hla', 'typVazbyDokl.obchod_sklad_hla')) 
                              and ((idTabA = _idDokl and modulA = OLD.modul) or 
                                   (idTabB = _idDokl and modulB = OLD.modul)); 
   
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddokldeleteobchvazba() OWNER TO %firmaRole%;

--
-- TOC entry 22 (class 1255 OID 238785)
-- Dependencies: 3 673
-- Name: ddokldelraddiru(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION ddokldelraddiru() RETURNS trigger
    AS $$  
declare  
  _datum date;
  _idUcetObdobi integer;  
begin  
  /* Kontrola na bug 9288. Po vyreseni mozno odstranit.*/
  /* Zakomentovano z duvodu importu z WinStromu 6 
  if (NEW.idPolRady is null) then  
    raise exception 'dDoklDelRadDiru(): idPolRady je null';  
  end if;*/  
  
  if (NEW.ucetni = true) then
    _datum = NEW.datUcto;
  else
    _datum = NEW.datVyst;
  end if;

  select idUcetObdobi into _idUcetObdobi from nUcetObdobi where platiOdData <= _datum and platiDoData >= _datum;
  
  delete from dRadyDiry where CisDira = NEW.Kod and idRadyRok =   
    (select idRadyRok from dRadyRok where idRady = NEW.idRady and idUcetObdobi = _idUcetObdobi group by idRadyRok);  
      
  return NEW;  
end;  
$$ LANGUAGE plpgsql;


ALTER FUNCTION public.ddokldelraddiru() OWNER TO %firmaRole%;

--
-- TOC entry 23 (class 1255 OID 238786)
-- Dependencies: 673 3
-- Name: ddoklfakinsdelpreceneni(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddoklfakinsdelpreceneni() RETURNS trigger
    AS $$  
declare ZAZNAM record;  
begin  
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;  
  
  if (ZAZNAM.Ucetni = true) then  
    if (ZAZNAM.sumCelkemMen <> 0) then                  -- pokud je nula nemuze nastat chyba preceneni (zrejme to neni doklad v cizi mene)  
      execute uNastavChybaPreceneni(ZAZNAM.datUcto);  
    end if;  
  end if;  
    
  return ZAZNAM;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklfakinsdelpreceneni() OWNER TO %firmaRole%;

--
-- TOC entry 25 (class 1255 OID 238787)
-- Dependencies: 3 673
-- Name: ddoklfakupdatepreceneni(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddoklfakupdatepreceneni() RETURNS trigger
    AS $$  
declare datum date;  
begin  
  if (NEW.sumCelkemMen <> 0 or OLD.sumCelkemMen <> 0) then                  -- pokud jsou obe nula nemuze nastat chyba preceneni (zrejme to neni doklad v cizi mene)  
    if (NEW.ucetni = true and OLD.ucetni = true) then                       -- pokud je ucetni  
      if (NEW.datUcto <> OLD.datUcto) then                                  -- pokud se zmenilo datum zauctovani musime nastavit obe  
        execute uNastavChybaPreceneni(NEW.datUcto);  
        execute uNastavChybaPreceneni(OLD.datUcto);  
      else  
          if (NEW.sumCelkemMen <> OLD.sumCelkemMen or NEW.kurz <> OLD.kurz) then  -- pokud se zmenilo neco ovlivnujici celkovou castku  
            execute uNastavChybaPreceneni(NEW.datUcto);  
          end if;  
      end if;  
    end if;  
  
    if (NEW.ucetni <> OLD.ucetni) then                                      -- pokud je ucetni a nebylo nebo naopak musime vyvolat chybu preceneni  
      if (NEW.ucetni = true) then  
        execute uNastavChybaPreceneni(NEW.datUcto);  
      else  
        execute uNastavChybaPreceneni(OLD.datUcto);  
      end if;  
    end if;  
  
  end if;  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklfakupdatepreceneni() OWNER TO %firmaRole%;

--
-- TOC entry 26 (class 1255 OID 238788)
-- Dependencies: 3 673
-- Name: ddoklfakupdateucty(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION ddoklfakupdateucty() RETURNS trigger
    AS $$  
declare nelzeZmena int;  
        idDokl int;  
        dokl record;
        ucPrij int;
        ucVyd int;
        _zdrojprofak boolean;
        _hromfakt boolean;
begin  
  nelzeZmena := 0;  
    
  --pokud dojde ke zmene primarniho uctu  
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then  
    -- uprava banka/pokladna vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY','typVazbyDokl.vazbaZDD')))  
    loop  
        if (select ucetni from ddoklint where iddoklint = idDokl) then
            execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);
        end if;
    end loop;  
  
    -- uhradaKR, preceneni - u kurzoveho rozdilu a preceneni nevim na ktere strane je hledany ucet, testuji oba  
    for dokl in (select * from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and compareId(idProtiUcet, OLD.idPrimUcet) = true and compareId(idPrimUcet, NEW.idPrimUcet) = false
        and idDoklInt in (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  
    for dokl in (select * from dDoklInt where compareId(idPrimUcet,  NEW.idPrimUcet) = false and compareId(idPrimUcet,  OLD.idPrimUcet) = true and compareId(idProtiUcet, NEW.idPrimUcet) = false
        and idDoklInt in (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 0, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 0, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  end if;  
  
  --pokud dojde ke zmene protiuctu (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idProtiUcet) = false and kopZklDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idProtiUcet where compareId(idZklDalUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idProtiUcet) = false and kopZklMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idProtiUcet where compareId(idZklMdUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
  
      -- vazba na sklad  
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklFak and modulA = NEW.modul and   
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)  
      loop  
        select zdrojprofak, hromfakt into _zdrojprofak, _hromfakt from ddoklsklad where iddoklsklad = iddokl;
        if _zdrojprofak = false or _hromfakt = false then     -- pokud byl skladovy doklad pridany hromadnou fakturaci tak na nej neprenasime
          execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);
        end if;  
      end loop;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu zakladni sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphZaklUcet, OLD.idDphZaklUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphZaklUcet where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphZaklUcet where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu snizene sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphSnizUcet, OLD.idDphSnizUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphSnizUcet where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphSnizUcet where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  if (nelzeZmena > 0) then  
    raise exception '0008:dDoklFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
  end if;  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklfakupdateucty() OWNER TO %firmaRole%;

--
-- TOC entry 90 (class 1255 OID 241914)
-- Dependencies: 673 3
-- Name: ddoklfakupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddoklfakupdatezauctovano() RETURNS trigger
    AS $$ 
declare 
  _idPolDokl integer; 
  _zuctovano boolean; 
begin 
  select isDokladZuctovan(NEW.idDoklFak, 'Fak') into _zuctovano; 
   
  if (NEW.zuctovano <> _zuctovano) then 
    update ddoklfak set zuctovano = _zuctovano where idDoklFak = NEW.idDoklFak; 
  end if; 
   
  return NEW; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklfakupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 27 (class 1255 OID 238789)
-- Dependencies: 3 673
-- Name: ddoklintupdateucty(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION ddoklintupdateucty() RETURNS trigger
    AS $$
declare idPoloz int;
        idDokl int;
        kopirovatKR boolean;
        ucMd int;
        ucDal int;
        ucNastav int;
        _zdrojprofak boolean;
        _hromfakt boolean;
begin
  kopirovatKR = false;
  -- pokud se zmenil nejaky ucet a mame vyplneny typ zauctovani zkusime nejprve rozhodnout jaky ucet prenaset podle nej
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false or compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false and NEW.idtypucop is not null) then
    -- MD - prim ucet, DAL - proti ucet
    select P.idprotiucetp, P.idprotiucetv into ucDal, ucMd from utypucop as P where NEW.idtypucop = P.idtypucop;
    if (ucMd is null and ucDal is not null and not compareId(NEW.idPrimUcet, OLD.idPrimUcet) ) then        -- na predpisu zauctovani je zadan jen ucet Dal, tj prenasime ucet Md
      kopirovatKR = true;
      ucNastav = NEW.idPrimUcet;
    end if;
    if (ucDal is null and ucMd is not null and not compareId(NEW.idProtiUcet, OLD.idProtiUcet) ) then        -- na predpisu zauctovani je zadan jen ucet Md, tj prenasime ucet Dal
      kopirovatKR = true;
      ucNastav = NEW.idProtiUcet;
    end if;
    
    if kopirovatKR then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, ucNastav) = false and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, ucNastav);
      end loop;
    end if;
  end if;

  --pokud dojde ke zmene protiuctu
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    if (NEW.modul = 'POK' and NEW.typPohybuK = 'typPohybu.vydej') then             -- pokladni vydej
      -- vazba na sklad
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklInt and modulA = NEW.modul and
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
      loop
        select zdrojprofak, hromfakt into _zdrojprofak, _hromfakt from ddoklsklad where iddoklsklad = iddokl;
        if _zdrojprofak = false or _hromfakt = false then     -- pokud byl skladovy doklad pridany hromadnou fakturaci tak na nej neprenasime
          execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);
        end if;
      end loop;
    end if;

    -- uprava faktur vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni
    for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and idDoklFak in
        (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY','typVazbyDokl.vazbaZDD')))
    loop
        if (select ucetni from ddoklfak where iddoklfak = idDokl) then
            execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
        end if;
    end loop;

    -- odpocet zalohy - polozka dokladu
    for idPoloz in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK = 'typVazbyDokl.uhradaZALOHY')) loop
      if (NEW.typPohybuK = 'typPohybu.prijem') then
        update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklDalUcet, NEW.idProtiUcet) = false and compareId(idZklDalUcet, OLD.idProtiUcet) = true;
      else
        update dPolFak set lastupdate = now(), idZklMdUcet  = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklMdUcet,  NEW.idProtiUcet) = false and compareId(idZklMdUcet,  OLD.idProtiUcet) = true;
      end if;
    end loop;

    -- uhradaKR, preceneni
    if (not kopirovatKR and not compareId(OLD.idPrimUcet, OLD.idProtiUcet)) then  -- nekopirovali jsme a ucty na internim dokladu nebyli stejne
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and compareId(idPrimUcet, OLD.idProtiUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
      end loop;
    end if;
  end if;

  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then
    -- uhradaKR, preceneni
    if (not kopirovatKR and not compareId(OLD.idPrimUcet, OLD.idProtiUcet)) then  -- nekopirovali jsme a ucty na internim dokladu nebyli stejne
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idPrimUcet) = false and compareId(idPrimUcet, OLD.idPrimUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idPrimUcet);
      end loop;
    end if;
  end if;

  return NEW;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklintupdateucty() OWNER TO %firmaRole%;

--
-- TOC entry 91 (class 1255 OID 241916)
-- Dependencies: 673 3
-- Name: ddoklintupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddoklintupdatezauctovano() RETURNS trigger
    AS $$ 
declare 
  _idPolDokl integer; 
  _zuctovano boolean; 
begin 
  select isDokladZuctovan(NEW.idDoklInt, 'Int') into _zuctovano; 
   
  if (NEW.zuctovano <> _zuctovano) then 
    update ddoklint set zuctovano = _zuctovano where idDoklInt = NEW.idDoklInt; 
  end if; 
   
  return NEW; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklintupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 28 (class 1255 OID 238790)
-- Dependencies: 3 673
-- Name: ddoklskladupdateucty(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION ddoklskladupdateucty() RETURNS trigger
    AS $$
declare idFak int;
declare idSklad int;
declare idPok int;
begin
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    if NEW.zdrojprofak = false or NEW.hromfakt = false then     -- pokud byl skladovy doklad pridany hromadnou fakturaci tak z nej neprenasime
      -- musime testovat i jestli je modul FAP protoze u dobropisu muze byt prijem/vydej opacne
      for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and modulA = 'FAP' and
              compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false)
      loop
          execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet);
      end loop;

      for idPok in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and modulA = 'POK' and 
              compareId((select idProtiUcet from dDoklInt where idDoklInt = idTabA), NEW.idProtiUcet) = false) 
      loop 
          execute dNastavUcetDokladu(1, idPok, 1, NEW.idProtiUcet); 
      end loop; 
    end if;
 
    for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
    end loop;

   /*for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabA = NEW.idDoklSklad and
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
    end loop;*/

  else
    /*if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabB = NEW.idDoklSklad and
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false)
      loop
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
      end loop;

    end if;*/

    if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabA = NEW.idDoklSklad and 
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false) 
      loop 
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
      end loop; 

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklskladupdateucty() OWNER TO %firmaRole%;

--
-- TOC entry 92 (class 1255 OID 241918)
-- Dependencies: 673 3
-- Name: ddoklskladupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION ddoklskladupdatezauctovano() RETURNS trigger
    AS $$ 
declare 
  _idPolDokl integer; 
  _zuctovano boolean; 
begin 
  select isDokladZuctovan(NEW.idDoklSklad, 'Sklad') into _zuctovano; 
   
  if (NEW.zuctovano <> _zuctovano) then 
    update ddoklsklad set zuctovano = _zuctovano where idDoklSklad = NEW.idDoklSklad; 
  end if; 
   
  return NEW; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.ddoklskladupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 31 (class 1255 OID 238791)
-- Dependencies: 3 673
-- Name: dgetcisdokl(integer, integer, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dgetcisdokl(i_iddokl integer, i_idrady integer, i_iducetniobdobi integer, i_modul character varying, i_typpohybuk character varying) RETURNS refcursor
    AS $$ 
declare 
  _idRadyRok integer; 
  _CisDelka integer; 
  _ZobrazNuly boolean; 
  _CisAkt integer; 
  _CisPoc integer; 
  _Prefix varchar(8); 
  _Postfix varchar(8); 
  _PocetZaznamu integer; 
   
  _idRadyDiry integer; 
  _CisDira varchar(20);   
  _Unique boolean; 
  _iter integer; 
 
  o_Chyba integer; 
  o_CisDokl varchar(20); 
   
  _navratoveHodnoty refcursor; 
begin 
  o_Chyba:= 0; 
  o_CisDokl:= null; 
   
  /* Ověření, zda pro daný účetní rok existuje dokladová řada pro rok. Pokud neexistuje, vytvoří se. */ 
  select idRadyRok into _idRadyRok from dRadyRok where idRady = i_idRady and iducetobdobi = i_idUcetniObdobi; 
  if(_idRadyRok is null) then 
    execute dZalozRaduRok (i_idRady, i_idUcetniObdobi, i_Modul); 
  end if; 
   
  /* Načte se dokladová řada pro účetní rok */ 
  select CisDelka, ZobrazNuly, CisAkt, CisPoc, Prefix, Postfix, idRadyRok into _CisDelka,_ZobrazNuly,_CisAkt,_CisPoc,_Prefix,_Postfix, 
    _idRadyRok from dRadyRok where idRady = i_idRady and iducetobdobi = i_idUcetniObdobi for update;       
 
 
  /* Podíváme se do seznamu děr, zda tam náhodou neexistuje vrácené číslo. Pokud ano, zjistíme jeho unikátnost. Pokud je unikátní, 
     provedeme jeho přidělení klientu. V opačném případě jej smažeme a pokusíme se vybrat nové číslo ze seznamu děr. */ 
                                                                            /* podmínka pro čtení jenom neprazdnych der*/
  select CisDira, idRadyDiry into _CisDira,_idRadyDiry from dRadyDiry where CisDira is not null and trim(CisDira) <> '' and  idRadyRok = _idRadyRok and LastUpdate <= now() order by cisdira asc limit 1; 
  if (_CisDira is not null) then 
     
    _Unique:= (select dUniqueCisDokl(-1,i_Modul,i_TypPohybuK,_CisDira));     
    while(_Unique = false and _CisDira is not null) loop 
      delete from dRadyDiry where idRadyDiry = _idRadyDiry; 
                                                                            /* podmínka pro čtení jenom neprazdnych der*/        
      select CisDira, idRadyDiry into _CisDira,_idRadyDiry from dRadyDiry where CisDira is not null and trim(CisDira) <> '' and idRadyRok = _idRadyRok and LastUpdate <= now() order by CisDira asc limit 1; 
      if(_CisDira is not null) then 
        _Unique:= (select dUniqueCisDokl(-1,i_Modul,i_TypPohybuK,_CisDira)); 
      end if; 
       
    end loop; 
 
    /* Pokud bylo nalezeno unikátní číslo, provede se jeho rezervace a vrátí se klientu. */ 
    if(_Unique = true and _CisDira is not null) then 
      o_CisDokl:= _CisDira; 
      update dRadyDiry set LastUpdate = now() + interval '2 hours' where idRadyDiry = _idRadyDiry; 
    end if;       
  end if; 
   
  /* Pokud nebylo číslo vzato z děr, provede se jeho přidělení standardním způsobem z řady. 
     Pozor! Pokud se jedná o první číslo řady, je potřeba vrátit aktuální číslo a nikoliv inkrementované. */ 
  if (o_CisDokl is null) then     
    if (_CisAkt <> _CisPoc) then 
      _CisAkt:= _CisAkt+1; 
    end if; 
     
    /* Získá se číslo a provede se test na jeho unikátnost.*/ 
    o_CisDokl:= (select dVytvorCisDokl(_Prefix,_CisAkt,_Postfix,_ZobrazNuly,_CisDelka,i_idUcetniObdobi)); 
    _Unique:= (select dUniqueCisDokl(-1,i_Modul,i_TypPohybuK,o_CisDokl)); 
     
    /* Podíváme se také do děr, protože počátek řady mohl být již vyžádán a je umístěn v dírách. 
       Typickým příkladem je generování závazků u Leasingu, kde se vytahuje několik čísel najednou. */ 
    if (_Unique = true) then 
      select count(*) into _PocetZaznamu from dRadyDiry where cisdira=o_CisDokl and idradyrok=_idRadyRok; 
      if (_PocetZaznamu > 0) then 
        _Unique:= false; 
      end if; 
    end if; 
     
    /* Pokud není číslo unikátní, pokus se vygenerovat nové. */ 
    _iter:= 0; 
    while (_Unique = false) loop 
      _CisAkt:= _CisAkt+1; 
      _iter:= _iter + 1; 
       
      o_CisDokl:= (select dVytvorCisDokl(_Prefix,_CisAkt,_Postfix,_ZobrazNuly,_CisDelka,i_idUcetniObdobi)); 
      _Unique:=(select dUniqueCisDokl(-1,i_Modul,i_TypPohybuK,o_CisDokl));     
       
      if (_iter > 100000) then 
        /* Číslo se z neznámých důvodů nepodařilo vygenerovat. Pozn.: Ochrana proti zacyklení.*/ 
        raise exception 'dGetCisDokl(): Číslo dokladu se nepodařilo vygenerovat.'; 
      end if; 
    end loop; 
     
    /* Nastavení chybových stavů (pokud nějaké nastaly). */ 
    if (o_CisDokl = 'x') then /* Kapacita číselné řady vyčerpána. */ 
      o_Chyba:= 1; 
    end if; 
    if (o_CisDokl = 'xx') then /* Délka číselné řady je delší. Max. 20 znaků.  */ 
      o_Chyba:= 2;  
    end if; 
    if (o_CisDokl = 'xxx') then /* Maximální délka čísla smí být 12 znaků. */ 
      o_Chyba:= 3; 
    end if;      
     
    /* Podařilo se vygenerovat unikátní číslo, provede se jeho rezervace a nastaví se nový vrchol dokladové řady. */ 
                                                                                                                        /*hlidani ukladani prazdnych der*/
    if (o_Chyba = 0) and (select count(*) from dRadyDiry where idRadyRok = _idRadyRok and CisDira = o_CisDokl) = 0 and o_CisDokl is not null and trim(o_CisDokl) <> ''  then
      insert into dRadyDiry(idRadyRok,CisDira,LastUpdate) values(_idRadyRok,o_CisDokl, now() + interval '2 hours'); 
      update dRadyRok set cisAkt = _cisAkt where idRadyRok = _idRadyRok; 
    end if; 
         
  end if;    
   
  open _navratoveHodnoty for select o_CisDokl as CisloDokladu, o_Chyba as Cislo; 
  return _navratoveHodnoty;   
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dgetcisdokl(i_iddokl integer, i_idrady integer, i_iducetniobdobi integer, i_modul character varying, i_typpohybuk character varying) OWNER TO %firmaRole%;

--
-- TOC entry 30 (class 1255 OID 238793)
-- Dependencies: 3 673
-- Name: dnastavucetdokladu(integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dnastavucetdokladu(tabulka integer, iddoklad integer, ucet integer, newiducet integer) RETURNS void
    AS $$  
declare typPohyb character varying(50);  
        typDph character varying(50);  
        primZkl boolean;  
        primDph boolean;  
        protiZkl boolean;  
        protiDph boolean;  
begin  
  -- nacteni typu pohybu a nastaveni zmeny uctu na dokladu  
  if (tabulka = 0) then             -- faktury  
    select typPohybuK into typPohyb from dDoklFak where idDoklFak = idDoklad;  
  
    if (ucet = 0) then  
      update dDoklFak set lastupdate = now(), idPrimUcet = newIdUcet where idDoklFak = idDoklad;  
    end if;  
    if (ucet = 1) then  
      update dDoklFak set lastupdate = now(), idProtiUcet = newIdUcet where idDoklFak = idDoklad;  
    end if;  
    if (ucet = 2) then  
      update dDoklFak set lastupdate = now(), idDphZaklUcet = newIdUcet where idDoklFak = idDoklad;  
    end if;  
    if (ucet = 3) then  
      update dDoklFak set lastupdate = now(), idDphSnizUcet = newIdUcet where idDoklFak = idDoklad;  
    end if;  
  else if (tabulka = 1) then        -- int/ban/pok  
    select typPohybuK into typPohyb from dDoklInt where idDoklInt = idDoklad;  
  
    if (ucet = 0) then  
      update dDoklInt set lastupdate = now(), idPrimUcet = newIdUcet where idDoklInt = idDoklad;  
    end if;  
    if (ucet = 1) then  
      update dDoklInt set lastupdate = now(), idProtiUcet = newIdUcet where idDoklInt = idDoklad;  
    end if;  
    if (ucet = 2) then  
      update dDoklInt set lastupdate = now(), idDphZaklUcet = newIdUcet where idDoklInt = idDoklad;  
    end if;  
    if (ucet = 3) then  
      update dDoklInt set lastupdate = now(), idDphSnizUcet = newIdUcet where idDoklInt = idDoklad;  
    end if;  
  else if (tabulka = 2) then        -- sklad  
    select typPohybuK into typPohyb from dDoklSklad where idDoklSklad = idDoklad;  
  
    if (ucet = 0) then  
      update dDoklSklad set lastupdate = now(), idPrimUcet = newIdUcet where idDoklSklad = idDoklad;  
    end if;  
    if (ucet = 1) then  
      update dDoklSklad set lastupdate = now(), idProtiUcet = newIdUcet where idDoklSklad = idDoklad;  
    end if;  
    if (ucet = 2) then  
      update dDoklSklad set lastupdate = now(), idDphZaklUcet = newIdUcet where idDoklSklad = idDoklad;  
    end if;  
    if (ucet = 3) then  
      update dDoklSklad set lastupdate = now(), idDphSnizUcet = newIdUcet where idDoklSklad = idDoklad;  
    end if;  
  else  
    -- chyba  
  end if;  
  end if;  
  end if;  
  
  -- inicializace promennych  
  typDph := null;  
  primZkl := false;  
  primDph := false;  
  protiZkl := false;  
  protiDph := false;  
  
  if (ucet = 0) then  
    primZkl := true;  
    primDph := true;  
  end if;  
  if (ucet = 1) then  
    protiZkl := true;  
  end if;  
  if (ucet = 2) then  
    protiDph := true;  
    typDph = 'typSzbDph.dphZakl';  
  end if;  
  if (ucet = 3) then  
    protiDph := true;  
    typDph = 'typSzbDph.dphSniz';  
  end if;  
  
  -- nastaveni uctu na polozkach dokladu  
  if (typPohyb = 'typPohybu.prijem') then  
    execute dNastavUctyPolozek(tabulka, idDoklad, primZkl, primDph, protiZkl, protiDph, newIdUcet, typDph);  
  end if;  
  
  if (typPohyb = 'typPohybu.vydej') then  
    execute dNastavUctyPolozek(tabulka, idDoklad, protiZkl, protiDph, primZkl, primDph, newIdUcet, typDph);  
  end if;  
  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dnastavucetdokladu(tabulka integer, iddoklad integer, ucet integer, newiducet integer) OWNER TO %firmaRole%;

--
-- TOC entry 32 (class 1255 OID 238795)
-- Dependencies: 3 673
-- Name: dnastavuctypolozek(integer, integer, boolean, boolean, boolean, boolean, integer, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dnastavuctypolozek(tabulka integer, iddoklad integer, mdzkl boolean, mddph boolean, dalzkl boolean, daldph boolean, newiducet integer, typdph character varying) RETURNS void
    AS $$  
declare typPohyb character varying(50);  
begin  
  if (tabulka = 0) then             -- faktury  
    if (mdZkl = true) then  
        update dPolFak set lastupdate = now(), idZklMdUcet=newIdUcet where idDoklFak = idDoklad and kopZklMdUcet = true and compareId(idZklMdUcet, newIdUcet) = false;  
    end if;  
    if (mdDph = true) then  
        update dPolFak set lastupdate = now(), idDphMdUcet=newIdUcet where idDoklFak = idDoklad and kopDphMdUcet = true and compareId(idDphMdUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph);  
    end if;  
    if (dalZkl = true) then  
        update dPolFak set lastupdate = now(), idZklDalUcet=newIdUcet where idDoklFak = idDoklad and kopZklDalUcet = true and compareId(idZklDalUcet, newIdUcet) = false;  
    end if;  
    if (dalDph = true) then  
        -- v případě reverse charge (FAP, ZAV - tj. vždy když je vydej), má být účtování DPH jak <účetDph> | <účetDph> -> tj. update nebudeme provádět
        update dPolFak set lastupdate = now(), idDphDalUcet=newIdUcet where idDoklFak = idDoklad and kopDphDalUcet = true and compareId(idDphDalUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph) 
            and iddoklfak not in (select df.iddoklfak from ddoklfak df inner join uclendph c on df.idclendph = c.idclendph 
            where c.typPlneniK in ('typPlneni.prijataRCH', 'typPlneni.uskutecnenaRCH' , 'typPlneni.obojiRCH' ) 
            and df.iddoklfak = iddoklfak and df.typPohybuK = 'typPohybu.vydej');  
    end if;  
  else if (tabulka = 1) then        -- int/ban/pok  
    if (mdZkl = true) then  
        update dPolInt set lastupdate = now(), idZklMdUcet=newIdUcet where idDoklInt = idDoklad and kopZklMdUcet = true and compareId(idZklMdUcet, newIdUcet) = false;  
    end if;  
    if (mdDph = true) then  
        update dPolInt set lastupdate = now(), idDphMdUcet=newIdUcet where idDoklInt = idDoklad and kopDphMdUcet = true and compareId(idDphMdUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph);  
    end if;  
    if (dalZkl = true) then  
        update dPolInt set lastupdate = now(), idZklDalUcet=newIdUcet where idDoklInt = idDoklad and kopZklDalUcet = true and compareId(idZklDalUcet, newIdUcet) = false;  
    end if;  
    if (dalDph = true) then  
        update dPolInt set lastupdate = now(), idDphDalUcet=newIdUcet where idDoklInt = idDoklad and kopDphDalUcet = true and compareId(idDphDalUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph);  
    end if;  
  else if (tabulka = 2) then        -- sklad  
    if (mdZkl = true) then  
        update dPolSklad set lastupdate = now(), idZklMdUcet=newIdUcet where idDoklSklad = idDoklad and kopZklMdUcet = true and compareId(idZklMdUcet, newIdUcet) = false;  
    end if;  
    if (mdDph = true) then  
        update dPolSklad set lastupdate = now(), idDphMdUcet=newIdUcet where idDoklSklad = idDoklad and kopDphMdUcet = true and compareId(idDphMdUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph);  
    end if;  
    if (dalZkl = true) then  
        update dPolSklad set lastupdate = now(), idZklDalUcet=newIdUcet where idDoklSklad = idDoklad and kopZklDalUcet = true and compareId(idZklDalUcet, newIdUcet) = false;  
    end if;  
    if (dalDph = true) then  
        update dPolSklad set lastupdate = now(), idDphDalUcet=newIdUcet where idDoklSklad = idDoklad and kopDphDalUcet = true and compareId(idDphDalUcet, newIdUcet) = false and  
            ((typDph is null and typszbdphk <> 'typSzbDph.dphOsv') or typszbdphk = typDph);  
    end if;  
  else  
    -- chyba  
  end if;  
  end if;  
  end if;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dnastavuctypolozek(tabulka integer, iddoklad integer, mdzkl boolean, mddph boolean, dalzkl boolean, daldph boolean, newiducet integer, typdph character varying) OWNER TO %firmaRole%;

--
-- TOC entry 83 (class 1255 OID 241941)
-- Dependencies: 673 3
-- Name: dpoldokldeleteobchvazba(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dpoldokldeleteobchvazba() RETURNS trigger
    AS $$ 
declare 
  _postfix varchar(20); 
  _idPolDokl bigint; 
begin 
  select getDoklNamePostfixByModul(OLD.modul) into _postfix; 
  if (_postfix = 'Fak') then 
    _idPolDokl := OLD.idPolFak; 
  else 
    if (_postfix = 'Obch') then 
      _idPolDokl := OLD.idPolObch; 
    else 
      if (_postfix = 'Sklad') then 
        _idPolDokl := OLD.idPolSklad; 
      end if; 
    end if; 
  end if; 
   
  delete from dVazebTab where (typvazbyk in ('typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol', 
                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol')) 
                              and ((idTabA = _idPolDokl and modulA = OLD.modul) or 
                                   (idTabB = _idPolDokl and modulB = OLD.modul)); 
   
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpoldokldeleteobchvazba() OWNER TO %firmaRole%;

--
-- TOC entry 89 (class 1255 OID 238796)
-- Dependencies: 3 673
-- Name: dpoldokldeleteucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dpoldokldeleteucto() RETURNS trigger
    AS $$ 
begin 
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet, 
        OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumZkl, -OLD.sumZklMen); 
   
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet, 
        OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumDph, -OLD.sumDphMen); 
   
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpoldokldeleteucto() OWNER TO %firmaRole%;

--
-- TOC entry 87 (class 1255 OID 238797)
-- Dependencies: 673 3
-- Name: dpoldoklinsertucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dpoldoklinsertucto() RETURNS trigger
    AS $$ 
begin 
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet, 
        NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumZkl, NEW.sumZklMen); 
   
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet, 
        NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumDph, NEW.sumDphMen); 
   
  return NEW; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpoldoklinsertucto() OWNER TO %firmaRole%;

--
-- TOC entry 88 (class 1255 OID 238798)
-- Dependencies: 673 3
-- Name: dpoldoklupdateucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dpoldoklupdateucto() RETURNS trigger
    AS $$ 
begin 
   
 IF ( NEW.Ucetni <> OLD.Ucetni OR
      NEW.Storno <> OLD.Storno OR
      comparedate(NEW.DatUcto, OLD.DatUcto) = false OR

      compareid(NEW.idZklMdUcet, OLD.idZklMdUcet) = false OR
      compareid(NEW.idZklDalUcet, OLD.idZklDalUcet) = false OR
      compareid(NEW.idDphMdUcet, OLD.idDphMdUcet) = false OR
      compareid(NEW.idDphDalUcet, OLD.idDphDalUcet) = false OR

      compareid(NEW.idMeny, OLD.idMeny) = false OR
      compareid(NEW.idStred, OLD.idStred) = false OR
      compareid(NEW.idCinnost, OLD.idCinnost) = false OR

      NEW.sumZkl <> OLD.sumZkl OR
      NEW.sumZklMen <> OLD.sumZklMen OR
      NEW.sumDph <> OLD.sumDph OR
      NEW.sumDphMen <> OLD.sumDphMen ) THEN

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet, 
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumZkl, -OLD.sumZklMen); 
   
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet, 
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumDph, -OLD.sumDphMen); 
   
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet, 
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumZkl, NEW.sumZklMen); 
   
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet, 
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumDph, NEW.sumDphMen); 

 END IF;
   
  return NEW; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpoldoklupdateucto() OWNER TO %firmaRole%;

--
-- TOC entry 33 (class 1255 OID 238799)
-- Dependencies: 673 3
-- Name: dpolfakdeletevazba(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dpolfakdeletevazba() RETURNS trigger
    AS $$
declare _dokl record;
        _idzal integer;
        _idKorekce integer;
        uhrad integer;
        _stavUhrK varchar;
        _idPomInt integer; 
        _idVazbaOdpocFak integer;
        _idVazbaUhrFak integer;
begin  
  if (OLD.typPolozkyK in ('typPolozky.odpocetZalohy', 'typPolozky.odpocetZdd')) then
    select idtabb into _idzal from dvazebtab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    -- v případě odpočtu zálohové položky je ve vazební tabulce odkazována položka faktury, my ale chceme hlavičku faktury
    if (_idzal is null) then
        select pf.iddoklfak into _idzal from dvazebtab vt inner join dpolfak pf on vt.idtabb = pf.idpolfak where vt.idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY';
    end if;
    
    
        -- SK - pomocný interní doklad
    select d.iddoklint, vtz.idvazby, vtf.idvazby into _idPomInt, _idVazbaOdpocFak, _idVazbaUhrFak from ddoklint d 
        inner join dvazebtab vtz on vtz.idtaba = d.iddoklint
        inner join dvazebtab vtf on vtf.idtaba = d.iddoklint 
        where 
        vtz.idtabb = _idzal and vtz.typvazbyk = 'typVazbyDokl.odpocitavanaFaktura' and 
            vtf.idtabb =  OLD.idDoklFak and vtf.typvazbyk = 'typVazbyDokl.uhrazovanaFaktura';

    if (_idVazbaOdpocFak is not null and _idVazbaUhrFak is not null) then
        delete from dvazebtab where idvazby in (_idVazbaOdpocFak, _idVazbaUhrFak);
        delete from dpolint  where iddoklint = _idPomInt;
        delete from ddoklint where iddoklint = _idPomInt;
    end if;
    -- /SK - pomocný interní doklad
    
    delete from dVazebTab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD' or typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
    
    select * into _dokl from dDoklFak where idDoklFak = OLD.idDoklFak;
    
    if (_dokl.stavUhrK = 'stavUhr.uhrazeno' and OLD.sumZkl < 0) then
      select count(*) into uhrad from dVazebTab where idTabA = _dokl.idDoklFak and modulA = _dokl.modul and typVazbyK = 'typVazbyDokl.uhrada';
      
      _stavUhrK = null;
      if (uhrad > 0) then
        _stavUhrK = 'stavUhr.castUhr';
      end if;
      
      update dDoklFak set stavUhrK = _stavUhrK where idDoklFak = _dokl.idDoklFak;
    end if;
    
    if _idzal is not null then
      _stavUhrK = null;
      select count(*) into uhrad from dVazebTab where idtabb = _idzal and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
      if (uhrad > 0) then
        _stavUhrK = 'stavOdp.cast';
      end if;
    end if;
    
    update ddoklfak set StavOdpocetK = _stavUhrK where iddoklfak = _idzal and not comparevarchar(StavOdpocetK, _stavUhrK);
    
    -- smazání vazeb a položek korekce KR odpočtu
    select idtabb into _idKorekce from dvazebtab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';

    if (_idKorekce is not null) then
        -- aktualizace juhSum
        update ddoklfak set juhSum = juhSum - (select sumZkl + sumDph from dpolfak where idpolfak = _idKorekce) where iddoklfak in (select iddoklfak from dpolfak where idpolfak = _idKorekce and not storno);
        delete from dVazebTab where idtaba = OLD.idPolFak and typVazbyK = 'typVazbyDokl.KROdpoctu';
        delete from dpolfak where idpolfak = _idKorekce;
    end if;
  end if;  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakdeletevazba() OWNER TO %firmaRole%;

--
-- TOC entry 34 (class 1255 OID 238800)
-- Dependencies: 3 673
-- Name: dpolfakupdateucty(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger
    AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
        pol record;
        df record;
        ds record;
        ucetFak varchar;
        ucetSkl varchar;
        osUpravaDoklad boolean;
begin  
  -- nacteni typu pohybu  
  select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy 
  if (typPohyb = 'typPohybu.prijem') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphMdUcet = NEW.idDphDalUcet where compareId(idDphMdUcet, NEW.idDphDalUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  -- kopírování účtů DPH pro potřeby pomocných dokladů osobitné úpravy
  if (typPohyb = 'typPohybu.vydej') then
      -- meni se ucet dane   
      if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then

          select d.osobupravadph into osUpravaDoklad from ddoklfak d where d.iddoklfak = NEW.iddoklfak; 
          if (osUpravaDoklad) then
              update dPolInt set idDphDalUcet = NEW.idDphMdUcet where compareId(idDphDalUcet, NEW.idDphMdUcet) = false and idpolint in 
                  (select pi.idPolInt from ddoklfak ddf inner join dvazebtab vt on vt.idtabB = ddf.iddoklfak inner join ddoklint di on vt.idtaba = di.iddoklint 
                       inner join dpolint pi on pi.iddoklint = di.iddoklint where vt.typVazbyK = 'typVazbyDokl.uhrazovanaFaktura' and ddf.iddoklfak = NEW.iddoklfak and pi.idSazbydph = NEW.idSazbydph);
          end if;
      end if;
  end if;
  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          select * into pol from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl') limit 1;
          select * into df from ddoklfak where iddoklfak = NEW.iddoklfak;
          select * into ds from ddoklsklad where iddoklsklad = pol.iddoklsklad;
          
          select kod into ucetFak from uucty where iducet = NEW.idZklMdUcet;
          select kod into ucetSkl from uucty where iducet = pol.idZklDalUcet;
        
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. FAK: zdroj-% hrom-% pol: kop-% % zdroj-% SKL: zdroj-% hrom-% pol: kop-% % zdroj-%', 
            df.zdrojProSkl, df.hromFakt, NEW.kopZklMdUcet, ucetFak, NEW.zdrojProSkl, ds.zdrojProFak, ds.hromFakt, true, ucetSkl, pol.ZdrojProFak;  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet where compareId(idZklDalUcet, NEW.idZklDalUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Zkl.';
            end if;
          end if;
          
          if (NEW.ucetni) then
              -- korekce kr (změna účtu na odpočtové položce vyvolá změnu účtu na položkce korekce)
              update dPolFak set idZklMdUcet = NEW.idZklDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idZklMdUcet, NEW.idZklDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZisk');

              update dPolFak set idZklDalUcet = NEW.idZklDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idZklDalUcet, NEW.idZklDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZtrata');

          end if;
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphDalUcet where compareId(idDphDalUcet, NEW.idDphDalUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
          
          if (NEW.ucetni) then
              -- korekce kr (změna účtu na odpočtové položce vyvolá změnu účtu na položkce korekce)
            update dPolFak set idDphMdUcet = NEW.idDphDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idDphMdUcet, NEW.idDphDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZisk');

            update dPolFak set idDphDalUcet = NEW.idDphDalUcet where idPolFak in (select idTabB from dVazebTab v inner join dpolfak pf on pf.idpolfak = v.idtabB where v.typVazbyK = 'typVazbyDokl.KROdpoctu' and idTabA = NEW.idPolFak
              and compareId(pf.idDphDalUcet, NEW.idDphDalUcet) = false and pf.typPolozkyK = 'typPolozky.korekceKRZtrata');
              
          end if; 
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  

            select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true and  
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            -- pokud smime zmenit vsechny polozky co potrebujeme menime  
            if (nelzeZmena = 0) then  
              update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet where compareId(idZklMdUcet, NEW.idZklMdUcet) = false and idPolFak in  
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
            else  
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Md Zkl.';
            end if;
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  

          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then
            select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true and
                idPolFak in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            -- pokud smime zmenit vsechny polozky co potrebujeme menime
            if (nelzeZmena = 0) then
              update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphMdUcet where compareId(idDphMdUcet, NEW.idDphMdUcet) = false and idPolFak in
                (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');
            else
              raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Odpocet zalohove polozky - ucet Dal Dph.';
            end if;
          end if;
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  

  if (NEW.zaloha = true) then
    -- nacteni typu pohybu
    select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;

    if (typPohyb = 'typPohybu.prijem') then
      if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false or compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and compareId(idZklDalUcet, NEW.idZklDalUcet) = false and kopZklDalUcet = true) or
          (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false and compareId(idDphDalUcet, NEW.idDphDalUcet) = false and kopDphDalUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idZklDalUcet, idDphDalUcet = NEW.idDphDalUcet 
            where (compareId(idZklDalUcet, NEW.idZklDalUcet) = false or compareId(idDphDalUcet, NEW.idDphDalUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
    if (typPohyb = 'typPohybu.vydej') then
      if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false or compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then
        select count(*) into nelzeZmena from dPolFak where 
          ((compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and compareId(idZklMdUcet, NEW.idZklMdUcet) = false and kopZklMdUcet = true) or
          (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false and compareId(idDphMdUcet, NEW.idDphMdUcet) = false and kopDphMdUcet = true))
          and idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklMdUcet, idDphMdUcet = NEW.idDphMdUcet 
            where (compareId(idZklMdUcet, NEW.idZklMdUcet) = false or compareId(idDphMdUcet, NEW.idDphMdUcet) = false) and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idPolFak and modulB = NEW.modul and typVazbyK = 'typVazbyDokl.odpocetPolZALOHY');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. Zalohova polozka - ucet Dal.';
        end if;
      end if;
    end if;
  end if;
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;

--
-- TOC entry 74 (class 1255 OID 241920)
-- Dependencies: 3 673
-- Name: dpolfakupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolfakupdatezauctovano()
  RETURNS trigger AS
$BODY$
declare
  ZAZNAM record;
  _idPolDokl integer;
  _zuctovano boolean;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  select isDokladZuctovan(ZAZNAM.idDoklFak, 'Fak') into _zuctovano;
  
  update ddoklfak set zuctovano = _zuctovano where idDoklFak = ZAZNAM.idDoklFak and zuctovano <> _zuctovano;
  
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

ALTER FUNCTION public.dpolfakupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 75 (class 1255 OID 241922)
-- Dependencies: 673 3
-- Name: dpolintupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolintupdatezauctovano()
  RETURNS trigger AS
$BODY$
declare
  ZAZNAM record;
  _idPolDokl integer;
  _zuctovano boolean;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  select isDokladZuctovan(ZAZNAM.idDoklInt, 'Int') into _zuctovano;
    
  update ddoklint set zuctovano = _zuctovano where idDoklInt = ZAZNAM.idDoklInt and zuctovano <> _zuctovano;
    
  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

ALTER FUNCTION public.dpolintupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 37 (class 1255 OID 238801)
-- Dependencies: 3 673
-- Name: dpolskladdelete(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _mazatTmpTable boolean; 
  _polSklad record;  
begin
  
  if(not OLD.storno) then
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(OLD.datSklad, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if;
    end loop;

    -- musim jeste odpocist mazanou polozku
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad);
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
  
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
        if(_rozsirenaPolozka.cenyRucne = true) then
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        else
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      else
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if;
    end loop;
    
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad);
    
    execute sprepoctisumydokladu(OLD.idDoklSklad);

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if; 
  
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

--
-- TOC entry 35 (class 1255 OID 238802)
-- Dependencies: 673 3
-- Name: dpolskladinsert(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _typPohybuk character varying;
  _mazatTmpTable boolean;
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
  _polSklad record; 
  _pocetMenenychVydejek integer;
  _odsunutaVydejka record;
  _pomocnaVydejka record;
begin
  if(NEW.storno = true) then
    return NEW;
  end if; 
  
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds 
      on ps.datsklad > NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej';
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
      return NEW;
    end if;

    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then
        if(_rozsirenaPolozka.cenyRucne = true) then
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
          if(_rozsirenaPolozka.storno = false) then 
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
          end if;
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      end if;
    end loop;

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.cenyRucne = true) then
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
        if(_rozsirenaPolozka.storno = false) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        end if;
      else
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      end if;
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
  --pokud výdej, tak fifuju vazby
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then
     execute sfifoDobropis(NEW.idpoldobropis, NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, 
              NEW.idKarty, NEW.mnozmj, NEW.cenyrucne);
    
    --execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
  end if;

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad);

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;

--
-- TOC entry 36 (class 1255 OID 238803)
-- Dependencies: 3 673
-- Name: dpolskladupdate(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
  _polSklad record;
  _datPosl date;
  _newDatPosl date;
begin 

  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno 
  ) then
    if(not comparedate(NEW.datVyst, OLD.datVyst)) then
      -- pokud se nezmenilo nic jinyho jen datum vystaveni
      select datPosl into _datPosl from skarty where idkarty = NEW.idkarty;
      select max(datVyst) into _newDatPosl from dPolSklad where idKarty = NEW.idKarty;
      
      if(_newDatPosl is not null and _datPosl is not null and _newDatPosl <> _datPosl) then
        update skarty set datPosl = _newDatPosl where idKarty = NEW.idKarty;
      end if;
    end if;
    return NEW;
  end if;

  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      --select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      --if(_pocetPolozek > 0) then 
      select 1 into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad limit 1; 
      if(_pocetPolozek is not null) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    if (OLD.storno=false and NEW.storno=true) then
      execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
    end if;

    _sklfifo := (select isfifosklad(NEW.datVyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.cenamj <> NEW.cenamj or OLD.sumZkl <> NEW.sumZkl) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   
 
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne);
    end if;
    
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
            end if;
          else 
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        end if; 
      end loop; 

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
            end if;
          else
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad); 

  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

--
-- TOC entry 38 (class 1255 OID 238804)
-- Dependencies: 3 673
-- Name: dpolskladupdateucty(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolskladupdateucty() RETURNS trigger
    AS $$
declare
  nelzeZmena int;
  _modul character varying;
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    -- z prijemky se pres vazbu polozkaSklPrevod ma prenaset ucet zklDal na vydejku zklMd
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set lastupdate = now(), idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  else
    -- z vydejky se ma pres vazbu polozkaSklPrevod ma prenaset ucet zklMd na ucet zklDal
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then
      select modulB into _modul from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        
        if (nelzeZmena = 0) then
          update dPolInt set lastupdate = now(), idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;
      else
        if _modul = 'FAP' then
          select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          
          if (nelzeZmena = 0) then
            update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
              idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          else
            raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
          end if;
        end if;
      end if;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;


ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;

--
-- TOC entry 76 (class 1255 OID 241924)
-- Dependencies: 3 673
-- Name: dpolskladupdatezauctovano(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dpolskladupdatezauctovano()
  RETURNS trigger AS
$BODY$
declare
  ZAZNAM record;
  _idPolDokl integer;
  _zuctovano boolean;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;
  
  select isDokladZuctovan(ZAZNAM.idDoklSklad, 'Sklad') into _zuctovano;
    
  execute putglotxvariable('dpolskladupdatezauctovano', 'true');
  update ddoklsklad set zuctovano = _zuctovano where idDoklSklad = ZAZNAM.idDoklSklad and zuctovano <> _zuctovano;
  execute removeglotxvariable('dpolskladupdatezauctovano');
    
  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;

ALTER FUNCTION public.dpolskladupdatezauctovano() OWNER TO %firmaRole%;

--
-- TOC entry 84 (class 1255 OID 241956)
-- Dependencies: 3 673
-- Name: drop_constraint_if_exists(character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION drop_constraint_if_exists(table_name character varying, constraint_name character varying) RETURNS void
    AS $$   
declare   
  _pocetConstraintu integer; 
  _exception character varying; 
begin 
 select count(*) into _pocetConstraintu from pg_constraint where conname = constraint_name; 
 if(_pocetConstraintu > 0) then 
   execute 'Alter table '||table_name||' drop constraint '||constraint_name||';'; 
 end if; 
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.drop_constraint_if_exists(table_name character varying, constraint_name character varying) OWNER TO %firmaRole%;

--
-- TOC entry 39 (class 1255 OID 238805)
-- Dependencies: 3 673
-- Name: duniquecisdokl(integer, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION duniquecisdokl(i_iddokl integer, i_modul character varying, i_typpohybuk character varying, i_cisdokl character varying) RETURNS boolean
    AS $$  
declare  
  _idDokl integer;  
begin  
  if (i_Modul in( 'FAV','FAP','PHL','ZAV') ) then  
    select idDoklFak into _idDokl from dDoklFak where Kod = i_CisDokl and modul = i_Modul limit 1;  
  end if;  
  if (i_Modul in( 'SKL') ) then  
    select idDoklSklad into _idDokl from dDoklSklad where Kod = i_CisDokl and modul = i_Modul limit 1;  
  end if;  
  if (i_Modul in( 'BAN','POK','INT')) then  
    select idDoklInt into _idDokl from dDoklInt where Kod = i_CisDokl and modul = i_Modul limit 1;  
  end if;  
  if(i_Modul in( 'NAP','NAV','PPP','PPV','OBP','OBV') ) then  
    select idDoklObch into _idDokl from dDoklObch where Kod = i_CisDokl and modul = i_Modul limit 1;  
  end if;  
    
  if((_idDokl is not null) and (_idDokl <> i_idDokl)) then  
    return false;  
  else  
    return true;  
  end if;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.duniquecisdokl(i_iddokl integer, i_modul character varying, i_typpohybuk character varying, i_cisdokl character varying) OWNER TO %firmaRole%;

--
-- TOC entry 40 (class 1255 OID 238806)
-- Dependencies: 3 673
-- Name: dvazebtabinsdelpreceneni(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dvazebtabinsdelpreceneni() RETURNS trigger
    AS $$  
declare isUcetni boolean;  
        celkemMen numeric(15,2);  
        datumUcto date;  
        datumVyst date;  
        ZAZNAM record;  
begin  
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;  
  
  isUcetni := false;  
  datumUcto := null;  
  datumVyst := null;  
  
  if (ZAZNAM.typVazbyK = 'typVazbyDokl.uhrada') then  
    select ucetni, sumCelkemMen into isUcetni, celkemMen from dDoklFak where idDoklFak = ZAZNAM.idTabA and modul = ZAZNAM.modulA;  
  
    if (isUcetni = true and celkemMen <> 0) then  
        select datUcto, datVyst into datumUcto, datumVyst from dDoklInt where idDoklInt = ZAZNAM.idTabB and modul = ZAZNAM.modulB;  
          
        if (datumUcto is not null) then  
          execute uNastavChybaPreceneni(datumUcto);  
        else  
          execute uNastavChybaPreceneni(datumVyst);  
        end if;  
  
    end if;  
  
  end if;  
    
  return ZAZNAM;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dvazebtabinsdelpreceneni() OWNER TO %firmaRole%;

--
-- TOC entry 43 (class 1255 OID 238807)
-- Dependencies: 673 3
-- Name: dvratcisdokl(integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dvratcisdokl(i_idrady integer, i_iducetobdobi integer, i_cisdokl character varying) RETURNS boolean
    AS $$ 
declare 
  _CisDelka integer; 
  _ZobrazNuly boolean; 
  _Prefix varchar(8); 
  _Postfix varchar(8); 
  _CisAkt integer; 
  _unique boolean; 
  _modul varchar; 
  _typPohybu varchar; 
  _idRadyDiry integer; 
  _idRadyRok integer; 
  _CisPoc integer; 
  _idRady integer; 
  _idUcetObdobi integer; 
  _idRadyDiryT integer; 
 
  _CisDokl varchar(20); 
begin 
  /** Nejprve se zkontrolují vstupní parametry **/     
   
  /* Id dokladové řady nesmí být null */
  /* !!! Důležité !!! Podmínky na následujících řádcích nevyhazují výjimku kvůli 
     importu z W6 na W10. */ 
  if (i_idRady is null) then 
    return true; 
    /*raise exception 'dVratCisDokl(): Vstupní číslo dokladové řady nesmí být prázdné!';*/ 
  end if; 
   
  /* Kontrola existence id řady */ 
  select idRady into _idRady from dRady where idRady = i_idRady; 
  if (_idRady is null) then 
    return true; 
    /*raise exception 'dVratCisDokl(): Pokus o vrácení čísla do dokladové řady, která neexistuje!';*/ 
  end if; 
   
  if (i_idUcetObdobi is null) then 
    raise exception 'dVratCisDokl(): Číslo vstupního účetního období je null!'; 
  end if; 
   
  select idUcetObdobi into _idUcetObdobi from nUcetObdobi where idUcetObdobi=i_idUcetObdobi; 
  if (_idUcetObdobi is null) then 
    raise exception 'dVratCisDokl(): Číslo vstupního účetního období neodpovídá existujícímu účetnímu období!'; 
  end if; 
   
  /** Konec striktní kontroly vstupních údajů **/ 
   
  /* Zjistí se číslo, které je na vrcholu dokladové řady pro účetní období */ 
  select CisDelka,ZobrazNuly,CisAkt,CisPoc,Prefix,Postfix,idRadyRok into _CisDelka,_ZobrazNuly,_CisAkt,_CisPoc,_Prefix,_Postfix, 
    _idRadyRok from dRadyRok where idRady = i_idRady and idUcetObdobi = i_idUcetObdobi for update; 
   
  /* Zjistí se modul a typ pohybu, pro kterou řada je. */ 
  select modul into _modul from dRady where idRady = i_idRady; 
   
  /* Vytvoří nové číslo podle vrcholu čís. řady pro porovnání */ 
  _CisDokl:= (select dVytvorCisDokl(_Prefix,_CisAkt,_Postfix,_ZobrazNuly,_CisDelka,i_idUcetObdobi));         
   
  /* Porovnám číslo z vrcholu řady s navráceným číslem. Pokud se jedná o poslední číslo řady, jednoduše snížím čítač, 
     protože novější číslo nebylo přiřazeno. Pokud ne, vložím číslo do seznamu děr.*/ 
  if (rtrim(_CisDokl) = rtrim(i_CisDokl)) then 
     update dRadyDiry set LastUpdate=now() where idRadyRok = _idRadyRok and cisdira = _CisDokl; 
      
     /* Pokud se maže doklad, který je na vrcholu a není v díře */ 
     select idRadyDiry into _idRadyDiryT from dRadyDiry where cisdira = _CisDokl and idRadyRok = _idRadyRok and LastUpdate<=now(); 
     if (_idRadyDiryT is null and _CisAkt <> _CisPoc) then 
       _CisAkt:= _CisAkt - 1; 
     end if; 
      
     loop 
       _CisDokl:= (select dVytvorCisDokl(_Prefix,_CisAkt,_Postfix,_ZobrazNuly,_CisDelka,i_idUcetObdobi)); 
       select idRadyDiry into _idRadyDiry from dRadyDiry where cisdira = _CisDokl and idRadyRok = _idRadyRok and LastUpdate<=now(); 
       if (_idRadyDiry is not null) then 
         delete from dRadyDiry where cisdira = _CisDokl and idRadyRok = _idRadyRok and LastUpdate<=now(); 
          
         /* Kontrola, aby nedošlo k přetečení počátku. */ 
         if (_CisAkt <> _CisPoc) then 
           _CisAkt:= _CisAkt - 1; 
         end if; 
       else        
         exit; 
       end if; 
     end loop; 
     
     update dRadyRok set cisAkt = _cisAkt where idRadyRok = _idRadyRok; 
  else 
    /* Nejsem na vrcholu rady - změním rezervaci na díru nebo díru založím, při opakovaném volání díru nevytvořím */ 
    select idRadyDiry into _idRadyDiry from dRadyDiry where idRadyRok = _idRadyRok and CisDira = i_CisDokl; 
    if(_idRadyDiry is null) then 
      insert into dRadyDiry( idRadyRok,CisDira,LastUpdate) values( _idRadyRok,i_CisDokl,now()); 
    else 
      update dRadyDiry set LastUpdate = now() where idRadyDiry = _idRadyDiry; 
    end if; 
  end if; 
   
  return true; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dvratcisdokl(i_idrady integer, i_iducetobdobi integer, i_cisdokl character varying) OWNER TO %firmaRole%;

--
-- TOC entry 41 (class 1255 OID 238808)
-- Dependencies: 673 3
-- Name: dvytvorcisdokl(character varying, integer, character varying, boolean, integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dvytvorcisdokl(i_prefix character varying, i_cisakt integer, i_postfix character varying, i_zobraznuly boolean, i_cisdelka integer, i_iducetniobdobi integer) RETURNS character varying
    AS $$  
declare  
  o_CisDokl varchar(20);  
  loc_Prefix varchar(8);  
  loc_Postfix varchar(8);  
  loc_ZobrazNuly boolean;  
  loc_cisAkt integer;  
  loc_CisDelka integer;  
  loc_CisDokl integer;  
  cislo_str varchar(20);  
  loc_Rok integer;  
  str_Rok varchar(10);  
begin  
  /* Inicializace lokálních proměnných */  
  loc_Prefix:= i_Prefix;  
  loc_Postfix:= i_Postfix;  
  loc_ZobrazNuly:= i_ZobrazNuly;  
  loc_cisAkt:= i_cisAkt;  
  loc_CisDelka:= i_CisDelka;  
    
  /* Počátační kontrola vstupních proměnných */  
  if (i_CisAkt < 0) then  
    raise exception 'dVytvorCisDokl(): Aktuální číslo řady je neplatné. Je: %', i_CisAkt;  
  end if;  
  
  /* Pokud je prefix či postfix null, nahraď za prázdný řetězec */  
  if loc_Prefix is null then  
    loc_Prefix:= '';  
  end if;  
  if loc_Postfix is null then  
    loc_Postfix:= '';  
  end if;  
    
  /* Získá se číslo pro nahrazení roku a případně se před něj doplní nula, pokud není 4 znaky dlouhý */  
  select RokProRadu into loc_Rok from nucetobdobi where iducetobdobi=i_idUcetniObdobi;  
  str_Rok:= lpad (cast (loc_Rok as text), 4, '0');  
  
  /* Náhrada masky roku */  
  loc_Prefix:= replace (loc_Prefix, '%YYYY%', str_Rok);  
  loc_Prefix:= replace (loc_Prefix, '%YYY%', substring (str_Rok from 2));  
  loc_Prefix:= replace (loc_Prefix, '%YY%', substring (str_Rok from 3));  
  loc_Prefix:= replace (loc_Prefix, '%Y%', substring (str_Rok from 4));    
  
  loc_Postfix:= replace (loc_Postfix, '%YYYY%', str_Rok);  
  loc_Postfix:= replace (loc_Postfix, '%YYY%', substring (str_Rok from 2));  
  loc_Postfix:= replace (loc_Postfix, '%YY%', substring (str_Rok from 3));  
  loc_Postfix:= replace (loc_Postfix, '%Y%', substring (str_Rok from 4));   
    
  if loc_ZobrazNuly = false then  
    o_CisDokl:= rtrim(loc_Prefix) || ltrim(cast (loc_CisAkt as text)) || rtrim(loc_Postfix);  
  else  
    o_CisDokl:= rtrim(loc_Prefix) || (case when (length(cast(loc_CisAkt as text))) < i_CisDelka then lpad(cast(loc_CisAkt as text), i_CisDelka, '0') else cast(loc_CisAkt as text) end) || rtrim (loc_Postfix);  
  end if;  
  
  cislo_str:= ltrim(cast (loc_CisAkt as text));    
  
  /* Přetečení rozsahu číselné řady */  
  /* Bug 32039 – [FlexiBee] Zrušit limit na číselnou řadu
  if Length(ltrim(cislo_str)) > i_CisDelka then  
    o_CisDokl:= 'x';  
  end if;  */
  
  /* Délka čísla je delší než 20 */  
  if Length(o_CisDokl) > 20 then  
    o_CisDokl:= 'xx';  
  end if;  
    
  /* Maximální délka čísla nesmí být delší než 12 znaků (viz. manuál) */  
  if Length (cislo_str)>12 then  
    o_CisDokl:= 'xxx';  
  end if;  
  
  return o_CisDokl;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dvytvorcisdokl(i_prefix character varying, i_cisakt integer, i_postfix character varying, i_zobraznuly boolean, i_cisdelka integer, i_iducetniobdobi integer) OWNER TO %firmaRole%;

--
-- TOC entry 42 (class 1255 OID 238809)
-- Dependencies: 673 3
-- Name: dzalozradurok(integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dzalozradurok(i_idrady integer, i_iducetniobdobi integer, i_modul character varying) RETURNS void
    AS $$  
declare  
  _PlatiOdData date;  
  _idUcetObdobi integer;  
  _idNalezeneRady integer;    
    
  _CisDelka integer;  
  _ZobrazNuly boolean;  
  _CisAkt integer;  
  _CisPoc integer;  
  _Prefix varchar;  
  _Postfix varchar;  
  _idRadyRok integer;  
  _Unique boolean;  
  _PostfixIncrement integer;     
  _PocetNalezeni integer;  
  i integer;  
  _DefPostfix varchar;  
  _idRady integer;  
     
  _radyCursor refcursor;  
begin  
  
  /* Zjistí se, zda pro starší účetní období existuje položka dokladové řady. */    
  select platiOdData into _PlatiOdData from nUcetObdobi where iducetobdobi = i_idUcetniObdobi;  

  select rr.idRadyRok, uo.iducetobdobi into _idNalezeneRady, _idUcetObdobi
  from dRadyRok rr join nUcetObdobi uo on uo.iducetobdobi = rr.iducetobdobi
  where rr.idRady = i_idRady and uo.platiOdData < _PlatiOdData 
  order by uo.platiOdData desc limit 1;
  
  /* Pokud byla nějaká dokladová řada pro starší rok nalezena, provede se překopírování záznamu. */  
  if (_idNalezeneRady is not null) then  
      
    /* Vrátí se data z nejnovějšího roku */  
    select CisDelka, ZobrazNuly, CisAkt, CisPoc, Prefix, Postfix, idRadyRok into _CisDelka,_ZobrazNuly,_CisAkt,_CisPoc,_Prefix,_Postfix,  
    _idRadyRok from dRadyRok where idRady = i_idRady and iducetobdobi = _idUcetObdobi;  
        
        
    /* Provede se vložení záznamu pro nejvyšší rok */  
    insert into dRadyRok (idRady,idUcetObdobi,CisDelka,ZobrazNuly,CisAkt,CisPoc,Prefix,Postfix,LastUpdate) values  
          (i_idRady, i_idUcetniObdobi, _CisDelka, _ZobrazNuly, _CisPoc, _CisPoc, _Prefix, _Postfix, now());  
    
  else  
    /* Neexistuje žádná položka dokladové řady pro starší účetní období, vytvoří se nová s implicitními hodnotami.  
       Provede se též kontrola, zda nově vytvořený záznam dokladové řady pro daný rok nekoliduje s již existujícím záznamem.  
       Pokud ano, provede se úprava výchozích hodnot řady tak, aby byla nově přidaná dokladová řada pro rok unikátní. */  
      
    _defPostfix:= '/%YY%';  
    _Unique:= false;  
    _postfixIncrement:= 0;  
    _CisPoc:= 1;     
      
    while (_Unique = false) loop  
      _Postfix:= _DefPostfix;  
      if (_PostfixIncrement > 0) then  
        _Postfix:= _postfix || '-' || cast (_PostfixIncrement as text);  
      end if;        
        
      _PocetNalezeni:= 0;  
      open _RadyCursor for select idRady from dRady where modul = i_modul;  
      loop  
        fetch _Radycursor into i;  
        if (i is null) then  
          exit;  
        end if;  
          
        select idRady into _idRady from dRadyRok where Prefix = '' and Postfix = _postfix and idUcetObdobi = i_idUcetniObdobi and idRady = i and cispoc = _cisPoc;  
        if (_idRady is not null) then  
          _PocetNalezeni:= _PocetNalezeni + 1;  
        end if;                  
      end loop;  
      close _RadyCursor;  
        
        
      if _PocetNalezeni = 0 then  
        _Unique:= true;  
      end if;  
        
      _PostfixIncrement:= _PostfixIncrement + 1;         
    end loop;             
  
    insert into dRadyRok (idRady,idUcetObdobi,CisDelka,ZobrazNuly,CisAkt,CisPoc,Prefix,Postfix,LastUpdate) values  
      (i_idRady,i_idUcetniObdobi,8,true,_cisPoc,_cisPoc,'',_postfix,now());  
         
  end if;    
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dzalozradurok(i_idrady integer, i_iducetniobdobi integer, i_modul character varying) OWNER TO %firmaRole%;

--
-- TOC entry 45 (class 1255 OID 238810)
-- Dependencies: 3 673
-- Name: dzdoklcheckvazby(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dzdoklcheckvazby() RETURNS trigger
    AS $$ 
declare   
  _idDokl integer;   
  _notInDVazebTab boolean;     
begin     
  if (OLD.modul in ('FAV', 'FAP', 'PHL', 'ZAV')) then   
    _idDokl:= OLD.idDoklFak;   
  else   
    if (OLD.modul in ('SKL')) then   
      _idDokl:= OLD.idDoklSklad;   
    else   
      if (OLD.modul in ('BAN', 'POK', 'INT')) then   
        _idDokl:= OLD.idDoklInt;   
      else 
        if (OLD.modul in ('PPP', 'NAV', 'OBP', 'PPV', 'NAP', 'OBV')) then 
          _idDokl := OLD.idDoklObch; 
        else   
          raise exception 'dDoklCheckVazby(): Neznámý modul: %', OLD.modul; 
        end if; 
      end if; 
    end if; 
  end if; 
   
  _notInDVazebTab:= (select dZkontrolujVazebniTab (_idDokl, true, OLD.modul)); 
  if (_notInDVazebTab = false) then 
    raise exception '0004:dDoklCheckVazby(): Ve vazební tabulce zůstávají vazby na doklad.'; 
  end if; 
   
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dzdoklcheckvazby() OWNER TO %firmaRole%;

--
-- TOC entry 47 (class 1255 OID 238811)
-- Dependencies: 3 673
-- Name: dzkontrolujvazebnitab(integer, boolean, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) RETURNS boolean
    AS $$ 
declare 
  _pocetVazeb integer; 
begin 
   
  /* Jedná se o položku dokladu */ 
  if (i_isDoklad = false) then 
    /* idtaba i idtabb jsou položky */ 
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk in ('typVazbyDokl.polozkaSkl', 
                                                             'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod',
                                                             'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol', 
                                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol',
                                                             'typVazbyDokl.odpocetPolZALOHY', 'typVazbyDokl.polozkaDobropis')) 
                                                      and ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb = i_modul)); 
    if (_PocetVazeb <> 0) then 
      return false; 
    end if; 
     
    /* kontrola, kde je pro položku dokladu jen u idtaba, jedná se o "typVazbyDokl.odpocetZALOHY" a "typVazbyDokl.odpocetZDD" */ 
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk = 'typVazbyDokl.odpocetZALOHY' or typvazbyk = 'typVazbyDokl.odpocetZDD') 
                                                      and ((idtaba = i_idDokl and modula = i_modul and modulb = i_modul)); 
    if (_pocetVazeb <> 0) then 
      return false; 
    end if; 
     
    return true; 
  else 
   
   /* Jedná se o doklad, kde je hlavička */ 
   select count(*) into _pocetVazeb from dVazebTab where (typvazbyk not in ('typVazbyDokl.polozkaSkl', 
                            'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod', 
                            'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol', 
                            'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol',
                            'typVazbyDokl.odpocetPolZALOHY', 'typVazbyDokl.polozkaDobropis', 'typVazbyDokl.KROdpoctu') 
                        ) and (not ( 
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZALOHY') or 
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZDD') or 
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZALOHY') or 
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZDD'))) and 
                        ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb=i_modul)); 
   if (_pocetVazeb <> 0) then 
     return false; 
   end if; 
      
   return true; 
  end if; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) OWNER TO %firmaRole%;

--
-- TOC entry 46 (class 1255 OID 238812)
-- Dependencies: 673 3
-- Name: dzpoldoklcheckvazby(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION dzpoldoklcheckvazby() RETURNS trigger
    AS $$ 
declare 
  _idPolDokl integer; 
  _notInDVazebTab boolean; 
begin 
  if (OLD.modul in( 'FAV','FAP','PHL','ZAV')) then 
    _idPolDokl:= OLD.idPolFak; 
  else 
    if (OLD.modul in( 'SKL')) then 
      _idPolDokl:= OLD.idPolSklad; 
    else 
      if (OLD.modul in( 'BAN','POK','INT')) then 
        _idPolDokl:= OLD.idPolInt; 
      else 
        if (OLD.modul in ('PPP', 'NAV', 'OBP', 'PPV', 'NAP', 'OBV')) then 
          _idPolDokl := OLD.idPolObch; 
        else 
          raise exception 'dPolDoklCheckVazby(): Neznámý modul: %', OLD.modul; 
        end if; 
      end if; 
    end if; 
  end if; 
   
  _notInDVazebTab:= (select dZkontrolujVazebniTab (_idPolDokl, false, OLD.modul)); 
  if (_notInDVazebTab = false) then 
    raise exception '0003:dDoklCheckVazby(): Ve vazební tabulce zůstávají vazby na položku dokladu.'; 
  end if; 
   
  return OLD; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.dzpoldoklcheckvazby() OWNER TO %firmaRole%;

--
-- TOC entry 94 (class 1255 OID 242124)
-- Dependencies: 669 673 3
-- Name: findvazbydokladu(integer, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION findvazbydokladu(_iddokl integer, _modul character varying) RETURNS SETOF vazbadokladu 
    AS $$
declare
  zaznam Record;
  _uroven integer;
  _prechodVP boolean;    -- zda povolen prechod z PPV/OBV na PPP/OBP
  _prechodZaucProd boolean;  -- zda jiz probehl prechod pres zauctovani prodejek
begin
  _uroven = 1;
  _prechodVP = true;
  _prechodZaucProd = false;
   
  drop table if exists vazbydokladu;
   
  CREATE TEMPORARY TABLE vazbydokladu
   (idvazebnidoklad integer NOT NULL,
    datucto timestamp without time zone,
    datvyst timestamp without time zone,
    iddokl integer,
    kod character varying(255),
    modul character varying(255),
    modulk character varying(255),
    popis text,
    poznam text,
    sumcelkem double precision,
    sumcelkemmen double precision,
    typvazbyk character varying(255),
    storno boolean,
    varsym character varying(255),
    idmeny integer,
    iduziv integer,
    idtypdokl integer,
    novy boolean,
    uroven integer,
    stavk character varying(255),
    nazfirmy character varying(255),
  	mesto character varying(255),
   	juhsum double precision,
    juhsummen double precision,
    CONSTRAINT vazbydokladu_pkey PRIMARY KEY (idvazebnidoklad)
  ) WITH (OIDS=FALSE);
   
  perform findViceVazeb('vazbydokladu', _idDokl, _modul, 0, true);
   
  while (select count(*) from vazbydokladu where novy = true) > 0 LOOP
    if _prechodZaucProd = false then
      select (count(*) > 0) into _prechodZaucProd from vazbydokladu where typvazbyk = 'typVazbyDokl.zaucProdejky';
    end if;
    if _prechodVP then
      select (count(*) = 0) into _prechodVP from vazbydokladu where modul in ('OBP', 'PPP') and novy = true;
    end if;
   
    for zaznam in (select * from vazbydokladu where novy = true)
    LOOP
      perform findViceVazeb('vazbydokladu', zaznam.idDokl, zaznam.modul, _uroven, _prechodVP);
   
      update vazbydokladu set novy = false where idvazebnidoklad = zaznam.idvazebnidoklad;
    end loop;

    if _prechodZaucProd then
      delete from vazbydokladu where novy = true and typvazbyk = 'typVazbyDokl.zaucProdejky';
    end if;
 
    _uroven = _uroven + 1;
  end loop;
   
  update vazbydokladu as V set modulK = modulK ||
    (case when (select typPohybuK from dDoklSklad where idDoklSklad = V.idDokl) = 'typPohybu.prijem' then 'PRI' else 'VYD' end)
    where V.modul = 'SKL';
 
  return query SELECT * FROM vazbydokladu;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.findvazbydokladu(_iddokl integer, _modul character varying) OWNER TO %firmaRole%;

--
-- TOC entry 95 (class 1255 OID 242120)
-- Dependencies: 3 673
-- Name: findvicevazeb(character varying, integer, character varying, integer, boolean); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION findvicevazeb(_inserttab character varying, _iddokl integer, _modul character varying, _uroven integer, _prechodvp boolean) RETURNS void
    AS $$ 
declare 
  tabulka varchar(20); 
  poleStav varchar(20); 
  dotaz varchar; 
  prechodPom varchar;   
begin 
  tabulka = getdoklnamepostfixbymodul(_modul); 
  prechodPom = ''; 
 
  if (_uroven = 0) then 
    if (tabulka = 'Fak') then 
      poleStav = 'stavUhrK'; 
    else 
      poleStav = 'stavUzivK';
      prechodPom = 'cast(null as numeric) as ';  
    end if; 
     
    dotaz =  
      'select 0 as idVazby, null as typVazbyK, false as storno, D.idDokl' || tabulka || ' as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.' || poleStav || ' as stavK,
        D.nazFirmy, D.mesto, ' || prechodPom || 'juhsum, ' || prechodPom || 'juhsummen
        from dDokl' || tabulka || ' as D where D.idDokl' || tabulka || ' = ' || _idDokl || ' and D.modul = ''' || _modul || ''''; 
  else 
 
  if (tabulka = 'Fak') then 
    dotaz =  
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'', 
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'', ''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.nakladVynos'')  
          and V.modulB in (''BAN'', ''POK'', ''INT'')  
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.PP'')  
          and V.modulA in (''BAN'', ''POK'', ''INT'')  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazovanaFaktura'')   
          and V.modulA in (''INT'')  
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocitavanaFaktura'')   
          and V.modulA in (''INT'')  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.hlavaSkl'' 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.uhradaPP'', ''typVazbyDokl.hlavaDobropis'')
          and V.modulB in (''PHL'', ''ZAV'', ''FAP'', ''FAV'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.uhradaPP'', ''typVazbyDokl.hlavaDobropis'') 
          and V.modulA in (''PHL'', ''ZAV'', ''FAP'', ''FAV'')
      union  
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul 
        where V.idTabA in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and 
          V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'')  
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavuhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
      union  
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on D.idDoklFak= 
                (select idDoklFak from dPolFak where idPolFak = V.idTabA) and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'') 
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen 
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'')
      union
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dPolFak as P on P.idPolFak = V.idTabA left outer join dDoklFak as D on D.idDoklFak = P.idDoklFak
        where V.idTabB in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and V.modulB=''' || _modul || ''' and
          V.typVazbyK = ''typVazbyDokl.odpocetPolZALOHY''  
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
      union
      select min(V.idVazby) as idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dPolFak as P on P.idPolFak = V.idTabB left outer join dDoklFak as D on D.idDoklFak = P.idDoklFak
        where V.idTabA in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and V.modulB=''' || _modul || ''' and
          V.typVazbyK = ''typVazbyDokl.odpocetPolZALOHY''  
        group by V.typVazbyK, V.storno, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK, D.nazFirmy, D.mesto, D.juhsum, D.juhsummen'; 
  else if (tabulka = 'Int') then 
    dotaz =  
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'', 
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'', ''typVazbyDokl.zaucProdejky'', ''typVazbyDokl.nakladVynos'')  
          and V.modulA in (''PHL'', ''ZAV'', ''FAP'', ''FAV'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.PP'')  
          and V.modulB in (''PHL'', ''ZAV'', ''FAP'', ''FAV'')
          
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.hlavaSkl'')  
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')  
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazujiciDoklad'')   
          and V.modulA in (''INT'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazovanaFaktura'')   
          and V.modulB in (''FAP'', ''FAV'', ''ZAV'', ''PHL'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocitavanaFaktura'')   
          and V.modulB in (''FAP'', ''FAV'')
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK, 
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen 
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrazujiciDoklad'')   
          and V.modulB in (''POK'', ''BAN'')';   
  else if (tabulka = 'Sklad') then 
    dotaz =  
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and  
          V.modulA in (''FAV'',''FAP'',''PHL'',''ZAV'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl''  
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and  
          V.modulA in (''BAN'',''POK'',''INT'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl'' 
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus''
      union
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus''
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and 
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod'' 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and 
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod'' 
      union   
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla'''; 
  else if (tabulka = 'Obch') then 
    if (_prechodVP = false and _modul in ('PPV', 'OBV')) then 
      prechodPom = ' and D.modul in (''PPV'', ''NAP'', ''OBV'')'; 
    end if; 
   
    dotaz =  
      'select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || ' 
      union  
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklObch as D on V.idTabB=D.idDoklObch and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || ' 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK,
        D.nazFirmy, D.mesto, D.juhsum, D.juhsummen
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'') 
      union 
      select V.idVazby, V.typVazbyK, V.storno, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,  
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK,
        D.nazFirmy, D.mesto, cast(null as numeric) as juhsum, cast(null as numeric) as juhsummen
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla'''; 
  else 
    raise exception 'findVazbyDokladu(): Neznámá tabulka % pro modul %', tabulka, _modul;  
  end if; 
  end if; 
  end if; 
  end if; 
   
  end if; 
   
  execute 'insert into ' || _insertTab || ' (idvazebnidoklad, typVazbyK, storno, idDokl, modul, modulk, kod, varsym, datvyst, datucto, sumcelkem, 
  sumcelkemmen, popis, poznam, idtypdokl,idmeny, iduziv, stavk, nazFirmy, mesto, juhsum, juhsummen, uroven, novy) select *, ' || _uroven || ', true from ('  
     || dotaz || ') as UN where (select count(*) from ' || _insertTab || ' as TV where  
     (TV.idDokl = UN.idDokl and TV.modul = UN.modul) or UN.idVazby = TV.idvazebnidoklad) = 0'; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.findvicevazeb(_inserttab character varying, _iddokl integer, _modul character varying, _uroven integer, _prechodvp boolean) OWNER TO %firmaRole%;

--
-- TOC entry 44 (class 1255 OID 238813)
-- Dependencies: 3 673
-- Name: fnn(numeric); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION fnn(x numeric) RETURNS numeric
    AS $$  
declare  
  vysl numeric(15,2);  
begin  
  if x is null then  
    vysl:= 0;  
  else  
    vysl:= x;  
  end if;  
  
  return vysl;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.fnn(x numeric) OWNER TO %firmaRole%;

--
-- TOC entry 73 (class 1255 OID 241912)
-- Dependencies: 673 3
-- Name: generateuniquekod(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION generateuniquekod(i_kod character varying, i_tablename character varying, infix character varying) RETURNS character varying
    AS $$ 
declare  
  _result varchar(20);  
  _resultExt varchar(20);  
  _pocet integer; 
  _cislo integer; 
begin 
  -- pokud neexistuje vratime ho beze zmen 
  execute 'select count(*) from '||i_tableName|| ' where kod = '''||i_kod||'''' into _pocet; 
  if (_pocet = 0) then 
    return i_kod; 
  end if; 
 
  _result = substring(i_kod, 0, 14); 
  _resultExt = _result; 
  _cislo = 2; 
  execute 'select count(*) from '||i_tableName|| ' where kod = '''||_result||'''' into _pocet; 
  while (_pocet > 0) loop 
    _resultExt = _result||infix||_cislo; 
    _cislo = _cislo + 1; 
    execute 'select count(*) from '||i_tableName|| ' where kod = '''||_resultExt||'''' into _pocet; 
  end loop; 
   
  return _resultExt; 
end; 
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.generateuniquekod(i_kod character varying, i_tablename character varying, infix character varying) OWNER TO %firmaRole%;

--
-- TOC entry 80 (class 1255 OID 241932)
-- Dependencies: 673 3
-- Name: getdoklnamepostfixbymodul(character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION getdoklnamepostfixbymodul(modul character varying) RETURNS character varying
    AS $$ 
declare 
  _postfix varchar(20); 
begin 
  if (modul in( 'FAV','FAP','PHL','ZAV')) then 
    _postfix := 'Fak'; 
  else 
    if (modul in( 'SKL')) then 
      _postfix := 'Sklad'; 
    else 
      if (modul in( 'BAN','POK','INT')) then 
        _postfix := 'Int'; 
      else 
        if (modul in ('PPP', 'NAV', 'OBP', 'PPV', 'NAP', 'OBV')) then 
          _postfix := 'Obch'; 
        else 
          raise exception 'getDoklNamePostfixByModul(): Neznámý modul: %', modul; 
        end if; 
      end if; 
    end if; 
  end if; 
   
  return _postfix; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.getdoklnamepostfixbymodul(modul character varying) OWNER TO %firmaRole%;

--
-- TOC entry 48 (class 1255 OID 238814)
-- Dependencies: 673 3
-- Name: getkurzfromdoklad(integer, date); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION getkurzfromdoklad(i_doklskladid integer, i_datvyst date) RETURNS numeric
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenyDoklad integer;  
  _kurzMnozstvi numeric(19,6);  
  _nbStred numeric(19,6);  
  _result numeric(19,6);  
    
begin   
  /* pokud je doklad v tuzemske mene vrati se kurz 1*/  
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenyDoklad from dDoklSklad where idDoklSklad = i_doklSkladId;  
  
  if(idMenyDoklad is null or idMenyDoklad = idMenyTuzemsko) then  
    return 1;  
  end if;   
  /* jinak se nacte z dokladu */  
  select kurz, kurzMnozstvi into _nbStred, _kurzMnozstvi from ddoklsklad where idDoklSklad = i_doklSkladId;  
  
  if _kurzMnozstvi = 0 then  
    _result := 0;  
  else  
    _result := _nbStred / _kurzMnozstvi;  
  end if;  
    
  return _result;   
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.getkurzfromdoklad(i_doklskladid integer, i_datvyst date) OWNER TO %firmaRole%;

--
-- TOC entry 49 (class 1255 OID 238815)
-- Dependencies: 673 3
-- Name: getkurzfromsklad(integer, date); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION getkurzfromsklad(i_skladid integer, i_datvyst date) RETURNS numeric
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenySklad integer;  
  _kurzMnozstvi numeric(19,6);  
  _nbStred numeric(19,6);  
  _result numeric(19,6);  
    
begin   
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenySklad from dBsp where idBsp = i_skladId;
  
  if(idMenySklad is null or idMenySklad = idMenyTuzemsko) then  
    return 1;  
  end if;   
    
  select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy 
  where idMeny = idMenySklad and i_DatVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
  order by PlatiOdData desc limit 1;  
  if(_nbStred is null) then  
    select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy
    where idMeny = idMenySklad and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
    limit 1;  
  end if;  
  if(_nbStred is null) then  
    raise exception '0001:getKurzFromSklad : neexistuje kurz!';  
    /*_nbStred := 0;  
    _kurzMnozstvi := 0;*/  
  end if;  
  
  if _kurzMnozstvi = 0 then  
    _result := 0;  
  else  
    _result := _nbStred / _kurzMnozstvi;  
  end if;  
    
  return _result;   
end;    
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.getkurzfromsklad(i_skladid integer, i_datvyst date) OWNER TO %firmaRole%;

--
-- TOC entry 96 (class 1255 OID 241913)
-- Dependencies: 3 673
-- Name: isdokladzuctovan(integer, character varying); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION isdokladzuctovan(iddokl integer, doklpostfix character varying) RETURNS boolean
    AS $$ 
declare 
  _modul varchar(100);
  _podvojucto boolean; 
  _ucetni boolean; 
  _storno boolean; 
  _bezpol boolean; 
  _datUcto date;  
  _doklOk integer; 
  _polozek integer; 
  _polOk integer; 
  _idDoklVazbaArray integer[]; 
  _idPolVazbaArray integer[]; 
  _idPolVazbaArrayCnt integer; 
  _idPolVazbaArrayCntOk integer; 
  idDoklColumn varchar(100); 
  doklTable varchar(100); 
  polTable varchar(100); 
begin 
  idDoklColumn := 'idDokl' || doklPostfix; 
  doklTable := 'dDokl' || doklPostfix; 
  polTable := 'dPol' || doklPostfix; 
 
  execute 'select modul, datUcto, ucetni, bezpolozek, storno from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl 
   into _modul, _datUcto, _ucetni, _bezpol, _storno; 
  execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl into _polozek; 
  _doklOk := 0; 
 
  if (_ucetni = true and _storno = false) then 
    -- zjistime zda firma vede ucetnictvi 
    select podvojucto into _podvojucto from nNastav where PlatiOdData <= _datUcto order by PlatiOdData desc limit 1; 
    if (_podvojucto is null) then 
      select podvojucto into _podvojucto from nNastav where PlatiOdData is null limit 1;  
    end if; 
 
    if (_podvojucto = true) then 
      -- ucetnictvi 
      if (_polozek = 0) then 
	if (_modul = 'INT') then
          execute
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and
              idstred is not null and datucto is not null and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprimucet is not null) and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and
              ((sumdphsniz = 0 and sumdphzakl = 0) or (iddphsnizucet is not null and iddphzaklucet is not null))'
            into _doklOk;
	else
          execute
            'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and
              idstred is not null and datucto is not null and
              ((sumcelkem = 0) or idprimucet is not null) and
              ((sumosv = 0 and sumzklsniz = 0 and sumzklzakl = 0) or idprotiucet is not null) and
              (sumdphsniz = 0 or iddphsnizucet is not null) and
              (sumdphsniz2 = 0 or iddphsniz2ucet is not null) and 
              (sumdphzakl = 0 or iddphzaklucet is not null)'
            into _doklOk;
	end if;
      else 
        execute 
          'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and 
            (ucetni = false or  
            (idstred is not null and datucto is not null and
              (sumZkl = 0 or (idzkldalucet is not null and idzklmducet is not null)) and
              (modul = ''SKL'' or typszbdphk is null or typszbdphk = ''typSzbDph.dphOsv'' or sumDph = 0 or (
                iddphmducet is not null and iddphdalucet is not null))))' 
          into _polOk; 
        if (_polOk = _polozek) then 
          _doklOk := 1; 
        end if; 
      end if; 
    else 
      -- danova evidence 
      if (doklTable = 'dDoklFak' or doklTable = 'dDoklInt') then 
        if (_bezpol = true or _polozek = 0) then 
          execute 'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' 
            and datucto is not null and danevidk is not null' into _doklOk; 
        else 
          execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' 
            and (ucetni = false or (datucto is not null and danevidk is not null))' into _polOk; 
          if (_polOk = _polozek) then
            _doklOk := 1;
          end if;
        end if; 
        
       --uhrada je zauctovana pokud jsou vsechny polozky vsech navazanych faktur zauctovany
        _idPolVazbaArrayCnt := 0;
        _idPolVazbaArrayCntOk := 0;
        if (doklTable = 'dDoklInt' and _doklOk != 1) then

          -- navazane faktury
          _idDoklVazbaArray := array(select idTabA from dVazebTab where idTabB = idDokl and typVazbyK in ('typVazbyDokl.uhrada'));
          if (coalesce(array_upper(_idDoklVazbaArray, 1), 0) != 0) then
           
            --navazane polozky
            _idPolVazbaArray := array(select idpolfak from dpolfak where iddoklfak = any(_idDoklVazbaArray));
            _idPolVazbaArrayCnt := coalesce(array_upper(_idPolVazbaArray, 1), 0);
            
            --zda jsou vsechny polozky zauctovane
            if (_idPolVazbaArrayCnt != 0) then
              _idPolVazbaArrayCntOk := (select count(*) from dpolfak where danevidk is not null and idpolfak = any(_idPolVazbaArray));
              if (_idPolVazbaArrayCnt = _idPolVazbaArrayCntOk) then
                _doklOk := 1;
              end if;
            end if;
            
          end if;
        end if;
        
      end if; 
    end if; 
  end if; 
   
  return (_doklOk = 1); 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.isdokladzuctovan(iddokl integer, doklpostfix character varying) OWNER TO %firmaRole%;

--
-- TOC entry 50 (class 1255 OID 238816)
-- Dependencies: 3 673
-- Name: isdoklskladmenacizi(integer, date); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION isdoklskladmenacizi(i_dokladid integer, i_datvyst date) RETURNS boolean
    AS $$   
declare   
  idMenyTuzemsko integer;  
  idMenyDoklad integer;  
begin   
  /* Vybrani tuzemske meny a meny z dokladu */  
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (idMenyTuzemsko is null) then  
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;   
  end if;  
  select idMeny into idMenyDoklad from dDoklSklad where idDoklSklad = i_DokladId;  
  
  /* Pokud je mena na dokladu null nebo stejna jako tuzemska tak vracim false*/  
  if(idMenyDoklad is null or idMenyDoklad = idMenyTuzemsko) then  
    return false;  
  end if;   
  return true;   
end;   
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.isdoklskladmenacizi(i_dokladid integer, i_datvyst date) OWNER TO %firmaRole%;

--
-- TOC entry 69 (class 1255 OID 241908)
-- Dependencies: 3 673
-- Name: maxvalue(numeric, numeric); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION maxvalue(num1 numeric, num2 numeric) RETURNS numeric
    AS $$  
begin  
  if (num1 > num2) then 
    return num1; 
  else 
    return num2; 
  end if; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.maxvalue(num1 numeric, num2 numeric) OWNER TO %firmaRole%;

--
-- TOC entry 51 (class 1255 OID 238817)
-- Dependencies: 3 673
-- Name: mdannakldelete(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION mdannakldelete() RETURNS trigger
    AS $$  
declare  
  mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where OLD.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,  
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mdannakldelete() OWNER TO %firmaRole%;

--
-- TOC entry 52 (class 1255 OID 238818)
-- Dependencies: 3 673
-- Name: mdannaklinsert(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION mdannaklinsert() RETURNS trigger
    AS $$  
declare  
  mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where NEW.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,  
        mena, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mdannaklinsert() OWNER TO %firmaRole%;

--
-- TOC entry 53 (class 1255 OID 238819)
-- Dependencies: 673 3
-- Name: mdannaklupdate(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION mdannaklupdate() RETURNS trigger
    AS $$  
declare  
  mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where NEW.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,  
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,  
        mena, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mdannaklupdate() OWNER TO %firmaRole%;

--
-- TOC entry 68 (class 1255 OID 241905)
-- Dependencies: 673 3
-- Name: minvalue(numeric, numeric); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION minvalue(num1 numeric, num2 numeric) RETURNS numeric
    AS $$  
begin  
  if (num1 < num2) then 
    return num1; 
  else 
    return num2; 
  end if; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.minvalue(num1 numeric, num2 numeric) OWNER TO %firmaRole%;

--
-- TOC entry 54 (class 1255 OID 238820)
-- Dependencies: 673 3
-- Name: mmajetekdeleteucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION mmajetekdeleteucto() RETURNS trigger
    AS $$
begin
  -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
  -- dosazujeme -1 a za sumZklMen 0.0
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
       -1, OLD.idStred, -OLD.sumZkl, 0.0);

  return OLD;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mmajetekdeleteucto() OWNER TO %firmaRole%;

--
-- TOC entry 55 (class 1255 OID 238821)
-- Dependencies: 3 673
-- Name: mmajetekinsertucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION mmajetekinsertucto() RETURNS trigger
    AS $$
begin
  -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
  -- dosazujeme -1 a za sumZklMen 0.0
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
        -1, NEW.idStred, NEW.sumZkl, 0.0);

  return NEW;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mmajetekinsertucto() OWNER TO %firmaRole%;

--
-- TOC entry 56 (class 1255 OID 238822)
-- Dependencies: 673 3
-- Name: mmajetekupdateucto(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION mmajetekupdateucto() RETURNS trigger
    AS $$
begin
  IF ( NEW.Ucetni <> OLD.Ucetni OR 
      comparedate(NEW.DatUcto, OLD.DatUcto) = false OR 
 
      compareid(NEW.idZklMdUcet, OLD.idZklMdUcet) = false OR 
      compareid(NEW.idZklDalUcet, OLD.idZklDalUcet) = false OR 
 
      compareid(NEW.idStred, OLD.idStred) = false OR 
 
      NEW.sumZkl <> OLD.sumZkl ) THEN 

    -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
    -- dosazujeme -1 a za sumZklMen 0.0
    execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
         -1, OLD.idStred, -OLD.sumZkl, 0.0);

    -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
    -- dosazujeme null a za sumZklMen 0.0
    execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
         -1, NEW.idStred, NEW.sumZKl, 0.0);
  END IF;

  return NEW;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.mmajetekupdateucto() OWNER TO %firmaRole%;

--
-- TOC entry 57 (class 1255 OID 238823)
-- Dependencies: 3 673
-- Name: msplatkaldelete(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION msplatkaldelete() RETURNS trigger
    AS $$  
declare  
    mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where OLD.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,  
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,  
        mena, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.msplatkaldelete() OWNER TO %firmaRole%;

--
-- TOC entry 58 (class 1255 OID 238824)
-- Dependencies: 3 673
-- Name: msplatkalinsert(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION msplatkalinsert() RETURNS trigger
    AS $$  
declare  
    mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where NEW.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,  
        mena, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,  
        mena, NEW.idStred, NEW.sumDph, NEW.sumDphMen);  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.msplatkalinsert() OWNER TO %firmaRole%;

--
-- TOC entry 59 (class 1255 OID 238825)
-- Dependencies: 3 673
-- Name: msplatkalupdate(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION msplatkalupdate() RETURNS trigger
    AS $$  
declare  
  mena integer;  
begin  
  select leasing.idMeny into mena from mleasing leasing where NEW.idleasing = leasing.idleasing;  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,  
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);  
  
  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,  
        mena, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,  
        mena, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);  
  
  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,  
        mena, NEW.idStred, NEW.sumDph, NEW.sumDphMen);  
  
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.msplatkalupdate() OWNER TO %firmaRole%;

--
-- TOC entry 71 (class 1255 OID 241909)
-- Dependencies: 673 3
-- Name: obchodrealizovatelnost(integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric
    AS $$  
declare 
  zbyvaNakl numeric(15,2); 
  moznoSklad numeric(15,2); 
  moznoNesklad numeric(15,2); 
  vysledek numeric(20,2); 
  _idadresar integer;
begin  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl and mnozmj > 0 and cenamj > 0; 
  
  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl;
  
  select coalesce(sum(a.procpol), 0) into moznoSklad from 
   (select minValue( 
        maxValue(dgetstavnaskladeaktualni(P.idCenik, P.idBspSkl, DATE(NOW()), _idadresar, idDokl, false), 0),
        sum(mnozMj-mnozMjReal)) 
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik 
      where idDoklObch = idDokl and C.skladove = true and mnozMj-mnozMjReal > 0
    group by P.idcenik, idbspskl) as a;
 
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad 
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  where idDoklObch = idDokl and cenaMj > 0 and mnozmj > 0 and  (C.skladove is null or C.skladove = false); 
 
  if (zbyvaNakl = 0) then 
    vysledek := 100 ; 
  else 
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100; 
  end if;  
  if (vysledek < 0.0) then 
     vysledek := -1.0;
  end if;	
  if (vysledek > 999) then 
     vysledek := 999;
  end if; 
   
  return vysledek; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;

--
-- TOC entry 93 (class 1255 OID 242086)
-- Dependencies: 673 3
-- Name: prepoctiobraty(integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION prepoctiobraty(iducetobd integer) RETURNS void
    AS $$ 
declare 
  _platiOd date; 
  _platiDo date; 
begin 
  select platioddata, platidodata into _platiOd, _platiDo from nucetobdobi where iducetobdobi = idUcetObd; 
 
  if (_platiOd is not null and _platiDo is not null) then 
    delete from uobraty where obdobi > 0 and (iducetobdobi = idUcetObd or 
      (obdobi < 99 and date(rok || '-' || obdobi || '-02') between _platiOd and _platiDo)); 
     
    -- zauctovani polozek faktur 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     -- zauctovani polozek internich dokladu 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
                                 
     -- zauctovani polozek skladovych dokladu                      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
     
     -- danove naklady 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from mdannakl as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     -- danove odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mdanodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- splatkovy kalendar 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, L.idMeny, P.idStred,  
          P.sumDph, P.sumDphMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- ucetni odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mucetodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- udalosti 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
        
          --udalosti
     --doplneno Steklem 14.4.2016 - prepocet stavu uctu ignoroval nove pole "sumdphdanove"
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, -1, P.idStred,   
          case when 
         (select nahrucetodpk from mmajetek as M where M.idmajetku = P.idmajetku ) = 'nahrUcet.ne' 
          then  P.sumdphdanove else P.sumDph end , 0.0) from mudalosti as P  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
        
  end if; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.prepoctiobraty(iducetobd integer) OWNER TO %firmaRole%;

--
-- TOC entry 60 (class 1255 OID 238827)
-- Dependencies: 3 673
-- Name: sodectiskladkartu(numeric, numeric, date, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION sodectiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer) RETURNS void
    AS $$  
declare  
begin  
  execute sPrepoctiSkladKartu(i_MnozMJ,i_CenaMJ,i_DatVyst,i_SkladKartaId,i_DoklSkladId,i_skladid,i_Nasobic);  
end  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sodectiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer) OWNER TO %firmaRole%;

--
-- TOC entry 61 (class 1255 OID 238828)
-- Dependencies: 673 3
-- Name: sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,6);    
  _StavMJ numeric(19,6);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);    
  _PoslCenaTuz numeric(19,6);    
  _PoslCenaMen numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklfifo boolean;    
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  /* Vypocet StavTuz */   
  if (loc_MnozMJ = 0 and _TypPohybuK = 'typPohybu.prijem')then    
    _PomMnozMJ:=1;   
  else   
    _PomMnozMJ:=loc_MnozMJ;   
  end if;   
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;  
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  end if;  
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_sumzkl numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,6);    
  _StavMJ numeric(19,6);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);    
  _PoslCenaTuz numeric(19,6);    
  _PoslCenaMen numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklfifo boolean;    
  _pozadavkyMj numeric(19,6);    
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl,pozadavkyMj from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl,_pozadavkyMj;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  /* Vypocet StavTuz */   
  if (loc_MnozMJ = 0 and _TypPohybuK = 'typPohybu.prijem')then    
    _PomMnozMJ:=1;   
    _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  else   
    _PomMnozMJ:=loc_MnozMJ;
    if(_TypPohybuK = 'typPohybu.prijem') then
       /* Pricitam sumZkl */
      _StavTuz:=_StavTuz+(i_sumZkl*i_Nasobic);
    else
      /* Odecitam sumZkl */
      _StavTuz:=_StavTuz-(i_sumZkl*i_Nasobic);
    end if;
  end if;   
  
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;  
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      stavMjSPozadavky = _StavMJ - _pozadavkyMj,
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      stavMjSPozadavky = _StavMJ - _pozadavkyMj,
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  end if;  
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


--
-- TOC entry 63 (class 1255 OID 238832)
-- Dependencies: 3 673
-- Name: unastavchybapreceneni(date); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION unastavchybapreceneni(datum date) RETURNS void
    AS $$  
begin  
  -- nastavi u ucetniho obdobi do ktereho spada zadane datum vlastnosti zmenaZaver a chybaPreceneni na true  
  if (datum is not null) then  
    update nUcetObdobi set zmenaZaver = true, chybaPreceneni = true where platiOdData <= datum and platiDoData >= datum;  
  end if;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.unastavchybapreceneni(datum date) OWNER TO %firmaRole%;

--
-- TOC entry 64 (class 1255 OID 238833)
-- Dependencies: 3 673
-- Name: uobratyinsertupdate(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION uobratyinsertupdate() RETURNS trigger
    AS $$  
begin  
  update nUcetObdobi set zmenaZaver = true where idUcetObdobi = NEW.idUcetObdobi and zmenaZaver = false;  
    
  return NEW;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.uobratyinsertupdate() OWNER TO %firmaRole%;

--
-- TOC entry 65 (class 1255 OID 238834)
-- Dependencies: 673 3
-- Name: uuctydelete(); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE FUNCTION uuctydelete() RETURNS trigger
    AS $$  
begin  
  delete from usesuzivpred where iducet = OLD.iducet;  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.uuctydelete() OWNER TO %firmaRole%;

--
-- TOC entry 66 (class 1255 OID 238835)
-- Dependencies: 3 673
-- Name: uuzavriucetniobdobi(integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: %firmaRole%
--

CREATE OR REPLACE FUNCTION uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer)
  RETURNS void AS
$BODY$
declare
  newRok integer;
  newObrat record;
  pom integer;
begin
  select date_part('year', platiOdData) into newRok from nUcetObdobi where idUcetObdobi = idNewObdobi;
  
  /*smazani pripadne predchozi zaverky*/
  delete from uObraty where idUcetObdobi = idOldObdobi and obdobi = 99;
  
  /* [1] Sesumovani obratu MD/D a zauctovani uzavreni vsech uctu v obdobi 99 */
  /* Protistranou techto ucetnich operaci bude pro rozvahove ucty ucet 702 (viz bod [3])
     a pro vysledkove ucty ucet 710 (viz bod [4]) */
  insert into uObraty( idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,O.idUcet,O.idStred,O.idCinnost,min(O.Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate
    from uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet
    where O.idUcetObdobi = idOldObdobi and U.typUctuK <> 'typUctu.zaverkovy'
    group by O.idMeny,O.idUcet,O.idStred,O.idCinnost,O.idUcetObdobi);

  /* [2] Presun zustatku rozvahovych uctu do obdobi 0 noveho roku */
  /* smazani nepotrebnych pocatecnich zustatku pro bod [2] */
  delete from uObraty o1
  where o1.idUcetObdobi = idNewObdobi and o1.obdobi = 0 and o1.uzivnastav = false
  and o1.idUcet <> idUcet701
  and not exists (select 1 from uObraty o2 
                  where o2.idUcetObdobi = idoldobdobi and o2.obdobi = 99
                    and o2.idMeny = o1.idMeny
                    and o2.idUcet = o1.idUcet and o2.idStred = o1.idStred and compareid(o2.idCinnost, o1.idCinnost));

  /* vynulovani pocatecnich zustatku pro bod [2], [5] a *[6]* */
  update uObraty
  set obrdal = 0, obrmd = 0, obrdalbck = 0, obrmdbck = 0
  where idUcetObdobi = idNewObdobi and obdobi = 0 and uzivnastav = false;

  update uObraty
  set obrdalbck = 0, obrmdbck = 0
  where idUcetObdobi = idNewObdobi and obdobi = 0 and uzivnastav = true
    and obrdalbck is not null and obrmdbck is not null;

  /* aktualizace pocatecnich zustatku */
  for newObrat in (select O.idMeny,O.idUcet,O.idStred,O.idCinnost,newRok as Rok,0 as Obdobi,
                     sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd, idNewObdobi as idUcetObdobi, now() as LastUpdate
                   from uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet
                   where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy') 
                   group by O.idMeny,O.idUcet,O.idStred,O.idCinnost,O.idUcetObdobi,U.typUctuK) loop
        select count(1) into pom from uObraty
        where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
          and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
          and iducetobdobi = newObrat.idUcetObdobi;
        if (pom > 0) then
            update uObraty 
            set obrdal = newObrat.ObrDal, obrmd = newObrat.ObrMd,
                obrdalbck = newObrat.ObrDal, obrmdbck = newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = false;
           
            update uObraty 
            set obrdalbck = newObrat.ObrDal, obrmdbck = newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = true;
        else
            insert into uObraty(idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,
                                ObrDal, ObrMd,ObrDalBck,ObrMdBck,idUcetObdobi,LastUpdate)
            values (newObrat.idMeny,newObrat.idUcet,newObrat.idStred,newObrat.idCinnost,newObrat.Rok,newObrat.Obdobi,
                    newObrat.ObrDal,newObrat.ObrMd,newObrat.ObrDal,newObrat.ObrMd,newObrat.idUcetObdobi,newObrat.LastUpdate);
        end if;
  end loop;

  /* [3] Sumace na zaverkovy ucet 702 - protistrana k ucetnim operacim z bodu [1a] */
  insert into uObraty( idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet702 as idUcet,O.idStred,O.idCinnost,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate
    from uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet
    where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK in( 'typUctu.rozvahovy','typUctu.podrozvahovy','typUctu.vnitropodnikovy') 
    group by O.idMeny,O.idStred,O.idCinnost,O.idUcetObdobi);

  /* [4] Sumace na zaverkovy ucet 710 - protistrana k ucetnim operacim z bodu [1b] */
  insert into uObraty( idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,ObrDal,ObrMd,idUcetObdobi,LastUpdate) (
    select O.idMeny,idUcet710 as idUcet,O.idStred,O.idCinnost,min(Rok) as Rok,99 as Obdobi,sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd,O.idUcetObdobi,now() as LastUpdate
    from uObraty as O left outer join uUcty as U on U.idUcet = O.idUcet
    where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and U.typUctuK = 'typUctu.vysledkovy'
    group by O.idMeny,O.idStred,O.idCinnost,O.idUcetObdobi);

  /* [5] Presun uctu 702 na ucet 701 v novem roce (s prohozenim stran) */
  for newObrat in (select O.idMeny,idUcet701 as idUcet,O.idStred,O.idCinnost,newRok as Rok,0 as Obdobi,
                     sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd, idNewObdobi as idUcetObdobi, now() as LastUpdate
                   from uObraty as O
                   where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet702
                   group by O.idMeny,O.idStred,O.idCinnost,O.idUcetObdobi) loop
        select count(1) into pom from uObraty
        where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
          and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
          and iducetobdobi = newObrat.idUcetObdobi;
        if (pom > 0) then
            update uObraty 
            set obrdal = newObrat.ObrDal, obrmd = newObrat.ObrMd,
                obrdalbck = newObrat.ObrDal, obrmdbck = newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = false;
           
            update uObraty 
            set obrdalbck = newObrat.ObrDal, obrmdbck = newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = true;
        else
            insert into uObraty(idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,
                                ObrDal, ObrMd,ObrDalBck,ObrMdBck,idUcetObdobi,LastUpdate)
            values (newObrat.idMeny,newObrat.idUcet,newObrat.idStred,newObrat.idCinnost,newObrat.Rok,newObrat.Obdobi,
                    newObrat.ObrDal,newObrat.ObrMd,newObrat.ObrDal,newObrat.ObrMd,newObrat.idUcetObdobi,newObrat.LastUpdate);
        end if;
  end loop;
      
  /* [6] Presun zustatku uctu 710 ze stareho roku na ucet 701 v novem roce (s prohozenim stran) */
  for newObrat in (select idMeny,idUcet701 as idUcet,idStred,idCinnost,newRok as Rok,0 as Obdobi,
                     sum(O.ObrMd) as ObrDal,sum(O.ObrDal) as ObrMd, idNewObdobi as idUcetObdobi, now() as LastUpdate
                   from uObraty as O
                   where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet710
                   group by O.idMeny,O.idStred,O.idCinnost,O.idUcetObdobi) loop
	select count(1) into pom from uObraty
		where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
		and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
		and iducetobdobi = newObrat.idUcetObdobi;
	if (pom > 0) then
            update uObraty 
            set obrdal = obrdal + newObrat.ObrDal, obrmd = obrmd + newObrat.ObrMd,
                obrdalbck = obrdalbck + newObrat.ObrDal, obrmdbck = obrmdbck + newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = false;
           
            update uObraty 
            set obrdalbck = obrdalbck + newObrat.ObrDal, obrmdbck = obrmdbck + newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = true;
	else
            insert into uObraty(idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,
                                ObrDal, ObrMd,ObrDalBck,ObrMdBck,idUcetObdobi,LastUpdate)
            values (newObrat.idMeny,newObrat.idUcet,newObrat.idStred,newObrat.idCinnost,newObrat.Rok,newObrat.Obdobi,
                    newObrat.ObrDal,newObrat.ObrMd,newObrat.ObrDal,newObrat.ObrMd,newObrat.idUcetObdobi,newObrat.LastUpdate);
	end if;
  end loop;

  /* [7] Presun zustatku uctu 710 ze stareho roku na ucet 431 v novem roce (bez prohozeni stran) */
  for newObrat in (select idMeny,idUcet431 as idUcet,idStred,idCinnost,newRok as Rok,0 as Obdobi,
                   sum(O.ObrDal) as ObrDal,sum(O.ObrMd) as ObrMd,idNewObdobi as idUcetObdobi, now() as LastUpdate
                   from uObraty as O
                   where O.idUcetObdobi = idOldObdobi and O.obdobi = 99 and O.idUcet = idUcet710
                   group by O.idMeny,O.idStred,O.idCinnost,O.idUcetObdobi) loop
	/** idUcet je 431 a ten jiz mohl byt zalozen, pokud na nej jiz uctovali */
	select count(1) into pom from uObraty
		where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
		and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
		and iducetobdobi = newObrat.idUcetObdobi;
	if (pom > 0) then
            update uObraty 
            set obrdal = obrdal + newObrat.ObrDal, obrmd = obrmd + newObrat.ObrMd,
                obrdalbck = obrdalbck + newObrat.ObrDal, obrmdbck = obrmdbck + newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = false;
           
            update uObraty 
            set obrdalbck = obrdalbck + newObrat.ObrDal, obrmdbck = obrmdbck + newObrat.ObrMd
            where obdobi = newObrat.Obdobi and rok = newObrat.Rok and idmeny = newObrat.idMeny
              and iducet = newObrat.idUcet and idstred = newObrat.idStred and compareid(idCinnost, newObrat.idCinnost)
              and iducetobdobi = newObrat.idUcetObdobi
              and uzivnastav = true;
	else
            insert into uObraty(idMeny,idUcet,idStred,idCinnost,Rok,Obdobi,
                                ObrDal, ObrMd,ObrDalBck,ObrMdBck,idUcetObdobi,LastUpdate)
            values (newObrat.idMeny,newObrat.idUcet,newObrat.idStred,newObrat.idCinnost,newObrat.Rok,newObrat.Obdobi,
                    newObrat.ObrDal,newObrat.ObrMd,newObrat.ObrDal,newObrat.ObrMd,newObrat.idUcetObdobi,newObrat.LastUpdate);
	end if;
  end loop;

end;
$BODY$
  LANGUAGE 'plpgsql';

ALTER FUNCTION public.uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer) OWNER TO %firmaRole%;


--
--
--

CREATE FUNCTION to_ascii(bytea, name) 
RETURNS text AS 'to_ascii_encname' LANGUAGE internal IMMUTABLE STRICT;

ALTER FUNCTION public.to_ascii(bytea, name) OWNER TO %firmaRole%;


--
-- TOC entry 3024 (class 2606 OID 238840)
-- Dependencies: 1846 1846
-- Name: aadresar_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY aadresar
    ADD CONSTRAINT aadresar_kod_key UNIQUE (kod);


--
-- TOC entry 3027 (class 2606 OID 238842)
-- Dependencies: 1846 1846
-- Name: aadresar_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY aadresar
    ADD CONSTRAINT aadresar_pkey PRIMARY KEY (idfirmy);


--
-- TOC entry 3034 (class 2606 OID 238844)
-- Dependencies: 1848 1848
-- Name: abanspoj_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY abanspoj
    ADD CONSTRAINT abanspoj_pkey PRIMARY KEY (idbanspoj);


--
-- TOC entry 3038 (class 2606 OID 238846)
-- Dependencies: 1850 1850
-- Name: akontakty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY akontakty
    ADD CONSTRAINT akontakty_pkey PRIMARY KEY (idkontakt);


--
-- TOC entry 3043 (class 2606 OID 238848)
-- Dependencies: 1852 1852
-- Name: amisturc_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY amisturc
    ADD CONSTRAINT amisturc_pkey PRIMARY KEY (idmur);


--
-- TOC entry 3048 (class 2606 OID 242048)
-- Dependencies: 1854 1854 1854
-- Name: askupfir_kod_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY askupfir
    ADD CONSTRAINT askupfir_kod_typorg_key UNIQUE (kod, idtyporg);


--
-- TOC entry 3050 (class 2606 OID 238852)
-- Dependencies: 1854 1854
-- Name: askupfir_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY askupfir
    ADD CONSTRAINT askupfir_pkey PRIMARY KEY (idskupfir);


--
-- TOC entry 3056 (class 2606 OID 238856)
-- Dependencies: 1856 1856
-- Name: asmerkod_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY asmerkod
    ADD CONSTRAINT asmerkod_pkey PRIMARY KEY (idsmerkod);


--
-- TOC entry 3059 (class 2606 OID 238858)
-- Dependencies: 1858 1858
-- Name: astaty_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY astaty
    ADD CONSTRAINT astaty_kod_key UNIQUE (kod);


--
-- TOC entry 3062 (class 2606 OID 238860)
-- Dependencies: 1858 1858
-- Name: astaty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY astaty
    ADD CONSTRAINT astaty_pkey PRIMARY KEY (idstatu);


--
-- TOC entry 3067 (class 2606 OID 238862)
-- Dependencies: 1860 1860
-- Name: audalosti_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY audalosti
    ADD CONSTRAINT audalosti_pkey PRIMARY KEY (idudalost);


--
-- TOC entry 3078 (class 2606 OID 238864)
-- Dependencies: 1862 1862
-- Name: ccenik_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ccenik
    ADD CONSTRAINT ccenik_kod_key UNIQUE (kod);


--
-- TOC entry 3080 (class 2606 OID 238866)
-- Dependencies: 1862 1862
-- Name: ccenik_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ccenik
    ADD CONSTRAINT ccenik_pkey PRIMARY KEY (idcenik);


--
-- TOC entry 3083 (class 2606 OID 238868)
-- Dependencies: 1864 1864
-- Name: cmerjed_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY cmerjed
    ADD CONSTRAINT cmerjed_kod_key UNIQUE (kod);


--
-- TOC entry 3085 (class 2606 OID 238870)
-- Dependencies: 1864 1864
-- Name: cmerjed_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY cmerjed
    ADD CONSTRAINT cmerjed_pkey PRIMARY KEY (idmj);


--
-- TOC entry 3093 (class 2606 OID 242085)
-- Dependencies: 1865 1865 1865
-- Name: cskupzboz_kod_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY cskupzboz
    ADD CONSTRAINT cskupzboz_kod_typorg_key UNIQUE (kod, idtyporg);


--
-- TOC entry 3095 (class 2606 OID 238874)
-- Dependencies: 1865 1865
-- Name: cskupzboz_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY cskupzboz
    ADD CONSTRAINT cskupzboz_pkey PRIMARY KEY (idskupzboz);


--
-- TOC entry 3098 (class 2606 OID 238876)
-- Dependencies: 1867 1867
-- Name: dbversion_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dbversion
    ADD CONSTRAINT dbversion_pkey PRIMARY KEY (iddbversion);

CREATE INDEX dbversion_dbversion_index ON dbversion(dbversion desc) WHERE needreimport = 't';
--
-- TOC entry 3133 (class 2606 OID 238878)
-- Dependencies: 1869 1869 1869
-- Name: ddoklfak_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklfak
    ADD CONSTRAINT ddoklfak_kod_key UNIQUE (kod, modul);


--
-- TOC entry 3135 (class 2606 OID 238880)
-- Dependencies: 1869 1869
-- Name: ddoklfak_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklfak
    ADD CONSTRAINT ddoklfak_pkey PRIMARY KEY (iddoklfak);


--
-- TOC entry 3170 (class 2606 OID 238882)
-- Dependencies: 1871 1871 1871
-- Name: ddoklint_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklint
    ADD CONSTRAINT ddoklint_kod_key UNIQUE (kod, modul);


--
-- TOC entry 3172 (class 2606 OID 238884)
-- Dependencies: 1871 1871
-- Name: ddoklint_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklint
    ADD CONSTRAINT ddoklint_pkey PRIMARY KEY (iddoklint);


--
-- TOC entry 3728 (class 2606 OID 241597)
-- Dependencies: 2000 2000 2000
-- Name: ddoklobch_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklobch
    ADD CONSTRAINT ddoklobch_kod_key UNIQUE (kod, modul);


--
-- TOC entry 3730 (class 2606 OID 241599)
-- Dependencies: 2000 2000
-- Name: ddoklobch_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklobch
    ADD CONSTRAINT ddoklobch_pkey PRIMARY KEY (iddoklobch);


--
-- TOC entry 3207 (class 2606 OID 238886)
-- Dependencies: 1873 1873 1873
-- Name: ddoklsklad_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklsklad
    ADD CONSTRAINT ddoklsklad_kod_key UNIQUE (kod, modul);


--
-- TOC entry 3209 (class 2606 OID 238888)
-- Dependencies: 1873 1873
-- Name: ddoklsklad_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ddoklsklad
    ADD CONSTRAINT ddoklsklad_pkey PRIMARY KEY (iddoklsklad);


--
-- TOC entry 3212 (class 2606 OID 238890)
-- Dependencies: 1875 1875
-- Name: delbanformat_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY delbanformat
    ADD CONSTRAINT delbanformat_kod_key UNIQUE (kod);


--
-- TOC entry 3214 (class 2606 OID 238892)
-- Dependencies: 1875 1875
-- Name: delbanformat_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY delbanformat
    ADD CONSTRAINT delbanformat_pkey PRIMARY KEY (idelbanformat);


--
-- TOC entry 3217 (class 2606 OID 238894)
-- Dependencies: 1877 1877
-- Name: dkonsym_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dkonsym
    ADD CONSTRAINT dkonsym_kod_key UNIQUE (kod);


--
-- TOC entry 3219 (class 2606 OID 238896)
-- Dependencies: 1877 1877
-- Name: dkonsym_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dkonsym
    ADD CONSTRAINT dkonsym_pkey PRIMARY KEY (idkonsym);


--
-- TOC entry 3237 (class 2606 OID 238898)
-- Dependencies: 1879 1879
-- Name: dpolfak_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dpolfak
    ADD CONSTRAINT dpolfak_pkey PRIMARY KEY (idpolfak);


--
-- TOC entry 3255 (class 2606 OID 238900)
-- Dependencies: 1881 1881
-- Name: dpolint_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dpolint
    ADD CONSTRAINT dpolint_pkey PRIMARY KEY (idpolint);


--
-- TOC entry 3747 (class 2606 OID 241601)
-- Dependencies: 2001 2001
-- Name: dpolobch_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dpolobch
    ADD CONSTRAINT dpolobch_pkey PRIMARY KEY (idpolobch);


--
-- TOC entry 3264 (class 2606 OID 238902)
-- Dependencies: 1883 1883
-- Name: dpolprikazuhr_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dpolprikazuhr
    ADD CONSTRAINT dpolprikazuhr_pkey PRIMARY KEY (idpolprikazuhr);


--
-- TOC entry 3283 (class 2606 OID 238904)
-- Dependencies: 1885 1885
-- Name: dpolsklad_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dpolsklad
    ADD CONSTRAINT dpolsklad_pkey PRIMARY KEY (idpolsklad);


--
-- TOC entry 3288 (class 2606 OID 238906)
-- Dependencies: 1887 1887
-- Name: dprikazuhr_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dprikazuhr
    ADD CONSTRAINT dprikazuhr_pkey PRIMARY KEY (idprikazuhr);


--
-- TOC entry 3291 (class 2606 OID 238908)
-- Dependencies: 1889 1889
-- Name: drady_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY drady
    ADD CONSTRAINT drady_kod_key UNIQUE (kod);


--
-- TOC entry 3293 (class 2606 OID 238910)
-- Dependencies: 1889 1889
-- Name: drady_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY drady
    ADD CONSTRAINT drady_pkey PRIMARY KEY (idrady);


--
-- TOC entry 3295 (class 2606 OID 241446)
-- Dependencies: 1891 1891 1891
-- Name: dradydiry_cisdira_idradyrok_unique; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dradydiry
    ADD CONSTRAINT dradydiry_cisdira_idradyrok_unique UNIQUE (cisdira, idradyrok);


--
-- TOC entry 3298 (class 2606 OID 238912)
-- Dependencies: 1891 1891
-- Name: dradydiry_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dradydiry
    ADD CONSTRAINT dradydiry_pkey PRIMARY KEY (idradydiry);


--
-- TOC entry 3302 (class 2606 OID 238914)
-- Dependencies: 1893 1893
-- Name: dradyrok_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dradyrok
    ADD CONSTRAINT dradyrok_pkey PRIMARY KEY (idradyrok);


--
-- TOC entry 3339 (class 2606 OID 241019)
-- Dependencies: 1895 1895 1895 1895
-- Name: dtypdokl_kod_modul_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dtypdokl
    ADD CONSTRAINT dtypdokl_kod_modul_typorg_key UNIQUE (kod, modul, idtyporg);


--
-- TOC entry 3341 (class 2606 OID 238918)
-- Dependencies: 1895 1895
-- Name: dtypdokl_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dtypdokl
    ADD CONSTRAINT dtypdokl_pkey PRIMARY KEY (idtypdokl);


--
-- TOC entry 3344 (class 2606 OID 238920)
-- Dependencies: 1897 1897 1897 1897 1897 1897
-- Name: dvazebtab_idtaba_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dvazebtab
    ADD CONSTRAINT dvazebtab_idtaba_key UNIQUE (idtaba, idtabb, modula, modulb, typvazbyk);


--
-- TOC entry 3346 (class 2606 OID 238922)
-- Dependencies: 1897 1897
-- Name: dvazebtab_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY dvazebtab
    ADD CONSTRAINT dvazebtab_pkey PRIMARY KEY (idvazby);


--
-- TOC entry 3349 (class 2606 OID 238924)
-- Dependencies: 1899 1899
-- Name: idodpodm_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY idodpodm
    ADD CONSTRAINT idodpodm_kod_key UNIQUE (kod);


--
-- TOC entry 3351 (class 2606 OID 238926)
-- Dependencies: 1899 1899
-- Name: idodpodm_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY idodpodm
    ADD CONSTRAINT idodpodm_pkey PRIMARY KEY (iddodpodm);


--
-- TOC entry 3354 (class 2606 OID 238928)
-- Dependencies: 1901 1901
-- Name: idruhdopr_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY idruhdopr
    ADD CONSTRAINT idruhdopr_kod_key UNIQUE (kod);


--
-- TOC entry 3356 (class 2606 OID 238930)
-- Dependencies: 1901 1901
-- Name: idruhdopr_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY idruhdopr
    ADD CONSTRAINT idruhdopr_pkey PRIMARY KEY (iddruhdopr);


--
-- TOC entry 3359 (class 2606 OID 238932)
-- Dependencies: 1903 1903
-- Name: iintrmerjed_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY iintrmerjed
    ADD CONSTRAINT iintrmerjed_kod_key UNIQUE (kod);


--
-- TOC entry 3361 (class 2606 OID 238934)
-- Dependencies: 1903 1903
-- Name: iintrmerjed_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY iintrmerjed
    ADD CONSTRAINT iintrmerjed_pkey PRIMARY KEY (idintrmerjed);


--
-- TOC entry 3364 (class 2606 OID 238936)
-- Dependencies: 1905 1905
-- Name: ikrajurc_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ikrajurc
    ADD CONSTRAINT ikrajurc_kod_key UNIQUE (kod);


--
-- TOC entry 3366 (class 2606 OID 238938)
-- Dependencies: 1905 1905
-- Name: ikrajurc_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ikrajurc
    ADD CONSTRAINT ikrajurc_pkey PRIMARY KEY (idkrajurc);


--
-- TOC entry 3370 (class 2606 OID 238940)
-- Dependencies: 1907 1907
-- Name: inomen_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY inomen
    ADD CONSTRAINT inomen_kod_key UNIQUE (kod);


--
-- TOC entry 3372 (class 2606 OID 238942)
-- Dependencies: 1907 1907
-- Name: inomen_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY inomen
    ADD CONSTRAINT inomen_pkey PRIMARY KEY (idnomen);


--
-- TOC entry 3375 (class 2606 OID 238944)
-- Dependencies: 1909 1909
-- Name: iobchtrans_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY iobchtrans
    ADD CONSTRAINT iobchtrans_kod_key UNIQUE (kod);


--
-- TOC entry 3377 (class 2606 OID 238946)
-- Dependencies: 1909 1909
-- Name: iobchtrans_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY iobchtrans
    ADD CONSTRAINT iobchtrans_pkey PRIMARY KEY (idobchtrans);


--
-- TOC entry 3380 (class 2606 OID 238948)
-- Dependencies: 1911 1911
-- Name: izvlpoh_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY izvlpoh
    ADD CONSTRAINT izvlpoh_kod_key UNIQUE (kod);


--
-- TOC entry 3382 (class 2606 OID 238950)
-- Dependencies: 1911 1911
-- Name: izvlpoh_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY izvlpoh
    ADD CONSTRAINT izvlpoh_pkey PRIMARY KEY (idzvlpoh);


--
-- TOC entry 3391 (class 2606 OID 238952)
-- Dependencies: 1913 1913
-- Name: mdannakl_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mdannakl
    ADD CONSTRAINT mdannakl_pkey PRIMARY KEY (iddannakl);


--
-- TOC entry 3400 (class 2606 OID 238954)
-- Dependencies: 1915 1915
-- Name: mdanodpisy_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mdanodpisy
    ADD CONSTRAINT mdanodpisy_pkey PRIMARY KEY (iddanodpisu);


--
-- TOC entry 3414 (class 2606 OID 238956)
-- Dependencies: 1917 1917
-- Name: mleasing_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mleasing
    ADD CONSTRAINT mleasing_kod_key UNIQUE (kod);


--
-- TOC entry 3416 (class 2606 OID 238958)
-- Dependencies: 1917 1917
-- Name: mleasing_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mleasing
    ADD CONSTRAINT mleasing_pkey PRIMARY KEY (idleasing);


--
-- TOC entry 3433 (class 2606 OID 238960)
-- Dependencies: 1919 1919
-- Name: mmajetek_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mmajetek
    ADD CONSTRAINT mmajetek_kod_key UNIQUE (kod);


--
-- TOC entry 3435 (class 2606 OID 238962)
-- Dependencies: 1919 1919
-- Name: mmajetek_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mmajetek
    ADD CONSTRAINT mmajetek_pkey PRIMARY KEY (idmajetku);


--
-- TOC entry 3438 (class 2606 OID 238964)
-- Dependencies: 1921 1921
-- Name: msazby_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY msazby
    ADD CONSTRAINT msazby_kod_key UNIQUE (kod);


--
-- TOC entry 3440 (class 2606 OID 238966)
-- Dependencies: 1921 1921
-- Name: msazby_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY msazby
    ADD CONSTRAINT msazby_pkey PRIMARY KEY (idsazby);


--
-- TOC entry 3454 (class 2606 OID 238968)
-- Dependencies: 1923 1923
-- Name: msplatkal_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY msplatkal
    ADD CONSTRAINT msplatkal_pkey PRIMARY KEY (idsplatkal);


--
-- TOC entry 3466 (class 2606 OID 242022)
-- Dependencies: 1925 1925 1925
-- Name: mtypleas_kod_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mtypleas
    ADD CONSTRAINT mtypleas_kod_typorg_key UNIQUE (kod, idtyporg);


--
-- TOC entry 3468 (class 2606 OID 238972)
-- Dependencies: 1925 1925
-- Name: mtypleas_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mtypleas
    ADD CONSTRAINT mtypleas_pkey PRIMARY KEY (idtypleas);


--
-- TOC entry 3480 (class 2606 OID 241991)
-- Dependencies: 1927 1927 1927
-- Name: mtypmaj_kod_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mtypmaj
    ADD CONSTRAINT mtypmaj_kod_typorg_key UNIQUE (kod, idtyporg);


--
-- TOC entry 3482 (class 2606 OID 238976)
-- Dependencies: 1927 1927
-- Name: mtypmaj_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mtypmaj
    ADD CONSTRAINT mtypmaj_pkey PRIMARY KEY (idtypmaj);


--
-- TOC entry 3492 (class 2606 OID 238978)
-- Dependencies: 1929 1929
-- Name: mucetodpisy_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mucetodpisy
    ADD CONSTRAINT mucetodpisy_pkey PRIMARY KEY (iducetodpisu);


--
-- TOC entry 3503 (class 2606 OID 238980)
-- Dependencies: 1931 1931
-- Name: mudalosti_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mudalosti
    ADD CONSTRAINT mudalosti_pkey PRIMARY KEY (idudalosti);


--
-- TOC entry 3506 (class 2606 OID 238982)
-- Dependencies: 1933 1933
-- Name: mumisteni_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mumisteni
    ADD CONSTRAINT mumisteni_kod_key UNIQUE (kod);


--
-- TOC entry 3508 (class 2606 OID 238984)
-- Dependencies: 1933 1933
-- Name: mumisteni_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mumisteni
    ADD CONSTRAINT mumisteni_pkey PRIMARY KEY (idumisteni);


--
-- TOC entry 3514 (class 2606 OID 238986)
-- Dependencies: 1935 1935
-- Name: mzapujcky_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY mzapujcky
    ADD CONSTRAINT mzapujcky_pkey PRIMARY KEY (idzapujcky);


--
-- TOC entry 3543 (class 2606 OID 238990)
-- Dependencies: 1939 1939
-- Name: nnastav_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY nnastav
    ADD CONSTRAINT nnastav_pkey PRIMARY KEY (idnastav);


--
-- TOC entry 3547 (class 2606 OID 238992)
-- Dependencies: 1941 1941
-- Name: nucetobdobi_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY nucetobdobi
    ADD CONSTRAINT nucetobdobi_kod_key UNIQUE (kod);


--
-- TOC entry 3549 (class 2606 OID 238994)
-- Dependencies: 1941 1941
-- Name: nucetobdobi_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY nucetobdobi
    ADD CONSTRAINT nucetobdobi_pkey PRIMARY KEY (iducetobdobi);


--
-- TOC entry 3557 (class 2606 OID 239000)
-- Dependencies: 1943 1943
-- Name: skarty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY skarty
    ADD CONSTRAINT skarty_pkey PRIMARY KEY (idkarty);


--
-- TOC entry 3563 (class 2606 OID 239004)
-- Dependencies: 1945 1945
-- Name: uclendph_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uclendph
    ADD CONSTRAINT uclendph_pkey PRIMARY KEY (idclendph);


--
-- TOC entry 3566 (class 2606 OID 239006)
-- Dependencies: 1947 1947 1947
-- Name: ukurzy_idmeny_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ukurzy
    ADD CONSTRAINT ukurzy_idmeny_key UNIQUE (idmeny, platioddata, typkurzuk);


--
-- TOC entry 3568 (class 2606 OID 239008)
-- Dependencies: 1947 1947
-- Name: ukurzy_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ukurzy
    ADD CONSTRAINT ukurzy_pkey PRIMARY KEY (idkurzy);


--
-- TOC entry 3572 (class 2606 OID 239010)
-- Dependencies: 1949 1949
-- Name: umeny_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY umeny
    ADD CONSTRAINT umeny_kod_key UNIQUE (kod);


--
-- TOC entry 3574 (class 2606 OID 239012)
-- Dependencies: 1949 1949
-- Name: umeny_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY umeny
    ADD CONSTRAINT umeny_pkey PRIMARY KEY (idmeny);


--
-- TOC entry 3581 (class 2606 OID 239014)
-- Dependencies: 1951 1951
-- Name: uobraty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uobraty
    ADD CONSTRAINT uobraty_pkey PRIMARY KEY (idobrat);


--
-- TOC entry 3584 (class 2606 OID 239016)
-- Dependencies: 1953 1953
-- Name: usazbydph_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usazbydph
    ADD CONSTRAINT usazbydph_pkey PRIMARY KEY (idsazbydph);


--
-- TOC entry 3588 (class 2606 OID 239018)
-- Dependencies: 1955 1955
-- Name: usesradky_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usesradky
    ADD CONSTRAINT usesradky_pkey PRIMARY KEY (idsesradky);


--
-- TOC entry 3592 (class 2606 OID 239020)
-- Dependencies: 1957 1957
-- Name: usesrozpaduce_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usesrozpaduce
    ADD CONSTRAINT usesrozpaduce_pkey PRIMARY KEY (idsesrozpaduce);


--
-- TOC entry 3596 (class 2606 OID 239022)
-- Dependencies: 1959 1959
-- Name: usesstdpred_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usesstdpred
    ADD CONSTRAINT usesstdpred_pkey PRIMARY KEY (idsesstdpred);


--
-- TOC entry 3600 (class 2606 OID 239024)
-- Dependencies: 1961 1961
-- Name: usessumace_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usessumace
    ADD CONSTRAINT usessumace_pkey PRIMARY KEY (idsessumace);


--
-- TOC entry 3606 (class 2606 OID 239026)
-- Dependencies: 1963 1963
-- Name: usestavy_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usestavy
    ADD CONSTRAINT usestavy_kod_key UNIQUE (kod);


--
-- TOC entry 3608 (class 2606 OID 239028)
-- Dependencies: 1963 1963
-- Name: usestavy_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usestavy
    ADD CONSTRAINT usestavy_pkey PRIMARY KEY (idsestavy);


--
-- TOC entry 3612 (class 2606 OID 239030)
-- Dependencies: 1965 1965
-- Name: usesuzivpred_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY usesuzivpred
    ADD CONSTRAINT usesuzivpred_pkey PRIMARY KEY (idsesuzivpred);


--
-- TOC entry 3618 (class 2606 OID 239034)
-- Dependencies: 1967 1967
-- Name: ustducty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ustducty
    ADD CONSTRAINT ustducty_pkey PRIMARY KEY (idstducet);


--
-- TOC entry 3621 (class 2606 OID 239036)
-- Dependencies: 1969 1969
-- Name: ustrediska_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ustrediska
    ADD CONSTRAINT ustrediska_kod_key UNIQUE (kod);


--
-- TOC entry 3623 (class 2606 OID 239038)
-- Dependencies: 1969 1969
-- Name: ustrediska_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY ustrediska
    ADD CONSTRAINT ustrediska_pkey PRIMARY KEY (idstred);


--
-- TOC entry 3626 (class 2606 OID 239040)
-- Dependencies: 1971 1971
-- Name: utyporg_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY utyporg
    ADD CONSTRAINT utyporg_kod_key UNIQUE (kod);


--
-- TOC entry 3628 (class 2606 OID 239042)
-- Dependencies: 1971 1971
-- Name: utyporg_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY utyporg
    ADD CONSTRAINT utyporg_pkey PRIMARY KEY (idtyporg);


--
-- TOC entry 3636 (class 2606 OID 240993)
-- Dependencies: 1973 1973 1973
-- Name: uucty_kod_typorg_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uucty
    ADD CONSTRAINT uucty_kod_typorg_key UNIQUE (kod, idtyporg);


--
-- TOC entry 3638 (class 2606 OID 239046)
-- Dependencies: 1973 1973
-- Name: uucty_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uucty
    ADD CONSTRAINT uucty_pkey PRIMARY KEY (iducet);


--
-- TOC entry 3644 (class 2606 OID 239048)
-- Dependencies: 1975 1975
-- Name: uzakazky_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uzakazky
    ADD CONSTRAINT uzakazky_kod_key UNIQUE (kod);


--
-- TOC entry 3646 (class 2606 OID 239050)
-- Dependencies: 1975 1975
-- Name: uzakazky_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY uzakazky
    ADD CONSTRAINT uzakazky_pkey PRIMARY KEY (idzakazky);


--
-- TOC entry 3648 (class 2606 OID 239054)
-- Dependencies: 1977 1977 1977 1977
-- Name: wcolumn_beankey_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wcolumn
    ADD CONSTRAINT wcolumn_beankey_key UNIQUE (beankey, propname, iduzivatel);


--
-- TOC entry 3650 (class 2606 OID 239056)
-- Dependencies: 1977 1977
-- Name: wcolumn_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wcolumn
    ADD CONSTRAINT wcolumn_pkey PRIMARY KEY (idcolumn);
    
CREATE INDEX wcolumn_iduzivatel_beankey_index ON wcolumn(iduzivatel, beankey);

--
-- TOC entry 3652 (class 2606 OID 239058)
-- Dependencies: 1978 1978 1978
-- Name: wkli_aadresar_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_aadresar
    ADD CONSTRAINT wkli_aadresar_pkey PRIMARY KEY (idwkli_aadresar);


--
-- TOC entry 3654 (class 2606 OID 239060)
-- Dependencies: 1979 1979 1979
-- Name: wkli_akontakt_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_akontakt
    ADD CONSTRAINT wkli_akontakt_pkey PRIMARY KEY (idwkli_akontakt);


--
-- TOC entry 3656 (class 2606 OID 239062)
-- Dependencies: 1980 1980 1980
-- Name: wkli_audalost_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_audalost
    ADD CONSTRAINT wkli_audalost_pkey PRIMARY KEY (idwkli_audalost);


--
-- TOC entry 3658 (class 2606 OID 239064)
-- Dependencies: 1981 1981 1981
-- Name: wkli_cenik_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_cenik
    ADD CONSTRAINT wkli_cenik_pkey PRIMARY KEY (idwkli_cenik);


--
-- TOC entry 3660 (class 2606 OID 239066)
-- Dependencies: 1982 1982 1982
-- Name: wkli_doklfak_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_doklfak
    ADD CONSTRAINT wkli_doklfak_pkey PRIMARY KEY (idwkli_doklfak);


--
-- TOC entry 3662 (class 2606 OID 239068)
-- Dependencies: 1983 1983 1983
-- Name: wkli_doklint_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_doklint
    ADD CONSTRAINT wkli_doklint_pkey PRIMARY KEY (idwkli_doklint);


--
-- TOC entry 3749 (class 2606 OID 241603)
-- Dependencies: 2002 2002 2002
-- Name: wkli_doklobch_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_doklobch
    ADD CONSTRAINT wkli_doklobch_pkey PRIMARY KEY (idwkli_doklobch);


--
-- TOC entry 3664 (class 2606 OID 239070)
-- Dependencies: 1984 1984 1984
-- Name: wkli_doklsklad_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_doklsklad
    ADD CONSTRAINT wkli_doklsklad_pkey PRIMARY KEY (idwkli_doklsklad);


--
-- TOC entry 3666 (class 2606 OID 239072)
-- Dependencies: 1985 1985 1985
-- Name: wkli_mleasing_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_mleasing
    ADD CONSTRAINT wkli_mleasing_pkey PRIMARY KEY (idwkli_mleasing);


--
-- TOC entry 3668 (class 2606 OID 239074)
-- Dependencies: 1986 1986 1986
-- Name: wkli_mmajetek_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wkli_mmajetek
    ADD CONSTRAINT wkli_mmajetek_pkey PRIMARY KEY (idwkli_mmajetek);


--
-- TOC entry 3671 (class 2606 OID 239076)
-- Dependencies: 1988 1988 1988
-- Name: wlokcis_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wlokcis
    ADD CONSTRAINT wlokcis_kod_key UNIQUE (kod, ciselnik);


--
-- TOC entry 3673 (class 2606 OID 239078)
-- Dependencies: 1988 1988
-- Name: wlokcis_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wlokcis
    ADD CONSTRAINT wlokcis_pkey PRIMARY KEY (idlokcis);


--
-- TOC entry 3675 (class 2606 OID 239080)
-- Dependencies: 1990 1990 1990
-- Name: wokna_kodform_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wokna
    ADD CONSTRAINT wokna_kodform_key UNIQUE (kodform, iduzivatel);


--
-- TOC entry 3677 (class 2606 OID 239082)
-- Dependencies: 1990 1990
-- Name: wokna_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wokna
    ADD CONSTRAINT wokna_pkey PRIMARY KEY (idokna);


--
-- TOC entry 3751 (class 2606 OID 241955)
-- Dependencies: 2004 2004 2004
-- Name: wsetting_klic_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wsetting
    ADD CONSTRAINT wsetting_klic_key UNIQUE (klic, iduzivatel);


--
-- TOC entry 3753 (class 2606 OID 241953)
-- Dependencies: 2004 2004
-- Name: wsetting_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wsetting
    ADD CONSTRAINT wsetting_pkey PRIMARY KEY (idsetting);


--
-- TOC entry 3686 (class 2606 OID 239088)
-- Dependencies: 1994 1994
-- Name: wuzivatel_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wuzivatel
    ADD CONSTRAINT wuzivatel_kod_key UNIQUE (kod);


--
-- TOC entry 3688 (class 2606 OID 239090)
-- Dependencies: 1994 1994
-- Name: wuzivatel_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wuzivatel
    ADD CONSTRAINT wuzivatel_pkey PRIMARY KEY (iduzivatel);


--
-- TOC entry 3692 (class 2606 OID 239092)
-- Dependencies: 1996 1996
-- Name: wvybklice_kod_key; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wvybklice
    ADD CONSTRAINT wvybklice_kod_key UNIQUE (kod);


--
-- TOC entry 3694 (class 2606 OID 239094)
-- Dependencies: 1996 1996
-- Name: wvybklice_pkey; Type: CONSTRAINT; Schema: public; Owner: %firmaRole%; Tablespace: 
--

ALTER TABLE ONLY wvybklice
    ADD CONSTRAINT wvybklice_pkey PRIMARY KEY (idvybklice);

--------------------------------------------------------------------------------
--Bug 13565 – [WinStrom] Sprava osobních certifikátu
--------------------------------------------------------------------------------

ALTER TABLE ONLY woscert
    ADD CONSTRAINT woscert_pkey PRIMARY KEY (idoscert);
    
ALTER TABLE woscert ADD CONSTRAINT woscert_uzivatel_id FOREIGN KEY (iduzivatel) REFERENCES wuzivatel (iduzivatel)    ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE ONLY woscertcipher
    ADD CONSTRAINT woscertcipher_pkey PRIMARY KEY (idoscertcipher);

ALTER TABLE woscertcipher ADD CONSTRAINT woscertcipher_certifikat_id FOREIGN KEY (idoscert) REFERENCES woscert (idoscert) ON UPDATE NO ACTION ON DELETE NO ACTION;
    
-- certifikat firem v adresari

ALTER TABLE ONLY wadrcert
    ADD CONSTRAINT wadrcert_pkey PRIMARY KEY (idadrcert);

ALTER TABLE wadrcert ADD CONSTRAINT wadrcert_adresar_id FOREIGN KEY (idadresar) REFERENCES aadresar (idfirmy) ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE ONLY wadrcertcipher
    ADD CONSTRAINT wadrcertcipher_pkey PRIMARY KEY (idadrcertcipher);

ALTER TABLE wadrcertcipher ADD CONSTRAINT wadrcertcipher_certifikat_id FOREIGN KEY (idadrcert) REFERENCES wadrcert (idadrcert) ON UPDATE NO ACTION ON DELETE NO ACTION;

-- Bug 13568 – [WinStrom] Podpis dokladu a jeho import
-- pridani otisku od daneho certifikatu pro certifikat adresare

ALTER TABLE ONLY wadrcertcipher
    ADD CONSTRAINT wadrcertcipher_otisk_unique UNIQUE (otisk);

--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Bug 13567 – [WinStrom] Zmena hesla u certifikatu a pridani cert. autorit
--------------------------------------------------------------------------------

ALTER TABLE ONLY wautcert
    ADD CONSTRAINT wautcert_pkey PRIMARY KEY (idAutCert);

ALTER TABLE ONLY wautcertcipher
    ADD CONSTRAINT wautcertcipher_pkey PRIMARY KEY (idautcertcipher);
    
ALTER TABLE wautcertcipher ADD CONSTRAINT wautcertcipher_certifikat_id FOREIGN KEY (idautcert) REFERENCES wautcert (idautcert) ON UPDATE NO ACTION ON DELETE NO ACTION;

--------------------------------------------------------------------------------

--
-- TOC entry 3018 (class 1259 OID 241043)
-- Dependencies: 1846
-- Name: aadresar_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--


CREATE INDEX deetkom_iddokl_index ON deetkom USING BTREE (iddokl);

CREATE INDEX aadresar_idfastatu_index ON aadresar USING btree (idfastatu) where idfastatu is not null;

CREATE INDEX nNastav_IdPostStatu_index ON nNastav USING btree (idPostStatu);

--
-- TOC entry 3019 (class 1259 OID 241041)
-- Dependencies: 1846
-- Name: aadresar_idskupfir_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX aadresar_idskupfir_index ON aadresar USING btree (idskupfir) where idskupfir is not null;


--
-- TOC entry 3020 (class 1259 OID 241040)
-- Dependencies: 1846
-- Name: aadresar_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX aadresar_idstatu_index ON aadresar USING btree (idstatu);


--
-- TOC entry 3021 (class 1259 OID 241042)
-- Dependencies: 1846
-- Name: aadresar_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX aadresar_idstred_index ON aadresar USING btree (idstred) where idstred is not null;


--
-- TOC entry 3025 (class 1259 OID 241426)
-- Dependencies: 1846 1846
-- Name: aadresar_mesto_ulice_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX aadresar_mesto_ulice_index ON aadresar USING btree (mesto, ulice);

CREATE INDEX aadresar_ic_upper_index ON aadresar(upper(ic::text));

CREATE INDEX aadresar_dic_upper_index ON aadresar(upper(dic::text));

CREATE INDEX aadresar_eankod_upper_index ON aadresar(upper(eankod::text)) where eankod is not null;

--
-- TOC entry 3028 (class 1259 OID 241427)
-- Dependencies: 1848
-- Name: abanspoj_buc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX abanspoj_buc_upper_index ON abanspoj USING btree (upper(buc::text));


--
-- TOC entry 3029 (class 1259 OID 241045)
-- Dependencies: 1848
-- Name: abanspoj_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX abanspoj_idfirmy_index ON abanspoj USING btree (idfirmy);


--
-- TOC entry 3030 (class 1259 OID 241047)
-- Dependencies: 1848
-- Name: abanspoj_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX abanspoj_idkonsym_index ON abanspoj USING btree (idkonsym);


--
-- TOC entry 3031 (class 1259 OID 241046)
-- Dependencies: 1848
-- Name: abanspoj_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX abanspoj_idsmerkod_index ON abanspoj USING btree (idsmerkod);


--
-- TOC entry 3032 (class 1259 OID 241044)
-- Dependencies: 1848
-- Name: abanspoj_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX abanspoj_idstatu_index ON abanspoj USING btree (idstatu);


--
-- TOC entry 3035 (class 1259 OID 241049)
-- Dependencies: 1850
-- Name: akontakty_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX akontakty_idfirmy_index ON akontakty USING btree (idfirmy);


--
-- TOC entry 3036 (class 1259 OID 241048)
-- Dependencies: 1850
-- Name: akontakty_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX akontakty_idstatu_index ON akontakty USING btree (idstatu);


--
-- TOC entry 3039 (class 1259 OID 241428)
-- Dependencies: 1850 1850
-- Name: akontakty_prijmeni_jmeno_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX akontakty_prijmeni_jmeno_index ON akontakty USING btree (prijmeni, jmeno);


--
-- TOC entry 3040 (class 1259 OID 241051)
-- Dependencies: 1852
-- Name: amisturc_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX amisturc_idfirmy_index ON amisturc USING btree (idfirmy);


--
-- TOC entry 3041 (class 1259 OID 241050)
-- Dependencies: 1852
-- Name: amisturc_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX amisturc_idstatu_index ON amisturc USING btree (idstatu);


--
-- TOC entry 3044 (class 1259 OID 241053)
-- Dependencies: 1854
-- Name: askupfir_idprimucetpfa_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX askupfir_idprimucetpfa_index ON askupfir USING btree (idprimucetpfa);


--
-- TOC entry 3045 (class 1259 OID 241052)
-- Dependencies: 1854
-- Name: askupfir_idprimucetvfa_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX askupfir_idprimucetvfa_index ON askupfir USING btree (idprimucetvfa);


--
-- TOC entry 3046 (class 1259 OID 241384)
-- Dependencies: 1854
-- Name: askupfir_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX askupfir_kod_index ON askupfir USING btree (kod);


--
-- TOC entry 3051 (class 1259 OID 242041)
-- Dependencies: 1854
-- Name: askupfir_typorg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX askupfir_typorg_index ON askupfir USING btree (idtyporg);


--
-- TOC entry 3052 (class 1259 OID 241385)
-- Dependencies: 1856
-- Name: asmerkod_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX asmerkod_kod_index ON asmerkod USING btree (kod);


--
-- TOC entry 3060 (class 1259 OID 241429)
-- Dependencies: 1858
-- Name: astaty_nazev_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX astaty_nazev_index ON astaty USING btree (nazev);


--
-- TOC entry 3065 (class 1259 OID 241039)
-- Dependencies: 1860
-- Name: audalosti_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX audalosti_idfirmy_index ON audalosti USING btree (idfirmy);


--
-- TOC entry 3068 (class 1259 OID 241452)
-- Dependencies: 1862
-- Name: ccenik_iddodavatel_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_iddodavatel_index ON ccenik USING btree (iddodavatel);


CREATE INDEX ccenik_idvyrobce_index ON ccenik USING btree (idvyrobce);


--
-- TOC entry 3069 (class 1259 OID 241055)
-- Dependencies: 1862
-- Name: ccenik_idmj1_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idmj1_index ON ccenik USING btree (idmj1);


--
-- TOC entry 3070 (class 1259 OID 241056)
-- Dependencies: 1862
-- Name: ccenik_idmj2_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idmj2_index ON ccenik USING btree (idmj2);


--
-- TOC entry 3071 (class 1259 OID 241057)
-- Dependencies: 1862
-- Name: ccenik_idmj3_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idmj3_index ON ccenik USING btree (idmj3);


--
-- TOC entry 3072 (class 1259 OID 241058)
-- Dependencies: 1862
-- Name: ccenik_idmjhmot_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idmjhmot_index ON ccenik USING btree (idmjhmot);


--
-- TOC entry 3073 (class 1259 OID 241059)
-- Dependencies: 1862
-- Name: ccenik_idmjobj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idmjobj_index ON ccenik USING btree (idmjobj);


--
-- TOC entry 3074 (class 1259 OID 241061)
-- Dependencies: 1862
-- Name: ccenik_idnomen_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idnomen_index ON ccenik USING btree (idnomen);


--
-- TOC entry 3075 (class 1259 OID 241054)
-- Dependencies: 1862
-- Name: ccenik_idskupzboz_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idskupzboz_index ON ccenik USING btree (idskupzboz);


--
-- TOC entry 3076 (class 1259 OID 241060)
-- Dependencies: 1862
-- Name: ccenik_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ccenik_idstatu_index ON ccenik USING btree (idstatu);

create index ccenik_eankod_upper_index on ccenik (upper(eankod::text)) where eankod is not null;
create index ccenik_baleniean1_upper_index on ccenik (upper(BaleniEan1::text)) where BaleniEan1 is not null;
create index ccenik_baleniean2_upper_index on ccenik (upper(BaleniEan2::text)) where BaleniEan2 is not null;
create index ccenik_baleniean3_upper_index on ccenik (upper(BaleniEan3::text)) where BaleniEan3 is not null;
create index ccenik_baleniean4_upper_index on ccenik (upper(BaleniEan4::text)) where BaleniEan4 is not null;
create index ccenik_baleniean5_upper_index on ccenik (upper(BaleniEan5::text)) where BaleniEan5 is not null;


--
-- TOC entry 3087 (class 1259 OID 241062)
-- Dependencies: 1865
-- Name: cskupzboz_idprotiucetpfa_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_idprotiucetpfa_index ON cskupzboz USING btree (idprotiucetpfa);


--
-- TOC entry 3088 (class 1259 OID 241064)
-- Dependencies: 1865
-- Name: cskupzboz_idprotiucetsklp_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_idprotiucetsklp_index ON cskupzboz USING btree (idprotiucetsklp);


--
-- TOC entry 3089 (class 1259 OID 241065)
-- Dependencies: 1865
-- Name: cskupzboz_idprotiucetsklv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_idprotiucetsklv_index ON cskupzboz USING btree (idprotiucetsklv);


--
-- TOC entry 3090 (class 1259 OID 241063)
-- Dependencies: 1865
-- Name: cskupzboz_idprotiucetvfa_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_idprotiucetvfa_index ON cskupzboz USING btree (idprotiucetvfa);


--
-- TOC entry 3091 (class 1259 OID 241388)
-- Dependencies: 1865
-- Name: cskupzboz_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_kod_index ON cskupzboz USING btree (kod);


--
-- TOC entry 3096 (class 1259 OID 242078)
-- Dependencies: 1865
-- Name: cskupzboz_typorg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX cskupzboz_typorg_index ON cskupzboz USING btree (idtyporg);


--
-- TOC entry 3099 (class 1259 OID 241075)
-- Dependencies: 1869
-- Name: ddoklfak_idbanspojdod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idbanspojdod_index ON ddoklfak USING btree (idbanspojdod) where idbanspojdod is not null;


--
-- TOC entry 3100 (class 1259 OID 241083)
-- Dependencies: 1869
-- Name: ddoklfak_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idclendph_index ON ddoklfak USING btree (idclendph);


--
-- TOC entry 3101 (class 1259 OID 241089)
-- Dependencies: 1869
-- Name: ddoklfak_iddodpodm_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_iddodpodm_index ON ddoklfak USING btree (iddodpodm) WHERE iddodpodm IS NOT NULL;


--
-- TOC entry 3102 (class 1259 OID 241080)
-- Dependencies: 1869
-- Name: ddoklfak_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_iddphsnizucet_index ON ddoklfak USING btree (iddphsnizucet);


--
-- TOC entry 3103 (class 1259 OID 241079)
-- Dependencies: 1869
-- Name: ddoklfak_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_iddphzaklucet_index ON ddoklfak USING btree (iddphzaklucet);


--
-- TOC entry 3104 (class 1259 OID 241091)
-- Dependencies: 1869
-- Name: ddoklfak_iddruhdopr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_iddruhdopr_index ON ddoklfak USING btree (iddruhdopr) WHERE iddruhdopr IS NOT NULL;


--
-- TOC entry 3105 (class 1259 OID 241073)
-- Dependencies: 1869
-- Name: ddoklfak_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idfastatu_index ON ddoklfak USING btree (idfastatu) where idfastatu is not null;


--
-- TOC entry 3106 (class 1259 OID 241071)
-- Dependencies: 1869
-- Name: ddoklfak_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idfirmy_index ON ddoklfak USING btree (idfirmy);


--
-- TOC entry 3107 (class 1259 OID 241070)
-- Dependencies: 1869
-- Name: ddoklfak_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idkonsym_index ON ddoklfak USING btree (idkonsym);


--
-- TOC entry 3108 (class 1259 OID 241093)
-- Dependencies: 1869
-- Name: ddoklfak_idkrajurc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idkrajurc_index ON ddoklfak USING btree (idkrajurc) WHERE idkrajurc IS NOT NULL;


--
-- TOC entry 3109 (class 1259 OID 241069)
-- Dependencies: 1869
-- Name: ddoklfak_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idmeny_index ON ddoklfak USING btree (idmeny);


--
-- TOC entry 3110 (class 1259 OID 241074)
-- Dependencies: 1869
-- Name: ddoklfak_idmur_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idmur_index ON ddoklfak USING btree (idmur) where idmur is not null;


--
-- TOC entry 3111 (class 1259 OID 241090)
-- Dependencies: 1869
-- Name: ddoklfak_idobchtrans_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idobchtrans_index ON ddoklfak USING btree (idobchtrans) WHERE idobchtrans IS NOT NULL;


--
-- TOC entry 3112 (class 1259 OID 241096)
-- Dependencies: 1869
-- Name: ddoklfak_idpolrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idpolrady_index ON ddoklfak USING btree (idpolrady);


--
-- TOC entry 3113 (class 1259 OID 241077)
-- Dependencies: 1869
-- Name: ddoklfak_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idprimucet_index ON ddoklfak USING btree (idprimucet);


--
-- TOC entry 3114 (class 1259 OID 241078)
-- Dependencies: 1869
-- Name: ddoklfak_idprotiucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idprotiucet_index ON ddoklfak USING btree (idprotiucet);


--
-- TOC entry 3115 (class 1259 OID 241095)
-- Dependencies: 1869
-- Name: ddoklfak_idrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idrady_index ON ddoklfak USING btree (idrady);


--
-- TOC entry 3116 (class 1259 OID 241097)
-- Dependencies: 1869
-- Name: ddoklfak_idsazbydphosv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idsazbydphosv_index ON ddoklfak USING btree (idsazbydphosv);


--
-- TOC entry 3117 (class 1259 OID 241098)
-- Dependencies: 1869
-- Name: ddoklfak_idsazbydphsniz_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idsazbydphsniz_index ON ddoklfak USING btree (idsazbydphsniz);


--
-- TOC entry 3118 (class 1259 OID 241099)
-- Dependencies: 1869
-- Name: ddoklfak_idsazbydphzakl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idsazbydphzakl_index ON ddoklfak USING btree (idsazbydphzakl);


--
-- TOC entry 3119 (class 1259 OID 241081)
-- Dependencies: 1869
-- Name: ddoklfak_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idsmerkod_index ON ddoklfak USING btree (idsmerkod) where idsmerkod is not null;


--
-- TOC entry 3120 (class 1259 OID 241082)
-- Dependencies: 1869
-- Name: ddoklfak_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstatdph_index ON ddoklfak USING btree (idstatdph);


--
-- TOC entry 3121 (class 1259 OID 241086)
-- Dependencies: 1869
-- Name: ddoklfak_idstatodesl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstatodesl_index ON ddoklfak USING btree (idstatodesl) WHERE idstatodesl IS NOT NULL;


--
-- TOC entry 3122 (class 1259 OID 241088)
-- Dependencies: 1869
-- Name: ddoklfak_idstatpuvod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstatpuvod_index ON ddoklfak USING btree (idstatpuvod) WHERE idstatpuvod IS NOT NULL;


--
-- TOC entry 3123 (class 1259 OID 241072)
-- Dependencies: 1869
-- Name: ddoklfak_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstatu_index ON ddoklfak USING btree (idstatu);


--
-- TOC entry 3124 (class 1259 OID 241087)
-- Dependencies: 1869
-- Name: ddoklfak_idstaturc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstaturc_index ON ddoklfak USING btree (idstaturc) WHERE idstaturc IS NOT NULL;


--
-- TOC entry 3125 (class 1259 OID 241084)
-- Dependencies: 1869
-- Name: ddoklfak_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idstred_index ON ddoklfak USING btree (idstred);


--
-- TOC entry 3126 (class 1259 OID 241068)
-- Dependencies: 1869
-- Name: ddoklfak_idtypdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idtypdokl_index ON ddoklfak USING btree (idtypdokl);


--
-- TOC entry 3128 (class 1259 OID 241094)
-- Dependencies: 1869
-- Name: ddoklfak_iduziv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_iduziv_index ON ddoklfak USING btree (iduziv);


--
-- TOC entry 3129 (class 1259 OID 241085)
-- Dependencies: 1869
-- Name: ddoklfak_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idzakazky_index ON ddoklfak USING btree (idzakazky) where idzakazky is not null;


--
-- TOC entry 3130 (class 1259 OID 241092)
-- Dependencies: 1869
-- Name: ddoklfak_idzvlpoh_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklfak_idzvlpoh_index ON ddoklfak USING btree (idzvlpoh) WHERE idzvlpoh IS NOT NULL;


--
-- TOC entry 3131 (class 1259 OID 241422)
-- Dependencies: 1869 1869
-- Name: ddoklfak_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

create index ddoklfak_varsym_upper_index on ddoklfak (upper(varsym::text));
create index ddoklint_varsym_upper_index on ddoklint (upper(varsym::text));
create index ddoklsklad_varsym_upper_index on ddoklsklad (upper(varsym::text));
create index ddoklobch_varsym_upper_index on ddoklobch (upper(varsym::text));

create index ddoklfak_cisobj_upper_index on ddoklfak (upper(cisobj::text)) where cisobj is not null;

--
-- TOC entry 3136 (class 1259 OID 241107)
-- Dependencies: 1871
-- Name: ddoklint_idbanspojdod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idbanspojdod_index ON ddoklint USING btree (idbanspojdod) where idbanspojdod is not null;


--
-- TOC entry 3137 (class 1259 OID 241115)
-- Dependencies: 1871
-- Name: ddoklint_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idclendph_index ON ddoklint USING btree (idclendph);


--
-- TOC entry 3138 (class 1259 OID 241121)
-- Dependencies: 1871
-- Name: ddoklint_iddodpodm_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_iddodpodm_index ON ddoklint USING btree (iddodpodm) WHERE iddodpodm IS NOT NULL;


--
-- TOC entry 3139 (class 1259 OID 241112)
-- Dependencies: 1871
-- Name: ddoklint_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_iddphsnizucet_index ON ddoklint USING btree (iddphsnizucet) where iddphsnizucet is not null;


--
-- TOC entry 3140 (class 1259 OID 241111)
-- Dependencies: 1871
-- Name: ddoklint_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_iddphzaklucet_index ON ddoklint USING btree (iddphzaklucet) where iddphzaklucet is not null;


--
-- TOC entry 3141 (class 1259 OID 241123)
-- Dependencies: 1871
-- Name: ddoklint_iddruhdopr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_iddruhdopr_index ON ddoklint USING btree (iddruhdopr) WHERE iddruhdopr IS NOT NULL;


--
-- TOC entry 3142 (class 1259 OID 241105)
-- Dependencies: 1871
-- Name: ddoklint_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idfastatu_index ON ddoklint USING btree (idfastatu) where idfastatu is not null;


--
-- TOC entry 3143 (class 1259 OID 241103)
-- Dependencies: 1871
-- Name: ddoklint_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idfirmy_index ON ddoklint USING btree (idfirmy);


--
-- TOC entry 3144 (class 1259 OID 241102)
-- Dependencies: 1871
-- Name: ddoklint_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idkonsym_index ON ddoklint USING btree (idkonsym);


--
-- TOC entry 3145 (class 1259 OID 241125)
-- Dependencies: 1871
-- Name: ddoklint_idkrajurc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idkrajurc_index ON ddoklint USING btree (idkrajurc) WHERE idkrajurc IS NOT NULL;


--
-- TOC entry 3146 (class 1259 OID 241101)
-- Dependencies: 1871
-- Name: ddoklint_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idmeny_index ON ddoklint USING btree (idmeny);


--
-- TOC entry 3147 (class 1259 OID 241106)
-- Dependencies: 1871
-- Name: ddoklint_idmur_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idmur_index ON ddoklint USING btree (idmur) where idmur is not null;


--
-- TOC entry 3148 (class 1259 OID 241122)
-- Dependencies: 1871
-- Name: ddoklint_idobchtrans_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idobchtrans_index ON ddoklint USING btree (idobchtrans) WHERE idobchtrans IS NOT NULL;


--
-- TOC entry 3149 (class 1259 OID 241128)
-- Dependencies: 1871
-- Name: ddoklint_idpolrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idpolrady_index ON ddoklint USING btree (idpolrady);


--
-- TOC entry 3150 (class 1259 OID 241109)
-- Dependencies: 1871
-- Name: ddoklint_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idprimucet_index ON ddoklint USING btree (idprimucet);


--
-- TOC entry 3151 (class 1259 OID 241110)
-- Dependencies: 1871
-- Name: ddoklint_idprotiucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idprotiucet_index ON ddoklint USING btree (idprotiucet);


--
-- TOC entry 3152 (class 1259 OID 241127)
-- Dependencies: 1871
-- Name: ddoklint_idrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idrady_index ON ddoklint USING btree (idrady);


--
-- TOC entry 3153 (class 1259 OID 241129)
-- Dependencies: 1871
-- Name: ddoklint_idsazbydphosv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idsazbydphosv_index ON ddoklint USING btree (idsazbydphosv);


--
-- TOC entry 3154 (class 1259 OID 241130)
-- Dependencies: 1871
-- Name: ddoklint_idsazbydphsniz_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idsazbydphsniz_index ON ddoklint USING btree (idsazbydphsniz);


--
-- TOC entry 3155 (class 1259 OID 241131)
-- Dependencies: 1871
-- Name: ddoklint_idsazbydphzakl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idsazbydphzakl_index ON ddoklint USING btree (idsazbydphzakl);


--
-- TOC entry 3156 (class 1259 OID 241113)
-- Dependencies: 1871
-- Name: ddoklint_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idsmerkod_index ON ddoklint USING btree (idsmerkod);


--
-- TOC entry 3157 (class 1259 OID 241114)
-- Dependencies: 1871
-- Name: ddoklint_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstatdph_index ON ddoklint USING btree (idstatdph);


--
-- TOC entry 3158 (class 1259 OID 241118)
-- Dependencies: 1871
-- Name: ddoklint_idstatodesl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstatodesl_index ON ddoklint USING btree (idstatodesl) WHERE idstatodesl IS NOT NULL;


--
-- TOC entry 3159 (class 1259 OID 241120)
-- Dependencies: 1871
-- Name: ddoklint_idstatpuvod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstatpuvod_index ON ddoklint USING btree (idstatpuvod) WHERE idstatpuvod IS NOT NULL;


--
-- TOC entry 3160 (class 1259 OID 241104)
-- Dependencies: 1871
-- Name: ddoklint_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstatu_index ON ddoklint USING btree (idstatu);


--
-- TOC entry 3161 (class 1259 OID 241119)
-- Dependencies: 1871
-- Name: ddoklint_idstaturc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstaturc_index ON ddoklint USING btree (idstaturc) WHERE idstaturc IS NOT NULL;


--
-- TOC entry 3162 (class 1259 OID 241116)
-- Dependencies: 1871
-- Name: ddoklint_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idstred_index ON ddoklint USING btree (idstred);


--
-- TOC entry 3163 (class 1259 OID 241100)
-- Dependencies: 1871
-- Name: ddoklint_idtypdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idtypdokl_index ON ddoklint USING btree (idtypdokl);


--
-- TOC entry 3165 (class 1259 OID 241126)
-- Dependencies: 1871
-- Name: ddoklint_iduziv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_iduziv_index ON ddoklint USING btree (iduziv);


--
-- TOC entry 3166 (class 1259 OID 241117)
-- Dependencies: 1871
-- Name: ddoklint_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idzakazky_index ON ddoklint USING btree (idzakazky) where idzakazky is not null;


--
-- TOC entry 3167 (class 1259 OID 241124)
-- Dependencies: 1871
-- Name: ddoklint_idzvlpoh_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklint_idzvlpoh_index ON ddoklint USING btree (idzvlpoh) WHERE idzvlpoh IS NOT NULL;

--
-- TOC entry 3695 (class 1259 OID 241861)
-- Dependencies: 2000
-- Name: ddoklobch_idbanspojdod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idbanspojdod_index ON ddoklobch USING btree (idbanspojdod);


--
-- TOC entry 3696 (class 1259 OID 241869)
-- Dependencies: 2000
-- Name: ddoklobch_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idclendph_index ON ddoklobch USING btree (idclendph);


--
-- TOC entry 3697 (class 1259 OID 241875)
-- Dependencies: 2000
-- Name: ddoklobch_iddodpodm_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_iddodpodm_index ON ddoklobch USING btree (iddodpodm) WHERE iddodpodm IS NOT NULL;


--
-- TOC entry 3698 (class 1259 OID 241866)
-- Dependencies: 2000
-- Name: ddoklobch_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_iddphsnizucet_index ON ddoklobch USING btree (iddphsnizucet);


--
-- TOC entry 3699 (class 1259 OID 241865)
-- Dependencies: 2000
-- Name: ddoklobch_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_iddphzaklucet_index ON ddoklobch USING btree (iddphzaklucet);


--
-- TOC entry 3700 (class 1259 OID 241877)
-- Dependencies: 2000
-- Name: ddoklobch_iddruhdopr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_iddruhdopr_index ON ddoklobch USING btree (iddruhdopr) WHERE iddruhdopr IS NOT NULL;


--
-- TOC entry 3701 (class 1259 OID 241859)
-- Dependencies: 2000
-- Name: ddoklobch_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idfastatu_index ON ddoklobch USING btree (idfastatu);


--
-- TOC entry 3702 (class 1259 OID 241857)
-- Dependencies: 2000
-- Name: ddoklobch_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idfirmy_index ON ddoklobch USING btree (idfirmy);


--
-- TOC entry 3703 (class 1259 OID 241856)
-- Dependencies: 2000
-- Name: ddoklobch_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idkonsym_index ON ddoklobch USING btree (idkonsym);


--
-- TOC entry 3704 (class 1259 OID 241879)
-- Dependencies: 2000
-- Name: ddoklobch_idkrajurc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idkrajurc_index ON ddoklobch USING btree (idkrajurc) WHERE idkrajurc IS NOT NULL;


--
-- TOC entry 3705 (class 1259 OID 241855)
-- Dependencies: 2000
-- Name: ddoklobch_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idmeny_index ON ddoklobch USING btree (idmeny);


--
-- TOC entry 3706 (class 1259 OID 241860)
-- Dependencies: 2000
-- Name: ddoklobch_idmur_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idmur_index ON ddoklobch USING btree (idmur);


--
-- TOC entry 3707 (class 1259 OID 241876)
-- Dependencies: 2000
-- Name: ddoklobch_idobchtrans_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idobchtrans_index ON ddoklobch USING btree (idobchtrans) WHERE idobchtrans IS NOT NULL;


--
-- TOC entry 3708 (class 1259 OID 241882)
-- Dependencies: 2000
-- Name: ddoklobch_idpolrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idpolrady_index ON ddoklobch USING btree (idpolrady);


--
-- TOC entry 3709 (class 1259 OID 241863)
-- Dependencies: 2000
-- Name: ddoklobch_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idprimucet_index ON ddoklobch USING btree (idprimucet);


--
-- TOC entry 3710 (class 1259 OID 241864)
-- Dependencies: 2000
-- Name: ddoklobch_idprotiucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idprotiucet_index ON ddoklobch USING btree (idprotiucet);


--
-- TOC entry 3711 (class 1259 OID 241881)
-- Dependencies: 2000
-- Name: ddoklobch_idrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idrady_index ON ddoklobch USING btree (idrady);


--
-- TOC entry 3712 (class 1259 OID 241883)
-- Dependencies: 2000
-- Name: ddoklobch_idsazbydphosv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idsazbydphosv_index ON ddoklobch USING btree (idsazbydphosv);


--
-- TOC entry 3713 (class 1259 OID 241884)
-- Dependencies: 2000
-- Name: ddoklobch_idsazbydphsniz_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idsazbydphsniz_index ON ddoklobch USING btree (idsazbydphsniz);


--
-- TOC entry 3714 (class 1259 OID 241885)
-- Dependencies: 2000
-- Name: ddoklobch_idsazbydphzakl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idsazbydphzakl_index ON ddoklobch USING btree (idsazbydphzakl);


--
-- TOC entry 3715 (class 1259 OID 241867)
-- Dependencies: 2000
-- Name: ddoklobch_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idsmerkod_index ON ddoklobch USING btree (idsmerkod);


--
-- TOC entry 3716 (class 1259 OID 241868)
-- Dependencies: 2000
-- Name: ddoklobch_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstatdph_index ON ddoklobch USING btree (idstatdph);


--
-- TOC entry 3717 (class 1259 OID 241872)
-- Dependencies: 2000
-- Name: ddoklobch_idstatodesl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstatodesl_index ON ddoklobch USING btree (idstatodesl) WHERE idstatodesl IS NOT NULL;


--
-- TOC entry 3718 (class 1259 OID 241874)
-- Dependencies: 2000
-- Name: ddoklobch_idstatpuvod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstatpuvod_index ON ddoklobch USING btree (idstatpuvod) WHERE idstatpuvod IS NOT NULL;


--
-- TOC entry 3719 (class 1259 OID 241858)
-- Dependencies: 2000
-- Name: ddoklobch_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstatu_index ON ddoklobch USING btree (idstatu);


--
-- TOC entry 3720 (class 1259 OID 241873)
-- Dependencies: 2000
-- Name: ddoklobch_idstaturc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstaturc_index ON ddoklobch USING btree (idstaturc) WHERE idstaturc IS NOT NULL;


--
-- TOC entry 3721 (class 1259 OID 241870)
-- Dependencies: 2000
-- Name: ddoklobch_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idstred_index ON ddoklobch USING btree (idstred);


--
-- TOC entry 3722 (class 1259 OID 241854)
-- Dependencies: 2000
-- Name: ddoklobch_idtypdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idtypdokl_index ON ddoklobch USING btree (idtypdokl);


--
-- TOC entry 3724 (class 1259 OID 241880)
-- Dependencies: 2000
-- Name: ddoklobch_iduziv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_iduziv_index ON ddoklobch USING btree (iduziv);


--
-- TOC entry 3725 (class 1259 OID 241871)
-- Dependencies: 2000
-- Name: ddoklobch_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idzakazky_index ON ddoklobch USING btree (idzakazky);


--
-- TOC entry 3726 (class 1259 OID 241878)
-- Dependencies: 2000
-- Name: ddoklobch_idzvlpoh_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklobch_idzvlpoh_index ON ddoklobch USING btree (idzvlpoh) WHERE idzvlpoh IS NOT NULL;


--
-- TOC entry 3173 (class 1259 OID 241139)
-- Dependencies: 1873
-- Name: ddoklsklad_idbanspojdod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idbanspojdod_index ON ddoklsklad USING btree (idbanspojdod) where idbanspojdod is not null;


--
-- TOC entry 3174 (class 1259 OID 241147)
-- Dependencies: 1873
-- Name: ddoklsklad_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idclendph_index ON ddoklsklad USING btree (idclendph) where idclendph is not null;


--
-- TOC entry 3175 (class 1259 OID 241153)
-- Dependencies: 1873
-- Name: ddoklsklad_iddodpodm_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_iddodpodm_index ON ddoklsklad USING btree (iddodpodm) WHERE iddodpodm IS NOT NULL;


--
-- TOC entry 3176 (class 1259 OID 241144)
-- Dependencies: 1873
-- Name: ddoklsklad_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_iddphsnizucet_index ON ddoklsklad USING btree (iddphsnizucet) where iddphsnizucet is not null;


--
-- TOC entry 3177 (class 1259 OID 241143)
-- Dependencies: 1873
-- Name: ddoklsklad_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_iddphzaklucet_index ON ddoklsklad USING btree (iddphzaklucet) where iddphzaklucet is not null;


--
-- TOC entry 3178 (class 1259 OID 241155)
-- Dependencies: 1873
-- Name: ddoklsklad_iddruhdopr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_iddruhdopr_index ON ddoklsklad USING btree (iddruhdopr) WHERE iddruhdopr IS NOT NULL;


--
-- TOC entry 3179 (class 1259 OID 241137)
-- Dependencies: 1873
-- Name: ddoklsklad_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idfastatu_index ON ddoklsklad USING btree (idfastatu) where idfastatu is not null;


--
-- TOC entry 3180 (class 1259 OID 241135)
-- Dependencies: 1873
-- Name: ddoklsklad_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idfirmy_index ON ddoklsklad USING btree (idfirmy);


--
-- TOC entry 3181 (class 1259 OID 241134)
-- Dependencies: 1873
-- Name: ddoklsklad_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idkonsym_index ON ddoklsklad USING btree (idkonsym) where idkonsym is not null;


--
-- TOC entry 3182 (class 1259 OID 241157)
-- Dependencies: 1873
-- Name: ddoklsklad_idkrajurc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idkrajurc_index ON ddoklsklad USING btree (idkrajurc) WHERE idkrajurc IS NOT NULL;


--
-- TOC entry 3183 (class 1259 OID 241133)
-- Dependencies: 1873
-- Name: ddoklsklad_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idmeny_index ON ddoklsklad USING btree (idmeny);


--
-- TOC entry 3184 (class 1259 OID 241138)
-- Dependencies: 1873
-- Name: ddoklsklad_idmur_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idmur_index ON ddoklsklad USING btree (idmur) where idmur is not null;


--
-- TOC entry 3185 (class 1259 OID 241154)
-- Dependencies: 1873
-- Name: ddoklsklad_idobchtrans_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idobchtrans_index ON ddoklsklad USING btree (idobchtrans) WHERE idobchtrans IS NOT NULL;


--
-- TOC entry 3186 (class 1259 OID 241160)
-- Dependencies: 1873
-- Name: ddoklsklad_idpolrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idpolrady_index ON ddoklsklad USING btree (idpolrady);


--
-- TOC entry 3187 (class 1259 OID 241141)
-- Dependencies: 1873
-- Name: ddoklsklad_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idprimucet_index ON ddoklsklad USING btree (idprimucet);


--
-- TOC entry 3188 (class 1259 OID 241142)
-- Dependencies: 1873
-- Name: ddoklsklad_idprotiucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idprotiucet_index ON ddoklsklad USING btree (idprotiucet);


--
-- TOC entry 3189 (class 1259 OID 241159)
-- Dependencies: 1873
-- Name: ddoklsklad_idrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idrady_index ON ddoklsklad USING btree (idrady);


--
-- TOC entry 3190 (class 1259 OID 241161)
-- Dependencies: 1873
-- Name: ddoklsklad_idsazbydphosv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idsazbydphosv_index ON ddoklsklad USING btree (idsazbydphosv) where idsazbydphosv is not null;


--
-- TOC entry 3191 (class 1259 OID 241162)
-- Dependencies: 1873
-- Name: ddoklsklad_idsazbydphsniz_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idsazbydphsniz_index ON ddoklsklad USING btree (idsazbydphsniz) where idsazbydphsniz is not null;


--
-- TOC entry 3192 (class 1259 OID 241163)
-- Dependencies: 1873
-- Name: ddoklsklad_idsazbydphzakl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idsazbydphzakl_index ON ddoklsklad USING btree (idsazbydphzakl) where idsazbydphzakl is not null;


--
-- TOC entry 3193 (class 1259 OID 241145)
-- Dependencies: 1873
-- Name: ddoklsklad_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idsmerkod_index ON ddoklsklad USING btree (idsmerkod) where idsmerkod is not null;


--
-- TOC entry 3194 (class 1259 OID 241146)
-- Dependencies: 1873
-- Name: ddoklsklad_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstatdph_index ON ddoklsklad USING btree (idstatdph) where idstatdph is not null;


--
-- TOC entry 3195 (class 1259 OID 241150)
-- Dependencies: 1873
-- Name: ddoklsklad_idstatodesl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstatodesl_index ON ddoklsklad USING btree (idstatodesl) WHERE idstatodesl IS NOT NULL;


--
-- TOC entry 3196 (class 1259 OID 241152)
-- Dependencies: 1873
-- Name: ddoklsklad_idstatpuvod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstatpuvod_index ON ddoklsklad USING btree (idstatpuvod) WHERE idstatpuvod IS NOT NULL;


--
-- TOC entry 3197 (class 1259 OID 241136)
-- Dependencies: 1873
-- Name: ddoklsklad_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstatu_index ON ddoklsklad USING btree (idstatu);


--
-- TOC entry 3198 (class 1259 OID 241151)
-- Dependencies: 1873
-- Name: ddoklsklad_idstaturc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstaturc_index ON ddoklsklad USING btree (idstaturc) WHERE idstaturc IS NOT NULL;


--
-- TOC entry 3199 (class 1259 OID 241148)
-- Dependencies: 1873
-- Name: ddoklsklad_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idstred_index ON ddoklsklad USING btree (idstred);


--
-- TOC entry 3200 (class 1259 OID 241132)
-- Dependencies: 1873
-- Name: ddoklsklad_idtypdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idtypdokl_index ON ddoklsklad USING btree (idtypdokl);


--
-- TOC entry 3202 (class 1259 OID 241158)
-- Dependencies: 1873
-- Name: ddoklsklad_iduziv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_iduziv_index ON ddoklsklad USING btree (iduziv);


--
-- TOC entry 3203 (class 1259 OID 241149)
-- Dependencies: 1873
-- Name: ddoklsklad_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idzakazky_index ON ddoklsklad USING btree (idzakazky) where idzakazky is not null;


--
-- TOC entry 3204 (class 1259 OID 241156)
-- Dependencies: 1873
-- Name: ddoklsklad_idzvlpoh_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ddoklsklad_idzvlpoh_index ON ddoklsklad USING btree (idzvlpoh) WHERE idzvlpoh IS NOT NULL;


--
-- TOC entry 3220 (class 1259 OID 241437)
-- Dependencies: 1879
-- Name: dpolfak_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_datvyst_index ON dpolfak USING btree (datvyst);


--
-- TOC entry 3221 (class 1259 OID 241174)
-- Dependencies: 1879
-- Name: dpolfak_idcenik_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idcenik_index ON dpolfak USING btree (idcenik) WHERE idcenik IS NOT NULL;


CREATE INDEX dpolfak_idcenhlad_index ON dpolfak USING btree (idcenhlad) WHERE idcenhlad IS NOT NULL;

--
-- TOC entry 3222 (class 1259 OID 241173)
-- Dependencies: 1879
-- Name: dpolfak_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idclendph_index ON dpolfak USING btree (idclendph);


--
-- TOC entry 3223 (class 1259 OID 241178)
-- Dependencies: 1879
-- Name: dpolfak_iddoklfak_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_iddoklfak_index ON dpolfak USING btree (iddoklfak);


--
-- TOC entry 3224 (class 1259 OID 241170)
-- Dependencies: 1879
-- Name: dpolfak_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_iddphdalucet_index ON dpolfak USING btree (iddphdalucet);


--
-- TOC entry 3225 (class 1259 OID 241169)
-- Dependencies: 1879
-- Name: dpolfak_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_iddphmducet_index ON dpolfak USING btree (iddphmducet);


--
-- TOC entry 3226 (class 1259 OID 241172)
-- Dependencies: 1879
-- Name: dpolfak_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idfirmy_index ON dpolfak USING btree (idfirmy) WHERE idfirmy IS NOT NULL;


--
-- TOC entry 3227 (class 1259 OID 241166)
-- Dependencies: 1879
-- Name: dpolfak_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idmeny_index ON dpolfak USING btree (idmeny);


--
-- TOC entry 3228 (class 1259 OID 241175)
-- Dependencies: 1879
-- Name: dpolfak_idmj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idmj_index ON dpolfak USING btree (idmj) WHERE idmj IS NOT NULL;


--
-- TOC entry 3229 (class 1259 OID 241176)
-- Dependencies: 1879
-- Name: dpolfak_idmjobjem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idmjobjem_index ON dpolfak USING btree (idmjobjem) WHERE idmjobjem IS NOT NULL;


--
-- TOC entry 3230 (class 1259 OID 241177)
-- Dependencies: 1879
-- Name: dpolfak_idsazbydph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idsazbydph_index ON dpolfak USING btree (idsazbydph);


--
-- TOC entry 3232 (class 1259 OID 241165)
-- Dependencies: 1879
-- Name: dpolfak_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idstred_index ON dpolfak USING btree (idstred);


--
-- TOC entry 3233 (class 1259 OID 241171)
-- Dependencies: 1879
-- Name: dpolfak_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idzakazky_index ON dpolfak USING btree (idzakazky) WHERE idzakazky IS NOT NULL;


--
-- TOC entry 3234 (class 1259 OID 241168)
-- Dependencies: 1879
-- Name: dpolfak_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idzkldalucet_index ON dpolfak USING btree (idzkldalucet);


--
-- TOC entry 3235 (class 1259 OID 241167)
-- Dependencies: 1879
-- Name: dpolfak_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolfak_idzklmducet_index ON dpolfak USING btree (idzklmducet);


--
-- TOC entry 3238 (class 1259 OID 241438)
-- Dependencies: 1881
-- Name: dpolint_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_datvyst_index ON dpolint USING btree (datvyst);


--
-- TOC entry 3239 (class 1259 OID 241189)
-- Dependencies: 1881
-- Name: dpolint_idcenik_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idcenik_index ON dpolint USING btree (idcenik) where idcenik is not null;


CREATE INDEX dpolint_idcenhlad_index ON dpolint USING btree (idcenhlad) where idcenhlad is not null;


--
-- TOC entry 3240 (class 1259 OID 241188)
-- Dependencies: 1881
-- Name: dpolint_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idclendph_index ON dpolint USING btree (idclendph);


--
-- TOC entry 3241 (class 1259 OID 241193)
-- Dependencies: 1881
-- Name: dpolint_iddoklint_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_iddoklint_index ON dpolint USING btree (iddoklint);


--
-- TOC entry 3242 (class 1259 OID 241185)
-- Dependencies: 1881
-- Name: dpolint_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_iddphdalucet_index ON dpolint USING btree (iddphdalucet) where iddphdalucet is not null;


--
-- TOC entry 3243 (class 1259 OID 241184)
-- Dependencies: 1881
-- Name: dpolint_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_iddphmducet_index ON dpolint USING btree (iddphmducet) where iddphmducet is not null;


--
-- TOC entry 3244 (class 1259 OID 241187)
-- Dependencies: 1881
-- Name: dpolint_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idfirmy_index ON dpolint USING btree (idfirmy) where idfirmy is not null;


--
-- TOC entry 3245 (class 1259 OID 241181)
-- Dependencies: 1881
-- Name: dpolint_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idmeny_index ON dpolint USING btree (idmeny);


--
-- TOC entry 3246 (class 1259 OID 241190)
-- Dependencies: 1881
-- Name: dpolint_idmj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idmj_index ON dpolint USING btree (idmj) where idmj is not null;


--
-- TOC entry 3247 (class 1259 OID 241191)
-- Dependencies: 1881
-- Name: dpolint_idmjobjem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idmjobjem_index ON dpolint USING btree (idmjobjem) where idmjobjem is not null;


--
-- TOC entry 3248 (class 1259 OID 241192)
-- Dependencies: 1881
-- Name: dpolint_idsazbydph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idsazbydph_index ON dpolint USING btree (idsazbydph);


--
-- TOC entry 3250 (class 1259 OID 241180)
-- Dependencies: 1881
-- Name: dpolint_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idstred_index ON dpolint USING btree (idstred);


--
-- TOC entry 3251 (class 1259 OID 241186)
-- Dependencies: 1881
-- Name: dpolint_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idzakazky_index ON dpolint USING btree (idzakazky) where idzakazky is not null;


--
-- TOC entry 3252 (class 1259 OID 241183)
-- Dependencies: 1881
-- Name: dpolint_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idzkldalucet_index ON dpolint USING btree (idzkldalucet);


--
-- TOC entry 3253 (class 1259 OID 241182)
-- Dependencies: 1881
-- Name: dpolint_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolint_idzklmducet_index ON dpolint USING btree (idzklmducet);


--
-- TOC entry 3731 (class 1259 OID 241896)
-- Dependencies: 2001
-- Name: dpolobch_idcenik_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idcenik_index ON dpolobch USING btree (idcenik);

CREATE INDEX dpolobch_idcenhlad_index ON dpolobch USING btree (idcenhlad);


--
-- TOC entry 3732 (class 1259 OID 241895)
-- Dependencies: 2001
-- Name: dpolobch_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idclendph_index ON dpolobch USING btree (idclendph);


--
-- TOC entry 3733 (class 1259 OID 241900)
-- Dependencies: 2001
-- Name: dpolobch_iddoklobch_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_iddoklobch_index ON dpolobch USING btree (iddoklobch);


--
-- TOC entry 3734 (class 1259 OID 241892)
-- Dependencies: 2001
-- Name: dpolobch_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_iddphdalucet_index ON dpolobch USING btree (iddphdalucet);


--
-- TOC entry 3735 (class 1259 OID 241891)
-- Dependencies: 2001
-- Name: dpolobch_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_iddphmducet_index ON dpolobch USING btree (iddphmducet);


--
-- TOC entry 3736 (class 1259 OID 241894)
-- Dependencies: 2001
-- Name: dpolobch_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idfirmy_index ON dpolobch USING btree (idfirmy);


--
-- TOC entry 3737 (class 1259 OID 241888)
-- Dependencies: 2001
-- Name: dpolobch_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idmeny_index ON dpolobch USING btree (idmeny);


--
-- TOC entry 3738 (class 1259 OID 241897)
-- Dependencies: 2001
-- Name: dpolobch_idmj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idmj_index ON dpolobch USING btree (idmj);


--
-- TOC entry 3739 (class 1259 OID 241898)
-- Dependencies: 2001
-- Name: dpolobch_idmjobjem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idmjobjem_index ON dpolobch USING btree (idmjobjem);


--
-- TOC entry 3740 (class 1259 OID 241899)
-- Dependencies: 2001
-- Name: dpolobch_idsazbydph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idsazbydph_index ON dpolobch USING btree (idsazbydph);


--
-- TOC entry 3742 (class 1259 OID 241887)
-- Dependencies: 2001
-- Name: dpolobch_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idstred_index ON dpolobch USING btree (idstred);


--
-- TOC entry 3743 (class 1259 OID 241893)
-- Dependencies: 2001
-- Name: dpolobch_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idzakazky_index ON dpolobch USING btree (idzakazky);


--
-- TOC entry 3744 (class 1259 OID 241890)
-- Dependencies: 2001
-- Name: dpolobch_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idzkldalucet_index ON dpolobch USING btree (idzkldalucet);


--
-- TOC entry 3745 (class 1259 OID 241889)
-- Dependencies: 2001
-- Name: dpolobch_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolobch_idzklmducet_index ON dpolobch USING btree (idzklmducet);


--
-- TOC entry 3256 (class 1259 OID 241249)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idmeny_index ON dpolprikazuhr USING btree (idmeny);


--
-- TOC entry 3257 (class 1259 OID 241246)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idprikazuhr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idprikazuhr_index ON dpolprikazuhr USING btree (idprikazuhr);


--
-- TOC entry 3258 (class 1259 OID 241251)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idprimdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idprimdokl_index ON dpolprikazuhr USING btree (idprimdokl);


--
-- TOC entry 3259 (class 1259 OID 241250)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idsmerkod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idsmerkod_index ON dpolprikazuhr USING btree (idsmerkod);


--
-- TOC entry 3260 (class 1259 OID 241248)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idstatubanky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idstatubanky_index ON dpolprikazuhr USING btree (idstatubanky);


--
-- TOC entry 3261 (class 1259 OID 241247)
-- Dependencies: 1883
-- Name: dpolprikazuhr_idstatuprijem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_idstatuprijem_index ON dpolprikazuhr USING btree (idstatuprijem);


--
-- TOC entry 3262 (class 1259 OID 241391)
-- Dependencies: 1883
-- Name: dpolprikazuhr_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolprikazuhr_kod_index ON dpolprikazuhr USING btree (kod);


--
-- TOC entry 3265 (class 1259 OID 241439)
-- Dependencies: 1885
-- Name: dpolsklad_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_datvyst_index ON dpolsklad USING btree (datvyst);


--
-- TOC entry 3266 (class 1259 OID 241204)
-- Dependencies: 1885
-- Name: dpolsklad_idcenik_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idcenik_index ON dpolsklad USING btree (idcenik);

--
-- TOC entry 3266 (class 1259 OID 241204)
-- Dependencies: 1885
-- Name: dpolsklad_idcenhlad_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idcenhlad_index ON dpolsklad USING btree (idcenhlad) where idcenhlad is not null;

--
-- TOC entry 3267 (class 1259 OID 241203)
-- Dependencies: 1885
-- Name: dpolsklad_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idclendph_index ON dpolsklad USING btree (idclendph) where idclendph is not null;


--
-- TOC entry 3268 (class 1259 OID 241208)
-- Dependencies: 1885
-- Name: dpolsklad_iddoklsklad_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_iddoklsklad_index ON dpolsklad USING btree (iddoklsklad);


--
-- TOC entry 3269 (class 1259 OID 241200)
-- Dependencies: 1885
-- Name: dpolsklad_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_iddphdalucet_index ON dpolsklad USING btree (iddphdalucet) where iddphdalucet is not null;


--
-- TOC entry 3270 (class 1259 OID 241199)
-- Dependencies: 1885
-- Name: dpolsklad_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_iddphmducet_index ON dpolsklad USING btree (iddphmducet) where iddphmducet is not null;


--
-- TOC entry 3271 (class 1259 OID 241202)
-- Dependencies: 1885
-- Name: dpolsklad_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idfirmy_index ON dpolsklad USING btree (idfirmy) where idfirmy is not null;


--
-- TOC entry 3272 (class 1259 OID 241209)
-- Dependencies: 1885
-- Name: dpolsklad_idkarty_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idkarty_index ON dpolsklad USING btree (idkarty);


--
-- TOC entry 3273 (class 1259 OID 241196)
-- Dependencies: 1885
-- Name: dpolsklad_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idmeny_index ON dpolsklad USING btree (idmeny);


--
-- TOC entry 3274 (class 1259 OID 241205)
-- Dependencies: 1885
-- Name: dpolsklad_idmj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idmj_index ON dpolsklad USING btree (idmj);


--
-- TOC entry 3275 (class 1259 OID 241206)
-- Dependencies: 1885
-- Name: dpolsklad_idmjobjem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idmjobjem_index ON dpolsklad USING btree (idmjobjem) where idmjobjem is not null;


--
-- TOC entry 3276 (class 1259 OID 241207)
-- Dependencies: 1885
-- Name: dpolsklad_idsazbydph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idsazbydph_index ON dpolsklad USING btree (idsazbydph) where idsazbydph is not null;


--
-- TOC entry 3278 (class 1259 OID 241195)
-- Dependencies: 1885
-- Name: dpolsklad_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idstred_index ON dpolsklad USING btree (idstred);


--
-- TOC entry 3279 (class 1259 OID 241201)
-- Dependencies: 1885
-- Name: dpolsklad_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idzakazky_index ON dpolsklad USING btree (idzakazky) where idzakazky is not null;


--
-- TOC entry 3280 (class 1259 OID 241198)
-- Dependencies: 1885
-- Name: dpolsklad_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idzkldalucet_index ON dpolsklad USING btree (idzkldalucet);


--
-- TOC entry 3281 (class 1259 OID 241197)
-- Dependencies: 1885
-- Name: dpolsklad_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dpolsklad_idzklmducet_index ON dpolsklad USING btree (idzklmducet);


--
-- TOC entry 3284 (class 1259 OID 241254)
-- Dependencies: 1887
-- Name: dprikazuhr_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dprikazuhr_idfastatu_index ON dprikazuhr USING btree (idfastatu);


--
-- TOC entry 3285 (class 1259 OID 241252)
-- Dependencies: 1887
-- Name: dprikazuhr_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dprikazuhr_idmeny_index ON dprikazuhr USING btree (idmeny);


--
-- TOC entry 3286 (class 1259 OID 241253)
-- Dependencies: 1887
-- Name: dprikazuhr_idtypdokl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dprikazuhr_idbanka_index ON dprikazuhr USING btree (idbanka);


--
-- TOC entry 3296 (class 1259 OID 241067)
-- Dependencies: 1891
-- Name: dradydiry_idradyrok_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dradydiry_idradyrok_index ON dradydiry USING btree (idradyrok);


--
-- TOC entry 3299 (class 1259 OID 241210)
-- Dependencies: 1893
-- Name: dradyrok_idrady_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dradyrok_idrady_index ON dradyrok USING btree (idrady);


--
-- TOC entry 3300 (class 1259 OID 241211)
-- Dependencies: 1893
-- Name: dradyrok_iducetobdobi_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dradyrok_iducetobdobi_index ON dradyrok USING btree (iducetobdobi);


--
-- TOC entry 3305 (class 1259 OID 241232)
-- Dependencies: 1895
-- Name: dtypdokl_iddodpodm_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_iddodpodm_index ON dtypdokl USING btree (iddodpodm);


--
-- TOC entry 3308 (class 1259 OID 241235)
-- Dependencies: 1895
-- Name: dtypdokl_iddruhdopr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_iddruhdopr_index ON dtypdokl USING btree (iddruhdopr);


--
-- TOC entry 3310 (class 1259 OID 241219)
-- Dependencies: 1895
-- Name: dtypdokl_idkonsym_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idkonsym_index ON dtypdokl USING btree (idkonsym);


--
-- TOC entry 3311 (class 1259 OID 241236)
-- Dependencies: 1895
-- Name: dtypdokl_idkrajurc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idkrajurc_index ON dtypdokl USING btree (idkrajurc);


--
-- TOC entry 3313 (class 1259 OID 241225)
-- Dependencies: 1895
-- Name: dtypdokl_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idmeny_index ON dtypdokl USING btree (idmeny);


--
-- TOC entry 3314 (class 1259 OID 241234)
-- Dependencies: 1895
-- Name: dtypdokl_idobchtrans_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idobchtrans_index ON dtypdokl USING btree (idobchtrans);


--
-- TOC entry 3315 (class 1259 OID 241220)
-- Dependencies: 1895
-- Name: dtypdokl_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idprimucet_index ON dtypdokl USING btree (idprimucet);


--
-- TOC entry 3318 (class 1259 OID 241214)
-- Dependencies: 1895
-- Name: dtypdokl_idradyprijem_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idradyprijem_index ON dtypdokl USING btree (idradyprijem);


--
-- TOC entry 3319 (class 1259 OID 241215)
-- Dependencies: 1895
-- Name: dtypdokl_idradyvydej_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idradyvydej_index ON dtypdokl USING btree (idradyvydej);


--
-- TOC entry 3321 (class 1259 OID 241226)
-- Dependencies: 1895
-- Name: dtypdokl_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idstatdph_index ON dtypdokl USING btree (idstatdph);


--
-- TOC entry 3322 (class 1259 OID 241229)
-- Dependencies: 1895
-- Name: dtypdokl_idstatodesl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idstatodesl_index ON dtypdokl USING btree (idstatodesl);


--
-- TOC entry 3323 (class 1259 OID 241231)
-- Dependencies: 1895
-- Name: dtypdokl_idstatpuvod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idstatpuvod_index ON dtypdokl USING btree (idstatpuvod);


--
-- TOC entry 3325 (class 1259 OID 241230)
-- Dependencies: 1895
-- Name: dtypdokl_idstaturc_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idstaturc_index ON dtypdokl USING btree (idstaturc);


--
-- TOC entry 3326 (class 1259 OID 241216)
-- Dependencies: 1895
-- Name: dtypdokl_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idstred_index ON dtypdokl USING btree (idstred);


--
-- TOC entry 3334 (class 1259 OID 241012)
-- Dependencies: 1895
-- Name: dtypdokl_idtyporg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idtyporg_index ON dtypdokl USING btree (idtyporg);


--
-- TOC entry 3335 (class 1259 OID 241213)
-- Dependencies: 1895
-- Name: dtypdokl_iducetobdobido_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_iducetobdobido_index ON dtypdokl USING btree (iducetobdobido);


--
-- TOC entry 3336 (class 1259 OID 241212)
-- Dependencies: 1895
-- Name: dtypdokl_iducetobdobiod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_iducetobdobiod_index ON dtypdokl USING btree (iducetobdobiod);


--
-- TOC entry 3337 (class 1259 OID 241233)
-- Dependencies: 1895
-- Name: dtypdokl_idzvlpoh_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX dtypdokl_idzvlpoh_index ON dtypdokl USING btree (idzvlpoh);


--
-- TOC entry 3367 (class 1259 OID 241255)
-- Dependencies: 1907
-- Name: inomen_idintrmerjed_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX inomen_idintrmerjed_index ON inomen USING btree (idintrmerjed);


--
-- TOC entry 3383 (class 1259 OID 241444)
-- Dependencies: 1913
-- Name: mdannakl_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_datvyst_index ON mdannakl USING btree (datvyst);


--
-- TOC entry 3384 (class 1259 OID 241305)
-- Dependencies: 1913
-- Name: mdannakl_idleasing_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_idleasing_index ON mdannakl USING btree (idleasing);


--
-- TOC entry 3385 (class 1259 OID 241308)
-- Dependencies: 1913
-- Name: mdannakl_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_idstred_index ON mdannakl USING btree (idstred);


--
-- TOC entry 3386 (class 1259 OID 241309)
-- Dependencies: 1913
-- Name: mdannakl_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_idzakazky_index ON mdannakl USING btree (idzakazky);


--
-- TOC entry 3387 (class 1259 OID 241307)
-- Dependencies: 1913
-- Name: mdannakl_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_idzkldalucet_index ON mdannakl USING btree (idzkldalucet);


--
-- TOC entry 3388 (class 1259 OID 241306)
-- Dependencies: 1913
-- Name: mdannakl_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_idzklmducet_index ON mdannakl USING btree (idzklmducet);


--
-- TOC entry 3389 (class 1259 OID 241400)
-- Dependencies: 1913
-- Name: mdannakl_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdannakl_kod_index ON mdannakl USING btree (kod);


--
-- TOC entry 3392 (class 1259 OID 241441)
-- Dependencies: 1915
-- Name: mdanodpisy_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_datvyst_index ON mdanodpisy USING btree (datvyst);


--
-- TOC entry 3393 (class 1259 OID 241310)
-- Dependencies: 1915
-- Name: mdanodpisy_idmajetku_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_idmajetku_index ON mdanodpisy USING btree (idmajetku);


--
-- TOC entry 3394 (class 1259 OID 241313)
-- Dependencies: 1915
-- Name: mdanodpisy_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_idstred_index ON mdanodpisy USING btree (idstred);


--
-- TOC entry 3395 (class 1259 OID 241314)
-- Dependencies: 1915
-- Name: mdanodpisy_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_idzakazky_index ON mdanodpisy USING btree (idzakazky);


--
-- TOC entry 3396 (class 1259 OID 241312)
-- Dependencies: 1915
-- Name: mdanodpisy_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_idzkldalucet_index ON mdanodpisy USING btree (idzkldalucet);


--
-- TOC entry 3397 (class 1259 OID 241311)
-- Dependencies: 1915
-- Name: mdanodpisy_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_idzklmducet_index ON mdanodpisy USING btree (idzklmducet);


--
-- TOC entry 3398 (class 1259 OID 241401)
-- Dependencies: 1915
-- Name: mdanodpisy_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mdanodpisy_kod_index ON mdanodpisy USING btree (kod);


--
-- TOC entry 3401 (class 1259 OID 241317)
-- Dependencies: 1917
-- Name: mleasing_idcasucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idcasucet_index ON mleasing USING btree (idcasucet);


--
-- TOC entry 3402 (class 1259 OID 241321)
-- Dependencies: 1917
-- Name: mleasing_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_iddphsnizucet_index ON mleasing USING btree (iddphsnizucet);


--
-- TOC entry 3403 (class 1259 OID 241320)
-- Dependencies: 1917
-- Name: mleasing_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_iddphzaklucet_index ON mleasing USING btree (iddphzaklucet);


--
-- TOC entry 3404 (class 1259 OID 241322)
-- Dependencies: 1917
-- Name: mleasing_idfirmydod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idfirmydod_index ON mleasing USING btree (idfirmydod);


--
-- TOC entry 3405 (class 1259 OID 241323)
-- Dependencies: 1917
-- Name: mleasing_idfirmyvyr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idfirmyvyr_index ON mleasing USING btree (idfirmyvyr);


--
-- TOC entry 3406 (class 1259 OID 241316)
-- Dependencies: 1917
-- Name: mleasing_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idmeny_index ON mleasing USING btree (idmeny);


--
-- TOC entry 3407 (class 1259 OID 241319)
-- Dependencies: 1917
-- Name: mleasing_idnaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idnaklucet_index ON mleasing USING btree (idnaklucet);


--
-- TOC entry 3408 (class 1259 OID 241324)
-- Dependencies: 1917
-- Name: mleasing_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idstred_index ON mleasing USING btree (idstred);


--
-- TOC entry 3409 (class 1259 OID 241315)
-- Dependencies: 1917
-- Name: mleasing_idtypleas_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idtypleas_index ON mleasing USING btree (idtypleas);


--
-- TOC entry 3410 (class 1259 OID 241325)
-- Dependencies: 1917
-- Name: mleasing_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idzakazky_index ON mleasing USING btree (idzakazky);


--
-- TOC entry 3411 (class 1259 OID 241318)
-- Dependencies: 1917
-- Name: mleasing_idzavazucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mleasing_idzavazucet_index ON mleasing USING btree (idzavazucet);

CREATE INDEX mleasing_iduziv_index ON mleasing USING btree (iduziv);

--
-- TOC entry 3417 (class 1259 OID 241333)
-- Dependencies: 1919
-- Name: mmajetek_iddoklfak_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_iddoklfak_index ON mmajetek USING btree (iddoklfak);


--
-- TOC entry 3418 (class 1259 OID 241334)
-- Dependencies: 1919
-- Name: mmajetek_idfirmydod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idfirmydod_index ON mmajetek USING btree (idfirmydod);


--
-- TOC entry 3419 (class 1259 OID 241335)
-- Dependencies: 1919
-- Name: mmajetek_idfirmyvyr_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idfirmyvyr_index ON mmajetek USING btree (idfirmyvyr);


--
-- TOC entry 3420 (class 1259 OID 241339)
-- Dependencies: 1919
-- Name: mmajetek_idodpucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idodpucet_index ON mmajetek USING btree (idodpucet);


--
-- TOC entry 3421 (class 1259 OID 241338)
-- Dependencies: 1919
-- Name: mmajetek_idopravucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idopravucet_index ON mmajetek USING btree (idopravucet);


--
-- TOC entry 3422 (class 1259 OID 241336)
-- Dependencies: 1919
-- Name: mmajetek_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idprimucet_index ON mmajetek USING btree (idprimucet);


--
-- TOC entry 3423 (class 1259 OID 241337)
-- Dependencies: 1919
-- Name: mmajetek_idprotiucetzar_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idprotiucetzar_index ON mmajetek USING btree (idprotiucetzar);


--
-- TOC entry 3424 (class 1259 OID 241326)
-- Dependencies: 1919
-- Name: mmajetek_idsazby_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idsazby_index ON mmajetek USING btree (idsazby);


--
-- TOC entry 3425 (class 1259 OID 241332)
-- Dependencies: 1919
-- Name: mmajetek_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idstred_index ON mmajetek USING btree (idstred);


--
-- TOC entry 3426 (class 1259 OID 241330)
-- Dependencies: 1919
-- Name: mmajetek_idtypmaj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idtypmaj_index ON mmajetek USING btree (idtypmaj);


--
-- TOC entry 3427 (class 1259 OID 241327)
-- Dependencies: 1919
-- Name: mmajetek_idumismist_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idumismist_index ON mmajetek USING btree (idumismist);


--
-- TOC entry 3428 (class 1259 OID 241329)
-- Dependencies: 1919
-- Name: mmajetek_idumisobj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idumisobj_index ON mmajetek USING btree (idumisobj);


--
-- TOC entry 3429 (class 1259 OID 241328)
-- Dependencies: 1919
-- Name: mmajetek_idumissekce_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idumissekce_index ON mmajetek USING btree (idumissekce);


--
-- TOC entry 3430 (class 1259 OID 241331)
-- Dependencies: 1919
-- Name: mmajetek_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mmajetek_idzakazky_index ON mmajetek USING btree (idzakazky);

CREATE INDEX mmajetek_iduziv_index ON mmajetek USING btree (iduziv);


--
-- TOC entry 3441 (class 1259 OID 241443)
-- Dependencies: 1923
-- Name: msplatkal_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_datvyst_index ON msplatkal USING btree (datvyst);


--
-- TOC entry 3442 (class 1259 OID 241345)
-- Dependencies: 1923
-- Name: msplatkal_idclendph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idclendph_index ON msplatkal USING btree (idclendph);


--
-- TOC entry 3443 (class 1259 OID 241348)
-- Dependencies: 1923
-- Name: msplatkal_iddoklfak_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_iddoklfak_index ON msplatkal USING btree (iddoklfak);


--
-- TOC entry 3444 (class 1259 OID 241344)
-- Dependencies: 1923
-- Name: msplatkal_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_iddphdalucet_index ON msplatkal USING btree (iddphdalucet);


--
-- TOC entry 3445 (class 1259 OID 241343)
-- Dependencies: 1923
-- Name: msplatkal_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_iddphmducet_index ON msplatkal USING btree (iddphmducet);


--
-- TOC entry 3446 (class 1259 OID 241340)
-- Dependencies: 1923
-- Name: msplatkal_idleasing_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idleasing_index ON msplatkal USING btree (idleasing);


--
-- TOC entry 3447 (class 1259 OID 241349)
-- Dependencies: 1923
-- Name: msplatkal_idstatdph_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idstatdph_index ON msplatkal USING btree (idstatdph);


--
-- TOC entry 3448 (class 1259 OID 241346)
-- Dependencies: 1923
-- Name: msplatkal_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idstred_index ON msplatkal USING btree (idstred);


--
-- TOC entry 3449 (class 1259 OID 241347)
-- Dependencies: 1923
-- Name: msplatkal_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idzakazky_index ON msplatkal USING btree (idzakazky);


--
-- TOC entry 3450 (class 1259 OID 241342)
-- Dependencies: 1923
-- Name: msplatkal_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idzkldalucet_index ON msplatkal USING btree (idzkldalucet);


--
-- TOC entry 3451 (class 1259 OID 241341)
-- Dependencies: 1923
-- Name: msplatkal_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_idzklmducet_index ON msplatkal USING btree (idzklmducet);


--
-- TOC entry 3452 (class 1259 OID 241405)
-- Dependencies: 1923
-- Name: msplatkal_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX msplatkal_kod_index ON msplatkal USING btree (kod);


--
-- TOC entry 3455 (class 1259 OID 241355)
-- Dependencies: 1925
-- Name: mtypleas_idcasucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_idcasucet_index ON mtypleas USING btree (idcasucet);


--
-- TOC entry 3456 (class 1259 OID 241352)
-- Dependencies: 1925
-- Name: mtypleas_iddphsnizucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_iddphsnizucet_index ON mtypleas USING btree (iddphsnizucet);


--
-- TOC entry 3457 (class 1259 OID 241353)
-- Dependencies: 1925
-- Name: mtypleas_iddphzaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_iddphzaklucet_index ON mtypleas USING btree (iddphzaklucet);


--
-- TOC entry 3458 (class 1259 OID 241356)
-- Dependencies: 1925
-- Name: mtypleas_idnaklucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_idnaklucet_index ON mtypleas USING btree (idnaklucet);


--
-- TOC entry 3459 (class 1259 OID 241357)
-- Dependencies: 1925
-- Name: mtypleas_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_idstred_index ON mtypleas USING btree (idstred);


--
-- TOC entry 3460 (class 1259 OID 241351)
-- Dependencies: 1925
-- Name: mtypleas_iducetobdobido_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_iducetobdobido_index ON mtypleas USING btree (iducetobdobido);


--
-- TOC entry 3461 (class 1259 OID 241350)
-- Dependencies: 1925
-- Name: mtypleas_iducetobdobiod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_iducetobdobiod_index ON mtypleas USING btree (iducetobdobiod);


--
-- TOC entry 3462 (class 1259 OID 241358)
-- Dependencies: 1925
-- Name: mtypleas_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_idzakazky_index ON mtypleas USING btree (idzakazky);


--
-- TOC entry 3463 (class 1259 OID 241354)
-- Dependencies: 1925
-- Name: mtypleas_idzavazucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_idzavazucet_index ON mtypleas USING btree (idzavazucet);


--
-- TOC entry 3464 (class 1259 OID 241406)
-- Dependencies: 1925
-- Name: mtypleas_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_kod_index ON mtypleas USING btree (kod);


--
-- TOC entry 3469 (class 1259 OID 242015)
-- Dependencies: 1925
-- Name: mtypleas_typorg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypleas_typorg_index ON mtypleas USING btree (idtyporg);


--
-- TOC entry 3470 (class 1259 OID 241365)
-- Dependencies: 1927
-- Name: mtypmaj_idodpucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idodpucet_index ON mtypmaj USING btree (idodpucet);


--
-- TOC entry 3471 (class 1259 OID 241364)
-- Dependencies: 1927
-- Name: mtypmaj_idopravucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idopravucet_index ON mtypmaj USING btree (idopravucet);


--
-- TOC entry 3472 (class 1259 OID 241362)
-- Dependencies: 1927
-- Name: mtypmaj_idprimucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idprimucet_index ON mtypmaj USING btree (idprimucet);


--
-- TOC entry 3473 (class 1259 OID 241363)
-- Dependencies: 1927
-- Name: mtypmaj_idprotiucetzar_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idprotiucetzar_index ON mtypmaj USING btree (idprotiucetzar);


--
-- TOC entry 3474 (class 1259 OID 241361)
-- Dependencies: 1927
-- Name: mtypmaj_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idstred_index ON mtypmaj USING btree (idstred);


--
-- TOC entry 3475 (class 1259 OID 241360)
-- Dependencies: 1927
-- Name: mtypmaj_iducetobdobido_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_iducetobdobido_index ON mtypmaj USING btree (iducetobdobido);


--
-- TOC entry 3476 (class 1259 OID 241359)
-- Dependencies: 1927
-- Name: mtypmaj_iducetobdobiod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_iducetobdobiod_index ON mtypmaj USING btree (iducetobdobiod);


--
-- TOC entry 3477 (class 1259 OID 241366)
-- Dependencies: 1927
-- Name: mtypmaj_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_idzakazky_index ON mtypmaj USING btree (idzakazky);


--
-- TOC entry 3478 (class 1259 OID 241407)
-- Dependencies: 1927
-- Name: mtypmaj_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_kod_index ON mtypmaj USING btree (kod);


--
-- TOC entry 3483 (class 1259 OID 241984)
-- Dependencies: 1927
-- Name: mtypmaj_typorg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mtypmaj_typorg_index ON mtypmaj USING btree (idtyporg);


--
-- TOC entry 3484 (class 1259 OID 241440)
-- Dependencies: 1929
-- Name: mucetodpisy_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_datvyst_index ON mucetodpisy USING btree (datvyst);


--
-- TOC entry 3485 (class 1259 OID 241367)
-- Dependencies: 1929
-- Name: mucetodpisy_idmajetku_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_idmajetku_index ON mucetodpisy USING btree (idmajetku);


--
-- TOC entry 3486 (class 1259 OID 241370)
-- Dependencies: 1929
-- Name: mucetodpisy_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_idstred_index ON mucetodpisy USING btree (idstred);


--
-- TOC entry 3487 (class 1259 OID 241371)
-- Dependencies: 1929
-- Name: mucetodpisy_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_idzakazky_index ON mucetodpisy USING btree (idzakazky);


--
-- TOC entry 3488 (class 1259 OID 241369)
-- Dependencies: 1929
-- Name: mucetodpisy_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_idzkldalucet_index ON mucetodpisy USING btree (idzkldalucet);


--
-- TOC entry 3489 (class 1259 OID 241368)
-- Dependencies: 1929
-- Name: mucetodpisy_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_idzklmducet_index ON mucetodpisy USING btree (idzklmducet);


--
-- TOC entry 3490 (class 1259 OID 241408)
-- Dependencies: 1929
-- Name: mucetodpisy_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mucetodpisy_kod_index ON mucetodpisy USING btree (kod);


--
-- TOC entry 3493 (class 1259 OID 241442)
-- Dependencies: 1931
-- Name: mudalosti_datvyst_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_datvyst_index ON mudalosti USING btree (datvyst);


--
-- TOC entry 3494 (class 1259 OID 241378)
-- Dependencies: 1931
-- Name: mudalosti_iddphdalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_iddphdalucet_index ON mudalosti USING btree (iddphdalucet);


--
-- TOC entry 3495 (class 1259 OID 241374)
-- Dependencies: 1931
-- Name: mudalosti_iddphmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_iddphmducet_index ON mudalosti USING btree (iddphmducet);


--
-- TOC entry 3496 (class 1259 OID 241372)
-- Dependencies: 1931
-- Name: mudalosti_idmajetku_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_idmajetku_index ON mudalosti USING btree (idmajetku);


--
-- TOC entry 3497 (class 1259 OID 241373)
-- Dependencies: 1931
-- Name: mudalosti_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_idstred_index ON mudalosti USING btree (idstred);


--
-- TOC entry 3498 (class 1259 OID 241375)
-- Dependencies: 1931
-- Name: mudalosti_idzakazky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_idzakazky_index ON mudalosti USING btree (idzakazky);


--
-- TOC entry 3499 (class 1259 OID 241377)
-- Dependencies: 1931
-- Name: mudalosti_idzkldalucet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_idzkldalucet_index ON mudalosti USING btree (idzkldalucet);


--
-- TOC entry 3500 (class 1259 OID 241376)
-- Dependencies: 1931
-- Name: mudalosti_idzklmducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_idzklmducet_index ON mudalosti USING btree (idzklmducet);


--
-- TOC entry 3501 (class 1259 OID 241409)
-- Dependencies: 1931
-- Name: mudalosti_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mudalosti_kod_index ON mudalosti USING btree (kod);


--
-- TOC entry 3509 (class 1259 OID 241380)
-- Dependencies: 1935
-- Name: mzapujcky_idleasing_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mzapujcky_idleasing_index ON mzapujcky USING btree (idleasing);


--
-- TOC entry 3510 (class 1259 OID 241379)
-- Dependencies: 1935
-- Name: mzapujcky_idmajetku_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mzapujcky_idmajetku_index ON mzapujcky USING btree (idmajetku);


--
-- TOC entry 3511 (class 1259 OID 241381)
-- Dependencies: 1935
-- Name: mzapujcky_idosoby_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mzapujcky_idosoby_index ON mzapujcky USING btree (idosoby);


--
-- TOC entry 3512 (class 1259 OID 241382)
-- Dependencies: 1935
-- Name: mzapujcky_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX mzapujcky_idstatu_index ON mzapujcky USING btree (idstatu);


--
-- TOC entry 3517 (class 1259 OID 241271)
-- Dependencies: 1939
-- Name: nnastav_idfastatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idfastatu_index ON nnastav USING btree (idfastatu);


--
-- TOC entry 3519 (class 1259 OID 241258)
-- Dependencies: 1939
-- Name: nnastav_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idmeny_index ON nnastav USING btree (idmeny);


--
-- TOC entry 3520 (class 1259 OID 241270)
-- Dependencies: 1939
-- Name: nnastav_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idstatu_index ON nnastav USING btree (idstatu);


--
-- TOC entry 3521 (class 1259 OID 241256)
-- Dependencies: 1939
-- Name: nnastav_idstatuleg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idstatuleg_index ON nnastav USING btree (idstatuleg);


--
-- TOC entry 3522 (class 1259 OID 241268)
-- Dependencies: 1939
-- Name: nnastav_idtdeppok_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdeppok_index ON nnastav USING btree (idtdeppok);


--
-- TOC entry 3523 (class 1259 OID 241269)
-- Dependencies: 1939
-- Name: nnastav_idtdepskl_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdepskl_index ON nnastav USING btree (idtdepskl);


--
-- TOC entry 3524 (class 1259 OID 241263)
-- Dependencies: 1939
-- Name: nnastav_idtdfapzdd_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdfapzdd_index ON nnastav USING btree (idtdfapzdd);


--
-- TOC entry 3525 (class 1259 OID 241262)
-- Dependencies: 1939
-- Name: nnastav_idtdfavzdd_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdfavzdd_index ON nnastav USING btree (idtdfavzdd);


--
-- TOC entry 3526 (class 1259 OID 241264)
-- Dependencies: 1939
-- Name: nnastav_idtdkurzroznaklad_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdkurzroznaklad_index ON nnastav USING btree (idtdkurzroznaklad);


--
-- TOC entry 3527 (class 1259 OID 241265)
-- Dependencies: 1939
-- Name: nnastav_idtdkurzrozvynos_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdkurzrozvynos_index ON nnastav USING btree (idtdkurzrozvynos);


--
-- TOC entry 3528 (class 1259 OID 241504)
-- Dependencies: 1939
-- Name: nnastav_idtdobfap_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobfap_index ON nnastav USING btree (idtdobfap);


--
-- TOC entry 3529 (class 1259 OID 241259)
-- Dependencies: 1939
-- Name: nnastav_idtdobfav_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobfav_index ON nnastav USING btree (idtdobfav);


--
-- TOC entry 3530 (class 1259 OID 241503)
-- Dependencies: 1939
-- Name: nnastav_idtdobfavzal_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobfavzal_index ON nnastav USING btree (idtdobfavzal);


--
-- TOC entry 3531 (class 1259 OID 241510)
-- Dependencies: 1939
-- Name: nnastav_idtdobnap_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobnap_index ON nnastav USING btree (idtdobnap);


--
-- TOC entry 3532 (class 1259 OID 241507)
-- Dependencies: 1939
-- Name: nnastav_idtdobnav_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobnav_index ON nnastav USING btree (idtdobnav);


--
-- TOC entry 3533 (class 1259 OID 241508)
-- Dependencies: 1939
-- Name: nnastav_idtdobobp_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobobp_index ON nnastav USING btree (idtdobobp);

CREATE INDEX nnastav_idtdobpEdi_index ON nnastav USING btree (idtdobobpEdi);

--
-- TOC entry 3534 (class 1259 OID 241511)
-- Dependencies: 1939
-- Name: nnastav_idtdobobv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobobv_index ON nnastav USING btree (idtdobobv);


--
-- TOC entry 3535 (class 1259 OID 241509)
-- Dependencies: 1939
-- Name: nnastav_idtdobppv_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobppv_index ON nnastav USING btree (idtdobppv);


--
-- TOC entry 3536 (class 1259 OID 241505)
-- Dependencies: 1939
-- Name: nnastav_idtdobsklpri_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobsklpri_index ON nnastav USING btree (idtdobsklpri);


--
-- TOC entry 3537 (class 1259 OID 241506)
-- Dependencies: 1939
-- Name: nnastav_idtdobsklvyd_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdobsklvyd_index ON nnastav USING btree (idtdobsklvyd);


--
-- TOC entry 3538 (class 1259 OID 241266)
-- Dependencies: 1939
-- Name: nnastav_idtdzbyteknaklad_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdzbyteknaklad_index ON nnastav USING btree (idtdzbyteknaklad);


--
-- TOC entry 3539 (class 1259 OID 241267)
-- Dependencies: 1939
-- Name: nnastav_idtdzbytekvynos_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtdzbytekvynos_index ON nnastav USING btree (idtdzbytekvynos);


CREATE INDEX nnastav_idtdpreplphl_index ON nnastav USING btree (idtdpreplphl);
CREATE INDEX nnastav_idtdpreplzav_index ON nnastav USING btree (idtdpreplzav);


--
-- TOC entry 3540 (class 1259 OID 241257)
-- Dependencies: 1939
-- Name: nnastav_idtyporg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_idtyporg_index ON nnastav USING btree (idtyporg);


--
-- TOC entry 3541 (class 1259 OID 242233)
-- Dependencies: 1939
-- Name: nnastav_menadual_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_menadual_index ON nnastav USING btree (idmenydual);


--
-- TOC entry 3544 (class 1259 OID 241432)
-- Dependencies: 1939
-- Name: nnastav_platioddata_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nnastav_platioddata_index ON nnastav USING btree (platioddata);


--
-- TOC entry 3550 (class 1259 OID 241433)
-- Dependencies: 1941
-- Name: nucetobdobi_platioddata_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX nucetobdobi_platioddata_index ON nucetobdobi USING btree (platioddata);


--
-- TOC entry 3551 (class 1259 OID 241275)
-- Dependencies: 1943
-- Name: skarty_idcenik_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX skarty_idcenik_index ON skarty USING btree (idcenik);


--
-- TOC entry 3555 (class 1259 OID 241274)
-- Dependencies: 1943
-- Name: skarty_iducetobdobi_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX skarty_iducetobdobi_index ON skarty USING btree (iducetobdobi);


--
-- TOC entry 3558 (class 1259 OID 241277)
-- Dependencies: 1945
-- Name: uclendph_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uclendph_idstatu_index ON uclendph USING btree (idstatu);


--
-- TOC entry 3559 (class 1259 OID 241412)
-- Dependencies: 1945
-- Name: uclendph_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uclendph_kod_index ON uclendph USING btree (kod);


--
-- TOC entry 3564 (class 1259 OID 241278)
-- Dependencies: 1947
-- Name: ukurzy_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ukurzy_idmeny_index ON ukurzy USING btree (idmeny);


--
-- TOC entry 3569 (class 1259 OID 241434)
-- Dependencies: 1947
-- Name: ukurzy_platioddata_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ukurzy_platioddata_index ON ukurzy USING btree (platioddata);

--
-- TOC entry 3575 (class 1259 OID 241279)
-- Dependencies: 1951
-- Name: uobraty_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uobraty_idmeny_index ON uobraty USING btree (idmeny);


--
-- TOC entry 3576 (class 1259 OID 241281)
-- Dependencies: 1951
-- Name: uobraty_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uobraty_idstred_index ON uobraty USING btree (idstred);


--
-- TOC entry 3577 (class 1259 OID 241280)
-- Dependencies: 1951
-- Name: uobraty_iducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uobraty_iducet_index ON uobraty USING btree (iducet);


--
-- TOC entry 3578 (class 1259 OID 241282)
-- Dependencies: 1951
-- Name: uobraty_iducetobdobi_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uobraty_iducetobdobi_index ON uobraty USING btree (iducetobdobi);


--
-- TOC entry 3579 (class 1259 OID 241421)
-- Dependencies: 1951 1951 1951 1951 1951
-- Name: uobraty_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uobraty_index ON uobraty USING btree (iducet, rok, obdobi, idstred, idmeny);


--
-- TOC entry 3582 (class 1259 OID 241273)
-- Dependencies: 1953
-- Name: usazbydph_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usazbydph_idstatu_index ON usazbydph USING btree (idstatu);


--
-- TOC entry 3585 (class 1259 OID 241431)
-- Dependencies: 1953
-- Name: usazbydph_platioddata_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usazbydph_platioddata_index ON usazbydph USING btree (platioddata);


--
-- TOC entry 3586 (class 1259 OID 241290)
-- Dependencies: 1955
-- Name: usesradky_idsestavy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesradky_idsestavy_index ON usesradky USING btree (idsestavy);


--
-- TOC entry 3589 (class 1259 OID 241291)
-- Dependencies: 1957
-- Name: usesrozpaduce_idsesradky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesrozpaduce_idsesradky_index ON usesrozpaduce USING btree (idsesradky);


--
-- TOC entry 3590 (class 1259 OID 241292)
-- Dependencies: 1957
-- Name: usesrozpaduce_iducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesrozpaduce_iducet_index ON usesrozpaduce USING btree (iducet);


--
-- TOC entry 3593 (class 1259 OID 241297)
-- Dependencies: 1959
-- Name: usesstdpred_idsesradky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesstdpred_idsesradky_index ON usesstdpred USING btree (idsesradky);


--
-- TOC entry 3594 (class 1259 OID 241298)
-- Dependencies: 1959
-- Name: usesstdpred_idstducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesstdpred_idstducet_index ON usesstdpred USING btree (idstducet);


--
-- TOC entry 3597 (class 1259 OID 241299)
-- Dependencies: 1961
-- Name: usessumace_idsesradky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usessumace_idsesradky_index ON usessumace USING btree (idsesradky);


--
-- TOC entry 3598 (class 1259 OID 241300)
-- Dependencies: 1961
-- Name: usessumace_idsesradkysum_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usessumace_idsesradkysum_index ON usessumace USING btree (idsesradkysum);


--
-- TOC entry 3601 (class 1259 OID 241294)
-- Dependencies: 1963
-- Name: usestavy_idradcil_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usestavy_idradcil_index ON usestavy USING btree (idradcil);


--
-- TOC entry 3602 (class 1259 OID 241296)
-- Dependencies: 1963
-- Name: usestavy_idradzdroj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usestavy_idradzdroj_index ON usestavy USING btree (idradzdroj);


--
-- TOC entry 3603 (class 1259 OID 241295)
-- Dependencies: 1963
-- Name: usestavy_idseszdroj_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usestavy_idseszdroj_index ON usestavy USING btree (idseszdroj);


--
-- TOC entry 3604 (class 1259 OID 241293)
-- Dependencies: 1963
-- Name: usestavy_idtyporg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usestavy_idtyporg_index ON usestavy USING btree (idtyporg);


--
-- TOC entry 3609 (class 1259 OID 241302)
-- Dependencies: 1965
-- Name: usesuzivpred_idsesradky_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesuzivpred_idsesradky_index ON usesuzivpred USING btree (idsesradky);


--
-- TOC entry 3610 (class 1259 OID 241303)
-- Dependencies: 1965
-- Name: usesuzivpred_iducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX usesuzivpred_iducet_index ON usesuzivpred USING btree (iducet);


--
-- TOC entry 3613 (class 1259 OID 241283)
-- Dependencies: 1967
-- Name: ustducty_idtyporg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ustducty_idtyporg_index ON ustducty USING btree (idtyporg);


--
-- TOC entry 3614 (class 1259 OID 241414)
-- Dependencies: 1967
-- Name: ustducty_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX ustducty_kod_index ON ustducty USING btree (kod);


--
-- TOC entry 3624 (class 1259 OID 241301)
-- Dependencies: 1971
-- Name: utyporg_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX utyporg_idstatu_index ON utyporg USING btree (idstatu);


--
-- TOC entry 3629 (class 1259 OID 241286)
-- Dependencies: 1973
-- Name: uucty_idmeny_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_idmeny_index ON uucty USING btree (idmeny);


--
-- TOC entry 3630 (class 1259 OID 241287)
-- Dependencies: 1973
-- Name: uucty_idstducet_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_idstducet_index ON uucty USING btree (idstducet);


--
-- TOC entry 3631 (class 1259 OID 240986)
-- Dependencies: 1973
-- Name: uucty_idtyporg_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_idtyporg_index ON uucty USING btree (idtyporg);


--
-- TOC entry 3632 (class 1259 OID 241285)
-- Dependencies: 1973
-- Name: uucty_iducetobdobido_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_iducetobdobido_index ON uucty USING btree (iducetobdobido);


--
-- TOC entry 3633 (class 1259 OID 241284)
-- Dependencies: 1973
-- Name: uucty_iducetobdobiod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_iducetobdobiod_index ON uucty USING btree (iducetobdobiod);


--
-- TOC entry 3634 (class 1259 OID 241416)
-- Dependencies: 1973
-- Name: uucty_kod_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uucty_kod_index ON uucty USING btree (kod);


--
-- TOC entry 3640 (class 1259 OID 241288)
-- Dependencies: 1975
-- Name: uzakazky_idfirmy_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uzakazky_idfirmy_index ON uzakazky USING btree (idfirmy);


--
-- TOC entry 3641 (class 1259 OID 241289)
-- Dependencies: 1975
-- Name: uzakazky_idstred_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX uzakazky_idstred_index ON uzakazky USING btree (idstred);


--
-- TOC entry 3669 (class 1259 OID 241425)
-- Dependencies: 1988
-- Name: wlokcis_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX wlokcis_index ON wlokcis USING btree (ciselnik);


--
-- TOC entry 3683 (class 1259 OID 241304)
-- Dependencies: 1994
-- Name: wuzivatel_idstatu_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX wuzivatel_idstatu_index ON wuzivatel USING btree (idstatu);


--
-- TOC entry 3689 (class 1259 OID 241435)
-- Dependencies: 1994 1994
-- Name: wuzivatel_prijmeni_jmeno_index; Type: INDEX; Schema: public; Owner: %firmaRole%; Tablespace: 
--

CREATE INDEX wuzivatel_prijmeni_jmeno_index ON wuzivatel USING btree (prijmeni, jmeno);


CREATE UNIQUE INDEX wuzivatel_dbusername_index ON wuzivatel USING btree (dbusername);

--------------------------------------------------------------------------------
--Bug 13565 – [WinStrom] Sprava osobních certifikátu
--------------------------------------------------------------------------------

CREATE INDEX woscert_iduzivatel_index ON woscert USING btree (iduzivatel);
CREATE INDEX woscertcipher_idcert_index ON woscertcipher USING btree (idoscert);
CREATE INDEX wadrcert_idadresar_index ON wadrcert USING btree (idadresar);
CREATE INDEX wadrcertcipher_idadrcert_index ON wadrcertcipher USING btree (idadrcert);

--------------------------------------------------------------------------------

--
-- TOC entry 4186 (class 2620 OID 241448)
-- Dependencies: 24 1869
-- Name: ddoklfakdelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakdelete
    BEFORE DELETE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelete();


--
-- TOC entry 4188 (class 2620 OID 241939)
-- Dependencies: 1869 82
-- Name: ddoklfakdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakdeleteobchvazba
    BEFORE DELETE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldeleteobchvazba();


--
-- TOC entry 4181 (class 2620 OID 239096)
-- Dependencies: 1869 22
-- Name: ddoklfakdelraddiru; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakdelraddiru
    BEFORE INSERT OR UPDATE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelraddiru();


--
-- TOC entry 4182 (class 2620 OID 239097)
-- Dependencies: 1869 23
-- Name: ddoklfakinsdelpreceneni; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakinsdelpreceneni
    BEFORE INSERT OR DELETE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklfakinsdelpreceneni();


--
-- TOC entry 4183 (class 2620 OID 239098)
-- Dependencies: 1869 25
-- Name: ddoklfakupdatepreceneni; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakupdatepreceneni
    BEFORE UPDATE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklfakupdatepreceneni();


--
-- TOC entry 4184 (class 2620 OID 239099)
-- Dependencies: 26 1869
-- Name: ddoklfakupdateucty; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakupdateucty
    AFTER UPDATE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklfakupdateucty();


--
-- TOC entry 4187 (class 2620 OID 241915)
-- Dependencies: 90 1869
-- Name: ddoklfakupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklfakupdatezauctovano
    AFTER INSERT OR UPDATE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklfakupdatezauctovano();


--
-- TOC entry 4192 (class 2620 OID 241449)
-- Dependencies: 24 1871
-- Name: ddoklintdelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklintdelete
    BEFORE DELETE ON ddoklint
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelete();


--
-- TOC entry 4189 (class 2620 OID 239101)
-- Dependencies: 22 1871
-- Name: ddoklintdelraddiru; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklintdelraddiru
    BEFORE INSERT OR UPDATE ON ddoklint
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelraddiru();


--
-- TOC entry 4190 (class 2620 OID 239102)
-- Dependencies: 27 1871
-- Name: ddoklintupdateucty; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklintupdateucty
    AFTER UPDATE ON ddoklint
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklintupdateucty();


--
-- TOC entry 4193 (class 2620 OID 241917)
-- Dependencies: 1871 91
-- Name: ddoklintupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklintupdatezauctovano
    AFTER INSERT OR UPDATE ON ddoklint
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklintupdatezauctovano();


--
-- TOC entry 4241 (class 2620 OID 241901)
-- Dependencies: 24 2000
-- Name: ddoklobchdelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklobchdelete
    BEFORE DELETE ON ddoklobch
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelete();


--
-- TOC entry 4245 (class 2620 OID 241938)
-- Dependencies: 82 2000
-- Name: ddoklobchdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklobchdeleteobchvazba
    BEFORE DELETE ON ddoklobch
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldeleteobchvazba();


--
-- TOC entry 4242 (class 2620 OID 241902)
-- Dependencies: 22 2000
-- Name: ddoklobchdelraddiru; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklobchdelraddiru
    BEFORE INSERT OR UPDATE ON ddoklobch
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelraddiru();


--
-- TOC entry 4197 (class 2620 OID 241450)
-- Dependencies: 24 1873
-- Name: ddoklskladdelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklskladdelete
    BEFORE DELETE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelete();


--
-- TOC entry 4199 (class 2620 OID 241940)
-- Dependencies: 82 1873
-- Name: ddoklskladdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklskladdeleteobchvazba
    BEFORE DELETE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldeleteobchvazba();


--
-- TOC entry 4194 (class 2620 OID 239104)
-- Dependencies: 22 1873
-- Name: ddoklskladdelraddiru; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklskladdelraddiru
    BEFORE INSERT OR UPDATE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE ddokldelraddiru();


--
-- TOC entry 4195 (class 2620 OID 239105)
-- Dependencies: 1873 28
-- Name: ddoklskladupdateucty; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklskladupdateucty
    AFTER UPDATE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklskladupdateucty();


--
-- TOC entry 4198 (class 2620 OID 241919)
-- Dependencies: 92 1873
-- Name: ddoklskladupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER ddoklskladupdatezauctovano
    AFTER INSERT OR UPDATE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE ddoklskladupdatezauctovano();


--
-- TOC entry 4200 (class 2620 OID 239106)
-- Dependencies: 1879 89
-- Name: dpoldokldeleteucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldokldeleteucto
    BEFORE DELETE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteucto();


--
-- TOC entry 4208 (class 2620 OID 239107)
-- Dependencies: 89 1881
-- Name: dpoldokldeleteucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldokldeleteucto
    BEFORE DELETE ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteucto();


--
-- TOC entry 4213 (class 2620 OID 239108)
-- Dependencies: 89 1885
-- Name: dpoldokldeleteucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldokldeleteucto
    BEFORE DELETE ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteucto();


--
-- TOC entry 4201 (class 2620 OID 239109)
-- Dependencies: 1879 87
-- Name: dpoldoklinsertucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklinsertucto
    BEFORE INSERT ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklinsertucto();


--
-- TOC entry 4209 (class 2620 OID 239110)
-- Dependencies: 1881 87
-- Name: dpoldoklinsertucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklinsertucto
    BEFORE INSERT ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklinsertucto();


--
-- TOC entry 4214 (class 2620 OID 239111)
-- Dependencies: 1885 87
-- Name: dpoldoklinsertucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklinsertucto
    BEFORE INSERT ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklinsertucto();


--
-- TOC entry 4202 (class 2620 OID 239112)
-- Dependencies: 88 1879
-- Name: dpoldoklupdateucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();


--
-- TOC entry 4210 (class 2620 OID 239113)
-- Dependencies: 88 1881
-- Name: dpoldoklupdateucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();


--
-- TOC entry 4215 (class 2620 OID 239114)
-- Dependencies: 88 1885
-- Name: dpoldoklupdateucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();


--
-- TOC entry 4207 (class 2620 OID 241943)
-- Dependencies: 1879 83
-- Name: dpolfakdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolfakdeleteobchvazba
    BEFORE DELETE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteobchvazba();


--
-- TOC entry 4203 (class 2620 OID 239115)
-- Dependencies: 1879 33
-- Name: dpolfakdeletevazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolfakdeletevazba
    BEFORE DELETE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpolfakdeletevazba();


--
-- TOC entry 4204 (class 2620 OID 239116)
-- Dependencies: 34 1879
-- Name: dpolfakupdateucty; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolfakupdateucty
    AFTER UPDATE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpolfakupdateucty();


--
-- TOC entry 4206 (class 2620 OID 241921)
-- Dependencies: 74 1879
-- Name: dpolfakupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolfakupdatezauctovano
    AFTER INSERT OR UPDATE OR DELETE
    ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpolfakupdatezauctovano();


--
-- TOC entry 4212 (class 2620 OID 241923)
-- Dependencies: 1881 75
-- Name: dpolintupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolintupdatezauctovano
    AFTER INSERT OR UPDATE OR DELETE
    ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dpolintupdatezauctovano();


--
-- TOC entry 4248 (class 2620 OID 241942)
-- Dependencies: 2001 83
-- Name: dpolobchdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolobchdeleteobchvazba
    BEFORE DELETE ON dpolobch
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteobchvazba();


--
-- TOC entry 4222 (class 2620 OID 241944)
-- Dependencies: 1885 83
-- Name: dpolskladdeleteobchvazba; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolskladdeleteobchvazba
    BEFORE DELETE ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldokldeleteobchvazba();


--
-- TOC entry 4216 (class 2620 OID 239120)
-- Dependencies: 38 1885
-- Name: dpolskladupdateucty; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolskladupdateucty
    AFTER UPDATE ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpolskladupdateucty();


--
-- TOC entry 4218 (class 2620 OID 241925)
-- Dependencies: 76 1885
-- Name: dpolskladupdatezauctovano; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dpolskladupdatezauctovano
    AFTER INSERT OR UPDATE OR DELETE
    ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpolskladupdatezauctovano();


--
-- TOC entry 4223 (class 2620 OID 239121)
-- Dependencies: 1897 40
-- Name: dvazebtabinsdelpreceneni; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dvazebtabinsdelpreceneni
    BEFORE INSERT OR DELETE ON dvazebtab
    FOR EACH ROW
    EXECUTE PROCEDURE dvazebtabinsdelpreceneni();


--
-- TOC entry 4185 (class 2620 OID 239122)
-- Dependencies: 45 1869
-- Name: dzdoklfakcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzdoklfakcheckvazby
    BEFORE DELETE ON ddoklfak
    FOR EACH ROW
    EXECUTE PROCEDURE dzdoklcheckvazby();


--
-- TOC entry 4191 (class 2620 OID 239123)
-- Dependencies: 1871 45
-- Name: dzdoklintcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzdoklintcheckvazby
    BEFORE DELETE ON ddoklint
    FOR EACH ROW
    EXECUTE PROCEDURE dzdoklcheckvazby();


--
-- TOC entry 4243 (class 2620 OID 241903)
-- Dependencies: 2000 45
-- Name: dzdoklobchcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzdoklobchcheckvazby
    BEFORE DELETE ON ddoklobch
    FOR EACH ROW
    EXECUTE PROCEDURE dzdoklcheckvazby();


--
-- TOC entry 4196 (class 2620 OID 239124)
-- Dependencies: 1873 45
-- Name: dzdoklskladcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzdoklskladcheckvazby
    BEFORE DELETE ON ddoklsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dzdoklcheckvazby();


--
-- TOC entry 4205 (class 2620 OID 239125)
-- Dependencies: 1879 46
-- Name: dzpolfakcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzpolfakcheckvazby
    BEFORE DELETE ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dzpoldoklcheckvazby();


--
-- TOC entry 4211 (class 2620 OID 239126)
-- Dependencies: 1881 46
-- Name: dzpolintcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzpolintcheckvazby
    BEFORE DELETE ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dzpoldoklcheckvazby();


--
-- TOC entry 4246 (class 2620 OID 241904)
-- Dependencies: 46 2001
-- Name: dzpolobchcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzpolobchcheckvazby
    BEFORE DELETE ON dpolobch
    FOR EACH ROW
    EXECUTE PROCEDURE dzpoldoklcheckvazby();


--
-- TOC entry 4217 (class 2620 OID 239127)
-- Dependencies: 46 1885
-- Name: dzpolskladcheckvazby; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER dzpolskladcheckvazby
    BEFORE DELETE ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dzpoldoklcheckvazby();


--
-- TOC entry 4224 (class 2620 OID 239128)
-- Dependencies: 1913 51
-- Name: mdannakldelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mdannakldelete
    BEFORE DELETE ON mdannakl
    FOR EACH ROW
    EXECUTE PROCEDURE mdannakldelete();


--
-- TOC entry 4225 (class 2620 OID 239129)
-- Dependencies: 52 1913
-- Name: mdannaklinsert; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mdannaklinsert
    BEFORE INSERT ON mdannakl
    FOR EACH ROW
    EXECUTE PROCEDURE mdannaklinsert();


--
-- TOC entry 4226 (class 2620 OID 239130)
-- Dependencies: 1913 53
-- Name: mdannaklupdate; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mdannaklupdate
    BEFORE UPDATE ON mdannakl
    FOR EACH ROW
    EXECUTE PROCEDURE mdannaklupdate();


--
-- TOC entry 4227 (class 2620 OID 239131)
-- Dependencies: 54 1915
-- Name: mmajetekdeleteucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekdeleteucto
    BEFORE DELETE ON mdanodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekdeleteucto();


--
-- TOC entry 4233 (class 2620 OID 239132)
-- Dependencies: 1929 54
-- Name: mmajetekdeleteucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekdeleteucto
    BEFORE DELETE ON mucetodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekdeleteucto();


--
-- TOC entry 4228 (class 2620 OID 239134)
-- Dependencies: 1915 55
-- Name: mmajetekinsertucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekinsertucto
    BEFORE INSERT ON mdanodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekinsertucto();


--
-- TOC entry 4234 (class 2620 OID 239135)
-- Dependencies: 55 1929
-- Name: mmajetekinsertucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekinsertucto
    BEFORE INSERT ON mucetodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekinsertucto();


--
-- TOC entry 4229 (class 2620 OID 239137)
-- Dependencies: 56 1915
-- Name: mmajetekupdateucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekupdateucto
    BEFORE UPDATE ON mdanodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekupdateucto();


--
-- TOC entry 4235 (class 2620 OID 239138)
-- Dependencies: 1929 56
-- Name: mmajetekupdateucto; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER mmajetekupdateucto
    BEFORE UPDATE ON mucetodpisy
    FOR EACH ROW
    EXECUTE PROCEDURE mmajetekupdateucto();


--
-- TOC entry 4230 (class 2620 OID 239140)
-- Dependencies: 1923 57
-- Name: msplatkaldelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER msplatkaldelete
    BEFORE DELETE ON msplatkal
    FOR EACH ROW
    EXECUTE PROCEDURE msplatkaldelete();


--
-- TOC entry 4231 (class 2620 OID 239141)
-- Dependencies: 1923 58
-- Name: msplatkalinsert; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER msplatkalinsert
    BEFORE INSERT ON msplatkal
    FOR EACH ROW
    EXECUTE PROCEDURE msplatkalinsert();


--
-- TOC entry 4232 (class 2620 OID 239142)
-- Dependencies: 59 1923
-- Name: msplatkalupdate; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER msplatkalupdate
    BEFORE UPDATE ON msplatkal
    FOR EACH ROW
    EXECUTE PROCEDURE msplatkalupdate();


--
-- TOC entry 4239 (class 2620 OID 239143)
-- Dependencies: 1951 64
-- Name: uobratyinsertupdate; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER uobratyinsertupdate
    BEFORE INSERT OR UPDATE ON uobraty
    FOR EACH ROW
    EXECUTE PROCEDURE uobratyinsertupdate();


--
-- TOC entry 4240 (class 2620 OID 239144)
-- Dependencies: 65 1973
-- Name: uuctydelete; Type: TRIGGER; Schema: public; Owner: %firmaRole%
--

CREATE TRIGGER uuctydelete
    BEFORE DELETE ON uucty
    FOR EACH ROW
    EXECUTE PROCEDURE uuctydelete();



ALTER TABLE public.astaty 
add CONSTRAINT aStaty_idmeny FOREIGN KEY (idmeny)
        REFERENCES umeny (idmeny)
        ON UPDATE NO ACTION ON DELETE NO ACTION;
        
ALTER TABLE public.astaty 
add CONSTRAINT aStaty_idfukraj FOREIGN KEY (idfukraj)
        REFERENCES aadresar (idfirmy)
        ON UPDATE NO ACTION ON DELETE NO ACTION;
        
ALTER TABLE public.astaty 
add CONSTRAINT aStaty_idfuuzprac FOREIGN KEY (idfuuzprac)
        REFERENCES aadresar (idfirmy)
        ON UPDATE NO ACTION ON DELETE NO ACTION;
