----------------------------------------------------------------------------------------------------------------
-- Bug 45368 - Změna výše slevy na 2. dítě a na další dítě 
-----------------------------------------------------------------------------------------------------------------

 create or replace function runupgrade()
   returns void as $$
 declare
   stat character varying(10);
 begin
   select a.uuid into stat from nnastav n 
     left join utyporg u on u.idtyporg = n.idtyporg
     left join astaty a on a.idstatu = u.idstatu
   order by coalesce(n.platioddata, '1900-01-01') desc limit 1;
 
   if (stat = 'CZ_CZ') then
         -- hlavička - omezení platnosti staré
        UPDATE pmzdcalchlav SET platido = '2016-04-30' WHERE idmzdcalchlav = 8;
         -- hlavička
        INSERT INTO pmzdcalchlav (idmzdcalchlav, lastupdate, kod, nazev, poznam, popis, show, platiod)
         VALUES (9, '2016-05-12 00:00:00.000', 'ČESKÉ MZDY 2016_5', 'Výpočet mzdy pro rok 2016 od 1.5.', e'vyřazení nulování zdravotky pro zaměstnání malého rozsahu u \nstandardního pracovního poměru - pořadí 50\n2014-01-16 ID zbytečných řádků: 5407,5408,5089 a okolní', e'1-DPP nad 10 000 Kč - sociálka a zdravotka \n2-sleva na poplatníka z 1970 na 2070\n3-sleva na dítě - 1117\n4-sociálka pro 4.', true, '2016-05-01');

         -- inicializace
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, idmzdcalchlav, idmzdslozout)
         VALUES (230, '2016-05-12 00:00:00.000', 'ZDR.DOPL.MIN.ZAKL.', 'Doplatek do minimílního  vyměřovacího základu zdravotního pojištění', true, 0, 'mzdCalcZdroj.osoba', 'zdrPojDoplatRozdel', 'procMzd', 9, 93);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (231, '2016-05-12 00:00:00.000', 'SLEVA NA POPLATNÍKA', 'Sleva na poplatníka (podepsal prohlášení k dani)', true, 1, 'mzdCalcZdroj.osoba', 'slevaPoplat', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 110);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (232, '2016-05-12 00:00:00.000', 'PRAC.PRÁVNÍ  PRŮMĚR ', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 2, 'mzdCalcZdroj.pracPom', 'predHrubPrijem', 'prumNaHodNem', 'mzdCalcPlatnost.vzdy', 9, 172);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (233, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Počáteční stav dovolené ', true, 3, 'mzdCalcZdroj.pracPom', 'dovoleneRocne', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 9, 184);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (234, '2016-05-12 00:00:00.000', 'SLEVA ZTP/P', 'Sleva - Držitel průkaz ZTP/P', true, 4, 'mzdCalcZdroj.osoba', 'prukazZTP', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 113);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (235, '2016-05-12 00:00:00.000', 'ZDR.ZÁKLAD POČÁTEK', 'Základ pro zdravotního pojištění - hodnota základu z předchozího zaměstnání', true, 5, 'mzdCalcZdroj.osoba', 'minuleZdrav', 'zaklMzd', 'mzdCalcPlatnost.prvniMesic', 9, 198);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (236, '2016-05-12 00:00:00.000', 'SOC.ZÁKLAD POČÁTEK', 'Základ pro sociální pojištění - hodnota základu z předchozího zaměstnání', true, 6, 'mzdCalcZdroj.osoba', 'minuleSoc', 'zaklMzd', 'mzdCalcPlatnost.prvniMesic', 9, 196);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (237, '2016-05-12 00:00:00.000', 'SLEVA STUDENT', 'Sleva - Student připravující se na budoucí povolání', true, 7, 'mzdCalcZdroj.osoba', 'student', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 114);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (238, '2016-05-12 00:00:00.000', 'SLEVA IN.DŮCH. 1.2. ', 'Sleva na invalidní důchod 1. a 2. stupně', true, 8, 'mzdCalcZdroj.osoba', 'invalCast', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 111);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (239, '2016-05-12 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro kryply', true, 8, 'mzdCalcZdroj.osoba', 'snizVymZaklZp', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 344);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (240, '2016-05-12 00:00:00.000', 'SLEVA IN.DŮCH.3.', 'Sleva na invalidní důchod 3. stupně', true, 9, 'mzdCalcZdroj.osoba', 'invalPlna', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 112);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (241, '2016-05-12 00:00:00.000', '% PŘÍSP.NA PEN.POJ', '% příspěvku firmy na penzijní pojištění zaměstnance', 'Načtení parametru z nastavení', true, 10, 'mzdCalcZdroj.nastaveni', 'mzdPenzPripProc', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 237);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (242, '2016-05-12 00:00:00.000', 'DOV. ZA DEN ABSENCE', 'Odečet dovolené za neomluvenou absenci', 'Načtení parametru z nastavení', true, 11, 'mzdCalcZdroj.nastaveni', 'mzdDnuDovolAbs', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 9, 236);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (243, '2016-05-12 00:00:00.000', 'DOVOLENÁ NÁROK', 'Nárok na dovolenou v roce', true, 13, 'mzdCalcZdroj.pracPom', 'dovoleneRocne', 'dnyPrac', 'mzdCalcPlatnost.vzdy', 9, 244);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (244, '2016-05-12 00:00:00.000', 'SLEVA NA DÍTĚ', 'Sleva na dítě ', true, 14, 'mzdCalcZdroj.osoba', 'diteOdpoc1;diteOdpoc2;odpocetDeti3', 'castMzd;castkaDen;castkaHod', 'mzdCalcPlatnost.vzdy', 9, 116);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (245, '2016-05-12 00:00:00.000', 'SLEVA NA DÍTĚ ZTP/P', 'Sleva na dítě ZTP/P', true, 14, 'mzdCalcZdroj.osoba', 'odpocetDetiZtp;odpocetDite1Ztp;odpocetDite2Ztp', 'castkaDen;dnySvatek;hodinySvatek', 'mzdCalcPlatnost.vzdy', 9, 251);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, zpracdatumk, idmzdcalchlav, idmzdslozout)
         VALUES (246, '2016-05-12 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'inicializace měsíce počátku - slouží k výpočtu poměrné části dovolené', true, 15, 'mzdCalcZdroj.pracPom', 'zacatek', 'dnyKal', 'mzdCalcPlatnost.zacatekPrvniRok', 'mzdCalcZpracDatum.mesicNaslPoc', 9, 340);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, zpracdatumk, idmzdcalchlav, idmzdslozout)
         VALUES (247, '2016-05-12 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'inicializace měsíce konce - slouží k výpočtu poměrné části dovolené', true, 15, 'mzdCalcZdroj.pracPom', 'konecPomeru', 'dnyKal', 'mzdCalcZpracDatum.mesicPredKon', 9, 341);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (248, '2016-05-12 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Náhráda za svátek', '', true, 16, 'mzdCalcZdroj.pracPom', 'svatkyPrumer', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 21);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (249, '2016-05-12 00:00:00.000', 'SVÁTEK', 'Svátek', '', true, 17, 'mzdCalcZdroj.pracPom', 'svatkyPrumer', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 256);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (250, '2016-05-12 00:00:00.000', 'UPLATNIT.REF.NÁHRADY', 'Uplatnit refundaci mzdy', true, 18, 'mzdCalcZdroj.nastaveni', 'mzdRefundNahrNemoc', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 336);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (251, '2016-05-12 00:00:00.000', 'JE DŮCHODOVÉ SPOŘENÍ', 'Je účastem důchodového spořeníi', true, 19, 'mzdCalcZdroj.osoba', 'ucastnikDuchSpor', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 360);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (252, '2016-05-12 00:00:00.000', 'STAROBNÍ DŮCHOD', 'Starobní důchod', true, 20, 'mzdCalcZdroj.osoba', 'starobniDuch', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 148);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
         VALUES (253, '2016-05-12 00:00:00.000', 'PŘEDČAS.STAR.DŮCHOD', 'Předčasný starobní důchod', true, 21, 'mzdCalcZdroj.osoba', 'starobniDuch', 'procMzd', 'mzdCalcPlatnost.vzdy', 9, 358);
        INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, poznam, show, cisrad, zdrojk, polein, poleout, idmzdcalchlav, idtyppracpom, idmzdslozout)
         VALUES (254, '2016-05-12 00:00:00.000', 'HODINY ROK', 'Suma odpracovaných hodin od začátku roku', '300 hodin smí ročně dělat DPP', true, 22, 'mzdCalcZdroj.ostatni', '300', 'procMzd', 9, 2, 372);

         -- výpočet
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7376, '2016-05-12 00:00:00.000', 'KOEF. PRO MĚS.MZDU ', '----- Připočtení dnů ve svátek', true, 1, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', '', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 1, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7377, '2016-05-12 00:00:00.000', 'KOEF. PRO MĚS.MZDU ', '----- Fond pracovní  doby v aktuálním měsíci', true, 2, 1.0, 1.0, 0.0, 'hodinySvatek;dnySvatek', '', 'hodiny;dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 1, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7378, '2016-05-12 00:00:00.000', 'SVÁTEK', 'Fond pracovní doby', true, 3, 1.0, 0.0, 0.0, 'hodinySvatek;dnySvatek;hodinySvatek;dnySvatek', 'hodiny;dnyPrac;hodinySvatek;dnySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 1, 256);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7379, '2016-05-12 00:00:00.000', 'PŘED NÁSTUPEM (PRAC)', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 4, 1.0, 0.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 227, 287);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7380, '2016-05-12 00:00:00.000', '365', '----- počet dní v roce', 'koeficient pro výpočet zbývající dovolené', true, 5, 0.0, 0.0, 365.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'dnyKal', '', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 245, 245);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7381, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 6, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 287, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7382, '2016-05-12 00:00:00.000', 'PŘED NÁSTUPEM (PRAC)', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 7, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek', 'dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 287, 287);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7383, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 8, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 3, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7384, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 9, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 4, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7385, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK...', true, 10, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 7, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7386, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', 'Volno neplacené - zaměstnavatel hradí 9% zdravotního pojištění ', true, 11, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 370, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7387, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 12, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 12, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7388, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 13, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 14, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7389, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 14, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 150, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7390, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 15, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 151, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7391, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 16, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 13, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7392, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 17, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 15, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7393, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 18, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 5, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7394, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 19, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 6, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7395, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 20, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 152, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7396, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', 'Vojenské cvičení neplacené', true, 21, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 295, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7397, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', 'Ostatní překážky v práci neplacené', true, 22, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 296, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7398, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 23, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 238, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7399, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 24, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 239, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7400, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 25, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 240, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7401, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 26, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 241, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7402, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 27, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 153, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7403, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 28, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 9, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7404, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', 'Školení', true, 29, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 363, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7405, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 30, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 10, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7406, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', true, 31, 1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 11, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7407, '2016-05-12 00:00:00.000', 'SVÁTEK', 'svátek sumovaná z nemoci', 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', true, 32, -1.0, 1.0, 0.0, 'dnySvatek;dnySvatek;hodinySvatek', 'dnySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 343, 256);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7408, '2016-05-12 00:00:00.000', 'SVÁTEK', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK', 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', true, 33, -1.0, 1.0, 0.0, 'dnySvatek;dnySvatek;hodinySvatek', 'dnySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 2, 256);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7409, '2016-05-12 00:00:00.000', '1', 'Prostoj 100%', true, 34, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 240, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7410, '2016-05-12 00:00:00.000', '1', 'Prostoj 80%', true, 35, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 239, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7411, '2016-05-12 00:00:00.000', '1', 'Prostoj 60% nebo částečná nezaměstnanost', true, 36, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 238, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7412, '2016-05-12 00:00:00.000', '1', 'Mimo evidenci neomluveno (pro všechny pracovní poměry) ', true, 37, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 153, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7413, '2016-05-12 00:00:00.000', '1', 'Ostatní překážky v práci neplacené', true, 38, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 296, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7414, '2016-05-12 00:00:00.000', '1', 'Mimo evidenci (pro všechny pracovní poměry) ', true, 39, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 152, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7415, '2016-05-12 00:00:00.000', '1', 'Volno neplacené - zaměstnavatel hradí 9% zdravotního pojištění ', true, 40, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 370, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7416, '2016-05-12 00:00:00.000', '1', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 41, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 10, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7417, '2016-05-12 00:00:00.000', '1', '----- Absence neomluvená  do neodpracované doby (čas)', 'změna 2015-09-15 ', true, 42, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 5, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7418, '2016-05-12 00:00:00.000', '1', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 43, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 11, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7419, '2016-05-12 00:00:00.000', '1', '----- Volno neplacené  do neodpracované doby (čas)', e'doplněno počítání koeficientu pro snížení minim.vym.základu ZP\nzměna 2015-09-15', true, 44, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 7, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7420, '2016-05-12 00:00:00.000', '1', '----- Volno placené  do neodpracované doby (čas)', '[jb] 2013-12-10 pokud nepocitame nahradu za svatek nedavame volno placene do nepritomnosti', true, 45, 1.0, 0.0, 1.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', '1;1;1;procMzd;procMzd', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 6, 21, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7421, '2016-05-12 00:00:00.000', '1', '----- Dovolená do neodpracované doby (čas)', '[jb] 2013-12-10 pokud nepocitame nahradu za svatek nedavame dovolenou do nepritomnosti', true, 46, 1.0, 0.0, 1.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', '1;1;1;procMzd;procMzd', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 2, 21, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7422, '2016-05-12 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', 'Neodpracovaná doba', '', e'Do pomocné proměnné si uložíme dny, které neponižují MVZ pro výpočet ZP.\n2015-10-09', true, 47, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 16, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7423, '2016-05-12 00:00:00.000', '1', '----- Nemoc  do neodpracované doby (čas)', true, 48, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 3, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7424, '2016-05-12 00:00:00.000', '1', '----- Karanténa  do neodpracované doby (čas)', true, 49, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 12, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7425, '2016-05-12 00:00:00.000', '1', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 50, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 13, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7426, '2016-05-12 00:00:00.000', '1', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 51, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 14, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7427, '2016-05-12 00:00:00.000', '1', '----- Nemoc z povolání do neodpracované doby (čas)', true, 52, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 15, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7428, '2016-05-12 00:00:00.000', 'CELKOVÁ NEPŘÍTOMNOST', 'Svátek', '[jb] 2013-12-05 pokud nepocitame nahradu za svatek nedavame svatek do nepritomnosti', true, 53, 1.0, 0.0, 1.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'procMzd;procMzd;procMzd;procMzd;procMzd', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 21, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7429, '2016-05-12 00:00:00.000', 'NEPŘÍTOMNOST - SUM ', '----- Ošetřování člena rodiny  do neodpracované doby (čas)', true, 54, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 4, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7430, '2016-05-12 00:00:00.000', '1', '----- Mateřská dovolená (vstupuje do vyloučených dob v ELDP)', true, 55, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 150, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7431, '2016-05-12 00:00:00.000', '1', 'Vojenské cvičení neplacené', true, 56, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 295, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7432, '2016-05-12 00:00:00.000', '1', '----- Rodičovská dovolená  (nevstupuje do vyloučených dob v ELDP) ', true, 57, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;hodiny;dnySvatek;hodinySvatek;dnyKal', 'dnyPrac;dnyKal;hodiny;dnyPrac;hodiny;prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 151, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7433, '2016-05-12 00:00:00.000', '1', 'Dny před nástupem (měsíci) do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy ', true, 58, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 287, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7434, '2016-05-12 00:00:00.000', '18', 'Životní pojištění', true, 59, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 130, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7435, '2016-05-12 00:00:00.000', 'ODPR.DOBA VYPOČ.', '----- Vypočtená odpracovaná doba = od fondu je odečtena  neodpracovaná doba', e'doplněno odečtení svátku obsažených v nepřítonosti\n', true, 60, -1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 16, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7436, '2016-05-12 00:00:00.000', '2', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 61, 1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodiny;hodinySvatek', 'dnyKal;dnyPrac;dnySvatek;hodiny;castMzd;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 188, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7437, '2016-05-12 00:00:00.000', '2', 'Fond pracovní  doby v aktuálním měsíci', true, 62, 1.0, 0.0, 0.0, 'hodinySvatek;dnySvatek;hodinySvatek;dnySvatek', '', 'hodinySvatek;dnySvatek;hodiny;dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 1, 21);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7438, '2016-05-12 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'svátek sumovaná z nemoci', true, 63, -1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 343, 21);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7439, '2016-05-12 00:00:00.000', '2', '----- Vynulování hodin náhrady za svátek', 'Do pole procMzd si nastavim hodontu - 1 bude náhrada za svátek 0 nebude náhrada', true, 64, 1.0, 0.0, 0.0, 'hodinySvatek;dnySvatek;hodiny;dnyPrac', 'procMzd;procMzd;procMzd;procMzd', 'hodinySvatek;dnySvatek;hodiny;dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 21, 21, 21);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7440, '2016-05-12 00:00:00.000', '2', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 65, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 17);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7441, '2016-05-12 00:00:00.000', '2', '----- Negace pole procmzd (z inicializace je 1 když je náhrada za svátek)', true, 66, 1.0, 0.0, 1.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 9, 256, 256);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7442, '2016-05-12 00:00:00.000', 'SVÁTEK V NEMOCI', '----- nulování hodin svátek', true, 67, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 343, 343);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7443, '2016-05-12 00:00:00.000', '2', '----- nulování hodin svátek', true, 68, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'hodinySvatek', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 256, 256);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7444, '2016-05-12 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 9200', 'dsdddd', true, 69, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 6, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7445, '2016-05-12 00:00:00.000', '2', '----- Přičtení svátku do odpracované doby když za něj není náhrada', '[jb] 2013-12-05 kdyz neni prumerem tak nepripocitame protoze jsme to ani neodecetli', true, 70, 1.0, 0.0, 1.0, 'hodinySvatek', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 21, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7446, '2016-05-12 00:00:00.000', '2', 'svátek sumovaná z nemoci', '[jb] 2013-12-05 kdyz neni prumerem tak nepripocitame protoze jsme to ani neodecetli', 'přidáno 6.10.2011', true, 71, -1.0, 0.0, 1.0, 'procMzd', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 343, 21, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7447, '2016-05-12 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', '----- odpracovaná doba  / fond = koeficient ke krácení měsíční a hodinové mzdy', e'Přičtení kalendářních dnů do pomocné proměnné (už v ní jsou dny, které neponižují MVZ).\n2015-09-23', true, 72, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7448, '2016-05-12 00:00:00.000', '2', '----- odpracovaná doba  / fond = koeficient ke krácení měsíční a hodinové mzdy', true, 73, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 179, 188, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7449, '2016-05-12 00:00:00.000', '2', '----- odpracováno - kal.dny  /  fond - kal.dny = koeficient pro minimální mzdu', '2015-09-23', true, 74, 1.0, 0.0, 0.0, 'prumNaHodNem', 'dnyKal', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 179, 188, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7450, '2016-05-12 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 9900', true, 75, 1.0, 0.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7451, '2016-05-12 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 9900', true, 76, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 2, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7452, '2016-05-12 00:00:00.000', '2', '----- výpočet odpracopvané doby pro dopaltek ZP do 9900', true, 77, 1.0, 1.0, 0.0, 'dnyKal', '', 'prumNaDenNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 6, 188);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7453, '2016-05-12 00:00:00.000', 'CELKOVÁ NEPŘÍTOMNOST', 'Neodpracovaná doba', 'vystup je pomer kolik kalendarnich dni neplati zdravotni ale z pohledu doplatku se bere jako ze ano', 'doplněno počítání koeficientu pro snížení minim.vym.základu ZP', true, 78, 1.0, 0.0, 0.0, 'prumNaDenNem;procMzd', 'dnyKal;dnyKal', 'prumNaDenNem;procMzd', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 16, 188, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7454, '2016-05-12 00:00:00.000', 'CELKOVÁ NEPŘÍTOMNOST', 'Neodpracovaná doba', 'vystup je pomer kolik kalendarnich dni neplati zdravotni ale z pohledu doplatku se bere jako ze ano', 'doplněno počítání koeficientu pro snížení minim.vym.základu ZP  xxx', true, 79, -1.0, 0.0, 1.0, 'procMzd', '', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 16, 16);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7455, '2016-05-12 00:00:00.000', '2', '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', '[jb] 2013-12-05 kdyz neni prumerem tak nepripocitame protoze jsme to ani neodecetli', true, 80, -1.0, 0.0, 1.0, 'hodinySvatek', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 21, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7456, '2016-05-12 00:00:00.000', '2', '----- vrácení pole ODPRACOVÁNO VÝPOČET  do původního stavu', 'přidáno 6.10.2011', true, 81, 1.0, 1.0, 0.0, 'procMzd', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 3, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7457, '2016-05-12 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', 'Odpracovaná doba', true, 82, 0.0, 0.0, 1.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensi', false, 0, false, 9, 179, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7458, '2016-05-12 00:00:00.000', 'ODPRACOVÁNO VÝPOČET', 'Odpracovaná doba', true, 83, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 179, 179, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7459, '2016-05-12 00:00:00.000', '2', 'Odpracovaná doba', true, 84, 1.0, 0.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', '', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 179, 335);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7460, '2016-05-12 00:00:00.000', 'ODPRAC.OD ZAČ.ROKU', 'Odpracovaná doba', true, 85, 1.0, 1.0, 0.0, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', '', 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 335);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7461, '2016-05-12 00:00:00.000', 'PRAC.PRÁVNÍ PRŮMER', '----- Suma základu pro průměrný výdělek za minulé čtvrtletí', '', true, 86, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 9, 90, 182);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7462, '2016-05-12 00:00:00.000', '3', '----- Odpracovaná doba za minulé čtvrtletí', '', true, 87, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 9, 179, 183);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7463, '2016-05-12 00:00:00.000', '3', 'Mzda za práci přesčas', '31.5.2010', true, 88, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 9, 22, 183);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7464, '2016-05-12 00:00:00.000', 'SVÁTEK 4 MM  ', '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!', '[jb] 2013-12-06 po oprave vypoctu svatku neni tahle slozka jiz nutna - slouzila pro scitani predchazejici ctvrtleti a kdyz by tam byla nyni, byli by svatky zapocteny dvakrat', '01.06.2010 nakrmení pracovní složky kvůli tomu abych jí mohl ulovat, když není měsíční mzda', true, 89, 0.0, 0.0, 0.0, 'hodinySvatek', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 256, 334);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7465, '2016-05-12 00:00:00.000', 'SVÁTEK 4 MM  ', 'Hodinová mzda', 'vynulování hoin svátků pro hodinovou mzdu', true, 90, 1.0, 0.0, 0.0, 'procMzd', 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 3, false, 9, 18, 334, 334);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7466, '2016-05-12 00:00:00.000', '3', 'Svátek pro měsíční mzdu do PPP', '01.06.2010', true, 91, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobi', 3, false, 9, 334, 183);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7467, '2016-05-12 00:00:00.000', '3', 'Čtvrtletní suma základu pro průměrný výdělek', 'suma odpracované doby za minulé čtvrtletí', true, 92, 1.0, 0.0, 0.0, 'castMzd', 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 182, 183, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7468, '2016-05-12 00:00:00.000', '3', 'Kontrola a dopočet PPP do 48.10 Kč (mninimální PPP)', '27.12.2010', 'rozdíl mezi vzpočteným průměrem a minimem 48,1', true, 93, 1.0, 0.0, -48.1, 'prumNaHodNem', '', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7469, '2016-05-12 00:00:00.000', '3', 'Oprava pracovněprávního hodinového průměru', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 94, 1.0, 1.0, 0.0, 'castkaHod;castkaHod', '', 'castkaHod;prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 364, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7470, '2016-05-12 00:00:00.000', '3', '----', e'27.12.2010\n16.1.2014 koef2 = 0 - nedopočítáváme minimum do 48,1 ale nechávám jaké je', e'do castka za hodinu si uložim koeficient pro výpočet \n0 ... průměr je větší\n1 ...průměr je menší ', true, 95, 0.0, 0.0, 0.0, 'procMzd', '', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, 9, 172, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7471, '2016-05-12 00:00:00.000', '3', '-----', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 96, 1.0, 0.0, 0.0, 'procMzd', 'castkaDen', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 172, 172, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7472, '2016-05-12 00:00:00.000', '3', '-----', '27.12.2010', 'Vynukuji přebytek nad 48,1 nebo převrátím znaménko', true, 97, 1.0, 1.0, 0.0, 'procMzd', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7473, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 98, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 179, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7474, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 99, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 179, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7475, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 100, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 22, 313);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7476, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 101, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 22, 313);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7477, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 102, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 22, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7478, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 103, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 22, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7479, '2016-05-12 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 104, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 16, 314);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7480, '2016-05-12 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 105, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 16, 314);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7481, '2016-05-12 00:00:00.000', 'ISPV **************', 'Dovolená', true, 106, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 2, 316);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7482, '2016-05-12 00:00:00.000', 'ISPV **************', 'Dovolená', true, 107, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 2, 316);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7483, '2016-05-12 00:00:00.000', 'POMĚR.MĚSÍČNÍ MZDA', 'Měsíční mzda ', true, 108, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 17, 188, 17);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7484, '2016-05-12 00:00:00.000', '3', 'Měsíční mzda  - výpočet částky za hodinu', true, 109, 1.0, 0.0, 0.0, 'zaklMzd', 'hodiny', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 17, 188, 17);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7485, '2016-05-12 00:00:00.000', '4', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 110, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 18);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7486, '2016-05-12 00:00:00.000', '4', 'Hodinová mzda', true, 111, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 18, 179, 18);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7487, '2016-05-12 00:00:00.000', '3', 'Měsíční mzda (plat)', true, 112, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 17, 63);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7488, '2016-05-12 00:00:00.000', '3', '----- Časová (hodinová) mzda do odpracované doby', true, 113, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 18, 63);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7489, '2016-05-12 00:00:00.000', '3', '----- Úkolová mzda  do odpracované doby', true, 114, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 19, 63);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7490, '2016-05-12 00:00:00.000', '3', 'Mzda za práci přesčas', true, 115, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 22, 63);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7491, '2016-05-12 00:00:00.000', 'HODINY ROK', 'Suma odpracovaných hodin v měsíci', true, 116, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 63, 372);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7492, '2016-05-12 00:00:00.000', 'HODINY ROK', 'Suma odpracovaných hodin v měsíci', true, 117, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 63, 372);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7493, '2016-05-12 00:00:00.000', '5', '----- Měsíční odměna', true, 118, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 23, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7494, '2016-05-12 00:00:00.000', 'PRÉMIE %', '----- Prémie % ze základní mzdy', true, 119, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 25, 25, 25);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7495, '2016-05-12 00:00:00.000', 'PRÉMIE % UKAZATELE', 'Prémie % z ukazatele / základu ', true, 120, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 27, 27, 27);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7496, '2016-05-12 00:00:00.000', 'PODÍLOVÁ MZDA', 'Podílová (provizní) mzda', true, 121, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 20, 20, 20);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7497, '2016-05-12 00:00:00.000', 'PODÍL NA ZISKU', 'Podíly % ze zisku / základu ', true, 122, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 28, 28, 28);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7498, '2016-05-12 00:00:00.000', '5', '----- Prémie % ze základní mzdy', true, 123, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 25, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7499, '2016-05-12 00:00:00.000', '5', '----- Odměna podle zákona o vynálezech a ZN', true, 124, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 30, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7500, '2016-05-12 00:00:00.000', '5', '----- Mimořádná odměna ', true, 125, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 24, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7501, '2016-05-12 00:00:00.000', 'PRESČAS', 'Měsíční mzda ', true, 126, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 17, 22);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7502, '2016-05-12 00:00:00.000', 'PRESČAS', 'Hodinová mzda', true, 127, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 18, 22);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7503, '2016-05-12 00:00:00.000', 'PRESČAS', 'Úkolová mzda ', true, 128, 1.0, 0.0, 0.0, 'castkaHod', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 19, 22);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7504, '2016-05-12 00:00:00.000', 'PRESČAS', 'Mzda za práci přesčas', true, 129, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 22, 22, 22);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7505, '2016-05-12 00:00:00.000', '5', '----- Mzda za práci přesčas', true, 130, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 22, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7506, '2016-05-12 00:00:00.000', '5', '----- Ostatní odměny', true, 131, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 33, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7507, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 132, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 267, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7508, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 133, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 268, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7509, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 134, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 269, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7510, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 135, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 270, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7511, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 136, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 271, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7512, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 137, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 272, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7513, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 138, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 273, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7514, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 139, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 274, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7515, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 140, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 275, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7516, '2016-05-12 00:00:00.000', '5', '----- Uživatelem zadaná odměna', true, 141, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 285, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7517, '2016-05-12 00:00:00.000', '5', '----- Podíly % ze zisku - základu ', true, 142, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 28, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7518, '2016-05-12 00:00:00.000', '5', '----- Prémie % z ukazatele - základu ', true, 143, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 27, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7519, '2016-05-12 00:00:00.000', 'HRUBÁ MZDA', 'Patří do základu pro výpočet pracocně právního průměru', true, 144, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 17, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7520, '2016-05-12 00:00:00.000', '5', '----- Časová (hodinová) mzda', true, 145, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 18, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7521, '2016-05-12 00:00:00.000', '5', '----- Podílová (provizní) mzda', true, 146, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 20, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7522, '2016-05-12 00:00:00.000', '5', '----- Úkolová mzda ', true, 147, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 19, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7523, '2016-05-12 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '[jb] 2013-12-05 nasobime procentem, aby byla castka 0 v pripade nepouziti nahrady a slozka byla nulova', true, 148, 1.0, 0.0, 0.0, 'prumNaHodNem', 'procMzd', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 172, 21, 21);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7524, '2016-05-12 00:00:00.000', 'PŘÍPLATEK ZA S+N', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 149, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 34);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7525, '2016-05-12 00:00:00.000', 'PŘÍPLATEK ZA PŘESČAS', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 150, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 216);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7526, '2016-05-12 00:00:00.000', 'NEČERPANÁ DOVOLENÁ', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 151, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 47);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7527, '2016-05-12 00:00:00.000', 'DOVOLENÁ', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 152, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 2);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7528, '2016-05-12 00:00:00.000', 'NOČNÍ PŘÍPLATEK', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 153, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 36);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7529, '2016-05-12 00:00:00.000', 'POHOTOVOST', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 154, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 39);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7530, '2016-05-12 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'Náhráda za svátek', '[jb] 2013-12-05 nasobime v ramci slozky a ne z PPP', '', true, 155, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodinySvatek', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 21, 21, 21);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7531, '2016-05-12 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Náhráda za svátek', true, 156, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 21, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7532, '2016-05-12 00:00:00.000', '5', '-----  hodiny  *  průměr =  základ', 'suma odpracované doby za minulé čtvrtletí', true, 157, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 216, 172, 216);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7533, '2016-05-12 00:00:00.000', '5', '-----  Procenta  *  základ = výsledek', 'suma odpracované doby za minulé čtvrtletí', true, 158, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 216, 216, 216);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7534, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 159, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 216, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7535, '2016-05-12 00:00:00.000', 'PŘIPLATEK ZA SVÁTEK', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', true, 160, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 38);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7536, '2016-05-12 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 161, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 38, 172, 38);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7537, '2016-05-12 00:00:00.000', 'PŘÍPLATEK ZA PŘESČAS', '----- základ x procenta', '', true, 162, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 38, 38, 38);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7538, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 163, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 38, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7539, '2016-05-12 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 164, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 34, 172, 34);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7540, '2016-05-12 00:00:00.000', 'PŘÍPLATEK ZA S+N', '----- základ x procenta', 'suma odpracované doby za minulé čtvrtletí', true, 165, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 34, 34, 34);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7541, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 166, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 34, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7542, '2016-05-12 00:00:00.000', '5', '----- výpočet základu', 'suma odpracované doby za minulé čtvrtletí', true, 167, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 36, 172, 36);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7543, '2016-05-12 00:00:00.000', 'NOČNÍ PŘÍPLATEK', '-----  Procenta  *  základ = výsledek', 'suma odpracované doby za minulé čtvrtletí', true, 168, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 36, 36, 36);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7544, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 169, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 36, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7545, '2016-05-12 00:00:00.000', 'POHOTOVOST', '-----  Kč/hod  *  hodiny = výsledek', '14.10.2013 - přechod z částky za hodinu na 10% z průměru', true, 170, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 39, 172, 39);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7546, '2016-05-12 00:00:00.000', 'POHOTOVOST', 'Odměna za prac. pohot.na pracovišti', '14.10.2013 - přechod z částky za hodinu na 10% z průměru', true, 171, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 39, 39, 39);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7547, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 172, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 39, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7548, '2016-05-12 00:00:00.000', 'POHOTOVOST MIMO', 'Odměna za prac. pohot.mimo pracoviště', 'změna z částky na hodinu na pracovněprávní průměr', true, 173, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 205, 172, 205);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7549, '2016-05-12 00:00:00.000', 'POHOTOVOST MIMO', '-----  Kč/hod  *  hodiny = výsledek', true, 174, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 205, 205, 205);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7550, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 175, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 205, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7551, '2016-05-12 00:00:00.000', 'PŘÍPL.ZA PROSTŘEDÍ', '-----  Kč/hod  *  hodiny = výsledek', true, 176, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaHod', 'hodiny', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 35, 35, 35);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7552, '2016-05-12 00:00:00.000', '5', '----- do hrubé mzdy', true, 177, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 35, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7553, '2016-05-12 00:00:00.000', 'OSOBNÍ PŘÍPLATEK', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 178, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 188, 41, 41);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7554, '2016-05-12 00:00:00.000', 'PŘÍPLATEK ZA VEDENÍ', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 179, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 188, 42, 42);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7555, '2016-05-12 00:00:00.000', 'PRÉMIE PEVNÁ', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', true, 180, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 188, 26, 26);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7556, '2016-05-12 00:00:00.000', '5', '----- Prémie pevnou částkou ', true, 181, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 26, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7557, '2016-05-12 00:00:00.000', '5', '----- Osobní příplatek', true, 182, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 41, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7558, '2016-05-12 00:00:00.000', '5', '----- Zvláštní příplatek', true, 183, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 40, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7559, '2016-05-12 00:00:00.000', '5', '----- Příplatek za rozdělenou směnu', true, 184, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 37, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7560, '2016-05-12 00:00:00.000', '5', '----- Příplatek za vedení a zastupování', true, 185, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 42, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7561, '2016-05-12 00:00:00.000', '5', '¨něco za něco', true, 186, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 257, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7562, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 187, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 258, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7563, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 188, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 259, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7564, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 189, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 260, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7565, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 190, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 261, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7566, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 191, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 262, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7567, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 192, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 263, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7568, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 193, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 264, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7569, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 194, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 265, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7570, '2016-05-12 00:00:00.000', '5', '----- Uživatelský příplatek', true, 195, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 266, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7571, '2016-05-12 00:00:00.000', 'PŘÍP.UŽIV.KRÁCENÝ 01', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] zadanou částku násobím koeficient z fondu - stejně jako mzdu', true, 196, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 373, 188, 373);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7572, '2016-05-12 00:00:00.000', 'PŘÍP.UŽIV.KRÁCENÝ 02', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] zadanou částku násobím koeficient z fondu - stejně jako mzdu', true, 197, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 374, 188, 374);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7573, '2016-05-12 00:00:00.000', 'PŘÍP.UŽIV.KRÁCENÝ 03', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] zadanou částku násobím koeficient z fondu - stejně jako mzdu', true, 198, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 375, 188, 375);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7574, '2016-05-12 00:00:00.000', 'PŘÍP.UŽIV.KRÁCENÝ 04', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] zadanou částku násobím koeficient z fondu - stejně jako mzdu', true, 199, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 376, 188, 376);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7575, '2016-05-12 00:00:00.000', 'PŘÍP.UŽIV.KRÁCENÝ 05', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] zadanou částku násobím koeficient z fondu - stejně jako mzdu', true, 200, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 377, 188, 377);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7576, '2016-05-12 00:00:00.000', '5', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] krácený příplatek přičítám tam, kam se přičítali nekrácené', true, 201, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 373, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7577, '2016-05-12 00:00:00.000', '5', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] krácený příplatek přičítám tam, kam se přičítali nekrácené', true, 202, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 374, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7578, '2016-05-12 00:00:00.000', '5', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] krácený příplatek přičítám tam, kam se přičítali nekrácené', true, 203, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 375, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7579, '2016-05-12 00:00:00.000', '5', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] krácený příplatek přičítám tam, kam se přičítali nekrácené', true, 204, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 376, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7580, '2016-05-12 00:00:00.000', '5', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', '[jb] krácený příplatek přičítám tam, kam se přičítali nekrácené', true, 205, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 377, 90);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7581, '2016-05-12 00:00:00.000', '6', 'NEpatří do základu pro výpočet pracocně právního průměru - Odměna členů statutárního orgánu', true, 206, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 31, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7582, '2016-05-12 00:00:00.000', '6', '----- Odměna členů statutárního orgánu-nerezident', true, 207, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 32, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7583, '2016-05-12 00:00:00.000', '6', '----- Náhrada škod podle zákoníku práce', true, 208, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 51, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7584, '2016-05-12 00:00:00.000', '6', '----- Odstupné, odchodné, odbytné', true, 209, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 44, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7585, '2016-05-12 00:00:00.000', '6', '----- Odměna k živ, prac. jubileu, odchodu do důch.', true, 210, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 29, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7586, '2016-05-12 00:00:00.000', '6', '----- Cestovní náhrady nadlimit', true, 211, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 46, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7587, '2016-05-12 00:00:00.000', '6', '----- Srážka za přečerpanou dovolenou', true, 212, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 48, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7588, '2016-05-12 00:00:00.000', '6', '----- Doplatek do průměrného výdělku', true, 213, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 49, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7589, '2016-05-12 00:00:00.000', '6', '----- Doplatek do minimální mzdy', true, 214, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 50, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7590, '2016-05-12 00:00:00.000', '6', '----- Jednorázová sociální výpomoc', true, 215, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 52, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7591, '2016-05-12 00:00:00.000', '6', '----- 1%  vstupní ceny vozu ', true, 216, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 54, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7592, '2016-05-12 00:00:00.000', '6', '----- Naturální plnění', true, 217, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 382, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7593, '2016-05-12 00:00:00.000', '6', '----- Peněž dar z FKSP', true, 218, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 55, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7594, '2016-05-12 00:00:00.000', '6', '----- Naturálni mzda', true, 219, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 56, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7595, '2016-05-12 00:00:00.000', 'PŘEKÁŽKY OSOBNÍ', 'Důležité osobní překážky v práci  (svatba, narození dítěte, vyšetření ve zdravotnickém zařízení aj. § 128) ', '', true, 220, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 10, 172, 10);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7596, '2016-05-12 00:00:00.000', '6', 'Důležité osobní překážky v práci  (svatba, narození dítěte, vyšetření ve zdravotnickém zařízení aj. § 128) ', '', true, 221, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 10, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7597, '2016-05-12 00:00:00.000', '6', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 222, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 172, 10);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7598, '2016-05-12 00:00:00.000', 'VOLNO PLACENÉ', 'Volno placené', '', true, 223, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 6, 172, 6);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7599, '2016-05-12 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Volno placené', '', true, 224, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 6, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7600, '2016-05-12 00:00:00.000', 'VOLNO PLACENÉ', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 225, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 6);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7601, '2016-05-12 00:00:00.000', 'OBECNÝ ZÁJEM', 'Překážky z důvodů obecného zájmu placené ', '', true, 226, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 11, 172, 11);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7602, '2016-05-12 00:00:00.000', '6', 'Překážky z důvodů obecného zájmu placené ', '', true, 227, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 11, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7603, '2016-05-12 00:00:00.000', '6', 'Pracovněprávní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', '', true, 228, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'prumNaHodNem', '', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 11);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7604, '2016-05-12 00:00:00.000', 'DOVOLENÁ', 'Dovolená', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 229, 1.0, 0.0, 0.0, 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 2, 172, 2);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7605, '2016-05-12 00:00:00.000', 'DOVOLENÁ CELKEM', 'Dovolená', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 230, 1.0, 1.0, 0.0, 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', '', 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 2, 346);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7606, '2016-05-12 00:00:00.000', 'DOVOLENÁ CELKEM', 'Celková dovolená zaokrouhlená na Kč nahoru', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 231, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 346, 346);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7607, '2016-05-12 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Celková dovolená zaokrouhlená na Kč nahoru', '', true, 232, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 346, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7608, '2016-05-12 00:00:00.000', 'NEČERPANÁ DOVOLENÁ', 'Proplacení nevyčerpané dovolené', '', true, 233, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 47, 172, 47);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7609, '2016-05-12 00:00:00.000', 'NEPATŘÍ DO PPP ', 'Proplacení nevyčerpané dovolené', '', true, 234, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 47, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7610, '2016-05-12 00:00:00.000', '6', '----- Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 235, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 248, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7611, '2016-05-12 00:00:00.000', 'PROSTOJ  60%', '----- Pracovněprávní hodinový průměr do prostoje', true, 236, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 238);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7612, '2016-05-12 00:00:00.000', '6 - 1', 'Prostoj 60% nebo částečná nezaměstnanost', true, 237, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 238, 172, 238);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7613, '2016-05-12 00:00:00.000', '6 - 2', 'Prostoj 60% nebo částečná nezaměstnanost', true, 238, 0.01, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 238, 238, 238);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7614, '2016-05-12 00:00:00.000', '6 - 3', 'Prostoj 60% nebo částečná nezaměstnanost', true, 239, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 238, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7615, '2016-05-12 00:00:00.000', 'PROSTOJ  80%', '----- Pracovněprávní hodinový průměr do prostoje', true, 240, 1.0, 0.0, 0.0, 'prumNaHodNem', '', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 239);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7616, '2016-05-12 00:00:00.000', '6 - 2', 'Prostoj 80%', true, 241, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 239, 172, 239);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7617, '2016-05-12 00:00:00.000', '6 - 3', 'Prostoj 80%', true, 242, 0.01, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 239, 239, 239);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7618, '2016-05-12 00:00:00.000', '6 - 3', 'Prostoj 80%', true, 243, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 239, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7619, '2016-05-12 00:00:00.000', 'PROSTOJ  100%', '----- Pracovněprávní hodinový průměr do prostoje', true, 244, 1.0, 0.0, 0.0, 'prumNaHodNem;100', '', 'prumNaHodNem;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 240);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7620, '2016-05-12 00:00:00.000', '6 - 1', 'Prostoj 100%', true, 245, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 240, 172, 240);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7621, '2016-05-12 00:00:00.000', '6 - 2', 'Prostoj 100%', true, 246, 0.01, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 240, 240, 240);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7622, '2016-05-12 00:00:00.000', '6 - 3', 'Prostoj 100%', true, 247, 1.0, 1.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 240, 89);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7623, '2016-05-12 00:00:00.000', '6', '----- Naturálni mzda', true, 248, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 56, 156);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7624, '2016-05-12 00:00:00.000', '6', '----- 1%  vstupní ceny vozu ', true, 249, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 54, 156);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7625, '2016-05-12 00:00:00.000', '6', '----- Naturální plnění', true, 250, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 382, 156);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7626, '2016-05-12 00:00:00.000', '8', '----- Odměna podle zákona o vynálezech a ZN', true, 251, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 30, 154);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7627, '2016-05-12 00:00:00.000', '8', '----- Odstupné, odchodné, odbytné', true, 252, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 44, 154);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7628, '2016-05-12 00:00:00.000', '8', '----- Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', true, 253, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 29, 154);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7629, '2016-05-12 00:00:00.000', '8', '----- Náhrada škod podle zákoníku práce', true, 254, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 51, 154);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7630, '2016-05-12 00:00:00.000', '8', '----- Jednorázová sociální výpomoc', true, 255, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 52, 154);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7631, '2016-05-12 00:00:00.000', '8', '----- Odstupné, odchodné, odbytné', true, 256, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 44, 155);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7632, '2016-05-12 00:00:00.000', '8', '----- Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', true, 257, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 29, 155);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7633, '2016-05-12 00:00:00.000', '8', '----- Odměna podle zákona o vynálezech a ZN', true, 258, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 30, 155);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7634, '2016-05-12 00:00:00.000', '8', '----- Náhrada škod podle zákoníku práce', true, 259, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 51, 155);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7635, '2016-05-12 00:00:00.000', '8', '----- Jednorázová sociální výpomoc', true, 260, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 52, 155);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7636, '2016-05-12 00:00:00.000', '8', '----- Základ pro průměrný výdělek', true, 261, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 90, 87);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7637, '2016-05-12 00:00:00.000', '8', '----- Nepatří do základu pro průměrný výdělek', true, 262, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 89, 87);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7638, '2016-05-12 00:00:00.000', '8', '----- Hrubá mzda celkem pro všechny pracovní poměry', true, 263, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 87, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7639, '2016-05-12 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 264, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 167, 319);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7640, '2016-05-12 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 265, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 167, 319);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7641, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 266, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 24, 321);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7642, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 267, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 24, 321);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7643, '2016-05-12 00:00:00.000', 'PRIPPCAS', 'Příplatek za práci přesčas', true, 268, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 216, 322);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7644, '2016-05-12 00:00:00.000', 'PRIPPCAS', 'Příplatek za práci přesčas', true, 269, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 216, 322);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7645, '2016-05-12 00:00:00.000', 'ISPV **************', 'Nepatří do základu pro průměrný výdělek', true, 270, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 89, 324);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7646, '2016-05-12 00:00:00.000', 'ISPV **************', 'Nepatří do základu pro průměrný výdělek', true, 271, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 89, 324);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7647, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za pr.neschopnost', true, 272, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 294, 325);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7648, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za pr.neschopnost', true, 273, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 294, 325);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7649, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odměna za prac. pohot.na pracovišti', true, 274, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 39, 326);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7650, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odměna za prac. pohot.na pracovišti', true, 275, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 39, 326);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7651, '2016-05-12 00:00:00.000', 'ISPV **************', 'Pracovněprávní hodinový průměr', true, 276, 1.0, 0.0, 0.0, 'prumNaHodNem', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 172, 327);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7652, '2016-05-12 00:00:00.000', 'SOC.ZÁKLAD STD', 'Výpočet sociálky', true, 277, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 87, 162);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7653, '2016-05-12 00:00:00.000', 'PŘÍSP.PEN.POJ. %', 'Hrubá mzda celkem ', true, 278, 1.0, 0.0, 0.0, 'castMzd', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 167, 250);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7654, '2016-05-12 00:00:00.000', '1', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance procentem', true, 279, 0.01, 1.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'procMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 250, 250, 250);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7655, '2016-05-12 00:00:00.000', '2', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance procentem', true, 280, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 250, 248);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7656, '2016-05-12 00:00:00.000', 'PENZIJ.+ŽIVOT.', 'Příspěvek firmy / zamětnavatele na životní  pojištění zaměstnance fixní', true, 281, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 180, 248);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7657, '2016-05-12 00:00:00.000', '4', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance fixní', true, 282, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 126, 248);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7658, '2016-05-12 00:00:00.000', 'PEN.+ŽIV.FIRMA SUMA', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 283, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 248, 247);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7659, '2016-05-12 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 284, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 248, 247);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7660, '2016-05-12 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance celkem za minulé měsíce', true, 285, -1.0, 0.0, 0.0, 'castMzd', 'castMzd', 30000.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 247, 249);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7661, '2016-05-12 00:00:00.000', '*', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 286, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 248, 249);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7662, '2016-05-12 00:00:00.000', 'PENZ.+ŽIV.DANĚNO', 'Příspěvek firmy na penzijní a životní pojištění zaměstnance v měsíci', true, 287, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 248, 65);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7663, '2016-05-12 00:00:00.000', 'PENZ.+ŽIV.DANĚNO', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 288, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 249, 65);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7664, '2016-05-12 00:00:00.000', 'HRUBA MZDA CELKEM ', '---- do nákladů firmy (hrubá mzda ) - příspěvek firmy na penzijní a životní pojištění do limitu', true, 289, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 249, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7665, '2016-05-12 00:00:00.000', 'HRUBÁ MZDA CELKEM ', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 290, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 249, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7666, '2016-05-12 00:00:00.000', '6', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 291, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 249, 88);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7667, '2016-05-12 00:00:00.000', '9', '----- Nepatří do základu pro sociální pojištění', true, 292, -1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 155, 162);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7668, '2016-05-12 00:00:00.000', '9', '---- Přidání počátku ', e'\nbyl na řádku  266\n\n03.01.2011 Oprava  - vyhozen typ sumace - kumuloval špatně počátek o d začátku roku', true, 293, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 196, 199);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7669, '2016-05-12 00:00:00.000', '9', '----- -----***** inicializace plátce soc.pojištění ', 'pro dpp, malý rozsah do 2000 atd se nuluje', true, 294, 0.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 162, 162);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7670, '2016-05-12 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', '1 pracovní poměr  - základ pro sociální pojištění ', true, 295, 1.0, 0.0, 0.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 162, 162, 162);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7671, '2016-05-12 00:00:00.000', '9', '----- *', true, 296, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 162, 94);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7672, '2016-05-12 00:00:00.000', 'SOC.POJ.ZÁKLAD', 'Penzijní připojištění Skupina.Dan - Daněno', true, 297, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 65, 94);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7673, '2016-05-12 00:00:00.000', '9', 'Základ pro výpočet sociální pojištění, který nepřekračuje roční limit', 'byl na řádku 265', true, 298, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 201, 199);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7674, '2016-05-12 00:00:00.000', '9', '---- Přidání aktuálního měsíce', true, 299, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 94, 199);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7675, '2016-05-12 00:00:00.000', '9', '---- Odečtu od limitu sumu vyýpočtového základu od začátku roku', '01.01.2015 změna částky', true, 300, -1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 1296288.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 199, 201);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7676, '2016-05-12 00:00:00.000', '9', '---- Výpočet toho co zbyde do limitu aktuální měsíc', true, 301, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 94, 201);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7677, '2016-05-12 00:00:00.000', 'ZÁKLAD PRO VÝPOČET', '----- Sociální pojištění - oprava základu', true, 302, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 164, 201);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7678, '2016-05-12 00:00:00.000', 'S.PRA.DŮCHOD-SAZBA %', 'Je účastem důchodového spořeníi', true, 303, 1.0, 3.5, 6.5, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 9, 360, 361);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7679, '2016-05-12 00:00:00.000', '9', '---- Základ pro sociální pojištění po akceptování limitu', true, 304, 0.215, 1.0, 0.0, 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 99);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7680, '2016-05-12 00:00:00.000', '9', 'Uplatnit refundaci mzdy', '03.01.2011 nastavení základní sazby  - 0.023', true, 305, 0.01, 0.0, 0.023, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 336, 100);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7681, '2016-05-12 00:00:00.000', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', e'03.01.2011\nVýměna konstanty 0.023 za proměnnou která nabývá hodnoty 0.023 nebo 0.033\npodle nastavení mazd - uplatnit refundaci náhrady za nemoc', true, 306, 1.0, 0.0, 1.0, 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 201, 100, 100);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7682, '2016-05-12 00:00:00.000', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 307, 0.012, 1.0, 0.0, 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 101);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7683, '2016-05-12 00:00:00.000', 'SPOŘENÍ DŮCHOD', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 308, 0.05, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 362);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7684, '2016-05-12 00:00:00.000', 'SOC.PRAC.DŮCHOD', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', true, 309, 0.01, 0.0, 0.0, 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 201, 361, 95);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7685, '2016-05-12 00:00:00.000', 'SOC.POJ.FIRMA PRAC.', 'Soc. pojištění - Firma - důchodové  (pro všechny pracovní poměry) ', true, 310, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 99, 102);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7686, '2016-05-12 00:00:00.000', '9', '----- Soc. pojištění - Firma - nemocenské   (pro všechny pracovní poměry) ', true, 311, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 100, 102);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7687, '2016-05-12 00:00:00.000', '9', '----- Soc. pojištění - Firma - Stát.pol.zaměs.   (pro všechny pracovní poměry) ', true, 312, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 101, 102);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7688, '2016-05-12 00:00:00.000', '9', 'Soc. pojištění - Firma - pro JD', true, 313, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 222, 102);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7689, '2016-05-12 00:00:00.000', '9', '----- Oprava soc. pojištění - zaměstnavatel', true, 314, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 76, 102);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7690, '2016-05-12 00:00:00.000', '9', '----- Sociálka výpočet', true, 315, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 95, 98);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7691, '2016-05-12 00:00:00.000', '9', '----- Oprava soc. pojištění - pracovník', true, 316, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 75, 98);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7692, '2016-05-12 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', '1 pracovní poměr  - základ pro sociální pojištění ', '', true, 317, 1.0, 1.0, 0.0, 'zaklMzd', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 162, 350);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7693, '2016-05-12 00:00:00.000', '9', 'Soc. pojištění - Zaměstnanec -JD', true, 318, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 223, 98);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7694, '2016-05-12 00:00:00.000', 'ZDRAVOTNÍ POJIŠTĚNÍ', 'Výpočet zdravotky *********************************************', true, 319, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 87, 163);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7695, '2016-05-12 00:00:00.000', '10', '---- Základ zdravotního pojištění', true, 320, -1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 154, 163);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7696, '2016-05-12 00:00:00.000', '10', '--', true, 321, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 165, 92);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7697, '2016-05-12 00:00:00.000', '10', '--', true, 322, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 65, 92);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7698, '2016-05-12 00:00:00.000', 'ODPOČET ZÁKLADU ZP', '11.5.           odpočet pro ZTP', true, 323, 0.0, 0.0, 6444.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 344, 344);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7699, '2016-05-12 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro ZTP', true, 324, 1.0, 0.0, 0.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 344, 344, 344);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7700, '2016-05-12 00:00:00.000', '10', '11.5.           odpočet pro ZTP', true, 325, -1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 344, 92);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7701, '2016-05-12 00:00:00.000', 'ZÁKL-POM-STAT.ORG', 'základ do pom. složky', '2015-12-22', true, 326, 1.0, 1.0, 0.0, 'zaklMzd;zaklMzd;zaklMzd', 'zaklMzd;procMzd;castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 163, 384);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7702, '2016-05-12 00:00:00.000', 'ZÁKL-POM-STAT.ORG', 'pomocná složka stat. org. - nastavení násobitele', '2015-12-22', 'procMzd je nastaveno na 0 v případě zpracování parametru typu prac. poměru pro PP "6-ODMĚNA NEREZIDENTA"', true, 327, 0.0, 1.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 9, 384, 384);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7703, '2016-05-12 00:00:00.000', 'ZÁKL-POM-STAT.ORG', 'pomocná složka stat. org. - výpočet základu', '2015-12-22', 'zaklMzd vyjde buď zaklMzd (6-ODMĚNA NEREZIDENTA) nebo 0 (ostatní PP)', true, 328, 1.0, 0.0, 0.0, 'zaklMzd', 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 384, 384, 384);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7704, '2016-05-12 00:00:00.000', '10', '--', true, 329, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 163, 92);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7705, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', true, 330, 0.0, 0.0, 1.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 352, 352);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7706, '2016-05-12 00:00:00.000', '10', '--', true, 331, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 202, 204);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7707, '2016-05-12 00:00:00.000', '10', '--', true, 332, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 198, 204);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7708, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', '1 pracovní poměr  - základ pro zdravotní pojištění  ', true, 333, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 163, 352);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7709, '2016-05-12 00:00:00.000', '10', '--', true, 334, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 92, 202);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7710, '2016-05-12 00:00:00.000', '10', '--', true, 335, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 202, 234);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7711, '2016-05-12 00:00:00.000', '10', '----- Základ pro neplacené volno - pouze pracovník', true, 336, 0.0, 0.0, 9900.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 106, 106);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7712, '2016-05-12 00:00:00.000', '10', '--', true, 337, 1.0, 0.0, 0.0, 'zaklMzd', 'dnyKal', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 106, 188, 106);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7713, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEP.VOL.4.5%', 'Zdravotní pojištění za neplacené volno', true, 338, 1.0, 0.0, 0.0, 'castkaDen', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 106, 371);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7714, '2016-05-12 00:00:00.000', '10', '--', true, 339, 1.0, 0.0, 0.0, 'castkaDen', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 106, 105);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7715, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEPL.VOLNO', '----- Odečtení  svátku obsaženého v nepřítomnosti od svátku  ve složce SVÁTEK...', true, 340, 0.0, 1.0, 0.0, 'dnyKalReal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 7, 106);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7716, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEP.VOL.4.5%', 'Volno neplacené - zaměstnavatel hradí 9% zdravotního pojištění ', true, 341, 0.0, 1.0, 0.0, 'dnyKalReal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 370, 371);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7717, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEPL.VOLNO', 'Zdravotní pojištění za neplacené volno', true, 342, 1.0, 0.0, -0.49, 'zaokrJak.matem', 'zaokrNa.jednotky', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 106, 106);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7718, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEP.VOL.4.5%', 'Zdravotní pojištění za neplacené volno', true, 343, 1.0, 0.0, -0.49, 'zaokrJak.matem', 'zaokrNa.jednotky', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 371, 371);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7719, '2016-05-12 00:00:00.000', '10', '----- Základ = dny neplaceného volna * částka na den (9200 / kal.dny)', true, 344, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaDen', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 106, 106, 106);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7720, '2016-05-12 00:00:00.000', 'ZDR.POJ.NEP.VOL.4.5%', 'Zdravotní pojištění za neplacené volno', true, 345, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaDen', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 371, 371, 371);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7721, '2016-05-12 00:00:00.000', '10', '----- Základ je stejný pro neomlucenou absenci', 'oprava dnyprac na dnykal', true, 346, 0.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castkaDen', 'dnyKal', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 105, 5, 105);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7722, '2016-05-12 00:00:00.000', '10', 'Fond pracovní doby', '', '2015-09-23', true, 347, 9900.0, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'castkaHod', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 188, 93);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7723, '2016-05-12 00:00:00.000', '10', '----- Výpočet rozdílu oproti vypočtenému základu pracovníka', true, 348, -1.0, 1.0, 0.0, 'zaklMzd', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 234, 93);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, vysldohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7724, '2016-05-12 00:00:00.000', '10', '----- Nulování když je prázdný', true, 349, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 9.9999999999E10, 'mzdCalcOper.plus', false, 0, false, 9, 93, 93);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7725, '2016-05-12 00:00:00.000', '10', '----- Doplatek - zvýšení základu pracovníka', true, 350, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 93, 234);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7726, '2016-05-12 00:00:00.000', 'ZDR.ZÁKL.FIRMA', '----- Doplatek - zvýšení základu pracovníka', true, 351, 1.0, 0.0, 1.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 93, 93, 202);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7727, '2016-05-12 00:00:00.000', '10', '----- Neplacené volno - zvýšení základu pracovníka', true, 352, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 106, 234);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7728, '2016-05-12 00:00:00.000', '10', 'Zdravotní pojištění za neplacené volno', true, 353, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 371, 234);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7729, '2016-05-12 00:00:00.000', '10', '----- Absence - zvýšení základu pracovníka', true, 354, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 105, 234);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7730, '2016-05-12 00:00:00.000', '10', '----- Výpočet celkového zdravotního pojištění', true, 355, 0.135, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 234, 218);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7731, '2016-05-12 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění ', true, 356, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 234, 218);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7732, '2016-05-12 00:00:00.000', 'ZDR.ZÁKL.FIRMA', 'Zdravotní pojištění za neplacené volno', true, 357, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 371, 202);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7733, '2016-05-12 00:00:00.000', '10', '== Zdravotní zdravotního  pojištění firmy - zaokrouhlená matematicky', true, 358, 0.09, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 202, 104);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7734, '2016-05-12 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění firmy', true, 359, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 202, 104);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7735, '2016-05-12 00:00:00.000', '10', '----- Oprava pojištění firmy', true, 360, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 78, 104);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7736, '2016-05-12 00:00:00.000', '10', 'Oprava zdrav. pojištění - firma', true, 361, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 78, 218);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7737, '2016-05-12 00:00:00.000', '10', '----- Celkové zdravotní pojištění do pracovníka', true, 362, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 218, 103);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7738, '2016-05-12 00:00:00.000', '10', '== ZDRAV.POJ.PRAC.= ZDRAV.POJ.CELKEM - ZDRAV.POJ.FIRMA', true, 363, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 104, 103);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7739, '2016-05-12 00:00:00.000', '10', '----- Překopírování základu do výsledného pojištění pracovníka', true, 364, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 234, 103);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7740, '2016-05-12 00:00:00.000', '10', '----- Oprava pojištění pracovníka', true, 365, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 77, 103);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7741, '2016-05-12 00:00:00.000', '10', '----- Oprava pojištění pracovníka', true, 366, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 77, 218);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7742, '2016-05-12 00:00:00.000', 'ZDRAV.POJ.ZÁKLAD', 'Zdrav. pojištění - pracovník', true, 367, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 103, 92);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7743, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', true, 368, 1.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 352, 353);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7744, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN', 'Identifikace zdravotního pojištění pro osobu', true, 369, 1.0, 0.0, 0.0, 'procMzd', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.lomeno', false, 0, false, 9, 353, 353, 353);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7745, '2016-05-12 00:00:00.000', 'DANĚ', 'Výpočet daně', true, 370, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 87, 158);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7746, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', e'1.1.2011 sníženo o 100 Kč z 2070\n1.1.2012 vráceno na 2070', true, 371, 2070.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 110, 110, 110);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7747, '2016-05-12 00:00:00.000', '11', '----- inicialůizace slevy', true, 372, 335.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 114, 114, 114);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7748, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', true, 373, 0.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 115, 115, 115);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7749, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', true, 374, 1345.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 113, 113, 113);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7750, '2016-05-12 00:00:00.000', 'SLEVA NA DÍTĚ ZTP/P', '----- inicilizace slevy', true, 375, 1.0, 0.0, 1.0, 'castkaDen;dnySvatek;hodinySvatek', '1417;-300;-100', 'castMzd;castMzd;castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 251, 251, 251);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7751, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', 'Spolu se změnou částek je potřeba změnit i hodnoty ve MzdyConstants', true, 376, 1.0, 0.0, 0.0, 'castMzd;castkaDen;castkaHod', '1117;1417;1717', 'castMzd;castkaDen;castkaHod', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 116, 116, 116);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7752, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', true, 377, 210.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 111, 111, 111);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7753, '2016-05-12 00:00:00.000', '11', '----- inicializace slevy', true, 378, 420.0, 0.0, 0.0, 'procMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 112, 112, 112);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7754, '2016-05-12 00:00:00.000', 'NEZDAN.ČÁSTKY CELKEM', 'Cestovní náhrady do limitu', true, 379, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 45, 88);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7755, '2016-05-12 00:00:00.000', '11', '----- Oprava zdanitelných příjmů', true, 380, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 79, 158);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7756, '2016-05-12 00:00:00.000', 'ZÁKLAD NAD 100 000 ', 'Základ daně ', true, 381, 1.0, 1.0, -108024.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 158, 380);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7757, '2016-05-12 00:00:00.000', 'ZÁKLAD NAD 100 000 ', 'Penzijní připojištění Skupina.Dan - Daněno', true, 382, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 65, 380);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7758, '2016-05-12 00:00:00.000', 'ZÁLOHA NAD 100 000 ', 'Nulovani zapornych hodnot', true, 383, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 9.99999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 380, 380);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7759, '2016-05-12 00:00:00.000', 'ZÁLOHA NAD 100 000 ', 'Základ daně pro solidární zdanění', true, 384, 0.07, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 380, 380);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7760, '2016-05-12 00:00:00.000', '11', 'Základ pro výpočet sociální pojištění, který nepřekračuje roční limit', true, 385, 0.25, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd;zaklMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7761, '2016-05-12 00:00:00.000', '11', 'Penzijní připojištění Skupina.Dan - Daněno', true, 386, 1.0, 1.0, 0.0, 'castMzd;castMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 65, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7762, '2016-05-12 00:00:00.000', '11', '----- Základ pro výpočet daně ', true, 387, 1.0, 1.0, 0.0, 'zaklMzd;zaklMzd;zaklMzd', 'zaklMzd;procMzd;castkaDen', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 158, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7763, '2016-05-12 00:00:00.000', '11', '----- Zdrav. pojištění - zaměstnavatel', true, 388, 1.0, 1.0, 0.0, 'castMzd;castMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 104, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7764, '2016-05-12 00:00:00.000', 'ZÁKLAD DANĚ - SHM', 'stat. orgán - odečet ZP od SHM', '2015-12-22', true, 389, -0.09, 1.0, 0.0, 'zaklMzd;zaklMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 384, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7765, '2016-05-12 00:00:00.000', '11', 'Základ pro výpočet daně - superhubá mzda', true, 390, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.stovky', 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 107, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7766, '2016-05-12 00:00:00.000', 'ZÁKLAD DANĚ - SHM', 'odečet SP od SHM', '2015-12-22', '', true, 391, -0.25, 1.0, 0.0, 'zaklMzd;zaklMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 384, 107);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7767, '2016-05-12 00:00:00.000', '11', '----- Základ pro výpočet daně', true, 392, 0.15, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 107, 108);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7768, '2016-05-12 00:00:00.000', '11', '----- Sleva - poplatníka', true, 393, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 110, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7769, '2016-05-12 00:00:00.000', '11', '----- Sleva - Student připravující se na budoucí povolání', true, 394, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 114, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7770, '2016-05-12 00:00:00.000', '11', '----- Sleva - Osoba, za kterou platí zdrav. pojištění stát', true, 395, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 115, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7771, '2016-05-12 00:00:00.000', '11', '----- Sleva - Držitel průkaz ZTP-P', true, 396, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 113, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7772, '2016-05-12 00:00:00.000', '11', '----- Oprava slevy na dani celkem', true, 397, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 81, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7773, '2016-05-12 00:00:00.000', '11', 'Sleva na dítě ZTP/P', true, 398, 1.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 251, 189);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7774, '2016-05-12 00:00:00.000', '11', '----- Sleva - Dítě', true, 399, 1.0, 1.0, 0.0, 'castMzd;castkaDen;castkaHod', '', 'castMzd;castMzd;castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 116, 189);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7775, '2016-05-12 00:00:00.000', '11', '----- Sleva na invalidní důchod 1. a 2. stupně', true, 400, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 111, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7776, '2016-05-12 00:00:00.000', '11', '----- Sleva na invalidní důchod 3. stupně', true, 401, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 112, 117);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7777, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', '----- Vypočtená daň', true, 402, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 108, 356);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7778, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', '----- Odpočet celkové slevy na dani', true, 403, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 117, 356);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7779, '2016-05-12 00:00:00.000', '11', 'Bonus', true, 404, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 189, 109);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7780, '2016-05-12 00:00:00.000', 'HRUBA MZDA CELKEM ', 'Hrubá mzda celkem ', 'do konstatnty dám, zda je hrubá mzda menší než polovina minimální mzdy', true, 405, 4599.0, 0.0, 1.0, 'castMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, 9, 167, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7781, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', 'Záloha na daň  dílčí', true, 406, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 356, 356);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7782, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ DÍLČÍ', 'Základ pro výpočet daně - superhubá mzda', true, 407, 1.0, 0.0, 0.0, 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 107, 356);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7783, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ', 'Připočtení do výsledku celkovou daň', true, 408, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 380, 118);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7784, '2016-05-12 00:00:00.000', 'ZÁLOHA NA DAŇ', 'Záloha na daň  dílčí', true, 409, 1.0, 1.0, 0.0, 'castMzd;zaklMzd;procMzd', 'castMzd;zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 356, 118);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7785, '2016-05-12 00:00:00.000', '11', 'Záloha na daň  dílčí', true, 410, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 356, 109);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7786, '2016-05-12 00:00:00.000', '11', '----- Omezení rozsahu bonusu na 100 - 4350 Kč', '2012-02-29', true, 411, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 5025.0, 'mzdCalcOper.plus', false, 0, false, 9, 109, 109);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7787, '2016-05-12 00:00:00.000', '11', '----- když je bonus 0, pak koeficient  násobící daň = 1, jinak 0 (daň se vynuluje )', '2012-02-29', true, 412, 0.0, 1.0, 0.0, 'castMzd', 'procMzd', 0.0, 5025.0, 'mzdCalcOper.rovno', false, 0, false, 9, 109, 190);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, vyslodhodnoty, vysldohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7788, '2016-05-12 00:00:00.000', 'BONUS', 'Daňový bonus', 'nuluji bonus, když je hrubá pod 1/2 minimalní mzdy', true, 413, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 50.0, 9.999999999999E12, 'mzdCalcOper.krat', false, 0, false, 9, 109, 167, 109);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7789, '2016-05-12 00:00:00.000', 'BONUS -', '----- záporný bonus', true, 414, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 109, 228);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7790, '2016-05-12 00:00:00.000', 'ZŮČTOVÁNÍ DANĚ ', 'Přeplatek daně z ročního zúčtování', 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', true, 415, -1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 254, 255);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7791, '2016-05-12 00:00:00.000', '11', '----- Nulování daně na základě nenulového bonusu', true, 416, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 118, 190, 118);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7792, '2016-05-12 00:00:00.000', '11', '----- Daňové zvýhodnění na děti', true, 417, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 189, 190, 191);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7793, '2016-05-12 00:00:00.000', '11', '----- Odečtení slevy ne děti, když není bonus', true, 418, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 191, 118);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7794, '2016-05-12 00:00:00.000', '11', '----- Oprava zálohy na daň', true, 419, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 82, 118);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7795, '2016-05-12 00:00:00.000', '12', 'Srážková daň', true, 420, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 87, 159);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7796, '2016-05-12 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'odměna nerezidenta - přičtení ZP k základu sráž. daně', '2015-12-22', true, 421, 0.09, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 384, 159);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7797, '2016-05-12 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'odměna nerezidenta - přičtení SP k základu sráž. daně', '2015-12-22', true, 422, 0.25, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 384, 159);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7798, '2016-05-12 00:00:00.000', '12', '----- Základ pro výpočet srážkové daně pro pracovní poměr', true, 423, 1.0, 1.0, 0.0, 'zaklMzd;zaklMzd', 'zaklMzd;procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 159, 157);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7799, '2016-05-12 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Sociální pojištění - firma před zaokrouhlením', e'10.2.2010\n13.1. 2014 deaktivace', true, 424, 0.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 102, 157);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7800, '2016-05-12 00:00:00.000', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Zdravotní  pojištění - firma', e'10.2.2010; 15.2.2010 - zrušeno zaokrouhlování základu srážkové daně na 100 Kč\n13.1. 2014 deaktivace', true, 425, 0.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 104, 157);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7801, '2016-05-12 00:00:00.000', '12', '----- Základ pro výpočet srážkové daně', true, 426, 0.15, 1.0, 0.0, 'zaokrJak.dolu', 'zaokrNa.jednotky', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 157, 145);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7802, '2016-05-12 00:00:00.000', '12', '----- Oprava srážkové daně', true, 427, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 83, 145);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7803, '2016-05-12 00:00:00.000', '13', '----- Hrubá mzda celkem pro všechny pracovní poměry', true, 428, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 167, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7804, '2016-05-12 00:00:00.000', 'MZDA', 'Čistá mzda', true, 429, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 118, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7805, '2016-05-12 00:00:00.000', '13', '----- Soc. pojištění - pracovník   (pro všechny pracovní poměry) ', true, 430, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 98, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7806, '2016-05-12 00:00:00.000', '13', '----- Zdrav. pojištění - pracovník', true, 431, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 103, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7807, '2016-05-12 00:00:00.000', '13', '----- Srážková daň ', true, 432, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 145, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7808, '2016-05-12 00:00:00.000', 'ČISTÁ MZDA', 'K výplatě = čistý příjem - suma srážek', true, 433, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 140, 292);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7809, '2016-05-12 00:00:00.000', '13', 'Cestovní náhrady do limitu', 'původně 343', true, 434, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 45, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7810, '2016-05-12 00:00:00.000', '13', 'Příspěvek firmy na penzijní a životní pojištění do limitu', 'původně 343', true, 435, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 249, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7811, '2016-05-12 00:00:00.000', '13', '----- Nepatří do hrubé mzdy', true, 436, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 156, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7812, '2016-05-12 00:00:00.000', 'REDUKOVANÝ PRŮMĚR', '----- Výpočet redukovaného průměru pro náhradu za nemoc - 1. redukční hranice', '03.01.2013 - změna 1. redukční hranice', true, 437, 0.9, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 157.68, 'mzdCalcOper.plus', false, 0, false, 9, 172, 173);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7813, '2016-05-12 00:00:00.000', '15', '----- 2. redukční hranice', '03.01.2013 - změna 2. redukční hranice', true, 438, 0.6, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 157.68, 236.43, 'mzdCalcOper.plus', false, 0, false, 9, 172, 174);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7814, '2016-05-12 00:00:00.000', '15', '----- 3. redukční hranice', '03.01.2013 - změna 3. redukční hranice', true, 439, 0.3, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 236.43, 472.68, 'mzdCalcOper.plus', false, 0, false, 9, 172, 175);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7815, '2016-05-12 00:00:00.000', '15', '----- Sumace redukčních hranic', true, 440, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 173, 176);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7816, '2016-05-12 00:00:00.000', '15', '-----', true, 441, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 174, 176);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7817, '2016-05-12 00:00:00.000', '15', '-----', true, 442, 1.0, 1.0, 0.0, 'prumNaHodNem', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 175, 176);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7818, '2016-05-12 00:00:00.000', '15', 'Pracovněprávní hodinový průměr - redukovaný', true, 443, 1.0, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.setiny', 'prumNaHodNem;prumNaHodNem', '1;0.6', 'prumNaHodNem;castkaHod', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 176, 176, 176);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7819, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 1-3', '-----     Výpočet pčesahu nemoci přes 24 hodiny první 3 dny', true, 444, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 24.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 69, 69);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7820, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 1-3', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', true, 445, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 69);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7821, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 1-3', 'Náhrada mzdy za nemoc  - první 3 dny', true, 446, 0.6, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 69, 69);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7822, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 1-3', 'Náhrada mzdy za nemoc  - první 3 dny', true, 447, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 69, 69);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7823, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 4-10 ', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', '02.01.2011', e'\n', true, 448, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 378);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7824, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 4-10 ', 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', '02.01.2011', '', true, 449, 0.6, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 378, 378, 378);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7825, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 4-15', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', '02.01.2011', '', true, 450, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 338);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7826, '2016-05-12 00:00:00.000', 'NÁHR.NEMOC 4-15', 'Náhrada za nemoc - za 4. až 15. pracovní den / směnu  / směny (část z 21 kalendářních dnů) ', '02.01.2011', '', true, 451, 0.6, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 338, 338, 338);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7827, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 452, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 0.0, 9.999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 171, 171);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7828, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', true, 453, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 171);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7829, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 454, 0.6, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 171, 171);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7830, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', true, 455, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 171, 171);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7831, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 4-10', '----- Přesun redukovaného PPP do  výpočtu náhrady karantény', '02.01.2011', '', true, 456, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 379);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7832, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 4-10', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', '02.01.2011', '', true, 457, 0.6, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 379, 379, 379);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7833, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 4-15', '----- Přesun redukovaného PPP do  výpočtu náhrady karantény', '02.01.2011', '', true, 458, 1.0, 0.0, 0.0, 'prumNaHodNem;prumNaHodNem', 'castMzd;castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 176, 337);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7834, '2016-05-12 00:00:00.000', 'NÁHR.KARANTÉNA 4-15', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', '02.01.2011', '', true, 459, 0.6, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'hodiny', 'castkaHod', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 337, 337, 337);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7835, '2016-05-12 00:00:00.000', '15', 'Daňový bonus', true, 460, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 109, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7836, '2016-05-12 00:00:00.000', '15', 'Přeplatek daně z ročního zúčtování', 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', true, 461, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 254, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7837, '2016-05-12 00:00:00.000', 'DOVOLENÁ PŘEVOD', 'Zbývající dovolená', true, 462, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.konecPredchoziRok', 1, false, 9, 186, 339);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7838, '2016-05-12 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Pokud je měsíc 0 připravíme si k přičtení 1, aby jsme byli na lednu', true, 463, 0.0, 1.0, 0.0, 'dnyKal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 9, 340, 340);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7839, '2016-05-12 00:00:00.000', 'MĚSÍC POČÁTEK', 'Měsíc počátku pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Přičteme konstantu z předchozího kroku, aby byl počátek v lednu vždy 1', true, 464, 1.0, 1.0, 0.0, 'procMzd', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 340, 340);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7840, '2016-05-12 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Pokud je měsíc 0 připravíme si k přičtení 13 - první nekompletní je až za tímto rokem', true, 465, 0.0, 13.0, 0.0, 'dnyKal', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, false, 9, 341, 341);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7841, '2016-05-12 00:00:00.000', 'MĚSÍC KONEC', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Přičteme konstantu z předchozího kroku, aby byl konec v prosinci vždy 12', true, 466, 1.0, 1.0, 0.0, 'procMzd', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 341, 341);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7842, '2016-05-12 00:00:00.000', 'MĚSÍCŮ PRACUJE', 'Měsíc konce pracovního poměru v aktuálním roce - slouží pro výpočet poměrné dovolené - pokud je den v měsíci > 1 bere se následující měsíc', 'Spočteme kolik měsíců v roce fakt pracoval', true, 467, 1.0, -1.0, 0.0, 'dnyKal', 'dnyKal', 'dnyKal', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 341, 340, 342);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7843, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Nárok na dovolenou', 'koeficient pro výpočet zbývající dovolené', true, 468, 0.166666, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'dnyPrac', 'dnyKal', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 244, 342, 184);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7844, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Nárok na dovolenou - poměrná část', 'koeficient pro výpočet zbývající dovolené', true, 469, 0.5, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.setiny', 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 184, 184);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7845, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku - inicializační složka ', true, 470, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 351, 184);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7846, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku - inicializační složka ', true, 471, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', true, 'mzdCalcSuma.rokPred', 0, false, 9, 351, 184);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7847, '2016-05-12 00:00:00.000', 'DOVOLENÁ POČÁTEK', 'Převod dovolené z minulého roku', true, 472, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 339, 184);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7848, '2016-05-12 00:00:00.000', 'DOVOLENÁ', '----- Dovolená', '', true, 473, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 184, 186);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7849, '2016-05-12 00:00:00.000', 'DOVOLENÁ ZBÝVÁ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 474, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 297, 186);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7850, '2016-05-12 00:00:00.000', 'DOVOLENÁ ZBÝVÁ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 475, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 297, 186);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7851, '2016-05-12 00:00:00.000', 'SUMA OPRAV DOVOLENÉ ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 476, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 297, 298);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7852, '2016-05-12 00:00:00.000', 'SUMA OPRAV DOVOLENÉ ', 'Opravava nároku na dovolenou', 'suma za minulé měsíce', true, 477, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 297, 298);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7853, '2016-05-12 00:00:00.000', '16', '----- Přičtení aktuálního měsíce', 'suma za minulé měsíce', true, 478, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 2, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7854, '2016-05-12 00:00:00.000', '16', '----- Sumace dovolené od začátku roku', '', true, 479, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 2, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7855, '2016-05-12 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Proplacení nevyčerpané dovolené', '', true, 480, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 47, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7856, '2016-05-12 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Proplacení nevyčerpané dovolené', 'suma za minulé měsíce', true, 481, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 47, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7857, '2016-05-12 00:00:00.000', 'ODEČET DOVOL.ZA ABS.', 'Absence neomluvená', 'sumaa odpracované doby za minulé čtvrtletí', true, 482, 1.0, 0.0, 1.0, 'dnyPrac', 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 5, 236, 235);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7858, '2016-05-12 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Odečet dovolené za neomluvenou absenci', 'sumaa odpracované doby za minulé čtvrtletí', true, 483, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 235, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7859, '2016-05-12 00:00:00.000', 'DOVOLENÁ VYBRÁNO', 'Odečet dovolené za neomluvenou absenci', 'sumaa odpracované doby za minulé čtvrtletí', true, 484, 1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 235, 185);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7860, '2016-05-12 00:00:00.000', '16', '----- Počáteční satv dovolené - vybráno od začátku roku', 'sumaa odpracované doby za minulé čtvrtletí', true, 485, -1.0, 1.0, 0.0, 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', true, 0, false, 9, 185, 186);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7861, '2016-05-12 00:00:00.000', '17', '----- Sumace náhrady za nemoc', true, 486, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 171, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7862, '2016-05-12 00:00:00.000', '17', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 487, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 379, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7863, '2016-05-12 00:00:00.000', '17', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 488, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 337, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7864, '2016-05-12 00:00:00.000', '17', 'Náhrada mzdy za nemoc  - první 3 dny', true, 489, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 69, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7865, '2016-05-12 00:00:00.000', '17', 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', true, 490, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 378, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7866, '2016-05-12 00:00:00.000', '17', 'Náhrada za nemoc - za 4. až 15. pracovní den / směnu  / směny (část z 21 kalendářních dnů) ', true, 491, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdProplat', 0, false, 9, 338, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7867, '2016-05-12 00:00:00.000', '17', 'Oprava - Náhrada mzdy za nemoc', true, 492, 1.0, 1.0, 0.0, 'castMzd;dnyKal;dnyPrac;hodiny', 'castMzd;dnyKal;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 72, 226);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7868, '2016-05-12 00:00:00.000', 'NÁHR. ZA PRAC.NESCH.', 'Celková náhrada za pracovní neschopnost', true, 493, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 226, 294);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7869, '2016-05-12 00:00:00.000', '15', 'Celková náhrada za nemoc', true, 494, 0.5, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 226, 178);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7870, '2016-05-12 00:00:00.000', 'REFUNDACE NÁHRADY', 'Uplatnit refundaci mzdy', e'02.01.2011 nulování náhrady mzdy - viz nastavení firmy\npro frimu nad 25 zaměstnanců je to vždy\npro firmu do 25 podle přání uživatele', true, 495, 1.0, 0.0, 0.0, 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 336, 178);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7871, '2016-05-12 00:00:00.000', 'SOC.POJ.CELKEM', '...', true, 496, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 9.9999999999999E12, 'mzdCalcOper.plus', false, 0, false, 9, 178, 217);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7872, '2016-05-12 00:00:00.000', '15', 'Celková náhrada za nemoc', true, 497, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 226, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7873, '2016-05-12 00:00:00.000', '4', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', true, 498, 1.0, 0.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 18);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7874, '2016-05-12 00:00:00.000', 'SRÁŽKY CELKEM', 'Výživné ', true, 499, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 119, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7875, '2016-05-12 00:00:00.000', '18', 'Náhrada škod', true, 500, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 120, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7876, '2016-05-12 00:00:00.000', '18', 'Pojištění ', true, 501, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 125, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7877, '2016-05-12 00:00:00.000', '18', 'Penzijní pojištění zaměstnance', true, 502, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 127, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7878, '2016-05-12 00:00:00.000', '18', 'Odbory částka ', true, 503, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 128, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7879, '2016-05-12 00:00:00.000', '18', 'Čistá mzda ', true, 504, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 140, 129);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7880, '2016-05-12 00:00:00.000', '18', 'Odbory % ze mzdy', true, 505, 0.01, 0.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 129, 129, 129);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7881, '2016-05-12 00:00:00.000', '18', 'Odbory % ze mzdy', true, 506, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 129, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7882, '2016-05-12 00:00:00.000', '18', 'Hrubá mzda celkem ', true, 507, 1.0, 0.0, 0.0, 'castMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 167, 134);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7883, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ PP', 'Odpracovaná doba', true, 508, 1.0, -1.0, 0.0, 'dnyPrac', 'dnyPrac', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 256, 381);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, poznam, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7884, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ PP', '----- Přičtení svátku do odpracované doby když za něj není náhrada', '', true, 509, 1.0, 0.0, 1.0, 'dnySvatek', 'procMzd', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 256, 21, 381);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7885, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ PP', 'Studium nebo  jiné formy přípravy', 'při studiu nemá nárok na stravenky', true, 510, -1.0, 1.0, 0.0, 'dnyPrac;dnySvatek', '', 'dnyPrac;dnyPrac', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 9, 381);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7886, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Stravné dle odprac. dnů ', true, 511, 0.0, 0.0, 0.0, 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.max', false, 0, false, 9, 133, 133);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7887, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Stravné dle odprac. dnů pro pracovní poměr', true, 512, 1.0, 0.0, 1.0, 'dnyPrac', '', 'dnyPrac', 0.0, 0.0, 'mzdCalcOper.max', false, 0, false, 9, 381, 133);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7888, '2016-05-12 00:00:00.000', 'STRAVNÉ VYPOČTENÉ', 'Stravné vypočet dle odprac. dnů ', true, 513, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'procMzd', 'dnyPrac', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 9, 133, 133, 133);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7889, '2016-05-12 00:00:00.000', 'ČISTÝ PŘÍJEM', 'K výplatě = čistý příjem - suma srážek', true, 514, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 140, 293);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7890, '2016-05-12 00:00:00.000', '18', 'Stravné vypočet dle odprac. dnů ', true, 515, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 133, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7891, '2016-05-12 00:00:00.000', 'CELKOVÁ DAŇ', 'Záloha na daň - výsledek po slevách a opravách', true, 516, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 118, 242);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7892, '2016-05-12 00:00:00.000', '18', 'Srážky% z hrubé mzdy ', true, 517, 0.01, 1.0, 0.0, 'zaokrJak.matem', 'zaokrNa.jednotky', 'zaklMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 134, 134, 134);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7893, '2016-05-12 00:00:00.000', '18', 'Srážky% z hrubé mzdy ', true, 518, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 134, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7894, '2016-05-12 00:00:00.000', '18', 'Půjčky ', true, 519, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 124, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7895, '2016-05-12 00:00:00.000', '18', 'Přeplatky ', true, 520, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 121, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7896, '2016-05-12 00:00:00.000', '18', 'Ostattní exekuce', true, 521, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 122, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7897, '2016-05-12 00:00:00.000', '18', 'Stravné', true, 522, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 132, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7898, '2016-05-12 00:00:00.000', '18', 'Spoření', true, 523, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 123, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7899, '2016-05-12 00:00:00.000', '18', 'Osobní účet ', true, 524, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 131, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7900, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 525, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 276, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7901, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 526, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 277, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7902, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 527, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 278, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7903, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 528, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 279, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7904, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 529, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 280, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7905, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 530, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 281, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7906, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 531, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 282, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7907, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 532, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 283, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7908, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 533, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 284, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7909, '2016-05-12 00:00:00.000', '18', 'Uživatelsky definovaná srážka', true, 534, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 286, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7910, '2016-05-12 00:00:00.000', '18', 'spoření důchod', true, 535, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 362, 135);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7911, '2016-05-12 00:00:00.000', 'K VÝPLATĚ', 'Celkové srážky', true, 536, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 135, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7912, '2016-05-12 00:00:00.000', 'K VÝPLATĚ', 'Příspěvek firmy na penzijní a životní pojištění do limitu', true, 537, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 249, 140);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7913, '2016-05-12 00:00:00.000', 'POJISTNÉ PRACOVNÍK', 'Sociální pojištění - pracovník  ', true, 538, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 98, 290);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7914, '2016-05-12 00:00:00.000', 'POJISTNÉ PRACOVNÍK', 'Zdrav. pojištění - pracovník', true, 539, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 103, 290);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7915, '2016-05-12 00:00:00.000', 'DOBÍRKA', 'Čistá mzda ', true, 540, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 140, 139);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7916, '2016-05-12 00:00:00.000', 'DOBÍRKA', 'Záloha mimořádná', true, 541, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 137, 139);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7917, '2016-05-12 00:00:00.000', 'DOBÍRKA', 'Záloha řádná', true, 542, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 136, 139);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7918, '2016-05-12 00:00:00.000', '2', '---- Nulování částky mzdy v odpracováno výpočet', true, 543, 0.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 179, 179);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7919, '2016-05-12 00:00:00.000', 'CELKOVÁ DAŇ', 'Srážková daň ', true, 544, 1.0, 1.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 145, 242);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7920, '2016-05-12 00:00:00.000', 'DAŇOVÝ BONUS', 'Daňový bonus', 'nuluji bonus, když je hrubá pod 1/2 minimalní mzdy', true, 545, 1.0, 0.0, 0.0, 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 109, 291);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7921, '2016-05-12 00:00:00.000', 'HRUBA MZDA CELKEM ', '1%  vstupní ceny vozu ', true, 546, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 54, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7922, '2016-05-12 00:00:00.000', 'HRUBA MZDA CELKEM ', 'Naturální plnění', true, 547, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 382, 167);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7923, '2016-05-12 00:00:00.000', '9', '---- Základ pro sociální pojištění po akceptování limitu', true, 548, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 99);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7924, '2016-05-12 00:00:00.000', 'SOC.FIR.NEMOC', '---- Základ pro sociální pojištění po akceptování limitu', true, 549, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 100);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7925, '2016-05-12 00:00:00.000', 'SOC.FIR.NEZAM.', '---- Základ pro sociální pojištění po akceptování limitu', true, 550, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 101);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7926, '2016-05-12 00:00:00.000', 'SOC.POJ.CELKEM', '---- Základ pro sociální pojištění po akceptování limitu', true, 551, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 217);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7927, '2016-05-12 00:00:00.000', 'SOC.POJ.PRACOVNÍK', '---- Základ pro sociální pojištění po akceptování limitu', true, 552, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 98);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7928, '2016-05-12 00:00:00.000', 'SOC.POJ.FIRMA ', '---- Základ pro sociální pojištění po akceptování limitu', true, 553, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 229);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7929, '2016-05-12 00:00:00.000', 'SOC.FIR.DŮCHOD', '---- Základ pro sociální pojištění po akceptování limitu', true, 554, 1.0, 0.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 201, 99);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7930, '2016-05-12 00:00:00.000', 'PRAC.PRÁVNÍ  PRŮMĚR ', 'Pracovněprávní hodinový průměr', true, 555, 1.0, 0.0, 0.0, 'prumNaHodNem', 'castkaHod', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 172, 172);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7931, '2016-05-12 00:00:00.000', 'DÍLČÍ HRUBÁ MZDA', '1%  vstupní ceny vozu ', true, 556, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 54, 87);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7932, '2016-05-12 00:00:00.000', 'DÍLČÍ HRUBÁ MZDA', 'Naturální plnění', true, 557, -1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 382, 87);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7933, '2016-05-12 00:00:00.000', 'SOC.POJ.CELKEM', '----- *', true, 558, 1.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 162, 217);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7934, '2016-05-12 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 559, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 9, 167, 299);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7935, '2016-05-12 00:00:00.000', 'ISPV **************', 'Hrubá mzda celkem ', true, 560, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 167, 299);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7936, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 561, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 9, 179, 301);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7937, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba', true, 562, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 179, 301);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7938, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 563, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 9, 24, 300);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7939, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mimořádná odměna ', true, 564, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 24, 300);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7940, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 565, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 9, 22, 302);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7941, '2016-05-12 00:00:00.000', 'ISPV **************', 'Mzda za práci přesčas', true, 566, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 22, 302);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7942, '2016-05-12 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 567, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.obdobiAkt', 3, true, 9, 16, 303);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7943, '2016-05-12 00:00:00.000', 'ISPV **************', 'Neodpracovaná doba', true, 568, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 16, 303);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7944, '2016-05-12 00:00:00.000', 'ISPV **************', 'Fond pracovní doby', true, 569, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 1, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7945, '2016-05-12 00:00:00.000', 'ISPV **************', 'Fond pracovní doby', true, 570, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 1, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7946, '2016-05-12 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'Když jsou hodiny z fondu pracovní doby tak koeficient pro úkolovou mzdu je 1, jinak je 0', true, 571, 0.0, 1.0, 0.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 9, 311, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7947, '2016-05-12 00:00:00.000', 'ISPV **************', 'Úkolová mzda ', 'úkolová mzda do FONDSJE', true, 572, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 19, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7948, '2016-05-12 00:00:00.000', 'ISPV **************', 'Úkolová mzda ', 'úkolová mzda do FONDSJE', true, 573, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 19, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7949, '2016-05-12 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'Přičtení úkolové mzdy do FONDSJE (pouze když není zadaný fond pracovní doby)', true, 574, 1.0, 0.0, 1.0, 'prumNaHodNem', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 9, 311, 311, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7950, '2016-05-12 00:00:00.000', 'ISPV **************', 'Sjednaný fond je plánovaný hodinový fond pracovní doby zaměstnance', 'úkolová mzda do FONDSJE', true, 575, 1.0, 1.0, 0.0, 'hodiny', 'prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 311, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7951, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'úkolová mzda do FONDSJE', true, 576, 0.0, 1.0, 0.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 9, 312, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7952, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'Přičtení úkolové mzdy do FONDSJE (pouze když není zadaný fond pracovní doby)', true, 577, 1.0, 0.0, 1.0, 'prumNaHodNem', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 9, 312, 312, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7953, '2016-05-12 00:00:00.000', 'ISPV **************', 'Celkový počet neodpracovaných hodin', '', true, 578, -1.0, 0.0, 1.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 9, 314, 312, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7954, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', '', true, 579, 0.0, 0.0, 1.0, 'hodiny', '', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, true, 9, 312, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (7955, '2016-05-12 00:00:00.000', 'ISPV **************', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', '', true, 580, 1.0, 0.0, 0.0, 'hodiny', 'castkaDen', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 9, 312, 312, 312);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7956, '2016-05-12 00:00:00.000', 'FONDSJE', 'Odpracovaná doba zaměstnance v daném pracovním poměru (podle § 353 odst. 2 a 3 ZP) ', 'úkolová mzda do FONDSJE', true, 581, 1.0, 0.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 312, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7957, '2016-05-12 00:00:00.000', 'FONDSJE', 'Počet přesčasových hodin (podle § 78 odst. 1 písm. i/ ZP)v', 'úkolová mzda do FONDSJE', true, 582, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 313, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7958, '2016-05-12 00:00:00.000', 'FONDSJE', 'Celkový počet neodpracovaných hodin', 'úkolová mzda do FONDSJE', true, 583, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 314, 311);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7959, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc  do neodpracované doby (čas)', true, 584, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 3, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7960, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Karanténa  do neodpracované doby (čas)', true, 585, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 12, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7961, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 586, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 13, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7962, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 587, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 14, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7963, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc z povolání do neodpracované doby (čas)', true, 588, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 15, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7964, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc  do neodpracované doby (čas)', true, 589, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 3, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7965, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Karanténa  do neodpracované doby (čas)', true, 590, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 12, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7966, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', true, 591, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 13, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7967, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', true, 592, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 14, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7968, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Nemoc z povolání do neodpracované doby (čas)', true, 593, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 15, 317);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7969, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 594, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 2, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7970, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 595, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 11, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7971, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 596, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 6, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7972, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 597, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 10, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7973, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 598, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 2, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7974, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 599, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 11, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7975, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 600, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 6, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7976, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 601, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 10, 315);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7977, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Mzda za práci přesčas', true, 602, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 22, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7978, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Ostatní odměny', true, 603, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 33, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7979, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Uživatelem zadaná odměna', true, 604, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 267, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7980, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 605, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 268, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7981, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 606, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 269, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7982, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 607, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 270, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7983, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 608, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 271, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7984, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 609, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 272, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7985, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 610, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 273, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7986, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 611, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 274, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7987, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 612, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 275, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7988, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 613, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 285, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7989, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Mzda za práci přesčas', true, 614, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 22, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7990, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Ostatní odměny', true, 615, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 33, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7991, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Uživatelem zadaná odměna', true, 616, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 267, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7992, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 617, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 268, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7993, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 618, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 269, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7994, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 619, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 270, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7995, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 620, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 271, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7996, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 621, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 272, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7997, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 622, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 273, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7998, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 623, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 274, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (7999, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 624, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 275, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8000, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelem zadaná odměna', true, 625, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 285, 320);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8001, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Dovolená do neodpracované doby (čas)', true, 626, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 2, 304);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8002, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', true, 627, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 11, 304);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8003, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Volno placené  do neodpracované doby (čas)', true, 628, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 6, 304);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8004, '2016-05-12 00:00:00.000', 'ISPV **************', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', true, 629, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 10, 304);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8005, '2016-05-12 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 630, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 69, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8006, '2016-05-12 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 631, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 69, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8007, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', true, 632, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 378, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8008, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za nemoc - za 4. až 10. pracovní den / směnu  / směny (část z 15 kalendářních dnů) ', true, 633, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 378, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8009, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za nemoc - za 4. až 15. pracovní den / směnu  / směny (část z 21 kalendářních dnů) ', true, 634, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 338, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8010, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za nemoc - za 4. až 15. pracovní den / směnu  / směny (část z 21 kalendářních dnů) ', true, 635, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 338, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8011, '2016-05-12 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 636, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 171, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8012, '2016-05-12 00:00:00.000', 'ISPV **************', '...se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 637, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 171, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8013, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 638, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 379, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8014, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 639, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 379, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8015, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 640, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 337, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8016, '2016-05-12 00:00:00.000', 'ISPV **************', 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ', true, 641, 1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 337, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8017, '2016-05-12 00:00:00.000', 'ISPV **************', 'svátek sumovaná z nemoci', true, 642, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, true, 9, 343, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8018, '2016-05-12 00:00:00.000', 'ISPV **************', 'svátek sumovaná z nemoci', true, 643, -1.0, 1.0, 0.0, 'hodiny', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, true, 9, 343, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8019, '2016-05-12 00:00:00.000', 'ISPV **************', 'Počet hodin z fondu pracovní doby neodpracovaných z důvodu dočasné pracovní neschopnosti (příp. karantény), za které se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 644, 0.0, 0.0, 1.0, 'hodiny', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensi', false, 0, true, 9, 318, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8020, '2016-05-12 00:00:00.000', 'ISPV **************', 'Počet hodin z fondu pracovní doby neodpracovaných z důvodu dočasné pracovní neschopnosti (příp. karantény), za které se neposkytuje nemocenská dávka podle zákona o nemocenském pojištění (zákon č. 187/2006 Sb.).', true, 645, 1.0, 0.0, 0.0, 'hodiny', 'procMzd', 'hodiny', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, true, 9, 318, 318, 318);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8021, '2016-05-12 00:00:00.000', 'ISPV **************', '----- do hrubé mzdy', true, 646, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 35, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8022, '2016-05-12 00:00:00.000', 'ISPV **************', 'Příplatek za práci v sobotu a neděli', true, 647, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 34, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8023, '2016-05-12 00:00:00.000', 'ISPV **************', 'Příplatek za práci ve ztíženém prac. prostředí', true, 648, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 35, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8024, '2016-05-12 00:00:00.000', 'ISPV **************', 'Příplatek za noční práci', true, 649, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 36, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8025, '2016-05-12 00:00:00.000', 'ISPV **************', 'Příplatek za rozdělenou směnu', true, 650, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 37, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8026, '2016-05-12 00:00:00.000', 'ISPV **************', 'Zvláštní příplatek', true, 651, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 40, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8027, '2016-05-12 00:00:00.000', 'ISPV **************', 'Osobní hodnocení - příplatek (je počítán poměrně podobně jako měsíční mzda)', true, 652, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 41, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8028, '2016-05-12 00:00:00.000', 'ISPV **************', 'Příplatek za vedení a zastupování (je počítán poměrně podobně jako měsíční mzda)', true, 653, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 42, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8029, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek ', true, 654, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 257, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8030, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 655, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 258, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8031, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 656, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 259, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8032, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 657, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 260, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8033, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 658, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 261, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8034, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 659, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 262, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8035, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 660, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 263, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8036, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 661, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 264, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8037, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 662, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 265, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8038, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek', true, 663, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 266, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8039, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', true, 664, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 373, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8040, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', true, 665, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 374, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8041, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', true, 666, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 375, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8042, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', true, 667, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 376, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8043, '2016-05-12 00:00:00.000', 'ISPV **************', 'Uživatelský příplatek (je počítán poměrem - podobně jako měsíční mzda)', true, 668, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 377, 354);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, sumtypk, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8044, '2016-05-12 00:00:00.000', 'ISPV **************', 'příplatek pro sumarizaci ISPV', true, 669, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 'mzdCalcSuma.rokPred', 0, false, 9, 354, 323);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8045, '2016-05-12 00:00:00.000', 'ISPV **************', 'příplatek pro sumarizaci ISPV', true, 670, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 354, 323);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8046, '2016-05-12 00:00:00.000', 'MĚSÍČNÍ MZDA ZÁKLAD', 'Měsíční mzda ', 'slouzi pouze pro zobrazeni zakladu na pasce', true, 671, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'zaklMzd', '', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 17, 383);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8047, '2016-05-12 00:00:00.000', 'ZÁKL.ZP-1 PRAC.POMĚR', 'Celkové zdravotní pojištění', true, 672, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 9, 218, 163, 163);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8048, '2016-05-12 00:00:00.000', 'ZÁKL.ZP-1 PRAC.POMĚR', 'Zdravotní  pojištění - firma', true, 673, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 9, 104, 163, 163);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8049, '2016-05-12 00:00:00.000', '17', '----- Sumace sociálního pojištění  A 2013', true, 674, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 102, 229);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8050, '2016-05-12 00:00:00.000', '17', '----- Sumace sociálního pojištění  B', true, 675, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 181, 229);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8051, '2016-05-12 00:00:00.000', '17', '----- Sumace sociálního pojištění  D', true, 676, 1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 98, 217);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8052, '2016-05-12 00:00:00.000', '17', '----- Sumace sociálního pojištění  C', true, 677, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 9, 229, 217);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8053, '2016-05-12 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', 'Celkové sociální pojištění', true, 678, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 9, 217, 350, 350);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8054, '2016-05-12 00:00:00.000', 'ZÁKL.SOC.POJ.1 POMĚR', 'Sociální pojištění - firma', true, 679, 1.0, 1.0, 0.0, 'castMzd', 'zaklMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 9, 229, 350, 350);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8055, '2016-05-12 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', 'Celkové sociální pojištění', true, 680, 1.0, 1.0, 0.0, 'castMzd;zaklMzd', 'zaklMzd;zaklMzd', 'castMzd;zaklMzd', 0.0, 0.0, 'mzdCalcOper.rozdelPomer', false, 0, false, 9, 217, 350, 162);

         -- typ prac. poměru
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (254, '2016-05-12 00:00:00.000', 'ZÁKLAD DANĚ', 'Základ daně ', '13.1. 2014 zmena na slozku ktera je vazana na pomer castkaDen;procMzd', true, 10, 0.0, 10000.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, false, true, true, true, true, true, 9, 2, 158);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (255, '2016-05-12 00:00:00.000', 'ZÁKLAD DANĚ', 'Základ daně ', '', true, 11, 0.0, 9.99999999999E11, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 6, 158);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, poznam, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (256, '2016-05-12 00:00:00.000', 'ZÁKLAD DANĚ', 'Základ daně ', '2015-12-22', '', true, 12, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, false, false, true, 9, 11, 158);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, poznam, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (257, '2016-05-12 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'Základ pro výpočet srážkové daně pro pracovní poměr', '2012-12-22', true, 28, 9.999999999999E12, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, false, true, true, 9, 11, 159);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (258, '2016-05-12 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'Základ pro výpočet srážkové daně pro pracovní poměr', e'10.2.2010\n13.1. 2014 zmena na slozku ktera je vazana na pomer', true, 30, 10000.0001, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, false, true, true, true, true, true, 9, 2, 159);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
         VALUES (259, '2016-05-12 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'Základ pro výpočet srážkové daně pro pracovní poměr', '13.1. 2014 zmena na slozku ktera je vazana na pomer', true, 31, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 159);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idcismzdsloz)
         VALUES (260, '2016-05-12 00:00:00.000', '*', 'Nulování doplatku do vyměřovacího základu zdravotního pojištění', true, 35, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, false, true, 9, 93);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (261, '2016-05-12 00:00:00.000', '*', 'Nulování sociálky pro malý rozsah do 2500', '', true, 40, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, false, true, true, true, true, true, true, 9, 1, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (262, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 41, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 2, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (263, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 42, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 1, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (264, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 42, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 4, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (265, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '.... jen DP přestává být tímto využíván', true, 43, 0.0, 9.9999999999E10, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, false, true, true, true, true, true, 9, 5, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (266, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 44, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 7, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (267, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 10, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (268, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 9, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (269, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 8, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (270, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 9, 6, 221);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, poznam, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (271, '2016-05-12 00:00:00.000', 'ZÁKL-POM-STAT.ORG', 'pomocná složka pro stat. org. (základ mzdy)', '2015-12-22', true, 46, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'procMzd', true, true, true, true, true, false, true, true, 9, 11, 384);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (272, '2016-05-12 00:00:00.000', '*', 'Zdravotka se nuluje u DPP do 10 000 Kč - od roku 2012', '', true, 60, 0.0, 10000.0, 0.0, 'zaklMzd', 'zaklMzd;castMzd', true, true, true, true, true, true, true, true, 9, 2, 163);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (273, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', '', true, 62, 0.0, 10000.0, 0.0, 'zaklMzd', 'procMzd', true, true, true, true, false, true, true, true, 9, 2, 352);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (274, '2016-05-12 00:00:00.000', '*', 'Sociálka se nuluje u DPP do 10 000 Kč od roku 2012', '', true, 70, 0.0, 10000.0, 0.0, 'zaklMzd', 'zaklMzd;castMzd;procMzd', true, true, true, true, true, true, true, true, 9, 2, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (275, '2016-05-12 00:00:00.000', '*', 'Nulování slevy na sociálce pro DPČ', '', true, 80, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 4, 219);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (276, '2016-05-12 00:00:00.000', '*', 'Nulování sociálky pro zaměstnání malého rozsahu', '', true, 90, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, false, true, true, true, true, true, true, 9, 4, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (277, '2016-05-12 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 100, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 4, 163);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (278, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  pro standardní pracovní poměry  ', '', true, 110, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 7, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (279, '2016-05-12 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  pro standardní pracovní poměry  ', true, 110, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 7, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (280, '2016-05-12 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', 'Nulování sociálního pojištění do částky 2499', '2012-02-29', true, 120, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 5, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (281, '2016-05-12 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 130, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 8, 163);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (282, '2016-05-12 00:00:00.000', '*', 'Sociálka se nuluje u krátkodobého zaměstnání vždy', '', true, 140, 0.0, 9.999999999999E12, 0.0, 'castMzd', 'zaklMzd;castMzd;procMzd', true, true, true, true, true, true, true, true, 9, 9, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (283, '2016-05-12 00:00:00.000', '*', 'Nulování zdravotky vždy ', '', true, 150, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 6, 163);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (284, '2016-05-12 00:00:00.000', '*', 'od 2014', '', true, 152, 0.0, 9.9999999999E10, 0.0, 'zaklMzd', 'zaklMzd;castMzd;procMzd', true, true, true, true, true, true, true, true, 9, 6, 162);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (285, '2016-05-12 00:00:00.000', 'ZP-JE POJIŠTĚN 1 POM', 'Identifikace zdravotního pojištění pro jeden pracovní poměr', '', true, 155, 0.0, 9.999999999E9, 0.0, 'zaklMzd', 'procMzd', true, true, true, true, false, true, true, true, 9, 6, 352);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
         VALUES (286, '2016-05-12 00:00:00.000', '*', 'Nulování zdravotky vždy do 2500', '', true, 160, 0.0, 2499.0, 0.0, 'zaklMzd', 'zaklMzd', true, true, true, true, true, true, true, true, 9, 10, 163);

         -- hromadné
        INSERT INTO pmzdcalchrom (idmzdcalchrom, lastupdate, kod, nazev, popis, show, cisrad, zaokrjakk, zaokrnak, polein, poleout, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (62, '2016-05-12 00:00:00.000', 'SOC.FIRMA ZAOKR.', 'Soc. pojištění - Firma (pro všechny pracovní poměry) ', 'Dojde k celkovému zaokrouuhlení sumy sociálky firmy  a k rozpuštění mezi jednotlivé zaměstnance ', true, 1, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 9, 102, 181);

         -- nastavíme hromadnou řádku do hlavičky
        UPDATE pmzdcalchlav SET idradkahromadne = 8049 WHERE idmzdcalchlav = 9;

        PERFORM pg_catalog.setval('seq_pmzdcalchlav', 9, true);
        PERFORM pg_catalog.setval('seq_pmzdcalcinit', 254, true);
        PERFORM pg_catalog.setval('seq_pmzdcalc', 8055, true);
        PERFORM pg_catalog.setval('seq_ptyppracpomparam', 286, true);
        PERFORM pg_catalog.setval('seq_pmzdcalchrom', 62, true);
   end if;
 end;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;
 
 select runupgrade();
 
 drop function runupgrade();
 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1010, 't', %appVersion%, clock_timestamp());